'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfBillboard" "3pf"
.SH NAME
.upperok
.B pfBillboard
\- 
Create and update automatic rotation billboard nodes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfBillboard.h>
.nf
.fi
.TP
\ 
\f3\%pfBillboard::pfBillboard\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfBillboard::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfBillboard::setPos\fP(int\ i,
'in +2
'll -2
const\ pfVec3\ &xyzOrigin);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfBillboard::getPos\fP(int\ i,
'in +2
'll -2
pfVec3\ &xyzOrigin);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfBillboard::setPosFlux\fP(pfFlux\ *flux);
.nf
.fi
.TP
pfFlux *
\f3\%pfBillboard::getPosFlux\fP(void);
.nf
.fi
.TP
void
\f3\%pfBillboard::setMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfBillboard::getMode\fP(int\ mode);
.nf
.fi
.TP
void
\f3\%pfBillboard::setAxis\fP(const\ pfVec3\ &axis);
.nf
.fi
.TP
void
\f3\%pfBillboard::getAxis\fP(pfVec3\ &axis);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfBillboard\fP is
derived from the parent class \f3\%pfGeode\fP,
so each of these member functions of
class \f3\%pfGeode\fP
are also directly usable with objects
of class \f3\%pfBillboard\fP.
This is also true for
ancestor classes
of class \f3\%pfGeode\fP.

.PD 0
.TP \w'pfGeoSet\ *\ \ \ 'u
int
\f3\%pfGeode::addGSet\fP(pfGeoSet*\ gset);
.PD 0
.TP
int
\f3\%pfGeode::removeGSet\fP(pfGeoSet*\ gset);
.PD 0
.TP
int
\f3\%pfGeode::insertGSet\fP(int\ index,
'in +2
'll -2
pfGeoSet*\ gset);
.in
.ll
.PD 0
.TP
int
\f3\%pfGeode::replaceGSet\fP(pfGeoSet*\ old,
'in +2
'll -2
pfGeoSet*\ new);
.in
.ll
.PD 0
.TP
pfGeoSet *
\f3\%pfGeode::getGSet\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGeode::getNumGSets\fP(void);

.PD
.PP
Since the class
\f3\%pfGeode\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfBillboard\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfBillboard\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfBillboard\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfBillboard is a pfGeode in which each pfGeoSet rotates to follow the
eyepoint.  Billboards are useful for complex objects which are roughly
symmetrical about one or more axes.  The billboard tracks the viewer by
rotating about an axis or a point to present the same image to the
viewer using far fewer polygons than a solid model.  A classic example
is a textured billboard of a single quadrilateral representing a
tree.

A pfBillboard can contain any number of pfGeoSets.  pfGeoSets are added
to and removed from the pfBillboard using the \f3\%pfGeode::addGSet\fP and
\f3\%pfGeode::removeGSet\fP routines used with pfGeodes.  Each pfGeoSet rotates
independently to follow the viewer.  By convention, the pfGeoSet is
rotated about the +Z axis so that the +Y axis points towards the eye
point.

\f3\%new pfBillboard\fP creates and returns a handle to a pfBillboard.  Like
other pfNodes, pfBillboards are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfBillboards should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfBillboard::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfBillboard\fP.  The \f3\%pfType\fP* returned
by \f3\%pfBillboard::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfBillboard\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfBboardPos\fP specifies the position \f2xyzOrigin\fP for the pfGeoSet with
index \f2i\fP.  \f3\%pfBillboard::getPos\fP copies the position of the pfGeoSet
with index \f2i\fP into \f2xyzOrigin\fP.

Billboards can either rotate about an axis or a point.

Axial billboards rotate about the axis specified by \f3\%pfBillboard::setAxis\fP.
The rotation is about the origin (0,0,0) of the pfGeoSet.  In all
cases, the geometry is modeled in the XZ plane, with +Y forward.  When
rendered, the billboard is rotated so that the -Y axis points back to
the eye point.  The +Z axis is the pfGeoSet's axis of rotation.  An
axial rotate billboard is specified by setting the \f3\%PFBB_ROT\fP
\f2mode\fP of the billboard to the \f2value\fP \f3\%PFBB_AXIAL_ROT\fP using
\f3\%pfBillboard::setMode\fP.  The axis of rotation (\f2x\fP, \f2y\fP, \f2z\fP) is
specified using \f3\%pfBillboard::setAxis\fP.  \f3\%pfBillboard::getAxis\fP returns the axis
of the pfBillboard.

Point rotate billboards are useful for spherical objects or special
effects such as smoke.  They come in two varieties depending on how
the remaining rotational degree of freedom is determined (rotating the
-Y axis towards the eye, still leaves an arbitrary rotation about the
pfGeoSet's Y axis).

.RS
If the \f3\%PFBB_ROT\fP mode on the billboard is set to \f3\%PFBB_POINT_ROT_EYE\fP,
the billboard is rotated so that the +Z axis of the pfGeoSet aligns
as closely as possible with the axis specified with
\f3\%pfBillboard::setAxis\fP, in eye space.
In particular, if the axis is +Z (as it is by default), the +Z axis
of the pfGeoSet stays upright on the screen.

If the \f3\%PFBB_ROT\fP mode on the billboard is set to \f3\%PFBB_POINT_ROT_WORLD\fP,
the billboard is rotated so that the angle between the +Z axis of the
pfGeoSet and axis specified with \f3\%pfBillboard::setAxis\fP
(in world space) is minimized.
.RE

Both \f3\%PFBB_AXIAL_ROT\fP and \f3\%PFBB_POINT_ROT_WORLD\fP billboards may
"spin" about the Y axis of the pfGeoSet when viewed along the rotation
or alignment axis.

\f3\%pfBillboard::setPosFlux\fP will set a pfFlux
to be used to contain the xyz origins of all the pfGeoSets under a
pfBillboard node.  The data size of position flux should be equal to
the number of pfGeoSets under the pfBillboard multiplied by the size
of pfVec3.  Having the origins in a flux allows you to animate
the origins to align them to a pfASD.
\f3\%pfBillboard::getPosFlux\fP returns the
current position flux is there is one.

After the first \f3\%pfSync\fP, the number of pfGeoSets, the number and
length of the primitives, and planarity of the vertices should not be
changed.

Some database formats may place a transformation above each billboard
for positioning it.  As with a pfGeode containing a small amount of
geometry, having many billboards with transformation matrices above
them can be expensive.

Since billboards always rotate towards the eyepoint, billboards in
adjacent channels with the same eyepoint have the same orientation.
Channels with different eyepoints will have different billboard
orientations.
.SH BUGS

Intersection traversals test only the pfBillboard's
bounding volume, not its individual pfGeoSets.

pfFlatten only transforms the position of a billboard, not the axis
and applies only a uniform scale to the billboard geometry.
.SH SEE ALSO
pfChannel,
pfGeode,
pfNode,
pfFlux,
pfScene,
pfTransparency,
pfDelete
