'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfColortable" "3pf"
.SH NAME
.upperok
.B pfColortable,
.B pfGetCurCtab
\- 
Specify color table properties
Color table class and related functions
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfColortable.h>
.nf
.fi
.TP
\ 
\f3\%pfColortable::pfColortable\fP()
.nf
.fi
.TP
\ 
\f3\%pfColortable::pfColortable\fP(int\ size)
.nf
.fi
.TP
static pfType *
\f3\%pfColortable::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfColortable::getCtabSize\fP();
.nf
.fi
.TP
void
\f3\%pfColortable::apply\fP();
.nf
.fi
.TP
int
\f3\%pfColortable::setColor\fP(int\ index,
'in +2
'll -2
pfVec4\ &color);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfColortable::getColor\fP(int\ index,
'in +2
'll -2
pfVec4\ &color);
.in
.ll
.nf
.fi
.TP
pfVec4 *
\f3\%pfColortable::getColors\fP();
.nf
.fi
.TP
pfColortable *
\f3\%pfGetCurCtab\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfColortable\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfColortable\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfColortable\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfColortable is a 'color indexing' mechanism used by pfGeoSets.  It
is \f2not\fP related to the graphics library hardware rendering notion of
\f2color index mode\fP.  If pfColortable operation is enabled, pfGeoSets
will be drawn with the colors defined in the current globally active
pfColortable rather than using the pfGeoSet's own local color list.
This facility can be used for instant large-scale color manipulation of
geometry in a scene.

\f3\%new\fP(arena) allocates a pfColortable from the specified memory
arena, or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP
allocates a pfColortable from the default memory arena (see
\f3\%pfGetSharedArena\fP).  Like other pfObjects, pfColortables cannot be
created statically, automatically on the stack or in arrays.  The default
constructor returns a pfColortable of 256 entries.  Or an argument
\f2size\fP may be provided to the constructor, where \f2size\fP is the
number of pfVec4 color elements to allocate for the pfColortable.
pfColortables should be deleted with \f3\%pfDelete\fP rather than the
delete operator.

The number of color elements in the pfColortable is returned by
\f3\%pfColortable::getCtabSize\fP.

\f3\%pfColortable::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfColortable\fP.  The \f3\%pfType\fP* returned
by \f3\%pfColortable::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking  the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfColortable\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an object,
it is usually better to use the member function
\f3\%isOfType\fPto test if an object is of a type derived from a
Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

Use a pfColortable's \f3\%apply\fP member function to select it as the current,
global color table.
If colorindex mode is enabled
(\f3\%pfEnable\fP(\f3\%PFEN_COLORTABLE\fP)), then all subsequent pfGeoSets
will use the pfVec4 array supplied by the global color table rather than
their own
local color array.  Colorindex mode works for both indexed and
non-indexed pfGeoSets.

\f3\%pfColortable::apply\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP,
\f3\%pfColortable::apply\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDispList::draw\fP.

\f3\%pfGetCurCtab\fP returns the currently active pfColortable or \f3\%NULL\fP
if there is none active.

Colors in a pfColortable are pfVec4's which specify red, green, blue,
and alpha in the range [0..1].
The member functions \f3\%setColor\fP and \f3\%getColor\fP
respectively set and get the color at index \f2index\fP.  To support
high performance manipulation of colortables, OpenGL Performer allows
direct access to the array of pfVec4 colors of a pfColortable.
The member function \f3\%getColors\fP
returns a pointer to this array which may be
manipulated directly.  However care must be taken not to write data
outside the array limits.

The pfColortable state element is identified by the
\f3\%PFSTATE_COLORTABLE\fP token.  Use this token with \f3\%pfGeoSet::setAttr\fP to
set the pfColortable of a pfGeoState and with \f3\%pfOverride\fP to
override subsequent colortable changes.

Example 1:
.Ex
.nf

/* Set up 'colorindexed' pfGeoState */
gstate->setAttr(PFSTATE_COLORTABLE, ctab);
gstate->setMode(PFSTATE_ENCOLORTABLE, PF_ON);

/* Attach gstate to gset */
gset->setGState(gstate);

/* Draw gset colorindexed with ctab */
gset->draw();
.Ee
.fi
.na


Example 2:
.Ex
.nf

pfEnable(PFEN_COLORTABLE);
ctab->apply();

/*
 * Override active pfColortable to 'ctab' and colorindex enable
 * to PF_ON.
 */
pfOverride(PFSTATE_COLORTABLE | PFSTATE_ENCOLORTABLE, PF_ON);
.Ee
.fi
.na

.SH NOTES

pfColortables can be used to simulate FLIR (Forward Looking Infrared)
and NVG (Night Vision Goggles) and for monochrome display devices
which separate video components for stereo display purposes. More
flexible FLIR and NVG simulation is available through the use of
indexed pfGeoStates.
.SH SEE ALSO
pfDelete,
pfDispList,
pfEnable,
pfGeoSet,
pfGeoState,
pfOverride,
pfState
