'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfConfig" "3pf"
.SH NAME
.upperok
.B pfMultipipe,
.B pfGetMultipipe,
.B pfMultithread,
.B pfGetMultithread,
.B pfMultiprocess,
.B pfGetMultiprocess,
.B pfGetMPBitmask,
.B pfConfig,
.B pfIsConfiged,
.B pfGetPID,
.B pfGetPIDName,
.B pfCreateProcessFunc,
.B pfGetCreateProcessFunc,
.B pfProcessMiscCPU,
.B pfGetProcessMiscCPU,
.B pfPrintProcessState,
.B pfGetPipe,
.B pfInitPipe,
.B pfGetStage,
.B pfGetStageName,
.B pfStageConfigFunc,
.B pfGetStageConfigFunc,
.B pfConfigStage,
.B pfHyperpipe,
.B pfGetHyperpipe,
.B pfGetPipeHyperId,
.B pfProcessPriorityUpgrade,
.B pfGetProcessPriorityUpgrade,
.B pfProcessHighestPriority,
.B pfGetProcessHighestPriority
\- 
Configure process and pipeline models, get pfPipe handle and process ID.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfCreateProcessFuncType\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
int
\f3\%pfMultipipe\fP(int\ num);
.nf
.fi
.TP
int
\f3\%pfGetMultipipe\fP(void);
.nf
.fi
.TP
int
\f3\%pfMultithread\fP(int\ pipe,
'in +2
'll -2
uint\ stage,
int\ nprocs);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetMultithread\fP(int\ pipe,
'in +2
'll -2
uint\ stage);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMultiprocess\fP(int\ mode);
.nf
.fi
.TP
int
\f3\%pfGetMultiprocess\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetMPBitmask\fP(void);
.nf
.fi
.TP
int
\f3\%pfConfig\fP(void);
.nf
.fi
.TP
int
\f3\%pfIsConfiged\fP(void);
.nf
.fi
.TP
pid_t
\f3\%pfGetPID\fP(int\ pipe,
'in +2
'll -2
uint\ stage);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfGetPIDName\fP(pid_t\ pid);
.nf
.fi
.TP
void
\f3\%pfCreateProcessFunc\fP(pfCreateProcessFuncType\ func);
.nf
.fi
.TP
pfCreateProcessFuncType
\f3\%pfGetCreateProcessFunc\fP(void);
.nf
.fi
.TP
void
\f3\%pfProcessMiscCPU\fP(int\ cpu);
.nf
.fi
.TP
int
\f3\%pfGetProcessMiscCPU\fP(void);
.nf
.fi
.TP
void
\f3\%pfPrintProcessState\fP(FILE\ *fp);
.nf
.fi
.TP
pfPipe *
\f3\%pfGetPipe\fP(int\ pipe);
.nf
.fi
.TP
int
\f3\%pfInitPipe\fP(pfPipe\ *pipe,
'in +2
'll -2
pfPipeFuncType\ configFunc);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetStage\fP(pid_t\ pid,
'in +2
'll -2
int\ *pipe);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfGetStageName\fP(int\ pipe,
'in +2
'll -2
uint\ stage);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfStageConfigFunc\fP(int\ pipe,
'in +2
'll -2
uint\ stageMask,
pfStageFuncType\ configFunc);
.in
.ll
.nf
.fi
.TP
pfStageFuncType
\f3\%pfGetStageConfigFunc\fP(int\ pipe,
'in +2
'll -2
uint\ stageMask);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfConfigStage\fP(int\ pipe,
'in +2
'll -2
uint\ stageMask);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfHyperpipe\fP(int\ n);
.nf
.fi
.TP
int
\f3\%pfGetHyperpipe\fP(pfPipe\ *pipe);
.nf
.fi
.TP
int
\f3\%pfGetPipeHyperId\fP(const\ pfPipe\ *pipe);
.nf
.fi
.TP
void
\f3\%pfProcessPriorityUpgrade\fP(int\ state);
.nf
.fi
.TP
int
\f3\%pfGetProcessPriorityUpgrade\fP();
.nf
.fi
.TP
void
\f3\%pfProcessHighestPriority\fP(int\ pri);
.nf
.fi
.TP
int
\f3\%pfGetProcessHighestPriority\fP();
.fi

.Ex
.nf

typedef void (*pfCreateProcessFuncType)(int _pipe, uint _stage, pid_t _pid);
typedef void (*pfStageFuncType)(int pipe, uint stage);
.Ee
.fi
.na

.SH DESCRIPTION

An OpenGL Performer application renders images using one or more
pfPipes.  A pfPipe is a software rendering pipeline that traverses,
culls, and draws one or more pfChannels into a single graphics
context. The software rendering pipeline is composed of three
functional \f2stages\fP:
.RS
.TP 20
\f3\%APP\fP
Application processing
.TP
\f3\%CULL\fP
Database culling and level-of-detail selection
.TP
\f3\%DRAW\fP
Drawing geometry produced by \f3\%CULL\fP
.RE

In addition, OpenGL Performer has a separate intersection stage which can
operate either synchronously or asynchronously with the rendering
pipeline (see \f3\%pfIsectFunc\fP).

All stages may be combined into a single process or split into multiple
processes for enhanced performance on multiprocessing systems.
\f3\%pfMultiprocess\fP controls the partitioning of functional stages into
processes. \f2mode\fP is a bitwise OR of the following tokens:

.RS
\f3\%PFMP_FORK_ISECT\fP
.br
\f3\%PFMP_FORK_CULL\fP
.br
\f3\%PFMP_FORK_DRAW\fP
.br
\f3\%PFMP_FORK_LPOINT\fP
.br
\f3\%PFMP_FORK_DBASE\fP
.br
\f3\%PFMP_FORK_COMPUTE\fP
.br
\f3\%PFMP_CULLoDRAW\fP
.br
\f3\%PFMP_CULL_DL_DRAW\fP
.RE


These tokens specify which stages to fork into separate processes and
what multiprocessing communication mechanism to use between the cull
and draw processes.

The process from which all other processes are spawned is known as the
application process, or \f3\%APP\fP. This process is the one that invokes
\f3\%pfConfig\fP and controls the rendering and intersection pipelines
through \f3\%pfFrame\fP.

User code in the intersection, database, cull, and draw processes are
"triggered" by calling \f3\%pfFrame\fP. \f3\%pfFrame\fP causes OpenGL Performer
to invoke the user callbacks associated with each process. These
callbacks are established by \f3\%pfIsectFunc\fP, \f3\%pfDBaseFunc\fP,
\f3\%pfChanTravFunc\fP respectively. See \f3\%pfFrame\fP for more details.

In addition to the cull and draw process, an optional light points process
can be used to discharged the draw process to do the intensive computation
involved by the \f3\%pfLPointState\fP attached to the lights points pfGeoSet.
This process is usefull when a lot of raster computation can be done on a
separate processor than the draw processor, and will become mandatory when
using the forthcoming calligraphic light points.

The cull process will put all geoset with a pfLPointState attached to in a
dedicated bin. The light points process will preprocess this bin in parallel
with the draw process drawing the other bins. The light points process uses
an internal ring display list to communicate the result of the preprocessing
to the draw, which will therefore draw all light points at the end. See \f3\%pfChannel\fP
for more details.

Each pfPipe has a \f3\%CULL\fP and \f3\%DRAW\fP stage which may be configured
as either one or two processes. The \f3\%ISECT\fP, \f3\%DBASE\fP, and
\f3\%COMPUTE\fP stages are independent of any pfPipe and may run in the same
process as the application process or as separate processes (\f3\%PFMP_FORK_ISECT\fP,
\f3\%PFMP_FORK_DBASE\fP, \f3\%PFMP_FORK_COMPUTE\fP).  In the latter case, the user may
further multiprocess intersection traversals through any IRIX multiprocessing
mechanism such as \f3\%fork\fP, \f3\%sproc\fP, or \f3\%m_fork\fP. Database
processing utilizing the pfBuffer mechanism may be further
parallelized through \f3\%fork\fP only (See \f3\%pfBuffer\fP).

For additional performance gains when a pfPipe contains multiple pfChannels,
the \f3\%CULL\fP stage may be further parallelized on a per-pfChannel basis.
When the \f2stage\fP argument to \f3\%pfMultithread\fP is \f3\%PFPROC_CULL\fP,
the \f3\%CULL\fP stage of the \f2pipe\fPth rendering pipeline is split
into \f2nprocs\fP \f3\%fork\fPed processes each of which operates singly on
a pfChannel. Thus this extra parallelization is only effective when both
\f2nprocs\fP and the number of pfChannels on \f2pipe\fP are greater than 1.
\f2nprocs\fP need not be equal to the number of pfChannels.
Currently, \f3\%pfMultithread\fP only accepts a \f2stage\fP argument of
\f3\%PFPROC_CULL\fP, returns 1 on success and -1 otherwise.
The \f3\%CULL\fP is not automatically multithreaded
if \f3\%PFMP_DEFAULT\fP is specified as the \f3\%pfMultiprocess\fP mode.

The \f3\%LPOINT\fP stage can also be multithreaded, using the same scheme as for the
cull process.

When multithreading the \f3\%CULL\fP, care must be taken to avoid
data collisions in user callback functions. In particular, pfChannel and
pfNode CULL callbacks (\f3\%pfChanTravFunc\fP, \f3\%pfNodeTravFuncs\fP) may be
invoked in parallel.

\f3\%pfGetMultithread\fP returns the number of processes in the processing
stage identified by \f2stage\fP on the \f2pipe\fPth rendering pipeline.
Currently, \f3\%pfGetMultithread\fP only accepts a \f2stage\fP argument of
\f3\%PFPROC_CULL\fP and returns -1 otherwise.

Thus, the number of processes an application uses is dependent
on:
.RS
.TP 5
1.
The multiprocessing modes set by \f3\%pfMultiprocess\fP and \f3\%pfMultithread\fP.
.TP
2.
The number of rendering pipelines set by \f3\%pfMultipipe\fP.
.TP
3.
The number of user-spawned processes.
.RE

The following table indicates the number of processes that are implied
by each multiprocessing mode combination as a function of the number of
OpenGL Performer pfPipes specified.

.TS
center tab($) ;
c | c | c | c .
FORK_ISECT$FORK_CULL$FORK_DRAW$# Processes
_
No$No$No$1
No$No$Yes$2
No$Yes$No$1 + numPipes
No$Yes$Yes$1 + 2*numPipes
_
Yes$No$No$2
Yes$No$Yes$3
Yes$Yes$No$2 + numPipes
Yes$Yes$Yes$2 + 2*numPipes
.TE

Here is an example configuration which would be used to generate a
high-performance stereo display using two pfPipes, each associated
with a hardware graphics pipeline. In this situation the output of
one pipeline will be displayed for the viewer's left eye, and the
other will go to the right eye. Here, multithreading the \f3\%CULL\fP
is of no use since each pfChannel is handled by its own pfPipe.

Example 1: Two pfPipe stereo configuration
.Ex
.nf

/* configure two hardware pipelines */
pfMultipipe(2);

/* operate processing tasks in parallel */
pfMultiprocess(PFMP_FORK_CULL | PFMP_FORK_DRAW | PFMP_FORK_ISECT);
.Ee
.fi
.na


The processing mode configured by this example looks like:

.Ex
.nf

            CULL ---> DRAW		left eye
           /
          /
        APP
       /  \\
      /    \\
    ISECT   CULL ---> DRAW		right eye
.Ee
.fi
.na


Example 2: One pfPipe stereo configuration using multithreaded CULL
.Ex
.nf


/* operate all processing tasks in parallel */
pfMultiprocess(PFMP_FORK_CULL | PFMP_FORK_DRAW | PFMP_FORK_ISECT);

pfMultithread(0, PFPROC_CULL, 2);
.Ee
.fi
.na


The processing mode configured by this example looks like:
.Ex
.nf

	         CULL 		left eye
          	/    \\
        APP-----      ---------> DRAW
       /        \\    /
      /          CULL 		right eye
    ISECT
.Ee
.fi
.na


\f3\%PFMP_CULL_DL_DRAW\fP and \f3\%PFMP_CULLoDRAW\fP specify how the cull and
draw stages should communicate.

If \f3\%PFMP_CULL_DL_DRAW\fP is set the cull stage will build up an OpenGL
Performer display list (pfDispList) which contains the entire frame's
worth of data. The draw stage then traverses this pfDispList when
\f3\%pfDraw\fP is called and sends commands to the graphics hardware.
When the cull and draw stages are different processes
(\f3\%PFMP_FORK_DRAW\fP) this mode is always enabled. However, when the
cull and draw stages are the same process, the display list
construction may add some overhead.  If, in this case,
\f3\%PFMP_CULL_DL_DRAW\fP is not specified, the cull stage will be delayed
until \f3\%pfDraw\fP is called. \f3\%pfDraw\fP will then cull and draw the
scene in immediate mode and not use a pfDispList.

\f3\%PFMP_CULL_DL_DRAW\fP is disabled by default but should be used for
applications which use multipass rendering techniques that require
multiple calls to \f3\%pfDraw\fP.

The 'o' in \f3\%PFMP_CULLoDRAW\fP is short for 'overlap' and when this bit
is set, the multiprocessed cull and draw stages of the same frame will
be overlapped.  The cull process (the producer) writes to a FIFO
(implemented as a ring buffer) while the draw process (the consumer)
simultaneously reads commands from the ring buffer.

The main benefit of this configuration is that latency will be reduced
a full frame time over the pipelined (non-overlapped) case. A
disadvantage is that the draw process may suffer from reduced throughput
if the cull process cannot keep up. This condition is exacerbated when
the cull sorts the database by draw bin or by graphics state. In each
case, the cull retains the database in internal data structures and
does not add drawing commands to the display list until the cull is
completed. Consequently, to get the best throughput from \f3\%PFMP_CULLoDRAW\fP,
database mode sorting and ordering should be disabled.

Example 3: Reasonable sorting setup for \f3\%PFMP_CULLoDRAW\fP

.Ex
.nf


pfMultiprocess(PFMP_APP_CULL_DRAW | PFMP_CULLoDRAW);

/* Draw opaque geometry immediately into CULLoDRAW's pfDispList
 * Transparent geometry is still saved and drawn after opaque. */
pfChanBinOrder(chan, PFSORT_OPAQUE_BIN, PFSORT_NO_ORDER);

/* PFCULL_SORT must be enabled for transparent geometry to be
ordered, i.e. - drawn last. */
pfChanTravMode(chan, PFTRAV_CULL, PFCULL_ALL);

.Ee
.fi
.na


\f3\%PFMP_CULLoDRAW\fP is ignored if the cull and draw stages are in the
same process.

The optional light points process uses the Display List mechanism as an
essential way of communication between the cull and the draw. Therefore,
it is compulsory to use \f3\%PFMP_CULL_DL_DRAW\fP with \f3\%PFMP_FORK_LPOINT\fP.
\f3\%pfConfig\fP will automatically replace \f3\%PFMP_CULLoDRAW\fP token if used in conjunction
with light points process.

For convenience, other tokens are provided for common multiprocessing
modes:
.RS
.TP 5
\f3\%PFMP_APPCULLDRAW\fP
All stages are combined into a single process.  A pfDispList is not
used. \f3\%pfDraw\fP both culls and renders the scene.
.TP
\f3\%PFMP_APPCULL_DL_DRAW\fP
All stages are combined into a single process.  A pfDispList is built
by \f3\%pfCull\fP and rendered by \f3\%pfDraw\fP.
.TP
\f3\%PFMP_APP_CULLDRAW\fP
The cull and draw stages are combined in a process that is separate
from the application process.  A pfDispList is not used. \f3\%pfDraw\fP
both culls and renders the scene.
Equivalent to (\f3\%PFMP_FORK_CULL\fP).
.TP
\f3\%PFMP_APP_CULL_DL_DRAW\fP
The cull and draw stages are combined in a process that is separate
from the application process. A pfDispList is built by \f3\%pfCull\fP and
rendered by \f3\%pfDraw\fP.
Equivalent to (\f3\%PFMP_FORK_CULL\fP | \f3\%PFMP_CULL_DL_DRAW\fP).
.TP
\f3\%PFMP_APPCULL_DRAW\fP
The application and cull stages are combined in a process that is
separate from the draw process.
Equivalent to (\f3\%PFMP_FORK_DRAW\fP).
.TP
\f3\%PFMP_APPCULLoDRAW\fP
The application and cull stages are combined in a process that is
separate from, but overlaps, the draw process.
Equivalent to (\f3\%PFMP_FORK_DRAW\fP | \f3\%PFMP_CULLoDRAW\fP).
.TP
\f3\%PFMP_APP_CULL_DRAW\fP
The application, cull, and draw stages are each separate processes.
Equivalent to (\f3\%PFMP_FORK_CULL\fP | \f3\%PFMP_FORK_DRAW\fP).
.TP
\f3\%PFMP_APP_CULLoDRAW\fP
The application, cull, and draw stages are each separate processes
and the cull and draw process are overlapped.
Equivalent to (\f3\%PFMP_FORK_CULL\fP | \f3\%PFMP_FORK_DRAW\fP | \f3\%PFMP_CULLoDRAW\fP).
.TP
\f3\%PFMP_DEFAULT\fP
OpenGL Performer will choose a multiprocessing mode based on the number
of pipelines required and the number of unrestricted processors
available. This is also the default mode if \f3\%pfMultiprocess\fP is
not called. \f3\%PFMP_DEFAULT\fP will attempt to use as many available
processors as possible except the \f3\%CULL\fP will not be automatically
multithreaded.
.RE

Example 4: Configuration with a light point process
.Ex
.nf


/* operate all processing tasks in parallel */
pfMultiprocess(PFMP_APP_CULL_DRAW | PFMP_FORK_LPOINT | PFMP_CULL_DL_DRAW);

.Ee
.fi
.na


The processing mode configured by this example looks like:
.Ex
.nf



        APP----- CULL ------->[ DRAW    ..]  (draws light points at the end)
       /              \                /
      /                \-----> LPOINT /   (preprocess light points in parallel to draw)
    ISECT

.Ee
.fi
.na



By default OpenGL Performer uses a single pfPipe.
If multiple rendering pipelines are required (in
most cases this will be for machines with multiple hardware pipelines),
use \f3\%pfMultipipe\fP to specify the number of pfPipes that
are created by \f3\%pfConfig\fP. Multipipe operation absolutely requires
that all participating hardware pipelines be genlocked. Otherwise
reduced throughput and increased latency will result.

The multiprocessing mode set by \f3\%pfMultiprocess\fP is used for all
rendering pipelines. However, OpenGL Performer never multi-threads the
application process although the application may choose to do so. If
the application itself multiprocesses, all OpenGL Performer calls must be
made from the process which calls \f3\%pfConfig\fP or results are
undefined.  When using multiple pipelines, the cull stage must be
forked (\f3\%PFMP_FORK_CULL\fP). If not, OpenGL Performer defaults to
\f3\%PFMP_APP_CULL_DRAW\fP.

\f3\%pfMultiprocess\fP, \f3\%pfMultithread\fP, and \f3\%pfMultipipe\fP must be called
after \f3\%pfInit\fP
but before \f3\%pfConfig\fP. \f3\%pfConfig\fP configures OpenGL Performer
according to the required number of pipelines and multiprocessing modes,
forks the appropriate number of OpenGL Performer processes and returns
control to the single-threaded application. \f3\%pfConfig\fP should be
called only once between \f3\%pfInit\fP and \f3\%pfExit\fP.
\f3\%pfConfig\fP returns a value of 1 if successful and -1 if an error is
detected.

\f3\%pfIsConfiged\fP returns a value of 1 if \f3\%pfConfig\fP has been
successfully called and a value of 0 otherwise.


OpenGL Performer uses \f3\%fork\fP to split off processes and will create the
specified number of separate processes only when \f3\%pfConfig\fP is
called. Forked processes do not share the same address space as
\f3\%sproc\fP'ed processes so the application must establish shared
memory communication mechanisms between processes or use the shared
memory features provided by OpenGL Performer (see \f3\%pfPassChanData\fP,
\f3\%pfMalloc\fP, \f3\%pfGetSharedArena\fP, \f3\%pfDataPool\fP).

In particular, care must be taken when the \f3\%DBASE\fP stage is configured
as a separate process. Although deletion requests (\f3\%pfDelete\fP) may be made
in any process, \f3\%DBASE\fP frees all the memory so if \f3\%DBASE\fP is forked
it can only free memory that was allocated out of OpenGL Performer's
shared memory arena (\f3\%pfGetSharedArena\fP) or from some other memory arena
that is visible to the \f3\%DBASE\fP process. Consequently it is safest
to allocate all objects from a shared memory arena when using a forked
\f3\%DBASE\fP process.

In addition to forking processes, \f3\%pfConfig\fP initializes the
number of pfFluxBuffer and pfCycleBuffer copies
(\f3\%pfFluxDefaultNumBuffers\fP and \f3\%pfCBufferConfig\fP) appropriate for
the multiprocessing mode.

\f3\%pfCreateProcessFunc\fP allows the specification of a callback function
that is called when Performer creates any process (the \f3\%pfConfig\fP forked
processes, the pfClock process, and the sproced processes for managing
pfQueues).  Users may specify a master process manager with this
mechanism for placing processes on CPUs and assigning them priorities.
A sample such process manager is in libpfutil and is set up with
\f3\%pfuInitDefaultProcessManager\fP and is the process manager used by
perfly.  By default the pfClock and pfQueue processes are placed
on the miscellaneous CPU that defaults to CPU 0
and no other management is done for the other created processes.
\f3\%pfGetCreateProcessFunc\fP will return the pointer to the current
process manager function which will be the internal default function
if one has not been set by the user.
\f3\%pfMiscCPU\fP will set the miscellaneous CPU and \f3\%pfGetMiscCPU\fP will
return the current \f3\%pfMiscCPU\fP that defaults to CPU 0 if it has not
been set.

After \f3\%pfConfig\fP is called, \f3\%pfGetPipe\fP should be used to get
handles to pfPipes for subsequent use in OpenGL Performer routines.
\f2pipe\fP identifies a pipe and ranges from 0 to numPipes - 1 where
numPipes is the number of pipes specified in \f3\%pfMultipipe\fP.

After \f3\%pfConfig\fP spawns other processes, \f3\%pfGetPID\fP will return the
process id of a specific pipeline stage or -1 to indicate error.
\f2pipe\fP specifies which pipeline the stage is in and ranges from 0 to
numPipes - 1. \f2stage\fP is a bitmask which identifies one or more
stages in the multiprocessing pipeline and may consist of:

.TS
center tab($) ;
C | C
L | L .
Token$Stage Description
_
\f3\%PFPROC_ISECT\fP$The intersection stage
\f3\%PFPROC_DBASE\fP$The database stage
\f3\%PFPROC_COMPUTE\fP$The pfASD, pfEngine/pfFlux and user compute stage
\f3\%PFPROC_APP\fP$The application stage
\f3\%PFPROC_CULL\fP$The cull stage
\f3\%PFPROC_DRAW\fP$The draw stage
\f3\%PFPROC_LPOINT\fP$The light points stage
\f3\%PFPROC_CLOCK\fP$The clock process
.TE

If \f2stage\fP identifies multiple stages, such as (\f3\%PFPROC_CULL |
PFPROC_DRAW\fP), then the process id will be returned only if an exact
match is made which in this example is only possible if the
multiprocessing mode is \f3\%PFMP_APP_CULLDRAW\fP. Otherwise a -1 is
returned.

\f2pipe\fP is ignored if \f2stage\fP identifies the \f3\%PFPROC_ISECT\fP,
\f3\%PFPROC_DBASE\fP, or \f3\%PFPROC_APP\fP stages since these stages are
not associated with any OpenGL Performer pipe.

\f3\%pfGetStage\fP is the "inverse" of \f3\%pfGetPID\fP. Given a process id,
\f2pid\fP, \f3\%pfGetStage\fP will return a bitmask which identifies the
stages that are performed by process \f2pid\fP and will copy into
\f2pipe\fP the number of the pipeline that \f2pid\fP is in if \f2pipe\fP is
not \f3\%NULL\fP. \f3\%pfGetStage\fP returns -1 if \f2pid\fP is not a known OpenGL
Performer process.

The stage bitmask used in \f3\%pfGetPID\fP and \f3\%pfGetStage\fP
identifies the thread number (\f3\%pfMultithread\fP) as well as
the processing stage(s). The thread ID is OR'ed into the upper bits of
the stage bitmask as follows:

.Ex
.nf

threadId = (stage & PFPROC_THREAD_MASK) >> PFPROC_THREAD_SHIFT;
.Ee
.fi
.na


The \f3\%PFPROC_THREAD1-7\fP tokens are provided as a convenience
(more than 8 threads are supported).

\f3\%pfGetPIDName\fP takes a process id \f2pid\fP and will return a pointer to a string
with a description of the processing that includes stage, pid, and pipe.
\f3\%pfGetStageName\fP takes a pfPipe number \f2pipe\fPand stage bit \f2stage\fP
and will return the string pointer with the full discription of the
corresponding process.

\f3\%pfPrintProcessState\fP will print to the opened file specified
by \f2fp\fP the current list of Performer processes and their
descriptions.  If the file pointer \f2fp\fP is NULL, the information
will be printed using standard \f2pfNotify\fP.

\f3\%pfGetMultiprocess\fP returns the requested multiprocess mode.
\f3\%pfGetMPBitmask\fP returns the actual multiprocess mode bitmask
in use which  might be different than the requested mode if \f3\%PFMP_DEFAULT\fP
was the requested mode or if single process was requested with
multipipe operation.
\f3\%pfGetMultipipe\fP returns the number of pfPipes configured.

After \f3\%pfConfig\fP, stage configuration callbacks may be specified with
\f3\%pfStageConfigFunc\fP and triggered with \f3\%pfConfigStage\fP. Configuration
callbacks are typically used for process initialization, e.g,
assign non-degrading priorities and locking processes to processors
or downloading textures in the \f3\%DRAW\fP stage callback.
The \f2stageMask\fP argument to \f3\%pfStageConfigFunc\fP is a bitmask which
identifies one or more OpenGL Performer stages (see \f3\%pfGetPID\fP above).
If >= 0, the \f2pipe\fP argument to \f3\%pfStageConfigFunc\fP selects
stage(s) on a particular pfPipe ( \f3\%pfGetPipe\fP(\f2pipe\fP) ). If
\f2pipe\fP is < 0 it selects stages of all pfPipes. Note that
\f2pipe\fP is ignored for the \f3\%PFPROC_ISECT\fP, \f3\%PFPROC_APP\fP, and
\f3\%PFPROC_DBASE\fP stages since they are not associated with any
pfPipe. \f2configFunc\fP is the callback function to be invoked for
the indicated stages. \f3\%pfGetStageConfigFunc\fP returns the
configuration function used for the stage identified by \f2pipe\fP
and \f2stageMask\fP.

\f3\%pfConfigStage\fP causes the callback functions to be invoked for
the identified stages at the start of processing the current
application frame. The current application frame gets to the next
stage at the next call to \f3\%pfFrame\fP.
\f2pipe\fP and \f2stageMask\fP are treated identically
as in \f3\%pfStageConfigFunc\fP. When multiprocessing, the callback functions
are invoked in the appropriate processes.

Example 4: Stage configuration

.Ex
.nf

void
configFunc(int pipe, uint stage)
{
    /* Fix CULL processes to processor 1 and 3 */
    if (stage == PFPROC_CULL)
	sysmp(MP_MUSTRUN, 2*pipe+1);

    /* Fix DRAW processes to processor 2 and 4 */
    else if (stage == PFPROC_DRAW)
	sysmp(MP_MUSTRUN, 2*pipe+2);
}

:

pfMultipipe(2);
pfMultiprocess(PFMP_APP_CULL_DRAW);
pfConfig();

pfStageConfigFunc(-1, PFPROC_CULL|PFPROC_DRAW, configFunc);
pfConfigStage(-1, PFPROC_CULL|PFPROC_DRAW);

pfFrame();

.Ee
.fi
.na


\f3\%pfHyperpipe\fP supports the hyperpipe hardware feature of
VGXT/Skywriter and Onyx/RealityEngine2 research systems, as well
as Onyx/InfiniteReality and Onyx2/InfiniteReality systems with
the DPLEX option. \f2n\fP indicates the number of pfPipes that
should be configured together in hyperpipe mode.  \f3\%pfHyperpipe\fP
should be called once for each hyperpipe group in the system that
is used by the application.

The first pfPipe in the new hyperpipe group will be the lowest
numbered pfPipe that is not currently assigned to another
hyperpipe group. This pfPipe is the master pfPipe. The slave
pfPipes are the next \f2n\fP-1 consecutive pfPipes. The master
pfPipe manages the pfPipeWindows and pfPipeVideoChannels for
the slave pfPipes. The application need only create or change
pfPipeWindows and pfPipeVideoChannels on the master pfPipe.
Performer will ensure that most attributes are propagated
to the slave objects. Those attributes that are graphics pipe
specific (i.e., VisualID or FBConfig) are not propagated, however.

Hyperpipes will run at a fraction of the system frame rate as defined
by \f3\%pfFrameRate\fP. For example, if the number of pipes in the hyperpipe
group is 2, then each pfPipe in the hyperpipe group will run at half the
system frame rate. Their aggregate rate will be equal to the system frame
rate.

\f3\%pfGetHyperpipe\fP returns the total number of pfPipes in the hyperpipe
group in which the given \f3\%pfPipe\fP belongs. \f3\%pfGetPipeHyperId\fP returns
the position of the given \f3\%pfPipe\fP in its hyperpipe group. The following
example configures a two-pipeline hyperpipe system. In this example, the
hyperpipe group pipes are screens 1 and 2 of the X display :0. This example
also configures screen 0 as a single, non-hyperpipe pipe.

Example 5: Hyperpipe Example
.Ex
.nf

pfMultipipe(3);  /* need 3 pipes, 2 for hyperpipe, 1 for single */
pfHyperpipe(2);  /* configure the hyperpipe (pfPipe 0 and 1) */
pfConfig();      /* configure Performer */

/* assign screens 1 and 2 to the hyperpipe pfPipes 0 and 1 */
pfPipeScreen(pfGetPipe(0), 1);
pfPipeScreen(pfGetPipe(1), 2);

/* assign screen 0 to the single pfPipe 2 */
pfPipeScreen(pfGetPipe(2), 0);

/* create the pfPipeWindow and pfChannel for the hyperpipe */
pwin = pfNewPWin(pfGetPipe(0));
/*
 * config this pwin as needed
 *
 * if fbconfig or visualid must be assigned directly then get
 * the pwin using:
 *     pwin = pfGetPipePWin(pfGetPipe(1), 0);
 *
 */

chan = pfNewChan(pfGetPipe(0));
/*
 * config the channel as needed
 */


/* create the pfPipeWindow and pfChannel for the single pipe */
pwin = pfNewPWin(pfGetPipe(2));
chan = pfNewChan(pfGetPipe(2));
.Ee
.fi
.na


The hyperpipe group configuration can be queried directly from GLX
(see glXQueryHyperpipeNetworkSGIX(3) for more information). This
information can be used to map pfPipes to physical screens.

During the execution frame of various Performer processes, The \f3\%APP\fP
process sometime waits for other processes. If multiple Performer processes run
on the same CPU, this wait can cause a system slowdown. OpenGL Performer provides
minimal control over process priorities in order to avoid this slowdown.  This
support is relevant only when running in real-time priorities.  Performer
supports temporary changes to the priorities of the \f3\%CULL\fP, \f3\%ISECT\fP,
\f3\%DBASE\fP and \f3\%COMPUTE\fP processes: When the \f3\%APP\fP process has to wait on
another Performer process, it can temporarily increase its priority to a fixed
high priority.

\f3\%pfProcessPriorityUpgrade\fP turns priority-upgrading on or off.
\f3\%pfGetProcessPriorityUpgrade\fP returns the current priority-upgrade mode.
By default, OpenGL Performer performs no priority
upgrades. Priority upgrading is necessary only when running more than one
Performer process on the same CPU with different real-time priorities. If every
Performer process is allocated a separate CPU, or when processes sharing a CPU
have the same priority, priority upgrading isn't necessary.
If Performer fails to change a process priority once, it turns
priority-upgrading off. This can happen when not running as super-user.

\f3\%pfProcessHighestPriority\fP and \f3\%pfGetProcessHighestPriority\fP set and get
the high priority that the APP process will upgrade to. By default, this
priority is set to 87. The set priority should be higher than the priorities
of all other OpenGL Performer processes.


.SH NOTES


Multiprocessing (forked CULL, DRAW, X Input, LPOINT, DBASE,
COMPUTE, etc.) is not supported in the single processor
version of OpenGL Performer for Linux.  Only PFMP_APPCULLDRAW
mode is available.

In practice, user callbacks in the intersection process
call only \f3\%pfNodeIsectSegs\fP and user callbacks in the database
process uses the pfBuffer mechanism to asynchronously create and delete
scene graphs to implement database paging.

If \f3\%PFMP_DEFAULT\fP is not used, it is up to the application to tailor
the number of OpenGL Performer processes to the number of processors.
Care must be taken to avoid thrashing, starvation, and deadlock.

If \f3\%pfIsectFunc\fP is called before \f3\%pfConfig\fP and the
multiprocessing mode is \f3\%PFMP_DEFAULT\fP, then \f3\%pfConfig\fP will fork
the intersection process if there are enough processors. Otherwise, you
must explicitly fork the intersection process by setting the
\f3\%PFMP_FORK_ISECT\fP bit in the argument passed to \f3\%pfMultiprocess\fP.

When using \f3\%PFMP_CULLoDRAW\fP, multipass algorithms (e.g. - landing
lights on InfiniteReality and RealityEngine) which call \f3\%pfDraw\fP more
than once per frame will not work.
.SH BUGS

If \f3\%PFMP_CULLoDRAW\fP is used, modifications to pfChannel passthrough
data (see \f3\%pfPassChanData\fP) made by the cull callback will not be
passed along to the draw callback. However, modifications made by the
application process will still make it to both cull and draw
callbacks.

\f3\%PFMP_CULLoDRAW\fP usually has no effect when OpenGL Performer is in the
free-running frame rate control mode specified by
\f3\%pfPhase(PFPHASE_FREE_RUN)\fP. Instead, use \f3\%PFPHASE_FLOAT\fP or
\f3\%PFPHASE_LOCK\fP.

When in \f3\%PFMP_CULLoDRAW\fP mode, the draw time recorded by OpenGL
Performer statistics does not include the time the draw process spends
waiting for the cull process to begin filling the ring buffer.

\f3\%OBSOLETE\fP

\f3\%pfInitPipe\fP is an obsolete routine for initializing the graphics
subsystem for a pfPipe. A callback function \f2configFunc\fP could be
provided for initializing \f2pipe\fP in the draw process and was used
for opening windows in the draw process for the pfPipe.  This function
has been obsoleted by the pfPipeWindow primitive which can be used to
configure windows in either or both the application process and draw
process, and by \f3\%pfConfigStage\fP which provides a mechanism for
initializing any OpenGL Performer process or pfPipe stage.  See the
\f3\%pfPipeWindow\fP man page for more information on
creating and opening OpenGL Performer windows.


.SH SEE ALSO
fork,
m_fork,
pfChannel,
pfCycleBuffer,
pfInit,
pfIsectFunc,
pfDBaseFunc,
pfPipe,
sproc
