'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfDCS" "3pf"
.SH NAME
.upperok
.B pfDCS
\- 
Create, modify and get the matrix of a dynamic coordinate system.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfDCS.h>
.nf
.fi
.TP
\ 
\f3\%pfDCS::pfDCS\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfDCS::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfDCS::setTrans\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDCS::setRot\fP(float\ h,
'in +2
'll -2
float\ p,
float\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDCS::setCoord\fP(pfCoord\ *coord);
.nf
.fi
.TP
void
\f3\%pfDCS::setScale\fP(float\ s);
.nf
.fi
.TP
void
\f3\%pfDCS::setScale\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDCS::setMat\fP(pfMatrix\ &m);
.nf
.fi
.TP
void
\f3\%pfDCS::getMat\fP(pfMatrix\ &m);
.nf
.fi
.TP
const pfMatrix*
\f3\%pfDCS::getMatPtr\fP(void);
.nf
.fi
.TP
void
\f3\%pfDCS::setMatType\fP(uint\ val);
.nf
.fi
.TP
uint
\f3\%pfDCS::getMatType\fP();
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfDCS\fP is
derived from the parent class \f3\%pfSCS\fP,
so each of these member functions of
class \f3\%pfSCS\fP
are also directly usable with objects
of class \f3\%pfDCS\fP.
This is also true for
ancestor classes
of class \f3\%pfSCS\fP.

.PD 0
.TP \w'const\ pfMatrix*\ \ \ 'u
void
\f3\%pfSCS::getMat\fP(pfMatrix\ &mat);
.PD 0
.TP
const pfMatrix*
\f3\%pfSCS::getMatPtr\fP(void);

.PD
.PP
Since the class
\f3\%pfSCS\fP is itself derived from
the parent class \f3\%pfGroup\fP, objects
of class \f3\%pfDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfDCS (Dynamic Coordinate System) is a pfSCS whose matrix can be
modified.

\f3\%new pfDCS\fP creates and returns a handle to a pfDCS.  Like
other pfNodes, pfDCSes are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfDCSes should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfDCS::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfDCS\fP.  The \f3\%pfType\fP* returned
by \f3\%pfDCS::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfDCS\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

The initial transformation is the identity matrix.  The transformation
of a pfDCS can be set by specifying a matrix or translation, scale and
rotation.  When independently setting translation, rotation, and
scale, the pfDCS matrix is computed as S*R*T, where S is the scale, R
is the rotation, and T is the translation. The order of effect is then
scale followed by rotation followed by translation.

pfDCS operations are absolute rather than cumulative.  For example:
.Ex
.nf

dcs->setTrans(2.0f, 0.0f, 0.0f);
dcs->setTrans(1.0f, 0.0f, 0.0f);
.Ee
.fi
.na

specifies a translation by 1 unit along the X coordinate axis, not
3 units.

By default a pfDCS uses a bounding sphere which is dynamic, so it is
automatically updated when the pfDCS transformation is changed or when
children are added, deleted or changed.  This behavior may be changed
using \f3\%pfNode::setBound\fP.  The bound for a pfDCS encompasses all
B(i)*S*R*T, where B(i) is the bound for the child 'i' and S*R*T
represents the scale, rotation, and translation transformation of the
pfDCS.

\f3\%pfDCS::setTrans\fP sets the translation part of the pfDCS to (\f2x\fP,
\f2y\fP, \f2z\fP).  The rotational portion of the matrix is unchanged.

\f3\%pfDCS::setScale\fP sets the scale portion of the pfDCS to scale uniformly
by a scale factor \f2s\fP.  This supersedes the previous scale leaving
the rotation and translation unchanged. \f3\%pfDCS::setScale\fP specifies
a non-uniform scale of \f2x\fP, \f2y\fP, \f2z\fP.

\f3\%pfDCS::setRot\fP sets the rotation portion of the matrix:
.RS
.TP 5
\f2h\fP
Specifies heading, the rotation about the Z axis.
.TP
\f2p\fP
Specifies pitch, the rotation about the X axis.
.TP
\f2r\fP
Specifies roll, rotation about the Y axis.
.RE

The matrix created is R*P*H, where R is the roll transform, P is the
pitch transform and H is the heading transform.  The new (h,p,r)
combination replaces the previous specification, leaving the scale and
translation unchanged.  The convention is natural for a model in which
+Y is "forward," +Z is "up" and +X is "right".  To maintain 1/1000
degree resolution in the single precision arithmetic used internally
for sine and cosine calculations, the angles \f2h\fP, \f2p\fP, \f2r\fP should
be in the range of -7500 to +7500 degrees.

\f3\%pfDCS::setCoord\fP sets the rotation and translation portion of the pfDCS
according to \f2coord\fP.  This is equivalent to:
.Ex
.nf

dcs->setRot(coord->hpr[0], coord->hpr[1], coord->hpr[2]);
dcs->setTrans(coord->xyz[0], coord->xyz[1], coord->xyz[2]);
.Ee
.fi
.na


\f3\%pfDCS::setMat\fP sets the transformation matrix for
the pfDCS to \f2m\fP.

Normally \f3\%pfDCS::setMat\fP is used as a replacement
for the above routines which individually set the scale, rotation and
translational components.  The mechanisms can be combined but only if
the supplied matrix can be represented as scale followed by a
rotation followed by a translation (e.g. a point pt is transformed by
the matrix as: pt' = pt*S*R*T), which implies that no shearing or
non-uniform scaling is present.

\f3\%pfDCS::setMatType\fP allows the specification of
information about the type of transformation the matrix represents.
This information allows Performer to speed up some operations.  The
matrix type is specified as the OR of

.RS
.TP5
PFMAT_TRANS:
matrix may include a translational component in the 4th row.
.TP
PFMAT_ROT
matrix may include a rotational component in the left upper 3X3 submatrix.
.TP
PFMAT_SCALE
matrix may include a uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_NONORTHO
matrix may include a non-uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_PROJ
matrix may include projections.
.TP
PFMAT_HOM_SCALE
matrix may have mat[4][4] != 1.
.TP
PFMAT_MIRROR
matrix may include mirroring transformation that
switches between right handed and left handed coordinate systems.
.TP
.RE

\f3\%pfDCS::getMatType\fP returns the matrix type as
set by \f3\%pfDCS::setMatType\fP.  If no matrix type is
set the default is ~0, corresponding to a general matrix.

The transformation of a pfDCS affects all its children.  As the
hierarchy is traversed from top to bottom, each new matrix is
pre-multiplied to create the new transformation.  For example, if
DCSb is below DCSa in the scene graph, any geometry G below DCSa is
transformed as G*DCSb*DCSa.

\f3\%pfNode::flatten\fP cannot flatten pfDCSes since they may change at
run-time.  In this case \f3\%pfNode::flatten\fP will compute a pfSCS representing
the accumulated static transformation that the pfDCS inherits and
insert it above the pfDCS.  Static transformations below a pfDCS are
flattened as usual.  See \f3\%pfNode::flatten\fP for more details.

The presence of transformations in the scene graph impacts the
performance of intersection, culling and drawing.  pfGeoSet culling
(see \f3\%PFCULL_GSET\fP in \f3\%pfChannel::setTravMode\fP) is disabled in portions of
the scene graph below pfDCSes.

Both pre and post CULL and DRAW callbacks attached to a pfDCS
(\f3\%pfNode::setTravFuncs\fP) will be affected by the transformation
represented by the pfDCS, i.e. - the pfDCS matrix will already have been
applied to the matrix stack before the pre callback is called and will
be popped only after the post callback is called.

\f3\%pfDCS::getMat\fP copies the transformation matrix value from the pfDCS
into the matrix \f2m\fP.  For faster matrix access, \f3\%pfDCS::getMatPtr\fP
can be used to get a const pointer to the pfDCS's matrix.
.SH SEE ALSO
pfCoord,
pfGroup,
pfChannel,
pfLookupNode,
pfFlatten,
pfMatrix,
pfNode,
pfSCS,
pfScene,
pfTraverser,
pfDelete
