'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfDoubleDCS" "3pf"
.SH NAME
.upperok
.B pfDoubleDCS
\- 
Create, modify and get the matrix of a double-precision dynamic coordinate system.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfMatrix4d*\ \ \ 'u
#include <Performer/pf/pfDoubleDCS.h>
.nf
.fi
.TP
\ 
\f3\%pfDoubleDCS::pfDoubleDCS\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfDoubleDCS::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setTrans\fP(double\ x,
'in +2
'll -2
double\ y,
double\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setRot\fP(double\ h,
'in +2
'll -2
double\ p,
double\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setCoord\fP(pfCoordd\ *coord);
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setScale\fP(double\ s);
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setScale\fP(double\ x,
'in +2
'll -2
double\ y,
double\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setMat\fP(pfMatrix4d\ &m);
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::getMat\fP(pfMatrix4d\ &m);
.nf
.fi
.TP
const pfMatrix4d*
\f3\%pfDoubleDCS::getMatPtr\fP(void);
.nf
.fi
.TP
void
\f3\%pfDoubleDCS::setMatType\fP(uint\ val);
.nf
.fi
.TP
uint
\f3\%pfDoubleDCS::getMatType\fP();
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfDoubleDCS\fP is
derived from the parent class \f3\%pfDoubleSCS\fP,
so each of these member functions of
class \f3\%pfDoubleSCS\fP
are also directly usable with objects
of class \f3\%pfDoubleDCS\fP.
This is also true for
ancestor classes
of class \f3\%pfDoubleSCS\fP.

.PD 0
.TP \w'const\ pfMatrix4d*\ \ \ 'u
void
\f3\%pfDoubleSCS::getMat\fP(pfMatrix4d\ &mat);
.PD 0
.TP
const pfMatrix4d*
\f3\%pfDoubleSCS::getMatPtr\fP(void);

.PD
.PP
Since the class
\f3\%pfDoubleSCS\fP is itself derived from
the parent class \f3\%pfGroup\fP, objects
of class \f3\%pfDoubleDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfDoubleDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfDoubleDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfDoubleDCS\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfDoubleDCS (Double-precision Dynamic Coordinate System) is a pfDoubleSCS
whose matrix can be modified. It is useful for generating scenes with objects
very far away from the origin.

\f3\%new pfDoubleDCS\fP creates and returns a handle to a pfDoubleDCS.  Like
other pfNodes, pfDoubleDCSes are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfDoubleDCSes should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfDoubleDCS::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfDoubleDCS\fP.  The \f3\%pfType\fP* returned
by \f3\%pfDoubleDCS::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfDoubleDCS\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

The initial transformation is the identity matrix.  The transformation
of a pfDoubleDCS can be set by specifying a matrix or translation, scale and
rotation.  When independently setting translation, rotation, and
scale, the pfDoubleDCS matrix is computed as S*R*T, where S is the scale, R
is the rotation, and T is the translation. The order of effect is then
scale followed by rotation followed by translation.

pfDoubleDCS operations are absolute rather than cumulative.  For example:
.Ex
.nf

dcs->setTrans(2.0f, 0.0f, 0.0f);
dcs->setTrans(1.0f, 0.0f, 0.0f);
.Ee
.fi
.na

specifies a translation by 1 unit along the X coordinate axis, not
3 units.

By default a pfDoubleDCS uses a bounding sphere which is dynamic, so it is
automatically updated when the pfDoubleDCS transformation is changed or when
children are added, deleted or changed.  This behavior may be changed
using \f3\%pfNode::setBound\fP.  The bound for a pfDoubleDCS encompasses all
B(i)*S*R*T, where B(i) is the bound for the child 'i' and S*R*T
represents the scale, rotation, and translation transformation of the
pfDoubleDCS.

\f3\%pfDoubleDCS::setTrans\fP sets the translation part of the pfDoubleDCS to (\f2x\fP,
\f2y\fP, \f2z\fP).  The rotational portion of the matrix is unchanged.

\f3\%pfDoubleDCS::setScale\fP sets the scale portion of the pfDoubleDCS to scale uniformly
by a scale factor \f2s\fP.  This supersedes the previous scale leaving
the rotation and translation unchanged. \f3\%pfDoubleDCS::setScale\fP specifies
a non-uniform scale of \f2x\fP, \f2y\fP, \f2z\fP.

\f3\%pfDoubleDCS::setRot\fP sets the rotation portion of the matrix:
.RS
.TP 5
\f2h\fP
Specifies heading, the rotation about the Z axis.
.TP
\f2p\fP
Specifies pitch, the rotation about the X axis.
.TP
\f2r\fP
Specifies roll, rotation about the Y axis.
.RE

The matrix created is R*P*H, where R is the roll transform, P is the
pitch transform and H is the heading transform.  The new (h,p,r)
combination replaces the previous specification, leaving the scale and
translation unchanged.  The convention is natural for a model in which
+Y is "forward," +Z is "up" and +X is "right".  To maintain 1/1000
degree resolution in the single precision arithmetic used internally
for sine and cosine calculations, the angles \f2h\fP, \f2p\fP, \f2r\fP should
be in the range of -7500 to +7500 degrees.

\f3\%pfDoubleDCS::setCoord\fP sets the rotation and translation portion of the pfDoubleDCS
according to \f2coord\fP.  This is equivalent to:
.Ex
.nf

dcs->setRot(coord->hpr[0], coord->hpr[1], coord->hpr[2]);
dcs->setTrans(coord->xyz[0], coord->xyz[1], coord->xyz[2]);
.Ee
.fi
.na


\f3\%pfDoubleDCS::setMat\fP sets the transformation matrix for
the pfDoubleDCS to \f2m\fP.

Normally \f3\%pfDoubleDCS::setMat\fP is used as a replacement
for the above routines which individually set the scale, rotation and
translational components.  The mechanisms can be combined but only if
the supplied matrix can be represented as scale followed by a
rotation followed by a translation (e.g. a point pt is transformed by
the matrix as: pt' = pt*S*R*T), which implies that no shearing or
non-uniform scaling is present.

\f3\%pfDoubleDCS::setMatType\fP allows the specification of
information about the type of transformation the matrix represents.
This information allows Performer to speed up some operations.  The
matrix type is specified as the OR of

.RS
.TP5
PFMAT_TRANS:
matrix may include a translational component in the 4th row.
.TP
PFMAT_ROT
matrix may include a rotational component in the left upper 3X3 submatrix.
.TP
PFMAT_SCALE
matrix may include a uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_NONORTHO
matrix may include a non-uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_PROJ
matrix may include projections.
.TP
PFMAT_HOM_SCALE
matrix may have mat[4][4] != 1.
.TP
PFMAT_MIRROR
matrix may include mirroring transformation that
switches between right handed and left handed coordinate systems.
.RE

\f3\%pfDoubleDCS::getMatType\fP returns the matrix type as
set by \f3\%pfDoubleDCS::setMatType\fP.  If no matrix type is
set the default is ~0, corresponding to a general matrix.

The transformation of a pfDoubleDCS affects all its children.  As the
hierarchy is traversed from top to bottom, each new matrix is
pre-multiplied to create the new transformation.  For example, if
DoubleDCSb is below DoubleDCSa in the scene graph, any geometry G below DoubleDCSa is
transformed as G*DoubleDCSb*DoubleDCSa.

\f3\%pfNode::flatten\fP cannot flatten pfDoubleDCSes since they may change at
run-time.  In this case \f3\%pfNode::flatten\fP will compute a pfDoubleSCS representing
the accumulated static transformation that the pfDoubleDCS inherits and
insert it above the pfDoubleDCS.  Static transformations below a pfDoubleDCS are
flattened as usual.  See \f3\%pfNode::flatten\fP for more details.

The presence of transformations in the scene graph impacts the
performance of intersection, culling and drawing.  pfGeoSet culling
(see \f3\%PFCULL_GSET\fP in \f3\%pfChannel::setTravMode\fP) is disabled in portions of
the scene graph below pfDoubleDCSes.

Both pre and post CULL and DRAW callbacks attached to a pfDoubleDCS
(\f3\%pfNode::setTravFuncs\fP) will be affected by the transformation
represented by the pfDoubleDCS, i.e. - the pfDoubleDCS matrix will already have been
applied to the matrix stack before the pre callback is called and will
be popped only after the post callback is called.

\f3\%pfDoubleDCS::getMat\fP copies the transformation matrix value from the pfDoubleDCS
into the matrix \f2m\fP.  For faster matrix access, \f3\%pfDoubleDCS::getMatPtr\fP
can be used to get a const pointer to the pfDoubleDCS's matrix.

\f3\%pfDoubleDCS\fP nodes are useful for modeling objects very far from the origin
or the database - so far away that the resolution of floating point numbers
isn't high enough to express small movements of the objects. We use a common
example to describe this feature of \f3\%pfDoubleDCS\fP nodes:

When modeling a round Earth and placing the origin in the center of the Earth,
the surface of the Earth is very far from the origin. The resolution of
floating point numbers is not high enough to express translations of 1 cm on the
surface of the Earth.

Since the underlying OpenGL implementation does not support double-precision
math, modeling in double precision numbers does not help. Instead, we observe
that when we fly/drive over the surface of the Earth, we want to depict small
translations only in the vicinity of the camera. Translating an object 200
miles away from the camera by 1 cm has negligible effect on the output image.
\f3\%pfDoubleDCS\fP nodes provide a method to translate the camera position to the
origin of the database every frame, and to correct the relative position of the
scene to that of the camera. This way, all the geometry in the vicinity of the
camera becomes close enough to the origin that the resolution of floating point
numbers is high enough to express small object translations.

In more practical terms, given a camera position at \f2E = (Ex, Ey, Ez)\fP, and a
database tile position at \f2T = (Tx, Ty, Tz)\fP, we build a scene graph with a
single \f3\%pfDoubleDCS\fP node at the root, and one \f3\%pfDoubleDCS\fP node above
each tile. We set the channel eyepoint in the origin by seting the channel
viewing matrix to the identity matrix. We then use the \f3\%pfDoubleDCS\fP node at
the root to express the real camera position and the \f3\%pfDoubleDCS\fP node above
each tile to express the position of the tile.  We load the translation \f2-E =
(-Ex, -Ey, -Ez)\fP onto the root \f3\%pfDoubleDCS\fP and the translation \f2T = (Tx,
Ty, Tz)\fP onto the tile \f3\%pfDoubleDCS\fP.  When Performer traverses the scene
graph, it composes the final translation \f2T-E = (Tx-Ex, Ty-Ey, Tz-Ez)\fP. When
the camera is fairly close to the tile, this translation is small enough that
even floating point numbers provide a high enough resolution for it.

Coding the above example we get:

.Ex
.nf

void
setDoublePrecisionDCS (pfChannel *chan,
                       pfDoubleDCS *ddcs,
                       pfCoordd *coord)
{
    pfMatrix4d          mat, invMat;

    // Channel camera is at origin.
    chan -> setViewMat(pfIdentMat);

    mat -> makeCoordd (coord);

    invMat -> invertOrthoN (mat);

    // Put inverse of camera position in double DCS.
    ddcs -> setMat (invMat);
}
.Ee
.fi
.na


where \f2coord\fP contains the camera position, and \f2ddcs\fP is the
\f3\%pfDoubleDCS\fP at the root of the scene graph. Every time the camera position
changes, we have to update the \f3\%pfDoubleDCS\fP at the root of the scene graph.
The tiles contain vertex coordinates relative to the tile origin. This origin
is translated by the tile \f3\%pfDoubleDCS\fP to the correct position.

\f3\%Important Note\fP

During the Performer CULL traversal, Performer maintains the accumulated matrix
from the root of the scene graph to the current node. Performer also maintains
the precision level of this accumulated matrix. When the last matrix node on
the path from the root of the scene graph to a node is a double-precision
matrix, the CULL test is ignored on this node. In other words, all the nodes
whose closest parent matrix node is a double-precision node are accepted by
the CULL traversal and are always drawn.

Performer does not CULL these nodes because the standard Performer node bounding
sphere is single-precision and can not correctly express double precision
matrix operations. Converting to double-precision bounding spheres would have
slowed down the CULL traversal.

There is a simple workaround that forces Performer back to single precision
mode: Add a \f3\%pfSCS\fP node below the lowest \f3\%pfDouble?CS\fP node. Use an
identity matrix for the new \f3\%pfSCS\fP node. The \f3\%pfSCS\fP node demotes the
CULL traversal back to single-precision mode, and the CULL test becomes active
again.

The sample code under /usr/share/Performer/src/pguide/libpf/C/doubleDCS2.c
demonstrates how to create a scene graph with the correct node setup.

.SH SEE ALSO
pfCoord,
pfGroup,
pfChannel,
pfLookupNode,
pfFlatten,
pfMatrix,
pfNode,
pfDCS,
pfSCS,
pfFCS,
pfDoubleSCS,
pfDoubleFCS,
pfScene,
pfTraverser,
pfDelete
