'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfDoubleFCS" "3pf"
.SH NAME
.upperok
.B pfDoubleFCS
\- 
Create, modify, and query double-precision flux coordinate system nodes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfMatrix4d*\ \ \ 'u
#include <Performer/pf/pfDoubleFCS.h>
.nf
.fi
.TP
\ 
\f3\%pfDoubleFCS::pfDoubleFCS\fP(pfFlux\ *flux);
.nf
.fi
.TP
static pfType *
\f3\%pfDoubleFCS::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfDoubleFCS::setFlux\fP(pfFlux\ *flux);
.nf
.fi
.TP
pfFlux*
\f3\%pfDoubleFCS::getFlux\fP(void);
.nf
.fi
.TP
void
\f3\%pfDoubleFCS::getMat\fP(pfMatrix4d\ &m);
.nf
.fi
.TP
const pfMatrix4d*
\f3\%pfDoubleFCS::getMatPtr\fP(void);
.nf
.fi
.TP
void
\f3\%pfDoubleFCS::setMatType\fP(uint\ val);
.nf
.fi
.TP
uint
\f3\%pfDoubleFCS::getMatType\fP();
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfDoubleFCS\fP is
derived from the parent class \f3\%pfDoubleSCS\fP,
so each of these member functions of
class \f3\%pfDoubleSCS\fP
are also directly usable with objects
of class \f3\%pfDoubleFCS\fP.
This is also true for
ancestor classes
of class \f3\%pfDoubleSCS\fP.

.PD 0
.TP \w'const\ pfMatrix4d*\ \ \ 'u
void
\f3\%pfDoubleSCS::getMat\fP(pfMatrix4d\ &mat);
.PD 0
.TP
const pfMatrix4d*
\f3\%pfDoubleSCS::getMatPtr\fP(void);

.PD
.PP
Since the class
\f3\%pfDoubleSCS\fP is itself derived from
the parent class \f3\%pfGroup\fP, objects
of class \f3\%pfDoubleFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfDoubleFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfDoubleFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfDoubleFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfDoubleFCS (Double-precision Flux Coordinate System) is a pfDoubleSCS whose
matrix is contained in a pfFlux.  A pfDoubleFCS is similar to a pfDoubleDCS,
in that its matrix can change, but since its matrix is contained in a pfFlux,
it can be animated using pfEngines.

\f3\%new pfDoubleFCS\fP creates and returns a handle to a pfDoubleFCS.  The
matrix of a the new pfDoubleFCS will be contained in \f2flux\fP. Like
other pfNodes, pfDoubleFCSes are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfDoubleFCSes should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfDoubleFCS::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfDoubleFCS\fP.  The \f3\%pfType\fP* returned
by \f3\%pfDoubleFCS::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfDoubleFCS\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfDoubleFCS::setFlux\fP attaches a pfFlux to a pDoubleFCS.

\f3\%pfDoubleFCS::getFlux\fP returns the pfFlux currently attached
to a pfDoubleFCS.

\f3\%pfDoubleFCS::setMatType\fP allows the specification of
information about the type of transformation the matrix represents.
This information allows Performer to speed up some operations.  The
matrix type is specified as the OR of

.RS
.TP5
PFMAT_TRANS:
matrix may include a translational component in the 4th row.
.TP
PFMAT_ROT
matrix may include a rotational component in the left upper 3X3 submatrix.
.TP
PFMAT_SCALE
matrix may include a uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_NONORTHO
matrix may include a non-uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_PROJ
matrix may include projections.
.TP
PFMAT_HOM_SCALE
matrix may have mat[4][4] != 1.
.TP
PFMAT_MIRROR
matrix may include mirroring transformation that
switches between right handed and left handed coordinate systems.
.TP
.RE

\f3\%pfDoubleFCS::getMatType\fP returns the matrix type as
set by \f3\%pfDoubleFCS::setMatType\fP.  If no matrix type is
set the default is ~0, corresponding to a general matrix.

The transformation of a pfDoubleFCS affects all its children.  As the
hierarchy is traversed from top to bottom, each new matrix is
pre-multiplied to create the new transformation.  For example, if
DoubleFCSb is below DoubleFCSa in the scene graph, any geometry G below DoubleFCSa is
transformed as G*DoubleFCSb*DoubleFCSa.

\f3\%pfNode::flatten\fP cannot flatten pfDoubleFCSes since they may
change at run-time.  In this case \f3\%pfNode::flatten\fP will
compute a pfDoubleSCS representing
the accumulated static transformation that the pfDoubleFCS inherits and
insert it above the pfDoubleFCS.  Static transformations below a pfDoubleFCS are
flattened as usual.  See \f3\%pfNode::flatten\fP for more details.

The presence of transformations in the scene graph impacts the
performance of intersection, culling and drawing.  pfGeoSet culling
(see \f3\%PFCULL_GSET\fP in \f3\%pfChannel::setTravMode\fP) is
disabled in portions of
the scene graph below pfDoubleFCSes.

Both pre and post CULL and DRAW callbacks attached to a pfDoubleFCS
(\f3\%pfNode::setTravFuncs\fP) will be affected by
the transformation represented by the pfDoubleFCS, i.e. - the pfDoubleFCS matrix will
already have been applied to the matrix stack before the pre callback is
called and will be popped only after the post callback is called.

\f3\%pfDoubleFCS::getMat\fP copies the transformation matrix value
from the pfDoubleFCS into the matrix \f2m\fP.  For faster matrix
access, \f3\%pfDoubleFCS::getMatPtr\fP
can be used to get a const pointer to the pfDoubleFCS's matrix.
.SH SEE ALSO
pfFlux,
pfEngine,
pfGroup,
pfChannel,
pfLookupNode,
pfFlatten,
pfMatrix4d,
pfNode,
pfDoubleSCS,
pfDoubleDCS,
pfScene,
pfTraverser,
pfDelete
