'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfEngine" "3pf"
.SH NAME
.upperok
.B pfEngine,
.B 
\- 
Create, initialize, and manage a pfEngine
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfEngineFuncType\ \ \ 'u
#include <Performer/pr/pfEngine.h>
.nf
.fi
.TP
pfEngine*
\f3\%pfEngine::pfEngine\fP(int\ function);
.nf
.fi
.TP
static pfType *
\f3\%pfEngine::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfEngine::setSrc\fP(int\ index,
'in +2
'll -2
void\ *data,
ushort\ *ilist,
int\ icount,
int\ offset,
int\ stride);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEngine::getSrc\fP(int\ index,
'in +2
'll -2
void\ **data,
ushort\ **ilist,
int\ *icount,
int\ *offset,
int\ *stride);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfEngine::getNumSrcs\fP(void);
.nf
.fi
.TP
void
\f3\%pfEngine::setDst\fP(void\ *data,
'in +2
'll -2
ushort\ *ilist,
int\ offset,
int\ stride);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEngine::getDst\fP(void\ **data,
'in +2
'll -2
ushort\ **ilist,
int\ *offset,
int\ *stride);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEngine::setIterations\fP(int\ iterations,
'in +2
'll -2
int\ items);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEngine::getIterations\fP(int\ *iterations,
'in +2
'll -2
int\ *items);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfEngine::getFunction\fP(void);
.nf
.fi
.TP
void
\f3\%pfEngine::setUserFunction\fP(pfEngineFuncType\ func);
.nf
.fi
.TP
pfEngineFuncType
\f3\%pfEngine::getUserFunction\fP(void);
.nf
.fi
.TP
void
\f3\%pfEngine::setMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfEngine::getMode\fP(int\ mode);
.nf
.fi
.TP
void
\f3\%pfEngine::setMask\fP(uint\ mask);
.nf
.fi
.TP
uint
\f3\%pfEngine::getMask\fP(void);
.nf
.fi
.TP
void
\f3\%pfEngine::setEvaluationRange\fP(pfVec3\ &center,
'in +2
'll -2
float\ min,
float\ max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEngine::getEvaluationRange\fP(pfVec3\ &center,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEngine::srcChanged\fP(void);
.nf
.fi
.TP
void
\f3\%pfEngine::evaluate\fP(int\ mask);
.nf
.fi
.TP
void
\f3\%pfEngine::evaluate\fP(int\ mask,
'in +2
'll -2
pfVec3\ eye_pos);
.in
.ll
.nf
.fi
.TP
typedef void
\f3\%(*pfEngineFuncType)\fP(pfEngine\ *engine);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfEngine\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfEngine\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfEngine\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A \f3\%pfEngine\fP is an object for controlling the dynamic data in a \f3\%pfFlux\fP.

\f3\%new\fP(arena) allocates a \f3\%pfEngine\fP from the specified memory arena, or
from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
\f3\%pfEngine\fP from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like
other pfObjects, \f3\%pfEngines\fP cannot be created statically, automatically
on the stack or in arrays.  \f3\%pfEngines\fP should be deleted
with \f3\%pfDelete\fP rather than the delete operator.
\f2function\fP is a symbolic token that specifies the function the pfEngine will
execute.  The \f2function\fP may be one of:

.RS
\f3\%PFENG_SUM\fP
.br
\f3\%PFENG_MORPH\fP
.br
\f3\%PFENG_BLEND\fP
.br
\f3\%PFENG_TRANSFORM\fP
.br
\f3\%PFENG_ALIGN\fP
.br
\f3\%PFENG_MATRIX\fP
.br
\f3\%PFENG_ANIMATE\fP
.br
\f3\%PFENG_BBOX\fP
.br
\f3\%PFENG_TIME\fP
.br
\f3\%PFENG_STROBE\fP
.br
\f3\%PFENG_USER_FUNCTION\fP
.RE

\f3\%pfEngine::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfEngine\fP.  The \f3\%pfType\fP* returned
by \f3\%pfEngine::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfEngine\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfEngine::getFunction\fP returns the
function of a pfEngine.

\f3\%pfEngine::setIterations\fP and
\f3\%pfEngine::getIterations\fP set and get
the number of iterations and items a pfEngine should operate on.
\f2iterations\fP is the number of times the engine should iterate.
\f2items\fP is the number of items that are operated on each iteration.
For example, if you wanted to add two arrays of 100 pfVec3s each, you
would set \f2iterations\fP to 100 and \f2items\fP to 3.

For some functions \f2iterations\fP and \f2items\fP are meaningless, and
they have special meanings in some functions.  This is noted in
the descriptions of the functions.

\f3\%pfEngine::setSrc\fP and
\f3\%pfEngine::getSrc\fP set and get the sources
of a pfEngine.

\f2index\fP specifies which source of a function is being set.  There are
symbolic tokens that define the sources for each of the functions.

\f2data\fP should be either a pfFlux* or a pointer to a block of
memory allocated with \f3\%pfMemory::malloc\fP.

\f2ilist\fP is an array of indexes into the destination
and specifies which destination elements this source
effects.  It can, and often will be, set to NULL in
which case this source effects all elements of the
destination.  Also if the \f2ilist\fP is set to NULL and
the destination has a non NULL \f2ilist\fP the destinations
\f2ilist\fP will be used as the source \f2ilist\fP.

\f2icount\fP is the number of indexes the \f2ilist\fP contains.

\f2offset\fP is the starting offset of the first element
of this source.  This will often be 0.

\f2stride\fP is how much the pointer should be advanced after
each iteration of the function.  This is often equal
to \f2items\fP from \f3\%pfEngine::setIterations\fP.

Both \f2offset\fP and \f2stride\fP are measured in items, where
an item is the basic data type of the source.  This is usually
floats.

\f3\%pfEngine::getNumSrcs\fP returns
the highest source index set plus one.

\f3\%pfEngine::setDst\fP and
\f3\%pfEngine::getDst\fP set and get the
destination of a pfEngine.

\f2data\fP should be either a pfFlux* or a pointer to a block of
memory allocated with \f3\%pfMemory::malloc\fP.
However, if this pfEngine is going to be part of a Performer
scene graph, \f2data\fP can only be a pfFlux*.

\f2ilist\fP is an array of indexes into the destination
and specifies which destination elements are effected
by this engine.  It can, and often will be, set to
NULL in which case this engine effects all elements of
the destination.  For engines to work properly it is
important that the destination \f2ilist\fP be a superset of
all source \f2ilists\fP.

Note: \f3\%pfEngine::setDst\fP does not have an
\f2icount\fP because the \f2iterations\fP set with
\f3\%pfEngine::setIterations\fP
specifies the number of indexes that the \f2ilist\fP contains.

\f2offset\fP is the starting offset of the first element
of the destination.  This will often be 0.

\f2stride\fP is how much the pointer should be advanced after
each iteration of the function.  This is often equal
to \f2items\fP from \f3\%pfEngine::setIterations\fP.

Both \f2offset\fP and \f2stride\fP are measured in items, where
an item is the basic data type of the source.  This is usually
floats.

\f3\%pfEngine::srcChanged\fP will mark the
destination pfFlux of a pfEngine as dirty for the current flux frame.

\f3\%pfEngine::setMode\fP and
\f3\%pfEngine::getMode\fP set and get the modes of a
pfEngine.  \f2mode\fP is the mode you are setting and \f2val\fP is the value
you are setting the mode to.  The modes are:
.PP
.TS
center tab($);
C | C
LB | LB .
\f2mode\fP$default
_
PFENG_RANGE_CHECK$PF_OFF
PFENG_MATRIX_MODE$PF_OFF
PFENG_TIME_MODE$PFENG_TIME_CYCLE
PFENG_TIME_TRUNC$PF_OFF
.TE
.PP
\f3\%PFENG_RANGE_CHECK\fP controls whether a range check is done when
\f3\%pfEngine::evaluate(mask, eyePos)\fP is called.
Setting it to \f3\%PF_ON\fP will cause the range check to be done.

\f3\%PFENG_MATRIX_MODE\fP is only applicable to the \f3\%PFENG_MATRIX\fP and
\f3\%PFENG_ANIMATE\fP functions and is describes with those functions.

\f3\%PFENG_TIME_MODE\fP and \f3\%PFENG_TIME_TRUNC\fP are only applicable to
the \f3\%PFENG_TIME\fP function and are described with that functions.

\f3\%pfEngine::setMask\fP and
\f3\%pfEngine::getMask\fP set and get the evaluation
mask of a pfEngine.  The default mask is \f3\%PFFLUX_BASIC_MASK\fP.

\f3\%pfEngine::setEvaluationRange\fP and
\f3\%pfEngine::getEvaluationRange\fP
set and get the evaluation range of a pfEngine.

\f3\%pfEngine::evaluate(mask)\fP and
\f3\%pfEngine::evaluate(mask, eyePos)\fP trigger
an evaluation of a pfEngine if any of the bits in \f2mask\fP match any of
the bits in the evaluation mask of the pfEngine.  The evaluation will
also be conditional on \f2eyePos\fP being within the evaluation range, if
the pfEngine has its \f3\%PFENG_RANGE_CHECK\fP mode set to \f3\%PF_ON\fP and
\f3\%pfEngine::evaluate(mask, eyePos)\fP is used.

\f3\%pfEngine::setUserFunction\fP and
\f3\%pfEngine::getUserFunction\fP set
and get the user function of a pfEngine.  This only has effect if the
function of the pfEngine is \f3\%PFENG_USER_FUNCTION\fP.  The user
function \f2func\fP, must be of type \f3\%pfEngineFuncType\fP.  The user
function of a pfEngine will be called when ever the pfEngine is
evaluated.  The user function will only be called if the pfEngine
has passed its evaluation criteria.  The user function should not
call \f3\%pfFlux::writeComplete\fP on its
destination pfFlux, as that will be done by
\f3\%pfEngine::evaluate\fP.

.SH FUNCTIONS

\f3\%PFENG_SUM\fP

This function will add arrays of floats together to form a destination
array of floats.  This function is very general and can be used in many
situations.  One use for it is in aligning objects such as buildings to
a pfASD.  Since \f3\%PFENG_SUM\fP can have as few as one source it can be
used to simply copy data from one location to another.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_SUM_SRC(n)\fP$float[]$yes$yes$yes
Destination$float[]$yes$yes$yes
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
yes$yes
.TE
.PP
\f3\%PFENG_MORPH\fP

This function sets the destination to a weighted sum of its sources.
You can use either the \f3\%PFENG_MORPH_FRAME\fP or the \f3\%PFENG_MORPH_WEIGHTS\fP
source to drive this function.

\f3\%PFENG_MORPH_WEIGHTS\fP contains a float for each of the
\f3\%PFENG_MORPH_SRC(n)\fP sources.  Element zero of \f3\%PFENG_MORPH_WEIGHTS\fP
gets multiplied against \f3\%PFENG_MORPH_SRC(0)\fP, element one gets
multiplied against \f3\%PFENG_MORPH_SRC(1)\fP, and so on.

\f3\%PFENG_MORPH_FRAME\fP contains a single float.  This float
specifies the weighting between two of the \f3\%PFENG_MORPH_SRC(n)\fP sources.
The integer portion specifies the sources and the fractional portion the
weighting between those sources.  For example, a \f3\%PFENG_MORPH_FRAME\fP of
3.8 would mean \f3\%PFENG_MORPH_SRC(3)\fP * 0.2 + \f3\%PFENG_MORPH_SRC(4)\fP * 0.8.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_MORPH_FRAME\fP$float[1]$no$no$no
\f3\%PFENG_MORPH_WEIGHTS\fP$float[n]$no$no$no
\f3\%PFENG_MORPH_SRC(n)\fP$float[]$yes$yes$yes
Destination$float[]$yes$yes$yes
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
yes$yes
.TE
.PP
\f3\%PFENG_BLEND\fP

This function is sort of a light version of the \f3\%PFENG_MORPH\fP function.
It sets the destination to a weighted sum of elements in the
\f3\%PFENG_BLEND_SRC\fP source.
You can use either the \f3\%PFENG_BLEND_FRAME\fP or the \f3\%PFENG_BLEND_WEIGHTS\fP
source to drive this function.

\f3\%PFENG_BLEND_SRC\fP should contain \f2iterations\fP elements.
An element is a set of \f2items\fP floats.  The \f2stride\fP of the
\f3\%PFENG_BLEND_SRC\fP source should generally be equal to \f2items\fP.

\f3\%PFENG_BLEND_WEIGHTS\fP contains a float for each of the elements in the
\f3\%PFENG_BLEND_SRC\fP source.  \f3\%PFENG_BLEND_WEIGHTS\fP[0]
gets multiplied against the \f2items\fP stating at
\f3\%PFENG_BLEND_SRC\fP[0*\f2stride\fP], \f3\%PFENG_BLEND_WEIGHTS\fP[1]
gets multiplied against the \f2items\fP stating at
\f3\%PFENG_BLEND_SRC\fP[1*\f2stride\fP], and so on.

\f3\%PFENG_BLEND_FRAME\fP contains a single float.  This float
specifies the weighting between two of the elements in the
\f3\%PFENG_BLEND_SRC\fP source.
The integer portion specifies the elements and the fractional portion the
weighting between those elements.  For example, a \f3\%PFENG_BLEND_FRAME\fP of
3.8 would mean
the \f2items\fP stating at \f3\%PFENG_BLEND_SRC\fP[3*\f2stride\fP] * 0.2 +
the \f2items\fP stating at \f3\%PFENG_BLEND_SRC\fP[4*\f2stride\fP] * 0.8.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_BLEND_FRAME\fP$float[1]$no$no$no
\f3\%PFENG_BLEND_WEIGHTS\fP$float[n]$no$no$no
\f3\%PFENG_BLEND_SRC\fP$float[]$no$yes$yes
Destination$float[]$no$yes$yes
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
special$yes
.TE
.PP
\f3\%PFENG_TRANSFORM\fP

This function transforms the \f3\%PFENG_TRANSFORM_SRC\fP array of floats by
the matrix contained in the \f3\%PFENG_TRANSFORM_MATRIX\fP source.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_TRANSFORM_SRC\fP$float[]$yes$yes$yes
\f3\%PFENG_TRANSFORM_MATRIX\fP$pfMatrix$no$no$no
Destination$float[]$yes$yes$yes
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
yes$yes
.TE
.PP
\f3\%PFENG_ALIGN\fP

This function generates an alignment matrix based on the sources.
\f3\%PFENG_ALIGN_POSITION\fP is used to determine the translational
portion of the matrix.  If \f3\%PFENG_ALIGN_POSITION\fP is NULL then the
translational portion of the matrix will be set to all zeros.
\f3\%PFENG_ALIGN_NORMAL\fP and \f3\%PFENG_ALIGN_AZIMUTH\fP are used to
determine the rotation portion of the matrix.  If either are NULL then the
rotation portion of the matrix will be set to all zeros.
One use for the \f3\%PFENG_ALIGN\fP function is in aligning moving objects, such
as vehicles, to a pfASD.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_ALIGN_POSITION\fP$float[3]$no$yes$no
\f3\%PFENG_ALIGN_NORMAL\fP$float[3]$no$yes$no
\f3\%PFENG_ALIGN_AZIMUTH\fP$float[3]$no$yes$no
Destination$pfMatrix$no$no$no
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
no$no
.TE
.PP
\f3\%PFENG_MATRIX\fP

This function generates a matrix based on its sources.

\f3\%PFENG_MATRIX_ROT\fP contains a heading pitch and roll rotations,
and does the equivalent of \f3\%pfDCS::setRot\fP.

\f3\%PFENG_MATRIX_TRANS\fP contains a xyz translation and does
the equivalent of \f3\%pfDCS::setTrans\fP.

\f3\%PFENG_MATRIX_SCALE_UNIFORM\fP contains a scale and does
the equivalent of \f3\%pfDCS::setScale\fP

\f3\%PFENG_MATRIX_SCALE_XYZ\fP contains a zyz scale and does
the equivalent of \f3\%pfDCS::setScale(x, y, z)\fP.

\f3\%PFENG_MATRIX_BASE_MATRIX\fP contains a pfMatrix that is either
pre or post multiplied against the matrix generated by the other
sources depending on the \f3\%PFENG_MATRIX_MODE\fP mode.

Any or all of the sources can be NULL, in which case they have no effect
on the resulting matrix.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_MATRIX_ROT\fP$float[3]$no$yes$no
\f3\%PFENG_MATRIX_TRANS\fP$float[3]$no$yes$no
\f3\%PFENG_MATRIX_SCALE_UNIFORM\fP$float[1]$no$yes$no
\f3\%PFENG_MATRIX_SCALE_XYZ\fP$float[3]$no$yes$no
\f3\%PFENG_MATRIX_BASE_MATRIX\fP$pfMatrix$no$no$no
Destination$pfMatrix$no$no$no
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
no$no
.TE
.PP
\f3\%PFENG_ANIMATE\fP

This function will animate a matrix based on its sources.  It is similar
to \f3\%PFENG_MATRIX\fP, but instead of having single values for its rotations
translations and scales, it has arrays of values.  Either the
\f3\%PFENG_ANIMATE_FRAME\fP or the \f3\%PFENG_ANIMATE_WEIGHTS\fP should be
used to control which or what combination of the values are used.

\f2iterations\fP specifies the number of values in the  rotation, translation,
scale sources, and the size of the \f3\%PFENG_ANIMATE_WEIGHTS\fP source.

\f3\%PFENG_ANIMATE_WEIGHTS\fP contains a float for each of the
values in the rotation, translation, and scale sources.  Element zero of
\f3\%PFENG_ANIMATE_WEIGHTS\fP gets multiplied against 0th value, element one
gets multiplied against 1st value, and so on.

\f3\%PFENG_ANIMATE_FRAME\fP contains a single float.  This float
specifies the weighting between two of the values in the rotation, translation,
and scale sources.
The integer portion specifies the values and the fractional portion the
weighting between those values.  For example, a \f3\%PFENG_ANIMATE_FRAME\fP of
3.8 would mean value[3] * 0.2 + value[4] * 0.8.

\f3\%PFENG_ANIMATE_ROT\fP contains an array of heading pitch and roll rotations,
and does the equivalent of \f3\%pfDCS::setRot\fP.

\f3\%PFENG_ANIMATE_TRANS\fP contains an array of xyz translations and does
the equivalent of \f3\%pfDCS::setTrans\fP.

\f3\%PFENG_ANIMATE_SCALE_UNIFORM\fP contains an array of scales and does
the equivalent of \f3\%pfDCS::setScale\fP

\f3\%PFENG_ANIMATE_SCALE_XYZ\fP contains an array of zyz scales and does
the equivalent of \f3\%pfDCS::setScale(x, y, z)\fP.

\f3\%PFENG_ANIMATE_BASE_MATRIX\fP contains a pfMatrix that is either
pre or post multiplied against the matrix generated by the other
sources depending on the \f3\%PFENG_MATRIX_MODE\fP mode.

Any or all of the sources can be NULL, in which case they have no effect
on the resulting matrix.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_ANIMATE_FRAME\fP$float[1]$no$no$no
\f3\%PFENG_ANIMATE_WEIGHTS\fP$float[n]$no$no$no
\f3\%PFENG_ANIMATE_ROT\fP$pfVec3[n]$no$yes$no
\f3\%PFENG_ANIMATE_TRANS\fP$pfVec3[n]$no$yes$no
\f3\%PFENG_ANIMATE_SCALE_UNIFORM\fP$float[n]$no$yes$no
\f3\%PFENG_ANIMATE_SCALE_XYZ\fP$pfVec3[n]$no$yes$no
\f3\%PFENG_ANIMATE_BASE_MATRIX\fP$pfMatrix$no$no$no
Destination$pfMatrix$no$no$no
.TE
.PP
n = \f2iterations\fP
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
special$no
.TE
.PP
\f3\%PFENG_BBOX\fP

This function generates a bounding box that contains the coordinates
in the \f3\%PFENG_BBOX_SRC\fP source.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_BBOX_SRC\fP$pfVec3[]$no$yes$yes
Destination$pfBox$no$no$no
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
yes$3
.TE
.PP
\f3\%PFENG_TIME\fP

This function takes a time in seconds and makes it into a frame number
that is useful in driving the frame source of the
\f3\%PFENG_MORPH\fP, \f3\%PFENG_BLEND\fP and \f3\%PFENG_ANIMATE\fP functions.

\f3\%PFENG_TIME_TIME\fP is the source time in seconds.  This is usually
connected to the pfFlux returned from \f3\%pfGetFrameTimeFlux\fP.

\f3\%PFENG_TIME_SCALE\fP contains 4 floats that are used to modify the
incoming time.
\f3\%PFENG_TIME_SCALE\fP[0] is an initial offset.
\f3\%PFENG_TIME_SCALE\fP[1] is a scale factor.
\f3\%PFENG_TIME_SCALE\fP[2] is a range.
\f3\%PFENG_TIME_SCALE\fP[3] is a final offset.

The \f3\%PFENG_TIME_MODE\fP mode determines how the destination number moves
between its start and end point.
\f3\%PFENG_TIME_CYCLE\fP will cause it to go from start to end then restart
at begin.
\f3\%PFENG_TIME_SWING\fP will cause it to go back and forth between start to end.
This mode is related to the interval mode of a pfSequence.

If the \f3\%PFENG_TIME_TRUNC\fP mode is set to \f3\%PF_ON\fP the result is
truncated.

The following pseudo code defines how the destination is calculated.

.Ex
.nf

dst is the destination
t is \f3\%PFENG_TIME_TIME\fP
s is \f3\%PFENG_TIME_SCALE\fP

if (\f3\%PFENG_TIME_MODE\fP == \f3\%PFENG_TIME_CYCLE\fP)
    dst = fmodf((t + s[0]) * s[1], s[2]) + s[3];
else /* \f3\%PFENG_TIME_MODE\fP == \f3\%PFENG_TIME_SWING\fP */
{
    tmp = fmodf((t + s[0]) * s[1], s[2] * 2.0f);
    if (tmp >= s[2])
	dst = ((s[2] * 2.0f) - tmp) + s[3];
    else
	dst = tmp + s[3];
}

if (\f3\%PFENG_TIME_TRUNC\fP == \f3\%PF_ON\fP)
    dst = (int)dst;
.Ee
.fi
.na

.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_TIME_TIME\fP$float[1]$no$no$no
\f3\%PFENG_TIME_SCALE\fP$float[4]$no$no$no
Destination$float[1]$no$no$no
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
no$no
.TE
.PP
\f3\%PFENG_STROBE\fP

This function switches \f2iterations\fP sets of \f2items\fP floats
between an on and off state based on the time.  One use of the
\f3\%PFENG_STROBE\fP function is light point animations.

\f3\%PFENG_STROBE_TIME\fP is the source time in seconds.  This is usually
connected to the pfFlux returned from \f3\%pfGetFrameTimeFlux\fP.

\f3\%PFENG_STROBE_TIMING\fP contains \f2iterations\fP sets of 3 floats that
are used to determine whether the destination for an iteration should
be set to the on or off time
whether
incoming time.
\f3\%PFENG_STROBE_TIMING\fP[n*\f2stride\fP + 0] is the on duration.
\f3\%PFENG_STROBE_TIMING\fP[n*\f2stride\fP + 1] is the off duration.
\f3\%PFENG_STROBE_TIMING\fP[n*\f2stride\fP + 2] is an offset.

\f3\%PFENG_STROBE_ON\fP contains \f2iterations\fP sets of \f2items\fP floats.

\f3\%PFENG_STROBE_OFF\fP contains \f2iterations\fP sets of \f2items\fP floats.
If \f3\%PFENG_STROBE_OFF\fP is \f3\%NULL\fP, all off states are 0.0.

The following pseudo code defines how the destination is calculated
for a set of \f2items\fP floats.

.Ex
.nf

dst is the destination
t is \f3\%PFENG_STROBE_TIME\fP
timing is \f3\%PFENG_STROBE_TIMING\fP
on is \f3\%PFENG_STROBE_ON\fP
off is \f3\%PFENG_STROBE_OFF\fP

if (timing[0] > fmodf(t + timing[2], timing[0] + timing[1]))
    for (i = 0; i < \f2items\fP; i++)
	dst[i] = on[i];
    else
	dst[i] = off[i];
.Ee
.fi
.na

.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_STROBE_TIME\fP$float[1]$no$no$no
\f3\%PFENG_STROBE_TIMING\fP$float[n*3]$no$yes$yes
\f3\%PFENG_STROBE_ON\fP$float[]$no$yes$yes
\f3\%PFENG_STROBE_OFF\fP$float[]$no$yes$yes
Destination$float[]$no$yes$yes
.TE
.PP
n = \f2iterations\fP
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
no$no
.TE
.PP
\f3\%PFENG_USER_FUNCTION\fP

The function executes the function set using
\f3\%pfEngine::setUserFunction\fP.
.PP
.TS
center tab($) ;
c | c | c | c | c
c | c | c | c | c
l | c | c | c | c .
Source \f2index\fP$Data$\f2ilist\fP$\f2offset\fP$\f2stride\fP
or Destination$Type$Applicable$Applicable$Applicable
_
\f3\%PFENG_USER_FUNCTION_SRC(n)\fP$*$*$*$*
Destination$*$*$*$*
.TE
.PP
.TS
center tab($) ;
c | c .
\f2iterations\fP$\f2items\fP
_
*$*
.TE
.PP
.SH SEE ALSO
pfFlux,
pfGetFrameTimeFlux,
pfFCS,
pfASD
