'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFluxMemory" "3pf"
.SH NAME
.upperok
.B pfFluxMemory
\- 
Manage a pfFluxMemory
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfFluxMemory*\ \ \ 'u
#include <Performer/pr/pfFlux.h>
.nf
.fi
.TP
static pfType*
\f3\%pfFluxMemory::getClassType\fP(void);
.nf
.fi
.TP
pfFlux*
\f3\%pfFluxMemory::getFlux\fP(pfFluxMemory*\ fmem);
.nf
.fi
.TP
static pfFluxMemory*
\f3\%pfFluxMemory::getFluxMemory\fP(void*\ data);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFluxMemory\fP is
derived from the parent class \f3\%pfMemory\fP,
so each of these member functions of
class \f3\%pfMemory\fP
are also directly usable with objects
of class \f3\%pfFluxMemory\fP.
This is also true for
ancestor classes
of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A \f3\%pfFluxMemory\fP is a data buffer of a pfFlux.  It has a header
and them a data portion.  A pfFluxMemory should never be created or
destroyed separate from its parent pfFlux.

\f3\%pfFluxMemory::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFluxMemory\fP.  The \f3\%pfType\fP* returned
by \f3\%pfFluxMemory::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfFluxMemory\fP.

\f3\%pfFluxMemory::getFlux\fP returns a pointer
to the parent pfFlux of a pfFluxMemory.

\f3\%pfFluxMemory::getFluxMemory\fP returns a pointer
to the pfFluxMemory that \f2data\fP points to the data portion of.

The data portion of a pfFluxMemory can be converted into a fluxed form
of any Performer object that is derived from pfMemory.  This should only
be done in the initFunc of a pfFlux.  Although any Performer object can
be fluxed, only certain Performer objects have been modified to accept
fluxed forms of the objects they connect to.  The following table lists
what can take what.
.PP
.TS
center tab($) ;
c | c
lB | lB .
parent object$fluxed child
_
pfGeode$pfGeoSet
.TE
.PP

Example of turning the data portion of a pfFluxMemory into a fluxed pfGeoSet.
This is how pfFluxedGSetInit() is implemented.  Note:  This can only be
done in C++.

.Ex
.nf


int pfFluxedGSetInit(pfFluxMemory *fmem)
{
    if (fmem == NULL)
        return sizeof(pfGeoSet);

    new(fmem) pfGeoSet;

    return 0;
}

.Ee
.fi
.na


Example of creating a pfFlux containing fluxed pfGeoSets:

.Ex
.nf


int make_fluxed_gset(pfFluxMemory *fmem)
{
    pfGeoSet *gset;
    pfVec3 *coords;

    if (fmem == NULL)
        return pfFluxedGSetInit(fmem);

    pfFluxedGSetInit(fmem);

    gset = (pfGeoSet*)fmem->getData();

    gset->setPrimType(PFGS_TRIS);

    ... finish initializing pfGeoSet

    return 0;
}

main()
{
    pfFlux *fluxed_gset;
    pfGeoSet *gset;

    pfInit();
    pfConfig();

    fluxed_gset = new pfFlux(make_fluxed_gset,
                             PFFLUX_DEFAULT_NUM_BUFFERS);
    gset = (pfGeoSet*)fluxed_gset->getCurData();

    ...
}

.Ee
.fi
.na


.SH SEE ALSO
pfFlux,
pfMemory,
pfFluxedGSetInit
