'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFont" "3pf"
.SH NAME
.upperok
.B pfFont
\- 
Routines to load fonts for use in Performer.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType*\ \ \ 'u
#include <Performer/pr/pfString.h>
.nf
.fi
.TP
\ 
\f3\%pfFont::pfFont\fP()
.nf
.fi
.TP
static pfType*
\f3\%pfFont::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfFont::setCharGSet\fP(int\ ascii,
'in +2
'll -2
pfGeoSet\ *gset);
.in
.ll
.nf
.fi
.TP
pfGeoSet*
\f3\%pfFont::getCharGSet\fP(int\ ascii);
.nf
.fi
.TP
void
\f3\%pfFont::setCharSpacing\fP(int\ ascii,
'in +2
'll -2
pfVec3\ &spacing);
.in
.ll
.nf
.fi
.TP
const pfVec3&
\f3\%pfFont::getCharSpacing\fP(int\ ascii);
.nf
.fi
.TP
void
\f3\%pfFont::setAttr\fP(int\ which,
'in +2
'll -2
void\ *attr);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfFont::getAttr\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfFont::setVal\fP(int\ which,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfFont::getVal\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfFont::setMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFont::getMode\fP(int\ mode);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFont\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfFont\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFont\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

The \f3\%pfFont\fP facility provides the capability to load fonts for
3-D rendering with the string drawing routines from \f3\%pfString\fP
and \f3\%pfText\fP.  The basic methodology is the user provides individual
GeoSets to be used as font characters.  Likewise, the user provides
3-D spacings for each character so that Performer can correctly move
the 'cursor' or '3-D origin' after drawing each character.  Note that
this facility is completely general and is independent of external
font descriptions - see \f3\%pfdLoadFont\fP for a description of loading
some PostScript Type I fonts into a pfFont structure.

\f3\%new\fP(arena) allocates a pfFont from the specified memory arena, or
from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfFont from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like
other pfObjects, pfFonts cannot be created statically, automatically
on the stack or in arrays and should be deleted with \f3\%pfDelete\fP
rather than the delete operator.

\f3\%pfFont::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFont\fP.  The \f3\%pfType\fP* returned
by \f3\%pfFont::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfFont\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

.SS \f3\%pfFont\fP Definition:
Call \f3\%pfFont::setCharGSet\fP to set the pfGeoSet which
Performer should use when drawing the character specified by \f2ascii\fP in a
\f3\%pfString\fP.
\f3\%pfFont::getCharGSet\fP returns the pfGeoSet currently
being used for the character specified by \f2ascii\fP.
Call \f3\%pfFont::setCharSpacing\fP to set the 3D spacing
for the character specified by \f2ascii\fP to be the pfVec3
\f2spacing\fP. This spacing is used to update the cursor position of a \f3\%pfString\fP
after this character has been drawn.
\f3\%pfFont::getCharSpacing\fP returns a reference to
a pfVec3 specifying the spacing of a given character of a font.

.SS \f3\%pfFont\fP Attributes:
\f3\%pfFont::setAttr\fP sets a particular attribute for a
given Performer font, while \f3\%pfFont::getAttr\fP will
return a particular attribute corresponding to the \f2which\fP token.

Current valid pfFont Attributes:
\f3\%PFFONT_GSTATE\fP
\f3\%PFFONT_BBOX\fP
\f3\%PFFONT_SPACING\fP
\f3\%PFFONT_NAME\fP

\f3\%PFFONT_GSTATE\fP specifies a global pfGeoState to be used for every
character of a pfFont. Note that pfGeoStates bound to GeoSets representing
characters will take precedence over the PFFONT_GSTATE pfGeoState.
A Font has NO pfGeoState by default.

\f3\%PFFONT_BBOX\fP specifies a bounding box that will enclose every individual
character of a pfFont.

\f3\%PFFONT_SPACING\fP specifies a global spacing to use to simulate fixed width
fonts.  This spacing is used only if the pfFont mode PFFONT_CHAR_SPACING
is set to PFFONT_CHAR_SPACING_FIXED or a spacing is not available (NULL) for
a given character.
\f3\%PFFONT_NAME\fP simply specifies a name associated with a pfFont.

.SS \f3\%pfFont\fP Modes:
\f3\%pfFont::setMode\fP sets a particular mode for a given
Performer font, while \f3\%pfFont::getAttr\fP will return
the current value of the mode corresponding to the \f2mode\fP token.

Current valid \f3\%pfFont\fP Modes:
\f3\%PFFONT_CHAR_SPACING\fP
\f3\%PFFONT_NUM_CHARS\fP

\f3\%PFFONT_CHAR_SPACING\fP specifies whether to use fixed or variable spacings for
all characters of a pfFont.  Possible values are \f3\%PFFONT_CHAR_SPACING_FIXED\fP
and \f3\%PFFONT_CHAR_SPACING_VARIABLE\fP - the later being the default.

.SS \f3\%pfFont\fP Values:
\f3\%pfFont::setVal\fP sets a particular value for a given
Performer font, while \f3\%pfFont::getVal\fP will return
the corresponding value associated with  the \f2which\fP token.
.SH NOTES

See \f3\%pfText\fP for sample code demonstrating \f3\%pfFont\fP.
.SH SEE ALSO
pfBox,
pfDelete,
pfGeoSet,
pfGeoState,
pfString,
pfText,
pfdLoadFont
