'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFrustum" "3pf"
.SH NAME
.upperok
.B pfFrustum
\- 
Operations on frusta
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfGeoMath.h>
.nf
.fi
.TP
\ 
\f3\%pfFrustum::pfFrustum\fP()
.nf
.fi
.TP
static pfType *
\f3\%pfFrustum::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfFrustum::makePersp\fP(float\ left,
'in +2
'll -2
float\ right,
float\ bottom,
float\ top);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustum::makeOrtho\fP(float\ left,
'in +2
'll -2
float\ right,
float\ bottom,
float\ top);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustum::makeSimple\fP(float\ fov);
.nf
.fi
.TP
int
\f3\%pfFrustum::getFrustType\fP(void);
.nf
.fi
.TP
void
\f3\%pfFrustum::getFOV\fP(float*\ fovh,
'in +2
'll -2
float*\ fovv);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustum::setAspect\fP(int\ which,
'in +2
'll -2
float\ widthHeightRatio);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfFrustum::getAspect\fP(void);
.nf
.fi
.TP
void
\f3\%pfFrustum::setNearFar\fP(float\ near,
'in +2
'll -2
float\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustum::getNearFar\fP(float*\ near,
'in +2
'll -2
float*\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustum::getNear\fP(pfVec3\ &ll,
'in +2
'll -2
pfVec3\ &lr,
pfVec3\ &ul,
pfVec3\ &ur);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustum::getFar\fP(pfVec3\ &ll,
'in +2
'll -2
pfVec3\ &lr,
pfVec3\ &ul,
pfVec3\ &ur);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFrustum::getEye\fP(pfVec3\ &eye);
.nf
.fi
.TP
void
\f3\%pfFrustum::getPtope\fP(pfPolytope\ *ptope);
.nf
.fi
.TP
void
\f3\%pfFrustum::getGLProjMat\fP(pfMatrix\ &mat);
.nf
.fi
.TP
void
\f3\%pfFrustum::apply\fP(void);
.nf
.fi
.TP
int
\f3\%pfFrustum::contains\fP(const\ pfVec3\ &pt);
.nf
.fi
.TP
int
\f3\%pfFrustum::contains\fP(const\ pfBox\ *box);
.nf
.fi
.TP
int
\f3\%pfFrustum::contains\fP(const\ pfSphere\ *sph);
.nf
.fi
.TP
int
\f3\%pfFrustum::contains\fP(const\ pfCylinder\ *cyl);
.nf
.fi
.TP
void
\f3\%pfFrustum::orthoXform\fP(const\ pfFrustum*\ src,
'in +2
'll -2
const\ pfMatrix\ &mat);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFrustum\fP is
derived from the parent class \f3\%pfPolytope\fP,
so each of these member functions of
class \f3\%pfPolytope\fP
are also directly usable with objects
of class \f3\%pfFrustum\fP.
This is also true for
ancestor classes
of class \f3\%pfPolytope\fP.

.PD 0
.TP \w'pfType*\ \ \ 'u
pfType*
\f3\%pfPolytope::getClassType\fP(void);
.PD 0
.TP
int
\f3\%pfPolytope::getNumFacets\fP(void);
.PD 0
.TP
int
\f3\%pfPolytope::setFacet\fP(int\ i,
'in +2
'll -2
const\ pfPlane\ *facet);
.in
.ll
.PD 0
.TP
int
\f3\%pfPolytope::getFacet\fP(int\ i,
'in +2
'll -2
pfPlane\ *facet);
.in
.ll
.PD 0
.TP
int
\f3\%pfPolytope::removeFacet\fP(int\ i);
.PD 0
.TP
void
\f3\%pfPolytope::orthoXform\fP(const\ pfPolytope\ *src,
'in +2
'll -2
const\ pfMatrix\ \ &mat);
.in
.ll
.PD 0
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfVec3\ \ &pt);
.PD 0
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfSphere\ *sphere);
.PD 0
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfBox\ *box);
.PD 0
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfCylinder\ *cyl);
.PD 0
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfPolytope\ *ptope1);

.PD
.PP
Since the class
\f3\%pfPolytope\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfFrustum\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFrustum\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfFrustum represents a viewing and or culling volume bounded by left,
right, top, bottom, near and far planes.

\f3\%new\fP(arena) allocates a pfFrustum from the specified memory arena,
or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfFrustum from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfFrusta cannot be created statically,
automatically on the stack or in arrays and should be deleted with
\f3\%pfDelete\fP rather than the delete operator.

A new pfFrustum defaults to a simple perspective frustum (see
\f3\%::makeSimple\fP) with FOV = 45 degrees, and
near and far distances of 1 and 1000.

\f3\%pfFrustum::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFrustum\fP.  The \f3\%pfType\fP* returned
by \f3\%pfFrustum::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfFrustum\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfFrustum::makePersp\fP configures the pfFrustum as a perspective frustum with
the eye at (0,0,0) and the points (\f2left\fP, \f2near\fP, \f2bottom\fP) and
(\f2right\fP, \f2near\fP, \f2top\fP) being the lower-left and upper-right
corners of the viewing plane.  The coordinate system used is:
left -> right = +X axis, near -> far = +Y axis, bottom -> top = +Z axis.
The far plane lies at Y = far. Note that the field of view of a
frustum configured with \f3\%pfFrustum::makePersp\fP is dependent on the current
near plane distance. However, subsequent changes to the near plane distance
with \f3\%pfFrustum::setNearFar\fP do not affect the field of view, simplifying
clip plane modification.

\f3\%pfFrustum::makePersp\fP is similar to the
IRIS GL \f3\%window(3g)\fP command and can generate off-axis projections
that are often used for stereo and "video-wall" displays.  With an
off-axis frustum, the line from the eyepoint passing through
the center of the image is not perpendicular to the projection plane.

Example 1:
.Ex
.nf

/*
 * Make two off-axis projections which together provide
 * horizontal and vertical FOVs of 90 and 45 degrees.
 */
t = pfTan(22.5f);

left->setNearFar( 1.0f, 1000.0f);
left->makePersp(-1.0f, 0.0f, -t, t);

right->setNearFar(1.0f, 1000.0f);
right->makePersp(0.0f, 1.0f, -t, t);
.Ee
.fi
.na

\f3\%pfFrustum::makeOrtho\fP configures the pfFrustum as an orthogonal frustum.  The 6
sides of the frustum are: x = left, x = right, z = bottom, z = top, y =
near, y = far.  \f3\%pfFrustum::makeOrtho\fP is similar to the IRIS GL
\f3\%ortho2(3g)\fP command.  The near and far distances of an orthogonal
frustum are set by \f3\%pfFrustum::setNearFar\fP.

\f3\%pfFrustum::makeSimple\fP configures the pfFrustum as an on-axis perspective
frustum with horizontal and vertical fields-of-view of \f2fov\fP
degrees.  With an on-axis frustum, the line connecting the center of
projection with the eyepoint is perpendicular to the projection plane.
\f3\%pfFrustum::makeSimple\fP is similar to the IRIS GL \f3\%perspective(3g)\fP
command.  The near and far distances of a simple frustum are set by
\f3\%pfFrustum::setNearFar\fP. For viewports with non-square aspect ratios,
\f3\%pfFrustum::setAspect\fP may be used to automatically fit either the horizontal
or vertical fields of view to the viewport (see below).

\f3\%pfFrustum::getFrustType\fP returns a symbolic token indicating the frustum type
of the pfFrustum and is one of: \f3\%PFFRUST_SIMPLE\fP, \f3\%PFFRUST_ORTHOGONAL\fP, or
\f3\%PFFRUST_PERSPECTIVE\fP.  The frustum type is set by the
\f3\%pfFrustum::make<*>\fP routines.  Note that it is possible to make a simple
frustum with \f3\%pfFrustum::makePersp\fP if \f2left\fP == -\f2right\fP and
\f2bottom\fP == -\f2top\fP.

\f3\%pfFrustum::setNearFar\fP sets the near and far distances of the pfFrustum.  It will
also recalculate the frustum's geometry based on the frustum type.
If \f2frust\fP is perspective, its field of view will not be changed, only
the near and far planes will be modified.
\f3\%pfFrustum::getNearFar\fP copies the near and far distances of the pfFrustum into
\f2near\fP and \f2far\fP.

\f3\%pfFrustum::setAspect\fP adjusts the horizontal or vertical extent of the pfFrustum
to fit the aspect ratio specified by \f2widthHeightRatio\fP.  \f2which\fP
is a symbolic token specifying how to modify \f2frust\fP and is one of:
.RS
.TP 30
\f3\%PFFRUST_CALC_NONE\fP
Disable aspect ratio calculation
.TP
\f3\%PFFRUST_CALC_HORIZ\fP
Modify horizontal extent of frustum to match the aspect ratio
.TP
\f3\%PFFRUST_CALC_VERT\fP
Modify vertical extent of frustum to match the aspect ratio
.RE

\f3\%pfFrustum::setAspect\fP is useful for matching a frustum to a viewport:

Example 2:
.Ex
.nf

getviewport(&l, &r, &b, &t);
aspect = (float)(r - l) / (float)(t - b);

/*
 * Fit vertical frustum extent to viewport so that horizontal
 * FOV is 45 degrees and vertical is based on 'aspect'.
 */
frust->makeSimple(45.0f);
frust->setAspect(PFFRUST_CALC_VERT, aspect);
.Ee
.fi
.na


Frustum aspect ratio matching is not persistent. You must call
\f3\%pfFrustum::setAspect\fP each time the frustum changes shape in order to
maintain matched frustum/viewport.

\f3\%pfFrustum::getAspect\fP returns the aspect ratio of the pfFrustum.

\f3\%pfFrustum::getFOV\fP copies the total horizontal and vertical fields of
view into \f2fovh\fP and \f2fovv\fP respectively.  The fields of view for an
orthogonal frustum are both 0.0.

\f3\%pfFrustum::getNear\fP returns the four corners of the near (viewing or
projection) plane putting
the lower-left, lower-right, upper-left and upper-right vertices into
\f2ll\fP, \f2lr\fP, \f2ul\fP, and \f2ur\fP, respectively.

\f3\%pfFrustum::getFar\fP returns the four corners of the far plane putting
the lower-left, lower-right, upper-left and upper-right vertices into
\f2ll\fP, \f2lr\fP, \f2ul\fP, and \f2ur\fP, respectively.

\f3\%pfFrustum::getEye\fP copies the eye position of the frustum the pfFrustum into
\f2eye\fP.

\f3\%pfFrustum::getPtope\fP copies the 6 half spaces which define
the pfFrustum into the pfPolytope \f2ptope\fP.

\f3\%pfFrustum::getGLProjMat\fP returns the projection matrix corresponding to
the pfFrustum in the coordinate system of the Graphics Library, ignoring
any transformations applied to \f2frust\fP with \f3\%pfFrustum::orthoXform\fP.

\f3\%pfFrustum::apply\fP configures the hardware projection matrix with the
projection defined by the pfFrustum.  Modifications made to \f2frust\fP do not have
effect until \f3\%pfFrustum::apply\fP is called.

\f3\%pfFrustum::apply\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP,
\f3\%pfFrustum::apply\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDispList::draw\fP.

\f3\%pfFrustum::contains(const pfVec3 pt, ...)\fP
returns \f3\%TRUE\fP or \f3\%FALSE\fP depending on whether the point \f2pt\fP is
in the interior of the specified frustum.

pfFrustum::contains(struct pfBox *),
pfFrustum::contains(struct pfSphere *), and
pfFrustum::contains(struct pfCylinder *)
test whether the specified pfFrustum contains a
non-empty portion of the volume specified by the 
argument, a box, sphere or cylinder, respectively.  The various
member functions \f3\%pfFrustum::contains\fP test whether the pfFrustum
contains a non-empty portion of a box, sphere, or cylinder.

The return value from these functions is the OR of one or more bit
fields.  The returned value may be:
.RS
.TP 5
\f3\%PFIS_FALSE\fP: The intersection of the primitive
and the pfFrustum is empty.
.TP
\f3\%PFIS_MAYBE\fP: The intersection of the primitive and the
pfFrustum might be non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP: The intersection of the primitive and the
pfFrustum is definitely non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP | \f3\%PFIS_ALL_IN\fP: The primitive
is non-empty and lies entirely inside the pfFrustum.
.RE

The primary use of \f3\%pfFrustum::contains\fP within OpenGL
Performer is in culling the database to the view frustum each frame,
where speed is paramount.  If this computation cannot be done easily,
the function returns \f3\%PFIS_MAYBE\fP.

\f3\%pfFrustum::orthoXform\fP transforms the frustum using the matrix \f2mat\fP:
\f2dst\fP = \f2src\fP * \f2mat\fP.  If \f2mat\fP is not orthogonal the results
are undefined.

.SH NOTES

pfFrustum construction orients the frustum with +Z up, +X to the
right, and +Y into the screen which is different than
the OpenGL viewing coordinate systems which has +Y up, +X to the
right and -Z into the screen.
.SH SEE ALSO
pfBox,
pfDelete,
pfDispList,
pfMatrix,
pfObject,
pfPlaneIsectSeg,
pfPolytope,
pfSphere,
pfState,
pfVec3,
ortho,
perspective,
window
