'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGLMatrix" "3pf"
.SH NAME
.upperok
.B pfScale,
.B pfTranslate,
.B pfRotate,
.B pfPushMatrix,
.B pfPushIdentMatrix,
.B pfPopMatrix,
.B pfLoadMatrix,
.B pfMultMatrix
\- 
Operate on graphics library matrix stack
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
void
\f3\%pfScale\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTranslate\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfRotate\fP(int\ axis,
'in +2
'll -2
float\ degrees);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPushMatrix\fP(void);
.nf
.fi
.TP
void
\f3\%pfPushIdentMatrix\fP(void);
.nf
.fi
.TP
void
\f3\%pfPopMatrix\fP(void);
.nf
.fi
.TP
void
\f3\%pfLoadMatrix\fP(pfMatrix\ m);
.nf
.fi
.TP
void
\f3\%pfMultMatrix\fP(pfMatrix\ m);
.fi
.SH DESCRIPTION

These functions are similar to the corresponding OpenGL
graphics library matrix stack commands.  The only difference is that
these OpenGL Performer commands may be applied to and retained in a
\f3\%pfDispList\fP for subsequent activation.

\f3\%pfRotate\fP accepts the values \f3\%PF_X\fP, \f3\%PF_Y\fP, and \f3\%PF_Z\fP to
select the axis of rotation.

\f3\%pfPushIdentMatrix\fP is equivalent to calling \f3\%pfPushMatrix\fP
followed with a call to \f3\%pfLoadMatrix\fP with an identity matrix.

These routines are all display-listable commands.  If a pfDispList has been
opened by \f3\%pfDispList::open\fP, these commands will not have immediate effect
but will be captured by the pfDispList and will only have effect when
that pfDispList is later drawn with \f3\%pfDispList::draw\fP.

.SH SEE ALSO
loadmatrix,
multmatrix,
popmatrix,
pushmatrix,
rot,
scale,
translate
