'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGeoState" "3pf"
.SH NAME
.upperok
.B pfGeoState,
.B pfGetCurGState,
.B pfGetCurGStateTable,
.B pfGetCurIndexedGState
\- 
Create, modify and query geometry state objects
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfGeoState.h>
.nf
.fi
.TP
\ 
\f3\%pfGeoState::pfGeoState\fP()
.nf
.fi
.TP
static pfType *
\f3\%pfGeoState::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfGeoState::apply\fP(void);
.nf
.fi
.TP
void
\f3\%pfGeoState::load\fP(void);
.nf
.fi
.TP
void
\f3\%pfGeoState::setMode\fP(uint64_t\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGeoState::getMode\fP(uint64_t\ mode);
.nf
.fi
.TP
int
\f3\%pfGeoState::getCurMode\fP(uint64_t\ mode);
.nf
.fi
.TP
int
\f3\%pfGeoState::getCombinedMode\fP(uint64_t\ mode,
'in +2
'll -2
const\ pfGeoState\ *combGState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGeoState::setMultiMode\fP(uint64_t\ mode,
'in +2
'll -2
int\ index,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGeoState::getMultiMode\fP(uint64_t\ mode,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGeoState::getCurMultiMode\fP(uint64_t\ mode,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGeoState::getCombinedMultiMode\fP(uint64_t\ mode,
'in +2
'll -2
int\ index,
const\ pfGeoState\ *combGState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGeoState::setVal\fP(uint64_t\ gsval,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGeoState::getVal\fP(uint64_t\ gsval);
.nf
.fi
.TP
float
\f3\%pfGeoState::getCurVal\fP(uint64_t\ gsval);
.nf
.fi
.TP
float
\f3\%pfGeoState::getCombinedVal\fP(uint64_t\ gsval,
'in +2
'll -2
const\ pfGeoState\ *combGState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGeoState::setInherit\fP(uint64_t\ mask);
.nf
.fi
.TP
uint64_t
\f3\%pfGeoState::getInherit\fP(void);
.nf
.fi
.TP
void
\f3\%pfGeoState::setAttr\fP(uint64_t\ attr,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGeoState::getAttr\fP(uint64_t\ attr);
.nf
.fi
.TP
void*
\f3\%pfGeoState::getCurAttr\fP(uint64_t\ attr);
.nf
.fi
.TP
void*
\f3\%pfGeoState::getCombinedAttr\fP(uint64_t\ attr,
'in +2
'll -2
const\ pfGeoState\ *combGState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGeoState::setMultiAttr\fP(uint64_t\ attr,
'in +2
'll -2
int\ index,
void\ *data);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGeoState::getMultiAttr\fP(uint64_t\ attr,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfGeoState::getCurMultiAttr\fP(uint64_t\ attr,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfGeoState::getCombinedMultiAttr\fP(uint64_t\ attr,
'in +2
'll -2
int\ index,
const\ pfGeoState\ *combGState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGeoState::setFuncs\fP(pfGStateFuncType\ preFunc,
'in +2
'll -2
pfGStateFuncType\ postFunc,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGeoState::getFuncs\fP(pfGStateFuncType\ *preFunc,
'in +2
'll -2
pfGStateFuncType\ *postFunc,
void\ **data);
.in
.ll
.nf
.fi
.TP
static void
\f3\%pfGeoState::applyTable\fP(pfList\ *gstab);
.nf
.fi
.TP
void
\f3\%pfGeoState::makeBasic\fP(void);
.nf
.fi
.TP
int
\f3\%pfGeoState::getNumTextures\fP();
.nf
.fi
.TP
pfGeoState *
\f3\%pfGetCurGState\fP(void);
.nf
.fi
.TP
pfList*
\f3\%pfGetCurGStateTable\fP(void);
.nf
.fi
.TP
pfGeoState*
\f3\%pfGetCurIndexedGState\fP(int\ index);
.fi

.Ex
.nf

typedef int (*pfGStateFuncType)(pfGeoState *gstate, void *userData);
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfGeoState\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfGeoState\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfGeoState\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfGeoState is an encapsulation of libpr graphics modes and attributes
(see \f3\%pfState\fP).  For example, a pfGeoState can describe a glass
surface by referencing a shiny pfMaterial and enabling transparency.
When a pfGeoState is applied by
\f3\%pfGeoState::apply\fP it sets up the graphics
state through normal libpr routines such as
\f3\%pfMaterial::apply\fP and \f3\%pfTransparency\fP.

Most pieces of state that may be manipulated through libpr immediate
mode routines may be specified on a per-pfGeoState basis.  For
customized state management, pfGeoStates provide function callbacks.
In addition, pfGeoStates can be indexed through a global table so a
single database can have multiple appearances while avoiding database
duplication.

The primary use of a pfGeoState is to attach it to a pfGeoSet
(\f3\%pfGeoSet::setGState\fP) in order to define the
appearance of the geometry encapsulated by the pfGeoSet.  As discussed
below, pfGeoStates have the useful property of order-independence so
that paired pfGeoSets and pfGeoStates will be rendered consistently
regardless of order.

pfGeoState state may either be locally set or globally inherited.  By
default, if a state element is not specified on a pfGeoState, then that
pfGeoState will inherit that state element from the global state.
Global state is set through libpr immediate mode functions, e.g.,
\f3\%pfMaterial::apply\fP, \f3\%pfTransparency\fP,
\f3\%pfDecal\fP, \f3\%pfFog::apply\fP or through
\f3\%pfGeoState::load\fP as described below. Local
state is set on a pfGeoState through
\f3\%pfGeoState::setMode\fP,
\f3\%pfGeoState::setAttr\fP, or
\f3\%pfGeoState::setVal\fP.

If all state elements are locally set, then a pfGeoState becomes a full
graphics context since all state is defined at the pfGeoState level.
While this is useful, it usually makes sense to inherit most state from
global default values and explicitly set only those state elements
which are expected to change often.  Examples of useful global defaults
are lighting model (\f3\%pfLightModel\fP), lights (\f3\%pfLight\fP), fog
(\f3\%pfFog\fP), and transparency (\f3\%pfTransparency\fP, usually OFF).
Highly variable state is likely to be limited to a small set like
textures and materials.  By default all pfGeoState state is inherited.

State is pushed before, and popped after pfGeoStates are applied so
that pfGeoStates do not inherit state from each other.  As a result
pfGeoStates are order-independent and you need not consider the problem
of one pfGeoState corrupting another by state inheritance through the
underlying graphics library. The actual pfGeoState pop is a lazy
one and does not happen unless a subsequent pfGeoState needs the
default state restored.  This means that the actual state between
pfGeoStates is not necessarily the global state.  If a return to global
state is required, call \f3\%pfFlushState\fP which will restore the global
state.

It is a performance advantage to locally set as little local pfGeoState
state as possible.  This may be accomplished by setting global defaults
which satisfy the majority of pfGeoStates being drawn.  For example, if
most of your database is textured, you should enable texturing at
initialization time (\f3\%pfEnable\fP(\f3\%PFEN_TEXTURE\fP)) and configure your
pfGeoStates to inherit the texture enable mode.

\f3\%new\fP(arena) allocates a pfGeoState from the specified memory arena,
or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfGeoState from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfGeoStates cannot be created statically,
automatically on the stack or in arrays.  pfGeoStates should be
deleted with \f3\%pfDelete\fP rather than the delete operator.
All modes and attributes are inherited by default.

\f3\%pfGeoState::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfGeoState\fP.  The \f3\%pfType\fP* returned by
\f3\%pfGeoState::getClassType\fP is the same
as the \f3\%pfType\fP* returned by invoking the virtual
function \f3\%getType\fP on any instance of class \f3\%pfGeoState\fP.
Because OpenGL Performer allows subclassing of built-in types, when
decisions are made based on the type of an object, it is usually better
to use  the member function \f3\%isOfType\fP to test
if an object is of a type derived from a Performer type rather than to
test for strict equality of the \f3\%pfType\fP*'s.

\f3\%pfGeoState::setMode\fP sets \f2mode\fP to \f2val\fP.  \f2mode\fP is a symbolic
constant specifying the mode to set.  Once set, a mode is no longer
inherited but is set to \f2val\fP.  \f2mode\fP is a symbolic token and is
one of:
.PP
.RS
\f3\%PFSTATE_TRANSPARENCY\fP
.br
\f3\%PFSTATE_ANTIALIAS\fP
.br
\f3\%PFSTATE_DECAL\fP
.br
\f3\%PFSTATE_ALPHAFUNC\fP
.br
\f3\%PFSTATE_ENLIGHTING\fP
.br
\f3\%PFSTATE_ENTEXTURE\fP
.br
\f3\%PFSTATE_ENFOG\fP
.br
\f3\%PFSTATE_CULLFACE\fP
.br
\f3\%PFSTATE_ENWIREFRAME\fP
.br
\f3\%PFSTATE_ENCOLORTABLE\fP
.br
\f3\%PFSTATE_ENHIGHLIGHTING\fP
.br
\f3\%PFSTATE_ENLPOINTSTATE\fP
.br
\f3\%PFSTATE_ENTEXGEN\fP
.br
\f3\%PFSTATE_ENTEXLOD\fP
.br
\f3\%PFSTATE_ENTEXMAT\fP
.RE

\f2val\fP specifies the value of \f2mode\fP and is a symbolic token
appropriate to the type of \f2mode\fP. For example when \f2mode\fP =
\f3\%PFSTATE_TRANSPARENCY\fP then \f2val\fP might be \f3\%PFTR_ON\fP.  Only modes
which differ from the global state should be set.  Mode values are not
inherited between pfGeoStates.  By default all modes are inherited.
See the \f3\%pfState\fP manual page for information on global default
settings.

\f3\%pfGeoState::setVal\fP sets the \f2gsval\fP value to
\f2val\fP.  \f2gsval\fP is a symbolic constant specifying the state value
to set.  Once set, a value is no longer inherited but is set to
\f2val\fP.  \f2gsval\fP is a symbolic token and can be chosen from any of
the following list (only one choice at present):
.RS
\f3\%PFSTATE_ALPHAREF\fP
.RE

\f3\%pfGeoState::setAttr\fP sets \f2attr\fP state element to \f2a\fP.
\f2attr\fP is a symbolic constant starting with \f3\%PFSTATE_\fP specifying an attribute
and is combined with \f2data\fP, a handle
to an attribute structure of the appropriate
\f3\%libpr\fP object relevant to \f3\%attr\fP.
.PP
.RS
.TP 25
\f3\%PFSTATE_FRONTMTL\fP
pfMaterial*
.TP
\f3\%PFSTATE_BACKMTL\fP
pfMaterial*
.TP
\f3\%PFSTATE_TEXTURE\fP
pfTexture*
.TP
\f3\%PFSTATE_TEXENV\fP
pfTexEnv*
.TP
\f3\%PFSTATE_FOG\fP
pfFog*
.TP
\f3\%PFSTATE_LIGHTMODEL\fP
pfLightModel*
.TP
\f3\%PFSTATE_LIGHTS\fP
pfLight**
.TP
\f3\%PFSTATE_COLORTABLE\fP
pfColortable*
.TP
\f3\%PFSTATE_HIGHLIGHT\fP
pfHighlight*
.TP
\f3\%PFSTATE_LPOINTSTATE\fP
pfLPointState*
.TP
\f3\%PFSTATE_TEXGEN\fP
pfTexGen*
.TP
\f3\%PFSTATE_TEXLOD\fP
pfTexLOD*
.TP
\f3\%PFSTATE_TEXMAT\fP
pfMatrix*
.TP
\f3\%PFSTATE_DECALPLANE\fP
pfPlane*
.RE

If \f2attr\fP is \f3\%PFSTATE_LIGHTS\fP, \f2a\fP should be an array of pfLight*
of length \f3\%PF_MAX_LIGHTS\fP which specifies which pfLights should be
used by the pfGeoState.  Empty entries in the light
array should be \f3\%NULL\fP.

A pfGeoState ignores the \f3\%PFMTL_FRONT\fP and \f3\%PFMTL_BACK\fP setting of
a pfMaterial (see \f3\%pfMaterial::setSide\fP).  Instead
it uses the attribute value, \f3\%PFSTATE_FRONTMTL\fP or
\f3\%PFSTATE_BACKMTL\fP to decide how to apply the material.  Consequently,
it is legal to use the same material for both front and back sides.
However, pfGeoStates do not modify the pfMaterial's side value which is
normally set through \f3\%pfMaterial::setSide\fP.

Once set, an attribute is no longer inherited but set to \f2a\fP.  Only
attributes which differ from the global state should be set.  Attributes
are not inherited between pfGeoStates.  By default, all attributes are
inherited from the global state.

\f3\%pfGeoState::setAttr\fP increments the reference
count of the supplied attribute and decrements the reference count of
the replaced attribute, if there is one.
\f3\%pfGeoState::setAttr\fP will \f2not\fP delete any
pfObject whose reference count reaches 0.

\f3\%pfGeoState\fP supports a few multi-valued elements. At present, all
these multi-valued elements are related to the multi-texture OpenGL extension.
The multi-texture extension enables the application of multiple texture maps
on a single polygon in a single drawing pass. This extension uses multiple
texture environments to determine the blending among the texture units.
All \f3\%pfGeoState\fP methods that set/get attributes and modes
have multi-valued versions. The multi-valued versions take one additional
parameter: \f2index\fP. In the case of the multi-texture extension, this variable
picks the hardware texture unit that an attribute or a value refer to.

\f3\%pfGeoState::setMultiAttr\fP is a version of
\f3\%pfGeoState::setAttr\fP used for setting multi-valued
attributes. A multi-values attribute collapses a set of attributes into a
single \f3\%pfGeoState\fP attribute. \f2index\fP picks the texture unit that \f2attr\fP
will be applied to. The following attribute tokens have multiple values:
.PP
.RS
\f3\%PFSTATE_TEXTURE\fP
.br
\f3\%PFSTATE_TEXENV\fP
.br
\f3\%PFSTATE_TEXGEN\fP
.br
\f3\%PFSTATE_TEXLOD\fP
.br
\f3\%PFSTATE_TEXMAT\fP
.RE

Similarly, \f3\%pfGeoState::getMultiAttr\fP,
\f3\%pfGeoState::getCurMultiAttr\fP and
\f3\%pfGeoState::getCombinedMultiAttr\fP
are multi-valued versions of
\f3\%pfGeoState::getAttr\fP,
\f3\%pfGeoState::getCurAttr\fP and
\f3\%pfGeoState::getCombinedAttr\fP. All accept the
above multi-value attribute tokens.

\f3\%pfGeoState::setMultiMode\fP is a multi-value version
of \f3\%pfGeoState::setMode\fP. It sets the \f2index\fP-th
element of \f2mode\fP to \f2val\fP.
It accepts the following multi-value mode tokens:
.PP
.RS
\f3\%PFSTATE_ENTEXTURE\fP
.br
\f3\%PFSTATE_ENTEXGEN\fP
.br
\f3\%PFSTATE_ENTEXLOD\fP
.br
\f3\%PFSTATE_ENTEXMAT\fP
.RE

Similarly, \f3\%pfGeoState::getMultiMode\fP,
\f3\%pfGeoState::getCurMultiMode\fP  and
\f3\%pfGeoState::getCombinedMultiMode\fP
are multi-value versions of
\f3\%pfGeoState::getMode\fP,
\f3\%pfGeoState::getCurMode\fP  and
\f3\%pfGeoState::getCombinedMode\fP.
All accept the above multi-value mode tokens.

When (\f2mode\fP == \f3\%PFSTATE_ENTEXTURE\fP) \f3\%pfGeoState\fP expects a contiguous
sequence of enable values. The first disabled index in this
mode determines how many values \f3\%pfGeoState\fP recognizes. For example,
when calling \f3\%gstate->setMultiMode(PFSTATE_ENTEXTURE, index, 1)\fP for index=[0, 1, 3],
\f3\%pfGeoState\fP will process two texture units and will ignore
the (\f2index\fP == 3) case.
In addition, if the current hardware doesn't support enough multi-texture units,
\f3\%pfGeoState\fP will issue a warning and ignore settings for unavailable hardware
texture units.
\f3\%pfGeoState::getNumTextures\fP returns the number
of texture units that \f3\%pfGeoState\fP will process.

Calling a multi-value method with (\f2index\fP == 0)
is equivalent to calling the single-value version of the
method.

As discussed above, modes, values and attributes may either be locally
set on a pfGeoState or inherited from the global state. To help resolve
the inheritance characteristics of pfGeoStates, 3 different versions
of "get" routines are provided for modes, values and attributes:
.RS
.TP
1.
\f3\%pfGeoState::getMode\fP,
\f3\%pfGeoState::getVal\fP,
\f3\%pfGeoState::getAttr\fP - The exact mode, value,
or attribute of the pfGeoState is returned.
.TP
2.
\f3\%pfGeoState::getCurMode\fP,
\f3\%pfGeoState::getCurVal\fP,
\f3\%pfGeoState::getCurAttr\fP - The exact mode, value,
or attribute of the pfGeoState is returned if not inherited. Otherwise
the mode, value, or attribute of the currently active global pfGeoState
is returned. Note that this requires that a pfState be current
(see \f3\%pfState::select\fP).
.TP
3.
\f3\%pfGeoState::getCombinedMode\fP,
\f3\%pfGeoState::getCombinedVal\fP,
\f3\%pfGeoState::getCombinedAttr\fP -
The exact mode, value,
or attribute of the pfGeoState is returned if not inherited. Otherwise
the mode, value, or attribute of the \f2combGState\fP
is returned.
.RE

\f3\%pfGeoState::getMode\fP returns the mode value
corresponding to \f2mode\fP.

\f3\%pfGeoState::getVal\fP returns the pfGeoState
value corresponding to \f2gsval\fP.

\f3\%pfGeoState::getAttr\fP returns the attribute
handle corresponding to \f2attr\fP. If \f2attr\fP is \f3\%PFSTATE_LIGHTS\fP,
the returned value is the pfLight* array.

\f3\%pfGeoState::setInherit\fP specifies which
state elements should be inherited from the global state.  \f2mask\fP is
a bitwise OR of tokens listed for
\f3\%pfGeoState::setMode\fP,
\f3\%pfGeoState::setAttr\fP, and
\f3\%pfGeoState::setVal\fP.  All of the state elements
specified in \f2mask\fP will become inherited.  All modes and attributes
are inherited unless explicitly specified by setting a mode or
attribute with \f3\%pfGeoState::setAttr\fP,
\f3\%pfGeoState::setMode\fP, or
\f3\%pfGeoState::setVal\fP.
\f3\%pfGeoState::getInherit\fP returns the
bitwise OR of the tokens for state which is currently inherited from
the global state.

\f3\%pfGeoState::apply\fP makes the
pfGeoState the current graphics state.  All modes and attributes of
the pfGeoState that are not inherited are applied
using libpr immediate mode commands, for example, the
\f3\%PFSTATE_TEXTURE\fP attribute is applied with
\f3\%pfTexture::apply\fP.  Inherited modes and
attributes that were modified by previous pfGeoStates are reset to
their global values.  State elements that are overridden (See
\f3\%pfOverride\fP) are not changed by
\f3\%pfGeoState::apply\fP.

Another way to apply a pfGeoState is with
\f3\%pfGeoSet::draw\fP.  If a pfGeoSet has an attached
pfGeoState (see \f3\%pfGeoSet::setGState\fP), then
\f3\%pfGeoSet::draw\fP will call
\f3\%pfGeoState::apply\fP with the attached
pfGeoState so that graphics state is properly established before the
pfGeoSet geometry is rendered.  

The following is an example of pfGeoState behavior.

Example 1:
.Ex
.nf

/* Configure global default that pfGeoStates can inherit */
pfLightModel *lmodel = new pfLightModel;
pfLight *light = new pfLight;
pfEnable(PFEN_LIGHTING);
lmodel->apply;
light->on;
pfTransparency(PFTR_OFF);

/* New pfGeoState inherits everything */
gstate = new pfGeoState;

/* Attach 'gstate' to 'gset' */
gset->setGState(gstate);

/* Configure 'gstate' with a transparent material */
gstate->setAttr(PFSTATE_FRONTMTL, mtl);
gstate->setMode(PFSTATE_TRANSPARENCY, PFTR_ON);
.Ee
.fi
.na


Method A:
.Ex
.nf

/* Draw transparent 'gset' */
gset->draw();
.Ee
.fi
.na


Method B:
.Ex
.nf

/* Remove 'gstate' from 'gset' */
gset->setGState(NULL);

/* Apply 'gstate' */
gstate->apply();

/* Draw transparent 'gset' */
gset->draw();
.Ee
.fi
.na


Method C:
.Ex
.nf

/* Remove 'gstate' from 'gset' */
gset->setGState(NULL);

mtl->apply();
pfTransparency(PFTR_ON);

/* Draw transparent 'gset' */
gset->draw();
.Ee
.fi
.na


In the above example, methods A, B, and C are all produce the same
visual result. Method A is recommended, however, since the pfGeoState
and pfGeoSet pair may be configured at database initialization time
and the use of a pfGeoState provides order-independence when rendering.

The following is an example of pfGeoState inheritance:
.Ex
.nf


pfLightModel *lmodel = new pfLightModel;
pfLight *light = new pfLight;
/* Configure global default that pfGeoStates can inherit */
pfEnable(PFEN_LIGHTING);

lmodel->apply();
light->on();

/* Assume 'redMtl' is PFMTL_FRONT */
redMtl->apply();

/* New pfGeoStates inherit everything */
gstateA = new pfGeoState;
gstateB = new pfGeoState;

/* Attach pfGeoStates to pfGeoSets */
gsetA->setGState(gstateA);
gsetB->setGState(gstateB);

/* Configure 'gstateA' with a green material */
gstateA->setAttr(PFSTATE_FRONTMTL, greenMtl);

/* Draw green 'gset' */
gsetA->draw();

/*
 * The FRONTMTL property of gstateB is not set so it inherits
 * the global default of 'redMtl' which will be restored
 * as the current pfMaterial when gstateB is applied.
 */

/* Draw red 'gset' */
gsetB->draw();

/*
 * Note that gsetA and gsetB could be drawn in the opposite
 * order with the same results.  This is a very important
 * pfGeoState property.
 */
.Ee
.fi
.na


\f3\%pfGetCurGState\fP returns the current pfGeoState that was previously
applied directly by \f3\%pfGeoState::apply\fP or
indirectly by \f3\%pfGeoSet::draw\fP.

\f3\%pfGeoState::setFuncs\fP sets the callbacks and
callback data pointer of the pfGeoState. The
reference count of \f2data\fP is incremented and the reference count of
the previous data is decremented but no deletion takes place if the
reference count reaches 0. Callbacks are invoked by
\f3\%pfGeoState::apply\fP (or indirectly by
\f3\%pfGeoSet::draw\fP as described above) in the
following order:

.Ex
.nf

\f2postFunc\fP() of previously-applied pfGeoState
setup state according to current pfGeoState
\f2preFunc\fP() of current pfGeoState
.Ee
.fi
.na


Notice that the post-callback invocation is delayed until a subsequent
pfGeoState is applied. However, \f3\%pfPushState\fP, \f3\%pfPopState\fP, and
\f3\%pfFlushState\fP will invoke any "leftover" post-callback.  It is legal
to call \f3\%pfPushState\fP and \f3\%pfPopState\fP in the pre and post
callbacks respectively but is not usually necessary because any
\f3\%libpr\fP state set inside pfGeoState callbacks is considered to have
been set by the pfGeoState. Consequently, the global state is not
modified and the normal pfGeoState inheritance rules apply to state set
inside the callbacks.

Callbacks are passed a pointer to the parent pfGeoState and the
\f2data\fP pointer that was previously supplied by
\f3\%pfGeoState::setFuncs\fP.  The return value from
pfGeoState callbacks is currently ignored.
\f3\%pfGeoState::getFuncs\fP gets back the pre and
post pfGeoState callbacks and callback data for the
pfGeoState in \f2preFunc\fP, \f2postFunc\fP, and \f2data\fP,
respectively.

A pfGeoSet may either directly reference or indirectly index a
pfGeoState with \f3\%pfGeoSet::setGState\fP and
\f3\%pfGeoSet::setGStateIndex\fP respectively.
Indexed pfGeoStates use a global table of pfGeoState pointers that is
set by \f3\%pfGeoState::applyTable\fP. If the
global table is \f3\%NULL\fP or the pfGeoState index is out of the range of
the global table, no pfGeoState is applied, otherwise the indexed
pfGeoState is applied when \f3\%pfGeoSet::draw\fP is
called. Non-indexed pfGeoState references ignore the current pfGeoState
table. \f3\%pfGetCurGStateTable\fP returns the current pfGeoState table and
\f3\%pfGetCurIndexedGState\fP returns the \f2index\fPth pfGeoState* in the
current pfGeoState table or \f3\%NULL\fP if the index cannot be properly
resolved.

\f3\%pfGeoState::load\fP is similar to
\f3\%pfGeoState::apply\fP except the modes and
attributes of the pfGeoState can be inherited by
subsequent pfGeoStates.  In other words, the
pfGeoState loads the global state.  Overridden state elements are
not modified by \f3\%pfGeoState::load\fP. If set, the
pre-callback of the pfGeoState is invoked after the
graphics state is loaded. As described above, the post-callback is not
invoked until a subsequent pfGeoState is applied or \f3\%pfPushState\fP,
\f3\%pfPopState\fP, or \f3\%pfFlushState\fP is called.

\f3\%pfGeoState::apply\fP,
\f3\%pfGeoState::applyTable\fP, and
\f3\%pfGeoState::load\fP are display-listable
commands.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP, these commands will not have
immediate effect but will be captured by the pfDispList and will only
have effect when that pfDispList is later executed with
\f3\%pfDispList::draw\fP.  Indexed pfGeoStates are
resolved at display list creation time, not at display list execution
time. In addition, pfGeoStates are "unwound" into their constituent
parts at display list creation time, e.g., a pfGeoState may decompose
into \f3\%pfMaterial::apply\fP and \f3\%pfTransparency\fP
calls. As a result, changes to a pfGeoState which have been captured by
a pfDispList will *not* be evident when that pfDispList is executed
(\f3\%pfDispList::draw\fP). pfGeoState indexing and
unwinding at display list creation time is done strictly to improve
pfDispList rendering performance.

\f3\%pfGeoState::makeBasic\fP configures every
state element (value, mode, and attribute) of the
pfGeoState to be identical to the state set with \f3\%pfBasicState\fP.
The "basic" state is the initial state of a graphics library window -
everything is "off". For example, the PFSTATE_ENLIGHTING mode will be
set to PF_OFF, and the PFSTATE_CULLFACE mode will be set to PFCF_OFF.
The following code fragment is equivalent to \f3\%pfBasicState\fP:

.Ex
.nf

pfGeoState *gstate = new(NULL) pfGeoState();
gstate->makeBasic();
gstate->load();
.Ee
.fi
.na


.SH NOTES

In some situations it may appear that pfGeoStates do inherit from each
other.  This is because OpenGL Performer currently does not provide any
defaults for the state attributes listed above such as \f3\%PFSTATE_TEXTURE\fP
and \f3\%PFSTATE_FRONTMTL\fP.  Consequently, if the application does not
explicitly set these attributes, it is possible for pfGeoStates which
inherit these attributes to inherit them from previous pfGeoStates.
.SH SEE ALSO
pfAlphaFunc,
pfAntialias,
pfBasicState,
pfCullFace,
pfDecal,
pfDelete,
pfDispList,
pfDrawGSet,
pfEnable,
pfFog,
pfGeoSet,
pfLight,
pfList,
pfLPointState,
pfOverride,
pfState,
pfTexture,
pfTexGen,
pfTransparency
