'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGroup" "3pf"
.SH NAME
.upperok
.B pfGroup
\- 
Create, modify, and query a group node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfGroup.h>
.nf
.fi
.TP
\ 
\f3\%pfGroup::pfGroup\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfGroup::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.nf
.fi
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.nf
.fi
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.nf
.fi
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.nf
.fi
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.nf
.fi
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfGroup\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfGroup\fP.
This is also true for
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfGroup\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfGroup\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'group\ \ 'u
\f2group\fP
identifies a pfGroup.
.SH DESCRIPTION

A pfGroup is the internal node type of the OpenGL Performer hierarchy and is
derived from pfNode.  A pfGroup has a list of children which are
traversed when \f2group\fP is traversed.  Children may be any pfNode
which includes both internal nodes (pfGroups) and leaf nodes
(pfNodes).  Other nodes which are derived from pfGroup may use pfGroup
API. OpenGL Performer nodes derived from pfGroup are:
.RS
\f3\%pfScene\fP
.br
\f3\%pfSwitch\fP
.br
\f3\%pfLOD\fP
.br
\f3\%pfSequence\fP
.br
\f3\%pfLayer\fP
.br
\f3\%pfSCS\fP
.br
\f3\%pfDCS\fP
.br
\f3\%pfMorph\fP
.RE

\f3\%new pfGroup\fP creates and returns a handle to a pfGroup.  Like
other pfNodes, pfGroups are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfGroups should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfGroup::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfGroup\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGroup::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfGroup\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfGroup::addChild\fP appends \f2child\fP to the pfGroup and increments
the reference count of \f2child\fP.  \f3\%pfGroup::removeChild\fP
removes \f2child\fP from the list and shifts the list down over the
vacant spot, e.g. - if \f2child\fP had index 0, then index 1 becomes
index 0, index 2 becomes index 1 and so on.  \f3\%pfGroup::removeChild\fP returns
a 1 if \f2child\fP was actually removed and 0 if it was not found in the
list. \f3\%pfGroup::removeChild\fP decrements the reference count of \f2child\fP
but does not delete \f2child\fP if its reference count reaches 0.

\f3\%pfGroup::insertChild\fP inserts \f2child\fP before the child with index
\f2index\fP.  \f2index\fP must be within the range 0 to
\f3\%pfGroup::getNumChildren\fP().

\f3\%pfGroup::replaceChild\fP replaces \f2old\fP with \f2new\fP and returns 1
if the operation was successful or 0 if \f2old\fP is not a child
of the pfGroup.

\f3\%pfGroup::searchChild\fP returns the index of \f2child\fP if it was found
in the children list of the pfGroup or -1 if it was not found.

\f3\%pfGroup::getNumChildren\fP returns the number of children in the pfGroup.
\f3\%pfGroup::getChild\fP returns a handle to the child with index \f2index\fP or
NULL if the index is out of range.

The bounding volume of a pfGroup encompasses all its children.
Modifications to the child list of a pfGroup will
cause OpenGL Performer to recompute new bounding
volumes for the pfGroup unless it is configured to use static
bounding volumes (see \f3\%pfNode::setBound\fP).

\f3\%pfGroup::bufferAddChild\fP and
\f3\%pfGroup::bufferRemoveChild\fP provide
access to nodes that do not exist in the current pfBuffer (See the
pfBuffer man page). Either, none, or both of the
pfBuffer and \f2node\fP may exist outside the current pfBuffer.
\f3\%pfGroup::bufferAddChild\fP and
\f3\%pfGroup::bufferRemoveChild\fP act just
like their non-buffered counterparts
\f3\%pfGroup::addChild\fP and
\f3\%pfGroup::removeChild\fP except that the
addition or removal request is not carried out immediately but is
recorded by the current pfBuffer. The request is delayed until the
first \f3\%pfBuffer::merge\fP when both
the parent pfGroup and \f2node\fP are found in the main OpenGL
Performer pfBuffer. The list of
\f3\%pfGroup::bufferAddChild\fP and
\f3\%pfGroup::bufferRemoveChild\fP requests is
traversed in \f3\%pfBuffer::merge\fP after all nodes
have been merged.
\f3\%pfGroup::bufferAddChild\fP and
\f3\%pfGroup::bufferRemoveChild\fP return
\f3\%TRUE\fP if the request was recorded and \f3\%FALSE\fP otherwise.

.SH SEE ALSO
pfNode,
pfBuffer,
pfDelete
