'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfHit" "3pf"
.SH NAME
.upperok
.B pfHit
\- 
Intersection and bounding operations on drawable geometry
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfGeoSet.h>
.nf
.fi
.TP
int
\f3\%pfHit::query\fP(uint\ which,
'in +2
'll -2
void\ *dst);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfHit::mQuery\fP(uint\ *which,
'in +2
'll -2
void\ *dst);
.in
.ll
.nf
.fi
.TP
static pfType *
\f3\%pfHit::getClassType\fP(void);
.fi
.SH DESCRIPTION

\f3\%pfHit::query\fP and \f3\%pfHit::mQuery\fP read out information from the pfHit
object.  \f3\%pfHit::query\fP copies an item from the object into the
location specified by \f2dst\fP.  \f2which\fP specifies the item to be
copied using one of the \f3\%PFHIT_\fP tokens listed above.
\f3\%pfHit::mQuery\fP copies a series of items sequentially into the buffer
specified by \f2dst\fP.  The items and their order are defined by a
NULL-terminated array of query tokens pointed to by \f2which\fP.  For
both functions, the return value is the number of bytes written to the
destination buffer.

\f3\%PFQHIT_FLAGS\fP returns a bit vector indicating the validity of
information in the structure.  It is formed by a bitwise OR-ing of
the \f3\%PFHIT_POINT\fP, \f3\%PFHIT_NORM\fP, \f3\%PFHIT_PRIM\fP, \f3\%PFHIT_TRI\fP,
\f3\%PFHIT_VERTS\fP and \f3\%PFHIT_XFORM\fP symbols.

.TS
center tab($) ;
c | c
lB | l .
Flags Bit$Validity
_
PFHIT_POINT$Point of intersection
PFHIT_NORM$Polygon normal
PFHIT_PRIM$Index of primitive in pfGeoSet
PFHIT_TRI$Index of triangle within primitive
PFHIT_VERTS$Triangle vertices
PFHIT_XFORM$Non-identity transformation matrix
.TE

Other queried quantities are valid if non-NULL.

\f3\%PFQHIT_POINT\fP, \f3\%PFQHIT_NORM\fP and \f3\%PFQHIT_SEG\fP query the point
of intersection, the normal of the triangle at that point, and the
current segment as clipped by the intersection process.  All are in
local coordinates, i.e. they do not include the transformations of
pfSCSes and pfDCSes above them in the scene graph.  When intersecting
with primitives inside a pfGeoSet, \f3\%PFQHIT_PRIM\fP, \f3\%PFQHIT_TRI\fP and
\f3\%PFQHIT_VERTS\fP provide the index of the primitive within the
pfGeoSet, the triangle within the primitive, and the vertices of the
intersected triangle, respectively.  \f3\%PFQHIT_GSET\fP returns the
GeoSet.  \f3\%PFQHIT_NODE\fP returns the parent pfGeode.

\f3\%PFQHIT_PATH\fP returns a pfPath* denoting the traversal path.  Like
the pfHit object it is reused and should not be freed.

\f3\%pfHit::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfHit\fP.  The \f3\%pfType\fP* returned
by \f3\%pfHit::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfHit\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

.SH SEE ALSO
pfCylinder,
pfNode,
pfGeoSet,
pfObject,
pfSeg
