'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfImageTile" "3pf"
.SH NAME
.upperok
.B pfImageTile,
.B pfGetGlobalReadQueue,
.B pfDeleteGlobalReadQueue
\- 
Memory representation for rectangular (sub)section of texture image.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfReadImageTile\ \ \ 'u
#include <Performer/pr/pfImageTile.h>
.nf
.fi
.TP
void
\f3\%pfImageTile::pfImageTile\fP();
.nf
.fi
.TP
void
\f3\%pfImageTile::setSize\fP(int\ w,
'in +2
'll -2
int\ h,
int\ d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::getSize\fP(int\ *w,
'in +2
'll -2
int\ *h,
int\ *d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::setOrigin\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::getOrigin\fP(int\ *s,
'in +2
'll -2
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::setMem\fP(unsigned\ char\ *img,
'in +2
'll -2
int\ nBytes);
.in
.ll
.nf
.fi
.TP
unsigned char *
\f3\%pfImageTile::getMem\fP(void);
.nf
.fi
.TP
unsigned char *
\f3\%pfImageTile::getUnalignedMem\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::getNumImageComponents\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setMemImageFormat\fP(int\ format);
.nf
.fi
.TP
int
\f3\%pfImageTile::getMemImageFormat\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setMemImageType\fP(int\ type);
.nf
.fi
.TP
int
\f3\%pfImageTile::getMemImageType\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::getMemImageTexelSize\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setMemInfo\fP(int\ psize,
'in +2
'll -2
int\ lock);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::getMemInfo\fP(int\ *psize,
'in +2
'll -2
int\ *lock);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::setName\fP(const\ char\ *fname);
.nf
.fi
.TP
const char *
\f3\%pfImageTile::getName\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setFileName\fP(const\ char\ *fname);
.nf
.fi
.TP
const char *
\f3\%pfImageTile::getFileName\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::getFileImageTexelSize\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setFileTile\fP(int\ tileS,
'in +2
'll -2
int\ tileT,
int\ tileR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::getFileTile\fP(int\ *tileS,
'in +2
'll -2
int\ *tileT,
int\ *tileR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::setNumFileTiles\fP(int\ nTilesS,
'in +2
'll -2
int\ nTilesT,
int\ nTilesR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::getNumFileTiles\fP(int\ *nTielsS,
'in +2
'll -2
int\ *nTilesT,
int\ *nTilesR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::setFileImageFormat\fP(int\ fileFmt);
.nf
.fi
.TP
int
\f3\%pfImageTile::getFileImageFormat\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setFileImageType\fP(int\ fileType);
.nf
.fi
.TP
int
\f3\%pfImageTile::getFileImageType\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setHeaderOffset\fP(int\ offset);
.nf
.fi
.TP
int
\f3\%pfImageTile::getHeaderOffset\fP(void);
.nf
.fi
.TP
unsigned char *
\f3\%pfImageTile::getSubTile\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
unsigned char *
\f3\%pfImageTile::getValidSubTile\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::setReadQueue\fP(pfQueue\ *q);
.nf
.fi
.TP
pfQueue *
\f3\%pfImageTile::getReadQueue\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::getTotalBytes\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::getValidBytes\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::getValidTexels\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setValidTexels\fP(int\ nTexels);
.nf
.fi
.TP
int
\f3\%pfImageTile::isValid\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::isDirty\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setReadFunc\fP(pfReadImageTileFuncType\ func);
.nf
.fi
.TP
pfReadImageTileFuncType
\f3\%pfImageTile::getReadFunc\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setDefaultTile\fP(pfImageTile\ *default);
.nf
.fi
.TP
pfImageTile *
\f3\%pfImageTile::getDefaultTile\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setDefaultTileMode\fP(int\ useDefault);
.nf
.fi
.TP
int
\f3\%pfImageTile::getDefaultTileMode\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::load\fP(void);
.nf
.fi
.TP
int
\f3\%pfImageTile::load\fP(int\ nTexels);
.nf
.fi
.TP
int
\f3\%pfImageTile::load\fP(const\ char\ *fname);
.nf
.fi
.TP
int
\f3\%pfImageTile::load\fP(const\ char\ *fname,
'in +2
'll -2
int\ nTexels);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::freeMem\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setMemQueue\fP(pfQueue\ *q);
.nf
.fi
.TP
pfQueue *
\f3\%pfImageTile::getMemQueue\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setPriority\fP(int\ priority);
.nf
.fi
.TP
int
\f3\%pfImageTile::getPriority\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::sortFunc\fP(pfQueueSortFuncData\ *data);
.nf
.fi
.TP
int
\f3\%pfImageTile::isLoading\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setUseMemQueue\fP(short\ useMemQueue);
.nf
.fi
.TP
short
\f3\%pfImageTile::getUseMemQueue\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setFileNameFunc\fP(pfTileFileNameFuncType\ fnptr);
.nf
.fi
.TP
pfTileFileNameFuncType
\f3\%pfImageTile::getFileNameFunc\fP(void);
.nf
.fi
.TP
void
\f3\%pfImageTile::setImageCache\fP(pfImageCache\ *icache);
.nf
.fi
.TP
pfImageCache *
\f3\%pfImageTile::getImageCache\fP(void)
.nf
.fi
.TP
void
\f3\%pfImageTile::setTileIndex\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfImageTile::getTileIndex\fP(int\ *s,
'in +2
'll -2
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfImageTile::ProcessOneRead\fP(void\ *data);
.nf
.fi
.TP
int
\f3\%pfImageTile::ReadDirect\fP(pfImageTile\ *itile,
'in +2
'll -2
int\ ntexels);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfImageTile::ReadNormal\fP(pfImageTile\ *itile,
'in +2
'll -2
int\ ntexels);
.in
.ll
.nf
.fi
.TP
pfQueue*
\f3\%pfGetGlobalReadQueue\fP(void);
.nf
.fi
.TP
void
\f3\%pfDeleteGlobalReadQueue\fP(void);
.nf
.fi
.TP
typedef int
\f3\%(*pfReadImageTileFuncType)\fP(pfImageTile\ *itile,
'in +2
'll -2
int\ nTexels);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfImageTile\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfImageTile\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfImageTile\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfImageTile is representation of a texture image in main memory.  A
pfImageTile can be used to load textures or pieces of texture from disk
and store them in certain byte configurations in main memory.  Further
these pfImageTiles can then be used as the src for pfTextures or
pfTexLoads in order to load imagery into a GL texture from main
memory.

The default constructor \f3\%pfImageTile\fP creates a pfImageTile.
\f3\%new\fP(arena) allocates a pfImageTile from the specified memory
arena, or from the process heap if \f2 arena\fP is \f3\%NULL\fP. \f3\%new\fP
allocates a pfImageTile from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfImageTiles cannot be created statically, automatically
on the stack or in arrays.  pfImageTiles should be deleted with \f3\%pfDelete\fP
rather than with the delete operator.

\f3\%pfImageTile::setSize\fP sets the size of this tile
in each of the three supported image dimensions.
\f3\%pfImageTile::getSize\fP fills in its arguments with
the sizes for each of the three supported image dimensions.
Any of the arguments w,h,d may be NULL, in which case it will be ignored.

\f3\%pfImageTile::setOrigin\fP sets the origin of the
subregion of the imagetile with respect to the possibly larger whole image.
\f3\%pfImageTile::getOrigin\fP fills in its arguments with
the imagetile's origin in each of the three supported image dimensions.
Any of the arguments s,t,r may be NULL, in which case it will be ignored.

Thus one example of a pfImageTile might be representing a subregion of 2048x2048x1
image that was 256x256x1 in size starting at location 1024,512,0 in the larger image.
In this case the origin of the imagetile would be 1024,512,0 and the size would be
256,256,1.

\f3\%pfImageTile::getMem\fP returns a pointer to the
memory used to represent the actual image for the imagetile.  This routine
is used to allow routines external to the imagetile to copy the image from
external devices or other memory into the imagetile efficiently.  Note,
this routine always returns memory aligned on page boundaries - even if the
memory was given to the imagetile via
\f3\%pfImageTile::setMem\fP.

\f3\%pfImageTile::getUnalignedMem\fP returns
a pointer to the memory used to represent the image for the imagetile.
This routine returns the non-page aligned version of the imagetile's memory;
however, the data is considered to start on the first page boundary -
see \f3\%pfImageTile::getMem\fP.  This routine is
useful for directly getting the memory pointer set on the imagetile via
\f3\%pfImageTile::setMem\fP.

\f3\%pfImageTile::setMem\fP assigns the memory that should
be used to represent the actual image for the imagetile.  \f2nBytes\fP refers
to the number of bytes that can be stored in \f2img\fP - this information is useful
if the imagetile needs to be resized.  Note that generically this memory will
be allocated and destroyed automatically and this piece of api need not be used
for normal applications.

\f3\%pfImageTile::setMemImageFormat\fP is used to set
the memory format and number of components used to represent an image texel
in memory within the image tile.  The memory formats correspond to GL and
Performer tokens used to define the external formats of textures.  See
\f3\%pfTexture\fP and \f3\%glTexImage2D\fP.
\f3\%pfImageTile::getMemImageFormat\fP returns the
memory format used to represent each image texel within the imagetile.
Possible memory formats include:
\f3\%PFTEX_LUMINANCE\fP, \f3\%PFTEX_LUMINANCE_ALPHA\fP, \f3\%PFTEX_RGB\fP, and
\f3\%PFTEX_RGBA\fP.

\f3\%pfImageTile::setMemImageType\fP is used to set the
data type of each component/texel stored with the memory of the imagetile.
The memory type corresponds directly to the external memory type tokens
passed into GL and Performer when defining external memory representation
of textures.  See \f3\%pfTexture\fP and \f3\%glTexImage2D\fP.
\f3\%pfImageTile::getMemImageType\fP returns the
memory type used to represent each image texel within the imagetile.

\f3\%pfImageTile::getMemImageTexelSize\fP returns
the size in bytes of each texel of the imagetile.  This size is determined
through knowing the number of components within the image and the size of each
component.  This information is directly derived from the memory format and
memory type of the imagetile.

\f3\%pfImageTile::getNumImageComponents\fP
returns the number of color components in each image texel, based on the
imagetile's memory format and memory type.

\f3\%pfImageTile::setMemInfo\fP is used to set
two important characteristics about the memory used to represent the
texture image with the imagetile.  \f2psize\fP is used to describe the
modulo on which the address of the actual data representing the texture
image must start.  For instance if \f2psize\fP is set to 4096 then the
effective address if the texture image must be modulo 4096.  The
default \f2psize\fP is in fact 4096 which is the current onyx page size.
Also note that this causes slightly more memory to be used for the
image because in order to guarantee a modulo \f2psize\fP memory alignment
from malloc, malloc must be requested with a \f2psize\fP extra bytes and
then when the actual address from malloc is returned, it is effectively
incremented to the next \f2psize\fP boundary.  \f2lock\fP specifies whether
the memory should be pinned down via \f3\%mpin\fP when allocated.  Both of
these parameters are necessary if the memory will be used for direct IO
reads from disk in which case strict alignment requirements are needed
because no intermediate memory buffer is used when copying data from
the disk.  \f3\%pfImageTile::getMemInfo\fP
returns the information about whether the imagetile should attempt to
\f3\%mpin\fP memory it creates and what modulo should be used as an
alignment requirement for the memory representing the texture image.
Either of the arguments psize,lock may be NULL, in which case
it will be ignored.

\f3\%pfImageTile::setName\fP and
\f3\%pfImageTile::getName\fP set and get the
name of a particular image tile.  The name is useful for nothing other
than to represent a possible image name associated with all of the
tiles of a particular image.

\f3\%pfImageTile::setFileName\fP and
\f3\%pfImageTile::getFileName\fP set and get
the filename associated with a particular image tile.  This filename
is used when the imagetile is loaded via
\f3\%pfImageTile::load\fP.

\f3\%pfImageTile::setFileImageFormat\fP is used to
set the texel format and number of components used to represent an
image texel in memory within the image tile.  The formats correspond to
GL and Performer tokens used to define the external formats of
textures.  See \f3\%pfTexture\fP and \f3\%glTexImage2D\fP.
\f3\%pfImageTile::getFileImageFormat\fP returns
the format used to represent each image texel within the imagetile on
disk.  Possible formats include:  \f3\%PFTEX_LUMINANCE\fP,
\f3\%PFTEX_LUMINANCE_ALPHA\fP, \f3\%PFTEX_RGB\fP, and \f3\%PFTEX_RGBA\fP.

\f3\%pfImageTile::setFileImageType\fP is used to set
the data type of each component/texel stored within the imagetile
data.  The memory type corresponds directly to the external memory type
tokens passed into GL and Performer when defining external memory
representation of textures.  See \f3\%pfTexture\fP and \f3\%glTexImage2D\fP.
\f3\%pfImageTile::getFileImageType\fP returns the
data type used to represent each image texel within the imagetile as
stored externally to the tile.

\f3\%pfImageTile::getFileImageTexelSize\fP
returns the size in bytes of each texel of the imagetile.  This size is
determined through knowing the number of components within the image
and the size of each component.  This information is directly derived
from the file format and file type of the imagetile.

\f3\%pfImageTile::setFileTile\fP sets the
subtile of the file in which the imagetile exists.
\f3\%pfImageTile::getFileTile\fP returns the
file subtile for this imagetile.
Any of the arguments tileS,tileT,tileR may be NULL, in which case
it will be ignored.
\f3\%pfImageTile::setNumFileTiles\fP sets
the number of tiles in each dimension within the file containing the
pfImageTile.
\f3\%pfImageTile::getNumFileTiles\fP
returns the number of tiles in each dimension within the file
containing the pfImageTile.
Any of the arguments nTilesS,nTilesT,nTilesR may be NULL, in which case
it will be ignored.

\f3\%pfImageTile::setHeaderOffset\fP
and \f3\%pfImageTile::getHeaderOffset\fP
sets and gets the header offset to be ignored at the beginning of
reading pfImageTile's from disk.

\f3\%pfImageTile::setDefaultTile\fP
sets an alternate pfImageTile to use when data is requested from this
tile and is not available.
\f3\%pfImageTile::getDefaultTile\fP
returns the alternate pfImageTile that was specified to be used
when image data is requested and is not available.

\f3\%pfImageTile::setDefaultTileMode\fP
and \f3\%pfImageTile::getDefaultTileMode\fP
set and gets the mode associated with the use of the default pfImageTile
associated with this pfImageTile.  PF_ON specifies to use the default
when data is unavailable, PF_OFF specifies to ignore the default tile.

\f3\%pfImageTile::getSubTile\fP returns a
pointer to the texel corresponding to s,t,r.

\f3\%pfImageTile::getValidSubTile\fP
also returns a pointer to the texel corresponding to s,t,r; however,
this function will spin waiting for that texel data to be validated
before it returns.  This is useful for synchronizing texel data being
loaded asynchronously.

\f3\%pfImageTile::setValidTexels\fP is used
to explicitly set the valid portion of an imagetile.  When the number of
valid texels is equal to the total number of texels in the imagetile
then the entire imagetile is marked as valid.

\f3\%pfImageTile::getValidTexels\fP
returns the number of currently valid texels.  This number is
determined by either the number of texels marked valid through a
\f3\%pfImageTile::load\fP or explicitly set via
\f3\%pfImageTile::setValidTexels\fP.

\f3\%pfImageTile::getTotalBytes\fP returns
the total number of bytes required to store a texture image within the
imagetile.  The value is calculated by multiplying the total number of
texels in the texture image by the size of each texel.

\f3\%pfImageTile::getValidBytes\fP returns
the total number of valid bytes available currently loaded of the image
stored with the imagetile.  The value is calculated by multiplying the
number of currently valid texels by the size of each texel.

\f3\%pfImageTile::isValid\fP returns whether the
entire texture image stored within the imagetile has been loaded.

\f3\%pfImageTile::isDirty\fP returns whether
something about the imagetile has changed that could cause it have to
be loaded.

\f3\%pfImageTile::setReadFunc\fP sets a
function to call in order to perform the actual read of data from disk
or other external device into the imagetile.  The default function
supports fast reading of several raw data formats and will eventually
support slow reading for a large number of image formats.
\f3\%pfImageTile::getReadFunc\fP returns the
current function used to read data into an imagetile when
\f3\%pfImageTile::load\fP is called.

\f3\%pfImageTile::setReadQueue\fP sets the
queue the imagetile should be appended to when it needs to be
read.  Setting \f2q\fP to \f3\%NULL\fP (the default) causes reads
to take place when load is called, in a synchronous process. Setting a
\f2q\fP to a valid read queue allows the read to happen asynchronously.
See the \f3\%pfQueue\fP man page for more information about queues.

\f3\%pfImageTile::halve\fP returns a new
pfImageTile that contains a half resolution version of the imagetile.
This will be useful for creating mipmaps but is currently not
implemented.

\f3\%pfImageTile::load\fP will cause the tile to be
loaded either synchronously or asynchronously depending on the
imagetile's current read queue - see
\f3\%pfImageTile::setReadQueue\fP above.  This
routine will attempt to load the entire image from the file specified
via the imagetile's filename parameter.

\f3\%pfImageTile::load(int ntexels)\fP
specifies that \f2ntexels\fP texels should be read into the imagetile and
validated.

\f3\%pfImageTile::load(const char *fname)\fP
effectively sets the filename of the imagetile and causes it to be
loaded.

\f3\%pfImageTile::load(const char *fname, int ntexels)\fP
sets the filename of the imagetile and causes a partial load to take place.

\f3\%pfImageTile::freeMem\fP causes the memory used to hold
the actual texture image within the imagetile to be freed.

\f3\%pfGetGlobalReadQueue\fP will return a pointer to a preconfigured global read queue
with one service thread that can manage all loading of pfImageTile's asynchronously.

\f3\%pfDeleteGlobalReadQueue\fP will delete the global read queue. The first
time \f3\%pfGetGlobalReadQueue\fP is called after the read queue has been deleted,
a new one will be allocated and configured.

\f3\%pfImageTile::setMemQueue\fP
sets the queue where image tiles will be place store their pfMemory
when they are reconfigured by an image cache. The memory
queue holds a list of pfMemorys. In practice,
only the image tile used as the proto tile needs to
set a valid memqueue value.  The use of the MemQueue and be controlled
via the \f3\%pfImageTile::setUseMemQueue\fP
function described below.

\f3\%pfImageTile::getMemQueue\fP returns
the current value of the image tile's memqueue pointer.

\f3\%pfImageTile::setUseMemQueue\fP is used
to tell the ImageTile whether or not to use the memory re-use queue
described by \f3\%pfImageTile::setMemQueue\fP.
The default value is TRUE which will allow the queue to be used.

\f3\%pfImageTile::getUseMemQueue\fP returns
TRUE if the imagetile is currently set to use the memory reuse queue
defined by \f3\%pfImageTile::setMemQueue\fP.

\f3\%pfImageTile::setPriority\fP
set the priority of an image tile. The priority value is used by sorting
read queues when the PF_DTR_READSORT DTR mode is enabled. The priority
is used by the read queue's sort function when the queue is in sorting mode.
image tile elements are sorted by priority, so the most important tiles
are read first. The image cache that owns the image tile sets the tiles'
priority based on their distance from the center of tex region. A tile's
priority is more important if the priority value is lower.
\f3\%pfImageTile::getPriority\fP
returns the current value of an image tile's priority.

\f3\%pfImageTile::sortFunc\fP
is a static member function of the pfImageTile class. It
is used as the sorting function for the read queue of
a pfImageCache. It is not intended for general use by applications.

\f3\%pfImageTile::isLoading\fP
indicates whether the image tile is currently being processed by the
read function. A value of non-zero means that the tile represented
by this image tile is being read from disk into a tile of the image
cache in system memory.

\f3\%pfImageTile::setFileNameFunc\fP
sets the file name function that the read function will call to
dynamically evaluate the file name that should be used to read
tile data from disk to the image cache's mem region. The default
function, \f3\%pfImageCache::autoConfigFileName()\fP, takes an image tile
argument and computes the proper file name string using the parameter
values set in the pfImageCache object. This function pointer is automatically
set when the pfImageCache creates and configures its pfImageTile objects.

\f3\%pfImageTile::getFileNameFunc\fP
returns a function pointer showing the pfImageTile object's file name
function. This function is called by the read function on the pfImageTile
object to set the filename before reading the file to download the texel
data. An exmple function that uses this function is the \f3\%ReadNormal\fP
and \f3\%ReadDirect\fP example read functions in \f3\%lib/libpfutil/pfdLoadImage.c\fP

\f3\%pfImageTile::setImageCache\fP
set the current pfImageCache pointer. The pfImageCache object is used
by the file name configuration function to generate the image tile filename.
This function is called by the read function when the pfImageTile texel
data is downloaded from disk the pfImageCache object's mem region. This value
is automatically set by the pfImageCache object when it creates and configures
its pfImageTile objects.

\f3\%pfImageTile::getImageCache\fP
returns a pointer to  the current pfImageCache object. If the pfImageTile
object was created by the application, the default value of the pointer
is NULL. If created by a pfImageCache object, the pointer will point to
the creating pfImageCache.

\f3\%pfImageTile::setTileIndex\fP
set the s, t, and r coordinates of the image tile within the cliptexture level.
This value positions the tile within the complete virtual level. This value
is set by the creating pfImageCache object.

\f3\%pfImageTile::getTileIndex\fP
return the current s, t, and r coordinates of the image tile.

\f3\%pfImageTile::ProcessOneRead\fP
this is the function that manages the global read queue. The read queue
calls this function with a pointer to the last read element. The
function casts the pointer to an pfImageTile pointer, then calls the
image tile's read function. The ProcessOneRead function returns the
number of bytes read.

\f3\%pfImageTile::ReadDirect\fP
this is the default read function used by the global read queue. It
tries to use direct I/O for efficiency to read the disk file containing
the image cache data. The source code for the C version of this function
is defined in \f3\%/usr/share/Performer/src/lib/libpfdb/pfdLoadImage.c\fP.
If the disk file can't be read using direct I/O, the function calls
\f3\%pfImageTile::ReadNormal\fP.

\f3\%pfImageTile::ReadNormal\fP
this is the fallback read function used by the global read queue. It
is called by \f3\%pfImageTile::ReadDirect\fP
if it fails. It tries to read the disk file using the FILE library.
If it fails, it prints a warning message. The source code for the C
version of this function is defined in
\f3\%/usr/share/Performer/src/lib/libpfdb/pfdLoadImage.c\fP.

.SH SEE ALSO
pfImageCache,
pfQueue,
pfTexLoad,
pfTexture
