'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLOD" "3pf"
.SH NAME
.upperok
.B pfLOD
\- 
Create, modify, and query level of detail nodes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLODEvalFuncType\ \ \ 'u
#include <Performer/pf/pfLOD.h>
.nf
.fi
.TP
\ 
\f3\%pfLOD::pfLOD\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfLOD::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLOD::setRange\fP(int\ index,
'in +2
'll -2
float\ range);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfLOD::getRange\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfLOD::getNumRanges\fP(void);
.nf
.fi
.TP
void
\f3\%pfLOD::setTransition\fP(int\ index,
'in +2
'll -2
float\ distance);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfLOD::getTransition\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfLOD::getNumTransitions\fP(void);
.nf
.fi
.TP
void
\f3\%pfLOD::setRangeFlux\fP(int\ index,
'in +2
'll -2
pfFlux\ *flux);
.in
.ll
.nf
.fi
.TP
pfFlux*
\f3\%pfLOD::getRangeFlux\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfLOD::getNumRangeFluxes\fP(void);
.nf
.fi
.TP
void
\f3\%pfLOD::setCenter\fP(pfVec3\ &center);
.nf
.fi
.TP
void
\f3\%pfLOD::getCenter\fP(pfVec3\ &center);
.nf
.fi
.TP
void
\f3\%pfLOD::setLODState\fP(pfLODState\ *ls);
.nf
.fi
.TP
pfLODState*
\f3\%pfLOD::getLODState\fP(void);
.nf
.fi
.TP
void
\f3\%pfLOD::setLODStateIndex\fP(int\ index);
.nf
.fi
.TP
void
\f3\%pfLOD::getLODStateIndex\fP(void);
.nf
.fi
.TP
float
\f3\%pfLOD::evaluate\fP(const\ pfChannel\ *chan,
'in +2
'll -2
const\ pfMatrix\ *offset);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLOD::setUserEvalFunc\fP(pfLOD\ *lod,
'in +2
'll -2
pfLODEvalFuncType\ evalFunc);
.in
.ll
.nf
.fi
.TP
pfLODEvalFuncType
\f3\%pfLOD::getUserEvalFunc\fP(pfLOD\ *lod);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLOD\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfLOD\fP.
This is also true for
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfLOD\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfLOD\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLOD\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'lod\ \ 'u
\f2lod\fP
identifies a pfLOD.
.Ex
.nf

typedef float (*pfLODEvalFuncType)
              (pfLOD *lod, pfChannel *chan, pfMatrix *offset);
.Ee
.fi
.na

.SH DESCRIPTION

A pfLOD is a level-of-detail (LOD) node.  Level-of-detail is a
technique for manipulating model complexity based on image
quality and rendering speed.  Typically, a model is drawn in finer
detail when close to the viewer (occupies large screen area) than
when it is far away (occupies little screen area).  In this way,
costly detail is drawn only when necessary.

Additionally, OpenGL Performer can adjust LODs based on rendering load.
If a scene is taking too long to draw, OpenGL Performer can globally
modify LODs so that they are drawn coarser and render time is reduced
(see \f3\%pfChannel::setStress\fP).

OpenGL Performer uses range-based LOD and adjusts for field-of-view and
viewport pixel size.  Range is computed as the distance from the
pfChannel eyepoint which is drawing the scene to a point designated as
the center of a pfLOD.  This range is then potentially modified by
pfChannel attributes (see \f3\%pfChannel::setLODAttr\fP, \f3\%pfChannel::setStress\fP).  This
range indexes the pfLOD range list to select a single child to draw.

pfLOD is derived from pfGroup
so it can have children and use pfGroup API to manipulate its
child list.  In addition to a list of children, a pfLOD has a list of
ranges which specify the transition points between levels-of-detail.
\f3\%new pfLOD\fP creates and returns a handle to a pfLOD.  Like
other pfNodes, pfLODs are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfLODs should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfLOD::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLOD\fP.  The \f3\%pfType\fP* returned
by \f3\%pfLOD::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfLOD\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLOD::setCenter\fP sets the object-space point which defines the center
of the pfLOD.  \f2center\fP is affected by any transforms in the hierarchy
above the pfLOD (see pfSCS).  \f3\%pfLOD::getCenter\fP
copies the LOD center point into \f2center\fP.

\f3\%pfLOD::setRange\fP sets the value of range list element \f2index\fP to
\f2range\fP which is a floating point distance specified in world
coordinates.  A child is selected based on the computed range
(LODRange) from the eyepoint to the pfLOD center and the range list
(\f2Ranges\fP) according to the following pseudocode decision test:
.Ex
.nf

if (LODRange < Ranges[0])
    draw nothing;
else
if (LODRange >= Ranges[i] && LODRange < Ranges[i+1])
    draw Child[i];
else
if (LODRange >= Ranges[N-1] where N is length of Ranges)
    draw nothing;
.Ee
.fi
.na


Ranges specified by \f3\%pfLOD::setRange\fP must be positive and increasing with
index or results are undefined.  \f3\%pfLOD::getRange\fP returns the range with
index \f2index\fP and \f3\%pfLOD::getNumRanges\fP returns the number of ranges
currently set.

Normally, LOD transitions are abrupt switches that can cause
distracting visual artifacts.  However, OpenGL Performer provides two ways
to achieve smooth LOD transitions.  The first way is by having morphing
LODs that transition smoothly between the static LODs.  The second way is
to blend between the LODs, by drawing both LODs during a transition range
and alpha blending between them.
Morphing LODs tends to achieve better draw performance because you are never
drawing two LODs at once.  But morphing LODs do require special modeling and
the morph engine will require some amount of CPU time to calculate the morphed
geometry.  Blended LODs have the advantage that no special modeling is
required, and so it is easy to enable blended LODs.

A morphing LOD is created by connecting a \f3\%pfFlux\fP to a \f3\%pfLOD\fP
node using \f3\%pfLOD::setRangeFlux\fP.  This \f3\%pfFlux\fP
is then connected to the \f3\%PFENG_MORPH_FRAME\fP source of one or more
\f3\%PFENG_MORPH\fP \f3\%pfEngines\fP.  When a LOD is selected, which has a range
flux attached, the range flux will be updated.  The value of the range flux
will be between 0.0 and 1.0, depending on where the computed range is
within the range for the LOD.
Morphing is discussed in greater depth in the \f3\%pfEngine\fP man page.

Blended level-of-detail transitions are enabled by setting a non-zero
transition range with \f3\%pfChannel::setLODAttr\fP.
Blending is discussed in greater depth in the
\f3\%pfChannel::setLODAttr\fP man page.

\f3\%pfLOD::setTransition\fP sets the distance over
which OpenGL Performer should
transition or "fade" between an lod's children.  The number of
transitions is equal to the number of LOD children + 1.  Thus
Transitions[0] specifies the distance over which LOD child 0 should
fade in. Transitions[1] specifies the distance over which OpenGL
Performer will fade between child 0 and child 1.  Transitions[N]
specifies the distance over which the last lod child will fade out.
Note that performer will regulate the transition such that the fade
will be centered based on the ranges specified by pfLODRange.  It is
also important to note the pfLODTransition distances should be
specified such that there is no overlap between transitions or
reasonable, but undefined, behavior will result.  Thus, it is important
to consider pfLODRanges when specifying transition distances.
\f3\%pfLOD::getTransition\fP returns the range with index \f2index\fP and
\f3\%pfLOD::getNumRanges\fP returns the number of ranges currently set.

Note that in practice OpenGL Performer will multiply this transition
distance by a global transition scale (this scale is set by calls to
\f3\%pfChannel::setLODAttr\fP with the \f3\%PFLOD_FADE\fP token).

The default behavior of pfLODTransition is that each transition is set
to a distance of 1.0 (except Transitions[0] which is set to 0.0 by default).
This makes it easy to specify a "global fade range" by controlling a
\f3\%pfChannel::setLODAttr\fP attribute - \f3\%PFLOD_FADE\fP.  By setting \f3\%PFLOD_FADE\fP to 10.0, all
transitions that have not be explicitly set will use 10.0 * 1.0 = 10.0
as their fade distance (except Transitions[0] which will not fade at all).

Note that if one does not desire control over individual lod transitions,
it is not necessary to call \f3\%pfLOD::setTransition\fP.

If a particular LOD is morphing you will probably want to set its
transitions to 0.0.

\f3\%pfLOD::setLODState\fP associates the given pfLOD and pfLODState.  This enables
the control of how a particular pfLOD responds to stress and range.
\f3\%pfLOD::getLODState\fP returns the pfLODState associated with lod if there
is one or NULL if one does not exist.

\f3\%pfLOD::setLODStateIndex\fP allows pfLODStates to be indexed on a per channel
basis.  \f2index\fP is an index into an pfList of pfLODStates specified via
\f3\%pfChannel::setLODStateList\fP.
\f3\%pfLOD::getLODStateIndex\fP returns the index currently specified for the pfLOD
or -1 if no index has been specified.

Note that if an out of range index is specified for a given pfLOD then the
pfLODState specified as the global pfLODState for that channel will be used.

\f3\%pfLOD::evaluate\fP returns the index of the child that the Performer Cull
traversal would produce given a specific channel and matrix offset.  The integer
portion of the return value represents the selected child, while the
floating point portion of the return is used to distinguish the fade ratio
between two visible lods if lod fading is turned on for the given channel
(see \f3\%pfChannel::setLODAttr\fP).  Thus an index of 1.0 would correspond to Performer's
decision to draw only child one.  A value of 1.25 would mean Performer
would be 25% across the FADE transition between child one and child two -
meaning that child one would be 75% opaque while child two would be 25%
opaque.  Similarly a value of 3.9 would represent child three being 10%
opaque (solid) while child four was 90% opaque.  The value -1.0 is
returned when no children are visible.  Note that negative floating point
values (like -.3) mean that Performer is currently fading in child 0
and that it is 70% opaque.  Thus return values will range from
-1.0 <= return value < N+1 where N is the number of children for
the LOD.
(See \f3\%pfChannel\fP and \f3\%pfLODState\fP)

\f3\%pfLOD::setUserEvalFunc\fP sets a user function for
picking an LOD result. The result of this user function is a
floating point number similar to the result of
\f3\%pfLOD::evaluate\fP.
\f3\%pfLOD::getUserEvalFunc\fP returns the current
user evaluation function.

.SH NOTES

Intersection traversals currently always intersect with an LODRange of
0.  To intersect with other ranges, a pfSwitch with the same parent
and children as the pfLOD can be created with the pfLOD used for
drawing and the pfSwitch used for intersecting (see
\f3\%pfChannel::setTravMask\fP).
.SH SEE ALSO
pfChannel,
pfGroup,
pfLODState,
pfNode,
pfDelete
