'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLODState" "3pf"
.SH NAME
.upperok
.B pfLODState
\- 
Create, modify, and query level of detail state.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfLODState.h>
.nf
.fi
.TP
\ 
\f3\%pfLODState::pfLODState\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfLODState::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLODState::setAttr\fP(long\ attr,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfLODState::getAttr\fP(long\ attr);
.nf
.fi
.TP
int
\f3\%pfLODState::setName\fP(const\ char\ *name);
.nf
.fi
.TP
const char *
\f3\%pfLODState::getName\fP(void);
.nf
.fi
.TP
pfLODState *
\f3\%pfLODState::find\fP(const\ char\ *name);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLODState\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfLODState\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLODState\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'ls\ \ 'u
\f2ls\fP
identifies a pfLODState.
.SH DESCRIPTION

pfLODState encapsulates a definition
of how an LOD or group of LODs should
respond to distance from the eyepoint and stress.
Currently, there are 8 attributes that
can be used to define LOD child selection and child transition distance
based on a LOD's distance from the channel's viewpoint and the channel's
stress (see \f3\%pfChannel\fP and \f3\%pfChannel::setStress\fP).

\f3\%new pfLODState\fP creates and returns a handle to a pfLODState.
pfLODStates are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfLODStates should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfLODState::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLODState\fP.  The \f3\%pfType\fP* returned
by \f3\%pfLODState::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfLODState\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLODState::setAttr\fP and \f3\%pfLODState::getAttr\fP are used to set and get
the following attributes:
.RS
.TP 5
\f3\%PFLODSTATE_RANGE_RANGESCALE\fP, \f3\%PFLODSTATE_RANGE_RANGEOFFSET\fP
directly modify the geometric range used to determine the current LOD child.
.TP
\f3\%PFLODSTATE_RANGE_STRESSSCALE\fP, \f3\%PFLODSTATE_RANGE_STRESSOFFSET\fP
modify the way the current channel stress affects the range computation.
.TP
\f3\%PFLODSTATE_TRANSITION_RANGESCALE\fP, \f3\%PFLODSTATE_TRANSITION_RANGEOFFSET\fP
directly modify the transition widths set by \f3\%pfLOD::setTransition\fP.
.TP
\f3\%PFLODSTATE_TRANSITION_STRESSSCALE\fP, \f3\%PFLODSTATE_TRANSITION_STRESSOFFSET\fP
modify the way transition widths are adjusted by the channel stress value.
.RE

These scale and offset values adjust the LOD selection process in
the following way, presented in pseudocode:
.Ex
.nf

effectiveRange =
    OverallLODScale *
    (Range * \f3\%RANGE_RANGESCALE\fP + \f3\%RANGE_RANGEOFFSET\fP) *
    (Stress * \f3\%RANGE_STRESSSCALE\fP + \f3\%RANGE_STRESSOFFSET\fP);

effectiveTransitionWidth[i] =
    OverallFadeScale *
    (Trans[i] * \f3\%TRANSITION_RANGESCALE\fP + \f3\%TRANSITION_RANGEOFFSET\fP) /
    (Stress * \f3\%TRANSITION_STRESSSCALE\fP + \f3\%TRANSITION_STRESSOFFSET\fP);
.Ee
.fi
.na


OverallLODScale and OverallFadeScale are the \f3\%PFLOD_SCALE\fP and
\f3\%PFLOD_FADE\fP attributes set with \f3\%pfChanLODAttr\fP. Both
are global values that affect the switching and transition ranges
of all pfLODs in the scene.

The default values for all \f3\%SCALE\fP and \f3\%OFFSET\fP attributes are
1.0 and 0.0 respectively except \f3\%TRANSITION_STRESSSCALE\fP and
\f3\%TRANSITION_STRESSOFFSET\fP which are 0.0 and 1.0 respectively, i.e.,
transition ranges are not scaled by stress by default.

A pfLODState influences a pfLOD's behavior in one of 3 ways:
.RS
.TP
1.
Direct reference. A pfLOD may directly reference a pfLODState with
\f3\%pfLOD::setLODState\fP.
.TP
2.
Indexed. A pfLOD may index a pfLODState with
\f3\%pfLOD::setLODStateIndex\fP. When the LOD
is evaluated, the \f2index\fPth entry of the evaluating pfChannel's
pfLODState table is used. A pfChannel's pfLODState table is set with
(\f3\%pfChannel::setLODStateList\fP).
With indexed pfLODStates, different pfChannels can have different
LOD behavior by using different pfLODState tables, e.g., an infrared
channel may not "see" cold objects as well as a visual channel
so "cold" pfLODs will index a different pfLODState in the infrared channel
than in the visual channel.
.TP
3.
Inherited from pfChannel. A pfLOD which does not directly reference
or index a pfLODState will use the pfLODState of the evaluating pfChannel
(\f3\%pfChannel::setLODState\fP). This is
the default pfLOD behavior.
.RE

When a pfLOD references or indexes a pfLODState,  the \f3\%SCALE\fP and \f3\%OFFSET\fP
parameters of the pfLODState are multiplied and added, respectively, to the
corresponding \f3\%SCALE\fP and \f3\%OFFSET\fP parameters of the evaluating
pfChannel's pfLODState, e.g., effective \f3\%RANGE_RANGESCALE\fP =
pfLODState's \f3\%RANGE_RANGESCALE\fP * pfChannel's \f3\%RANGE_RANGESCALE\fP.

Multiple pfLODs may share the same pfLODState reference or index.

\f3\%pfLODState::setName\fP and \f3\%pfLODState::getName\fP set and get the name of a
particular pfLODState while \f3\%pfLODState::find\fP will return the first
pfLODState defined with the given name.
.SH SEE ALSO
pfLOD,
pfChannel
