'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLayer" "3pf"
.SH NAME
.upperok
.B pfLayer
\- 
Create, modify, and query layer nodes for decals and coplanar polygons.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfLayer.h>
.nf
.fi
.TP
\ 
\f3\%pfLayer::pfLayer\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfLayer::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLayer::setMode\fP(int\ mode);
.nf
.fi
.TP
int
\f3\%pfLayer::getMode\fP(void);
.nf
.fi
.TP
void
\f3\%pfLayer::setPlane\fP(pfPlane\ *plane);
.nf
.fi
.TP
pfPlane *
\f3\%pfLayer::getPlane\fP(void);
.nf
.fi
.TP
void
\f3\%pfLayer::setBase\fP(pfNode\ *base);
.nf
.fi
.TP
pfNode *
\f3\%pfLayer::getBase\fP(void);
.nf
.fi
.TP
void
\f3\%pfLayer::setDecal\fP(pfNode\ *decal);
.nf
.fi
.TP
pfNode *
\f3\%pfLayer::getDecal\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLayer\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfLayer\fP.
This is also true for
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfLayer\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfLayer\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLayer\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

On Z-buffer based machines, numerical precision can cause distracting
artifacts when rendering coplanar geometry.  A pfLayer is a node
derived from pfGroup that supports proper drawing of coplanar geometry
on OpenGL platforms.

A pfLayer can be thought of as a stack of geometry where each
layer has visual priority over the geometry beneath it in the stack.
An example of a 3 layer stack consists of stripes which are layered
over a runway which is layered over the ground. The bottommost
layer is called the "base" while the other layers are called "decals".
When using certain hardware mechanisms (\f3\%PFDECAL_BASE_STENCIL\fP)
to implement pfLayers, the "base" is special because it defines
the depth values which are used to determine pfLayer visibility with
respect to other scene geometry and which are written to the depth buffer.

\f3\%new pfLayer\fP creates and returns a handle to a pfLayer.  Like
other pfNodes, pfLayers are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfLayers should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfLayer::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLayer\fP.  The \f3\%pfType\fP* returned
by \f3\%pfLayer::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfLayer\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

Since pfLayer is derived from pfGroup, pfGroup API may be used to
manipulate its child list.  OpenGL Performer considers child 0 to be the
base geometry and children 1 through N-1 to be decals.  Decals are
rendered in order such that decal[i+1] is drawn atop decal[i]. In other
words, decal[i+1] has visual priority over decal[i] even though they
are coplanar.
\f3\%pfLayer::setBase\fP and \f3\%pfLayer::setDecal\fP are convenience routines for
setting the base and decal children of the pfLayer in the common case
where there is only one decal child.  \f3\%pfLayer::getBase\fP and
\f3\%pfLayer::getDecal\fP return the base and first child of the pfLayer.

The \f2mode\fP argument to \f3\%pfLayer::setMode\fP specifies which hardware
mechanism to use and is one of:
.RS
.TP 5
\f3\%PFDECAL_BASE_DISPLACE\fP
Use slope-based polygon displacement to slightly displace the depth values
of decal geometry closer to the eye so they have visual priority. Each
decal is displaced more than its predecessor to properly resolve priority between
decals. The maximum number of decals is 8.
.TP
\f3\%PFDECAL_BASE_DISPLACE\fP | \f3\%PFDECAL_LAYER_OFFSET\fP
Use slope-based polygon displacement to slightly displace the depth values
of decal geometry closer to the eye so they have visual priority.
In addition, decal geometry is offset a constant amount to eliminate
anomalies caused by geometry which is nearly perpendicular to the view.
Each decal is displaced and offset more than its predecessor to
properly resolve priority between decals. The maximum number of decals is 8.
.TP
\f3\%PFDECAL_BASE_STENCIL\fP
Use the stencil-buffer logic to determine visibility of decal geometry.
There is no limit to the number of decals.
.TP
\f3\%PFDECAL_BASE_FAST\fP
Use a decaling mechanism appropriate to the hardware that produces the
fastest, but not necessarily the highest quality, decaling.
.TP
\f3\%PFDECAL_BASE_HIGH_QUALITY\fP
Use a decaling mechanism appropriate to the hardware that produces the
highest quality, but not necessarily the fastest, decaling.
.RE

The decal mode may also include the \f3\%PFDECAL_PLANE\fP token OR-ed with one of the above tokens
which will enable the use of the decal reference plane
(set with \f3\%pfLayer::setPlane\fP).
This can offer much higher quality of \f3\%PFDECAL_BASE_DISPLACE\fP type layers.

The default layer mode is \f3\%PFDECAL_BASE_FAST\fP.
\f3\%pfLayer::getMode\fP returns the mode of the pfLayer.

The different pfLayer modes offer quality-feature tradeoffs
listed in the table below:

.TS
center tab($);
C | C | C | C
L | L | L | L.
$\f3\%DISPLACE\fP$\f3\%STENCIL\fP$\f3\%(DISPLACE | OFFSET)\fP
_
Quality$medium$high$high
Sorting$enabled$disabled$enabled
Coplanarity$not required$required$not required
Multipass$ok$not ok$ok
Containment$not required$required$not required
.TE

The \f3\%STENCIL\fP mechanism offers the best image quality but at a
performance cost since the base and layer geometry must be rendered in
order, obviating any benefits of sorting by graphics state offered by
\f3\%pfChannel::setBinSort\fP. When multisampling on
RealityEngine, this mechanism
also significantly reduces pixel fill performance.
The performance impact is not as severe in InfiniteReality systems.
An additional
constraint is that \f3\%STENCIL\fPed layers must be coplanar or decal
geometry may incorrectly show through base geometry. A subtle but
important issue with \f3\%STENCIL\fPed layers is that they are unsuitable
for multipass renderings (projected textures) since multiple surfaces
are visible at a given pixel.  For proper results, each layer in the
"stack" must be completely contained within the boundaries of the
base geometry.

The \f3\%DISPLACE\fP mechanism offers the best performance since layers can
be sorted by graphics state, because the displace call itself is
usually faster than other mode changes, and because there is no pixel
fill rate penalty when it is in use. The \f3\%OFFSET\fP mechanism adds a
constant offset to the decal geometry. This mode can be very expensive
(RealityEngine) so when using it the database should be sorted with
\f3\%PFSTATE_DECAL\fP as the first sorting key
(see \f3\%pfChannel::setBinSort\fP).  Both \f3\%DISPLACE\fP
mechanisms do not require that geometry within a single layer be
coplanar and also produce a single visible surface at each pixel for
multipass renderings. The main disadvantage is that decal geometry may
incorrectly poke through other geometry due to the displacement of the
decal geometry. Another disadvantage is that the maximum number of
decals is 8.

The performance differences between \f3\%STENCIL\fP and \f3\%DISPLACE\fP modes
are hardware-dependent so some experimentation and benchmarking is
required to determine the most suitable method for your application.

\f3\%pfLayer::setPlane\fP sets a reference plane to be
used for all geometry under the pfLayer node.
\f3\%pfLayer::getPlane\fP returns the reference plane,
or NULL if no such plane is set on the pfLayer.

.SH NOTES

Using \f3\%PFDECAL_BASE_STENCIL\fP for pfLayer nodes requires several
steps for proper operation. First, the graphics hardware must
support stencil plane rendering. Secondly, the graphics context must
be configured with at least one stencil plane, and the lowest order
bit of the allocated stencil planes be reserved for OpenGL Performer
use.  \f3\%pfInitGfx\fP configures the graphics context in just this way.

The use of displacements for rendering coplanar geometry can cause
visual artifacts such as decals "Z fighting" or "flimmering" when
viewed perpendicularly, and the "punching through" of decals that
should mask base geometry when both are viewed obliquely.  The former
artifact can be eliminated by specifying \f3\%PFDECAL_BASE_DISPLACE\fP |
\f3\%PFDECAL_LAYER_OFFSET\fP as the layer mode. Subtle details of this
rendering mode are described in the \f3\%pfDecal\fP man page.
If unacceptable artifacts still persist, the database should be
modified to eliminate the need for coplanar rendering or
\f3\%PFDECAL_BASE_HIGH_QUALITY\fP should be used.

When using \f3\%PFDECAL_LAYER_OFFSET\fP, the minimum depth buffer range
set with \f3\%lsetdepth\fP must be incremented an extra 1024 * max layers
so the negative displacement of the layers does not wrap.
\f3\%pfInitGfx\fP does this automatically.
.SH BUGS

OpenGL Performer properly renders coplanar geometry only on machines that have
a hardware stencil buffer allocated or which support displaced polygon
rendering.
.SH SEE ALSO
pfChannel,
pfDecal,
pfGroup,
pfInitGfx,
pfLookupNode,
pfNode,
pfDelete
