'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLightModel" "3pf"
.SH NAME
.upperok
.B pfLightModel,
.B pfGetCurLModel
\- 
Create, modify and query lighting model
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfLight.h>
.nf
.fi
.TP
\ 
\f3\%pfLightModel::pfLightModel\fP()
.nf
.fi
.TP
static pfType *
\f3\%pfLightModel::getClassType\fP(void);
.nf
.fi
.TP
static void
\f3\%pfLightModel::apply\fP(void);
.nf
.fi
.TP
void
\f3\%pfLightModel::setAtten\fP(float\ a0,
'in +2
'll -2
float\ a1,
float\ a2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLightModel::getAtten\fP(float\ *a0,
'in +2
'll -2
float\ *a1,
float\ *a2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLightModel::setLocal\fP(int\ l);
.nf
.fi
.TP
int
\f3\%pfLightModel::getLocal\fP(void);
.nf
.fi
.TP
void
\f3\%pfLightModel::setTwoSide\fP(int\ t);
.nf
.fi
.TP
int
\f3\%pfLightModel::getTwoSide\fP(void);
.nf
.fi
.TP
void
\f3\%pfLightModel::setAmbient\fP(float\ r,
'in +2
'll -2
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLightModel::getAmbient\fP(float\ *r,
'in +2
'll -2
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
pfLightModel *
\f3\%pfGetCurLModel\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLightModel\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfLightModel\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLightModel\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfLightModel defines characteristics of the hardware lighting model
used to illuminate geometry.
See the OpenGL \f3\%glLightModel(3g)\fP man page for more details on
lighting environments and individual parameters.

\f3\%new\fP(arena) allocates a pfLightModel from the specified memory
arena, or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP
allocates a pfLightModel from the default memory arena (see
\f3\%pfGetSharedArena\fP).  Like other pfObjects, pfLightModels cannot be
created statically, automatically on the stack or in arrays.
pfLightModels should be deleted with \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfLightModel::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLightModel\fP.  The \f3\%pfType\fP* returned
by \f3\%pfLightModel::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfLightModel\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLightModel::setAtten\fP sets the lighting attenuation factors for the pfLightModel.
\f2a1\fP, \f2a2\fP, and \f2a3\fP specify the constant, linear, and
second-order attenuation factors, respectively.  These factors are
associated with all non-infinite lights.  The default values for
constant, linear, and quadratic attenuation factors are 1.0, 0.0,
and 0.0, respectively, effectively disabling each.
Note that OpenGL light attenuation is done per-light.
See the \f3\%pfLight::setAtten\fP man page for more
information.

\f3\%pfLightModel::getAtten\fP copies the lighting attenuation factors for the pfLightModel
into the parameters \f2a1\fP, \f2a2\fP, and \f2a3\fP.

\f3\%pfLightModel::setLocal\fP specifies whether the light reflection calculations
are to be done based on a local or infinite viewpoint.  The default is
\f3\%PF_OFF\fP signifying an infinite viewer for the light model.  In
general, local lighting is more expensive than infinite lighting.

\f3\%pfLightModel::getLocal\fP returns a boolean value signifying whether or not
the effective viewpoint in the pfLightModel is a local viewpoint.

\f3\%pfLightModel::setTwoSide\fP specifies whether two-sided lighting is to be used
in the given light model.  The default is \f3\%PF_OFF\fP, disabling two-sided
lighting.  See the OpenGL \f3\%glLightModel\fP
man page for more details on two-sided lighting.

\f3\%pfLightModel::getTwoSide\fP returns the setting of the pfLightModel's two-sided
lighting mode.

\f3\%pfLightModel::setAmbient\fP receives three floating point values in the range
from 0.0 through 1.0 to set the red, green, and blue, values for the
amount of the ambient light associated with the scene for the given
light model.

\f3\%pfLightModel::getAmbient\fP copies the red, green, and blue components of
the ambient in the given light model into the parameters \f2r\fP, \f2g\fP,
and \f2b\fP, respectively.  The default value for the ambient red, green,
and blue light components is 0.2.

\f3\%pfLightModel::apply\fP causes the pfLightModel, with its current settings, to become
the current lighting model.  When lighting is enabled (See below), this
lighting model will be applied to all geometry drawn after
\f3\%pfLightModel::apply\fP is called.  Modifications to the pfLightModel, such as changing
the ambient color, or setting two-sided lighting, will not be applied
until \f3\%pfLightModel::apply\fP is called with the pfLightModel.

For geometry to be illuminated, the following must be true:
.RS
.TP 5
1.
Lighting must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_LIGHTING\fP)
.TP
2.
A pfLightModel must be applied: \f3\%pfLightModel::apply\fP
.TP
3.
A pfMaterial must be applied: \f3\%pfMaterial::apply\fP
.TP
4.
One or more pfLights must be on: \f3\%pfLight::on\fP
.TP
5.
Illuminated geometry must have normals: \f3\%pfGeoSet::setAttr\fP, \f3\%PFGS_NORMAL3\fP
.RE

The lighting model state element is identified by the
\f3\%PFSTATE_LIGHTMODEL\fP token.  Use this token with \f3\%pfGeoState::setAttr\fP to
set the lighting model of a pfGeoState and with \f3\%pfOverride\fP to
override subsequent lighting model changes.:
.SH EXAMPLES
Example 1:
.Ex
.nf

lmodel->setTwoSide(PF_ON);

/* Set up two-sided lighting pfGeoState */
gstate->setMode(PFSTATE_ENLIGHTING, PF_ON);
gstate->setAttr(PFSTATE_LIGHTMODEL, lmodel);
gstate->setAttr(PFSTATE_FRONTMTL, mtl);
gstate->setAttr(PFSTATE_BACKMTL, mtl);
gstate->setMode(PFSTATE_CULLFACE, PF_OFF);

/* Attach gstate to gset */
gset->setGState(gstate);

/* Set normal array. 'gset' is non-indexed */
gset->setAttr(PFGS_NORMAL3, PFGS_PER_VERTEX, norms, NULL);

/* Draw lit, two-sided gset */
gset->draw();
.Ee
.fi
.na


Example 2:
.Ex
.nf

lmodel->apply();

/* Override so that all geometry is lit with 'lmodel' */
pfOverride(PFSTATE_LIGHTMODEL, PF_ON);
.Ee
.fi
.na


\f3\%pfLightModel::apply\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP,
\f3\%pfLightModel::apply\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDispList::draw\fP.

\f3\%pfGetCurLModel\fP returns a pointer to the currently active
pfLightModel, or NULL if there is no active pfLightModel.
.SH SEE ALSO
pfDelete,
pfDispList,
pfGeoState,
pfLight,
glLightModel,
pfMaterial,
pfObject,
pfState,
lmbind,
lmcolor,
lmdef
