'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfList" "3pf"
.SH NAME
.upperok
.B pfList
\- 
Dynamically-sized list utility
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfList.h>
.nf
.fi
.TP
\ 
\f3\%pfList::pfList\fP();
.nf
.fi
.TP
\ 
\f3\%pfList::pfList\fP(int\ eltSize,
'in +2
'll -2
int\ listLength);
.in
.ll
.nf
.fi
.TP
static pfType *
\f3\%pfList::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfList::add\fP(void*\ elt);
.nf
.fi
.TP
void
\f3\%pfList::combine\fP(const\ pfList\ *a,
'in +2
'll -2
const\ pfList\ *b);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfList::fastRemove\fP(void*\ elt);
.nf
.fi
.TP
void
\f3\%pfList::fastRemoveIndex\fP(int\ index);
.nf
.fi
.TP
void *
\f3\%pfList::get\fP(int\ index);
.nf
.fi
.TP
const void **
\f3\%pfList::getArray\fP(void);
.nf
.fi
.TP
int
\f3\%pfList::getArrayLen\fP(void);
.nf
.fi
.TP
int
\f3\%pfList::getEltSize\fP(void);
.nf
.fi
.TP
int
\f3\%pfList::getNum\fP(void);
.nf
.fi
.TP
void
\f3\%pfList::insert\fP(int\ index,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfList::move\fP(int\ index,
'in +2
'll -2
void\ *elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfList::setArrayLen\fP(int\ len);
.nf
.fi
.TP
void
\f3\%pfList::setNum\fP(int\ num);
.nf
.fi
.TP
int
\f3\%pfList::remove\fP(void*\ elt);
.nf
.fi
.TP
void
\f3\%pfList::removeIndex\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfList::replace\fP(void*\ old,
'in +2
'll -2
void*\ new);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfList::reset\fP(void);
.nf
.fi
.TP
int
\f3\%pfList::search\fP(void*\ elt);
.nf
.fi
.TP
void
\f3\%pfList::set\fP(int\ index,
'in +2
'll -2
void\ *elt);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfList\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfList\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfList\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION


A pfList is a dynamically-sized array of arbitrary, but
homogeneously-sized, elements.

The default constructor \f3\%pfList\fP creates a list with an element size
of sizeof(void *) bytes.
The element size is fixed at creation time and cannot be
later changed.  Another constructor is provided that allows the
element size \f2eltSize\fP and initial allocated length \f2listLength\fP
for the pfList.  \f3\%new\fP(arena) allocates a pfList from the specified
memory arena, or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP
allocates a pfList from the default memory arena (see
\f3\%pfGetSharedArena\fP).  Like other pfObjects, pfLists cannot be
created statically, automatically on the stack or in arrays.  pfLists
should be deleted with \f3\%pfDelete\fP rather than the delete operator.

\f3\%pfList::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfList\fP.  The \f3\%pfType\fP* returned
by \f3\%pfList::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfList\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

A pfList dynamically increases its array size by a factor of 2 and
zeros the additional memory whenever it runs out of array memory.  This
way the array size quickly reaches its final size without many
reallocations of memory.  However, some memory (up to one half of the
total allocation) at the end of the array may be wasted.  If you know
the exact number of elements in the array, you can specify the pfList
array length either when creating it (the \f2listLength\fP argument to
\f3\%new pfList\fP) or with \f3\%pfList::setArrayLen\fP.  \f3\%pfList::getArrayLen\fP
returns the current array length of the pfList.

Example 1:
.Ex
.nf

/* Fit list's array to its current number of elements */
list->setArrayLen(list->getNum());
.Ee
.fi
.na


\f3\%pfList::set\fP sets the \f2index\fPth element of the pfList to \f2elt\fP.  The list
is automatically grown if \f2index\fP is beyond the current array
length.

\f3\%pfList::get\fP returns the element of the pfList at index \f2index\fP or 0 if
\f2index\fP is out of bounds.

\f3\%pfList::add\fP appends \f2elt\fP to the pfList and automatically grows the pfList
if necessary.

\f3\%pfList::remove\fP removes \f2elt\fP from the pfList and shifts the array down
over the vacant spot, e.g. - if \f2elt\fP had index 0, then index 1
becomes index 0, index 2 becomes index 1 and so on.  \f3\%pfList::remove\fP
returns the index of \f2elt\fP if \f2elt\fP was actually removed and -1 if
it was not found in the list. \f3\%pfList::removeIndex\fP
removes the \f2index\fPth element of the pfList, and like \f3\%pfList::remove\fP, shifts the array down over the vacant spot.

\f3\%pfList::fastRemove\fP removes \f2elt\fP from
the pfList but does not shift the array; instead
it places the last element of the array into the vacated location so it
does not preserve the list ordering.
\f3\%pfList::fastRemoveIndex\fP replaces the
\f2index\fPth element with the last element of the pfList.

Note that both
\f3\%pfList::remove\fP and \f3\%pfList::fastRemove\fP linearly search the array for \f2elt\fP
and remove only the first matching element.  To remove all occurrences
of \f2elt\fP do the following:
.Ex
.nf

while (list->remove(elt) >= 0)
    /* empty */ ;
.Ee
.fi
.na


\f3\%pfList::search\fP returns the index of \f2elt\fP if \f2elt\fP was found in
the pfList and -1 otherwise.

\f3\%pfList::insert\fP inserts \f2elt\fP before the array element with index
\f2index\fP.  \f2index\fP must be within the range [0 ..
\f3\%list->getNum\fP()].

\f3\%pfList::move\fP deletes \f2elt\fP from its current location and
inserts before the array element with index
\f2index\fP.  \f2index\fP must be within the range [0 ..
\f3\%list->getNum\fP()] or else (-1) is returned
and no move is executed.
If \f2elt\fP is not already in the pfList, (-1) is returned
and \f2elt\fP is not inserted into the list. Otherwise, \f2index\fP is returned
to indicate success.

\f3\%pfList::replace\fP replaces the first instance of \f2old\fP with \f2new\fP and
returns the index of \f2old\fP if it was found in the pfList and -1
otherwise.

\f3\%pfList::getNum\fP returns the number of elements in the pfList. (Actually,
\f2list\fP may have holes in its array so \f3\%pfList::getNum\fP technically should
be considered as returning the maximum index of all elements in the pfList.)

\f3\%pfList::reset\fP zeros the pfList's array and resets the number of
elements to 0.  It does not resize the array.

\f3\%pfList::combine\fP sets the pfList to \f2a\fP appended with \f2b\fP.  the pfList
may be the same as \f2a\fP or \f2b\fP.  Lists must have equal element sizes
to be combined.

For quick access to the list array, \f3\%pfList::getArray\fP returns a
pointer to the internal array of the pfList.  Care should be taken with
this routine since out of bounds range checking provided by pfList API
is bypassed.  If you add elements to the pfList then use \f3\%pfList::setNum\fP to set
the number of elements of the pfList.
.SH BUGS

pfLists currently only support an element size of \f3\%sizeof(void*)\fP.
.SH SEE ALSO
pfDelete
