'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMatStack" "3pf"
.SH NAME
.upperok
.B pfMatStack
\- 
Create and manipulate a matrix stack.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfLinMath.h>
.nf
.fi
.TP
\ 
\f3\%pfMatStack::pfMatStack\fP();
.nf
.fi
.TP
\ 
\f3\%pfMatStack::pfMatStack\fP(int\ size);
.nf
.fi
.TP
static pfType *
\f3\%pfMatStack::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfMatStack::reset\fP(void);
.nf
.fi
.TP
int
\f3\%pfMatStack::push\fP(void);
.nf
.fi
.TP
int
\f3\%pfMatStack::pop\fP(void);
.nf
.fi
.TP
void
\f3\%pfMatStack::preMult\fP(const\ pfMatrix\ &m);
.nf
.fi
.TP
void
\f3\%pfMatStack::postMult\fP(const\ pfMatrix\ &m);
.nf
.fi
.TP
void
\f3\%pfMatStack::load\fP(const\ pfMatrix\ &m);
.nf
.fi
.TP
void
\f3\%pfMatStack::get\fP(pfMatrix\ &m);
.nf
.fi
.TP
pfMatrix *
\f3\%pfMatStack::getTop\fP(void);
.nf
.fi
.TP
int
\f3\%pfMatStack::getDepth\fP(void);
.nf
.fi
.TP
void
\f3\%pfMatStack::preTrans\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatStack::postTrans\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatStack::preRot\fP(float\ degrees,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatStack::postRot\fP(float\ degrees,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatStack::preScale\fP(float\ xs,
'in +2
'll -2
float\ ys,
float\ zs);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatStack::postScale\fP(float\ xs,
'in +2
'll -2
float\ ys,
float\ zs);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfMatStack\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfMatStack\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfMatStack\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

These routines allow the creation and manipulation of a stack of 4x4 matrices.

\f3\%new\fP(arena) allocates a pfMatStack from the specified memory arena,
or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfMatStack from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfMatStacks cannot be created statically,
automatically on the stack or in arrays.  The default constructor
creates a matrix stack 64 deep.  Another constructor is provided that
takes a \f2size\fP argument.  pfMatStacks should be deleted with
\f3\%pfDelete\fP rather than the delete operator.
\f2size\fP is the number of pfMatrix's in the matrix stack.  The initial
depth is 1 and the top of stack is the identity matrix.

\f3\%pfMatStack::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfMatStack\fP.  The \f3\%pfType\fP* returned
by \f3\%pfMatStack::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfMatStack\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfMatStack::reset\fP sets the stack depth to 1
and sets the top of stack to the identity matrix.

\f3\%pfMatStack::push\fP pushes down the specified
matrix stack duplicating the top.
\f3\%pfMatStack::pop\fP pops the matrix stack.
Attempting to pop a matrix stack containing only a single element or
pushing past the maximum depth causes a warning and leaves the stack
unchanged.

\f3\%pfMatStack::preMult\fP pre-multiplies the top
of the stack by the matrix \f2m\fP and replaces the top of the stack with
the product.  Thus if \f2T\fP is the top of the stack, the operation
replaces \f2T\fP with \f2m\fP*\f2T\fP.  This order corresponds to that used
by OpenGL's \f2glMultMatrix\fP.
\f3\%pfMatStack::postMult\fP operates similarly
but using post-multiplication, calculating \f2T\fP*\f2m\fP instead.

\f3\%pfMatStack::load\fP replaces the top of the stack
with the matrix \f2m\fP.

\f3\%pfMatStack::get\fP copies the top of the matrix
into the matrix \f2m\fP.  \f3\%pfMatStack::getTop\fP
returns a pointer to the top of the matrix stack.

\f3\%pfMatStack::getDepth\fP returns the current
depth of the stack.  Initially the depth is \f21\fP.

The following transformations pre- and post- multiply the top of the
matrix stack:

\f3\%pfMatStack::preTrans\fP and
\f3\%pfMatStack::postTrans\fP respectively pre-
and post- multiply the top of the matrix stack by the translation
matrix generated by the coordinates \f2x\fP, \f2y\fP and \f2z\fP.  (See
\f3\%pfMatrix::makeTrans\fP).

\f3\%pfMatStack::preRot\fP and
\f3\%pfMatStack::postRot\fP respectively pre- and
post- multiply the top of the matrix stack by the rotation by
\f2degrees\fP about the axis defined by (\f2x\fP, \f2y\fP, \f2z\fP).  (See
\f3\%pfMatrix::makeRot\fP).  The results are undefined
if the vector (\f2x\fP, \f2y\fP, \f2z\fP) is not normalized.

\f3\%pfMatStack::preScale\fP and
\f3\%pfMatStack::postScale\fP respectively pre-
and post- multiply the top of the matrix stack by a scaling matrix.
(See \f3\%pfMatrix::makeScale\fP).  The matrix
scales by \f2x\fP in the X direction, \f2y\fP and the Y direction and \f2z\fP
in the Z direction.
.SH NOTES

\f3\%pfMatStack::preRot\fP and
\f3\%pfMatStack::postRot\fP use pfSinCos which is
faster than the libm counterpart, but has less resolution.

pfMatStack is not related to the GL matrix stack.

IMPORTANT: The argument order of degrees and axis to the
\f3\%pfMatStack::preRot\fP are not the same as to
the corresponding routine \f3\%pfRotMStack\fP in the IRIS Performer 1.0
and IRIS Performer 1.1 releases. This change was first introduced in
the IRIS Performer 1.2 release and is present in subsequent releases of
OpenGL Performer.

.SH SEE ALSO
pfDelete,
pfMakeRotMat,
pfMakeScaleMat,
pfMakeTransMat,
pfMatrix,
pfSinCos,
multmatrix
