'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMaterial" "3pf"
.SH NAME
.upperok
.B pfMaterial,
.B pfGetCurMtl
\- 
Create, modify and query a material.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfMaterial.h>
.nf
.fi
.TP
\ 
\f3\%pfMaterial::pfMaterial\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfMaterial::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfMaterial::setSide\fP(int\ side);
.nf
.fi
.TP
int
\f3\%pfMaterial::getSide\fP(void);
.nf
.fi
.TP
void
\f3\%pfMaterial::setAlpha\fP(float\ alpha);
.nf
.fi
.TP
float
\f3\%pfMaterial::getAlpha\fP(void);
.nf
.fi
.TP
void
\f3\%pfMaterial::setShininess\fP(float\ shininess);
.nf
.fi
.TP
float
\f3\%pfMaterial::getShininess\fP(void);
.nf
.fi
.TP
void
\f3\%pfMaterial::setColor\fP(int\ color,
'in +2
'll -2
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMaterial::getColor\fP(int\ color,
'in +2
'll -2
float\ *r,
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMaterial::setColorMode\fP(int\ side,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMaterial::getColorMode\fP(int\ side);
.nf
.fi
.TP
void
\f3\%pfMaterial::apply\fP(void);
.nf
.fi
.TP
pfMaterial *
\f3\%pfGetCurMtl\fP(int\ side);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfMaterial\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfMaterial\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfMaterial\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

In conjunction with other lighting parameters, a pfMaterial defines the
appearance of illuminated geometry.  A pfMaterial defines the
reflectance characteristics of surfaces such as diffuse color and
shininess.
See the OpenGL \f3\%glMaterial(3g)\fP man page for
more details on materials parameters.

\f3\%new\fP(arena) allocates a pfMaterial from the specified memory arena,
or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfMaterial from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfMaterials cannot be created statically,
automatically on the stack or in arrays.  pfMaterials should be
deleted with \f3\%pfDelete\fP rather than the delete operator.

\f3\%pfMaterial::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfMaterial\fP.  The \f3\%pfType\fP* returned
by \f3\%pfMaterial::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfMaterial\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfMaterial::setSide\fP receives a symbolic token, one of \f3\%PFMTL_FRONT\fP,
\f3\%PFMTL_BACK\fP, or \f3\%PFMTL_BOTH\fP indicating which side of a polygon
the material should affect.  If lighting is to affect the back sides of
polygons, two-sided lighting must be enabled.  Two-sided lighting
requires a two-sided pfLightModel (see \f3\%pfLightModel::setTwoSide\fP) and that
face culling be disabled (see \f3\%pfCullFace\fP) so that backfacing
polygons are not rejected.

\f3\%pfMaterial::getSide\fP returns the side(s) affected by the pfMaterial.

\f3\%pfMaterial::setAlpha\fP specifies the alpha of the pfMaterial in the range 0.0 through
1.0.  If transparency is enabled (see \f3\%pfTransparency\fP), a material
whose alpha is < 1.0 and whose color mode is \f3\%PFMTL_CMODE_OFF\fP will
be transparent with alpha of 1.0 being completely opaque and 0.0 being
completely transparent.  The default alpha value is 1.0 or completely
opaque. For non-homogeneous transparency, use a color mode
other than \f3\%PFMTL_CMODE_OFF\fP and transparency will be taken
from geometry colors. In OpenGL, \f3\%pfMaterial::setAlpha\fP
sets the alpha of the AMBIENT, DIFFUSE, EMISSIVE, and SPECULAR colors.
However, it is the DIFFUSE alpha that determines the resulting alpha value from the
lighting calculation.

\f3\%pfMaterial::getAlpha\fP returns the alpha of the pfMaterial.

\f3\%pfMaterial::setShininess\fP specifies the specular scattering exponent, or the
shininess, of the given material.  It receives a floating point value in
the range 0.0 to 128.0.  The default shininess value is 0.0, which
effectively disables specular reflection.

\f3\%pfMaterial::getShininess\fP returns the shininess of the pfMaterial.

\f3\%pfMaterial::setColor\fP sets a specific color of the pfMaterial.  \f2color\fP indicates
which color is to be set by \f2r\fP, \f2g\fP, and \f2b\fP and is one of
\f3\%PFMTL_AMBIENT\fP, \f3\%PFMTL_DIFFUSE\fP, \f3\%PFMTL_EMISSION\fP, or
\f3\%PFMTL_SPECULAR\fP.  The default colors are:

.TS
center tab($) ;
c | c c c
lB | c c c .
Light Component$Red$Green$Blue
_
PFMTL_AMBIENT$0.2$0.2$0.2
PFMTL_DIFFUSE$0.8$0.8$0.8
PFMTL_EMISSION$0.0$0.0$0.0
PFMTL_SPECULAR$0.0$0.0$0.0
.TE

\f3\%pfMaterial::getColor\fP copies the \f2color\fP of the pfMaterial into \f2r\fP, \f2g\fP,
and \f2b\fP.  \f2color\fP may be one of  \f3\%PFMTL_AMBIENT\fP,
\f3\%PFMTL_DIFFUSE\fP, \f3\%PFMTL_EMISSION\fP, or \f3\%PFMTL_SPECULAR\fP.

\f3\%pfMaterial::setColorMode\fP specifies how pfGeoSet and Graphics Library
color commands affect the pfMaterial.
\f2side\fP is the same symbolic token used for \f3\%pfMaterial::setSide\fP and
indicates which side \f2mode\fP affects.  \f2mode\fP is a symbolic token
specifying which color property of the material is replaced by color
commands:
.IP
\f3\%PFMTL_CMODE_AMBIENT_AND_DIFFUSE\fP, RGB color commands will replace the
DIFFUSE and AMBIENT color property of the current material. This is
the default pfMaterial color mode.

\f3\%PFMTL_CMODE_AMBIENT\fP, RGB color commands will replace the AMBIENT color
property of the current material.

\f3\%PFMTL_CMODE_DIFFUSE\fP, RGB color commands will replace the DIFFUSE color
property of the current material.

\f3\%PFMTL_CMODE_EMISSION\fP, RGB color commands will replace the EMISSION color
property of the current material.

\f3\%PFMTL_CMODE_SPECULAR\fP, RGB color commands will replace the SPECULAR color
property of the current material.

\f3\%PFMTL_CMODE_OFF\fP, RGB color commands will be ignored, i.e., overridden
by the material colors.

\f3\%PFMTL_CMODE_COLOR\fP, RGB color commands will replace the current color.
If lighting is enabled, lit material colors are always used.
\f3\%PFMTL_CMODE_COLOR\fP is not available in OpenGL and will be treated as \f3\%PFMTL_CMODE_OFF\fP.
.PP

Materials do not have a single alpha; rather, the AMBIENT, DIFFUSE, SPECULAR,
and EMISSIVE colors have individual alphas which are replaced along with
red, green, and blue when the appropriate color mode is enabled.

When enabled, \f3\%pfMaterial::setColorMode\fP can offer
substantial performance gains by drastically reducing the number of different pfMaterials
required by a database. Instead of using a different pfMaterial for
every unique material color, \f3\%pfMaterial::setColorMode\fP can take a color
component from the geometry, rather than from the pfMaterial. For example,
if \f2mode\fP is \f3\%PFMTL_CMODE_DIFFUSE\fP, then the diffuse color component of
the pfMaterial is ignored. Instead, the color specified by a pfGeoSet
or the color specified through the Graphics Library (e.g.
\f3\%glColor(3g)\fP in OpenGL) becomes the new diffuse color.
However, \f3\%pfMaterial::getColor\fP
will still return the original diffuse color.

The the pfMaterial of \f2mtl\fP must be
enabled (other than \f3\%PFMTL_CMODE_COLOR\fP or \f3\%PFMTL_CMODE_OFF\fP)
for the colors (\f3\%PFGS_COLOR4\fP) of any pfGeoSets which use
the pfMaterial to have effect. Note that the only way
to display per-vertex colors on lit pfGeoSets is to enable
\f3\%pfMaterial::setColorMode\fP on the
pfMaterial used by the pfGeoSets; specifically, pfGeoSets do not support a
different pfMaterial for each vertex.

The default color mode is \f3\%PFMTL_CMODE_AMBIENT_AND_DIFFUSE\fP which causes
both diffuse and ambient material colors to be replaced by geometry color commands.
Specifically, this setting allows colors specified by pfGeoSets to have
effect.  When lighting is disabled, the color mode is set to
\f3\%PFMTL_CMODE_OFF\fP.

\f3\%pfMaterial::getColorMode\fP returns
the color mode of the pfMaterial
corresponding to \f2side\fP.

\f3\%pfMaterial::apply\fP makes the pfMaterial the current pfMaterial.  If lighting is
enabled (see below), the pfMaterial will be applied to all geometry drawn
after \f3\%pfMaterial::apply\fP is called.  Modifications to the pfMaterial, such as
changing the diffuse color, will not be applied until \f3\%pfMaterial::apply\fP is
called with the pfMaterial.

For geometry to be illuminated the following must be true:
.RS
.TP 5
1.
Lighting must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_LIGHTING\fP),
.TP
2.
A pfLightModel must be applied: \f3\%pfLightModel::apply\fP,
.TP
3.
A pfMaterial must be applied: \f3\%pfMaterial::apply\fP,
.TP
4.
One or more pfLights must be on for diffuse and specular effects:
\f3\%pfLight::on\fP,
.TP
5.
Illuminated geometry must have normals for diffuse and specular effects:
\f3\%pfGeoSet::setAttr\fP, \f3\%PFGS_NORMAL3\fP. Note that ambient
and emissive lighting does not require normals.
.RE

The front and back material state elements are identified by the
\f3\%PFSTATE_FRONTMTL\fP and \f3\%PFSTATE_BACKMTL\fP tokens.  Use these tokens
with \f3\%pfGeoState::setAttr\fP to set the materials of a pfGeoState and with
\f3\%pfOverride\fP to override subsequent material changes.:

Example 1: Define a 50% transparent, shiny red plastic material
.Ex
.nf


/* Make it red */
redMtl->setColor(PFMTL_DIFFUSE, 1.0f, 0.0f, 0.0f);

/* Disable color mode so the PFMTL_DIFFUSE color is not ignored */
redMtl->setColorMode(PFMTL_FRONT, PFMTL_CMODE_OFF);

/* Make it shiny */
redMtl->setColor(PFMTL_SPECULAR, 1.0f, 1.0f, 1.0f);
redMtl->setShininess(16.0f);

/* Make it 50% transparent */
redMtl->setAlpha(0.5f);

/* Set the front material of a pfGeoState */
gstate->setMode(PFSTATE_ENLIGHTING, PF_ON);
gstate->setMode(PFSTATE_TRANSPARENCY, PFTR_ON);
gstate->setAttr(PFSTATE_FRONTMTL, redMaterial);

/* Attach gstate to gset */
gset->setGState(gstate);

/* Set normal array. 'gset' is non-indexed */
gset->setAttr(PFGS_NORMAL3, PFGS_PER_VERTEX, norms, NULL);

/* Draw transparent, shiny red gset */
gset->draw();
.Ee
.fi
.na


Example 2:
.Ex
.nf

mtl->setSide(PFMTL_FRONT);
mtl->apply();

/* Override so that all geometry uses 'mtl' as front material */
pfOverride(PFSTATE_FRONTMTL, PF_ON);
.Ee
.fi
.na


When setting the pfMaterial(s) of a pfGeoState using \f3\%pfGeoState::setAttr\fP,
the side of the material is ignored.  Instead, the \f3\%PFSTATE\fP token
defines which side the material should be applied to.  For example,
.Ex
.nf

gstate->setAttr(PFSTATE_FRONTMTL, mtl)
.Ee
.fi
.na

will ensure that \f2mtl\fP is always applied to the front side of polygons
after \f2gstate\fP is applied.

\f3\%pfMaterial::apply\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP,
\f3\%pfMaterial::apply\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDispList::draw\fP.

\f3\%pfGetCurMtl\fP receives a symbolic token specifying the side of
interest, one of \f3\%PFMTL_FRONT\fP or \f3\%PFMTL_BACK\fP, and returns a
pointer to the currently active material for that side, or NULL if
there is no active pfMaterial.

.SH SEE ALSO
lmbind,
lmcolor,
lmdef,
pfCullFace,
pfDelete,
pfDispList,
pfEnable,
pfGSetAttr,
pfGeoState,
pfLight,
pfLightModel,
pfLightOn,
pfLModelTwoSide,
pfObject,
pfState,
pfTransparency
