'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMatrix" "3pf"
.SH NAME
.upperok
.B pfMatrix
\- 
Set and operate on 4x4 matrices.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ float&\ \ \ 'u
#include <Performer/pr/pfLinMath.h>
.nf
.fi
.TP
void*
\f3\%pfMatrix::operator new\fP(size_t);
.nf
.fi
.TP
void*
\f3\%pfMatrix::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfMatrix::pfMatrix\fP();
.nf
.fi
.TP
\ 
\f3\%pfMatrix::pfMatrix\fP(float\ a00,
'in +2
'll -2
float\ a01,
float\ a02,
float\ a03,
float\ a10,
float\ a11,
float\ a12,
float\ a13,
float\ a20,
float\ a21,
float\ a22,
float\ a23,
float\ a30,
float\ a31,
float\ a32,
float\ a33);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::makeIdent\fP(void);
.nf
.fi
.TP
void
\f3\%pfMatrix::makeTrans\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::makeScale\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::makeRot\fP(float\ degrees,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::makeQuat\fP(const\ pfQuat&\ q);
.nf
.fi
.TP
void
\f3\%pfMatrix::makeEuler\fP(float\ h,
'in +2
'll -2
float\ p,
float\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::makeVecRotVec\fP(const\ pfVec3&\ v1,
'in +2
'll -2
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::makeCoord\fP(const\ pfCoord\ *c);
.nf
.fi
.TP
void
\f3\%pfMatrix::getOrthoQuat\fP(pfQuat&\ dst);
.nf
.fi
.TP
void
\f3\%pfMatrix::getOrthoCoord\fP(pfCoord*\ dst);
.nf
.fi
.TP
int
\f3\%pfMatrix::getMatType\fP(void);
.nf
.fi
.TP
void
\f3\%pfMatrix::setRow\fP(int\ row,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::getRow\fP(int\ row,
'in +2
'll -2
float\ *x,
float\ *y,
float\ *z,
float\ *w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::setCol\fP(int\ col,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::getCol\fP(int\ col,
'in +2
'll -2
float\ *x,
float\ *y,
float\ *z,
float\ *w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::setRow\fP(int\ row,
'in +2
'll -2
const\ pfVec3&\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::getRow\fP(int\ row,
'in +2
'll -2
pfVec3&\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::setCol\fP(int\ col,
'in +2
'll -2
const\ pfVec3&\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::getCol\fP(int\ col,
'in +2
'll -2
pfVec3&\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::set\fP(const\ float\ *m);
.nf
.fi
.TP
void
\f3\%pfMatrix::copy\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::add\fP(const\ pfMatrix&\ m1,
'in +2
'll -2
const\ pfMatrix&\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::sub\fP(const\ pfMatrix&\ m1,
'in +2
'll -2
const\ pfMatrix&\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::scale\fP(float\ s,
'in +2
'll -2
pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::transpose\fP(pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::mult\fP(const\ pfMatrix&\ m1,
'in +2
'll -2
const\ pfMatrix&\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::preMult\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::postMult\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::preTrans\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z,
pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::postTrans\fP(const\ pfMatrix&\ m,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::preRot\fP(float\ degrees,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::postRot\fP(const\ pfMatrix&\ mat,
'in +2
'll -2
float\ degrees,
float\ x,
float\ y,
float\ z,
);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::preScale\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z,
pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMatrix::postScale\fP(const\ pfMatrix&\ m,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMatrix::invertFull\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::invertAff\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::invertOrtho\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::invertOrthoN\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
int
\f3\%pfMatrix::invertIdent\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
void
\f3\%pfMatrix::equal\fP(const\ pfMatrix&\ m2);
.nf
.fi
.TP
void
\f3\%pfMatrix::almostEqual\fP(const\ pfMatrix&\ m2,
'in +2
'll -2
float\ tol);
.in
.ll
.nf
.fi
.TP
float&
\f3\%pfMatrix::operator []\fP(int\ i);
.nf
.fi
.TP
const float&
\f3\%pfMatrix::operator []\fP(int\ i);
.nf
.fi
.TP
int
\f3\%pfMatrix::operator ==\fP(const\ pfMatrix&\ v);
.nf
.fi
.TP
pfMatrix
\f3\%pfMatrix::operator +\fP(const\ pfMatrix&\ v);
.nf
.fi
.TP
pfMatrix
\f3\%pfMatrix::operator -\fP(const\ pfMatrix&\ v);
.nf
.fi
.TP
pfMatrix&
\f3\%pfMatrix::operator +=\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
pfMatrix&
\f3\%pfMatrix::operator -=\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
pfMatrix&
\f3\%pfMatrix::operator =\fP(const\ pfMatrix&\ v);
.nf
.fi
.TP
pfMatrix&
\f3\%pfMatrix::operator *=\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
pfMatrix
\f3\%pfMatrix::operator *=\fP(const\ pfMatrix&\ m);
.nf
.fi
.TP
pfMatrix
\f3\%pfMatrix::operator *\fP(const\ pfMatrix&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.nf
.fi
.TP
pfMatrix
\f3\%pfMatrix::operator *\fP(float\ d,
'in +2
'll -2
const\ pfMatrix&\ v);
.in
.ll
.nf
.fi
.TP
pfMatrix
\f3\%pfMatrix::operator /\fP(const\ pfMatrix&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.fi

.Ex
.nf

struct pfCoord
{
   pfVec3       xyz;
   pfVec3       hpr;
};

struct pfMatrix
{
   float	mat[4][4];
};
.Ee
.fi
.na

.SH DESCRIPTION


Routines for pfMatrix, a 4X4 matrix.

Most accesses to pfMatrix go through pfMatrix::operator[], but
pfMatrix is a public struct whose data member mat is directly
accessible, e.g.  for passing to a routine expecting a float* such as
glLoadMatrixf.  The default constructor \f3\%pfMatrix()\fP is empty and
does not initialize the values in the matrix.  An initializing
constructor \f3\%pfMatrix\fP(float, ... float) accepts the initial values
in row major order, i.e. mat[0][0], mat[0][1], mat[0][2], mat[0][3],
...  mat[3][3].

\f3\%new\fP(arena) allocates a pfMatrix from the specified memory arena,
or from the heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfMatrix
from the default memory arena (\f3\%pfGetSharedArena\fP). pfMatrices can
also be created automatically on the stack or statically.  pfMatrices
allocated with \f3\%new\fP can be deleted with \f3\%delete\fP or \f3\%pfDelete\fP.

\f3\%pfMatrix::makeIdent\fP sets the
pfMatrix to the identity matrix.  \f3\%PFMAKE_IDENT_MAT\fP is an
equivalent macro.

The following routines create transformation matrices based on
multiplying a row vector by a matrix on the right, i.e. the vector v
transformed by m is v * m.   Many actions will go considerably faster
if the last column is (0,0,0,1).

\f3\%pfMatrix::makeTrans\fP sets the pfMatrix to the matrix which translates by
(\f2x\fP, \f2y\fP, \f2z\fP).  Equivalent macro: \f3\%PFMAKE_TRANS_MAT\fP.

\f3\%pfMatrix::makeScale\fP sets the pfMatrix to the matrix which scales by \f2x\fP in
the X direction, by \f2y\fP in the Y direction and by \f2z\fP in the Z
direction.  Equivalent macro: \f3\%PFMAKE_SCALE_MAT\fP

\f3\%pfMatrix::makeRot\fP sets the pfMatrix to the matrix which rotates by
\f2degrees\fP about the axis denoted by the unit vector (\f2x\fP, \f2y\fP,
\f2z\fP).  If (\f2x\fP, \f2y\fP, \f2z\fP) is not normalized, results are
undefined.

\f3\%pfMatrix::makeQuat\fP builds a rotation matrix that expresses the
rotation defined by the quaternion \f2q\fP.

\f3\%pfMatrix::makeEuler\fP sets the pfMatrix to a rotation matrix composed of the
Euler angles \f2h\fP, \f2p\fP, \f2r\fP: \f2h\fP specifies heading, the rotation
about the Z axis; \f2p\fP specifies pitch, the rotation about the X axis;
and, \f2r\fP specifies roll, rotation about the Y axis.  The matrix
created is \f2the pfMatrix\fP = R*P*H, where R is the roll transform, P is the
pitch transform and H is the heading transform.  All rotations follow
the right hand rule.  The convention is natural for a model in which +Y
is "forward," +Z is "up" and +X is "right".  This routine uses
\f3\%pfSinCos\fP which is faster than the libm counterpart, but has less
resolution (see \f3\%pfSinCos\fP).

\f3\%pfMatrix::makeVecRotVec\fP sets
the pfMatrix to the rotation matrix which rotates the
vector \f2v1\fP onto \f2v2\fP, i.e. \f2v2\fP = \f2v1\fP * \f2dst\fP.
\f2v2\fP must be normalized.  The rotation axis is always chosen to be
perpendicular to both \f2v0\fP and \f2v1\fP so that the rotation angle is as small
as possible.  Note that the result is ambiguous only when \f2v0\fP == -\f2v1\fP;
in this case the rotation axis is chosen to be an arbitrary vector
perpendicular to \f2v0\fP and \f2v1\fP.

\f3\%pfMatrix::makeCoord\fP sets the pfMatrix to the matrix which rotates by the
Euler transform specified by \f2c\fP->hpr and translates by
\f2c\fP->xyz, i.e. \f2dst\fP = R*P*H*T, where R is the roll transform,
P is the pitch transform and H is the heading transform, and T is
the translation transform.

\f3\%pfMatrix::getOrthoQuat\fP constructs a
quaternion pfMatrix equivalent to the rotation
expressed by the orthonormal matrix \f2m\fP.

\f3\%pfMatrix::getOrthoCoord\fP returns in
the pfMatrix the translation and rotation of the
orthonormal matrix, \f2m\fP.  The returned pitch ranges from -90 to +90
degrees.  Roll and heading range from -180 to +180.

\f3\%pfMatrix::setMatType\fP allows the specification
of information about the type of transformation the matrix represents.
This information allows Performer to speed up some operations.  The
matrix type is specified as the OR of
.RS
.TP 5
PFMAT_TRANS:
matrix includes a translational component in the 4th row.
.TP
PFMAT_ROT:
matrix includes a rotational component in the left upper 3X3 submatrix.
.TP
PFMAT_SCALE:
matrix includes a uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_NONORTHO:
matrix includes a non-uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_PROJ:
matrix includes projections.
.TP
PFMAT_HOM_SCALE:
mat[4][4] != 1.
.TP
PFMAT_MIRROR:
matrix includes mirroring transformation that
switches between right handed and left handed coordinate systems.
.RE

\f3\%pfMatrix::getMatType\fP computes the type of
matrix.  This information can be useful if a matrix is to be
used repeatedly, e.g. to transform many objects, but is somewhat
time consuming to compute.

\f3\%pfMatrix::setRow\fP.
\f2mat\fP[\f2row\fP][0] = \f2x\fP,
\f2mat\fP[\f2row\fP][1] = \f2y\fP,
\f2mat\fP[\f2row\fP][2] = \f2z\fP,
\f2mat\fP[\f2row\fP][3] = \f2w\fP.  Use the arguments to set row
\f2row\fP of the pfMatrix.  \f2row\fP must be 0, 1, 2, or
3.  Equivalent macro: \f3\%PFSET_MAT_ROW\fP.

\f3\%pfMatrix::getRow\fP.  \f2*x\fP =
\f2mat\fP[\f2row\fP][0], \f2*y\fP =
\f2mat\fP[\f2row\fP][1], \f2*z\fP =
\f2mat\fP[\f2row\fP][2], \f2*w\fP =
\f2mat\fP[\f2row\fP][3].  Get the arguments to row \f2row\fP of
the pfMatrix.  \f2row\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_ROW\fP.

\f3\%pfMatrix::setCol\fP.
\f2mat\fP[0][\f2col\fP] = \f2x\fP,
\f2mat\fP[1][\f2col\fP] = \f2y\fP,
\f2mat\fP[2][\f2col\fP] = \f2z\fP,
\f2mat\fP[3][\f2col\fP] = \f2w\fP.  Use the arguments to set col
\f2col\fP of the pfMatrix.  \f2col\fP must be 0, 1, 2, or
3.  Equivalent macro: \f3\%PFSET_MAT_COL\fP.

\f3\%pfMatrix::getCol\fP.  \f2*x\fP =
\f2mat\fP[0][\f2col\fP], \f2*y\fP =
\f2mat\fP[1][\f2col\fP], \f2*z\fP =
\f2mat\fP[2][\f2col\fP], \f2*w\fP =
\f2mat\fP[3][\f2col\fP].  Get the arguments to col \f2col\fP of
the pfMatrix.  \f2col\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_COL\fP.

\f3\%pfMatrix::setRow\fP.
\f2mat\fP[\f2row\fP][i] = \f2v\fP[i], i = 0, 1, 2.  Set row
\f2row\fP of the pfMatrix to the vector \f2v\fP.  \f2row\fP
must be 0, 1, 2, or 3.  Equivalent macro: \f3\%PFSET_MAT_ROWVEC3\fP.

\f3\%pfMatrix::getRow\fP.  \f2mat\fP[i]
= \f2m\fP[\f2row\fP][i], i = 0, 1, 2.  Return row \f2row\fP of \f2m\fP and in
the pfMatrix.  \f2row\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_ROWVEC3\fP.

\f3\%pfMatrix::setCol\fP.
\f2mat\fP[i][\f2col\fP] = \f2v\fP[i], i = 0, 1, 2.  Set column
\f2col\fP of the pfMatrix to the vector \f2v\fP.  \f2col\fP
must be 0, 1, 2, or 3.  Equivalent macro: \f3\%PFSET_MAT_COLVEC3\fP.

\f3\%pfMatrix::getCol\fP.  \f2mat\fP[i]
= \f2m\fP[i][\f2col\fP], i = 0, 1, 2.  Return column \f2col\fP of \f2m\fP in
the pfMatrix.  \f2col\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_COLVEC3\fP.

\f3\%pfMatrix::set\fP.
\f2mat\fP[i][j] = \f2m\fP[i*4+j], 0 <= i,j <= 3.

\f3\%pfMatrix::copy\fP: \f2mat\fP = \f2m\fP.
Copies \f2m\fP into the pfMatrix.  Equivalent macro:
\f3\%PFCOPY_MAT\fP

\f3\%pfMatrix::preTrans\fP: \f2mat\fP =
T(\f2x\fP,\f2y\fP,\f2z\fP) * \f2m\fP, where T(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix
which translates by (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfMatrix::postTrans\fP: \f2mat\fP =
\f2m\fP * T(\f2x\fP,\f2y\fP,\f2z\fP), where T(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix
which translates by (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfMatrix::preRot\fP: \f2mat\fP =
R(\f2degrees\fP, \f2x\fP,\f2y\fP,\f2z\fP) * \f2m\fP, where
R(\f2degrees\fP,\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which rotates by
\f2degrees\fP about the axis (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfMatrix::postRot\fP: \f2mat\fP = \f2m\fP * R(\f2degrees\fP, \f2x\fP,\f2y\fP,\f2z\fP),
where R(\f2degrees\fP,\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which rotates
by \f2degrees\fP about the axis (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfMatrix::preScale\fP: \f2mat\fP = S(\f2x\fP,\f2y\fP,\f2z\fP) * \f2m\fP, where
S(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which scales by
(\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfMatrix::postScale\fP: \f2mat\fP = \f2m\fP * S(\f2x\fP,\f2y\fP,\f2z\fP), where
S(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which scales by
(\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfMatrix::add\fP: \f2mat\fP = \f2m1\fP + \f2m2\fP.  Sets the pfMatrix to the sum of
\f2m1\fP and \f2m2\fP.

\f3\%pfMatrix::sub\fP: \f2mat\fP = \f2m1\fP - \f2m2\fP.  Sets the pfMatrix to the
difference of \f2m1\fP and \f2m2\fP.

\f3\%pfMatrix::scale\fP: \f2mat\fP = \f2s\fP * \f2m\fP.  Sets the pfMatrix to the
product of the scalar \f2s\fP and the matrix \f2m\fP.  This multiplies
the full 4X4 matrix and is not a 3D geometric scale.

\f3\%pfMatrix::transpose\fP: \f2mat\fP = Transpose(\f2m\fP).  Sets the pfMatrix to
the transpose of \f2m\fP.

\f3\%pfMatrix::mult\fP: \f2mat\fP = \f2m1\fP * \f2m2\fP.  Sets the pfMatrix to the
product of \f2m1\fP and \f2m2\fP.

\f3\%pfMatrix::postMult\fP: \f2mat\fP = \f2mat\fP *\f2m\fP.  Postmultiplies
the pfMatrix by \f2m\fP.

\f3\%pfMatrix::preMult\fP: \f2mat\fP = \f2m\fP * \f2mat\fP.  Premultiplies
the pfMatrix by \f2m\fP.

\f3\%pfMatrix::invertFull\fP, \f3\%pfMatrix::invertAff\fP, \f3\%pfMatrix::invertOrtho\fP,
\f3\%pfMatrix::invertOrthoN\fP, and \f3\%pfMatrix::invertIdent\fP, set the pfMatrix to the
inverse of \f2m\fP for general, affine, orthogonal, orthonormal and
identity matrices respectively.  They are listed here in order of
decreasing generality and increasing speed.  If the matrix \f2m\fP is not
of the type specified in the routine name, the result is undefined.
\f3\%pfMatrix::invertFull\fP returns FALSE if the matrix is singular and TRUE
otherwise.

\f3\%pfMatrix::equal\fP(m2) = (\f2pfMatrix.mat\fP == \f2m2\fP).  Tests for strict
component-by-element equality of
the pfMatrix
and \f2m2\fP and
returns FALSE or TRUE.  Macro equivalent: \f3\%PFEQUAL_MAT\fP.

\f3\%pfMatrix::almostEqual\fP(m2, tol).  Tests for approximate
element-by-element equality of
the pfMatrix
and \f2m2\fP.  It
returns FALSE or TRUE depending on whether the absolute value of the
difference between each pair of elements is less than the tolerance
\f2tol\fP.  Macro equivalent: \f3\%PFALMOST_EQUAL_MAT\fP.

\f3\%float& operator []\fP(int)
\f3\%const float& operator []\fP(int)
Bracket operators to allow indexing into the 2D array,
e.g. m[3][2].

\f3\%int operator ==\fP(const pfMatrix&)
Equality comparison operator.

\f3\%pfMatrix operator +\fP(const pfMatrix&)
\f3\%pfMatrix operator -\fP(const pfMatrix&)
Component-wise binary matrix addition and subtraction operators.

\f3\%pfMatrix& operator +=\fP(const pfMatrix&);
\f3\%pfMatrix& operator -=\fP(const pfMatrix&);
Component-wise matrix addition and subtraction operators.

\f3\%pfMatrix& operator =\fP(const pfMatrix&)
Set the matrix from another matrix.

\f3\%pfMatrix& operator *=\fP(const pfMatrix&)
\f3\%pfMatrix operator *=\fP(const pfMatrix&)
Performs right multiplication with anther matrix.

\f3\%pfMatrix operator *\fP(const pfMatrix&, float)
\f3\%pfMatrix operator *\fP(float, const pfMatrix&)
\f3\%pfMatrix operator /\fP(const pfMatrix&, float)
Component-wise binary scalar multiplication and division operators.

Routines can accept the same matrix as source, destination, or as a
repeated operand.

.SH NOTES

Some of these routines use pfSinCos and pfSqrt, which are faster but
have less resolution than the libm counterparts.  (See \f3\%pfSinCos\fP)
When using overloaded operators in C++, assignment operators, e.g.
"+=", are somewhat more efficient than the corresponding binary
operators, e.g. "+", because the latter construct a temporary
intermediate object.  Use assignment operators or macros for
binary operations where optimal speed is important.

C++ does not support array deletion (i.e. \f3\%delete[]\fP) for
arrays of objects allocated new operators that take additional
arguments.  Hence, the array deletion operator \f3\%delete[]\fP should not
be used on arrays of objects created with \f3\%new\fP(arena) pfMatrix[n].
.SH SEE ALSO
pfSinCos,
pfSqrt,
pfVec3,
pfVec4
