'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfObject" "3pf"
.SH NAME
.upperok
.B pfObject
\- 
pfObject, callback and user data operations
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfDeleteFuncType\ \ \ 'u
#include <Performer/pr/pfObject.h>
.nf
.fi
.TP
void*
\f3\%pfObject::operator new\fP(size_t);
.nf
.fi
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.nf
.fi
.TP
static pfType *
\f3\%pfObject::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.nf
.fi
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
static void
\f3\%pfObject::setUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
static void
\f3\%pfObject::setUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.nf
.fi
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.nf
.fi
.TP
static void *
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.nf
.fi
.TP
static void *
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfObject::getNumUserData\fP();
.nf
.fi
.TP
static int
\f3\%pfObject::getNumUserData\fP(pfObject\ *obj);
.nf
.fi
.TP
static int
\f3\%pfObject::getNamedUserDataSlot\fP(const\ char\ *name);
.nf
.fi
.TP
static const char*
\f3\%pfObject::getUserDataSlotName\fP(int\ slot);
.nf
.fi
.TP
static int
\f3\%pfObject::getNumNamedUserDataSlots\fP(void);
.nf
.fi
.TP
static void
\f3\%pfObject::setCopyFunc\fP(pfCopyFuncType\ func);
.nf
.fi
.TP
static void
\f3\%pfObject::setCopyFunc\fP(int\ slot,
'in +2
'll -2
pfCopyFuncType\ func);
.in
.ll
.nf
.fi
.TP
static pfCopyFuncType
\f3\%pfObject::getCopyFunc\fP(void);
.nf
.fi
.TP
static pfCopyFuncType
\f3\%pfObject::getCopyFunc\fP(int\ slot);
.nf
.fi
.TP
static void
\f3\%pfObject::setDeleteFunc\fP(pfDeleteFuncType\ func);
.nf
.fi
.TP
static void
\f3\%pfObject::setDeleteFunc\fP(int\ slot,
'in +2
'll -2
pfDeleteFuncType\ func);
.in
.ll
.nf
.fi
.TP
static pfDeleteFuncType
\f3\%pfObject::getDeleteFunc\fP(void);
.nf
.fi
.TP
static pfDeleteFuncType
\f3\%pfObject::getDeleteFunc\fP(int\ slot);
.nf
.fi
.TP
static void
\f3\%pfObject::setPrintFunc\fP(pfPrintFuncType\ func);
.nf
.fi
.TP
static void
\f3\%pfObject::setPrintFunc\fP(int\ slot,
'in +2
'll -2
pfPrintFuncType\ func);
.in
.ll
.nf
.fi
.TP
static pfPrintFuncType
\f3\%pfObject::getPrintFunc\fP(void);
.nf
.fi
.TP
static pfPrintFuncType
\f3\%pfObject::getPrintFunc\fP(int\ slot);
.nf
.fi
.TP
static int
\f3\%pfObject::getGLHandle\fP(void);
.nf
.fi
.TP
static int
\f3\%pfObject::deleteGLHandle\fP(void);
.fi

.Ex
.nf

typedef void (*pfCopyFuncType)(pfObject *dst, const pfObject *src);
typedef void (*pfDeleteFuncType)(pfObject *obj);
typedef void (*pfPrintFuncType)(const pfObject *obj, uint which, uint verbose, char *, FILE *);
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfObject\fP is
derived from the parent class \f3\%pfMemory\fP,
so each of these member functions of
class \f3\%pfMemory\fP
are also directly usable with objects
of class \f3\%pfObject\fP.
This is also true for
ancestor classes
of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfObject is the abstract data type from which the major OpenGL
Performer data structures are derived.  pfObject in turn derives from
pfMemory which is the basic memory allocation unit.  Although pfObjects
cannot be created directly, most OpenGL Performer data structures are
derived from them and thus inherit the functionality of the pfObject
routines described here and those for pfMemory.

\f3\%new\fP(arena) allocates a pfObject from the specified memory arena,
or from the heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfObject
from the default memory arena (see \f3\%pfGetSharedArena\fP).  pfObjects
cannot be automatically on the stack, statically or in arrays.
pfObjects allocated with \f3\%new\fP should be deleted with
\f3\%pfDelete\fP rather than the delete operator.

\f3\%pfObject::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfObject\fP.  The \f3\%pfType\fP* returned
by \f3\%pfObject::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfObject\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

User data provides a mechanism for associating application
specific data with OpenGL Performer objects.
pfObjects have multiple slots for attaching user data.
User data slots can not be used until they are named.
By default only slot 0 is named.

\f3\%pfObject::getNamedUserDataSlot\fP
will returns a user data slot number associated with \f2name\fP.  If
name is not yet associated with a slot, the next unused slot will
be named \f2name\fP.  Once a slot has been named its name can never
be changed.

\f3\%pfObject::getUserDataSlotName\fP
returns the name of user data \f2slot\fP.

\f3\%pfObject::getNumNamedUserDataSlots\fP
returns the number of named user data slots.

\f3\%pfObject::setUserData\fP attaches the user-supplied data
pointer, \f2data\fP, to user data \f2slot\fP of the pfObject.
If \f2slot\fP is not specified slot 0 is assumed.


Example 2: How to use User Data.
.Ex
.nf

typedef struct
{
    float	coeffFriction;
    float	density;
    float	*dataPoints;
}
myMaterial;

myMaterial	*granite;

granite = (myMaterial *)pfMalloc(sizeof(myMaterial), NULL);
granite->coeffFriction = 0.5f;
granite->density = 3.0f;
granite->dataPoints = (float *)pfMalloc(sizeof(float)*8, NULL);
graniteMtl = new pfMaterial;

graniteMtl->setUserData(granite);
.Ee
.fi
.na


\f3\%pfObject::getUserData\fP returns the user-data pointer for \f2slot\fP of
the pfObject.  If \f2slot\fP is not specified slot 0 is assumed.

Note that memory from \f3\%pfMemory::malloc\fP is not an
considered a pfObject so
user-data pointers are not provided for pfMalloc'ed memory.

User data is reference counted if it is a \f3\%libpr\fP-type object like
pfTexture, pfGeoSet, or memory allocated from
\f3\%pfMemory::malloc\fP.  Thus user data is deleted if
its reference count reaches 0 when its parent pfObject is deleted.

\f3\%pfObject::getNumUserData\fP returns 1 +
greatest non-NULL user data slot number of the pfObject,
or 0 if no slot contains non-NULL user data.

\f3\%pfObject::setDeleteFunc\fP,
\f3\%pfObject::setCopyFunc\fP, and
\f3\%pfObject::setPrintFunc\fP set
global function callbacks which are called when deleting, copying, and
printing a pfObject with non-NULL user data in \f2slot\fP.  If \f2slot\fP
is not specified slot 0 is assumed.  These callbacks are
provided so you can change the default behavior of user data.
If a callback is not specified or is NULL, the default behaviors are:
.RS
.TP
1.
Delete: Call \f3\%pfUnrefDelete\fP on the user data.
.TP
2.
Copy: Decrement the reference count of the user data attached to
the destination pfObject (but do not delete it), increment the
reference count of the user data attached to
the source pfObject and copy the user data pointer from the source
to the destination pfObject. In pseudo-code:
.Ex
.nf

	pfUnref(dst->userData[slot]);
	pfRef(src->userData[slot]);
	dst->userData[slot] = src->userData[slot];
.Ee
.fi
.na

.TP
3.
Print: Print the address of the user data.
.RE

\f3\%pfObject::getDeleteFunc\fP,
\f3\%pfObject::getCopyFunc\fP, and
\f3\%pfObject::getPrintFunc\fP
return the global deletion, copy, and print callbacks respectively for
\f2slot\fP.  If \f2slot\fP is not specified slot 0 is assumed.

Example 3: How to delete the user data of Example 2.
.Ex
.nf

void
myDeleteFunc(pfObject *obj)
{
    myMaterial	*mtl = obj->getUserData();

    pfFree(mtl->dataPoints);
    mtl->free();
}
 :
/* allocate a new material */
graniteMtl = new pfMaterial;

/* bind user data to material */
graniteMtl->setUserData(granite);

/* set deletion callback */
myDeleteFunc->setDeleteFunc();

/*
 * This will trigger callback only if graniteMtl has
 * a reference count <= 0.
 */
graniteMtl->checkDelete();
.Ee
.fi
.na


In the above example, the 'dataPoints' array of the 'myMaterial'
structure would not have been freed without the deletion callback
since pfDelete would have simply deleted the myMaterial structure.

\f3\%pfObject::getGLHandle\fP is a back-door
mechanism for those who need to tweak the graphics library objects
which underly many libpr objects.
\f3\%pfObject::getGLHandle\fP returns the graphics
library identifier associated with \f2obj\fP or -1 if \f2obj\fP has no
associated graphics library handle.
\f3\%pfObject::deleteGLHandle\fP will delete the
object's associated GL object.  Currently this is supported only for
pfTextures.

.SH SEE ALSO
pfDelete,
pfMemory
