'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfPolytope" "3pf"
.SH NAME
.upperok
.B pfPolytope
\- 
Create, configure, transform, and intersect polytopes
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfType*\ \ \ 'u
#include <Performer/pr/pfGeoMath.h>
.nf
.fi
.TP
\ 
\f3\%pfPolytope::pfPolytope\fP();
.nf
.fi
.TP
pfType*
\f3\%pfPolytope::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfPolytope::getNumFacets\fP(void);
.nf
.fi
.TP
int
\f3\%pfPolytope::setFacet\fP(int\ i,
'in +2
'll -2
const\ pfPlane\ *facet);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPolytope::getFacet\fP(int\ i,
'in +2
'll -2
pfPlane\ *facet);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPolytope::removeFacet\fP(int\ i);
.nf
.fi
.TP
void
\f3\%pfPolytope::orthoXform\fP(const\ pfPolytope\ *src,
'in +2
'll -2
const\ pfMatrix\ \ &mat);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfVec3\ \ &pt);
.nf
.fi
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfSphere\ *sphere);
.nf
.fi
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfBox\ *box);
.nf
.fi
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfCylinder\ *cyl);
.nf
.fi
.TP
int
\f3\%pfPolytope::contains\fP(const\ pfPolytope\ *ptope1);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfPolytope\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfPolytope\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfPolytope\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION


A pfPolytope is a set of half spaces whose intersection defines a
convex, possibly semi-infinite, volume which may be used for culling
and other intersection testing where a tighter bound than a pfBox,
pfSphere, or pfCylinder is of benefit.

\f3\%new\fP(arena) allocates a pfPolytope from the specified memory arena,
or from the process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfPolytope from the default memory arena (see \f3\%pfGetSharedArena\fP).
Like other pfObjects, pfPolytopes cannot be created statically,
automatically on the stack or in arrays.  pfPolytopes can also be
created automatically on the stack or statically.  pfPolytopes allocated
with \f3\%new\fP can be deleted with \f3\%delete\fP or \f3\%pfDelete\fP.

\f3\%pfPolytope::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfPolytope\fP.  The \f3\%pfType\fP* returned
by \f3\%pfPolytope::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfPolytope\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfPolytope::setFacet\fP sets the \f2i\fPth facet of the pfPolytope to \f2facet\fP.
\f2facet\fP defines a half space such that the normal of the pfPlane
faces "outside". \f3\%pfPolytope::getFacet\fP copies the
\f2i\fPth facet of the pfPolytope into \f2facet\fP.

\f3\%pfPolytope::removeFacet\fP removes the \f2i\fPth facet of the pfPolytope
from the list. Remaining facets are shifted left over the removed
facet.

\f3\%pfPolytope::getNumFacets\fP returns the number of facets in the pfPolytope.

\f3\%pfPolytope::orthoXform\fP transforms \f2src\fP by
\f2mat\fP and
stores the result in the pfPolytope.
\f2mat\fP should be an orthonormal matrix or results are
undefined.

The various member functions \f3\%pfPolytope::contains\fP compute the
intersection of a pfPolytope with a variety of geometric primitives.
\f3\%pfPolytope::contains\fP returns one of the following:
.RS
.TP 5
\f3\%PFIS_FALSE\fP:
The intersection of the primitive and the pfPolytope is empty.
.TP
\f3\%PFIS_MAYBE\fP:
The intersection of the primitive and the pfPolytope might be non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP:
The intersection of the primitive and the pfPolytope is definitely non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP | \f3\%PFIS_ALL_IN\fP:
The primitive is non-empty and lies entirely inside the pfPolytope.
.RE
.SH SEE ALSO
pfBox,
pfCylinder,
pfDelete,
pfFrustum,
pfMatrix,
pfObject,
pfSphere
