'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfQuat" "3pf"
.SH NAME
.upperok
.B pfQuat
\- 
Set and operate on quaternions
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'extern\ void\ \ \ 'u
#include <Performer/pr/pfLinMath.h>
.nf
.fi
.TP
\ 
\f3\%pfQuat::pfQuat\fP();
.nf
.fi
.TP
\ 
\f3\%pfQuat::pfQuat\fP(float\ _x,
'in +2
'll -2
float\ _y,
float\ _z,
float\ _w);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfQuat::pfQuat\fP(const\ float\ v[4]);
.nf
.fi
.TP
\ 
\f3\%pfQuat::pfQuat\fP(const\ pfMatrix\ &m);
.nf
.fi
.TP
\ 
\f3\%pfQuat::pfQuat\fP(const\ pfVec3\ &axis,
'in +2
'll -2
float\ _angle);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfQuat::pfQuat\fP(const\ pfVec3\ &rotateFrom,
'in +2
'll -2
const\ pfVec3\ rotateTo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::makeRot\fP(float\ angle,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::getRot\fP(float\ *angle,
'in +2
'll -2
float\ *x,
float\ *y,
float\ *z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::getRot\fP(pfMatrix\ &m);
.nf
.fi
.TP
void
\f3\%pfQuat::makeRot\fP(const\ pfMatrix\ &m);
.nf
.fi
.TP
void
\f3\%pfQuat::makeVecRotVec\fP(const\ pfVec3\ &rotateFrom,
'in +2
'll -2
const\ pfVec3\ rotateTo);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfQuat::length\fP(void);
.nf
.fi
.TP
void
\f3\%pfQuat::conj\fP(const\ pfQuat\ &q);
.nf
.fi
.TP
void
\f3\%pfQuat::exp\fP(const\ pfQuat\ &q);
.nf
.fi
.TP
void
\f3\%pfQuat::log\fP(const\ pfQuat\ &q);
.nf
.fi
.TP
void
\f3\%pfQuat::mult\fP(const\ pfQuat\ &q1,
'in +2
'll -2
const\ pfQuat\ &q2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::div\fP(const\ pfQuat\ &q1,
'in +2
'll -2
const\ pfQuat\ &q2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::invert\fP(const\ pfQuat\ &q);
.nf
.fi
.TP
int
\f3\%pfQuat::equal\fP(const\ pfQuat\ &q1,
'in +2
'll -2
const\ pfQuat\ &q2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfQuat::almostEqual\fP(const\ pfQuat\ &q1,
'in +2
'll -2
const\ pfQuat\ &q2,
float\ tol);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::slerp\fP(float\ t,
'in +2
'll -2
const\ pfQuat\ &q1,
const\ pfQuat\ &q2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQuat::squad\fP(float\ t,
'in +2
'll -2
const\ pfQuat\ &q1,
const\ pfQuat\ &q2,
const\ pfQuat\ &a,
const\ pfQuat\ &b);
.in
.ll
.nf
.fi
.TP
extern void
\f3\%pfQuat::meanTangent\fP(const\ pfQuat\ &q1,
'in +2
'll -2
const\ pfQuat\ &q2,
const\ pfQuat\ &q3);
.in
.ll
.nf
.fi
.TP
pfQuat &
\f3\%pfQuat::operator *\fP(const\ pfQuat\ &m);
.nf
.fi
.TP
pfQuat
\f3\%pfQuat::operator *=\fP(const\ pfQuat\ &m);
.nf
.fi
.TP
pfQuat
\f3\%pfQuat::operator /\fP(const\ pfQuat\ &v);
.nf
.fi
.TP
pfQuat &
\f3\%pfQuat::operator /=\fP(const\ pfQuat\ &v);
.fi

.Ex
.nf

struct pfQuat : public pfVec4
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfQuat\fP is
derived from the parent class \f3\%pfVec4\fP,
so each of these member functions of
class \f3\%pfVec4\fP
are also directly usable with objects
of class \f3\%pfQuat\fP.
This is also true for
ancestor classes
of class \f3\%pfVec4\fP.

.PD 0
.TP \w'const\ float&\ \ \ 'u
void*
\f3\%pfVec4::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfVec4::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void
\f3\%pfVec4::addScaled\fP(pfVec3&\ dst,
'in +2
'll -2
const\ pfVec3&\ v1,
float\ s,
const\ pfVec3&\ v2);
.in
.ll
.PD 0
.TP
void
\f3\%pfVec4::add\fP(const\ pfVec4&\ v1,
'in +2
'll -2
const\ pfVec4&\ v2);
.in
.ll
.PD 0
.TP
int
\f3\%pfVec4::almostEqual\fP(const\ pfVec4&\ v2,
'in +2
'll -2
float\ tol);
.in
.ll
.PD 0
.TP
void
\f3\%pfVec4::combine\fP(float\ s1,
'in +2
'll -2
const\ pfVec4&\ v1,
float\ s2,
const\ pfVec4&\ v2);
.in
.ll
.PD 0
.TP
void
\f3\%pfVec4::copy\fP(const\ pfVec4&\ v);
.PD 0
.TP
float
\f3\%pfVec4::distance\fP(const\ pfVec4&\ pt2);
.PD 0
.TP
float
\f3\%pfVec4::dot\fP(const\ pfVec4&\ v2);
.PD 0
.TP
int
\f3\%pfVec4::equal\fP(const\ pfVec4&\ v2);
.PD 0
.TP
float
\f3\%pfVec4::length\fP(void);
.PD 0
.TP
void
\f3\%pfVec4::negate\fP(const\ pfVec4&\ v);
.PD 0
.TP
float
\f3\%pfVec4::normalize\fP(void);
.PD 0
.TP
void
\f3\%pfVec4::scale\fP(float\ s,
'in +2
'll -2
const\ pfVec4&\ v);
.in
.ll
.PD 0
.TP
void
\f3\%pfVec4::set\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z,
float\ w);
.in
.ll
.PD 0
.TP
float
\f3\%pfVec4::sqrDistance\fP(const\ pfVec4&\ pt2);
.PD 0
.TP
void
\f3\%pfVec4::sub\fP(const\ pfVec4&\ v1,
'in +2
'll -2
const\ pfVec4&\ v2);
.in
.ll
.PD 0
.TP
void
\f3\%pfVec4::xform\fP(const\ pfVec4&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.PD 0
.TP
float&
\f3\%pfVec4::operator []\fP(int\ i);
.PD 0
.TP
const float&
\f3\%pfVec4::operator []\fP(int\ i);
.PD 0
.TP
int
\f3\%pfVec4::operator ==\fP(const\ pfVec4&\ v);
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator -\fP()\ const;
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator +\fP(const\ pfVec4&\ v);
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator -\fP(const\ pfVec4&\ v);
.PD 0
.TP
pfVec4&
\f3\%pfVec4::operator =\fP(const\ pfVec4&\ v);
.PD 0
.TP
pfVec4&
\f3\%pfVec4::operator *=\fP(float\ d);
.PD 0
.TP
pfVec4&
\f3\%pfVec4::operator /=\fP(float\ d);
.PD 0
.TP
pfVec4&
\f3\%pfVec4::operator +=\fP(const\ pfVec4&\ v);
.PD 0
.TP
pfVec4&
\f3\%pfVec4::operator -=\fP(const\ pfVec4&\ v);
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator *\fP(const\ pfVec4&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator *\fP(float\ d,
'in +2
'll -2
const\ pfVec4&\ v);
.in
.ll
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator /\fP(const\ pfVec4&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.PD 0
.TP
pfVec4
\f3\%pfVec4::operator *\fP(const\ pfVec4&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.PD
.fi
.SH DESCRIPTION

pfQuat represents a quaternion as the four floating point values
(\f2x\fP, \f2y\fP, \f2z\fP, \f2w\fP) of a pfVec4.

The default constructor \f3\%pfQuat\fP() is empty and does no
initialization.  \f3\%new\fP(arena) allocates a pfQuat from the specified
memory arena, or from the heap if \f2arena\fP is NULL.  \f3\%new\fP
allocates a pfQuat from the default memory arena (see
\f3\%pfGetSharedArena\fP).  pfQuats can also be created automatically on
the stack or statically.  pfQuats allocated with \f3\%new\fP can be
deleted with \f3\%delete\fP or \f3\%pfDelete\fP.  pfQuats can also be constructed
by specifying the four members of the quaternion directly as floats using
\f3\%pfQuat\fP(float _x, float _y, float _z, float _w), as an array of floats
using \f3\%pfQuat\fP(const float v[4]), from an orthonormal pfMatrix using
\f3\%pfQuat\fP(const pfMatrix &m), from an axis and angle using
\f3\%pfQuat\fP(const pfVec3 &axis, float _angle), and from two vectors to rotate
between using \f3\%pfQuat\fP(const pfVec3 &rotateFrom, const pfVec3 rotateTo).

\f3\%pfQuat::makeRot\fP converts an \f2axis\fP and
\f2angle\fP rotation representation to a quaternion.
\f3\%pfQuat::getRot\fP is the inverse operation. It
produces the axis (as a unit length direction vector) and angle
equivalent to the given quaternion.  Also see
\f3\%pfMatrix::makeQuat\fP and
\f3\%pfMatrix::getOrthoQuat\fP.

\f3\%pfQuat::makeRot(pfMatrix)\fP converts the
rotation expressed by an orthonormal pfMatrix to a pfQuat.  If the
pfMatrix is not orthonormal the results are undefined (and will most
certainly not be the rotation that you wanted).
\f3\%pfQuat::getRot(pfMatrix)\fP constructs a
rotation matrix from the quaternion.

\f3\%pfQuat::makeVecRotVec\fP constructs a
quaternion from the rotation between the two vectors rotateFrom and
rotateTo.

Several monadic quaternion operators are provided.  \f3\%pfQuat::conj\fP
produces the complex conjugate \f2dst\fP of \f2q\fP by negating only the
complex components (\f2x\fP, \f2y\fP, and \f2z\fP) which results in an
inverse rotation.  \f3\%pfQuat::exp\fP and \f3\%pfQuat::log\fP perform complex
exponentiation and logarithm functions respectively. The length of a
quaternion is computed by \f3\%pfQuat::length\fP and is defined as the
norm of all four quaternion components.  Macro equivalents are
\f3\%PFCONJ_QUAT\fP and \f3\%PFLENGTH_QUAT\fP.  For negation, use the pfVec4
routine, \f3\%pfVec4::negate\fP.

\f3\%pfQuat::mult\fP and \f3\%pfQuat::div\fP are dyadic quaternion operations
which provide the product, and quotient of two quaternions.  When
quaternions are used to represent rotations, multiplication of two
quaternions is equivalent, but more efficient, than the multiplication
of the two correspondinging rotation matrices.

\f3\%pfQuat::invert\fP computes the multiplicative inverse of a
quaternion.  These operations are the basis from which the other
quaternion capabilities have been derived.  Macro equivalents are
\f3\%PFMULT_QUAT\fP, \f3\%PFDIV_QUAT\fP, and \f3\%PFINVERT_QUAT\fP.  For
addition and scalar multiplication, use the pfVec4 routines
\f3\%pfVec4::add\fP, \f3\%pfVec4::sub\fP, and \f3\%pfVec4::scale\fP.
Comparisons
can be made with the pfVec4 member functions
\f3\%pfVec4::equal\fP and \f3\%pfVec4::almostEqual\fP, since pfQuat is
derived from pfVec4.

\f3\%pfQuat & operator *\fP(const pfQuat &m)
\f3\%pfQuat operator *=\fP(const pfQuat &m)
Performs multiplication with anther pfQuat.

\f3\%pfQuat operator /\fP(const pfQuat &v)
\f3\%pfQuat & operator /=\fP(const pfQuat &v)
Performs division with anther pfQuat.

Interpolation of quaternions (as presented by Ken Shoemake) is an
effective technique for rotation interpolation. Spherical linear
interpolation is performed with \f3\%pfQuat::slerp\fP, which produces a
pfQuat that is \f2t\fP of the way between \f2q1\fP and
\f2q2\fP.

Spherical quadratic interpolation is provided by \f3\%pfQuat::squad\fP and
its helper function, \f3\%pfQuat::meanTangent\fP.

.SH NOTES


These functions use a pfVec4 to represent quaternions and store the
imaginary part first, thus the array contents q = {x,y,z,w} are a
representation of the quaternion w + x\f2i\fP + y\f2j\fP+ z\f2k\fP.

Because both \f2q\fP and \f2-q\fP represent the same rotation (quaternions
have a rotation range of [-360,360] degrees) conversions such as
\f3\%pfMatrix::getOrthoQuat\fP make an arbitrary
choice of the sign of the returned quaternion.  To prevent the
arbitrary sign from introducing large, unintended rotations,
\f3\%pfQuat::slerp\fP checks the angle \f2theta\fP
between \f2q1\fP and \f2q2\fP.  If \f2theta\fP exceeds 180 degrees, \f2q2\fP
is negated changing the interpolations range from [0,\f2theta\fP] to [0,
\f2theta\fP-360 degrees].

When using overloaded operators in C++, assignment operators, e.g.
"+=", are somewhat more efficient than the corresponding binary
operators, e.g. "+", because the latter construct a temporary
intermediate object.  Use assignment operators or macros for
binary operations where optimal speed is important.

C++ does not support array deletion (i.e. \f3\%delete[]\fP) for
arrays of objects allocated new operators that take additional
arguments.  Hence, the array deletion operator \f3\%delete[]\fP should not
be used on arrays of objects created with \f3\%new\fP(arena) pfVec4[n].

For more information on quaternions, see the article by Sir William
Rowan Hamilton "\f2On quaternions; or on a new system of imaginaries in
algebra\fP," in the Philosophical Magazine, xxv, pp. 10-13 (July 1844).
More recent references include "\f2Animating Rotation with Quaternion
Curves\fP," SIGGRAPH Proceedings Vol 19, Number 3, 1985, and
"\f2Quaternion Calculus For Animation\fP," in "Math for SIGGRAPH",
Course Notes, #23, SIGGRAPH 1989, both by Ken Shoemake.  An
introductory tutorial is available on the Internet at
ftp://ftp.cis.upenn.edu/pub/graphics/shoemake/quatut.ps.Z.  Note that
for consistency with Performer's transformation order, pfQuats are the
conjugates of the quaternions described in these references.

.SH SEE ALSO
pfVec4,
pfMatrix
