'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfSCS" "3pf"
.SH NAME
.upperok
.B pfSCS
\- 
Create and get matrix for a static coordinate system node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfSCS.h>
.nf
.fi
.TP
\ 
\f3\%pfSCS::pfSCS\fP(pfMatrix\ mat);
.nf
.fi
.TP
static pfType *
\f3\%pfSCS::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfSCS::getMat\fP(pfMatrix\ &mat);
.nf
.fi
.TP
const pfMatrix*
\f3\%pfSCS::getMatPtr\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfSCS\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfSCS\fP.
This is also true for
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfSCS\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfSCS\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfSCS\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfSCS node represents a static coordinate system -- a modeling
transform that cannot be changed once created.  pfSCS nodes are similar
to but less flexible than pfDCS nodes. What they lack in changeability
they make up in performance.

\f3\%new pfSCS\fP creates and returns a handle to a pfSCS.  Like other
pfNodes, pfSCSes are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfSCSes should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%new pfSCS\fP creates a pfSCS using \f2mat\fP as the
transformation matrix.

By default a pfSCS uses a dynamic bounding volume so it is
automatically updated when children are added, deleted or changed.
This behavior may be changed using \f3\%pfNode::setBound\fP.  The bound for a
pfSCS encompasses all B(i)*\f2mat\fP, where B(i) is the bound for the
child 'i' and \f2mat\fP is the transformation matrix of the pfSCS.

\f3\%pfSCS::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfSCS\fP.  The \f3\%pfType\fP* returned
by \f3\%pfSCS::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfSCS\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

The transformation of a pfSCS affects all its children.  As the
hierarchy is traversed from top to bottom, each new matrix is
pre-multiplied to create the new transformation.  For example, if
SCSb is below SCSa in the scene graph, any geometry G below SCSa is
transformed as G*SCSb*SCSa.

Static transformations represented by pfSCSes may be 'flattened' in a
pre-processing step for improved intersection, culling, and drawing
performance.  \f3\%pfNode::flatten\fP accumulates transformations in a scene
graph, applies them to geometry, and sets flattened pfSCSes to the
identity matrix.  Flattening is recommended when available memory
and scene graph structure allow it.  See \f3\%pfNode\fP for more
details.

\f3\%pfSCS::getMat\fP copies the transformation matrix for the pfSCS
into \f2mat\fP. For faster matrix access,
\f3\%pfSCS::getMatPtr\fP returns a const pointer to the pfSCS's matrix.

Both pre and post CULL and DRAW callbacks attached to a pfSCS
(\f3\%pfNode::setTravFuncs\fP) will be affected by the transformation
represented by the pfSCS, i.e. - the pfSCS matrix will already have been
applied to the matrix stack before the pre callback is called and will
be popped only after the post callback is called.
.SH SEE ALSO
pfGroup,
pfMatrix,
pfNode,
pfTraverser,
pfDelete
