'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfScene" "3pf"
.SH NAME
.upperok
.B pfScene
\- 
Create a scene or root node, set and get scene pfGeoState or
pfGeoState index.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfScene.h>
.nf
.fi
.TP
\ 
\f3\%pfScene::pfScene\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfScene::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfScene::setGState\fP(pfGeoState\ *gstate);
.nf
.fi
.TP
pfGeoState *
\f3\%pfScene::getGState\fP(void);
.nf
.fi
.TP
void
\f3\%pfScene::setGStateIndex\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfScene::getGStateIndex\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfScene\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfScene\fP.
This is also true for
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfScene\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfScene\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfScene\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'gstate\ \ 'u
\f2gstate\fP
identifies a pfGeoState.
.SH DESCRIPTION

A pfScene is the root of a hierarchical database which may be drawn or
intersected with.  pfScene is derived from pfGroup so it can use
pfGroup and pfNode API.  A pfScene may have children like a pfGroup but
it cannot be a child of another node. Its special purpose is to serve
as the root node of a scene graph.

\f3\%new pfScene\fP creates and returns a handle to a pfScene.  Like other
pfNodes, pfTexts are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfScenes should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfScene::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfScene\fP.  The \f3\%pfType\fP* returned
by \f3\%pfScene::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfScene\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

OpenGL Performer will automatically carry out the APP, CULL, and DRAW
traversals on pfScenes which are attached to pfChannels by
\f3\%pfChanScene\fP.  The CULL and DRAW traversals are directly or
indirectly triggered by \f3\%pfFrame\fP while the APP traversal is
triggered by \f3\%pfAppFrame\fP.

Multiple pfChannels may reference the
same pfScene but each pfChannel references only a single pfScene.

\f3\%pfScene::setGState\fP attaches \f2gstate\fP to the pfScene. The pfGeoState of
a pfScene defines the "global state" which may be inherited by
other pfGeoStates. This state inheritance mechanism is further
described in the pfGeoState man page.

The scene pfGeoState is defined as the global state by \f3\%pfGeoState::load\fP.
This pfGeoState will be loaded before the pfChannel DRAW callback
(\f3\%pfChannel::setTravFunc\fP) is invoked so any custom rendering in the callback
will inherit the state set by the scene pfGeoState. \f3\%pfScene::getGState\fP
returns the directly referenced pfGeoState of the pfScene or
the appropriate pfGeoState in the global table if the pfScene indexes its
pfGeoState or NULL if the index cannot be resolved.

The scene pfGeoState may be indexed through a global table by assigning
an index with \f3\%pfScene::setGStateIndex\fP and specifying the table with
\f3\%pfGeoState::applyTable\fP. Usually this table is provided by the pfChannel
(\f3\%pfChannel::setGStateTable\fP). \f3\%pfScene::getGStateIndex\fP returns the pfGeoState
index of the pfScene or -1 if the pfScene directly references its pfGeoState.

It is not necessary to provide a scene pfGeoState, but it is a convenient
way to specify the default inheritable values for all pfGeoState elements
on a per-scene basis.
.SH SEE ALSO
pfChannel,
pfGeoState,
pfGroup,
pfDelete
