'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfShader" "3pf"
.SH NAME
.upperok
.B pfShader
\- 
Create, modify and query multi-pass shading primitives.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfShader.h>
.nf
.fi
.TP
\ 
\f3\%pfShader::pfShader\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfShader::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfShader::setName\fP(const\ char*\ _name);
.nf
.fi
.TP
const char*
\f3\%pfShader::getName\fP()\ const;
.nf
.fi
.TP
void
\f3\%pfShader::openPass\fP(int\ passType);
.nf
.fi
.TP
void
\f3\%pfShader::closePass\fP();
.nf
.fi
.TP
int
\f3\%pfShader::getCurPassType\fP();
.nf
.fi
.TP
int
\f3\%pfShader::getNumPasses\fP();
.nf
.fi
.TP
pfShaderPass *
\f3\%pfShader::getCurPass\fP();
.nf
.fi
.TP
pfShaderPass *
\f3\%pfShader::getPass\fP(int\ index);
.nf
.fi
.TP
pfPassList *
\f3\%pfShader::getPassList\fP();
.nf
.fi
.TP
void
\f3\%pfShader::setPassMode\fP(int\ which,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfShader::getPassMode\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfShader::setPassMultiMode\fP(int\ which,
'in +2
'll -2
int\ index,
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfShader::getPassMultiMode\fP(int\ which,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfShader::setPassAttr\fP(int\ which,
'in +2
'll -2
void*\ attr);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfShader::getPassAttr\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfShader::setPassMultiAttr\fP(int\ which,
'in +2
'll -2
int\ index,
void\ *attr);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfShader::getPassMultiAttr\fP(int\ which,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfShader::setPassVal\fP(int\ which,
'in +2
'll -2
float\ value);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfShader::getPassVal\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfShader::setPassMultiVal\fP(int\ which,
'in +2
'll -2
int\ index,
float\ values);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfShader::getPassMultiVal\fP(int\ which,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfShader::setDefaultGeoState\fP(pfGeoState\ *gstate);
.nf
.fi
.TP
void
\f3\%pfShader::setDefaultFBState\fP(pfFBState\ *fbs);
.nf
.fi
.TP
pfGeoState *
\f3\%pfShader::getDefaultGeoState\fP();
.nf
.fi
.TP
pfFBState *
\f3\%pfShader::getDefaultFBState\fP();
.nf
.fi
.TP
void
\f3\%pfShader::setPassGeoState\fP(pfGeoState\ *gstate);
.nf
.fi
.TP
void
\f3\%pfShader::setPassFBState\fP(pfFBState\ *fbs);
.nf
.fi
.TP
pfGeoState *
\f3\%pfShader::getPassGeoState\fP();
.nf
.fi
.TP
pfFBState *
\f3\%pfShader::getPassFBState\fP();
.nf
.fi
.TP
int
\f3\%pfShader::allocateTempTexture\fP();
.nf
.fi
.TP
int
\f3\%pfShader::setPassTempTexture\fP(int\ texID);
.nf
.fi
.TP
int
\f3\%pfShader::setTempTexture\fP(int\ texID,
'in +2
'll -2
pfTexture\ *texture);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfShader::resolveTempTextures\fP();
.nf
.fi
.TP
int
\f3\%pfShader::getNumTempTextures\fP();
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfShader\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfShader\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfShader\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION


A \f3\%pfShader\fP is a container for multi-pass rendering algorithm descriptions.
A multi-pass rendering algorithm consists of a collection of passes.
A pass contains information for drawing some arbitrary geometry with a
specific state on the graphic pipeline. A pass may contain pointers to
a \f3\%pfGeoState\fP and a \f3\%pfFBState\fP. These two determine the graphic state
to be set before rendering the pass.

A \f3\%pfShader\fP is not a part of the scene graph. An application should use
\f3\%pfShaderManager\fP in order to associate a \f3\%pfShader\fP to a node on the scene
graph.  Once a node on the scene graph has a \f3\%pfShader\fP associated with it,
the entire geometry contents under this node is rendered using that
\f3\%pfShader\fP.

\f3\%pfShader\fP supports a number of pass types:

.RS
\f3\%PF_SHADERPASS_GEOMETRY\fP
.br
\f3\%PF_SHADERPASS_QUAD\fP
.br
\f3\%PF_SHADERPASS_COPYPIXELS\fP
.br
\f3\%PF_SHADERPASS_ACCUM\fP
.RE

A pass of type \f3\%PF_SHADERPASS_GEOMETRY\fP draws its associated geometry using
the pass \f3\%pfGeoState\fP and \f3\%pfFBState\fP.

A pass of type \f3\%PF_SHADERPASS_QUAD\fP draws a quad covering the screen
bounding box of the associated geometry. It applies the specified
\f3\%pfGeoState\fP and \f3\%pfFBState\fP before drawing the quad.

A pass of type \f3\%PF_SHADERPASS_COPYPIXELS\fP operates on bitmaps the size of the
screen bounding box of the associated geometry. It can move bitmaps in three
directions:
.Ex
.nf

1. From frame buffer to texture memory.
2. From frame buffer onto itself.
3. From texture memory to frame buffer.
.Ee
.fi
.na


A pass of type \f3\%PF_SHADERPASS_ACCUM\fP operates on bitmaps the size of the
screen bounding box of the associated geometry. It can copy bitmaps to and from
the accumulation buffer.


\f3\%new pfShader\fP creates and returns a handle to a pfShader.  Like
other pfUpdatables, pfShaders are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfShaders should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfShader::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfShader\fP.  The \f3\%pfType\fP* returned
by \f3\%pfShader::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfShader\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfShader::setName\fP sets the name for the shader.
Note that this is only used for identifying purposes and by the pfb loader.
\f3\%pfShader::getName\fP returns the name of the
shader, if any.

\f3\%pfShader::openPass\fP starts a definition of a new
pass on a \f3\%pfShader\fP. \f3\%pfShader::closePass\fP
ends the definition of the currently open pass.
Upon opening a new pass, the application must provide a pass type from the types
mentioned above.
While a pass is open, an application may invoke methods
to define the parameters of the pass.

\f3\%pfShader::getCurPassType\fP returns the type of
the currently open pass. If no pass is currently open, it returns NULL.

\f3\%pfShader::getNumPasses\fP returns the number of
passes on a \f3\%pfShader\fP. This number does not include the currently open
pass.

\f3\%pfShader::getPassList\fP returns a pointer to a
\f3\%pfPassList\fP. A \f3\%pfPassList\fP contains the full description of all the
passes that were opened and closed on this \f3\%pfShader\fP. The \f3\%pfPassList\fP
pointer can be added to a \f3\%pfGeoSet\fP using the method
\f3\%pfGeoSet::setPassList\fP in order to change its drawing
behavior and make it use the \f3\%pfShader\fP passes instead of its standard
drawing function. Changing the \f3\%pfPassList\fP pointer on a \f3\%pfGeoSet\fP is
normally handled by the \f3\%pfShaderManager\fP.

\f3\%pfShader::setPassMode\fP  and
\f3\%pfShader::getPassMode\fP set and get
modes on the currently open pass. On passes of type
\f3\%PF_SHADERPASS_COPYPIXELS\fP, one can set the pixel copy direction by
setting \f2which\fP to \f3\%PF_SHADERPASS_COPYPIXELS_DIRECTION\fP and setting \f2mode\fP
to one of the following:

.RS
.TP 5
\f3\%PF_COPYPIXELSPASS_TO_TEXTURE\fP
- From frame buffer to Texture memory.
.TP
\f3\%PF_COPYPIXELSPASS_FROM_TEXTURE\fP
- From texture memory to frame buffer.
.TP
\f3\%PF_COPYPIXELSPASS_IN_PLACE\fP
- From frame buffer onto itself.
.RE

On passes of type \f3\%PF_SHADERPASS_ACCUM\fP, one can set the accumulation buffer
operation by setting \f2which\fP to \f3\%PF_SHADERPASS_ACCUM_OP\fP and setting
\f2mode\fP to one of the valid OpenGL \f3\%GLenum\fP's as the first parameter of
the OpenGL function \f3\%glAccum\fP. The \f3\%PF_SHADERPASS_ACCUM\fP passes \f2mode\fP
directly to the \f3\%glAccum\fP call.

\f3\%pfShader::setPassMultiMode\fP  and
\f3\%pfShader::getPassMultiMode\fP
set and get multi-valued
modes on the currently open pass. At the moment, there are no available modes
to set. This API is reserved for future extensions.

\f3\%pfShader::setPassAttr\fP  and
\f3\%pfShader::getPassAttr\fP set and get attributes on
the currently open pass.

On all pass types, setting \f2which\fP to
\f3\%PF_SHADERPASS_FBSTATE\fP and \f2attr\fP to a \f3\%pfFBState\fP pointer sets the
\f3\%pfFBState\fP that the currently open pass uses.

On passes of type \f3\%PF_SHADERPASS_GEOMETRY\fP and \f3\%PF_SHADERPASS_QUAD\fP,
setting \f2which\fP to \f3\%PF_SHADERPASS_GSTATE\fP
and \f2attr\fP to a \f3\%pfGeoState\fP pointer sets the \f3\%pfGeoState\fP that the
currently open pass uses.

On passes of type \f3\%PF_SHADERPASS_GEOMETRY\fP, setting \f2which\fP to
\f3\%PF_SHADERPASS_OVERRIDE_COLOR\fP and setting \f2attr\fP to a \f3\%pfVec4\fP pointer
sets the override color of the currently open pass to the input \f3\%pfVec4\fP.

On passes of type \f3\%PF_SHADERPASS_QUAD\fP, setting \f2which\fP to
\f3\%PF_SHADERPASS_COLOR\fP and setting \f2attr\fP to a \f3\%pfVec4\fP pointer sets the
quad color of the currently open pass.

On passes of type \f3\%PF_SHADERPASS_COPYPIXELS\fP, setting \f2which\fP to
\f3\%PF_SHADERPASS_TEXTURE\fP and setting \f2attr\fP to a \f3\%pfTexture\fP pointer sets
the texture used by the currently open pass.

\f3\%pfShader::setPassMultiAttr\fP  and
\f3\%pfShader::getPassMultiAttr\fP set and get
multi-value attributes on the currently open pass.  At the moment, there are no
available attributes to set. This API is reserved for future extensions.

\f3\%pfShader::setPassVal\fP  and
\f3\%pfShader::getPassVal\fP set and get values on
the currently open pass.

On passes of type \f3\%PF_SHADERPASS_COPYPIXELS\fP, setting \f2which\fP to
\f3\%PF_SHADERPASS_TEMP_TEXTURE_ID\fP and setting \f2value\fP to
a temporary texture ID determines what temporary texture this pass uses.
This value is not used internally by the pass. It serves as temporary storage
for the chosen texture ID.
A later call to \f3\%pfShader::setPassAttr\fP should supply
the actual \f3\%pfTexture\fP pointer for this pass.

On passes of type \f3\%PF_SHADERPASS_ACCUM\fP, setting \f2which\fP to
\f3\%PF_SHADERPASS_ACCUM_VAL\fP determines the second parameter of the call to
\f3\%glAccum\fP. The \f3\%PF_SHADERPASS_ACCUM\fP pass uses \f2value\fP as the second
parameter of the OpenGL \f3\%glAccum\fP call.

\f3\%pfShader::setPassMultiVal\fP  and
\f3\%pfShader::getPassMultiVal\fP set and get
multi-element values on the currently open pass. At the moment, there are no
available multi-element values to set. This API is reserved for future
extensions.

The following table contains a summary of the available attributes, modes and
values for each shader type:
.PP
.TS
center tab($) ;
c | c c c c .
Token$GEOMETRY$QUAD$COPYPIXELS$ACCUM
_
\f3\%PF_SHADERPASS_FBSTATE\fP$+$+$+$+
(Attribute)$$$$
\f3\%PF_SHADERPASS_GSTATE\fP$+$+$-$-
(Attribute)$$$$
\f3\%PF_SHADERPASS_OVERRIDE_COLOR\fP$+$-$-$-
(Attribute)$$$$
\f3\%PF_SHADERPASS_COLOR\fP$-$+$-$-
(Attribute)$$$$
\f3\%PF_SHADERPASS_TEXTURE\fP$-$-$+$-
(Attribute)$$$$
$$$$
\f3\%PF_SHADERPASS_COPYPIXELS_DIRECTION\fP$-$-$+$-
(Mode)$$$$
\f3\%PF_SHADERPASS_ACCUM_OP\fP$-$-$-$+
(Mode)$$$$
$$$$
\f3\%PF_SHADERPASS_TEMP_TEXTURE_ID\fP$-$-$+$-
(Value)$$$$
\f3\%PF_SHADERPASS_ACCUM_VAL\fP$-$-$-$+
(Value)$$$$
.TE
.PP

\f3\%pfShader::setDefaultGeoState\fP and
\f3\%pfShader::getDefaultGeoState\fP set and
get the shader default \f3\%pfGeoState\fP. All graphic state that isn't defined on
a pass \f3\%pfGeoState\fP is inherited from the \f3\%pfShader\fP \f3\%pfGeoState\fP.
Any graphic state that isn't specified on both the
default \f3\%pfGeoState\fP and the \f3\%pfShader\fP \f3\%pfGeoState\fP is inherited from a
hard-coded system default.

\f3\%pfShader::setDefaultFBState\fP and
\f3\%pfShader::getDefaultFBState\fP set and
get the shader default \f3\%pfFBState\fP. All frame-buffer state that isn't
defined on a pass \f3\%pfFBState\fP is inherited from the \f3\%pfShader\fP
\f3\%pfFBState\fP. Any frame-buffer state that isn't specified on both the
default \f3\%pfFBState\fP and the \f3\%pfShader\fP \f3\%pfFBState\fP is inherited from a
hard-coded system default.

\f3\%pfShader::allocateTempTexture\fP
returns the integer ID of the next available temporary texture for
the pfShader and increments the temporary texture count for the pfShader.

When constructing a new pfShader object,
\f3\%pfShader::allocateTempTexture\fP
must be called once for each unique temporary texture which will be
used by the pfShader.  The returned integer ID should be used for
subsequent calls to
\f3\%pfShader::setPassTempTexture\fP
and
\f3\%pfShader::setTempTexture\fP
for specifying texture IDs for passes and mapping pfTexture objects
to texture IDs.

When constructing a pass of a pfShader which requires a temporary
texture,
\f3\%pfShader::setPassTempTexture\fP
should be called to assign one of the texture IDs returned by
\f3\%pfShader::allocateTempTexture\fP
to the current pass.  This will create an association between the
pfShader's pass and one of the temporary texture IDs allocated with
\f3\%pfShader::allocateTempTexture\fP.
\f3\%pfShader::setPassTempTexture\fP
returns negative one if \f2texID\fP is less than zero or greater than or equal
to the temporary texture count for the pfShader. Negative one will
also be returned if the current pass is not a pfCopyPixelsPass.  Zero
is returned on successful assignment.


\f3\%pfShader::setTempTexture\fP maps the integer
\f2texID\fP returned by
\f3\%pfShader::allocateTempTexture\fP
to the pfTexture* \f2texture\fP.  In order to reduce texture memory usage
it is desirable for \f2texture\fP to point to a pfTexture object which
will be shared between multiple pfShaders.  This can be done because
the data stored in pfShader temporary textures is just that, temporary.
Once all the passes of one pfShader have been applied, another pfShader
can make use of the temporary texture for storing its own temporary
results.  Of course, it isn't required that pfTextures be shared between
pfShaders, it's just a good idea to do so and avoid wasting resources.
\f3\%pfShader::setPassTempTexture\fP
returns negative one if \f2texID\fP is less than zero or greater than or equal
to the temporary texture count for the pfShader.  Zero is returned on
success.


\f3\%pfShader::resolveTempTextures\fP
resolves the mapping from the per pass integer texture IDs assigned with
\f3\%pfShader::setPassTempTexture\fP to
the pfTexture pointers assigned with
\f3\%pfShader::setTempTexture\fP.  If
\f3\%pfShader::resolveTempTextures\fP
is not called, the passes of the pfShaders will not be assigned pointers
to pfTexture objects.
\f3\%pfShader::resolveTempTextures\fP
returns negative one if the current pass for the pfShader is still open.
Zero is returned on success.

When loading pfShaders with pfdLoadShader and mapping them to pfNodes
with the pfShaderManager, temporary texture management will be taken
care of automatically.  pfdLoadShader will make the appropriate calls
to \f3\%pfShader::allocateTempTexture\fP
and \f3\%pfShader::setPassTempTexture\fP
while the pfShaderManager will create a shared pool of pfTexture objects
and assign them to pfShaders with
\f3\%pfShader::setTempTexture\fP.  Finally,
once all texture IDs of all pfShaders have been mapped to pointers to
pfTextures in the shared pfTexture pool, the pfShaderManager will
call \f3\%pfShader::resolveTempTextures\fP
to map the texture IDs stored in each pfShader's passes to pfTexture
pointers.

\f3\%pfShader::getNumTempTextures\fP
returns the count of allocated temporary textures for the pfShader.

.SH NOTES

Shaded \f3\%pfGeoSets\fP can not be compiled into OpenGL display
lists. Applying a shader to a pfNode will disable that functionality
on all the \f3\%pfGeoSets\fP in the subtree rooted at that node. The function \f3\%pfGeoSet:setDrawMode\fP with the \f3\%PFGS_COMPILE_GL\fP or \f3\%PFGS_DRAW_GLOBJ\fP mode tokens will have no effect on shaded \f3\%pfGeoSets\fP.

.SH SEE ALSO
pfShaderManager,
pfGeoSet,
glAccum,
pfGeoState,
pfFBState
