'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfShaderManager" "3pf"
.SH NAME
.upperok
.B pfShaderManager
\- 
Create and manage mapping between shaders and scene graph nodes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfShaderManager.h>
.nf
.fi
.TP
\ 
\f3\%pfShaderManager::pfShaderManager\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfShaderManager::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfShaderManager::applyShader\fP(pfNode\ *node,
'in +2
'll -2
pfShader\ *shader);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfShaderManager::removeShader\fP(pfNode\ *node,
'in +2
'll -2
int\ shaderNum);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfShaderManager::getNumShaders\fP(pfNode\ *node);
.nf
.fi
.TP
pfShader *
\f3\%pfShaderManager::getShader\fP(pfNode\ *node,
'in +2
'll -2
int\ shaderNum);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfShaderManager::resolveShaders\fP(pfNode\ *node);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfShaderManager\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfShaderManager\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfShaderManager\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'smgr\ \ 'u
\f2smgr\fP
identifies a pfShaderManager.
.SH DESCRIPTION

These functions provide a means to apply pfShaders to scene graph
nodes, remove pfShaders from scene graph nodes and resolve sets of
pfShaders into representative pfPassLists for application to pfGeoSets.

\f3\%new pfShaderManager\fP creates and returns a handle to a pfShaderManager.
pfShaderManagers are always allocated from shared memory and cannot be
created statically, on the stack or in arrays.

\f3\%pfShaderManager::getClassType\fP
returns the \f3\%pfType\fP* for the class \f3\%pfShaderManager\fP.  The \f3\%pfType\fP*
returned by
\f3\%pfShaderManager::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfShaderManager\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfShaderManager::applyShader\fP
adds \f2shader\fP to \f2node\fP's pfShader list.  This list is maintained
internally by the pfShaderManager and is not a member of pfNode.
\f2shader\fP's reference count is incremented by one.  Zero is returned
on success, negative one is returned on failure.  Failure will occur
if either \f2node\fP or \f2shader\fP are NULL.

\f3\%pfShaderManager::removeShader\fP
removes the pfShader indexed by \f2shaderNum\fP from \f2node\fP's pfShader
list.  The reference count of the pfShader which is removed is decremented
by one. Zero is returned on success, negative one is returned on failure.
Failure will occur if either \f2node\fP is NULL or \f2shaderNum\fP is less
than zero or greater than the greatest pfShader index for \f2node\fP.

\f3\%pfShaderManager::getNumShaders\fP
returns the number of pfShaders in \f2node\fP's pfShaderList.  Returns
negative one on failure which will occur if \f2node\fP is NULL.  If \f2node\fP
is non-NULL but has had no pfShaders applied to it, zero is returned.

\f3\%pfShaderManager::removeShader\fP
returns a handle to the pfShader indexed by \f2shaderNum\fP in \f2node\fP's
pfShader list.  The reference count of the returned pfShader is not
incremented.  It is up to the caller to handle this.  NULL is returned
on failure which will occur if either \f2node\fP is NULL or \f2shaderNum\fP
is less than zero or greater than the greatest pfShader index for \f2node\fP.

\f3\%pfShaderManager::resolveShaders\fP
performs a depth first traversal of the sub-graph whose root is \f2node\fP.
At each node in the sub-graph, the pfShaderManager determines which, if
any, pfShaders have been applied to the current node and pushes these onto
the shader stack.

If the current node is a group node then
\f3\%pfShaderManager::resolveShaders\fP
continues its traversal into the current node's children.  If the current
node is a pfGeode then a pfPassList must be constructed and applied to all
pfGeoSets in the pfGeode.  To avoid creating unnecessary, duplicate
pfPassLists, the pfShaderManager maintains a dictionary of pfPassLists that
it has already created.  This dicionary is searchable by the shader stack
from which each pfPassList entry was created.  If the current shader stack
corresponds to a shader stack in the dictionary, the corresponding pfPassList
is retrieved from the dictionary and it is applied to all pfGeoSets of the
current pfGeode.  If no match for the current shader stack can be found in
the dictionary, then a new pfPassList must be created and added to the
dictionary.  To create a new pfPassList, a new pfPassList is allocated and
the pfPassLists of each pfShader in the shader stack are appended to it.
This new pfPassList and the corresponding shader stack are added to the
dictionary and the pfPassList is applied to all pfGeoSets of the current
pfGeode.

When leaving nodes, the pfShaderManager removes any pfShaders from the
shader stack which were applied at the current node.  In this way, the
net effect of the shader stack is for pfShaders which are applied to
group nodes to be inherited by child nodes.

.SH NOTES


.SH BUGS


.SH SEE ALSO
pfShader
