'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfSwitch" "3pf"
.SH NAME
.upperok
.B pfSwitch
\- 
Create, modify, and query a switch node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfSwitch.h>
.nf
.fi
.TP
\ 
\f3\%pfSwitch::pfSwitch\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfSwitch::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfSwitch::setVal\fP(float\ val);
.nf
.fi
.TP
float
\f3\%pfSwitch::getVal\fP(void);
.nf
.fi
.TP
int
\f3\%pfSwitch::setValFlux\fP(pfFlux\ *flux);
.nf
.fi
.TP
pfFlux *
\f3\%pfSwitch::getValFlux\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfSwitch\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfSwitch\fP.
This is also true for
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfGroup::addChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::insertChild\fP(int\ index,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::replaceChild\fP(pfNode\ *old,
'in +2
'll -2
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfGroup::removeChild\fP(pfNode*\ child);
.PD 0
.TP
int
\f3\%pfGroup::searchChild\fP(pfNode*\ child);
.PD 0
.TP
pfNode *
\f3\%pfGroup::getChild\fP(int\ index);
.PD 0
.TP
int
\f3\%pfGroup::getNumChildren\fP(void);
.PD 0
.TP
int
\f3\%pfGroup::bufferAddChild\fP(pfNode\ *child);
.PD 0
.TP
int
\f3\%pfGroup::bufferRemoveChild\fP(pfNode\ *child);

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfSwitch\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfSwitch\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfSwitch\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfSwitch is an interior node in the OpenGL Performer node hierarchy
that selects one, all, or none of its children.  It is derived from
pfGroup so it can use pfGroup API to manipulate its child list.

\f3\%new pfSwitch\fP creates and returns a handle to a pfSwitch.  Like other
pfNodes, pfSwitches are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfSwitches should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfSwitch::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfSwitch\fP.  The \f3\%pfType\fP* returned
by \f3\%pfSwitch::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfSwitch\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfSwitch::setVal\fP sets the switch value of
the pfSwitch to \f2val\fP.  \f2val\fP may
be a float ranging from 0 to N-1 with N being the number of children
of the pfSwitch or it may be a symbolic token: \f3\%PFSWITCH_ON\fP or
\f3\%PFSWITCH_OFF\fP in which case all children or no children are
selected.  \f3\%pfSwitch\fP uses the integer portion
of \f2val\fP. \f3\%pfSwitch::getVal\fP returns the current switch value.

The validity of the switch value delayed until the switch is actually
evaluated (usually by a traversal such as CULL). For example, it is legal
to set a switch value of 2
on a pfSwitch node with no children, provided at least 2 children are
added before the pfSwitch is evaluated.

\f3\%pfSwitch::setValFlux\fP and
\f3\%pfSwitch::getValFlux\fP set and get a pfFlux
to be used for controling a pfSwitch.  This is an alternate method of
contoling a pfSwitch.  If the value flux of a pfSwitch is \f3\%NULL\fP,
the switch will be contorlled by the value set with
\f3\%pfSwitch::setVal\fP.  A value flux should contain
a single float.  The integer portion of the float will be used to select
the switch setting.

Calling \f3\%pfSwitch::setVal\fP on a pfSwitch with a
non \f3\%NULL\fP value flux will set the value flux.
Calling \f3\%pfSwitch::getVal\fP on a pfSwitch with a
non \f3\%NULL\fP value flux will return the current data of the value flux.

.SH NOTES

\f3\%PF_ON\fP and \f3\%PF_OFF\fP tokens will NOT work with \f3\%pfSwitch::setVal\fP.
.SH SEE ALSO
pfGroup,
pfNode,
pfScene,
pfDelete
