'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexEnv" "3pf"
.SH NAME
.upperok
.B pfTexEnv,
.B pfGetCurTEnv
\- 
Create, modify and query texture environment
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfTexEnv\ *\ \ \ 'u
#include <Performer/pr/pfTexture.h>
.nf
.fi
.TP
\ 
\f3\%pfTexEnv::pfTexEnv\fP();
.nf
.fi
.TP
pfType *
\f3\%pfTexEnv::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexEnv::setMode\fP(int\ mode);
.nf
.fi
.TP
int
\f3\%pfTexEnv::getMode\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexEnv::setBlendColor\fP(float\ r,
'in +2
'll -2
float\ g,
float\ b,
float\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexEnv::getBlendColor\fP(float*\ r,
'in +2
'll -2
float*\ g,
float*\ b,
float*\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexEnv::apply\fP(void);
.nf
.fi
.TP
pfTexEnv *
\f3\%pfGetCurTEnv\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexEnv\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexEnv\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexEnv\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

\f3\%new\fP(arena) allocates a pfTexEnv from the specified memory arena,
or from the heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfTexEnv
from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like other
pfObjects, pfTexEnvs cannot be created statically, automatically on
the stack or in arrays.  pfTexEnvs should be deleted
with \f3\%pfDelete\fP rather than the delete operator.
See the OpenGL \f3\%glTexEnv(3g)\fP man
page for more details on texture environments.

\f3\%pfTexEnv::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexEnv\fP.  The \f3\%pfType\fP* returned
by \f3\%pfTexEnv::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfTexEnv\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfTexEnv::setMode\fP sets the texture environment mode.  \f2mode\fP is a
symbolic token that specifies a texture environment mode and is one of
the following:
.RS
\f3\%PFTE_MODULATE\fP
.br
\f3\%PFTE_BLEND\fP
.br
\f3\%PFTE_DECAL\fP
.br
\f3\%PFTE_REPLACE\fP
.br
\f3\%PFTE_ADD\fP
.br
\f3\%PFTE_ALPHA\fP
.RE

The default mode is \f3\%PFTE_MODULATE\fP.  \f3\%pfTexEnv::getMode\fP returns the
mode of the pfTexEnv.
See the OpenGL \f3\%glTexEnvf(3g)\fP man page for more details on
texture environments.

n\f3\%pfTexEnv::setBlendColor\fP sets the texture environment blend color.  This color is used when the texture environment mode is
\f3\%PFTE_BLEND\fP or \f3\%PFTE_ADD\fP.
The default OpenGL Performer texture environment
blend color is [1,1,1,1].
It is different from the default OpenGL blend color of [0,0,0,0].
This was done to maintain compatibility with previous OpenGL Performer releases.
\f3\%pfTexEnv::getBlendColor\fP copies the texture
environment blend color into \f2r\fP, \f2g\fP, \f2b\fP, \f2a\fP.

\f3\%pfTexEnv::apply\fP makes the pfTexEnv the current texture environment.  When
texturing is enabled (see below), this texture environment will be
applied to all geometry drawn after \f3\%pfTexEnv::apply\fP is called.  Only
one pfTexEnv may be active at a time although many may be defined.
Modifications to the pfTexEnv, such as changing the blend color, will not
have effect until \f3\%pfTexEnv::apply\fP is called.

For geometry to be textured, the following must be true:
.RS
.TP
1.
Texturing must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_TEXTURE\fP)
.TP
2.
A pfTexEnv must be applied: \f3\%pfTexEnv::apply\fP
.TP
3.
A pfTexture must be applied: \f3\%pfTexture::apply\fP
.TP
4.
Geometry must have texture coordinates: \f3\%pfGeoSet::setAttr\fP, \f3\%PFGS_TEXCOORD2\fP
.RE

The texture environment state element is identified by the
\f3\%PFSTATE_TEXENV\fP token.  Use this token with \f3\%pfGeoState::setAttr\fP to set
the texture environment of a pfGeoState and with \f3\%pfOverride\fP to
override subsequent texture environment changes.

Example 1:
.Ex
.nf

/* Set up blue 'blend' texture environment */
tev = new pfTexEnv;
tev->setMode(PFTE_BLEND);
tev->setBlendColor(0.0f, 0.0f, 1.0f);

/* Set up textured/blended pfGeoState */
gstate->setMode(PFSTATE_ENTEXTURE, PF_ON);
gstate->setAttr(PFSTATE_TEXENV, tev);
gstate->setAttr(PFSTATE_TEXTURE, tex);

/* Attach gstate to gset */
gset->setGState(gstate);

/* Set texture coordinate array. 'gset' is non-indexed */
gset->setAttr(PFGS_TEXCOORD2, PFGS_PER_VERTEX, tcoords, NULL);

/* Draw textured gset */
gset->draw();
.Ee
.fi
.na


Example 2:
.Ex
.nf

tev->apply();

/* Override so that all textured geometry uses 'tev' */
pfOverride(PFSTATE_TEXENV, PF_ON);
.Ee
.fi
.na


\f3\%pfTexEnv::apply\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP,
\f3\%pfTexEnv::apply\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDispList::draw\fP.

\f3\%pfGetCurTEnv\fP returns the currently active pfTexEnv or NULL if there
is no active pfTexEnv.
.SH NOTES


\f3\%PFTE_ALPHA\fP is supported only on RealityEngine graphics systems.

.SH SEE ALSO
pfDelete,
pfDispList,
pfEnable,
pfGeoState,
pfObject,
pfState,
pfTexture,
tevbind,
tevdef,
texbind,
texdef,
glTexEnv,
glTexImage2D.
