'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexGen" "3pf"
.SH NAME
.upperok
.B pfTexGen,
.B pfGetCurTGen
\- 
Create, modify and query texture coordinate generator
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfTexGen*\ \ \ 'u
#include <Performer/pr/pfTexture.h>
.nf
.fi
.TP
\ 
\f3\%pfTexGen::pfTexGen\fP();
.nf
.fi
.TP
pfType *
\f3\%pfTexGen::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexGen::setMode\fP(int\ texCoord,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfTexGen::getMode\fP(int\ texCoord);
.nf
.fi
.TP
void
\f3\%pfTexGen::setPlane\fP(int\ texCoord,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexGen::getPlane\fP(int\ texCoord,
'in +2
'll -2
float*\ x,
float*\ y,
float*\ z,
float*\ d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexGen::setPoint\fP(int\ texCoord,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ dx,
float\ dy,
float\ dz);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexGen::getPoint\fP(int\ texCoord,
'in +2
'll -2
float*\ x,
float*\ y,
float*\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexGen::apply\fP(void);
.nf
.fi
.TP
pfTexGen*
\f3\%pfGetCurTGen\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexGen\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexGen\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexGen\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'texCoord\ \ 'u
\f2texCoord\fP
identifies a texture coordinate and is one of:
.IP
\f3\%PF_S\fP,
\f3\%PF_T\fP,
\f3\%PF_R\fP,
\f3\%PF_Q\fP
.PP
.SH DESCRIPTION

The \f3\%pfTexGen\fP capability is used to automatically generate texture
coordinates for geometry, typically for special effects like projected
texture, reflection mapping, and for light points (\f3\%pfLPointState\fP).
\f3\%new\fP(arena) allocates a pfTexGen from the specified memory arena,
or from the heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfTexGen
from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like other
pfObjects, pfTexGens cannot be created statically, automatically on
the stack or in arrays.  pfTexGens should be deleted with \f3\%pfDelete\fP
rather than the delete operator.

\f3\%pfTexGen::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexGen\fP.  The \f3\%pfType\fP* returned
by \f3\%pfTexGen::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfTexGen\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfTexGen::setMode\fP sets the mode of the pfTexGen corresponding to texture
coordinate \f2texCoord\fP to \f2mode\fP. \f2mode\fP must be one of the
following:

.RS
.TP
\f3\%PFTG_OFF\fP
Disables texture coordinate generation
.TP
\f3\%PFTG_OBJECT_LINEAR\fP
Generate texture coordinate as distance from plane in object space.
.TP
\f3\%PFTG_EYE_LINEAR\fP
Generate texture coordinate as distance from plane in eye space. The plane
is transformed by the inverse of the ModelView matrix when
the pfTexGen is
applied.
.TP
\f3\%PFTG_EYE_LINEAR_IDENT\fP
Generate texture coordinate as distance from plane in eye space. The plane
is not transformed by the inverse of the ModelView matrix.
.TP
\f3\%PFTG_SPHERE_MAP\fP
Generate texture coordinate based on the view vector reflected about
the vertex normal in eye space.
.TP
\f3\%PFTG_OBJECT_DISTANCE_TO_LINE\fP
Coordinate will be the distance in object space from the vertex to
a line specified with a point and direction vector through \f3\%pfTGenPoint\fP.
.TP
\f3\%PFTG_EYE_DISTANCE_TO_LINE\fP
Coordinate will be the distance in eye space from the eye to
a line specified with \f3\%pfTGenPoint\fP through the vertex.
.RE

See the OpenGL \f3\%glTexGen(3g)\fP man page for the
specific mathematics of the texture coordinate generation modes.

The default texture generation mode for all texture coordinates is
\f3\%PFTG_OFF\fP. \f3\%pfTexGen::getMode\fP returns the mode of the pfTexGen.

\f3\%pfTexGen::setPlane\fP sets the plane equation used for generating
coordinates for texture coordinate \f2texCoord\fP to \f2a\fPX + \f2b\fPY +
\f2c\fPZ + \f2d\fP = 0. This plane equation is used when the pfTexGen's mode is
\f3\%PFTG_EYE_LINEAR\fP, \f3\%PFTG_EYE_LINEAR_IDENT\fP, or \f3\%PFTG_OBJECT_LINEAR\fP
but is ignored when its mode is \f3\%PFTG_SPHERE_MAP\fP. The default plane
equations are:

.RS
\f3\%PF_S\fP: (1, 0, 0, 0)
.TP
\f3\%PF_T\fP: (0, 1, 0, 0)
.TP
\f3\%PF_R\fP: (0, 0, 1, 0)
.TP
\f3\%PF_Q\fP: (0, 0, 0, 1)
.RE

\f3\%pfTexGen::getPlane\fP will return the
plane equation parameters for texture coordinate \f2texCoord\fP
of the pfTexGen in \f2x\fP, \f2y\fP, \f2z\fP, \f2d\fP.
(If any of those arguments are NULL, they will be ignored.)

\f3\%pfTexGen::setPoint\fP sets a point and possible
direction vector for use with point and line based texture generation
functions.
\f3\%pfTexGen::getPoint\fP will return the point
of the pfTexGen in \f2x\fP, \f2y\fP, \f2z\fP.

\f3\%pfTexGen::apply\fP configures the graphics hardware with the texture
coordinate generating parameters encapsulated by the pfTexGen.  Only the
most recently applied pfTexGen is active although any number of
pfTexGen definitions may be created.  Texture coordinate generation
must be enabled (\f3\%pfEnable\fP(\f3\%PFEN_TEXGEN\fP)) for the pfTexGen to have
effect and modifications made to the pfTexGen do not have effect until the
next time \f3\%pfTexGen::apply\fP is called. \f3\%pfGetCurTGen\fP returns the
currently active pfTexGen.

The pfTexGen state element is identified by the \f3\%PFSTATE_TEXGEN\fP
token.  Use this token with \f3\%pfGeoState::setAttr\fP to set the pfTexGen
attribute of a pfGeoState and with \f3\%pfOverride\fP to override
subsequent pfTexGen changes.:

Example 1:
.Ex
.nf

/* Set up pfGeoState */
gstate->setMode(PFSTATE_ENTEXGEN, PF_ON);
gstate->setAttr(PFSTATE_TEXGEN, new pfTexGen);

/* Attach gstate to gset */
gset->setGState(gstate);

/* Draw pfGeoSet whose texture coordinates are generated */
gset->draw();
.Ee
.fi
.na


Example 2:
.Ex
.nf

/* Override so that all geometry is affected by 'tgen' */
pfEnable(PFEN_TEXGEN);
tgen->apply();
pfOverride(PFSTATE_TEXGEN | PFSTATE_ENTEXGEN, PF_ON);
.Ee
.fi
.na


\f3\%pfTexGen::apply\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfDispList::open\fP,
\f3\%pfTexGen::apply\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDispList::draw\fP.

.SH SEE ALSO
pfDelete,
pfDispList,
pfGeoState,
pfLPointState,
pfMemory,
pfObject,
pfOverride,
texgen,
glTexGen.
