'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexLOD" "3pf"
.SH NAME
.upperok
.B pfTexLOD,
.B pfGetCurTLOD
\- 
A texture level of detail control structure.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfTexLOD\ *\ \ \ 'u
#include <Performer/pr/pfTexture.h>
.nf
.fi
.TP
\ 
\f3\%pfTexLOD::pfTexLOD\fP();
.nf
.fi
.TP
pfType *
\f3\%pfTexLOD::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexLOD::setRange\fP(float\ min,
'in +2
'll -2
float\ max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLOD::getRange\fP(float\ *min,
'in +2
'll -2
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLOD::setBias\fP(float\ biasS,
'in +2
'll -2
float\ biasT,
float\ biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLOD::getBias\fP(float\ *biasS,
'in +2
'll -2
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLOD::apply\fP(void);
.nf
.fi
.TP
pfTexLOD *
\f3\%pfGetCurTLOD\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexLOD\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexLOD\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexLOD\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

\f3\%new\fP(arena) allocates a pfTexLOD from the specified memory arena,
or from the heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfTexLOD
from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like other
pfObjects, pfTexLODs cannot be created statically, automatically on
the stack or in arrays.  pfTexLODs should be deleted
with \f3\%pfDelete\fP rather than the delete operator.
Texture LOD control is only supported under OpenGL operation that
the texture_lod extensions.
See the or OpenGL \f3\%glIntro(3g)\fP for a list of supported extensions
and their descriptions.

\f3\%pfTexLOD::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexLOD\fP.  The \f3\%pfType\fP* returned
by \f3\%pfTexLOD::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfTexLOD\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfTexLOD::apply\fP makes the pfTexLOD
the texture LOD control parameters. When texturing is enabled,
the texture LOD parameters set \f2tlod\fP will be applied to the current texture.
Texture LOD parameters set directly on a pfTexture will take priority over those
set in any pfTexLOD.
Only one pfTexLOD may be active at a time although many may be defined.
Modifications to the pfTexLOD, such as changing the range, will not
have effect until \f3\%pfTexLOD::apply\fP is called.

The texture LOD state element is identified by the \f3\%PFSTATE_TEXLOD\fP token.
Use this token with \f3\%pfGeoState::setAttr\fP to set
a texture LOD configuration on a pfGeoState and with \f3\%pfOverride\fP to
override subsequent texture LOD.

A pfTexLOD will only take affect if texture LOD control is currently enabled.
Texture LOD control can be enabled directly via pfEnable using the \f3\%PFEN_TEXLOD\fP
token and enable on a pfGeoState with the \f3\%PFSTATE_ENTEXLOD\fP token and the
boolean value to \f3\%pfGeoState::setMode\fP.

\f3\%pfTexLOD::setRange\fP will set the current texture
lod range to use only levels \f2min\fP through \f2max\fP where \f2min\fP is
the highest resolution level and \f2max\fP is the lowest resolution
MIPmap.  This can be used in conjunction with texture paging to limit
access of level of a texture that have currently been loaded.  Because
the min/max limits can be floating point values, new levels can be
smoothly blended in when they become available to avoid a popping.
LOD range can also be used for more efficient use of texture memory where
allow different geometry textured with different images to share a
texture where a near object references the high resolution levels
and a object use the low resolution levels.
\f3\%pfTexLOD::getRange\fP will return
the LOD range.  Either of the arguments min,max may be NULL
in which case it will be ignored.

\f3\%pfTexLOD::setBias\fP will set s, t, and r bias values for the
texture level of detail computation to be \f2biasS\fP, \f2biasT\fP, and \f2biasR\fP,
respectively.   These bias values can be used to compensate for asymmetric
minification of a MIPmapped texture; to force blurring of a texture to
simulate motion blur and depth of field, or to force a texture to be sharper.
This functionality uses the texture_lod_bias extension of OpenGL
and the exact use of these bias values is explained in the \f3\%glIntro\fP man page.
\f3\%pfTexLOD::getBias\fP will return the LOD bias.
Any of the arguments biasS,biasT,biasR may be NULL in which case
it will be ignored.

\f3\%pfGetCurTLOD\fP will return the most recently applied pfTexLOD as
applied through a pfGeoState, or \f3\%pfApplyTLOD\fP.

.SH SEE ALSO
pfDelete,
pfDispList,
pfEnable,
pfGeoState,
pfObject,
pfState,
pfTexture,
glIntro,
glTexImage2D.
