'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexLoad" "3pf"
.SH NAME
.upperok
.B pfTexLoad
\- 
Create, modify, and apply a texture load. Several sources can
be loaded into a GL texture (pfTexture).
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pr/pfTexLoad.h>
.nf
.fi
.TP
\ 
\f3\%pfTexLoad::pfTexLoad\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfTexLoad::getClassType\fP();
.nf
.fi
.TP
void
\f3\%pfTexLoad::setSrcOrg\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoad::getSrcOrg\fP(int\ *s,
'in +2
'll -2
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoad::setDstOrg\fP(int\ s,
'in +2
'll -2
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoad::getDstOrg\fP(int\ *s,
'in +2
'll -2
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoad::setSrc\fP(void\ *src);
.nf
.fi
.TP
void *
\f3\%pfTexLoad::getSrc\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setSrcLevel\fP(int\ lvl);
.nf
.fi
.TP
int
\f3\%pfTexLoad::getSrcLevel\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setDst\fP(void\ *tex);
.nf
.fi
.TP
void *
\f3\%pfTexLoad::getDst\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setDstLevel\fP(int\ lvl);
.nf
.fi
.TP
int
\f3\%pfTexLoad::getDstLevel\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setSize\fP(int\ w,
'in +2
'll -2
int\ h,
int\ d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoad::getSize\fP(int\ *w,
'in +2
'll -2
int\ *h,
int\ *d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoad::setFrame\fP(int\ frameCount);
.nf
.fi
.TP
int
\f3\%pfTexLoad::getFrame\fP(void);
.nf
.fi
.TP
int
\f3\%pfTexLoad::getPrevLoadedTexels\fP(void);
.nf
.fi
.TP
int
\f3\%pfTexLoad::getDirty\fP(void);
.nf
.fi
.TP
int
\f3\%pfTexLoad::setDirty\fP(int\ dirtmask);
.nf
.fi
.TP
int
\f3\%pfTexLoad::getStatus\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setAttr\fP(int\ attr,
'in +2
'll -2
void\ *val);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfTexLoad::getAttr\fP(int\ attr);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfTexLoad::getMode\fP(int\ mode);
.nf
.fi
.TP
void
\f3\%pfTexLoad::setVal\fP(int\ which,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfTexLoad::getVal\fP(int\ which);
.nf
.fi
.TP
int
\f3\%pfTexLoad::apply\fP();
.nf
.fi
.TP
int
\f3\%pfTexLoad::apply\fP(int\ texels);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexLoad\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexLoad\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexLoad\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

\f3\%pfTexLoad\fP is used to control the mapping from texture images external
to the GL to texture images currently loaded into the GL.  Each \f3\%pfTexLoad\fP
defines a load of a certain size from the origin of one of several sources
to a origin in a destination pfTexture which corresponds to a GL texture.
The functionality of this structure is to provide robust support for
\f3\%glTexImage2D\fP and \f3\%glTexSubImage2DEXT\fP.

\f3\%new\fP(arena) allocates a pfTexLoad from the specified memory arena, or
from the process heap if \f2arena\fP is NULL. \f3\%new\fP allocates a pfTexLoad
from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like other
pfObjects, pfTexLoads cannot be created statically, automatically on the
stack or in arrays and should be deleted with \f3\%pfDelete\fP rather than
the delete operator.

\f3\%pfTexLoad::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexLoad\fP.  The \f3\%pfType\fP* returned
by \f3\%pfTexLoad::getClassType\fP is the same
as the \f3\%pfType\fP* returned by invoking the virtual
function \f3\%getType\fP on any instance of class \f3\%pfTexLoad\fP.  When
decisions are made based on the type of an object, it is usually better
to us  the member function \f3\%isOfType\fP to test
if an object is of a type derived from a Performer type rather than
to test for strict equality of the \f3\%pfType\fP's.

The \f3\%pfTexLoad::setMode\fP and
\f3\%pfTexLoad::getMode\fP routines set and get
the modes of operation for a pfTexLoad.
Current modes include:

.RS
\f3\%PFTLOAD_SOURCE\fP
.br
\f3\%PFTLOAD_DEST\fP
.br
\f3\%PFTLOAD_SYNC\fP
.br
\f3\%PFTLOAD_SYNC_SOURCE\fP
.br
\f3\%PFTLOAD_AUTOREF\fP
.RE

\f3\%PFTLOAD_SOURCE\fP defines the nature of the source of imagery for
the texture download.  The only currently supported value is:

.RS
\f3\%PFTLOAD_SOURCE_IMAGETILE\fP
.RE

but in future releases the following sources will be supported:

.RS
\f3\%PFTLOAD_SOURCE_IMAGEARRAY\fP
.br
\f3\%PFTLOAD_SOURCE_IMAGETILE\fP
.br
\f3\%PFTLOAD_SOURCE_TEXTURE\fP
.br
\f3\%PFTLOAD_SOURCE_VIDEO\fP
.br
\f3\%PFTLOAD_SOURCE_FRAMEBUFFER\fP
.RE

\f3\%PFTLOAD_DEST\fP currently only supports the \f3\%PFTLOAD_DEST_TEXTURE\fP
as a destination type.

\f3\%PFTLOAD_SYNC\fP defines when the pfTexLoad needs to take place.
Currently the only supported value for this mode is
\f3\%PFTLOAD_SYNC_IMMEDIATE\fP - meaning the download should take place
immediately.

\f3\%PFTLOAD_SYNC_SOURCE\fP defines whether the load should require confirmation
of valid data from the source before loading.  Possible values are PF_ON
and PF_OFF where a value of PF_ON means the load will only take place
after valid data is available from the load source.  A value of PF_OFF
will cause the pfTexLoad to complete its download with whatever data is
available from the source regardless of its validity.

\f3\%PFTLOAD_AUTOREF\fP defines whether pfTexLoads should use \f3\%pfUnref\fP
when they get applied in pfDispList's.  This mode allows users to keep
track via a reference count when the texture load actually took place.
This in turn facilitates reuse of pfTexLoad structures.

\f3\%pfTexLoad::setAttr\fP and
\f3\%pfTexLoad::getAttr\fP set and get attributes
of a pfTexLoad.

\f3\%PFTLOAD_SOURCE\fP and \f3\%PFTLOAD_DEST\fP allow the user to specify the
source and destination for a pfTexLoad.  These attributes are equivalent
to making respective calls to \f3\%pfTLoadSrc\fP and \f3\%pfTLoadDst\fP.

\f3\%pfTexLoad::setVal\fP allows the user to specify
all of the values associated with a pfTexLoad.  This is redundant api
allowing for the generic setting of values that otherwise have individual
explicit sets/gets associated with them.
Current value tokens:

.RS
\f3\%PFTLOAD_SOURCE_LEVEL\fP
.br
\f3\%PFTLOAD_SOURCE_S\fP
.br
\f3\%PFTLOAD_SOURCE_T\fP
.br
\f3\%PFTLOAD_SOURCE_T\fP
.br
\f3\%PFTLOAD_SOURCE_R\fP
.br
\f3\%PFTLOAD_DEST_LEVEL\fP
.br
\f3\%PFTLOAD_DEST_S\fP
.br
\f3\%PFTLOAD_DEST_T\fP
.br
\f3\%PFTLOAD_DEST_R\fP
.br
\f3\%PFTLOAD_WIDTH\fP
.br
\f3\%PFTLOAD_HEIGHT\fP
.br
\f3\%PFTLOAD_DEPTH\fP
.RE

\f3\%pfTexLoad::setSrc\fP sets the source data for the
pfTexLoad.  Currently the only supported source type for pfTexLoads
is PFTLOAD_SOURCE_IMAGETILE and therefore \f2_src\fP must point to a
pfImageTile.
\f3\%pfTexLoad::getSrc\fP returns the pointer (if any)
to the source data for the pfTexLoad.

\f3\%pfTexLoad::setDst\fP sets the destination texture
for the pfTexLoad.  \f3\%pfTexLoad::getDst\fP returns
a pointer to the pfTexture destination.

\f3\%pfTexLoad::setDstLevel\fP sets a specific mipmap
level in the destination pfTexture for this texture load.
\f3\%pfTexLoad::getDstLevel\fP returns the
currently specified target mipmap level for the pfTexLoad.

\f3\%pfTexLoad::setSrcLevel\fP sets a specific level
from which to get data from the source object.  This value will not be
used until pfTexture's are supported as source's for pfTexLoads.
\f3\%pfTexLoad::getSrcLevel\fP will return the
current source level from which to retrieve load data if the source type
is \f3\%PFTLOAD_SOURCE_TEXTURE\fP.

\f3\%pfTexLoad::setSize\fP sets the size of the pfTexLoad.
\f2w\fP*\f2h\fP*\f2d\fP texels will be downloaded when the pfTexLoad is applied.
\f3\%pfTexLoad::getSize\fP returns the currently
configured size of the pfTexLoad.

\f3\%pfTexLoad::setSrcOrg\fP sets the origin inside
a larger image from which to retrieve the imagery that should be downloaded.
\f3\%pfTexLoad::getSrcOrg\fP returns the origin of
the download data within the possibly larger source imagery.

\f3\%pfTexLoad::setDstOrg\fP sets the origin inside
the destination pfTexture where the pfTexLoad should place its rectangular
download region.

The above routines could be used to easily configure a download of a 256x256x1
sub-region of a 2048x1024x1 source image into a specific tile within a
512x512x1 texture. In the above example if a user wished to download the
top right-hand corner of the source imagery into the middle of the destination
512x512x1 texture, \f3\%pfTLoadSrc\fP would be called with a pfImageTile
representing the 2048x1024x1 source data, \f3\%pfTLoadDst\fP would be called
with the appropriate 512x512x1 pfTexture, \f3\%pfTLoadSize\fP would be called
with parameters 256,256,1. \f3\%pfTLoadSrcOrg\fP would be called with a value
of 1792,768,0 and \f3\%pfTLoadDstOrg\fP would be called with a value of
128,128,0.

\f3\%pfTexLoad::apply\fP causes the preconfigured
texture download to take place.  If there is a current pfDispList active
then the pfTexLoad will place itself into the pfDispList and the pfTexLoad
apply which will perform the download will happen when the pfDispList is
drawn.  Otherwise the texture download will happen immediately.

\f3\%pfTexLoad::apply(int nTexels)\fP acts just
like the normal apply except that \f2nTexels\fP is used to describe a subset
of texels to download in the current apply.  Note that the actual apply
can only download on row boundaries and so the actual downloaded number
of texels may differ slightly from that dictated by the user.  Partial
applies always start at the bottom, lower left-hand corner of the image
and count to the right and then up where each row must be loaded before
the next is started. For example in the case of a 4x4 texture, a partial
download of 4 texels will cause the bottom row of the texture to be downloaded
and not the bottom left 2x2 region. A subsequent call causing another partial
download of 4 texels would download the 2nd row, and so on.
.SH SEE ALSO
pfTexture,
pfImageTile,
glTexImage2D,
glTexSubImage2DEXT
