'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfText" "3pf"
.SH NAME
.upperok
.B pfText
\- 
Create, modify, and query a 3D text node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType\ *\ \ \ 'u
#include <Performer/pf/pfText.h>
.nf
.fi
.TP
\ 
\f3\%pfText::pfText\fP();
.nf
.fi
.TP
static pfType *
\f3\%pfText::getClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfText::addString\fP(pfString*\ string);
.nf
.fi
.TP
int
\f3\%pfText::removeString\fP(pfString*\ str);
.nf
.fi
.TP
int
\f3\%pfText::insertString\fP(int\ index,
'in +2
'll -2
pfString*\ str);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfText::replaceString\fP(pfString*\ old,
'in +2
'll -2
pfString*\ new);
.in
.ll
.nf
.fi
.TP
pfString *
\f3\%pfText::getString\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfText::getNumStrings\fP(const\ pfString*\ string);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfText\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfText\fP.
This is also true for
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfNode::getParent\fP(int\ i);
.PD 0
.TP
int
\f3\%pfNode::getNumParents\fP(void);
.PD 0
.TP
void
\f3\%pfNode::setBound\fP(pfSphere\ *bsph,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getBound\fP(pfSphere\ *bsph);
.PD 0
.TP
pfNode*
\f3\%pfNode::clone\fP(int\ mode);
.PD 0
.TP
pfNode*
\f3\%pfNode::bufferClone\fP(int\ mode,
'in +2
'll -2
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::flatten\fP(int\ mode);
.PD 0
.TP
int
\f3\%pfNode::setName\fP(const\ char\ *name);
.PD 0
.TP
const char *
\f3\%pfNode::getName\fP(void);
.PD 0
.TP
pfNode*
\f3\%pfNode::find\fP(const\ char\ *pathName,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfNode::lookup\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::isect\fP(pfSegSet\ *segSet,
'in +2
'll -2
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravMask\fP(int\ which,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfNode::getTravMask\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::getTravFuncs\fP(int\ which,
'in +2
'll -2
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNode::setTravData\fP(int\ which,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfNode::getTravData\fP(int\ which);
.PD 0
.TP
void
\f3\%pfNode::setTravMode\fP(int\ which,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfNode::getTravMode\fP(int\ which,
'in +2
'll -2
int\ mode)\ const;
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfText\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfText\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH PARAMETERS
.TP \w'string\ \ 'u
\f2string\fP
identifies a pfString.
.SH DESCRIPTION

A pfText is analogous to a \f3\%pfGeode\fP.  A pfText encapsulates
pfStrings in a scene graph as a \f3\%pfGeode\fP encapsulates
\f3\%pfGeoSet\fPs.  A pfText is a leaf node in the OpenGL Performer scene
graph hierarchy and is derived from \f3\%pfNode\fP so it can use
\f3\%pfNode\fP API.  A pfText is simply a list of pfStrings.

The bounding volume of a pfText is that which surrounds all its
pfStrings.  Unless the bounding volume is considered static (see
\f3\%pfNode::setBound\fP), OpenGL Performer will compute a new volume when the
list of pfStrings is modified by \f3\%pfText::addString\fP, \f3\%pfText::removeString\fP,
\f3\%pfText::insertString\fP or \f3\%pfText::replaceString\fP.  If the bounding box of a child
pfString changes, call \f3\%pfNode::setBound\fP to tell OpenGL Performer to
update the bounding volume of the pfText.

\f3\%new pfText\fP creates and returns a handle to a pfText.  Like other
pfNodes, pfTexts are always allocated from shared memory
and cannot be created statically, on the stack or in arrays.
pfTexts should be deleted using \f3\%pfDelete\fP rather than the
delete operator.

\f3\%pfText::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfText\fP.  The \f3\%pfType\fP* returned
by \f3\%pfText::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfText\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfText::addString\fP appends \f2str\fP to the pfText's pfString list.
\f3\%pfText::removeString\fP removes \f2str\fP from the list and shifts the list
down over the vacant spot.  For example, if \f2str\fP had index 0, then
index 1 becomes index 0, index 2 becomes index 1 and so on.
\f3\%pfText::removeString\fP returns a 1 if \f2str\fP was actually removed and 0 if
it was not found in the list.  \f3\%pfText::addString\fP and \f3\%pfText::removeString\fP will
cause OpenGL Performer to recompute new bounding volumes for the pfText unless
it is configured to use static bounding volumes.

\f3\%pfText::insertString\fP will insert \f2str\fP before the pfString with index
\f2index\fP.  \f2index\fP must be within the range 0 to
\f3\%pfText::getNumStrings\fP().  \f3\%pfText::replaceString\fP replaces \f2old\fP with
\f2new\fP and returns 1 if the operation was successful or 0 if \f2old\fP
was not found in the list.  \f3\%pfText::insertString\fP and \f3\%pfText::replaceString\fP will
cause OpenGL Performer to recompute new bounding volumes for the pfText
unless it is configured to use static bounding volumes.

\f3\%pfText::getNumStrings\fP returns the number of pfStrings in the pfText.
\f3\%pfText::getString\fP returns a handle to the pfString with index \f2index\fP or
\f3\%NULL\fP if the index is out of range.

Here is a sample code snippet demonstrating how to use
pfText, pfFont, and pfString to add 3D text to a scene graph:

.Ex
.nf

/* Initialize Performer and create pfScene "scene" */

/* Get shared memory arena */
arena = pfGetSharedArena();

/* Append standard directories to Performer search path, PFPATH */
pfFilePath(".:/usr/share/Performer/data");

/* Create 3D message and place in scene. */
text = new pfText;
scene->addChild(text);
if (pfFindFile("Times-Elfin.of", path, R_OK))
{
    str = new pfString;
    str->setMode(PFSTR_DRAWSTYLE, PFSTR_EXTRUDED);
    str->setMode(PFSTR_JUSTIFY, PFSTR_MIDDLE);
    str->setColor(1.0f, 0.0f, 0.8f, 1.0f);
    str->setString("Welcome to OpenGL Performer");
    str->flatten();
    text->addString(str);
}
else
{
    pfNotify(PFNFY_WARN,PFNFY_PRINT,"Couldn't find font file.");
    exit(0);
}
.Ee
.fi
.na


.SH SEE ALSO
pfGeoSet,
pfNode,
pfString,
pfFont,
pfDelete
