'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfType" "3pf"
.SH NAME
.upperok
.B pfType
\- 
pfType data typing system
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ char\ *\ \ \ 'u
#include <Performer/pr/pfType.h>
.nf
.fi
.TP
\ 
\f3\%pfType::pfType\fP(pfType\ *parent,
'in +2
'll -2
char\ *name);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfType::operator new\fP(size_t\ s);
.nf
.fi
.TP
const char *
\f3\%pfType::getName\fP();
.nf
.fi
.TP
pfType *
\f3\%pfType::getParent\fP();
.nf
.fi
.TP
int
\f3\%pfType::isDerivedFrom\fP(pfType\ *ancestor);
.nf
.fi
.TP
void
\f3\%pfType::setMaxTypes\fP(int\ n);
.fi
.SH DESCRIPTION

Objects derived from pfMemory have an associated pfType.  An object's
pfType* is returned by calling pfMemory::getType.

\f3\%pfType::getParent\fP returns the parent
class of the pfType.  Note that Performer only uses single inheritance
and the type system only maintains a single inheritance chain.

\f3\%pfType::getName\fP returns the name of the
class.

\f3\%pfType::isDerivedFrom\fP tests whether
the pfType has \f2ancestor\fP somewhere in its inheritance ancestry.
It returns TRUE if the ancestor was found, and FALSE otherwise.

The type system must be initialized in shared memory before other
processes that will share the type system are created.  When the type
system is initialized by \f3\%pfInit\fP, each Performer class creates a
type for itself.  \f3\%new pfType(pfType*,char*)\fP
allows an application to add additional types to the type system.
\f2parent\fP specifies the parent class, or NULL if the class has no
parents.  \f2name\fP is the name of the class.  pfTypes must be
explicitly new'ed, i.e. they cannot be created statically or
automatically on the stack.

\f3\%pfType::setMaxTypes\fP allows an application
to increase the number of allowed types.  This must be called before
\f3\%pfInit\fP to have effect.

pfMemory also has two convenience functions
\f3\%pfMemory::isOfType\fP,
\f3\%pfMemory::getTypeName\fP that allow
access to type information with a single call.

Because OpenGL Performer allows subclassing of built-in types, when
decisions are made based on the type of an object, it is usually
better to use
\f3\%pfType::isDerivedFrom\fP
or
\f3\%pfMemory::isOfType\fP
to test the type of an object rather than to test for the strict
equality of the \f3\%pfType\fP*'s.
.SH NOTES

pfTypes cannot be deleted.
.SH SEE ALSO
pfMemory
