'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVec2" "3pf"
.SH NAME
.upperok
.B pfVec2
\- 
Set and operate on 2-component vectors
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfVec2&\ \ \ 'u
#include <Performer/pr/pfLinMath.h>
.nf
.fi
.TP
void*
\f3\%pfVec2::operator new\fP(size_t);
.nf
.fi
.TP
void*
\f3\%pfVec2::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfVec2::pfVec2\fP();
.nf
.fi
.TP
\ 
\f3\%pfVec2::pfVec2\fP(float\ x,
'in +2
'll -2
float\ y);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec2::addScaled\fP(const\ pfVec2&\ v1,
'in +2
'll -2
float\ s,
const\ pfVec2&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec2::add\fP(const\ pfVec2&\ v1,
'in +2
'll -2
const\ pfVec2&\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfVec2::almostEqual\fP(const\ pfVec2&\ v2,
'in +2
'll -2
float\ tol);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec2::combine\fP(float\ s1,
'in +2
'll -2
const\ pfVec2&\ v1,
float\ s2,
const\ pfVec2&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec2::copy\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
float
\f3\%pfVec2::distance\fP(const\ pfVec2&\ pt2);
.nf
.fi
.TP
float
\f3\%pfVec2::dot\fP(const\ pfVec2&\ v2);
.nf
.fi
.TP
int
\f3\%pfVec2::equal\fP(const\ pfVec2&\ v2);
.nf
.fi
.TP
float
\f3\%pfVec2::length\fP(void);
.nf
.fi
.TP
void
\f3\%pfVec2::negate\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
float
\f3\%pfVec2::normalize\fP(void);
.nf
.fi
.TP
void
\f3\%pfVec2::scale\fP(float\ s,
'in +2
'll -2
const\ pfVec2&\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec2::set\fP(float\ x,
'in +2
'll -2
float\ y);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfVec2::sqrDistance\fP(const\ pfVec2&\ pt2);
.nf
.fi
.TP
void
\f3\%pfVec2::sub\fP(const\ pfVec2&\ v1,
'in +2
'll -2
const\ pfVec2&\ v2);
.in
.ll
.nf
.fi
.TP
float&
\f3\%pfVec2::operator []\fP(int\ i);
.nf
.fi
.TP
int
\f3\%pfVec2::operator ==\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
pfVec2
\f3\%pfVec2::operator -\fP()\ const;
.nf
.fi
.TP
pfVec2
\f3\%pfVec2::operator +\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
pfVec2
\f3\%pfVec2::operator -\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
pfVec2&
\f3\%pfVec2::operator =\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
pfVec2&
\f3\%pfVec2::operator *=\fP(float\ d);
.nf
.fi
.TP
pfVec2&
\f3\%pfVec2::operator /=\fP(float\ d);
.nf
.fi
.TP
pfVec2&
\f3\%pfVec2::operator +=\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
pfVec2&
\f3\%pfVec2::operator -=\fP(const\ pfVec2&\ v);
.nf
.fi
.TP
pfVec2
\f3\%pfVec2::operator *\fP(const\ pfVec2&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.nf
.fi
.TP
pfVec2
\f3\%pfVec2::operator *\fP(float\ d,
'in +2
'll -2
const\ pfVec2&\ v);
.in
.ll
.nf
.fi
.TP
pfVec2
\f3\%pfVec2::operator /\fP(const\ pfVec2&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.fi

.Ex
.nf

struct pfVec2 {
    float vec[2];
};
.Ee
.fi
.na

.SH DESCRIPTION

Math functions for 2-component vectors.  Most of these routines have
macro equivalents.

Most accesses to pfVec2 go through pfVec2::operator[], but pfVec2 is a
public struct whose data member vec is directly accessible, e.g.  for
passing to a routine expecting a float* such as glTexCoord2fv.  The
default constructor \f3\%pfVec2()\fP is empty and does not initialize the
values in the vector.  An initializing constructor \f3\%pfVec2\fP(float,
float) accepts the initial values for the vector.  \f3\%new\fP(arena)
allocates a pfVec2 from the specified memory arena, or from the heap
if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfVec2 from the default
memory arena (\f3\%pfGetSharedArena\fP).  pfVec2s can also be created
automatically on the stack or statically.  pfVec2s allocated with
\f3\%new\fP can be deleted with \f3\%pfDelete\fP, not \f3\%delete\fP.

The name \f2vec\fP has been used below to indicate the pfVec2 on which
the member function is being invoked.

\f3\%pfVec2::set\fP: \f2vec\fP[0] = \f2x\fP, \f2vec\fP[1] = \f2y\fP.
Macro equivalent is  \f3\%PFSET_VEC2\fP.

\f3\%pfVec2::copy\fP: \f2vec\fP = \f2v\fP.
Macro equivalent is  \f3\%PFCOPY_VEC2\fP.

\f3\%pfVec2::negate\fP: \f2vec\fP = -\f2v\fP.
Macro equivalent is  \f3\%PFNEGATE_VEC2\fP.

\f3\%pfVec2::add\fP: \f2vec\fP = \f2v1\fP + \f2v2\fP.  Sets \f2vec\fP to
the sum of vectors \f2v1\fP and \f2v2\fP.  Macro equivalent is \f3\%PFADD_VEC2\fP.

\f3\%pfVec2::sub\fP: \f2vec\fP = \f2v1\fP - \f2v2\fP.  Sets \f2vec\fP to
the difference of \f2v1\fP and \f2v2\fP.  Macro equivalent is
\f3\%PFSUB_VEC2\fP.

\f3\%pfVec2::addScaled\fP: \f2vec\fP = \f2v1\fP + \f2s\fP *
\f2v2\fP.  Sets \f2vec\fP to the vector \f2v1\fP plus the vector \f2v2\fP
scaled by \f2s\fP.  Macro equivalent is  \f3\%PFADD_SCALED_VEC2\fP.

\f3\%pfVec2::scale\fP: \f2vec\fP = \f2s\fP * \f2v1\fP.  Sets \f2vec\fP to
the vector \f2v\fP scaled by \f2s\fP.  Macro equivalent is  \f3\%PFSCALE_VEC2\fP.

\f3\%pfVec2::combine\fP: \f2vec\fP = \f2s1\fP * \f2v1\fP +
\f2s2\fP * \f2v2\fP.  Sets \f2vec\fP to be the linear combination of \f2v1\fP
and \f2v2\fP with scales \f2s1\fP and \f2s2\fP, respectively.  Macro
equivalent: \f3\%PFCOMBINE_VEC2\fP.

\f3\%pfVec2::normalize\fP: \f2vec\fP = \f2vec\fP / length(\f2vec\fP).
Normalizes the vector \f2vec\fP to have unit length and returns the
original length of the vector.

\f3\%pfVec2::dot\fP = \f2vec\fP dot \f2v2\fP = \f2vec\fP[0] * \f2v2\fP[0] +
\f2vec\fP[1] * \f2v2\fP[1] .  Returns dot product of the vectors \f2vec\fP and
\f2v2\fP.  Macro equivalent is  \f3\%PFDOT_VEC2\fP.

\f3\%pfVec2::length\fP = |vec| = sqrt(\f2vec\fP dot \f2vec\fP).  Returns length of
the vector \f2vec\fP.  Macro equivalent is  \f3\%PFLENGTH_VEC2\fP.

\f3\%pfVec2::sqrDistance\fP = (\f2vec\fP - \f2v2\fP) dot (\f2vec\fP -
\f2v2\fP).  Returns square of distance between two points \f2v1\fP and
\f2v2\fP.  Macro equivalent is  \f3\%PFSQR_DISTANCE_PT2\fP.

\f3\%pfVec2::distance\fP = sqrt((\f2vec\fP - \f2v2\fP) dot (\f2vec\fP -
\f2v2\fP)).  Returns distance between two points \f2vec\fP and \f2v2\fP.
Macro equivalent is  \f3\%PFDISTANCE_PT2\fP.

\f3\%pfVec2::equal\fP = (\f2vec\fP == \f2v2\fP).  Tests for strict
component-wise equality of two vectors \f2vec\fP and \f2v2\fP and returns
FALSE or TRUE.  Macro equivalent is  \f3\%PFEQUAL_VEC2\fP.

\f3\%pfVec2::almostEqual\fP.  Tests for approximate
component-wise equality of two vectors \f2vec\fP and \f2v2\fP.  It returns
FALSE or TRUE depending on whether the absolute value of the difference
between each pair of components is less than the tolerance \f2tol\fP.
Macro equivalent is  \f3\%PFALMOST_EQUAL_VEC2\fP.

\f3\%float& operator []\fP(int i)
Accesses indexed component of the vector.

\f3\%int operator ==\fP(const pfVec2&)
Equality comparison operator.

\f3\%pfVec2 operator -\fP() const
Nondestructive unary negation - returns a new vector.

\f3\%pfVec2 operator +\fP(const pfVec2&)
\f3\%pfVec2 operator -\fP(const pfVec2&)
Component-wise binary vector addition and subtraction operators.

\f3\%pfVec2& operator =\fP(const pfVec2&)
Vector assignment operator.

\f3\%pfVec2& operator *=\fP(float)
\f3\%pfVec2& operator /=\fP(float)
Component-wise scalar multiplication and division operators.

\f3\%pfVec2& operator +=\fP(const pfVec2&)
\f3\%pfVec2& operator -=\fP(const pfVec2&)
Component-wise vector addition and subtraction operators.

\f3\%pfVec2 operator *\fP(const pfVec2&, float)
\f3\%pfVec2 operator *\fP(float, const pfVec2&)
\f3\%pfVec2 operator /\fP(const pfVec2&, float)
Component-wise binary scalar multiplication and division operators.

Routines can accept the same vector as source, destination, or as a
repeated operand.

.SH NOTES

When using overloaded operators in C++, assignment operators, e.g.
"+=", are somewhat more efficient than the corresponding binary
operators, e.g. "+", because the latter construct a temporary
intermediate object.  Use assignment operators or macros for
binary operations where optimal speed is important.

C++ does not support array deletion (i.e. \f3\%delete[]\fP) for
arrays of objects allocated new operators that take additional
arguments.  Hence, the array deletion operator \f3\%delete[]\fP should not
be used on arrays of objects created with \f3\%new\fP(arena) pfVec2[n].
.SH SEE ALSO
pfMatrix,
pfVec3,
pfVec4
