'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVec3" "3pf"
.SH NAME
.upperok
.B pfVec3
\- 
Set and operate on 3-component vectors
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ float&\ \ \ 'u
#include <Performer/pr/pfLinMath.h>
.nf
.fi
.TP
void*
\f3\%pfVec3::operator new\fP(size_t);
.nf
.fi
.TP
void*
\f3\%pfVec3::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfVec3::pfVec3\fP();
.nf
.fi
.TP
\ 
\f3\%pfVec3::pfVec3\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::addScaled\fP(const\ pfVec3&\ v1,
'in +2
'll -2
float\ s,
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::add\fP(const\ pfVec3&\ v1,
'in +2
'll -2
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfVec3::equal\fP(const\ pfVec3&\ v2);
.nf
.fi
.TP
int
\f3\%pfVec3::almostEqual\fP(const\ pfVec3&\ v2,
'in +2
'll -2
float\ tol);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::combine\fP(float\ s1,
'in +2
'll -2
const\ pfVec3&\ v1,
float\ s2,
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::copy\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
void
\f3\%pfVec3::cross\fP(const\ pfVec3&\ v1,
'in +2
'll -2
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfVec3::distance\fP(const\ pfVec3&\ pt2);
.nf
.fi
.TP
float
\f3\%pfVec3::dot\fP(const\ pfVec3&\ v2);
.nf
.fi
.TP
float
\f3\%pfVec3::length\fP(void);
.nf
.fi
.TP
void
\f3\%pfVec3::negate\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
float
\f3\%pfVec3::normalize\fP(void);
.nf
.fi
.TP
void
\f3\%pfVec3::scale\fP(float\ s,
'in +2
'll -2
const\ pfVec3&\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::set\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfVec3::sqrDistance\fP(const\ pfVec3&\ pt2);
.nf
.fi
.TP
void
\f3\%pfVec3::sub\fP(const\ pfVec3&\ v1,
'in +2
'll -2
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::xformVec\fP(const\ pfVec3&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::xformPt\fP(const\ pfVec3&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec3::fullXformPt\fP(const\ pfVec3&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
float&
\f3\%pfVec3::operator []\fP(int\ i);
.nf
.fi
.TP
const float&
\f3\%pfVec3::operator []\fP(int\ i);
.nf
.fi
.TP
int
\f3\%pfVec3::operator ==\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator -\fP()\ const;
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator +\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator -\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
pfVec3&
\f3\%pfVec3::operator =\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
pfVec3&
\f3\%pfVec3::operator *=\fP(float\ d);
.nf
.fi
.TP
pfVec3&
\f3\%pfVec3::operator /=\fP(float\ d);
.nf
.fi
.TP
pfVec3&
\f3\%pfVec3::operator +=\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
pfVec3&
\f3\%pfVec3::operator -=\fP(const\ pfVec3&\ v);
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator *\fP(const\ pfVec3&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator *\fP(float\ d,
'in +2
'll -2
const\ pfVec3&\ v);
.in
.ll
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator /\fP(const\ pfVec3&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.nf
.fi
.TP
pfVec3
\f3\%pfVec3::operator *\fP(const\ pfVec3&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.fi

.Ex
.nf

struct pfVec3 {
    float vec[3];
};
.Ee
.fi
.na

.SH DESCRIPTION

Math functions for 3-component vectors.  Most of these routines have
macro equivalents.

Most accesses to pfVec3 go through pfVec3::operator[], but pfVec3
is a public struct whose data member vec is directly accessible, e.g.
when necessary for passing to a routine expecting a float* such as
glColor3fv.  The default constructor \f3\%pfVec3()\fP is empty and does
not initialize the values in the vector.  An initializing constructor
\f3\%pfVec3\fP(float, float, float) accepts the initial values for the
vector.  \f3\%new\fP(arena) allocates a pfVec3 from the specified memory
arena, or from the heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a
pfVec3 from the default memory arena (\f3\%pfGetSharedArena\fP).  pfVec3s
can also be created automatically on the stack or statically.  pfVec3s
allocated with \f3\%new\fP can should be deleted with \f3\%pfDelete\fP,
not \f3\%delete\fP.

The name \f2vec\fP has been used below to indicate the pfVec3 on which
the member function is being invoked.

\f3\%pfVec3::set\fP: \f2vec\fP[0] = \f2x\fP, \f2vec\fP[1] = \f2y\fP,
\f2vec\fP[2] = \f2z\fP.  Macro equivalent is  \f3\%PFSET_VEC3\fP.

\f3\%pfVec3::copy\fP: \f2vec\fP = \f2v\fP.
Macro equivalent is  \f3\%PFCOPY_VEC3\fP.

\f3\%pfVec3::negate\fP: \f2vec\fP = -\f2v\fP.
Macro equivalent is  \f3\%PFNEGATE_VEC3\fP.

\f3\%pfVec3::add\fP: \f2vec\fP = \f2v1\fP + \f2v2\fP.  Sets \f2vec\fP
to the sum of vectors \f2v1\fP and \f2v2\fP.  Macro equivalent is \f3\%PFADD_VEC3\fP.

\f3\%pfVec3::sub\fP: \f2vec\fP = \f2v1\fP - \f2v2\fP.  Sets \f2vec\fP to
the difference of \f2v1\fP and \f2v2\fP.  Macro equivalent is  \f3\%PFSUB_VEC3\fP.

\f3\%pfVec3::scale\fP: \f2vec\fP = \f2s\fP * \f2v1\fP.  Sets \f2vec\fP to
the vector \f2v\fP scaled by \f2s\fP.  Macro equivalent is  \f3\%PFSCALE_VEC3\fP.

\f3\%pfVec3::addScaled\fP: \f2vec\fP = \f2v1\fP + \f2s\fP *
\f2v2\fP.  Sets \f2vec\fP to the vector \f2v1\fP plus the vector \f2v2\fP
scaled by \f2s\fP.  Macro equivalent is  \f3\%PFADD_SCALED_VEC3\fP.

\f3\%pfVec3::combine\fP: \f2vec\fP = \f2s1\fP * \f2v1\fP +
\f2s2\fP * \f2v2\fP.  Sets \f2vec\fP to be the linear combination of \f2v1\fP
and \f2v2\fP with scales \f2s1\fP and \f2s2\fP, respectively.  Macro
equivalent: \f3\%PFCOMBINE_VEC3\fP.

\f3\%pfVec3::normalize\fP: \f2vec\fP = \f2vec\fP / length(\f2vec\fP).
Normalizes the vector \f2vec\fP to have unit length and returns the
original length of the vector.

\f3\%pfVec3::cross\fP: \f2vec\fP = \f2v1\fP X \f2v2\fP.  Sets \f2vec\fP
to the cross-product of two vectors \f2v1\fP and \f2v2\fP.

\f3\%pfVec3::xformVec\fP: \f2vec\fP = \f2v\fP * \f2m\fP (\f2vec\fP[i]=\f2v[i]\fP
i=0, 1, 2; \f2v\fP[3] = 0).  Transforms \f2v\fP as a vector by the matrix
\f2m\fP.

\f3\%pfVec3::xformPt\fP: \f2vec\fP = \f2vec\fP * \f2m\fP (\f2vec\fP[i]=\f2vec[i]\fP
i=0, 1, 2; \f2vec\fP[3] = 1).  Transforms \f2vec\fP as a point by the matrix
\f2m\fP using the 4X3 submatrix.

\f3\%pfVec3::fullXformPt\fP: \f2vec\fP = \f2v\fP * \f2m\fP
(\f2vec\fP[i]=\f2v[i]\fP i=0, 1, 2; \f2vec\fP[3] = 1).  Transforms \f2vec\fP as a
point by the matrix \f2m\fP using the full 4X4 matrix and scaling
\f2dst\fP by the resulting w coordinate.

\f3\%pfVec3::dot\fP = \f2vec\fP dot \f2v2\fP = \f2vec\fP[0] * \f2v2\fP[0] +
\f2vec\fP[1] * \f2v2\fP[1] + \f2vec\fP[2] * \f2v2\fP[2].  Returns dot product of
the vectors \f2vec\fP and \f2v2\fP.  Macro equivalent is  \f3\%PFDOT_VEC3\fP.

\f3\%pfVec3::length\fP = |vec| = sqrt(\f2vec\fP dot \f2vec\fP).  Returns length of
the vector \f2vec\fP.  Macro equivalent is  \f3\%PFLENGTH_VEC3\fP.

\f3\%pfVec3::sqrDistance\fP = (\f2vec\fP - \f2v2\fP) dot (\f2vec\fP - \f2v2\fP).
Returns square of distance between two points \f2vec\fP and \f2v2\fP.  Macro
equivalent is \f3\%PFSQR_DISTANCE_PT3\fP.

\f3\%pfVec3::distance\fP = sqrt((\f2vec\fP - \f2v2\fP) dot (\f2vec\fP -
\f2v2\fP)).  Returns distance between two points \f2vec\fP and \f2v2\fP.
Macro equivalent is  \f3\%PFDISTANCE_PT3\fP.

\f3\%pfVec3::equal\fP = (\f2vec\fP == \f2v2\fP).  Tests for strict component-wise
equality of two vectors \f2vec\fP and \f2v2\fP and returns FALSE or TRUE.
Macro equivalent is  \f3\%PFEQUAL_VEC3\fP.

\f3\%pfVec3::almostEqual\fP.  Tests for approximate
component-wise equality of two vectors \f2vec\fP and \f2v2\fP.  It returns
FALSE or TRUE depending on whether the absolute value of the
difference between each pair of components is less than the tolerance
\f2tol\fP.  Macro equivalent is  \f3\%PFALMOST_EQUAL_VEC3\fP.

\f3\%float& operator []\fP(int)
\f3\%const float& operator []\fP(int)
Accesses indexed component of vector.

\f3\%int operator ==\fP(const pfVec3&)
Equality comparison operator.

\f3\%pfVec3 operator -\fP() const
Nondestructive unary negation - returns a new vector.

\f3\%pfVec3 operator +\fP(const pfVec3&)
\f3\%pfVec3 operator -\fP(const pfVec3&)
Component-wise binary vector addition and subtraction operators.

\f3\%pfVec3& operator =\fP(const pfVec3&)
Vector assignment operator.

\f3\%pfVec3& operator *=\fP(float)
\f3\%pfVec3& operator /=\fP(float)
Component-wise scalar multiplication and division operators.

\f3\%pfVec3& operator +=\fP(const pfVec3&)
\f3\%pfVec3& operator -=\fP(const pfVec3&)
Component-wise vector addition and subtraction operators.

\f3\%pfVec3 operator *\fP(const pfVec3&, float)
\f3\%pfVec3 operator *\fP(float d, const pfVec3&)
\f3\%pfVec3 operator /\fP(const pfVec3&, float)
\f3\%pfVec3 operator *\fP(const pfVec3&, const pfMatrix&)
Component-wise binary scalar multiplication and division operators.

Routines can accept the same vector as source, destination, or as a
repeated operand.

.SH NOTES

When using overloaded operators in C++, assignment operators, e.g.
"+=", are somewhat more efficient than the corresponding binary
operators, e.g. "+", because the latter construct a temporary
intermediate object.  Use assignment operators or macros for
binary operations where optimal speed is important.

C++ does not support array deletion (i.e. \f3\%delete[]\fP) for
arrays of objects allocated new operators that take additional
arguments.  Hence, the array deletion operator \f3\%delete[]\fP should not
be used on arrays of objects created with \f3\%new\fP(arena) pfVec3[n].

.SH SEE ALSO
pfMatrix,
pfVec2,
pfVec4
