'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVec4" "3pf"
.SH NAME
.upperok
.B pfVec4
\- 
Set and operate on 4-component vectors
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ float&\ \ \ 'u
#include <Performer/pr/pfVec4.h>
.nf
.fi
.TP
void*
\f3\%pfVec4::operator new\fP(size_t);
.nf
.fi
.TP
void*
\f3\%pfVec4::operator new\fP(size_t,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfVec4::pfVec4\fP();
.nf
.fi
.TP
\ 
\f3\%pfVec4::pfVec4\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec4::addScaled\fP(pfVec3&\ dst,
'in +2
'll -2
const\ pfVec3&\ v1,
float\ s,
const\ pfVec3&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec4::add\fP(const\ pfVec4&\ v1,
'in +2
'll -2
const\ pfVec4&\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfVec4::almostEqual\fP(const\ pfVec4&\ v2,
'in +2
'll -2
float\ tol);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec4::combine\fP(float\ s1,
'in +2
'll -2
const\ pfVec4&\ v1,
float\ s2,
const\ pfVec4&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec4::copy\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
float
\f3\%pfVec4::distance\fP(const\ pfVec4&\ pt2);
.nf
.fi
.TP
float
\f3\%pfVec4::dot\fP(const\ pfVec4&\ v2);
.nf
.fi
.TP
int
\f3\%pfVec4::equal\fP(const\ pfVec4&\ v2);
.nf
.fi
.TP
float
\f3\%pfVec4::length\fP(void);
.nf
.fi
.TP
void
\f3\%pfVec4::negate\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
float
\f3\%pfVec4::normalize\fP(void);
.nf
.fi
.TP
void
\f3\%pfVec4::scale\fP(float\ s,
'in +2
'll -2
const\ pfVec4&\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec4::set\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfVec4::sqrDistance\fP(const\ pfVec4&\ pt2);
.nf
.fi
.TP
void
\f3\%pfVec4::sub\fP(const\ pfVec4&\ v1,
'in +2
'll -2
const\ pfVec4&\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVec4::xform\fP(const\ pfVec4&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.nf
.fi
.TP
float&
\f3\%pfVec4::operator []\fP(int\ i);
.nf
.fi
.TP
const float&
\f3\%pfVec4::operator []\fP(int\ i);
.nf
.fi
.TP
int
\f3\%pfVec4::operator ==\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator -\fP()\ const;
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator +\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator -\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
pfVec4&
\f3\%pfVec4::operator =\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
pfVec4&
\f3\%pfVec4::operator *=\fP(float\ d);
.nf
.fi
.TP
pfVec4&
\f3\%pfVec4::operator /=\fP(float\ d);
.nf
.fi
.TP
pfVec4&
\f3\%pfVec4::operator +=\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
pfVec4&
\f3\%pfVec4::operator -=\fP(const\ pfVec4&\ v);
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator *\fP(const\ pfVec4&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator *\fP(float\ d,
'in +2
'll -2
const\ pfVec4&\ v);
.in
.ll
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator /\fP(const\ pfVec4&\ v,
'in +2
'll -2
float\ d);
.in
.ll
.nf
.fi
.TP
pfVec4
\f3\%pfVec4::operator *\fP(const\ pfVec4&\ v,
'in +2
'll -2
const\ pfMatrix&\ m);
.in
.ll
.fi

.Ex
.nf

struct pfVec4 {
    float vec[4];
};
.Ee
.fi
.na

.SH DESCRIPTION

Math functions for 4-component vectors.

Most accesses to pfVec4 go through pfVec4::operator[], but pfVec4
is a public struct whose data member vec is directly accessible, e.g.
for passing to a routine expecting a float* such as glColor4fv.
The default constructor \f3\%pfVec4()\fP is empty and does not initialize
the values in the vector.  An initializing constructor \f3\%pfVec4\fP(float,
float, float, float) accepts the initial values for the vector.  \f3\%new\fP(arena)
allocates a pfVec4 from the specified memory arena, or from the heap if
\f2arena\fP is NULL.  \f3\%new\fP allocates a pfVec4 from the default memory
arena (\f3\%pfGetSharedArena\fP).  pfVec4s can also be created automatically on
the stack or statically.  pfVec4s allocated with \f3\%new\fP should be
deleted with \f3\%pfDelete\fP, not \f3\%delete\fP.

The name \f2vec\fP has been used below to indicate the pfVec4 on which
the member function is being invoked.

\f3\%pfVec4::set\fP: \f2vec\fP[0] = \f2x\fP, \f2vec\fP[1] = \f2y\fP,
\f2vec\fP[2] = \f2z\fP, \f2vec\fP[3] = \f2w\fP .  Macro equivalent is
\f3\%PFSET_VEC4\fP.

\f3\%pfVec4::copy\fP: \f2vec\fP = \f2v\fP.  Macro equivalent is
\f3\%PFCOPY_VEC4\fP.

\f3\%pfVec4::negate\fP: \f2vec\fP = -\f2v\fP.  Macro equivalent is
\f3\%PFNEGATE_VEC4\fP.

\f3\%pfVec4::add\fP: \f2vec\fP = \f2v1\fP + \f2v2\fP.  Sets \f2vec\fP to
the sum of vectors \f2v1\fP and \f2v2\fP.  Macro equivalent is \f3\%PFADD_VEC4\fP.

\f3\%pfVec4::sub\fP: \f2vec\fP = \f2v1\fP - \f2v2\fP.  Sets \f2vec\fP to
the difference of \f2v1\fP and \f2v2\fP.  Macro equivalent is
\f3\%PFSUB_VEC4\fP.

\f3\%pfVec4::scale\fP: \f2vec\fP = \f2s\fP * \f2v1\fP.  Sets \f2vec\fP to
the vector \f2v\fP scaled by \f2s\fP.  Macro equivalent is \f3\%PFSCALE_VEC4\fP.

\f3\%pfVec4::addScaled\fP: \f2vec\fP = \f2v1\fP + \f2s\fP *
\f2v2\fP.  Sets \f2vec\fP to the vector \f2v1\fP plus the vector \f2v2\fP
scaled by \f2s\fP.  Macro equivalent is \f3\%PFADD_SCALED_VEC4\fP.

\f3\%pfVec4::combine\fP: \f2vec\fP = \f2s1\fP * \f2v1\fP +
\f2s2\fP * \f2v2\fP.  Sets \f2vec\fP to be the linear combination of \f2v1\fP
and \f2v2\fP with scales \f2s1\fP and \f2s2\fP, respectively.  Macro
equivalent is \f3\%PFCOMBINE_VEC4\fP.

\f3\%pfVec4::normalize\fP: \f2vec\fP = \f2vec\fP / length(\f2vec\fP).
Normalizes the vector \f2vec\fP to have unit length and returns the
original length of the vector.

\f3\%pfVec4::xform\fP: \f2vec\fP = \f2v\fP * \f2m\fP.  Transforms \f2v\fP
by the matrix \f2m\fP.

\f3\%pfVec4::dot\fP = \f2vec\fP dot \f2v2\fP = \f2vec\fP[0] * \f2v2\fP[0] +
\f2vec\fP[1] * \f2v2\fP[1] + \f2vec\fP[2] * \f2v2\fP[2] + \f2vec\fP[3] *
\f2v2\fP[3].  Returns dot product of the vectors \f2v1\fP and
\f2v2\fP.  Macro equivalent is \f3\%PFDOT_VEC4\fP.

\f3\%pfVec4::length\fP = |vec| = sqrt(\f2vec\fP dot \f2vec\fP).  Returns length of
the vector \f2vec\fP.  Macro equivalent is \f3\%PFLENGTH_VEC4\fP.

\f3\%pfVec4::sqrDistance\fP = (\f2vec\fP - \f2v2\fP) dot (\f2vec\fP -
\f2v2\fP).  Returns square of distance between two points \f2vec\fP and
\f2v2\fP.  Macro equivalent is \f3\%PFSQR_DISTANCE_PT4\fP.

\f3\%pfVec4::distance\fP = sqrt((\f2vec\fP - \f2v2\fP) dot (\f2vec\fP -
\f2v2\fP)).  Returns distance between two points \f2vec\fP and \f2v2\fP.
Macro equivalent is \f3\%PFDISTANCE_PT4\fP.

\f3\%pfVec4::equal\fP = (\f2vec\fP == \f2v2\fP).  Tests for strict
component-wise equality of two vectors \f2vec\fP and \f2v2\fP and returns
FALSE or TRUE.  Macro equivalent is \f3\%PFEQUAL_VEC4\fP.

\f3\%pfVec4::almostEqual\fP.  Tests for approximate
component-wise equality of two vectors \f2vec\fP and \f2v2\fP.  It returns
FALSE or TRUE depending on whether the absolute value of the difference
between each pair of components is less than the tolerance \f2tol\fP.
Macro equivalent is \f3\%PFALMOST_EQUAL_VEC4\fP.
\f3\%float& operator []\fP(int i)
\f3\%const float& operator []\fP(int i)
Accesses indexed component of vector.

\f3\%int operator ==\fP(const pfVec4&)
Equality comparison operator.

\f3\%pfVec4 operator -\fP() const
Nondestructive unary negation - returns a new vector.

\f3\%pfVec4 operator +\fP(const pfVec4&)
\f3\%pfVec4 operator -\fP(const pfVec4&)
Component-wise binary vector addition and subtraction operators.

\f3\%pfVec4& operator =\fP(const pfVec4&)
Vector assignment operator.

\f3\%pfVec4& operator *=\fP(float)
\f3\%pfVec4& operator /=\fP(float)
Component-wise scalar multiplication and division operators.

\f3\%pfVec4& operator +=\fP(const pfVec4&)
\f3\%pfVec4& operator -=\fP(const pfVec4&)
Component-wise vector addition and subtraction operators.

\f3\%pfVec4 operator *\fP(const pfVec4&, float)
\f3\%pfVec4 operator *\fP(float d, const pfVec4&)
\f3\%pfVec4 operator /\fP(const pfVec4&, float)
\f3\%pfVec4 operator *\fP(const pfVec4&, const pfMatrix&)
Component-wise binary scalar multiplication and division operators.

Routines can accept the same vector as source, destination, or as a
repeated operand.

.SH NOTES

When using overloaded operators in C++, assignment operators, e.g.
"+=", are somewhat more efficient than the corresponding binary
operators, e.g. "+", because the latter construct a temporary
intermediate object.  Use assignment operators or macros for
binary operations where optimal speed is important.

C++ does not support array deletion (i.e. \f3\%delete[]\fP) for
arrays of objects allocated new operators that take additional
arguments.  Hence, the array deletion operator \f3\%delete[]\fP should not
be used on arrays of objects created with \f3\%new\fP(arena) pfVec4[n].
.SH SEE ALSO
pfMatrix,
pfVec2,
pfVec3
