'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVolFog" "3pf"
.SH NAME
.upperok
.B pfVolFog
\- 
Defines a nonuniform volume fog.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfTexture\ *\ \ \ 'u
#include <Performer/pf/pfVolFog.h>
.nf
.fi
.TP
void
\f3\%pfVolFog::setColor\fP(float\ _r,
'in +2
'll -2
float\ _g,
float\ _b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::getColor\fP(float\ *r,
'in +2
'll -2
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::setFlags\fP(int\ which,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfVolFog::getFlags\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfVolFog::setVal\fP(int\ which,
'in +2
'll -2
float\ \ val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::getVal\fP(int\ which,
'in +2
'll -2
float\ *val);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::setAttr\fP(int\ which,
'in +2
'll -2
void\ *attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::getAttr\fP(int\ which,
'in +2
'll -2
void\ *attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::apply\fP(pfScene\ *scene);
.nf
.fi
.TP
void
\f3\%pfVolFog::draw\fP(pfChannel\ *channel);
.nf
.fi
.TP
void
\f3\%pfVolFog::addChannel\fP(pfChannel\ *channel);
.nf
.fi
.TP
void
\f3\%pfVolFog::updateView\fP(void);
.nf
.fi
.TP
void
\f3\%pfVolFog::addNode\fP(pfNode\ *node);
.nf
.fi
.TP
void
\f3\%pfVolFog::setDensity\fP(float\ density);
.nf
.fi
.TP
float
\f3\%pfVolFog::getDensity\fP(void);
.nf
.fi
.TP
pfTexture *
\f3\%pfVolFog::getTexture\fP(void);
.nf
.fi
.TP
void
\f3\%pfVolFog::addPoint\fP(float\ elevation,
'in +2
'll -2
float\ density);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfVolFog::addColoredPoint\fP(float\ elevation,
'in +2
'll -2
float\ density,
float\ _r,
float\ _g,
float\ _b);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfVolFog\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfVolFog\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfVolFog\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION

A pfVolFog is a class that is used to draw the scene with fog that has
different densities at different locations in the scene. The class
supports
two types of nonuniform fog: a layered fog and a patchy fog.

A layered fog changes only with elevation, its density and
color is
uniform at a given height. In a pfVolFog a layered fog is defined by a
set
of elevation points. Each elevation point can specify a fog density and
optionally also a fog color at the point's elevation.
The density and the color between two neighboring points is linearly
interpolated.
A patchy fog is defined by closed three-dimensional objects and its
density
is constant inside these objects. At the moment all objects specify
a patchy fog of the same color and the same density.

.br
A pfVolFog is not part of the scene graph, it is created
separately by the application process. Once created elevation points of
a layered fog can be specified by calling
\f3\%pfVolFog::addPoint\fP or
\f3\%pfVolFog::addColoredPoint\fP
repeatedly.
The fog initialization is completed by calling
\f3\%pfVolFog::apply\fP.

Example:
.Ex
.nf

pfVolFog *lfog = new pfVolFog;

lfog->addPoint(elev1, density1);
lfog->addPoint(elev2, density2);
lfog->addPoint(elev3, density3);

lfog->apply();
.Ee
.fi
.na


.br
The boundary of a patchy fog is specified by
\f3\%pfVolFog::addNode\fP(\f2node\fP),
where
\f2node\fP
contains the surfaces enclosing the foggy areas. It is possible to
define
several
disjoint areas in the same tree or by adding several different nodes.
Note
that
each area has to be completely enclosed and the vertices of the surfaces
have to
be ordered so that the front face of each surface faces outside the
foggy
area. The node has to be part of the scene graph for the rendering to
work
properly.

Example:
.Ex
.nf

pfVolFog *pfog = new pfVolFog;

pfog->addNode(fogNode);

pfog->apply();
.Ee
.fi
.na


.br
Patchy and layered fog can be combined but only if layered fog has
a uniform color.

.br

The function \f3\%pfVolFog::apply\fP initializes
a pfVolFog. If
at least two
elevation points were defined it initializes
data structures necessary for rendering of a layered fog, including a 3D
texture.
Any control points defined afterwards are ignored.
If a node containing patchy fog boundaries has been added prior to calling
\f3\%pfVolFog::apply\fP a patchy fog is
initialized.
Since function \f3\%pfVolFog::addNode\fP only
marks
the parts of the scene graphs that specify the texture it is possible
to
add additional patchy fog nodes even after
\f3\%pfVolFog::apply\fP has been called.

.br

A pfVolFog needs information about the current eye position and view
direction.
Since this information is not directly accessible in a draw process it
is
necessary to call
\f3\%pfVolFog::addChannel\fP
for each channel (at the beginning of the application).
Whenever the view changes the application process has to call
\f3\%pfVolFog::updateView\fP. For example,
see
programs in perf/samples/apps/C/fogfly or perf/samples/apps/C++/volfog.
Without updating the view the fog will not be rendered.

If the application changes the position of the patchy fog boundaries (for
example, by inserting a pfSCS, pfDCS, or pfFCS node above the fog node)
or the orientation of the whole scene with respect to the up vector
(for example, the use of a trackball in perfly) the fog may not be
drawn correctly.

.br

To draw the scene with a fog the draw process has to call
\f3\%pfVolFog::draw\fP instead of \f3\%pfDraw\fP. This
function will take care of drawing the whole scene graph with the
specified
fog. Expect the draw time to increase because the scene is drawn twice
(three times if both patchy and layered fog are specified). In case
of a patchy fog there may also be several full-screen polygons being drawn.
You can easily
disable the fog by not calling
\f3\%pfVolFog::draw\fP.
Since boundaries of patchy fog are in the scene graph do not use
\f3\%pfDraw\fP
to draw the scene without fog but use \f3\%pfDrawBin\fP with
PFSORT_DEFAULT_BIN, PFSORT_OPAQUE_BIN, and PFSORT_TRANSP_BIN.

A patchy fog needs as deep color buffer as possible (optimally 12-bit
per
r,g,b) and a stencil buffer. It is recommended to use at least a 4-bit
stencil buffer (1-bit is sufficient only for very simple fog objects).
It
may be necessary to modify your application so that it asks for such a
visual.

.br
A pfVolFog can be deleted using \f3\%pfDelete\fP. In case of a layered fog it
is
necessary to delete the texture handle in a draw process. The texture
is returned by \f3\%pfVolFog::getTexture\fP.
See example in perf/samples/apps/C/fogfly.

.br

FOG PARAMETERS

As mentioned above a layered fog of a uniform color is specified by
function \f3\%pfVolFog::addPoint\fP, which sets
the
fog density at a given elevation.
The density is scaled so that if the fog has density 1
the nearest object inside the fog that has full fog color
is at a distance equal to the 1/10 of the
diagonal of the scene bounding box.
The layered fog color is set by
function \f3\%pfVolFog::setColor\fP or by calling
\f3\%pfVolFog::setAttr\fP with parameter
PFVFOG_COLOR and a pointer to an array of three floats. The default fog
color is (0.9,0.9,1).

A layered fog of a nonuniform color is specified by function
\f3\%pfVolFog::addColoredPoint\fP, which
sets the fog density and the fog color at a given elevation. The color
set
by \f3\%pfVolFog::setColor\fP is then ignored.

The layered fog mode is set by function \f3\%pfVolFog::setVal\fP with parameter PFVFOG_LAYERED_MODE and one of PFVFOG_LINEAR,
PFVFOG_EXP, or PFVFOG_EXP2. It is also possible to set the mode
both for a layered and patchy fog at once by using paramater PFVFOG_MODE.
The default mode is PFVFOG_LINEAR. Function of the mode parameter is
equivalent to function of the fog mode of the OpenGL \f3\%glFog()\fP.

The size of a 3D texture used by a layer fog can be modified by calling
\f3\%pfVolFog::setAttr\fP with parameter
PFVFOG_3D_TEX_SIZE and an array of three integer values. The default
texture size is 64x64x64, but reasonable results can be achieved with
even smaller sizes. The sizes are automatically rounded to the closest
greater or equal power of 2. The
second value should be greater or equal than the third value.

If 3d textures are not supported a set of
2d textures is used instead of a 3d texture (the number of 2d textures
is equal to the third dimension of the 3d texture).
Every time r coordinate changes more than 0.1 a new texture is computed
by interpolating between two neighboring slices and the texture is reloaded.
The use of 2d textures can be forced by calling
\f3\%pfVolFog::setFlags\fP with
flag PFVFOG_FLAG_FORCE_2D_TEXTURE set to 1.

Once a layered fog is initialized by calling the
\f3\%pfVolFog::apply\fP changing any of the above
parameters will not affect rendering of the layered fog.

.br

The density of a patchy fog is controlled by function
\f3\%pfVolFog::setDensity\fP. It can be
also set using \f3\%pfVolFog::setVal\fP
with parameter PFVFOG_FOG_DENSITY.
As in case of a layered fog the density of a patchy fog
is scaled by the tenth of the diagonal of the scene bounding box.


The user can specify an additional density value that is added
to every pixel inside or behind a patchy fog boundary using the function
\f3\%pfVolFog::setVal\fP
with parameter PFVFOG_FOG_DENSITY_BIAS. This value makes
a patchy fog appear denser but it may create unrealistically sharp
boundaries. The default value is 0.

The patchy fog color is set by function
\f3\%pfVolFog::setColor\fP or by calling
\f3\%pfVolFog::setAttr\fP with parameter
PFVFOG_COLOR and a pointer to an array of three floats.
If the blend_color extension is not available patchy fog will be
white.

The patchy fog mode is set by function \f3\%pfVolFog::setVal\fP with parameter PFVFOG_PATCHY_MODE and one of PFVFOG_LINEAR,
PFVFOG_EXP, or PFVFOG_EXP2. It is also possible to set the mode
both for a patchy and layered fog at once by using paramater PFVFOG_MODE.
The default mode is PFVFOG_LINEAR.

The quality and speed of patchy fog rendering can be controlled
by \f3\%pfVolFog::setVal\fP
with parameter PFVFOG_RESOLUTION. The resolution is a value between
0 and 1. Higher values will reduce banding and speed up the drawing.
On the other hand, high values may cause corruption in areas of too
many overlapping fog surfaces. The default value is 0.2, but you
may try to use values higher than that if your fog boundaries do not
overlap much.

Parameters of a patchy fog can be modified any time and they will affect
the rendering of the subsequent frame. A patchy fog can also be animated by
modifying the geometry of the fog nodes. Make sure that the bounding box
of the geoset is updated and that
\f3\%pfVolFog::addNode\fP is called every time the
bounding box is updated.

The multi-pass algorithms used for rendering layered and patchy fog
may produce incorrect results if the scene graph contains polygons that
have equal depth values. To avoid such problems a stencil buffer is used
during rendering of the second pass. You can disable this function by
setting flag PFVFOG_FLAG_CLOSE_SURFACES to 0.

By default, the multi-pass algoritm is applied only when the boundaries
of a patchy fog are visible. This may cause undesirable changes of
semitransparent edges of scene objects when fog objects move into or away
from the view. To force the use of the multi-pass
algorithm, call \f3\%pfVolFog::setFlags\fP with
flag PFVFOG_FLAG_FORCE_PATCHY_PASS set to 1.

It is possible to use a different algorithm for rendering patchy fog that
can handle semitransparent surfaces. To use this algorithm, set flag
PFVFOG_FASTER_PATCHY_FOG to 1.

If flag PFVFOG_FLAG_LAYERED_PATCHY_FOG is set the layered fog is used to
define a density of a patchy fog. The layered fog is then present only in
areas defined by the patchy fog boundaries. Since layered fog is computed
for the whole scene, it is important to set fog parameter
PFVFOG_MAX_DISTANCE to a value that correspods to the size of the patchy
fog area (for example, a diameter of its bounding sphere). Use function
\f3\%pfVolFog::setVal\fP to modify the maximum distance
parameter. This option does not work with faster patchy fog algorithm.

Every set function has an equivalent get function.


HINTS

A layered fog is faster to render than a patchy fog, thus if draw is very
slow try to use a layered fog instead of a patchy fog. Rendering of both
types of fog together is even slower and you may try to define only one
type.

.br
Changing the fog mode does not affect the rendering speed in case of
a layered fog but rendering of a patchy fog is slower for fog modes
PFVFOG_EXP and PFVFOG_EXP2. If you prefer using non-linear modes try
to use them only for the layered fog and not for the patchy fog.

.br
You can speed up drawing of a patchy fog by reducing the size of the fog
boundaries. In case of several disjoint fog areas the size of a bounding
box containing all boundaries affects the draw time and quality.
Try to avoid defining a patchy fog in two opposite parts of your scene.
Try also to increase the value of \f2resolution\fP (if there are not too
many overlapping fog boundaries) or reduce the patchy fog density.

.br

If there is a lot of banding visible in the fog try to choose a visual
with as many bits per color component as possible. Keep in mind that
a patchy fog needs stencil buffer.
You can also try to apply all techniques mentioned in the previous item
-
reducing the size of patchy fog boundaries, increasing \f2resolution\fP,
or
decreasing density.

.br
If a patchy fog looks incorrect - the fog appears outside the specified
boundaries -
make sure that the vertices of the fog boundaries are specified in the
correct order so that front faces always face outside the foggy area.

.br
If you see a darker band in a layered fog at the eye level make sure
that
the texture size is set so that the second value is
greater or equal than the third value.

.br

LIMITATIONS

Layered fog:

.RS
.TE
The 3D texture coordinates for a layered fog are determined at each vertex and
interpolated
across a polygon. Consequently, an object located on top of a large
ground
polygon may be fogged a bit more or less than the part of the polygon
just
under the object.

.TE
A layered fog works fast with a 3d texture. Reloading of 2d textures
during
the animation can be slow.
.RE

Patchy fog:

.RS
.TE
The method does not work well for semi-transparent surfaces. If your
scene
contains objects that are semitransparent or that have semi-transparent
edges
(for example, tree billboards or mountains in Performer town) these
objects
or edges may be cut or may be fogged more than the neighboring pixels.
Even if a semi-transparent edge of a billboard is outside the fog it
will not be smooth.
Set flag PFVFOG_FASTER_PATCHY_FOG to use a different algorithm that
does not have these problems. The faster algorithm, on the other hand,
suffers from the same problems as layered fog because the fog factors
are determined at each vertex and interpolated across a polygon.

.TE

All areas of a patchy fog have the same color.

.TE
The default algorithm for patchy fog does not work with pfEarthSky.

.TE

A layered patchy fog is extremely sensitive to the size of the fog area
and the density of the layered fog. Specifically, the fog values accumulated
along an arbitrary line crossing the bounding box of the fog area should not
reach 1.

.TE
A patchy fog needs stencil buffer and as deep color buffers as possible.
The rendering quality on a visual with less than 12 bits per color
component
is low, unless the fogged area is very small compared to the size of the
whole scene.

.TE
If the blend_color extension is not available the patchy fog color will
be
white.

.RE


.SH SEE ALSO
pfObject,
pfNode,
pfFog
