'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdBreakup" "3pf"
.SH NAME
.upperok
.B pfdBreakup
\- 
Create an artificial hierarchy from unstructured input geometry.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfNode\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
pfNode *
\f3\%pfdBreakup\fP(pfGeode\ *geode,
'in +2
'll -2
float\ geodeSize,
int\ stripLength,
int\ geodeChild);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfdBreakup\fP accepts a pfGeode that contains pfGeoSets of type
\f3\%PFGS_TRISTRIPS\fP and builds a new scene graph, with the same
geometric content but with a spatial subdivision structure designed
for efficient processing. When the subdivision process is successful
\f3\%pfdBreakup\fP returns the root of the new scene graph.  \f3\%NULL\fP is
returned on failure.  Failure is often due to providing
non-\f3\%PFGS_TRISTRIPS\fP \f3\%pfGeoSets\fP to \f3\%pfdBreakup\fP.

The \f3\%pfGeoSets\fP in \f2geode\fP are subdivided based on their geometrical
centers using an octree.  The degree of recursive partitioning desired
is specified in the function arguments.  The resulting scene graph
is a \f2pfGroup\fP that contains more \f2pfGroup\fPs, recursively.
The bottom level \f2pfGroup\fPs contains \f2pfGeode\fPs each of which
is of a size no larger than \f2geodeSize\fP (\f2geodeSize\fP
is the maximum size of the leaf octants in world coordinate) and has triangle
strips no longer than \f2stripLength\fP. Each \f3\%pfGeode\fP created will
have no more than \f2geodeChild\fP \f3\%pfGeoSet\fPs.
If the input geode has size less than \f2geodeSize\fP and
has no more than \f2geodeChild\fP \f3\%pfGeoSet\fPs, then we returns
the \f2pfGeode\fP instead of a \f2pfGroup\fP.
.SH NOTES

The input geode is not deleted.

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH BUGS

\f3\%pfdBreakup\fP does not work for indexed \f3\%pfGeoSets\fP.
.SH SEE ALSO
pfGeoSet,
pfGeode,
pfNode
