'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdBuilder" "3pf"
.SH NAME
.upperok
.B pfdInitBldr,
.B pfdExitBldr,
.B pfdNewBldr,
.B pfdDelBldr,
.B pfdSelectBldr,
.B pfdGetCurBldr,
.B pfdAddBldrGeom,
.B pfdAddIndexedBldrGeom,
.B pfdBldrStateVal,
.B pfdGetBldrStateVal,
.B pfdBldrStateMode,
.B pfdGetBldrStateMode,
.B pfdBldrStateAttr,
.B pfdGetBldrStateAttr,
.B pfdBldrStateInherit,
.B pfdGetBldrStateInherit,
.B pfdCaptureDefaultBldrState,
.B pfdResetBldrState,
.B pfdPushBldrState,
.B pfdPopBldrState,
.B pfdSaveBldrState,
.B pfdLoadBldrState,
.B pfdBldrGState,
.B pfdGetBldrGState,
.B pfdBuild,
.B pfdBuildNode,
.B pfdSelectBldrName,
.B pfdGetCurBldrName,
.B pfdGetTemplateObject,
.B pfdResetAllTemplateObjects,
.B pfdResetObject,
.B pfdMakeDefaultObject,
.B pfdResetBldrGeometry,
.B pfdGetBldrShare,
.B pfdSetBldrShare,
.B pfdResetBldrShare,
.B pfdCleanBldrShare,
.B pfdDefaultGState,
.B pfdGetDefaultGState,
.B pfdMakeSceneGState,
.B pfdOptimizeGStateList,
.B pfdBldrMode,
.B pfdGetBldrMode,
.B pfdBldrAttr,
.B pfdGetBldrAttr,
.B pfdBldrDeleteNode
\- 
Provides a simple interface between model input code and
internal Performer model representations.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfGeoState\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
void
\f3\%pfdInitBldr\fP(void);
.nf
.fi
.TP
void
\f3\%pfdExitBldr\fP(void);
.nf
.fi
.TP
pfdBuilder *
\f3\%pfdNewBldr\fP(void);
.nf
.fi
.TP
void
\f3\%pfdDelBldr\fP(pfdBuilder\ *bldr);
.nf
.fi
.TP
void
\f3\%pfdSelectBldr\fP(pfdBuilder\ *bldr);
.nf
.fi
.TP
pfdBuilder *
\f3\%pfdGetCurBldr\fP(void);
.nf
.fi
.TP
void
\f3\%pfdAddBldrGeom\fP(pfdGeom\ *prims,
'in +2
'll -2
int\ count);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddIndexedBldrGeom\fP(pfdGeom\ *prims,
'in +2
'll -2
int\ count);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdBldrStateVal\fP(int\ which,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfdGetBldrStateVal\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfdBldrStateMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdGetBldrStateMode\fP(int\ mode);
.nf
.fi
.TP
void
\f3\%pfdBldrStateAttr\fP(int\ which,
'in +2
'll -2
const\ void\ *attr);
.in
.ll
.nf
.fi
.TP
const void *
\f3\%pfdGetBldrStateAttr\fP(int\ attr);
.nf
.fi
.TP
void
\f3\%pfdBldrStateInherit\fP(uint\ mask);
.nf
.fi
.TP
uint
\f3\%pfdGetBldrStateInherit\fP(void);
.nf
.fi
.TP
void
\f3\%pfdCaptureDefaultBldrState\fP(void);
.nf
.fi
.TP
void
\f3\%pfdResetBldrState\fP(void);
.nf
.fi
.TP
void
\f3\%pfdPushBldrState\fP(void);
.nf
.fi
.TP
void
\f3\%pfdPopBldrState\fP(void);
.nf
.fi
.TP
void
\f3\%pfdSaveBldrState\fP(void\ *name);
.nf
.fi
.TP
void
\f3\%pfdLoadBldrState\fP(void\ *name);
.nf
.fi
.TP
void
\f3\%pfdBldrGState\fP(const\ pfGeoState\ *gstate);
.nf
.fi
.TP
const pfGeoState *
\f3\%pfdGetBldrGState\fP(void);
.nf
.fi
.TP
pfNode *
\f3\%pfdBuild\fP(void);
.nf
.fi
.TP
pfNode *
\f3\%pfdBuildNode\fP(void\ *name);
.nf
.fi
.TP
void
\f3\%pfdSelectBldrName\fP(void\ *name);
.nf
.fi
.TP
void *
\f3\%pfdGetCurBldrName\fP(void);
.nf
.fi
.TP
pfObject *
\f3\%pfdGetTemplateObject\fP(pfType\ *type);
.nf
.fi
.TP
void
\f3\%pfdResetAllTemplateObjects\fP(void);
.nf
.fi
.TP
void
\f3\%pfdResetObject\fP(pfObject\ *obj);
.nf
.fi
.TP
void
\f3\%pfdMakeDefaultObject\fP(pfObject\ *obj);
.nf
.fi
.TP
void
\f3\%pfdResetBldrGeometry\fP(void);
.nf
.fi
.TP
pfdShare *
\f3\%pfdGetBldrShare\fP(void);
.nf
.fi
.TP
void
\f3\%pfdSetBldrShare\fP(pfdShare\ *share);
.nf
.fi
.TP
void
\f3\%pfdResetBldrShare\fP(void);
.nf
.fi
.TP
void
\f3\%pfdCleanBldrShare\fP(void);
.nf
.fi
.TP
void
\f3\%pfdDefaultGState\fP(pfGeoState\ *def);
.nf
.fi
.TP
const pfGeoState *
\f3\%pfdGetDefaultGState\fP(void);
.nf
.fi
.TP
pfGeoState *
\f3\%pfdMakeSceneGState\fP(pfList\ *gstateList,
'in +2
'll -2
pfGeoState\ *previousGlobalState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdOptimizeGStateList\fP(pfList\ *gstateList,
'in +2
'll -2
pfGeoState\ *globalGState);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdBldrMode\fP(int\ mode,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdGetBldrMode\fP(int\ mode);
.nf
.fi
.TP
void
\f3\%pfdBldrAttr\fP(int\ which,
'in +2
'll -2
void\ *attr);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfdGetBldrAttr\fP(int\ which);
.nf
.fi
.TP
void
\f3\%pfdBldrDeleteNode\fP(pfNode\ *node);
.fi
.SH DESCRIPTION

Converting a model database into Performer runtime structures is a
very common task which almost all Performer applications must do.
However, the form in which databases are modeled does not necessarily
correspond to Performer runtime structures.  Therefore, the task of
reading database information can be tedious.

The Performer \f2Builder\fP is meant to manage most of the details of
constructing efficient runtime structures.  It provides a simple and
convenient interface for bringing scene data into the application
without the need for considering how best to structure that data for
efficient rendering in Performer.  The Builder provides a
comprehensive interface between model input code (such as database
file parsers) and the internal mechanisms of scene representation in
Performer.

The operational state of the Builder is encapsulated in a
\f3\%pfdBuilder\fP object.  During execution, there is always a current
pfdBuilder defined.  \f3\%pfdInitBldr\fP initializes the current (default)
pfdBuilder and \f3\%pfdExitBldr\fP terminates its use.  For those who wish
to explicitly manage the use of several builders, \f3\%pfdNewBldr\fP
creates a new pfdBuilder object and \f3\%pfdDelBldr\fP destroys a pfdBuilder
object.  \f3\%pfdSelectBldr\fP and \f3\%pfdGetCurBldr\fP set and query the
current pfdBuilder, respectively.

The Builder is used in an immediate mode fashion.  A typical client
will feed a series of geometric primitives to the Builder,
occasionally setting certain graphics states, and finally request that
the Builder convert all the input data into a Performer scene graph.

\f3\%pfdAddBldrGeom\fP is the means by which a new geometric primitive is
entered into the Builder.  It accepts a pointer to a single \f3\%pfdGeom\fP
structure \f2prims\fP. If the indicated \f3\%pfdGeom\fP is a line-strip, then
the \f2count\fP argument provides the number of line segments in the
strip.  \f3\%pfdAddIndexedBldrGeom\fP provides the same functions for
indexed primitives.
See the documentation for the Performer geometry builder
(\f3\%pfdGeoBuilder\fP) for documentation on the structure and use of the
\f3\%pfdGeom\fP structure.

In addition to geometry, we need to specify various graphics states.
There is always a current graphics state being applied to input
geometric primitives.  \f3\%pfdBldrStateVal, pfdGetBldrStateVal,
pfdBldrStateMode, pfdGetBldrStateMode, pfdBldrStateAttr,
pfdGetBldrStateAttr, pfdBldrStateInherit\fP, and
\f3\%pfdGetBldrStateInherit\fP are used to access and alter this state.
These functions are an exact duplication of the interface to
\f3\%pfGeoState\fPs; refer to the \f3\%pfGeoState\fP documentation for details on
graphics states and their use.

The current graphics state can also be manipulated as a whole.
\f3\%pfdPushBldrState\fP and \f3\%pfdPopBldrState\fP manipulate a stack of
graphics states, the top of which is the current state. \f3\%pfdDefaultGState\fP
records the state defined by pfGeoState \f2def\fP as the Builder's
default state.
\f3\%pfdResetBldrState\fP resets the current graphics state to the default
state, and \f3\%pfdCaptureDefaultBldrState\fP makes the current state the
default state.  Finally, \f3\%pfdSaveBldrState\fP saves the current state
with the given name, and \f3\%pfdLoadBldrState\fP loads the named state
into the current state.

For convenience, the current graphics state can be set directly from a
pfGeoState using \f3\%pfdBldrGState\fP.  The given pfGeoState will be used
as a template to set the current Builder graphics state.
\f3\%pfdGetBldrGState\fP returns the current Builder state as a
pfGeoState.  The returned pfGeoState \f2should not\fP be modified in any
way.

By default the Builder will use the global \f3\%pfdShare\fP structure to
store shared graphics state.  It is possible to set the \f3\%pfdShare\fP
structure used by the current pfdBuilder using \f3\%pfdSetBldrShare\fP.
\f3\%pfdSetBldrShare\fP returns the \f3\%pfdShare\fP structure used by the
current pfdBuilder.

\f3\%pfdBuild\fP takes all the geometry data and graphics state
information that has been input into the Builder and constructs a
Performer scene graph for it.  The function returns a pfNode which is
the root of this graph.

While transferring database information to the Builder, it is possible
to partition the database into logical units.  Each unit is given a
name; in normal operation, all data is tagged with the same default
name.  Every named partition will correspond to a disjoint subgraph in
the scene graph generated by \f3\%pfdBuild\fP.  The function
\f3\%pfdBuildNode\fP can be used to build the graph for a single specific
partition, rather than the entire input database.
\f3\%pfdSelectBldrName\fP sets the name being applied to input data and
\f3\%pfdGetCurBldrName\fP queries the current name being used.

It is also possible to remove all accumulated data in the
Builder.  \f3\%pfdResetBldrGeometry\fP clears away all geometry
information stored in the Builder.  \f3\%pfdResetBldrShare\fP deletes all
shared graphics state in the Builder.  \f3\%pfdCleanBldrShare\fP deletes
all shared graphics state that is only referenced through the current
pfdBuilder's share structure (this is accomplished through
\f3\%pfdCleanShare\fP which in turn uses \f3\%pfUnrefDelete\fP to delete
individual state elements that are only referenced by the pfdBuilder).

\f3\%pfdBldrDeleteNode\fP gets a list of all state attributes attached to
leaf nodes under \f2node\fP, activates \f3\%pfDelete\fP on \f2node\fP, then
proceeds to remove each state attribute from the current pfdBuilder's
share structure via \f3\%pfdRemoveSharedObject\fP.

The Builder also tries to alleviate the need for the user to
manipulate Performer objects while building the database.
\f3\%pfdGetTemplateObject\fP returns a standard object of the given type.
The user can then fill in the appropriate slots of this object and
pass this object to the Builder.  This allows the Builder to deal with
some of the details of Performer data structures as well as accept the
burden of managing memory for database objects.  \f3\%pfdResetObject\fP
fills in a template object with the default values for that object type.
\f3\%pfdMakeDefaultObject\fP sets the default values using the given object as
a template. Use \f3\%pfdResetAllTemplateObjects\fP to restore all of the
template objects to the values defined by the Builder's default
pfGeoState.

As another form of sharing, Performer databases can also utilize a
default global pfGeoState.  For example, \f3\%pfSceneGState\fP sets the
global pfGeoState for an entire scene.  All pfGeoStates in the
relevant scene graph would inherit state from the global default.  See
the manual pages for \f3\%pfGeoState\fP for further details on state
inheritance.

The construction of this default state is also incorporated into the
Builder.  While processing incoming data, the Builder remembers the
default pfGeoState.  \f3\%pfdDefaultGState\fP sets this default state and
\f3\%pfdGetDefaultGState\fP can be used to query it.  All pfGeoStates
constructed by the Builder will inherit the attributes of this default
pfGeoState.  If a series of pfGeoStates have already been constructed,
\f3\%pfdMakeSceneGState\fP can be used to extract a default pfGeoState
which maximizes sharing through inheritance.  In order to do this,
\f3\%pfdMakeSceneGState\fP requires the list of pfGeoStates to be
optimized and the default pfGeoState in effect when they were
originally constructed.  Finally, \f3\%pfdOptimizeGStateList\fP takes a
list of pfGeoStates and forces them to inherit state wherever that
state agrees with the specified default.

The behavior of the Builder can be controlled by changing various
Builder modes and attributes.  \f3\%pfdBldrMode\fP and \f3\%pfdGetBldrMode\fP
set and query the Builder modes, respectively.  \f3\%pfdBldrAttr\fP and
\f3\%pfdGetBldrAttr\fP set and query Builder attributes.

The supported Builder modes are:
.RS
\f3\%PFDBLDR_MESH_ENABLE\fP
.br
\f3\%PFDBLDR_AUTO_COLORS\fP
.br
\f3\%PFDBLDR_AUTO_ORIENT\fP
.PD 0
.TP
\f3\%PFDBLDR_AUTO_NORMALS\fP
These modes are used to control the geometry builder.  See the documentation
for \f3\%pfdGeoBldrMode\fP for details.
.RE

.RS
\f3\%PFDBLDR_MESH_SHOW_TSTRIPS\fP
.br
\f3\%PFDBLDR_MESH_INDEXED\fP
.br
\f3\%PFDGBLDR_SHARE_INDEX_LISTS\fP
.br
\f3\%PFDBLDR_MESH_MAX_TRIS\fP
.PD 0
.TP
\f3\%PFDBLDR_MESH_RETESSELLATE\fP
These modes are used to control the triangle strip mesher.  Refer to the
documentation for \f3\%pfdMesherMode\fP.

.TP
\f3\%PFDBLDR_BREAKUP\fP
When this mode is enabled (its value is non-NULL), input geometry will
be fed through \f3\%pfdBreakup\fP.  This utility takes the unstructured
input geometry and creates an output graph reflecting a spatial
subdivision of the input.
.RE

.RS
\f3\%PFDBLDR_BREAKUP_SIZE\fP
.br
\f3\%PFDBLDR_BREAKUP_BRANCH\fP
.PD 0
.TP
\f3\%PFDBLDR_BREAKUP_STRIP_LENGTH\fP
If \f3\%pfdBreakup\fP is called, the values of these modes determine the
argument values passed to it.

.TP
\f3\%PFDBLDR_SHARE_MASK\fP
This is a bitwise-OR of the attributes that should be shared in the
Performer scene graph constructed by the Builder (see \f3\%pfdShare\fP).

.TP
\f3\%PFDBLDR_ATTACH_NODE_NAMES\fP
If this mode is enabled, every pfNode constructed by the Builder will
have its name set to the name assigned to it during input
to the Builder; that is, the name set using \f3\%pfdSelectBldrName\fP
will become the name of the new nodes.

.TP
\f3\%PFDBLDR_DESTROY_DATA_UPON_BUILD\fP
If this mode is set, all the data in the builder along with associated
state information (except for information about attributes that
should be shared) will be destroyed when
\f3\%pfdBuild\fP returns.
.RE

The available attributes are:
.RS
.TP 5
\f3\%PFDBLDR_NODE_NAME_COMPARE\fP
The value of this attribute is a function to compare two node names.
If its value is NULL, the == operator is used for comparisons.
.TP

\f3\%PFDBLDR_STATE_NAME_COMPARE\fP
The value of this attribute is a function to compare two state names.
If its value is NULL, the == operator is used for comparisons.
.RE

The following code sample illustrates the use of the Builder.  It is
designed to read a database file which is simply a list of vertex
coordinates.  Every vertex triple defines a triangle.
.Ex
.nf

pfNode * pfdLoadFile_tri (char *fileName)
{
    FILE	*triFile	= NULL;
    pfNode	*node		= NULL;
    pfdGeom	*prim		= NULL;
    int		 v		= 0;

    /* open ".tri" file */
    if ((triFile = pfdOpenFile(fileName)) == NULL)
	return NULL;

    /* allocate primitive buffer */
    prim = pfdNewGeom(3);

    /* discard any lingering geometry in the builders */
    pfdResetBldrGeometry();

    /* pick a random not-too-dark color */
    pfuRandomColor(prim->colors[0], 0.4f, 0.8f);

    /* specify control data */
    prim->numVerts = 3;
    prim->primtype = PFGS_POLYS;
    prim->nbind = PFGS_PER_VERTEX;
    prim->cbind = PFGS_PER_PRIM;
    prim->tbind = PFGS_OFF;

    /* read triangles from ".tri" file */
    while (!feof(triFile))
    {
	/* read vertices from ".tri" file */
	for (v = 0; v < 3; v++)
	{
	    /* read vertex data */
	    fscanf(triFile, "%f %f %f",
		   &prim->coords[v][PF_X],
		   &prim->coords[v][PF_Y],
		   &prim->coords[v][PF_Z]);
	    fscanf(triFile, "%f %f %f",
		   &prim->norms[v][PF_X],
		   &prim->norms[v][PF_Y],
		   &prim->norms[v][PF_Z]);
	}

	/* add this line to builder */
	pfdAddBldrGeom(prim, 1);
    }

    /* close ".tri" file */
    fclose(triFile);

    /* release primitive buffer */
    pfdDelGeom(prim);

    /* get a complete scene graph representing file's primitives */
    node = pfdBuild();

    return node;
}
.Ee
.fi
.na

.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfGeoSet,
pfGeoState,
pfObject,
pfdBreakup,
pfdGeoBuilder,
pfdMeshGSet,
pfdMesherMode,
pfdShare,
pfSceneGState
