'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdCallbacks" "3pf"
.SH NAME
.upperok
.B pfdPreDrawTexgenExt,
.B pfdPostDrawTexgenExt,
.B pfdPreDrawReflMap,
.B pfdPostDrawReflMap,
.B pfdPreDrawContourMap,
.B pfdPostDrawContourMap,
.B pfdPreDrawLinearMap,
.B pfdPostDrawLinearMap,
.B pfdTexgenParams
\- 
Node callbacks examples for special effects.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
int
\f3\%pfdPreDrawTexgenExt\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPostDrawTexgenExt\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPreDrawReflMap\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPostDrawReflMap\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPreDrawContourMap\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPostDrawContourMap\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPreDrawLinearMap\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdPostDrawLinearMap\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdTexgenParams\fP(const\ float\ *newParamsX,
'in +2
'll -2
const\ float\ *newParamsY);
.in
.ll
.fi
.SH DESCRIPTION

These callback functions provide a useful generic callback prototype
for \f3\%pfNode\fPs.  Use these callbacks to create effects that OpenGL
Performer does not support directly, or to perform graphics library
tasks differently than the built-in mechanisms. The currently implemented
callbacks perform reflection mapping using \f3\%texgen\fP.

To write a database loader that loads reflective materials (as in
\f3\%pfdLoadFile_obj\fP), just group reflective materials under different geodes
from non-reflective materials and call \f3\%pfNodeTravFuncs\fP using
\f3\%pfdPreDrawReflMap\fP as the pre-draw callback and
\f3\%pfdPostDrawReflMap\fP as the post-draw callback as follows.
.Ex
.nf

pfNodeTravFuncs(MyReflMappedGeode, PFTRAV_DRAW,
    pfdPreDrawReflMap, pfdPostDrawReflMap);
.Ee
.fi
.na

This will tell the loader to set \f3\%pfdPreDrawReflMap\fP as the pre-draw
callback and \f3\%pfdPostDrawReflMap\fP as the post-draw callback for the
geode containing the reflective materials.

At one time the \f3\%pfdLoadFile_obj\fP database loader used these
mechanisms to implement reflection mapping. Now that the pfTexGen
attribute has been added to libpr's pfGeoState this is no longer
necessary and the OBJ loader has been updated. The techniques of
the reflection map callback utilities is provided as an example of
how similar functions might be implemented.
.SH NOTES

The libpfdu source code, object code and documentation are
provided as unsupported software.  Routines are subject to change in
future releases.
.SH SEE ALSO
pfNode,
pfNodeTravFuncs,
pfdLoadFile_obj,
texgen
