'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdCleanTree" "3pf"
.SH NAME
.upperok
.B pfdFreezeTransforms,
.B pfdCleanTree,
.B pfdReplaceNode,
.B pfdInsertGroup,
.B pfdRemoveGroup
\- 
Scene graph optimizations
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfNode\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
pfNode *
\f3\%pfdFreezeTransforms\fP(pfNode\ *node,
'in +2
'll -2
pfuTravFuncType\ func);
.in
.ll
.nf
.fi
.TP
pfNode *
\f3\%pfdCleanTree\fP(pfNode\ *node,
'in +2
'll -2
pfuTravFuncType\ func);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdReplaceNode\fP(pfNode\ *oldn,
'in +2
'll -2
pfNode\ *newn);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdInsertGroup\fP(pfNode\ *oldn,
'in +2
'll -2
pfGroup\ *grp);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdRemoveGroup\fP(pfGroup\ *oldn);
.fi
.SH DESCRIPTION


\f3\%pfdCleanTree\fP traverses the scene graph rooted at \f2node\fP and
removes redundant and empty pfGroups from the scene graph.  It also
converts any pfSCS with an identity transformation into a pfGroup.

By default, pfGroups are eliminated if they have one or fewer
children.  Any children are reparented to the parent of the pfGroup
being eliminated.  The one exception is a pfSwitch node with one
child, which is not eliminated.  An optional function \f2func\fP can be
provided to alter this determination during the traversal.  At each
candidate pfGroup, \f2func\fP is passed a pfuTraverser which includes
the current node.  If \f2func\fP returns TRUE, the current node is
eliminated.  If \f2func\fP returns FALSE, the current node is retained.


\f3\%pfdFreezeTransforms\fP traverses the scene graph rooted at \f2node\fP and
converts pfDCSes to pfSCSes.  Usually in preparation for a subsequent
call to \f3\%pfFlatten\fP.  By default the conversion occurs for those
pfDCSes that don't have any callbacks and do not have the string "dcs"
or "DCS" embedded in the node name.  An optional function \f2func\fP can
be provided to alter this determination during the traversal.  At each
candidate pfGroup, \f2func\fP is passed a pfuTraverser which includes
the current node.  If \f2func\fP returns TRUE, the current node is
converted.  If \f2func\fP returns FALSE, the current node remains a
pfDCS.

\f3\%pfdReplaceNode\fP, \f3\%pfdInsertGroup\fP and \f3\%pfdRemoveGroup\fP are
helper routines.  \f3\%pfdReplaceNode\fP replaces the node \f2oldn\fP with
the node \f2newn\fP in the scene graph, including reparenting \f2newn\fP
to the \f2oldn\fP's parents and reparenting \f2oldn\fP's children to
\f2newn\fP.  \f2oldn\fP is not deleted.  Any callbacks, traversal masks
and the node name are also copied.  \f3\%pfdInsertGroup\fP inserts the
group \f2grp\fP above \f2oldn\fP in the the scene graph.  \f2grp\fP replaces
\f2oldn\fP as a child of all \f2grp\fP's parents.  \f2oldn\fP becomes a
child of \f2grp\fP.  \f3\%pfdRemoveGroup\fP removes \f2oldn\fP from the scene
graph, reparenting all of \f2oldn\fP's children to the parents of
\f2oldn\fP.  \f2oldn\fP is not deleted.

.SH SEE ALSO
pfFlatten
