'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdCombineBillboards" "3pf"
.SH NAME
.upperok
.B pfdCombineBillboards
\- 
Merge pfBillboard nodes together.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
void
\f3\%pfdCombineBillboards\fP(pfNode\ *node,
'in +2
'll -2
int\ sizeLimit);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfdCombineBillboards\fP gathers sibling billboard nodes together
into as few large pfBillboard nodes as possible. This can often
increase the efficiency of billboard processing in databases with large
numbers of single-pfGeoSet pfBillboard nodes, such as the
OpenGL Performer Town database. The \f2sizeLimit\fP argument defines an
upper limit to the merging process. No pfBillboard node will be
made to have more than this number of pfGeoSets, and no pfBillboard
node already having more than this number will be modified during
the traversal.

There are a few requirements and restrictions to the pfBillboard
combination process. In order to be merged, pfBillboard nodes
must be both \f2similar\fP and \f2combinable\fP.

For a pair of pfBillboard nodes to be \f2similar\fP they must each
have the same values for their pfBillboard attributes. The attributes
of pfBillboard nodes are:
.RS
.TP 10
Mode
Both pfBillboard nodes must have the same rotation mode. The modes
are PFBB_AXIAL_ROT, PFBB_POINT_ROT_EYE, and PFBB_POINT_ROT_WORLD.
.TP
Axis
Both pfBillboard nodes must have the same axis of rotation. The axis
is compared using \f3\%pfAlmostEqualVec3\fP with a tolerance of 0.0001.
.RE

In order for two pfBillboard nodes to be considered \f2combinable\fP,
two additional conditions must be met:
.RS
.TP 10
Size
The destination pfBillboard node must not be too big.  The argument
\f2sizeLimit\fP defines the maximum number if pfGeoSets that any
combined node may contain, so nodes that already have at least
\f2sizeLimit\fP pfGeoSets will not receive additional pfGeoSets.
.TP
Safe
Both pfBillboard nodes being combined--the one giving up pfGeoSets and
the one receiving them--must be uninstanced nodes. This means that
each node has only one parent. This situation can be forced if desired
by calling \f3\%pfFlatten\fP on a scene graph before passing that scene
graph to \f3\%pfdCombineBillboards\fP.
.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfFlatten,
pfAlmostEqualVec3
