'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdExtensor" "3pf"
.SH NAME
.upperok
.B pfdAddState,
.B pfdStateCallback,
.B pfdGetStateCallback,
.B pfdGetStateToken,
.B pfdGetUniqueStateToken,
.B pfdNewExtensor,
.B pfdNewExtensorType,
.B pfdCompareExtensor,
.B pfdCompareExtraStates,
.B pfdCopyExtraStates,
.B pfdGetExtensor,
.B pfdGetExtensorType,
.B pfdUniqifyData
\- 
Flexible callback extension mechanism
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfNodeTravFuncType\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
int
\f3\%pfdAddState\fP(void\ *name,
'in +2
'll -2
long\ dataSize,
void\ (*initialize)(void\ *data),
void\ (*deletor)(void\ *data),
int\ (*compare)(void\ *data1,
void\ *data2),
long\ (*copy)(void\ *dst,
void\ *src),
int\ token);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdStateCallback\fP(int\ stateToken,
'in +2
'll -2
int\ whichCBack,
pfNodeTravFuncType\ callback);
.in
.ll
.nf
.fi
.TP
pfNodeTravFuncType
\f3\%pfdGetStateCallback\fP(int\ stateToken,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdGetStateToken\fP(void\ *name);
.nf
.fi
.TP
int
\f3\%pfdGetUniqueStateToken\fP(void);
.nf
.fi
.TP
pfdExtensor *
\f3\%pfdNewExtensor\fP(int\ which);
.nf
.fi
.TP
pfdExtensorType *
\f3\%pfdNewExtensorType\fP(int\ token);
.nf
.fi
.TP
int
\f3\%pfdCompareExtensor\fP(void\ *a,
'in +2
'll -2
void\ *b);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdCompareExtraStates\fP(void\ *lista,
'in +2
'll -2
void\ *listb);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdCopyExtraStates\fP(pfList\ *dst,
'in +2
'll -2
pfList\ *src);
.in
.ll
.nf
.fi
.TP
pfdExtensor *
\f3\%pfdGetExtensor\fP(int\ token);
.nf
.fi
.TP
pfdExtensorType *
\f3\%pfdGetExtensorType\fP(int\ token);
.nf
.fi
.TP
void *
\f3\%pfdUniqifyData\fP(pfList\ *dataList,
'in +2
'll -2
const\ void\ *data,
long\ dataSize,
void\ *(*newData)(long),
int\ (*compare)(void\ *,
void\ *),
long\ (*copy)(void\ *,
void\ *),
int\ *compareResult);
.in
.ll
.fi
.SH DESCRIPTION

.Ex
.nf

/* Define minimal Extensor as state in the builder */
/* Note a token will be created for you and passed back if the token */
/* arg is NULL */
extern int		pfdAddState(void *name,
			    long dataSize,
			    void (*initialize)(void *data),
			    void (*deletor)(void *data),
			    int (*compare)(void *data1, void *data2),
			    long (*copy)(void *dst, void *src),
			    int token);

/* Extend Extensor Definition through callbacks listed above */
/* Specify function callbacks for an Extensor */
extern void pfdStateCallback(int stateToken, int whichCBack, pfNodeTravFuncType callback);
extern pfNodeTravFuncType pfdGetStateCallback(int stateToken, int which);

/* Look up the builder state token to use for a registered name */
extern int pfdGetStateToken(void *name);

/* Get the next Unique State token that can be used as a valid */
/* token for user state in the builder */
extern int pfdGetUniqueStateToken(void);

/* Create Generic Extensors and Extensor Definitions */
/* Note the builder creates these automatically based on user */
/* definition of extensors through pfdAddState and appropriately */
/* creates instances of an Extensor based on the current user state */
extern pfdExtensor* pfdNewExtensor(int which);
extern pfdExtensorType* pfdNewExtensorType(int token);

/* Needed to share Extensors and do internal extensor caching */
extern int pfdCompareExtensor(void *a, void *b);

/* Compare a list of Extensors */
extern int pfdCompareExtraStates(void *lista, void *listb);
extern void pfdCopyExtraStates(pfList *dst, pfList *src);

/* Find an instance of an Extensor in the Builder's current User State */
extern pfdExtensor* pfdGetExtensor(int token);

/* Find a Extensor Definitions in the Builder */
extern pfdExtensorType* pfdGetExtensorType(int token);

/* Share Arbitrary data */
extern void *pfdUniqifyData(pfList *dataList, const void *data,
	long dataSize, void *(*newData)(long),
	int (*compare)(void *,void *),
	long (*copy)(void *, void *),
	int *compareResult);
.Ee
.fi
.na

.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
