'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdExtractGraphTriangles" "3pf"
.SH NAME
.upperok
.B pfdExtractGraphTriangles
\- 
Extraxt all the triangle from a scene graph.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
#include <Performer/pfdu.h>
.nf
.fi
.TP
void
\f3\%pfdExtractGraphTriangles\fP(pfNode\ *node,
'in +2
'll -2
pfGeoSet\ *gset,
unsigned\ long\ flags);
.in
.ll
.fi
.SH DESCRIPTION


\f3\%pfdExtractGraphTriangles\fP takes the pfNode \f2node\fP as input. It traverses
the scene graph portion spanned by this node and collects all the triangles.
It stores all the triangles in the pfGeoSet \f2gset\fP.
\f3\%pfdExtractGraphTriangles\fP uses the parameter \f2flags\fP to determine whar
triangle attributes are to be collected in \f2gset\fP. \f2flags\fP is a bitwise OR
of the following:

.RS
.TP 5
\f3\%PR_QUERY_TRI_COORD\fP
- Collect PFGS_COORD3 attributes.
.TP
\f3\%PR_QUERY_TRI_TEXTURE\fP
- Collect PFGS_TEXCOORD2 attributes.
.TP
\f3\%PR_QUERY_TRI_COLOR\fP
- Collect per-vertex PFGS_COLOR4 attributes.
.TP
\f3\%PR_QUERY_TRI_NORMAL\fP
- Collect per-vertex PFGS_NORMAL3 attributes.
.RE


The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfASD,
pfTerrain,
pfdAlignVerticesToASD,
pfdProjectVerticesOnASD
