'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdGeoBuilder" "3pf"
.SH NAME
.upperok
.B pfdNewGeom,
.B pfdResizeGeom,
.B pfdDelGeom,
.B pfdCopyGeom,
.B pfdReverseGeom,
.B pfdNewGeoBldr,
.B pfdDelGeoBldr,
.B pfdGeoBldrMode,
.B pfdGetGeoBldrMode,
.B pfdTriangulatePoly,
.B pfdAddGeom,
.B pfdAddPoint,
.B pfdAddLine,
.B pfdAddTri,
.B pfdAddPoly,
.B pfdAddPoints,
.B pfdAddLines,
.B pfdAddLineStrips,
.B pfdAddIndexedPoints,
.B pfdAddIndexedLines,
.B pfdAddIndexedLineStrips,
.B pfdAddIndexedTri,
.B pfdAddIndexedPoly,
.B pfdGetNumTris,
.B pfdBuildGSets,
.B pfdPrintGSet
\- 
Create optimized pfGeoSets from independent geometry.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfdGeoBuilder\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
pfdGeom *
\f3\%pfdNewGeom\fP(int\ numV);
.nf
.fi
.TP
void
\f3\%pfdResizeGeom\fP(pfdGeom\ *geom,
'in +2
'll -2
int\ numV);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdDelGeom\fP(pfdGeom\ *geom);
.nf
.fi
.TP
void
\f3\%pfdCopyGeom\fP(pfdGeom\ *dst,
'in +2
'll -2
pfdGeom\ *src);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdReverseGeom\fP(pfdGeom\ *geom);
.nf
.fi
.TP
pfdGeoBuilder *
\f3\%pfdNewGeoBldr\fP(void);
.nf
.fi
.TP
void
\f3\%pfdDelGeoBldr\fP(pfdGeoBuilder*\ bldr);
.nf
.fi
.TP
void
\f3\%pfdGeoBldrMode\fP(pfdGeoBuilder*\ bldr,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdGetGeoBldrMode\fP(pfdGeoBuilder*\ bldr,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdTriangulatePoly\fP(pfdGeom\ *pgon,
'in +2
'll -2
pfdPrim\ *triList);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddGeom\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *Geom,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddPoint\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdPrim\ *Point);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddLine\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdPrim\ *line);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddTri\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdPrim\ *tri);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddPoly\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *poly);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddPoints\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *points);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddLines\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *lines);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddLineStrips\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *lineStrips,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddIndexedPoints\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *points);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddIndexedLines\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *lines);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddIndexedLineStrips\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *lines,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddIndexedTri\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdPrim\ *tri);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfdAddIndexedPoly\fP(pfdGeoBuilder\ *bldr,
'in +2
'll -2
pfdGeom\ *poly);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfdGetNumTris\fP(pfdGeoBuilder\ *bldr);
.nf
.fi
.TP
pfList *
\f3\%pfdBuildGSets\fP(pfdGeoBuilder\ *bldr);
.nf
.fi
.TP
void
\f3\%pfdPrintGSet\fP(pfGeoSet\ *gset);
.fi

.Ex
.nf

typedef struct _pfdPrim
{
    int         flags;
    int         nbind, cbind, tbind;

    float       pixelsize;

    pfVec3      coords[3];
    pfVec3      norms[3];
    pfVec4      colors[3];
    pfVec2      texCoords[3];

    pfVec3      *coordList;
    pfVec3      *normList;
    pfVec4      *colorList;
    pfVec2      *texCoordList;

    ushort      icoords[3];
    ushort      inorms[3];
    ushort      icolors[3];
    ushort      itexCoords[3];

    struct _pfdPrim         *next;
} pfdPrim;

typedef struct _pfdGeom
{
    int         flags;
    int         nbind, cbind, tbind;

    int         numVerts;
    short       primtype;
    float       pixelsize;

    pfVec3      *coords;
    pfVec3      *norms;
    pfVec4      *colors;
    pfVec2      *texCoords;

    pfVec3      *coordList;
    pfVec3      *normList;
    pfVec4      *colorList;
    pfVec2      *texCoordList;

    ushort      *icoords;
    ushort      *inorms;
    ushort      *icolors;
    ushort      *itexCoords;

    struct _pfdGeom         *next;
} pfdGeom;

typedef pfdGeom pfdPoly;
typedef pfdPrim pfdTri;
.Ee
.fi
.na

.SH DESCRIPTION

The \f3\%pfdGeoBuilder\fP tools greatly simplify the task of creating OpenGL
Performer geometry structures (\f3\%pfGeoSets\fP).  More importantly, the
\f3\%pfdGeoBuilder\fP utility creates optimized line-strip and triangle-strip
\f3\%pfGeoSets\fP that can significantly improve rendering performance and
decrease memory usage.

The \f3\%pfdGeoBuilder\fP only manages geometry. For managing geometry and
state (appearance attributes such as texture and material) there is a
higher level \f3\%pfdBuilder\fP tool that itself uses the
\f3\%pfdGeoBuilder\fP.

Typically the higher-level \f3\%pfdBuilder\fP (rather than the low-level
\f3\%pfdGeoBuilder\fP) is used when writing a database importer for OpenGL
Performer.  In either case, the loaders take external data in popular
database file formats and convert them into OpenGL Performer runtime
scene-graph structures.  There are many examples of file loaders based
on the pfdBuilder and pfdGeoBuilder facilities in the \f3\%libpfdb\fP
database loader library.

The pfdGeoBuilder is used to build pfGeoSets from arbitrary input geometry
in the following way:
.RS
.TP 5
1.
Create a \f3\%pfdGeoBuilder\fP data structure by calling \f3\%pfdNewGeoBldr\fP.
.TP
2.
Create a pfdGeom data structure by calling \f3\%pfdNewGeom\fP with the
maximum number of vertices required. This size can be changed later
via calls to \f3\%pfdResizeGeom\fP.
.TP
3.
Add geometric objects one at a time to the builder created in Step 1
via calls to \f3\%pfdAddGeom\fP, \f3\%pfdAddPoint\fP, \f3\%pfdAddLine\fP,
\f3\%pfdAddTri\fP, \f3\%pfdAddPoly\fP, \f3\%pfdAddPoints\fP, \f3\%pfdAddLines\fP,
\f3\%pfdAddLineStrips\fP, \f3\%pfdAddIndexedPoints\fP, \f3\%pfdAddIndexedLines\fP,
\f3\%pfdAddIndexedLineStrips\fP, \f3\%pfdAddIndexedTri\fP, or
\f3\%pfdAddIndexedPoly\fP.
.TP
4.
Once all geometry has been added to the builder, call \f3\%pfdBuildGSets\fP
to obtain a list of \f3\%pfGeoSet\fPs representing the geometry in line strips
and triangle strips wherever possible.
.RE

\f3\%pfdNewGeom\fP allocates a \f3\%pfdGeom\fP structure capable of containing a
single geometric object with up to \f2numV\fP vertices. This object
contains a number of internal arrays whose sizes scale with \f2numV\fP,
so allocating a large \f3\%pfdGeom\fP can require a considerable amount of
storage.

\f3\%pfdResizeGeom\fP is used to change the vertex limit of the \f3\%pfdGeom\fP
\f2geom\fP.  The old vertex values are retained in this reallocation, so
that loaders can simply invoke \f3\%pfdResizeGeom\fP to enlarge a \f3\%pfdGeom\fP
without special attention to the existing data. When the new size
(\f2numV\fP) is smaller than the previous size, only the first \f2numV\fP
old vertices are kept.

\f3\%pfdDelGeom\fP frees the storage allocated for the pfdGeom \f2geom\fP.

\f3\%pfdCopyGeom\fP copies the contents of the pfdGeom \f2src\fP to \f2dst\fP.
Use \f3\%pfdResizeGeom\fP if necessary to ensure that the arrays internal
to \f2dst\fP are of an appropriate size prior to the copy.

\f3\%pfdReverseGeom\fP reverses the order of the vertices in \f2geom\fP. Use
this to generate polygonal objects with a consistent vertex ordering
(clockwise or counterclockwise) when viewed from the outside. When this
is the case, backface culling can be enabled for improved graphics
performance.

\f3\%pfdNewGeoBldr\fP allocates a new \f3\%pfdGeoBuilder\fP structure and
initializes it to accept geometry. The \f3\%pfdGeoBuilder\fP's internal data is
self-sizing and will grow as needed when points, lines, and polygons
are added to it.

\f3\%pfdDelGeoBldr\fP frees the storage allocated to the \f3\%pfdGeoBuilder\fP
\f2bldr\fP.

\f3\%pfdGeoBldrMode\fP specifies modes to be used by the \f3\%pfdGeoBuilder\fP
\f2bldr\fP as it processes input geometry and constructs \f3\%pfGeoSets\fP.  The
supported modes are:

.RS
.TP 5
\f3\%PFDGBLDR_AUTO_COLORS\fP
Generate random colors for geometric objects. There are four options
for this mode, and they are:
.RS
.TP 5
PFDGBLDR_COLORS_PRESERVE
Leave color definitions as they are. This is the default mode.
.TP
PFDGBLDR_COLORS_MISSING
Generate colors for those primitives that do not provide them.
This mode only replaces missing colors, it does not override
any colors that have been defined.
.TP
PFDGBLDR_COLORS_GENERATE
Generate a new random color for each primitive.
.TP
PFDGBLDR_COLORS_DISCARD
Discard existing color definitions and do not generate any
replacement colors.
.RE

.TP
\f3\%PFDGBLDR_AUTO_NORMALS\fP
Generate normals for geometric objects. There are four options
for this mode, and they are:
.RS
.TP 5
PFDGBLDR_NORMALS_PRESERVE
Leave normal definitions as they are. This is the default mode.
.TP
PFDGBLDR_NORMALS_MISSING
Generate normals for those primitives that do not provide them.
This mode only replaces missing normals, it does not override
any normals that have been defined.
.TP
PFDGBLDR_NORMALS_GENERATE
Generate a new normal for each primitive.
.TP
PFDGBLDR_NORMALS_DISCARD
Discard existing normal definitions and do not generate any
replacement normals.
.RE

.TP
\f3\%PFDGBLDR_AUTO_TEXTURE\fP
Generate texture coordinates for geometric objects. There are
four options for this mode, and they are:
.RS
.TP 5
PFDGBLDR_TEXTURE_PRESERVE
Leave texture coordinate definitions as they are. This is the
default mode.
.TP
PFDGBLDR_TEXTURE_MISSING
Generate texture coordinates for those primitives that do not
provide them.  This mode only replaces missing texture coordinates,
it does not override any texture coordinates that have been defined.
\f2This option is provided for future expansion. It is not currently
implemented\fP.
.TP
PFDGBLDR_TEXTURE_GENERATE
Generate texture coordinates for each primitive. \f2This option is
provided for future expansion. It is not currently implemented\fP.
.TP
PFDGBLDR_TEXTURE_DISCARD
Discard existing texture coordinate definitions and do not
generate any replacement texture coordinates.
.RE

.TP
\f3\%PFDGBLDR_AUTO_ORIENT\fP
Automatically reverse normal vector direction or vertex order for
polygons that have a supplied overall normal or per-vertex normals
if the internally computed normal value indicates that the input
vertices had clockwise rather than counterclockwise orientation.
.RS
.TP
PFDGBLDR_ORIENT_PRESERVE
Do not modify vertex orientation or normal direction.
.TP
PFDGBLDR_ORIENT_NORMALS
Reverse direction (by negating normals) to make the sidedness
of polygons consistent with the standard orientation, which is
counterclockwise when viewed from the outside of the surface.
The outside is defined as the direction in which the normal
points.
.TP
PFDGBLDR_ORIENT_VERTICES
Reverse direction (by reversing the order of vertices) to make
the sidedness of polygons consistent with the standard orientation,
which is counterclockwise when viewed from the outside of the surface.
The outside is defined as the direction in which the normal points.
This is the default method, since people who provide a normal usually
know which way they want it to point.
.RE

.TP
\f3\%PFDGBLDR_MESH_ENABLE\fP
Generate triangle meshes from input geometry.
This task is actually performed using the \f3\%pfdMeshGSet\fP function. See
the \f3\%pfdTMesher\fP man page for further details.
The default is \f3\%TRUE\fP.
.RE

\f3\%pfdGetBldrMode\fP returns the current value of \f3\%pfdGeoBuilder\fP
\f2bldr\fP's internal processing mode, \f2mode\fP. The valid \f2mode\fP
arguments are those listed for \f3\%pfdGeoBldrMode\fP above.

\f3\%pfdTriangulatePoly\fP triangulates a polygon defined by pfdGeom
\f2pgon\fP and appends the resulting triangles to the list of triangles
in \f2triList\fP. If the input polygon is concave,
\f3\%pfdTriangulatePoly\fP will OR the \f3\%PFDPOLY_CONCAVE\fP bit into the
\f2flags\fP member of the \f2poly\fP structure.  The return value is
\f3\%TRUE\fP if \f2poly\fP is concave and \f3\%FALSE\fP otherwise.  Note that
\f3\%pfdTriangulatePoly\fP will not "fan out" convex polygons but will
"zigzag" them so the resultant triangles can be easily formed into a
single triangle strip (see \f3\%pfdMeshGSet\fP).

Geometric objects are added to a \f3\%pfdGeoBuilder\fP using the general
\f3\%pfdAddGeom\fP function or via the related functions described below.
\f3\%pfdAddGeom\fP adds one a pfdGeom object to the designated
\f3\%pfdGeoBuilder\fP \f2bldr\fP. If the pfdGeom is a line strip, then the
argument \f2num\fP specifies the number of lines in the line strip
\f3\%pfdAddGeom\fP is the general way to add geometry to a
\f3\%pfdGeoBuilder\fP.

Four distinct types of geometric objects can be defined in a pfdGeom:
points, lines, line strips, and polygons, and there is a lower-level
primitive adding function for each: \f3\%pfdAddPoints\fP, \f3\%pfdAddLines\fP,
\f3\%pfdAddLineStrips\fP, and \f3\%pfdAddPoly\fP. These functions are invoked
by \f3\%pfdAddGeom\fP to process input geometry and are not usually called
directly by users.

The \f3\%pfdGeoBuilder\fP also supports the optimization of indexed geometric
data. It is only necessary to specify index list information in the
pfdGeom structure and then call one of the indexed versions of the
geometry adding functions:  \f3\%pfdAddIndexedPoints\fP,
\f3\%pfdAddIndexedLines\fP, \f3\%pfdAddIndexedLineStrips\fP, or
\f3\%pfdAddIndexedPoly\fP.

There are four remaining geometry adding functions. These accept
low-level \f3\%pfdPrim\fP geometry definitions rather than the
higher-level \f3\%pfdGeom\fP definitions. Use of these functions is
discouraged.  \f3\%pfdAddPoint\fP adds the point \f3\%pfdPrim\fP \f2Point\fP to
\f3\%pfdGeoBuilder\fP \f2bldr\fP, \f3\%pfdAddLine\fP adds the line \f2line\fP,
\f3\%pfdAddTri\fP adds the triangle \f2tri\fP, and \f3\%pfdAddIndexedTri\fP adds
the indexed triangle \f2tri\fP.

In all cases, these geometry processing functions copy the geometric
definition into internal \f3\%pfdGeoBuilder\fP memory so that the
application need not manage multiple \f3\%pfdGeom\fP or \f3\%pfdPrim\fP data
structures. The fields of the \f3\%pfdGeom\fP or \f3\%pfdPrim\fP structure
should be set as follows:

\f2nbind\fP, \f2cbind\fP, \f2tbind\fP specify the normal, color, and texture
coordinate binding respectively.  They may be one of the following values:

.RS
.TP 5
\f3\%PFGS_PER_VERTEX\fP
An attribute is specified for each vertex of the
point, line, or polygon.
.TP
\f3\%PFGS_PER_PRIM\fP, \f3\%PFGS_OVERALL\fP
The first element of the attribute
array specifies the attribute for the point, line, or polygon, e.g. norms[0]
is the normal for the entire object.
.TP
\f3\%PFGS_OFF\fP
No attribute value is specified.
.RE

\f2pixelsize\fP defines the width in pixels to be used when drawing the
indicated point or line. \f2pixelsize\fP is ignored for polygon data.

\f2coords\fP, \f2norms\fP, \f2colors\fP, \f2texCoords\fP specify the coordinates,
normals, colors, and texture coordinates of the point, line, or polygon
according to the binding types described above, e.g. \f2coords\fP[0],
\f2coords\fP[1], \f2coords\fP[2] define the coordinates of a pfdTri.

Example 1:
.Ex
.nf

    pfdGeoBuilder *bldr;
    pfdGeom       *geom;
    pfList        *gsetList;

    /* allocate pfdGeoBuilder and pfdGeom storage */
    bldr = pfdNewGeoBldr();
    geom = pfdNewGeom(4);

    /* feed polygons to pfdGeoBuilder */
    while (!done)
    {
	    :
	geom->flags = 0;
	geom->nbind = PFGS_PER_PRIM;
	geom->cbind = PFGS_OFF;
	geom->tbind = PFGS_OFF;

	geom->numVerts = 4;
	pfCopyVec3(geom->coords[0], myCoords[i]);
	pfCopyVec3(geom->coords[1], myCoords[i+1]);
	pfCopyVec3(geom->coords[2], myCoords[i+2]);
	pfCopyVec3(geom->coords[3], myCoords[i+3]);

	pfCopyVec3(geom->norms[0], myNorms[j]);

	pfdAddGeom(bldr, geom, 1);
	    :
    }

    /* generate optimized triangle mesh GeoSet */
    gsetList = pfdBuildGSets(bldr);

    /* add returned pfGeoSets to geode */
    for (i=0; i<pfGetNum(gsetList); i++)
	pfAddGSet(geode, pfGet(gsetList, i));

    /* release pfdGeoBuilder and pfdGeom storage */
    pfdDelGeoBldr(bldr);
    pfdDelGeom(geom);
.Ee
.fi
.na


\f3\%pfdGetNumTris\fP returns the number of triangles currently contained in
the \f3\%pfdGeoBuilder\fP structure \f2bldr\fP.

\f3\%pfdBuildGSets\fP converts all accumulated points, lines, and polygons
into point, line, line strip, triangle, and triangle-strip pfGeoSets
and returns a \f3\%pfList\fP referencing these pfGeoSets. \f3\%pfdBuildGSets\fP
also resets \f2bldr\fP, removing the geometric definitions therein.  The
pfGeoSets created by the builder are meshed by \f3\%pfdMeshGSet\fP,
subject to the meshing mode set by \f3\%pfdMesherMode\fP.

\f3\%pfdPrintGSet\fP prints a representation of pfGeoSet \f2gset\fP using the
\f3\%pfNotify\fP mechanism.
.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfGeoSet,
pfGeode,
pfList,
pfdMeshGSet,
pfdMesherMode,
pfdTMesher
