'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdLoadFont" "3pf"
.SH NAME
.upperok
.B pfdLoadFont,
.B pfdLoadFont_type1
\- 
Utilities for loading fonts into Performer applications
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfFont\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
pfFont *
\f3\%pfdLoadFont\fP(char\ *ext,
'in +2
'll -2
char\ *fontFileName,
int\ style);
.in
.ll
.nf
.fi
.TP
pfFont *
\f3\%pfdLoadFont_type1\fP(char\ *fontName,
'in +2
'll -2
int\ style);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfdLoadFont\fP tries to load a font of specific type using the
\f2ext\fP to find a routine that is capable of building this type
of font.  The routine name is of the form pfdLoadFont_ext.
This routine will then use \f2fontFileName\fP to find a
file containing the font description and try to create the pfFont
using this description and the \f2style\fP token.
Current font style tokens include:
\f3\%PFDFONT_TEXTURED\fP,
\f3\%PFDFONT_OUTLINED\fP,
\f3\%PFDFONT_FILLED\fP,
\f3\%PFDFONT_EXTRUDED\fP,
and
\f3\%PFDFONT_VECTOR\fP.
Although only some of these styles may be available for any
particular font.

\f3\%pfdLoadFont_type1\fP is one instance of a font loader.  It loads
Haeberli font definitions into Performer structures.
Valid styles are all of the above except \f3\%PFDFONT_VECTOR\fP.
.SH SEE ALSO
pfFont,
pfString,
pfText
