'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdLoadMPClipTexture" "3pf"
.SH NAME
.upperok
.B pfdLoadMPClipTexture
\- 
Read Configuration File to Configure a MultiProcess Clip Texture
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfMPClipTexture\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
pfMPClipTexture *
\f3\%pfdLoadMPClipTexture\fP(const\ char\ *fileName)
.fi
.SH DESCRIPTION

\f3\%pfdLoadMPClipTexture\fP accepts a string containing the path to a
configuration file describing a \f3\%pfClipTexture\fP. It configures and
creates a multiprocess clip texture.

A Multiprocess Clip Texture is part of libpf, and unlike a Clip Texture,
is not restricted to use in the draw process. See the \f3\%pfMPClipTexture\fP
man page for more information.

The configuration files for creating a \f3\%pfClipTexture\fP and a
\f3\%pfMPClipTexture\fP are identical. See the \f3\%pfClipTexture\fP man page for
information on the clip texture configuration file format.
.SH NOTES

ClipTexture functionality is not supported under Linux.

.SH BUGS

The parser that reads configuration files is very limited. In particular, it
only allows comments where it would be expecting a token, and expects the
tokens and data fields in a fixed order.
.SH SEE ALSO
pfImageCache,
pfMPImageCache,
pfClipTexture,
pfMPClipTexture,
pfTexture,
pfdLoadClipTexture
