'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfdSpatialize" "3pf"
.SH NAME
.upperok
.B pfdSpatialize,
.B pfdTravGetGSets
\- 
Collect and partition pfGeoSets in scene graphs.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfGroup\ *\ \ \ 'u
#include <Performer/pfdu.h>
.nf
.fi
.TP
pfGroup *
\f3\%pfdSpatialize\fP(pfGroup\ *group,
'in +2
'll -2
float\ maxGeodeSize,
int\ maxGeoSets);
.in
.ll
.nf
.fi
.TP
pfList *
\f3\%pfdTravGetGSets\fP(pfNode\ *node);
.fi
.SH DESCRIPTION

\f3\%pfdSpatialize\fP gathers together all the \f3\%pfGeoSets\fP referenced in
the graph rooted at \f2group\fP.  It constructs a new subgraph where all
the \f3\%pfGeoSets\fP are grouped together by their spatial location. An
octree is used to control the grouping. It is ensured that no more
than \f2maxGeoSets\fP \f3\%pfGeoSets\fP will be grouped together in one
\f3\%pfGeode\fP and that the spatial width of every individual \f3\%pfGeode\fP
constructed will never exceed \f2maxGeodeSize\fP. The new graph is
returned to the caller.

\f3\%pfdTravGetGSets\fP traverses the graph rooted at \f2node\fP to find all
the referenced pfGeoSets.  A list containing every pfGeoSet found by
this traversal is returned to the caller.
.SH NOTES

The libpfdu source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfGeoSet
