'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuAutoList" "3pfu"
.SH NAME
.upperok
.B pfuAutoList
\- 
Dynamically-sized resource owning list
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'static\ pfType*\ \ \ 'u
#include <Performer/pfutil/pfuAutoList.h>
.nf
.fi
.TP
\ 
\f3\%pfuAutoList::pfuAutoList\fP();
.nf
.fi
.TP
\ 
\f3\%pfuAutoList::pfuAutoList\fP(int\ listLength);
.nf
.fi
.TP
static pfType*
\f3\%pfuAutoList::getClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfuAutoList::add\fP(pfMemory*\ elt);
.nf
.fi
.TP
void*
\f3\%pfuAutoList::get\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfuAutoList::getNum\fP(void);
.nf
.fi
.TP
void
\f3\%pfuAutoList::insert\fP(int\ index,
'in +2
'll -2
pfMemory*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuAutoList::move\fP(int\ index,
'in +2
'll -2
pfMemory*\ elt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuAutoList::remove\fP(pfMemory*\ elt);
.nf
.fi
.TP
void
\f3\%pfuAutoList::removeIndex\fP(int\ index);
.nf
.fi
.TP
int
\f3\%pfuAutoList::replace\fP(pfMemory*\ old,
'in +2
'll -2
pfMemory*\ new);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuAutoList::reset\fP(void);
.nf
.fi
.TP
int
\f3\%pfuAutoList::search\fP(pfMemory*\ elt);
.nf
.fi
.TP
int
\f3\%pfuAutoList::search\fP(pfType*\ type);
.nf
.fi
.TP
void
\f3\%pfuAutoList::set\fP(int\ index,
'in +2
'll -2
pfMemory*\ elt);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfuAutoList\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfuAutoList\fP.
This is also true for
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'void*\ \ \ 'u
void*
\f3\%pfObject::operator new\fP(size_t);
.PD 0
.TP
void*
\f3\%pfObject::operator new\fP(size_t,
'in +2
'll -2
pfFluxMemory\ *fmem);
.in
.ll
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(void\ *data);
.PD 0
.TP
void
\f3\%pfObject::setUserData\fP(int\ slot,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj);
.PD 0
.TP
void*
\f3\%pfObject::getUserData\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
int
\f3\%pfObject::getNumUserData\fP();

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfuAutoList\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void*
\f3\%pfMemory::getData\fP(const\ void\ *ptr);
.PD 0
.TP
pfType *
\f3\%pfMemory::getType\fP();
.PD 0
.TP
int
\f3\%pfMemory::isOfType\fP(pfType\ *type);
.PD 0
.TP
int
\f3\%pfMemory::isExactType\fP(pfType\ *type);
.PD 0
.TP
const char *
\f3\%pfMemory::getTypeName\fP();
.PD 0
.TP
int
\f3\%pfMemory::copy\fP(pfMemory\ *src);
.PD 0
.TP
int
\f3\%pfMemory::compare\fP(const\ pfMemory\ *mem);
.PD 0
.TP
void
\f3\%pfMemory::print\fP(uint\ which,
'in +2
'll -2
uint\ verbose,
char\ *prefix,
FILE\ *file);
.in
.ll
.PD 0
.TP
int
\f3\%pfMemory::getArena\fP(void\ *ptr);
.PD 0
.TP
void*
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::ref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unref\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::unrefGetRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::getRef\fP();
.PD 0
.TP
int
\f3\%pfMemory::checkDelete\fP();
.PD 0
.TP
int
\f3\%pfMemory::isFluxed\fP();
.PD 0
.TP
void *
\f3\%pfMemory::getArena\fP();
.PD 0
.TP
int
\f3\%pfMemory::getSize\fP();
.PD
.fi
.SH DESCRIPTION


A pfuAutoList is a dynamically-sized list of elements.  Elements must
be of type pointer to pfMemory (or a derived class).  pfuAutoList
increments the reference count of elements that are added or inserted
into the list.  It decrements the reference count of elements that are
removed from the list.  In this way, pfuAutoList takes ownership of its
elements.

The default constructor \f3\%pfuAutoList\fP creates a list with an element
size of \f3\%sizeof( pfMemory* )\fP.  The element size is fixed and cannot
be changed. Another constructor is provided that allows the initial
allocated length \f2listLength\fP for the pfuAutoList.  \f3\%new\fP(arena)
allocates a pfuAutoList from the specified memory arena, or from the
process heap if \f2arena\fP is NULL.  \f3\%new\fP allocates a pfuAutoList
from the default memory arena (see \f3\%pfGetSharedArena\fP).  Like other
pfObjects, pfuAutoLists cannot be created statically, automatically on
the stack or in arrays.

pfuAutoLists should be deleted with \f3\%pfDelete\fP rather than the delete
operator.  When a list is deleted, it calls \f3\%pfMemory::unrefDelete()\fP
on all elements in the list.

\f3\%pfuAutoList::getClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfuAutoList\fP.  The \f3\%pfType\fP* returned
by \f3\%pfuAutoList::getClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking the
virtual function \f3\%getType\fP on any instance of class
\f3\%pfuAutoList\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use  the member
function \f3\%isOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

A pfuAutoList dynamically increases its list size by a factor of 2 and
zeros the additional memory whenever it runs out of memory.  This way
the list size quickly reaches its final size without many
reallocations of memory.  However, some memory (up to one half of the
total allocation) at the end of the list may be wasted.  If you know
the exact number of elements in the list, you can specify the
pfuAutoList list length when creating it (the \f2listLength\fP argument
to \f3\%new pfuAutoList\fP).

\f3\%pfList::set\fP sets the \f2index\fPth element of
the pfList to \f2elt\fP.  The list is automatically
grown if \f2index\fP is beyond the current list length.  If the list
already contains an element at \f2index\fPth then \f3\%pfMemory::unref()\fP is
called on that element, before \f2elt\fP is inserted into the list.
\f3\%pfMemory::ref()\fP is called on \f2elt\fP.

\f3\%pfuAutoList::get\fP returns the element of
the pfuAutoList at index \f2index\fP or 0 if \f2index\fP
is out of bounds.

\f3\%pfuAutoList::add\fP appends \f2elt\fP to
the pfuAutoList and automatically grows
the pfuAutoList if necessary.  \f3\%pfMemory::ref()\fP is
called on \f2elt\fP.

\f3\%pfuAutoList::remove\fP removes \f2elt\fP from
the pfuAutoList and shifts the elements down over the
vacant spot, e.g. - if \f2elt\fP had index 0, then index 1 becomes index
0, index 2 becomes index 1 and so on.
\f3\%pfuAutoList::remove\fP returns the index of \f2elt\fP
if \f2elt\fP was actually removed and -1 if it was not found in the list.
\f3\%pfuAutoList::removeIndex\fP removes the
\f2index\fPth element of the pfuAutoList, and like
\f3\%pfuAutoList::remove\fP, shifts the elements down over
the vacant spot.

Note that if the requested element was removed from the list then
\f3\%pfMemory::unref()\fP is called on that element. In this way, the list
disowns the removed element.

Note that \f3\%pfuAutoList::remove\fP linearly searches
the list for \f2elt\fP and removes only the first matching element.  To
remove all occurrences of \f2elt\fP do the following:
.Ex
.nf

while (list->remove(elt) >= 0)
    /* empty */ ;
.Ee
.fi
.na


\f3\%pfuAutoList::search( pfMemory* )\fP returns the
index of \f2elt\fP if \f2elt\fP was found in the
pfuAutoList and -1 otherwise.

\f3\%pfuAutoList::search( pfType* )\fP returns the
index of \f2type\fP, if an element was found in the
pfuAutoList that returns \f3\%TRUE\fP for \f3\%pfMemory::isOfType()\fP, and
returns -1 otherwise.

\f3\%pfuAutoList::insert\fP inserts \f2elt\fP before the
list element with index \f2index\fP.  \f2index\fP must be within the range
[0 .. \f3\%list->getNum\fP()].
\f3\%pfMemory::ref()\fP is called on \f2elt\fP.

\f3\%pfuAutoList::move\fP deletes \f2elt\fP from its current
location and inserts before the list element with index \f2index\fP.
\f2index\fP must be within the range [0 ..
\f3\%list->getNum\fP()] or else (-1) is
returned and no move is executed. If \f2elt\fP is not already in
the pfuAutoList, (-1) is returned and \f2elt\fP is not
inserted into the list. Otherwise, \f2index\fP is returned to indicate
success.

\f3\%pfuAutoList::replace\fP replaces the first instance
of \f2old\fP with \f2new\fP and returns the index of \f2old\fP if it was
found in the pfuAutoList and -1 otherwise.
\f3\%pfMemory::unref()\fP is called on \f2old\fP if it was found in the list.

\f3\%pfuAutoList::getNum\fP returns the number of
elements in the pfuAutoList.

\f3\%pfuAutoList::reset\fP calls
\f3\%pfMemory::unrefDelete()\fP on all the elements in \f2list\fP and resets
the number of elements to 0.

.SH NOTES

Any attempt to add or insert non-\f3\%pfMemory\fP objects into a
\f3\%pfuAutoList\fP will fail. If an error status cannot be returned then a
warning will be issued. The list will remain unchanged.

.SH SEE ALSO
pfList,
pfMemory
