'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfClipTexture" "3pf"
.SH NAME
.upperok
.B pfNewClipTexture,
.B pfGetClipTextureClassType,
.B pfClipTextureCenter,
.B pfGetClipTextureCenter,
.B pfGetClipTextureCurCenter,
.B pfClipTextureLevel,
.B pfGetClipTextureLevel,
.B pfClipTextureClipSize,
.B pfGetClipTextureClipSize,
.B pfClipTextureVirtualSize,
.B pfGetClipTextureVirtualSize,
.B pfClipTextureInvalidBorder,
.B pfGetClipTextureInvalidBorder,
.B pfClipTextureVirtualLODOffset,
.B pfGetClipTextureVirtualLODOffset,
.B pfClipTextureNumEffectiveLevels,
.B pfGetClipTextureNumEffectiveLevels,
.B pfClipTextureMaster,
.B pfGetClipTextureMaster,
.B pfGetClipTextureSlaves,
.B pfClipTextureLevelPhaseMargin,
.B pfGetClipTextureLevelPhaseMargin,
.B pfClipTextureLevelPhaseShift,
.B pfGetClipTextureLevelPhaseShift,
.B pfGetClipTextureOffset,
.B pfUpdateClipTexture,
.B pfApplyClipTexture,
.B pfClipTextureLODRange,
.B pfGetClipTextureLODRange,
.B pfGetClipTextureCurLODRange,
.B pfClipTextureDTRFadeCount,
.B pfGetClipTextureDTRFadeCount,
.B pfClipTextureDTRMode,
.B pfGetClipTextureDTRMode,
.B pfClipTextureTexLoadTime,
.B pfGetClipTextureTexLoadTime,
.B pfClipTextureDTRBlurMargin,
.B pfGetClipTextureDTRBlurMargin,
.B pfInvalidateClipTexture,
.B pfClipTextureLODBias,
.B pfGetClipTextureLODBias,
.B pfGetClipTextureCurLODBias,
.B pfClipTextureNumAllocatedLevels,
.B pfGetClipTextureNumAllocatedLevels,
.B pfGetClipTextureMinDTRLOD,
.B pfIsClipTextureVirtual,
.B pfClipTextureLODOffsetLimit,
.B pfGetClipTextureLODOffsetLimit,
.B pfClipTextureNumEffectiveLevelsLimit,
.B pfGetClipTextureNumEffectiveLevelsLimit,
.B pfClipTextureMinLODLimit,
.B pfGetClipTextureMinLODLimit,
.B pfClipTextureMaxLODLimit,
.B pfGetClipTextureMaxLODLimit,
.B pfClipTextureLODBiasLimit,
.B pfGetClipTextureLODBiasLimit
\- 
Create, modify, and update a virtual texture via a cache in texture
memory and main memory, as well as management of disk paging.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfClipTexture\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfClipTexture *
\f3\%pfNewClipTexture\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetClipTextureClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfClipTextureCenter\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ s,
int\ t,
int\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureCenter\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ *s,
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureCurCenter\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ *s,
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureLevel\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ lvl,
pfObject\ *levelObj);
.in
.ll
.nf
.fi
.TP
pfObject *
\f3\%pfGetClipTextureLevel\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ lvl);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureClipSize\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ clipSize);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureClipSize\fP(pfClipTexture*\ clip);
.nf
.fi
.TP
void
\f3\%pfClipTextureVirtualSize\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ width,
int\ height,
int\ depth);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureVirtualSize\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ *width,
int\ *height,
int\ *depth);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureInvalidBorder\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ nTexels);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureInvalidBorder\fP(pfClipTexture*\ clip);
.nf
.fi
.TP
void
\f3\%pfClipTextureVirtualLODOffset\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ offset);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureVirtualLODOffset\fP(pfClipTexture*\ clip);
.nf
.fi
.TP
void
\f3\%pfClipTextureNumEffectiveLevels\fP(pfClipTexture*\ clip,
'in +2
'll -2
int\ levels);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureNumEffectiveLevels\fP(pfClipTexture*\ clip);
.nf
.fi
.TP
void
\f3\%pfClipTextureMaster\fP(pfClipTexture*\ clip,
'in +2
'll -2
pfClipTexture\ *master);
.in
.ll
.nf
.fi
.TP
pfClipTexture *
\f3\%pfGetClipTextureMaster\fP(pfClipTexture\ *slave);
.nf
.fi
.TP
pfList *
\f3\%pfGetClipTextureSlaves\fP(pfClipTexture\ *master);
.nf
.fi
.TP
void
\f3\%pfClipTextureLevelPhaseMargin\fP(pfClipTexture\ *clip,
'in +2
'll -2
int\ level,
int\ size);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureLevelPhaseMargin\fP(pfClipTexture\ *clip,
'in +2
'll -2
int\ level);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureLevelPhaseShift\fP(pfClipTexture\ *clip,
'in +2
'll -2
int\ level,
int\ shiftS,
int\ shiftT,
int\ shiftR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureLevelPhaseShift\fP(pfClipTexture\ *clip,
'in +2
'll -2
int\ level,
int\ *shiftS,
int\ *shiftT,
int\ *shiftR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureOffset\fP(int\ *s,
'in +2
'll -2
int\ *t,
int\ *r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfUpdateClipTexture\fP(pfClipTexture*\ clip);
.nf
.fi
.TP
void
\f3\%pfApplyClipTexture\fP(pfClipTexture*\ clip);
.nf
.fi
.TP
void
\f3\%pfClipTextureLODRange\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ min,
float\ max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureLODRange\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureCurLODRange\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureDTRFadeCount\fP(pfClipTexture\ *tex,
'in +2
'll -2
int\ count);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureDTRFadeCount\fP(pfClipTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfClipTextureDTRMode\fP(pfClipTexture\ *tex,
'in +2
'll -2
uint\ DTRMode);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetClipTextureDTRMode\fP(pfClipTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfClipTextureTexLoadTime\fP(pfClipTexture\ *tex,
'in +2
'll -2
float\ time);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetClipTextureTexLoadTime\fP(pfClipTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfClipTextureDTRBlurMargin\fP(pfClipTexture\ *tex,
'in +2
'll -2
float\ margin);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetClipTextureDTRBlurMargin\fP(pfClipTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfInvalidateClipTexture\fP(pfClipTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfClipTextureLODBias\fP(float\ biasS,
'in +2
'll -2
float\ biasT,
float\ biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureLODBias\fP(float\ *biasS,
'in +2
'll -2
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureCurLODBias\fP(float\ *biasS,
'in +2
'll -2
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureNumAllocatedLevels\fP(pfClipTexture\ *tex,
'in +2
'll -2
int\ levels);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetClipTextureNumAllocatedLevels\fP(pfClipTexture\ *tex,
'in +2
'll -2
int\ levels);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetClipTextureMinDTRLOD\fP(void);
.nf
.fi
.TP
int
\f3\%pfIsClipTextureVirtual\fP(void);
.nf
.fi
.TP
void
\f3\%pfClipTextureLODOffsetLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
int\ lo,
int\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureLODOffsetLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
int\ *lo,
int\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureNumEffectiveLevelsLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
int\ lo,
int\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureNumEffectiveLevelsLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
int\ *lo,
int\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureMinLODLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ lo,
float\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureMinLODLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ *lo,
float\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureMaxLODLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ lo,
float\ hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureMaxLODLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ *lo,
float\ *hi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfClipTextureLODBiasLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ Slo,
float\ Shi,
float\ Tlo,
float\ Thi,
float\ Rlo,
float\ Rhi);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetClipTextureLODBiasLimit\fP(pfClipTexture*\ tex,
'in +2
'll -2
float\ *Slo,
float\ *Shi,
float\ *Tlo,
float\ *Thi,
float\ *Rlo,
float\ *Rhi);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfClipTexture\fP is
derived from the parent class \f3\%pfTexture\fP,
so each of these member functions of
class \f3\%pfTexture\fP
are also directly usable with objects
of class \f3\%pfClipTexture\fP.
Casting an object of class \f3\%pfClipTexture\fP
to an object of class \f3\%pfTexture\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfTexture\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
void
\f3\%pfTexName\fP(pfTexture\ *tex,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTexName\fP(const\ pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfTexImage\fP(pfTexture\ *tex,
'in +2
'll -2
uint*\ image,
int\ comp,
int\ ns,
int\ nt,
int\ nr);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexImage\fP(const\ pfTexture\ *tex,
'in +2
'll -2
uint\ **image,
int\ *comp,
int\ *ns,
int\ *nt,
int\ *nr);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexFormat\fP(pfTexture\ *tex,
'in +2
'll -2
int\ format,
int\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetTexFormat\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ format);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexFilter\fP(pfTexture\ *tex,
'in +2
'll -2
int\ filt,
int\ type);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexAnisotropy\fP(pfTexture\ *tex,
'in +2
'll -2
int\ degree);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetTexAnisotropy\fP(pfTexture\ *tex);
.PD 0
.TP
int
\f3\%pfGetTexFilter\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ filt);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexRepeat\fP(pfTexture\ *tex,
'in +2
'll -2
int\ wrap,
int\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetTexRepeat\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ wrap);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexBorderColor\fP(pfTexture*\ tex,
'in +2
'll -2
pfVec4\ clr);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexBorderColor\fP(pfTexture*\ tex,
'in +2
'll -2
pfVec4\ *clr);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexBorderType\fP(pfTexture*\ tex,
'in +2
'll -2
int\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetTexBorderType\fP(pfTexture*\ tex);
.PD 0
.TP
void
\f3\%pfTexSpline\fP(pfTexture\ *tex,
'in +2
'll -2
int\ type,
pfVec2\ *pts,
float\ clamp);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexSpline\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ type,
pfVec2\ *pts,
float\ *clamp);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexDetail\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level,
pfTexture\ *detail);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexDetail\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ *level,
pfTexture\ **detail);
.in
.ll
.PD 0
.TP
pfTexture *
\f3\%pfGetTexDetailTex\fP(const\ pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfDetailTexTile\fP(pfTexture\ *tex,
'in +2
'll -2
int\ j,
int\ k,
int\ m,
int\ n,
int\ scram);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetDetailTexTile\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ *j,
int\ *k,
int\ *m,
int\ *n,
int\ *scram);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexList\fP(pfTexture\ *tex,
'in +2
'll -2
pfList\ *list);
.in
.ll
.PD 0
.TP
pfList *
\f3\%pfGetTexList\fP(const\ pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfTexFrame\fP(pfTexture\ *tex,
'in +2
'll -2
float\ frame);
.in
.ll
.PD 0
.TP
float
\f3\%pfGetTexFrame\fP(const\ pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfTexLoadMode\fP(pfTexture\ *tex,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetTexLoadMode\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexLevel\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level,
pfTexture\ *ltex);
.in
.ll
.PD 0
.TP
pfTexture *
\f3\%pfGetTexLevel\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ min,
float\ max);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetCurTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *biasS,
float\ *biasT,
float\ *biasR);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexLODBias\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *biasS,
float\ *biasT,
float\ *biasR);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexLODBias\fP(pfTexture*\ tex,
'in +2
'll -2
float\ biasS,
float\ biasT,
float\ biasR);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetCurTexLODBias\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *biasS,
float\ *biasT,
float\ *biasR);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexLoadOrigin\fP(pfTexture\ *tex,
'in +2
'll -2
int\ which,
int\ xo,
int\ yo);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexLoadOrigin\fP(pfTexture\ *tex,
'in +2
'll -2
int\ which,
int\ *xo,
int\ *yo);
.in
.ll
.PD 0
.TP
void
\f3\%pfTexLoadSize\fP(pfTexture\ *tex,
'in +2
'll -2
int\ xs,
int\ ys);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetTexLoadSize\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.PD 0
.TP
void
\f3\%pfApplyTex\fP(pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfFormatTex\fP(pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfLoadTex\fP(pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfTexLoadImage\fP(pfTexture*\ tex,
'in +2
'll -2
uint\ *image);
.in
.ll
.PD 0
.TP
uint *
\f3\%pfGetTexLoadImage\fP(const\ pfTexture*\ tex);
.PD 0
.TP
void
\f3\%pfLoadTexLevel\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level);
.in
.ll
.PD 0
.TP
int
\f3\%pfLoadTexFile\fP(pfTexture\ *tex,
'in +2
'll -2
char\ *fname);
.in
.ll
.PD 0
.TP
void
\f3\%pfSaveTexFile\fP(pfTexture\ *tex,
'in +2
'll -2
char\ *fname);
.in
.ll
.PD 0
.TP
void
\f3\%pfSubloadTex\fP(pfTexture*\ tex,
'in +2
'll -2
int\ source,
uint\ *image,
int\ xsrc,
int\ ysrc,
int\ srcwid,
int\ xdst,
int\ ydst,
int\ xsize,
int\ ysize);
.in
.ll
.PD 0
.TP
void
\f3\%pfSubloadTexLevel\fP(pfTexture*\ tex,
'in +2
'll -2
int\ source,
uint\ *image,
int\ xsrc,
int\ ysrc,
int\ srcwid,
int\ xdst,
int\ ydst,
int\ xsize,
int\ ysize,
int\ level);
.in
.ll
.PD 0
.TP
void
\f3\%pfIdleTex\fP(pfTexture\ *tex);
.PD 0
.TP
int
\f3\%pfIsTexLoaded\fP(const\ pfTexture\ *tex);
.PD 0
.TP
int
\f3\%pfIsTexFormatted\fP(const\ pfTexture\ *tex);
.PD 0
.TP
void
\f3\%pfApplyTexMinLOD\fP(float\ min);
.PD 0
.TP
void
\f3\%pfApplyTexMaxLOD\fP(float\ min);
.PD 0
.TP
void
\f3\%pfApplyTexLODBias\fP(float\ biasS,
'in +2
'll -2
float\ biasT,
float\ biasR);
.in
.ll
.PD 0
.TP
pfTexture*
\f3\%pfGetCurTex\fP(void);
.PD 0
.TP
void
\f3\%pfApplyTMat\fP(pfMatrix\ *mat);

.PD
.PP
Since the class
\f3\%pfTexture\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfClipTexture\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfClipTexture\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

A \f3\%pfClipTexture\fP is used to represent a very large texture image
with a modest amount of texture memory supplemented by a moderate
amount of main memory and a correspondingly greater quantity of backing
store on disk.  Limits to the size of this large disk-based virtual
texture image are determined by texture hardware coordinate precision
considerations, implementation details (see \f3\%pfQuerySys\fP
PFQSYS_MAX_CLIPTEXTURE_SIZE for more information about this), and
by available disk storage.

The implementation approach is to keep only a small area of interest of
each level of a MIP-map in the hardware texture cache at any one time.
This stack of subimages then forms a cached sub-volume of the normal
pyramid of hierarchical resolutions stored within a MIP-map.  This sub-volume
of the MIP-map pyramid is chosen such that the image generated from a
particular view can be rendered as if the entire MIP-map pyramid were
present.  Thus the fundamental assumption is that for any given
viewpoint, a predetermined amount of texture (based on screen
resolution and possibly affected by perspective) can be used to
approximate an arbitrarily large texture.  The relevant work, then, is
to choose an area of interest or 'center' of resolution.  This 'center'
is chosen such that a subset of each MIP-map level aligned by the center
will yield a correct final image.  This assumption is valid because of
the way that MIP-mapped textures address texture memory; no more than
screen resolution can be used from any single map level in the MIP-map
resolution pyramid.  To simplify the calculations and concept, each
level of a clipmap is clamped (clipped) to a predetermined size.  Also
note that because of the nature of this data structure, several levels
contain the same number of texels, but each coarser level represents
four times the area of the finer level in the texture space.  At some
point, levels no longer are clipped and the subset of data stored within
the level actually contains the entire map. This means that all of the
original data is present at some resolution.

The model used to implement a 'clipmap' is a one in which each clipped
level of the clipmap can be thought of as performing a toroidal image
roam through a larger virtual texture.  The center of resolution of the
clipmap defines the current origin of roaming for each level via a shift
and mask operation.  Each clipped level is represented by a pfImageCache
and is generally independent of the other levels, the exception being
that the pfClipTexture forces an alignment of the center of each level's
pfImageCache so that the graphics library and texture hardware are able
to understand exactly what subset of image data is available at each level
at all times.

\f3\%pfNewClipTexture\fP creates and returns a handle to a new pfClipTexture.
\f2arena\fP specifies a malloc arena out of which the pfClipTexture is
allocated or NULL for allocation from the calling process' heap.
pfClipTextures can be deleted with \f3\%pfDelete\fP.

\f3\%pfClipTextureCenter\fP sets the center
of resolution for the virtual texture.  \f2s\fP,\f2t\fP,and \f2r\fP specify the
location in finest map level texels around which the clipmap should align
itself.  Due to hardware constraints, this center can only be set
on certain texel boundaries and these boundaries are automatically enforced
by Performer (see pfQuerySys PFQSYS_CLIPTEXTURE_CENTER_ALIGNMENT
for more details).  Note that the center of the finest level actually
defines the center of each clipped level of the clipmap by the shift
and mask relationship:

.RS
CenterLevelN = (Center>>N) & CENTER_ALIGNMENT_MASK
.RE

\f3\%pfGetClipTextureCenter\fP returns the
center of resolution for the virtual texture represented by this
clipmap. This is the value that was last set by the application. Since the
center must be processed before it's effects become visible, this value
may not be the value of the center currently in use. To get the in-use center
value, call
\f3\%pfGetClipTextureCurCenter\fP
The get center calls fill in their pointer arguments, s, t, and r.
If one or more of the values aren't needed, a null value may be used
instead of an integer pointer, in which case the argument value is ignored.

\f3\%pfClipTextureClipSize\fP sets the
maximum size of the image used to represent any level of a pfClipTexture.
MIP-map levels which would have normally been larger than this size are
'clipped' to \f2clipSize\fP based on the center set via
\f3\%pfClipTextureCenter\fP.
\f3\%pfGetClipTextureClipSize\fP returns
the maximum size for the image used to represent any level of the MIP-map
pyramid stored with a pfClipTexture.

\f3\%pfClipTextureLevel\fP sets the pfImageCache or pfImageTile to use for a
particular level of a clipmap.  Each level which would normally have a
MIP-mapped size greater than the clipped size of the pfClipTexture must
specify a pfImageCache which can be used by the clipmap to extract the
appropriate subset of the image necessary for \f2level\fP based on the
current center of resolution as defined by
\f3\%pfClipTextureCenter\fP.  Each level
below the 'clipped' portion of the clipmap can be specified as either a
pfImageCache or a pfImageTile.  Note when using pfImageCache's for
these levels, the cache's valid region should be the entire image.

\f3\%pfGetClipTextureLevel\fP returns the
pfObject (either a pfImageCache or a pfImageTile as defined above)
which is currently being used as the \f2lvl\fPth level of the
pfClipTexture.

\f3\%pfClipTextureVirtualSize\fP sets
the overall virtual size of the pfClipTexture.  This size currently can
not exceed the maximum supported hardware size of a texture (see
pfQuerySys PFQSYS_MAX_CLIPTEXTURE_SIZE for more details).  Note that
this size represents the coordinate system in which the pfClipTexture
will be represented when drawing.  For instance, even if the clipped
size of the pfClipTexture is 1024x1024x1, a texture coordinate of
(.5,.25,0) will refer to the texel at 16384,8192,0 if the virtual size of
the texture was 32768x32768x1.
\f3\%pfGetClipTextureVirtualSize\fP
returns the virtual size.  Any of the arguments width,height,depth
may be NULL in which case it is ignored.

\f3\%pfClipTextureInvalidBorder\fP
sets a border region for each clipped level that the hardware is not to
use.  This invalid border essentially shrinks the stack size set by
\f3\%pfClipTextureClipSize\fP when the
pfClipTexture is drawn.  This border can be interactively set to lessen
the incremental texture paging necessary to keep the hardware cache of
texture up to date.  This border must be set to a minimum value because
of hardware constraints (see pfQuerySys
PFQSYS_MIN_CLIPTEXTURE_INVALID_BORDER to find out minimum border
size).  Note the border should also be a multiple of
PFQSYS_CLIPTEXTURE_CENTER_ALIGNMENT.  Thus a pfClipTexture which has a
stack size of 1024 with an invalid border of 16 has an effective stack
size of 992.
\f3\%pfGetClipTextureInvalidBorder\fP
returns the current value used to shrink the valid region of each
clipped MIP-map level in a pfClipTexture.

\f3\%pfClipTextureVirtualLODOffset\fP
This value offsets from the top (highest resolution) level of actual stack to
define the top level of a virtual stack. This allows for a deeper cliptexture
stack than can be directly supported by the hardware. Setting the LOD offset
to zero makes the top level of the actual and virtual clip texture stack the
same; this is the default value.
\f3\%pfGetClipTextureVirtualLODOffset
\fP returns the virtual LOD Offset
currently being used by the clip texture.

\f3\%pfClipTextureNumEffectiveLevels\fP
sets the number of levels the hardware will use when using a cliptexture. This
routine is used in conjunction with virtualLODoffset to define a subset of the
actual clip texture so that clip textures larger than can be supported in
hardware can be used. The number of effect levels starts from the top
(highest resolution) level as defined by virtualLODoffset.
\f3\%pfGetClipTextureNumEffectiveLevels
\fP returns the number of effective
levels currently being used by the clip texture.


\f3\%pfClipTextureMaster\fP establishes a
master/slave relationship between two mpcliptextures. The cliptexture that
is called becomes a slave to the one given as an argument.

Master and slave cliptextures are used to render
mpcliptextures across multiple pipes. The masters and slaves have corresponding
master and slave cliptextures and image caches. Only the master image cache
controls the disk downloads and the image cache tiles in memory. Each slave
uses those tiles to do its own downloading to texture memory.

\f3\%pfGetClipTextureMaster
\fP returns the master clip texture of this
mp clip texture, if this clip texture is a slave. If the clip texture is
not a slave, it returns NULL.

\f3\%pfGetClipTextureSlave\fP
returns a pfList containing a list of all the slave cliptextures using the
given cliptexture as its master. If the clip texture is not a master,
the call returns NULL.

\f3\%pfClipTextureLevelPhaseShift\fP
sets an offset to the center of a particular clipped level.  This offset
means that this level could (and should) be misaligned relative to other
clipped levels so that its texture paging will happen at different
increments (and hopefully in different frames) than other levels.  However
phase offset also requires a corresponding increase in level size (see
\f3\%pfClipTextureLevelPhaseMargin\fP)
to account for the phase shift.  This needs to happen so that actual
clipped size + phase shift texels will be present in the hardware cache
(of which only clipped size will be used).
\f3\%pfGetClipTextureLevelPhaseShift\fP
gets the previously described phase shift for the given level
Any of the arguments s,t,r may be NULL in which case it is ignored.
The default phase shift for level i is 2^(i+2) - 4;
most applications should not need to change this.

\f3\%pfClipTextureLevelPhaseMargin\fP
sets an extra border of texture that each clipped level should attempt to
keep valid.  This provides headroom so that all levels have their
real 'clipped' regions valid in texture hardware even if they are being
updated out of phase.
\f3\%pfGetClipTextureLevelPhaseMargin\fP
returns the current extra frame of texture in use by the given clipped level.
The default phase margin is 0 for level 0, and 8 for all other levels;
most applications should not need to change this.

\f3\%pfGetClipTextureOffset\fP returns
the current offset being used to offset each level toroidally during
incremental texture loading of the pfClipTexture.
Any of the arguments s,t,r may be NULL in which case it is ignored.
This offset defines
the effective origin of the imagery within a map level of a pfClipTexture.
It is assumed that each map level is represented toroidally based on this
origin such that effective coordinates relative to a particular map level
are generated via this equation.

.RS
((S+offS)%clipSize, (T+offT)%clipSize, (R+offR)%clipSize)
.RE

Note that the offset for each level of the pfClipTexture on InfiniteReality
can be had by taking the returned offset and modifying it as follows:

.RS
OffsetN = (Offset>>N) & ~7.
.RE

\f3\%pfUpdateClipTexture\fP causes the
pfClipTexture to update all of its data structure based on the new
center of the pfClipTexture.  These updates include preparing a work
list of texture loads to be performed in order to force the hardware
texture cache to be consistent based on the new center of resolution as
defined by \f3\%pfClipTextureCenter\fP.
It also causes all of the pfImageCache's used to represent levels
within the pfClipTexture to have their cache origin and valid region
origin updated based on this new center.  This will subsequently cause
any needed cache tiles to be paged in from disk as defined in the
pfImageCache api.

\f3\%pfApplyClipTexture\fP causes the pfClipTexture
to be updated via \f3\%pfUpdateClipTexture\fP
and then actually services the generated list of texture downloads to
update the GL/texture hardware based on the new center.

\f3\%pfClipTexLODRange\fP extends the notion of
the pfTexture routine of the same name. Since pfClipTextures can change the
min LOD value as part of DTR load control, this routine saves the set
value separately.  pfClipTextures then take the maximum (blurrier)
of the DTR and and set values when setting LOD Range each frame.
\f3\%pfGetClipTextureLODRange\fP will return the
texture LOD range set on the pfClipTexture.  If the range is unset
the value \f3\%PFTEX_DEFAULT\fP will be returned in \f2min\fP and \f2max\fP.
\f3\%pfGetClipTextureCurLODRange\fP will
return the current effective LOD range being applied to the given
pfClipTexture and considers values inherited from the current global state.
If the values are completely unset, GL defaults will be returned.
NULL arguments to
\f3\%pfGetClipTextureLODRange\fP
and \f3\%pfGetClipTextureCurLODRange\fP
are legal (they are ignored).




\f3\%pfClipTextureDTRMode\fP
Is used to control DTR (dynamic texture resolution) or clip texture
load control. Clip texture DTR consists of a number of independent load
control modes, control by the DTRMode bitmask, and a number of user-settable
parameters, all of which have reasonable default values. Currently, the
DTR bitmask can be any combination of the folowing bits: PF_DTR_MEMLOAD,
PF_DTR_TEXLOAD, and PF_DTR_READSORT. PF_DTR_MEMLOAD uses
image tile availability to adjust load control, PF_DTR_TEXLOAD uses estimated
texture subload time to adjust load control, PF_DTR_READSORT turns on sorting
in the image tile read queue.

These modes can be set singly or in any combination.
The default value is
\f3\%PF_DTR_MEMLOAD|PF_DTR_TEXLOAD|PF_DTR_READSORT\fP.

\f3\%pfGetClipTextureDTRMode\fP
can be used to get the currently set DTR mode.

\f3\%pfClipTextureTexLoadTime\fP
sets the time allowed to download all of the cliptexture updates for a
particular cliptexture. DTR (Dynamic Texture Resolution) has a mode,
PF_DTR_TEXLOAD, where it estimates the amount of time necessary to
perform the texture subloads to update the cliptexture for the current
frame. This time is summed up over all the subloads in all the clipped
levels of the cliptexture. The estimate uses the size of the texture
downloads and a cost table, which contains download times for different
size subregions. There are multiple cost tables available. The one
appropriate to the machine in use is chosen. As the cost of the downloads
necessary to update the cliptexture are computed, level by level, from
coarsest to finest, the running total is compared against the maximum
allowed cost. When a level is reached that would cause the total to
exceed the maximum allowed cost, DTR blurs down to the next lower level.
This way the time in the DRAW process is rationed.

This call can adjust the maximum
allowed time for cliptexture downloads. The default value is 6. The value
is a non-negative floating point amount of milliseconds. This value has no
effect unless PF_DTR_TEXLOAD is set. If it is not set, there is no time
rationing.
\f3\%pfGetClipTextureTexLoadTime\fP
is used to get the currently set maximum download time. Since the value
is set in the CULL process, and the effects will be seen in the DRAW
process, there may be a delay of up to 1 frame before changes take effect.

\f3\%pfClipTextureDTRFadeCount\fP
is used to adjust the number of frames it takes to fade in a new level of
the cliptexture. When DTR's PF_DTR_TEXLOAD mode is on, the sharpest visible
level (minDTRLOD) is adjusted based on which levels have tile files available and have the draw
process time to download them into texture memory. When a new, finer level
becomes available, DTRFadeCount is used to keep the new level or levels
from appearing too abruptly.
Each frame, the value of minDTRLOD is faded in towards the new target level
by an amount that is 1/DTRFadeCount of the distance
from the current (fractional) value to the target value.
Note that since this process causes the current value to
change every frame, the fade-in does not linearly converge
to the target value in DTRFadeCount frames as one might expect;
rather, it converges exponentially to the target value without
ever actually reaching it, and DTRFadeCount controls how slowly
this exponential function converges.

\f3\%pfGetClipTextureDTRFadeCount\fP
can be used to get the currently set DTR fade count.
The default fade count is 5.

Note that the DTRFadeCount as described above
is sufficient to smooth out the value of minDTRLOD when the minimum
texloaded level decreases (becomes finer); however, there are times
when the min loaded level that can be loaded within the currently allotted
DTR tex load time increases (becomes coarser) due to increasing
disk or texload demands, typically when speed of motion of the
clip center is increased.  Simply fading out to the new integer level over
many frames does not work, since the levels finer than the new target level
are not in texture memory; attempts to show these levels will result
in displaying the garbage contents of uninitialized texture memory.
So in order to smooth out the increases, DTR must uses an additional
predictive technique.  It does this using a parameter called DTRBlurMargin
which the program can set by calling the member function
\f3\%pfClipTextureDTRBlurMargin\fP.
DTRBlurMargin should be a value between 0 and 1 inclusive;
roughly speaking, a higher blur margin means more cushioning--
transitions will be smoother (less "DTR flickering"),
but minDTRLOD will tend to hover higher (coarser) for any given speed
of the clip center.

The exact way this is implemented is as follows.
Each frame, when the levels are loaded from coarse to fine until the current
DTR tex load time is reached (as described above under TexLoadTime),
the algorithm takes note of exactly what level has been reached when
the smaller time DTRTexLoadTime*(1.-DTRBlurMargin) has elapsed.
In general this happens at some fractional point between two
levels' completions, so the result is a fractional level;
this fractional level is used as the target of the exponential fade-in (or out)
function used to set minDTRLOD (as described above under DTRBlurMargin),
instead of the actual integer min texloaded level for that frame.
Thus, in particular, setting DTRBlurMargin=0 means disabling this
technique entirely.
The default value of DTRBlurMargin is .5, which empirically tends to keep
the target at an average of roughly 1 level coarser than the integer min
texloaded level, thereby allowing the min texloaded level to increase
to the next higher integer without forcing a corresponding jump in the visible
minDTRLOD.  Higher values of DTRBlurMargin can be used to tolerate
bigger jumps in the min texloaded level.

\f3\%pfGetClipTextureDTRBlurMargin\fP
returns the currently set DTRBlurMargin value. The default value is .5.

\f3\%pfGetClipTextureMinDTRLOD\fP
return the min LOD value computed by the pfClipTexture's load control
system described above.
The actual min LOD value used by the cliptexture is the maximum of
the DTR min LOD and the min LOD set by the application.

\f3\%pfInvalidateClipTexture\fP
caused the cliptexture to mark all of it's clipped levels as invalid
and forces a complete reload of the texture memory owned by the cliptexture's
image caches. Note that invalidate doesn't force a reload of texture data
from disk to the system memory cache;
there is a utility function pfuReallyInvalidateClipTexture()
which does that.

\f3\%pfClipTextureLODBias\fP
sets the S, T, and R bias values on the pfClipTexture object. Setting the
the bias values with the pfClipTexture's method rather than the pfTexture's
guarantees that the bias values will be sent to the pfTexture object and
the pfTexture is applied when the pfClipTexture is applied. Using the
pfTexture is less certain, since setting the pfTexture state is not
frame accurate.

\f3\%pfGetClipTextureLODBias\fP
returns the current S, T, and R bias values saved in the pfClipTexture
object. The default values are all zero.

\f3\%pfGetClipTextureCurLODBias\fP
returns the current S, T, and R bias values saved in the pfTexture
rather than the pfClipTexture object. The default values are all zero.

\f3\%pfClipTextureNumAllocatedLevels\fP
places an upper bound on the number of levels in the pfClipTexture
that will actually be stored in texture memory, starting at level 0 (the finest
level).
This only has an effect when the pfClipTexture is a virtual clip texture
and numAllocatedLevels is less than the number of virtual levels.
The levels in use
will always be restricted to a subset of the levels that are allocated in
texture memory.

\f3\%pfGetClipTextureNumAllocatedLevels\fP
return the value previously set by
\f3\%pfClipTextureNumAllocatedLevels\fP.
The default value is 1000.

\f3\%pfIsClipTextureVirtual\fP
returns non-zero if the pfClipTexture is configured to be virtual. A
pfClipTexture is virtual if it configured with less effective levels
than there levels in the entire pfCliptexture. A virtual pfClipTexture
can only display a contiguous subset of its levels at a time. The set
of displayable levels can be shifted by changing the pfClipTexture's
virtual lod offset value. The number of displayable levels can be
changed through the effective levels parameter.

Virtual pfClipTextures allow the application to exceed the 32K by 32K
size limit of non-virtual pfClipTextures at the expense of extra callbacks
in the scene graph and higher texture memory usage for the pyramid
levels. See the Cliptextures chapter of the programming guide for details.
For information on various bugs and limitations inherent in virtual
clipmaps on InfiniteReality, see the document
/usr/share/Performer/doc/clipmap/IRClipmapBugs.html or
/usr/share/Performer/doc/clipmap/IRClipmapBugs.txt which is included
with the Performer sample source code.

The functions
\f3\%
pfClipTextureLODOffsetLimit,
pfClipTextureNumEffectiveLevelsLimit,
pfClipTextureMinLODLimit,
pfClipTextureMaxLODLimit,
pfClipTextureLODBiasLimit
\fPand corresponding query functions\f3\%
pfGetClipTextureLODOffsetLimit,
pfGetClipTextureNumEffectiveLevelsLimit,
pfGetClipTextureMinLODLimit,
pfGetClipTextureMaxLODLimit,
pfGetClipTextureLODBiasLimit
\fPare for applications (such as the clipfly example program)
to modify or override the values set by callbacks (such
as those installed by the .spherepatch and .ct scene file loaders)
that control the corresponding clip center parameters.
The intended use is for the application to call the
\f3\%Limit\fP
functions (based on GUI slider input, for example),
and then the intelligent callback functions of the loaders call the
corresponding \f3\%GetLimit\fP functions and use
the results to modify their selection of the final parameters
sent to the pfClipTexture.

The limits are not enforced by pfClipTexture; they are provided
merely to facilitate communication from the application to the
callback function controlling the parameters.  That function
is free to ignore or only partially honor the limits if it wishes
(but failing to honor the limits will of course make it more difficult
for a user to browse and debug a texture using the clipfly controls).

.SH NOTES


pfClipTextures are currently supported only on Onyx and Onyx2 with
InfiniteReality graphics systems.  Current values for hardware
specific constraints on this system are:

.RS
PFQSYS_MAX_CLIPTEXTURE_SIZE  = 32768
.br
PFQSYS_CLIPTEXTURE_CENTER_ALIGNMENT = 8
.br
PFQSYS_MIN_CLIPTEXTURE_INVALID_BORDER = 16
.RE

.SH SEE ALSO
pfImageCache,
pfImageTile,
pfQuerySys,
pfTexLoad,
pfTexture,
pfuReallyInvalidateClipTexture
