'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfColortable" "3pf"
.SH NAME
.upperok
.B pfNewCtab,
.B pfGetCtabClassType,
.B pfGetCtabSize,
.B pfApplyCtab,
.B pfCtabColor,
.B pfGetCtabColor,
.B pfGetCtabColors,
.B pfGetCurCtab
\- 
Specify color table properties
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfColortable\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfColortable *
\f3\%pfNewCtab\fP(int\ size,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfType *
\f3\%pfGetCtabClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetCtabSize\fP(const\ pfColortable\ *ctab);
.nf
.fi
.TP
void
\f3\%pfApplyCtab\fP(pfColortable\ *ctab);
.nf
.fi
.TP
int
\f3\%pfCtabColor\fP(pfColortable\ *ctab,
'in +2
'll -2
int\ index,
pfVec4\ color);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetCtabColor\fP(const\ pfColortable\ *ctab,
'in +2
'll -2
int\ index,
pfVec4\ color);
.in
.ll
.nf
.fi
.TP
pfVec4 *
\f3\%pfGetCtabColors\fP(const\ pfColortable\ *ctab);
.nf
.fi
.TP
pfColortable *
\f3\%pfGetCurCtab\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfColortable\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfColortable\fP.
Casting an object of class \f3\%pfColortable\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfColortable\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

A pfColortable is a 'color indexing' mechanism used by pfGeoSets.  It
is \f2not\fP related to the graphics library hardware rendering notion of
\f2color index mode\fP.  If pfColortable operation is enabled, pfGeoSets
will be drawn with the colors defined in the current globally active
pfColortable rather than using the pfGeoSet's own local color list.
This facility can be used for instant large-scale color manipulation of
geometry in a scene.

\f3\%pfNewCtab\fP creates and returns a handle to a pfColortable.
\f2arena\fP specifies a malloc arena out of which the pfColortable is
allocated or \f3\%NULL\fP for allocation off the process heap.  \f2size\fP
is the number of pfVec4 color elements to allocate for the
pfColortable.  pfColortables can be deleted with \f3\%pfDelete\fP.

The number of color elements in the pfColortable is returned by
\f3\%pfGetCtabSize\fP.

\f3\%pfGetCtabClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfColortable\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetCtabClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfColortable\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an object,
it is usually better to use \f3\%pfIsOfType\fPto test if an object is of a type derived from a
Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfApplyCtab\fP selects \f2ctab\fP as the current, global
pfColortable.
If colorindex mode is enabled
(\f3\%pfEnable\fP(\f3\%PFEN_COLORTABLE\fP)), then all subsequent pfGeoSets
will use the pfVec4 array supplied by the global color table rather than
their own
local color array.  Colorindex mode works for both indexed and
non-indexed pfGeoSets.

\f3\%pfApplyCtab\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfApplyCtab\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

\f3\%pfGetCurCtab\fP returns the currently active pfColortable or \f3\%NULL\fP
if there is none active.

Colors in a pfColortable are pfVec4's which specify red, green, blue,
and alpha in the range [0..1].
\f3\%pfCtabColor\fP and \f3\%pfGetCtabColor\fP
respectively set and get the color at index \f2index\fP.  To support
high performance manipulation of colortables, OpenGL Performer allows
direct access to the array of pfVec4 colors of a pfColortable.
\f3\%pfGetCtabColors\fP
returns a pointer to this array which may be
manipulated directly.  However care must be taken not to write data
outside the array limits.

The pfColortable state element is identified by the
\f3\%PFSTATE_COLORTABLE\fP token.  Use this token with \f3\%pfGStateAttr\fP to
set the pfColortable of a pfGeoState and with \f3\%pfOverride\fP to
override subsequent colortable changes.

Example 1:
.Ex
.nf

/* Set up 'colorindexed' pfGeoState */
pfGStateAttr(gstate, PFSTATE_COLORTABLE, ctab);
pfGStateMode(gstate, PFSTATE_ENCOLORTABLE, PF_ON);

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Draw gset colorindexed with ctab */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

pfEnable(PFEN_COLORTABLE);
pfApplyCtab(ctab);

/*
 * Override active pfColortable to 'ctab' and colorindex enable
 * to PF_ON.
 */
pfOverride(PFSTATE_COLORTABLE | PFSTATE_ENCOLORTABLE, PF_ON);
.Ee
.fi
.na

.SH NOTES

pfColortables can be used to simulate FLIR (Forward Looking Infrared)
and NVG (Night Vision Goggles) and for monochrome display devices
which separate video components for stereo display purposes. More
flexible FLIR and NVG simulation is available through the use of
indexed pfGeoStates.
.SH SEE ALSO
pfDelete,
pfDispList,
pfEnable,
pfGeoSet,
pfGeoState,
pfOverride,
pfState
