'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfDataPool" "3pf"
.SH NAME
.upperok
.B pfCreateDPool,
.B pfGetDPoolSize,
.B pfGetDPoolName,
.B pfReleaseDPool,
.B pfAttachDPool,
.B pfDPoolAlloc,
.B pfDPoolFree,
.B pfDPoolFind,
.B pfDPoolLock,
.B pfDPoolSpinLock,
.B pfDPoolUnlock,
.B pfDPoolTest,
.B pfDPoolAttachAddr,
.B pfGetDPoolAttachAddr,
.B pfGetDPoolClassType
\- 
Create, control and allocate from locked memory pools.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'volatile\ void*\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfDataPool*
\f3\%pfCreateDPool\fP(uint\ size,
'in +2
'll -2
char\ *name);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetDPoolSize\fP(pfDataPool\ *dpool);
.nf
.fi
.TP
const char*
\f3\%pfGetDPoolName\fP(pfDataPool*\ dpool);
.nf
.fi
.TP
int
\f3\%pfReleaseDPool\fP(pfDataPool\ *dpool);
.nf
.fi
.TP
pfDataPool*
\f3\%pfAttachDPool\fP(char\ *name);
.nf
.fi
.TP
volatile void*
\f3\%pfDPoolAlloc\fP(pfDataPool\ *dpool,
'in +2
'll -2
uint\ size,
int\ id);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfDPoolFree\fP(pfDataPool\ *dpool,
'in +2
'll -2
void\ *dpmem);
.in
.ll
.nf
.fi
.TP
volatile void*
\f3\%pfDPoolFind\fP(pfDataPool\ *dpool,
'in +2
'll -2
int\ id);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfDPoolLock\fP(void\ *dpmem);
.nf
.fi
.TP
int
\f3\%pfDPoolSpinLock\fP(void*\ dpmem,
'in +2
'll -2
int\ spins,
int\ block);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDPoolUnlock\fP(void\ *dpmem);
.nf
.fi
.TP
int
\f3\%pfDPoolTest\fP(void\ *dpmem);
.nf
.fi
.TP
void
\f3\%pfDPoolAttachAddr\fP(void\ *addr);
.nf
.fi
.TP
void*
\f3\%pfGetDPoolAttachAddr\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetDPoolClassType\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfDataPool\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfDataPool\fP.
Casting an object of class \f3\%pfDataPool\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfDataPool\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'dpool\ \ 'u
\f2dpool\fP
identifies a pfDataPool.
.SH DESCRIPTION

A pfDataPool is similar to a shared memory malloc arena but adds the
ability to lock/unlock pfDataPool memory for multiprocessing
applications.  The datapool functions allow related or unrelated
processes to share data and provide a means for locking data blocks to
eliminate data collision.  These functions use the shared arena
functions (see \f3\%usinit\fP).

\f3\%pfCreateDPool\fP creates and returns a
handle to a pfDataPool.  \f2size\fP is the size in bytes of the
pfDataPool.  \f2name\fP is the name of the pfDataPool and is also the
name of the memory-mapped file used by the pfDataPool.  This file is
created in the directory "/usr/tmp" unless the environment variable
\f3\%PFTMPDIR\fP is defined, in which case the file is created in the
directory named in the \f3\%PFTMPDIR\fP environment variable.  \f2name\fP
should be unique among all pfDataPool names and only a single process
should create a given pfDataPool with name \f2name\fP.

\f3\%pfGetDPoolClassType\fP return
the \f3\%pfType\fP* for the class \f3\%pfDataPool\fP.  The \f3\%pfType\fP*
returned is the same as the \f3\%pfType\fP* returned by invoking
\f3\%pfGetType\fP  on any instance of class
\f3\%pfDataPool\fP.  Because OpenGL Performer allows subclassing of built-in
types, when decisions are made based on the type of an object, it is
usually better to use \f3\%pfIsOfType\fP to test if
an object is of a type derived from a Performer type rather than to
test for strict equality of the \f3\%pfType\fP*'s.

\f3\%pfGetDPoolSize\fP and \f3\%pfGetDPoolName\fP return the size in bytes and
the string name of \f2dpool\fP respectively.

\f3\%pfAttachDPool\fP allows the calling
process to attach to a pfDataPool with name \f2name\fP that may have
been created by another process.  A handle to the found pfDataPool is
returned or \f3\%NULL\fP if it was not found or could not be accessed.

\f3\%pfReleaseDPool\fP hides \f2dpool\fP so that
no other processes may attach to it although all previously attached
processes may still access it.  Additionally, a released pfDataPool
will be removed from the file system (deleted) once all attached
processes exit.  \f3\%pfReleaseDPool\fP returns \f3\%TRUE\fP if successful and
\f3\%FALSE\fP otherwise.

\f3\%pfDPoolAlloc\fP returns a pointer to a
block of memory of \f2size\fP bytes that was allocated out of
\f2dpool\fP or \f3\%NULL\fP if there is not enough
available memory in \f2dpool\fP.  \f2size\fP is in bytes and can
range from 1 to the size of the pfDataPool.  The actual size allocated
is always rounded up to the next 16 byte boundary.  \f2id\fP is an
integer id assigned to the block of memory that is used to reference
it by \f3\%pfDPoolFind\fP.  Block
id's should be unique or the results are undefined.

\f3\%pfDPoolFind\fP returns a pointer to a block
of pfDataPool memory which is identified by \f2id\fP or \f3\%NULL\fP if
\f2id\fP was not found.  The calling process must be attached to the
datapool memory.

\f3\%pfDPoolFree\fP frees the memory block previously allocated by
\f3\%pfDPoolAlloc\fP and makes it available to be reallocated.

\f3\%pfDPoolLock\fP, \f3\%pfDPoolSpinLock\fP  and
\f3\%pfDPoolUnlock\fP lock and unlock access to
a block of pfDataPool memory that was allocated by
\f3\%pfDPoolAlloc\fP.  When the lock cannot be
acquired, \f3\%pfDPoolLock\fP yields the
processor causing the current thread to block until the lock is
available.  \f3\%pfDPoolSpinLock\fP  provides more control by accepting arguments
to control the spinning and blocking.  When \f2block\fP is \f2FALSE\fP,
\f3\%pfDPoolSpinLock\fP returns rather than
yielding the processor if the lock cannot be acquired.  \f2spins\fP
specifies the number of times to spin before yielding or returning.  A
\f2spins\fP value of -1 invokes the default, currently 600.
\f3\%pfDPoolLock\fP and \f3\%pfDPoolSpinLock\fP return
1 upon acquisition of the lock, 0
upon failure to acquire the lock and -1 upon error.
\f3\%pfDPoolUnlock\fP relinquishes the lock on
the block of memory.

There are a fixed number of locks (currently 4096) allocated for each
pfDataPool and a new lock is consumed when an allocation in that
pfDataPool is first locked.  Subsequent releases and locks do not
require further lock allocations.

Example:
.Ex
.nf

typedef struct SharedData
{
    float a, b, c;
} SharedData;

pfDataPool *pool;
SharedData *data;
 :
/* create a DataPool with room for 4 SharedData structures */
pool = pfCreateDPool(4*sizeof(SharedData), "dpoolForSharedData");

/* allocate SharedData structure in the data pool with ID=153 */
data = (SharedData*)pfDPoolAlloc(pool, sizeof(SharedData), 153);
 :
/* write to the DataPool with cooperative mutual exclusion */
pfDPoolLock((void*)data);
data->a = 370.0;
data->b = 371.0;
data->c = 407.0;
pfDPoolUnlock((void*)data);
.Ee
.fi
.na


\f3\%pfDPoolLock\fP attempts to acquire a
hardware lock associated with \f2dpmem\fP.  If another process has
already acquired the lock, the calling process will not return until
the lock is acquired.  Whether the process blocks or spins is a
function of the machine configuration.  (see \f3\%usconfig\fP).
\f3\%pfDPoolUnlock\fP unlocks \f2dpmem\fP.  A
process which double-trips a lock by calling \f3\%pfDPoolLock\fP twice in succession will block until the
lock is unset by another process.  A process may unlock a lock that
was locked by a different process.
\f3\%pfDPoolTest\fP returns 0 if \f2dpmem\fP is
unlocked and 1 if it is locked.

pfDataPool memory may be accessed without using the lock and unlock
feature; however this defeats the mutual exclusion feature provided by
pfDataPool functions.

A data pool must occupy the same range of virtual memory addresses in
all processes that attach to it. \f3\%pfAttachDPool\fP will fail if
something else has already been mapped into the required address space,
e.g. as a result of mmap or sbrk.  To minimize this risk, \f3\%pfCreateDPool\fP
tries to place new datapools above the main shared memory arena created
by \f3\%pfInitArenas\fP.  The address at which the next datapool will be
created can be overridden by calling \f3\%pfDPoolAttachAddr\fP with the
\f2addr\fP argument specifying the desired address.  An \f2addr\fP of NULL
tells Performer to return to its normal placement efforts.  The next
attachment address is returned by \f3\%pfGetDPoolAttachAddr\fP.

In the absence of a shared memory arena created by \f3\%pfInitArenas\fP,
\f3\%pfCreateDPool\fP lets the kernel choose the data pool
placement.

Deleting a data pool with \f3\%pfDelete\fP or  unmaps the
data pool from virtual memory as well as deleting the pfDataPool
data structure.

.SH NOTES


pfDataPool functionality is not currently supported under
the single processor version of Performer on Linux.

When a datapool is created, a file is created in "/usr/tmp" or
\f3\%PFTMPDIR\fP.  The file name will end with the string ".pfdpool".  If
\f3\%pfReleaseDPool\fP is not called to unlink
the datapool, this file will remain in the file system after the
program exits, taking up disk space.

When using pfDataPools between unrelated processes, you can reduce
memory conflicts by having the application that uses more virtual
memory create the datapool and having the smaller application attach
to the datapool before allocating memory that might cause conflicts.
Alternately, if an address is known to be safe for both applications,
it can be specified using
\f3\%pfDPoolAttachAddr\fP.
.SH SEE ALSO
amalloc,
pfInitArenas,
usconfig,
usinit,
ussetlock,
ustestlock,
usunsetlock
