'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfDispList" "3pf"
.SH NAME
.upperok
.B pfNewDList,
.B pfGetDListClassType,
.B pfOpenDList,
.B pfResetDList,
.B pfCloseDList,
.B pfGetDListSize,
.B pfGetDListType,
.B pfAddDListCmd,
.B pfAppendDList,
.B pfDListCallback,
.B pfDrawDList,
.B pfCompileDList,
.B pfPreprocessDList,
.B pfDListMode,
.B pfGetDListMode,
.B pfDrawGLObj,
.B pfGetCurDList
\- 
Create and control a display list
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfDispList\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfDispList *
\f3\%pfNewDList\fP(int\ type,
'in +2
'll -2
int\ size,
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfType *
\f3\%pfGetDListClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfOpenDList\fP(pfDispList\ *dlist);
.nf
.fi
.TP
void
\f3\%pfResetDList\fP(pfDispList\ *dlist);
.nf
.fi
.TP
void
\f3\%pfCloseDList\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetDListSize\fP(const\ pfDispList\ *dlist);
.nf
.fi
.TP
int
\f3\%pfGetDListType\fP(const\ pfDispList\ *dlist);
.nf
.fi
.TP
void
\f3\%pfAddDListCmd\fP(int\ cmd);
.nf
.fi
.TP
int
\f3\%pfAppendDList\fP(pfDispList*\ dlist,
'in +2
'll -2
const\ pfDispList\ *src);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDListCallback\fP(pfDListFuncType\ callback,
'in +2
'll -2
int\ nbytes,
void\ *data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfDrawDList\fP(pfDispList\ *dlist);
.nf
.fi
.TP
int
\f3\%pfCompileDList\fP(pfDispList\ *dlist);
.nf
.fi
.TP
int
\f3\%pfPreprocessDList\fP(pfDispList\ *dlist,
'in +2
'll -2
int\ flag);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDListMode\fP(pfDispList\ *dlist,
'in +2
'll -2
int\ mode,
int\ value);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetDListMode\fP(pfDispList\ *dlist,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDrawGLObj\fP(GLOBJECT\ obj);
.nf
.fi
.TP
pfDispList *
\f3\%pfGetCurDList\fP(void);
.fi

.Ex
.nf

typedef void (*pfDListFuncType)(void *data);
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfDispList\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfDispList\fP.
Casting an object of class \f3\%pfDispList\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfDispList\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'dlist\ \ 'u
\f2dlist\fP
identifies a pfDispList.
.SH DESCRIPTION

A pfDispList is a reusable display list that captures certain libpr
commands.
\f3\%pfNewDList\fP creates and returns a handle to a new pfDispList.
The arguments specify the type and size of the display list.
pfDispLists can be deleted with \f3\%pfDelete\fP.

\f2type\fP is a symbolic token that specifies a type of pfDispList and
is either \f3\%PFDL_FLAT\fP or \f3\%PFDL_RING\fP.  A \f3\%PFDL_FLAT\fP display
list is a linear list of commands and data while a \f3\%PFDL_RING\fP is
configured as a ring buffer (FIFO).  A ring buffer is provided for
multiprocessed paired producer and consumer applications where the
producer writes to the buffer while the consumer simultaneously reads
from, and draws the buffer.  OpenGL Performer automatically ensures ring
buffer consistency by providing synchronization and mutual exclusion
to processes on ring buffer full or empty conditions.
\f3\%pfGetDListType\fP returns the type
of \f2dlist\fP.

\f3\%pfGetDListClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfDispList\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetDListClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfDispList\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fPto test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

The \f2size\fP argument to \f3\%pfNewDList\fP gives a hint in words about how
much storage the pfDispList will require.  If more storage is required,
OpenGL Performer will automatically grow the pfDispList by \f2size\fP words
at a time.  \f2arena\fP specifies the malloc arena out of which the
pfDispList is allocated or NULL for allocation off the heap.
\f3\%pfGetDListSize\fP returns the size of \f2dlist\fP that was requested by
\f3\%pfNewDList\fP, not its current size.

\f3\%pfOpenDList\fP opens \f2dlist\fP for appending and puts the calling
process into display list mode.  When in display list mode,
display-listable \f3\%libpr\fP commands are recorded in the currently active display
list rather than being executed immediately.  libpr commands that may
be recorded in a pfDispList say so in their respective man pages.  Only
one pfDispList may be open at a time.  \f3\%pfGetCurDList\fP returns the
currently active display list or \f3\%NULL\fP if the calling process is in
immediate mode.

The currently active pfDispList is a global value but is stored in the
PRDA process header so that \f2share\fP \f2group\fP \f2processes\fP (see
\f3\%sproc\fP) need not share the same currently active pfDispList.

The contents of one pfDispList may be appended to a second pfDispList
with the function
\f3\%pfAppendDList\fP.
All pfDispList elements in \f2src\fP are appended to the pfDispList
\f2dlist\fP.

Each pfDispList maintains head and tail pointers that indicate where
in the list commands are to be appended and evaluated respectively.
Commands entered into the display list are appended after the head
pointer and increment the head pointer appropriately.  Commands drawn
by \f3\%pfDrawDList\fP increment the tail pointer but do not remove
commands from the list.  In the \f3\%PFDL_RING\fP case, OpenGL Performer
ensures that the tail pointer does not overrun the head pointer and
vice versa by spinning processes.

Both head and tail pointers are reset to the beginning of the
pfDispList by
\f3\%pfResetDList\fP
so that any additions to the current
pfDispList will overwrite previously entered commands.  The tail
pointers of flat lists are automatically reset by \f3\%pfDrawDList\fP when
the tail pointer reaches the head pointer so that the pfDispList may be
rendered again from the beginning.

\f3\%pfCloseDList\fP 'closes' the active pfDispList and returns the
application to immediate mode.

For \f3\%PFDL_FLAT\fP display lists, \f3\%pfDrawDList\fP
traverses \f2dlist\fP
from the tail to the head pointer, and then resets the tail pointer to
the beginning of \f2dlist\fP.  If the pfDispList is
a \f3\%PFDL_RING\fP, \f3\%pfDrawDList\fP will
continually draw the display list, returning
control to the application only on \f3\%PFDL_END_OF_FRAME\fP or
\f3\%PFDL_RETURN\fP commands (see \f3\%pfAddDListCmd\fP).
After returning, a subsequent call to
\f3\%pfDrawDList\fP
will restart drawing from the
previous position in the list.

\f3\%pfDrawDList\fP interprets the commands and data in \f2dlist\fP and
executes libpr state routines that in turn execute graphics library
commands that send command tokens down the graphics pipeline.
\f3\%pfDrawDList\fP is itself a display-listable command provided \f2dlist\fP
is not the currently active pfDispList.
The return value is the end of frame, \f3\%PFDL_END_OF_FRAME\fP,
forced return \f3\%PFDL_RETURN\fP, or end of list \f3\%PFDL_END_OF_LIST\fP token
will be returned or else -1 if an error
is encountered.  If the current pfDispList mode is \f3\%PFDL_MODE_COMPILE_GL\fP,
the \f3\%PFDL_END_OF_LIST\fP token will be returned.

\f3\%pfCompileDList\fP will compile a pfDispList into
a GL display list. The return value is that from
\f3\%pfDrawDList\fP and will be -1 if an error is
encountered.
Note that user callback functions in pfDispLists are only exectued upon display
list creation.

\f3\%pfDListMode\fP sets the specified \f2mode\fP to the
given value.  The supported mode is \f3\%PFDL_MODE_COMPILE_GL\fP and when set
to 1, this causes the associated GL display list to be drawn when
\f3\%pfDrawDList\fP is called and a new GL display
list will be auto-created if one does not exist or of the current
display list is dirty. By default, \f3\%PFDL_MODE_COMPILE_GL\fP is false.
User callback functions in pfDispLists are only exectued upon display list
creation.
\f3\%pfGetDListMode\fP returns the current
value of \f2mode\fP.

The following example draws a pfGeoSet into a pfDispList and then
subsequently draws the pfDispList:
.Ex
.nf

/* Open DList and append GSet */
pfOpenDList(dlist);
pfEnable(PFEN_WIREFRAME);
pfDrawGSet(gset);

/* Close DList and return to immediate mode */
pfCloseDList();

/* Draw 'gset' in wireframe */
pfDrawDList(dlist);
.Ee
.fi
.na


\f3\%pfDListCallback\fP allows custom rendering in the middle of a display
list by putting a function callback and data in the current display
list.  Up to 64 bytes of user-data may be copied into the display
list.  \f2nbytes\fP specifies the length of data that \f2data\fP
references.  When a callback token is encountered while drawing a
display list, the function \f2callback\fP will be called with a pointer
to the user data that is cached in the display list.  A callback may
call \f3\%pfPushState\fP upon entering and \f3\%pfPopState\fP when leaving to
ensure that any state changes made in the callback will be not
inherited by subsequent geometry.

\f3\%pfAddDListCmd\fP adds \f2cmd\fP to the currently active display list.
\f2cmd\fP is one of the following symbolic tokens, both of which return
control to the application but indicate different situations.
.RS
\f3\%PFDL_RETURN\fP
.br
\f3\%PFDL_END_OF_FRAME\fP
.RE

\f3\%pfDrawGLObj\fP will directly draw the graphics library display list object
identified by \f2obj\fP (\f3\%glCallList\fP in OpenGL) if there is no active
pfDispList. If there is an open pfDispList, then \f3\%pfDrawGLObj\fP will simply
add the identifier and command to the active pfDispList.

OpenGL Performer optimizes pfDispList's when they are being built by
eliminating redundant mode changes and by unwinding pfGeoStates into
their component parts.  As a result, modifications to objects after they
are placed in a pfDispList may be ignored by the pfDispList.  To be safe,
do not modify any objects that were placed in one or more pfDispLists.

Here is an example of this phenomenon:
.Ex
.nf

/* Attach gstate0 to gset */
pfGSetGState(gset, gstate0);

/* Open dlist as current pfDispList */
pfOpenDList(dlist);
pfDrawGSet(gset);

/* Return to immediate mode */
pfCloseDList();

/* Attach gstate1 to gset */
pfGSetGState(gset, gstate1);

/*
 * dlist will use gstate0 and not be aware that gset was modified to
 * use gstate1.
 */
pfDrawDList(dlist);
.Ee
.fi
.na

.RE

.SS Preprocessing a Display List

The following routines are useful in \f3\%libpr\fP-only applications; \f3\%libpf\fP
applications do not need to call these routines.  Preprocessing of the light
point display list is automatically managed by the \f3\%libpf\fP Light Point
process (see \f3\%pfConfig\fP).

\f3\%pfPreprocessDList\fP is used to
preprocess  the \f2dlist\fP display list in order to
accelerate it's handling in the draw process.  This call must be
encapsulated between the open and close of another pfDispList.
It is just like drawing a pfDispList into another one.

The \f2flag\fP is a bit field that indicates which preprocessing is to be
done. Currently only \f3\%PFDL_PREPROCESS_LPSTATE\fP (which computes the
appearance of each light point) is defined. See \f3\%pfLPointState\fP and
\f3\%pfCalligraphic\fP for further information.

Preprocessing makes sense only if it is done in a separate process, so
that these computations can be done while the Draw Process is drawing
other display lists. Typically, the Draw Process will draw the polygons
of the scene while the Preprocessing process is performing the light
point computations. This is what the Light Point Process does in libpf.

Given that \f2lpointDrawDList\fP is an empty RING Display List, and that
\f2lpointPreprocessDList\fP is a FLAT Display List that contains all the
pfGeoset that have to be preprocessed, the typical code for the Light
Point Process is:
.Ex
.nf

/* select the pfCalligraphic to render with (optional) */
pfSelectCalligraphic(calligraphic);

/* set the performer View Matrix */
/* used to compute the intensity of each light */
pfViewMat(viewMat);
/* can be obtain from pfInvertOrthoNMatMat.invertOrthoN(viewMat,invViewMat); */
/* and also not mandatory. Will be computed from viewMat if not given */
/* used to do the 3D->2D projection for the calligraphics lights points */
pfInvViewMat(invViewMat);
pfNearPixDist(nearPixDist);
/* can use getGLProjMat from a Frustum to get this matrix */
pfProjMat(projMat);
/* Open the Draw RING Display List */
pfOpenDList(lpointDrawDList);
/* preprocess the LPoint FLAT Display List */
pfPreprocessDList(lpointPreprocessDList,PFDL_PREPROCESS_LPSTATE);
/* Post an end of frame token in the ring Dlist */
pfAddDListCmd(PFDL_END_OF_FRAME);
/* Close the Draw RING Display List */
pfCloseDList();
.Ee
.fi
.na


Note that pfSelectCalligraphic, pfViewMat, pfInvViewMat, pfNearPixDist
and pfProjMat are all Display List-able, and should not go in the
lpointDrawDList, as they are needed to configure the preprocessing.

Also, processing of pfLPointState requires that the \f3\%pfModelMat()\fP
matrix are stored in the lpointPreprocessDList each time the model
matrix changes before drawing a pfGeoSet. This is done automatically
by the Culler in a \f3\%libpf\fP application.

So, the Draw Process simply looks like this:
.Ex
.nf

/* do usual Channel settings */
/* including pfPixScale if using DVR */
pfPixScale(scale);
/* draw the polygons */
pfDrawDList(polygonDList);
/* draw the light point Draw Ring DLIST */
pfDrawDList(lpointDrawDList);
/* will exit at the EndOfFrame token */
/* whatever */
/* then swapbuffer */
.Ee
.fi
.na


Note that in the case of calligraphic light points it is mandatory
that the lpoints are the last geometric elements sent to the graphic
pipe.
.SH SEE ALSO
pfCalligraphic,
pfDelete,
pfGeoState,
pfLPointState,
pfObject,
pfState,
callobj,
sproc
