'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfDoubleSCS" "3pf"
.SH NAME
.upperok
.B pfNewDoubleSCS,
.B pfGetDoubleSCSClassType,
.B pfGetDoubleSCSMat,
.B pfGetDoubleSCSMatPtr
\- 
Create and get matrix for a static coordinate system node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfMatrix4d*\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfDoubleSCS *
\f3\%pfNewDoubleSCS\fP(pfMatrix4d\ mat);
.nf
.fi
.TP
pfType *
\f3\%pfGetDoubleSCSClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfGetDoubleSCSMat\fP(pfDoubleSCS\ *scs,
'in +2
'll -2
pfMatrix4d\ mat);
.in
.ll
.nf
.fi
.TP
const pfMatrix4d*
\f3\%pfGetDoubleSCSMatPtr\fP(pfDoubleSCS\ *scs);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfDoubleSCS\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfDoubleSCS\fP.
Casting an object of class \f3\%pfDoubleSCS\fP
to an object of class \f3\%pfGroup\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.PD 0
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfDoubleSCS\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfDoubleSCS\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfDoubleSCS\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'scs\ \ 'u
\f2scs\fP
identifies a pfDoubleSCS
.SH DESCRIPTION

A pfDoubleSCS node represents a static coordinate system -- a modeling
transform that cannot be changed once created.  pfDoubleSCS nodes are similar
to but less flexible than pfDoubleDCS nodes. What they lack in changeability
they make up in performance.

\f3\%pfNewDoubleSCS\fP creates and returns a handle to a pfDoubleSCS.  Like
other pfNodes, pfDoubleSCSes are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfNewDoubleSCS\fP creates a pfDoubleSCS using \f2mat\fP as the
transformation matrix.

By default a pfDoubleSCS uses a dynamic bounding volume so it is
automatically updated when children are added, deleted or changed.
This behavior may be changed using \f3\%pfNodeBSphere\fP.  The bound for a
pfDoubleSCS encompasses all B(i)*\f2mat\fP, where B(i) is the bound for the
child 'i' and \f2mat\fP is the transformation matrix of the pfDoubleSCS.

\f3\%pfGetDoubleSCSClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfDoubleSCS\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetDoubleSCSClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfDoubleSCS\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

The transformation of a pfDoubleSCS affects all its children.  As the
hierarchy is traversed from top to bottom, each new matrix is
pre-multiplied to create the new transformation.  For example, if
DoubleSCSb is below DoubleSCSa in the scene graph, any geometry G below DoubleSCSa is
transformed as G*DoubleSCSb*DoubleSCSa.

Static transformations represented by pfDoubleSCSes may be 'flattened' in a
pre-processing step for improved intersection, culling, and drawing
performance.  \f3\%pfFlatten\fP accumulates transformations in a scene
graph, applies them to geometry, and sets flattened pfDoubleSCSes to the
identity matrix.  Flattening is recommended when available memory
and scene graph structure allow it.  See \f3\%pfFlatten\fP for more
details.

\f3\%pfGetDoubleSCSMat\fP copies the transformation matrix for \f2scs\fP
into \f2mat\fP. For faster matrix access,
\f3\%pfGetDoubleSCSMatPtr\fP returns a const pointer to \f2scs\fP's matrix.

Both pre and post CULL and DRAW callbacks attached to a pfDoubleSCS
(\f3\%pfNodeTravFuncs\fP) will be affected by the transformation
represented by the pfDoubleSCS, i.e. - the pfDoubleSCS matrix will already have been
applied to the matrix stack before the pre callback is called and will
be popped only after the post callback is called.
.SH SEE ALSO
pfGroup,
pfLookupNode,
pfFlatten,
pfSCS,
pfMatrix4d,
pfNode,
pfTraverser,
pfDelete
