'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfEarthSky" "3pf"
.SH NAME
.upperok
.B pfNewESky,
.B pfGetESkyClassType,
.B pfESkyMode,
.B pfGetESkyMode,
.B pfESkyAttr,
.B pfGetESkyAttr,
.B pfESkyColor,
.B pfGetESkyColor,
.B pfESkyFog,
.B pfGetESkyFog,
.B pfESkyFogDensities,
.B pfGetESkyFogDensities,
.B pfESkyFogTextureElevations,
.B pfGetESkyFogTextureElevations,
.B pfESkyFogTexture,
.B pfGetESkyFogTexture,
.B pfESkyFogTextureColorTable,
.B pfGetESkyFogTextureColorTable,
.B pfESkyLoadFogTextureColorTable,
.B pfESkyMakeFogTexture
\- 
Create and control weather, Earth-Sky model, and screen clearing.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfEarthSky\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfEarthSky *
\f3\%pfNewESky\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetESkyClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfESkyMode\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetESkyMode\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ \ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyAttr\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ attr,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetESkyAttr\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ \ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyColor\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ which,
float\ r,
float\ g,
float\ b,
float\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetESkyColor\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ \ which,
float\ *r,
float\ *g,
float\ *b,
float\ *a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyFog\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ which,
pfFog\ *fog);
.in
.ll
.nf
.fi
.TP
pfFog *
\f3\%pfGetESkyFog\fP(pfEarthSky\ *esky,
'in +2
'll -2
int\ \ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyFogDensities\fP(pfEarthSky*\ _esky,
'in +2
'll -2
int\ numpt,
float\ *elevations,
float\ *densities);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetESkyFogDensities\fP(pfEarthSky*\ _esky,
'in +2
'll -2
int\ *numpt,
float\ **elevations,
float\ **densities);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyFogTextureElevations\fP(pfEarthSky*\ _esky,
'in +2
'll -2
int\ n,
float\ *elev);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetESkyFogTextureElevations\fP(pfEarthSky*\ _esky,
'in +2
'll -2
int\ *n,
float\ **elev);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyFogTexture\fP(pfEarthSky*\ _esky,
'in +2
'll -2
pfTexture\ *tex);
.in
.ll
.nf
.fi
.TP
pfTexture*
\f3\%pfGetESkyFogTexture\fP(pfEarthSky*\ _esky);
.nf
.fi
.TP
void
\f3\%pfESkyFogTextureColorTable\fP(pfEarthSky*\ _esky,
'in +2
'll -2
int\ n,
unsigned\ char\ *table);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetESkyFogTextureColorTable\fP(pfEarthSky*\ _esky,
'in +2
'll -2
int\ *n,
unsigned\ char\ **table);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfESkyLoadFogTextureColorTable\fP(pfEarthSky*\ _esky);
.nf
.fi
.TP
void
\f3\%pfESkyMakeFogTexture\fP(pfEarthSky*\ _esky);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfEarthSky\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfEarthSky\fP.
Casting an object of class \f3\%pfEarthSky\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfEarthSky\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'esky\ \ 'u
\f2esky\fP
identifies a pfEarthSky.
.SH DESCRIPTION

These functions provide a means to clear the frame and Z-buffer, draw a
sky, horizon and ground plane, and to implement various weather
effects.  Once the earth-sky is set in a channel, it should be the
first thing drawn when a scene is rendered.

\f3\%pfNewESky\fP creates and returns a handle to a pfEarthSky.  Like
other pfNodes, pfEarthSky nodes are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfNewESky\fP creates a pfEarthSky and sets up
reasonable defaults.  To render the earth and sky model, it must be
added to a pfChannel.  By default, the mode is to render a full screen
clear unless either the sky or ground is turned on.  pfEarthSky is
called automatically in the draw process, unless a draw callback is
present, in which case, it must be explicitly called using
\f3\%pfClearChan\fP.

\f3\%pfGetESkyClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfEarthSky\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetESkyClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfEarthSky\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfESkyMode\fP is used to set the earth-sky rendering mode.  \f3\%pfGetESkyMode\fP
is used to obtain the earth-sky rendering mode. These functions currently
accept the two mode arguments \f3\%PFES_BUFFER_CLEAR\fP, and \f3\%PFES_CLOUDS\fP.
.RS
\f3\%PFES_BUFFER_CLEAR\fP may have the following values:
.RS
.TP 5
\f3\%PFES_FAST\fP
The default mode.  This simply clears the color and Z buffers.  The
clear color can be set using
\f3\%pfESkyColor\fP.  Dithering is turned
off during the clear.
.TP
\f3\%PFES_TAG\fP Initializes the framebuffer to a known state very
rapidly.  Has an effect only when multisampling.  Often, this mode is
used as an optimization before rendering a background that covers the
entire screen.  See \f3\%pfClear\fP for the details and restrictions of
the mode \f3\%PFCL_MSDEPTH\fP.
.TP
\f3\%PFES_SKY\fP
Causes a sky and horizon backdrop to be drawn.  These are drawn using
large polygons that are recalculated each frame, using information
about the clipping planes, field of view, and eyepoint vertical
position for the selected channel.  They are drawn instead of a screen
clear, forcing the Z buffer to a known state.  If the viewpoint goes
below the ground plane, the area below the horizon will not be
cleared.  In the case of \f3\%PFES_SKY\fP, the screen is never cleared
below the lower edge of the horizon.
.TP
\f3\%PFES_SKY_GRND\fP
Add a ground plane to the sky and horizon model drawn by \f3\%PFES_SKY\fP.
.TP
\f3\%PFES_SKY_CLEAR\fP
Draw the sky and horizon, and clear the screen below the edge of the horizon.
.RE

\f3\%PFES_CLOUDS\fP is used to set the type of cloud layer.  Currently, the
only value supported is:
.RS
.TP 5
\f3\%PFES_OVERCAST\fP
This cloud type is a non-textured, opaque region that has a color and
both top and bottom dimensions.  This, being the only choice at present,
is the default type.
.RE
.RE

\f3\%pfESkyColor\fP is used to set the colors referenced by the earth-sky
rendering routines.  \f3\%pfGetESkyColor\fP returns the indicated color
component of the earth-sky mode. The components are:
.RS
.TP 20
\f3\%PFES_SKY_TOP\fP
The color of the sky directly above the viewpoint.
.TP
\f3\%PFES_SKY_BOT\fP
The color of the sky where it joins the horizon.
.TP
\f3\%PFES_HORIZ\fP
The color of the bottom edge of the horizon.
.TP
\f3\%PFES_GRND_FAR\fP
The color of the ground plane where it meets the horizon.
.TP
\f3\%PFES_GRND_NEAR\fP
The color of the ground plane directly below the viewer.
.TP
\f3\%PFES_CLOUD_BOT\fP
The color of the bottom of the opaque cloud layer.
.TP
\f3\%PFES_CLOUD_TOP\fP
The color of the top of the opaque cloud layer.
.TP
\f3\%PFES_CLEAR\fP
The color for simple screen clearing.
.RE

The fog color is set as explained in the \f3\%pfFog\fP man page.

\f3\%pfESkyAttr\fP is used to set a number of attributes.  The companion
function \f3\%pfGetESkyAttr\fP is used to return these same attribute
values. The tokens and their meanings are listed below:
.RS
.TP 5
\f3\%PFES_GRND_HT\fP Set the ground height for the ground plane that is
used when \f3\%PFES_SKY_GRND\fP is enabled and defines the bottom edge of
the horizon which is used in all of the modes that draw a sky.  The
ground plane extends from the eyepoint to the horizon with a width
greater than the field of view.  Note that objects placed on the ground
with the same height may not Z buffer correctly.  Also, as objects
move into the distance, the Z buffer resolution for those pixels will
decrease, making proper priority resolution of small distances between
the ground plane and objects less likely.
.TP
\f3\%PFES_HORIZ_ANGLE\fP Set the vertical displacement of the horizon band
in degrees.  The horizon band is blended into the sky bottom color so
it may appear to be less than this angle.  This angle remains constant
for any heading.  To simulate directional horizon glow, the angle and
color can be changed each frame to achieve the correct appearance.
.TP
\f3\%PFES_CLOUD_TOP\fP Set the cloud layer upper position.  The cloud layer
is enabled when the cloud base is less than the cloud top.  By default,
it is disabled (base > top).  Each token is followed by a height
value.  The cloud layer is opaque.  The cloud layer thickness is simply
(top - bottom).
.TP
\f3\%PFES_CLOUD_BOT\fP Set the cloud layer lower position.  The cloud layer
is enabled when the cloud base is less than the cloud top.  By default,
it is disabled (base > top).  Each token is followed by a height
value.  The cloud layer is opaque.  The cloud layer thickness is simply
(top - bottom).
.TP
\f3\%PFES_TZONE_TOP\fP Set the transition zone for exiting a cloud layer.
Provided to allow a smooth transition out of clouds.  This transition
is enabled by making the transition height greater than the cloud top.
It is disabled by doing the opposite or by disabling the cloud layer.
By default, the transition zone is disabled.
.TP
\f3\%PFES_TZONE_BOT\fP Set the transition zone for entering a cloud layer.
Provided to allow a smooth transition into clouds.  This transition is
enabled by making the transition height less than the cloud bottom.  It
is disabled by doing the opposite or by disabling the cloud layer.  By
default, the transition zone is disabled.
.TP
\f3\%PFES_GRND_FOG_TOP\fP Set the height of the ground fog layer.  Ground
fog is enabled when a valid pfFog is set.  By default ground fog is
disabled.
.RE

\f3\%pfESkyFog\fP sets which type of fog to use when in ground fog or general
visibility.  The token may be one of the following values:
.RS
\f3\%PFES_GRND\fP
.br
\f3\%PFES_GENERAL\fP
.RE
\f3\%pfGetESkyFog\fP returns the indicated fog selection.

Several different fog functions may be defined at initialization, then
just switched in using this routine.  Distant haze and different curves
would be done this way.  If ground fog is enabled, and the viewer is
transitioning out of the ground fog layer, the fog will be blended into
clear visibility or \f3\%PFES_GENERAL\fP fog.

Due to the design of the graphics library, fog would be discontinuous
in adjacent channels which use rotational viewing offsets (See
\f3\%pfChanViewOffsets\fP).  However,
when attached to a pfChannel (see
\f3\%pfChanESky\fP) that has a rotational
viewing offset, a pfEarthSky will automatically adjust the ranges of
the pfFog set by \f3\%pfESkyFog\fP to account
for any rotational offsets so that fog is continuous across adjacent
channels.
.SH NOTES

pfEarthSky does not work properly for off-axis viewing frusta.

Because \f3\%PFES_TAG\fP only has effect when multisampling, care must be
taken for cross-platform portability.  Background renderings that rely
on the depth buffer having been reset (e.g. backgrounds that do not
disable z buffering with \f3\%glDepthFunc(GL_ALWAYS)\fP in OpenGL) may need
to request a normal depth buffer clear when not multisampling.

When multisampling, \f3\%PFES_SKY_GND\fP and \f3\%PFES_SKY\fP are significantly
faster than \f3\%PFES_SKY_CLEAR\fP.

.SH Layered Fog Support

pfEarthSky provides basic support for creating a layered fog model based on the
defined elevations and densities of the different atomospheric layers.
The resulting model is stored in a 3D texture where each slice of the 3D
texture represents summed fog densities for an eye at a given elevation
and  points at d,h where d is a horizontal distance from the eye and
h is the height of the given point along a defined "up" vector. A
texture lookup table (texture color table) is then use to exponentiate
this value to turn the fog density into a fog blending factor.  pfTexGen
functions are used to do the proper indexing into the fog model when
rendering.
This 3D texture can be used to apply a layered fog model as a second
pass after first rendering an unfogged scene.
\f3\%pfESkyMakeFogTexture\fP will create
the fog texture and create it just based on the normal pfEarthSky definition,
or use additional information, such as your own provided layers and densities
for finer resolution. The following routines allow you to set and get
the different parts of the elements used to create the model:
.RS
.TP
\f3\%pfESkyFogDensities\fP
.TP
\f3\%pfGetESkyFogDensities\fP
.TP
\f3\%pfESkyFogTextureElevations\fP
.TP
\f3\%pfGetESkyFogTextureElevations\fP
.TP
\f3\%pfESkyFogTexture\fP
.TP
\f3\%pfGetESkyFogTexture\fP
.TP
\f3\%pfESkyFogTextureColorTable\fP
.TP
\f3\%pfGetESkyFogTextureColorTable\fP
.TP
\f3\%pfESkyLoadFogTextureColorTable\fP
.TP
For an example of layerd fog look at the /usr/share/Performer/src/sample/C/fogfly/
demonstration program.

.SH BUGS


The layered fog model on pfEarthSky doesn't work with the pfEarthSky geometry.
Instead, you should define your own enviornmental geometry.
.SH SEE ALSO
pfChanViewOffsets,
pfClear,
pfFog,
pfNewChan,
zfunction,
glDepthFunc,
pfDelete
