'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFCS" "3pf"
.SH NAME
.upperok
.B pfNewFCS,
.B pfGetFCSClassType,
.B pfFCSFlux,
.B pfGetFCSFlux,
.B pfGetFCSMat,
.B pfGetFCSMatPtr,
.B pfFCSMatType,
.B pfGetFCSMatType
\- 
Create, modify, and query flux coordinate system nodes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfMatrix*\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfFCS *
\f3\%pfNewFCS\fP(pfFlux\ *flux);
.nf
.fi
.TP
pfType *
\f3\%pfGetFCSClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfFCSFlux\fP(pfFCS*\ fcs,
'in +2
'll -2
pfFlux\ *flux);
.in
.ll
.nf
.fi
.TP
pfFlux*
\f3\%pfGetFCSFlux\fP(pfFCS*\ fcs);
.nf
.fi
.TP
void
\f3\%pfGetFCSMat\fP(pfFCS\ *fcs,
'in +2
'll -2
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
const pfMatrix*
\f3\%pfGetFCSMatPtr\fP(pfFCS\ *fcs);
.nf
.fi
.TP
void
\f3\%pfFCSMatType\fP(pfFCS\ *fcs,
'in +2
'll -2
uint\ val);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetFCSMatType\fP(pfFCS\ *fcs);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFCS\fP is
derived from the parent class \f3\%pfSCS\fP,
so each of these member functions of
class \f3\%pfSCS\fP
are also directly usable with objects
of class \f3\%pfFCS\fP.
Casting an object of class \f3\%pfFCS\fP
to an object of class \f3\%pfSCS\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfSCS\fP.

.PD 0
.TP \w'const\ pfMatrix*\ \ \ 'u
void
\f3\%pfGetSCSMat\fP(pfSCS\ *scs,
'in +2
'll -2
pfMatrix\ mat);
.in
.ll
.PD 0
.TP
const pfMatrix*
\f3\%pfGetSCSMatPtr\fP(pfSCS\ *scs);

.PD
.PP
Since the class
\f3\%pfSCS\fP is itself derived from
the parent class \f3\%pfGroup\fP, objects
of class \f3\%pfFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.PD 0
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFCS\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'fcs\ \ 'u
\f2fcs\fP
identifies a pfFCS
.SH DESCRIPTION

A pfFCS (Flux Coordinate System) is a pfSCS whose matrix is contained in
a pfFlux.  A pfFCS is similar to a pfDCS, in that its matrix can change,
but since its matrix is contained in a pfFlux, it can be animated using
pfEngines.

\f3\%pfNewFCS\fP creates and returns a handle to a pfFCS.  The
matrix of a the new pfFCS will be contained in \f2flux\fP. Like
other pfNodes, pfFCSes are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetFCSClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFCS\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetFCSClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfFCS\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfFCSFlux\fP attaches a pfFlux to a pFCS.

\f3\%pfGetFCSFlux\fP returns the pfFlux currently attached
to a pfFCS.

\f3\%pfFCSMatType\fP allows the specification of
information about the type of transformation the matrix represents.
This information allows Performer to speed up some operations.  The
matrix type is specified as the OR of

.RS
.TP5
PFMAT_TRANS:
matrix may include a translational component in the 4th row.
.TP
PFMAT_ROT
matrix may include a rotational component in the left upper 3X3 submatrix.
.TP
PFMAT_SCALE
matrix may include a uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_NONORTHO
matrix may include a non-uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_PROJ
matrix may include projections.
.TP
PFMAT_HOM_SCALE
matrix may have mat[4][4] != 1.
.TP
PFMAT_MIRROR
matrix may include mirroring transformation that
switches between right handed and left handed coordinate systems.
.TP
.RE

\f3\%pfGetFCSMatType\fP returns the matrix type as
set by \f3\%pfFCSMatType\fP.  If no matrix type is
set the default is ~0, corresponding to a general matrix.

The transformation of a pfFCS affects all its children.  As the
hierarchy is traversed from top to bottom, each new matrix is
pre-multiplied to create the new transformation.  For example, if
FCSb is below FCSa in the scene graph, any geometry G below FCSa is
transformed as G*FCSb*FCSa.

\f3\%pfFlatten\fP cannot flatten pfFCSes since they may
change at run-time.  In this case \f3\%pfFlatten\fP will
compute a pfSCS representing
the accumulated static transformation that the pfFCS inherits and
insert it above the pfFCS.  Static transformations below a pfFCS are
flattened as usual.  See \f3\%pfFlatten\fP for more details.

The presence of transformations in the scene graph impacts the
performance of intersection, culling and drawing.  pfGeoSet culling
(see \f3\%PFCULL_GSET\fP in \f3\%pfChanTravMode\fP) is
disabled in portions of
the scene graph below pfFCSes.

Both pre and post CULL and DRAW callbacks attached to a pfFCS
(\f3\%pfNodeTravFuncs\fP) will be affected by
the transformation represented by the pfFCS, i.e. - the pfFCS matrix will
already have been applied to the matrix stack before the pre callback is
called and will be popped only after the post callback is called.

\f3\%pfGetFCSMat\fP copies the transformation matrix value
from \f2fcs\fP into the matrix \f2m\fP.  For faster matrix
access, \f3\%pfGetFCSMatPtr\fP
can be used to get a const pointer to \f2fcs\fP's matrix.
.SH SEE ALSO
pfFlux,
pfEngine,
pfGroup,
pfChanTravMode,
pfLookupNode,
pfFlatten,
pfMatrix,
pfNode,
pfSCS,
pfScene,
pfTraverser,
pfDelete
