'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFile" "3pf"
.SH NAME
.upperok
.B pfCreateFile,
.B pfOpenFile,
.B pfCloseFile,
.B pfReadFile,
.B pfSeekFile,
.B pfWriteFile,
.B pfGetFileStatus,
.B pfGetFileClassType
\- 
Asynchronous real-time file access operations
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfFile\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfFile *
\f3\%pfCreateFile\fP(char\ *path,
'in +2
'll -2
mode_t\ mode);
.in
.ll
.nf
.fi
.TP
pfFile *
\f3\%pfOpenFile\fP(char\ *fname,
'in +2
'll -2
int\ oflag,
...);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfCloseFile\fP(pfFile\ *file);
.nf
.fi
.TP
int
\f3\%pfReadFile\fP(pfFile\ *file,
'in +2
'll -2
char\ *buf,
int\ nbyte);
.in
.ll
.nf
.fi
.TP
off_t
\f3\%pfSeekFile\fP(pfFile\ *file,
'in +2
'll -2
off_t\ off,
int\ whence);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfWriteFile\fP(pfFile\ *file,
'in +2
'll -2
char\ *buf,
int\ nbyte);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFileStatus\fP(const\ pfFile\ *file,
'in +2
'll -2
int\ attr);
.in
.ll
.nf
.fi
.TP
pfType *
\f3\%pfGetFileClassType\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFile\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfFile\fP.
Casting an object of class \f3\%pfFile\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFile\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

The functions \f3\%pfCreateFile\fP, \f3\%pfOpenFile\fP, \f3\%pfCloseFile\fP,
\f3\%pfReadFile\fP, \f3\%pfWriteFile\fP, and \f3\%pfSeekFile\fP operate in an
identical fashion and take similar arguments as the standard UNIX file
I/O functions: \f3\%creat, open, close, read, write,\fP and \f3\%lseek\fP.  The
difference is that they return immediately without blocking while the
physical file-system access operation completes and also that instead
of an integer file descriptor, a pfFile handle is used.  OpenGL Performer
supports a maximum of \f3\%PFRTF_MAXREQ\fP pending file I/O requests.

When called, \f3\%pfOpenFile\fP and
\f3\%pfCreateFile\fP create a new process
using the \f3\%sproc\fP mechanism that manages the file operations
asynchronously with the calling process.  If the calling process has
super-user privileges, the new process will assign itself to processor
0, and lower its priority.  The spawned process will exit when either
its pfFile is closed via \f3\%pfCloseFile\fP or when
its parent process
(that which called \f3\%pfOpenFile\fP or \f3\%pfCreateFile\fP) exits.

\f3\%pfCloseFile\fP closes the open file and terminates the I/O process
created by \f3\%pfOpenFile\fP or \f3\%pfCreateFile\fP.  \f3\%pfCloseFile\fP does not
free \f2file\fP - use \f3\%pfDelete\fP for that purpose.

\f3\%pfGetFileClassType\fP
returns the \f3\%pfType\fP* for the class
\f3\%pfFile\fP.  The \f3\%pfType\fP* returned by \f3\%pfGetFileClassType\fP
is the same as the \f3\%pfType\fP* returned by invoking
\f3\%pfGetType\fP
on any instance of class \f3\%pfFile\fP.  Because
OpenGL Performer allows subclassing of built-in types, when
decisions are made based on the type of an object, it is
usually better to use \f3\%pfIsOfType\fP
to test if an object is
of a type derived from a Performer type rather than to
test for strict equality of the \f3\%pfType\fP*'s.

\f3\%pfGetFileStatus\fP returns the status of \f2file\fP corresponding to
\f3\%attr\fP which may be one of:
.RS
.TP 20
\f3\%PFRTF_STATUS\fP
Return 0 if last action complete and no other actions pending.
1 if action in progress, and -1 if last action failed.
.TP
\f3\%PFRTF_CMD\fP
Return the current (or last) file I/O action, one of the following:
.RS
\f3\%PFRTF_NOACTION\fP
.br
\f3\%PFRTF_CREATE\fP
.br
\f3\%PFRTF_OPEN\fP
.br
\f3\%PFRTF_READ\fP
.br
\f3\%PFRTF_WRITE\fP
.br
\f3\%PFRTF_SEEK\fP
.br
\f3\%PFRTF_CLOSE\fP
.br
\f3\%PFRTF_PENDING\fP
.RE
.TP
\f3\%PFRTF_BYTES\fP
Return the number of bytes from the last read or write action.
.TP
\f3\%PFRTF_OFFSET\fP
Return the offset from the last seek action.
.TP
\f3\%PFRTF_PID\fP
Return the process id of the I/O process associated with \f2file\fP.
.RE
.SH NOTES


OpenGL Performer for Linux does not currently support Direct File I/O.

The need for the pfFile facility has been largely superseded by the
IRIX 5 asynchronous I/O facility.  These capabilities are accessible
through \f3\%aio_cancel\fP, \f3\%aio_error\fP, \f3\%aio_init\fP, \f3\%aio_read\fP,
\f3\%aio_return\fP, \f3\%aio_suspend\fP, and \f3\%aio_write\fP.  Users are
encouraged to use the aio functions for performing asynchronous file
operations in programs now in development.

The calling process should always call
\f3\%pfCloseFile\fP to close a file before exiting.
If the calling program exits without doing so, the file will not be
closed.  Such files can be challenging to remove from the file system.
.SH SEE ALSO
access,
aio_cancel,
aio_error,
aio_init,
aio_read,
aio_return,
aio_suspend,
aio_write,
close,
creat,
fcntl,
lseek,
open,
read,
write
