'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFlux" "3pf"
.SH NAME
.upperok
.B pfNewFlux,
.B pfNewFluxInitFunc,
.B pfGetFluxInitFunc,
.B pfGetFluxClassType,
.B pfGetFluxDataSize,
.B pfGetFluxNumBuffers,
.B pfFluxInitData,
.B pfFluxCallDataFunc,
.B pfGetFluxCurData,
.B pfGetFluxCurDataFromData,
.B pfGetFluxWritableData,
.B pfGetFluxWritableDataFromData,
.B pfGetFluxBufferData,
.B pfFluxWriteComplete,
.B pfFluxWriteCompleteFromData,
.B pfFluxMode,
.B pfGetFluxMode,
.B pfFluxSrcChanged,
.B pfGetFluxSrcEngine,
.B pfGetFluxNumSrcEngines,
.B pfGetFluxClientEngine,
.B pfGetFluxNumClientEngines,
.B pfFluxMask,
.B pfGetFluxMask,
.B pfFluxEvaluate,
.B pfFluxEvaluateEye,
.B pfFluxSyncGroup,
.B pfGetFluxSyncGroup,
.B pfGetFluxNamedSyncGroup,
.B pfGetFluxSyncGroupName,
.B pfGetFluxNumNamedSyncGroups,
.B pfFluxSyncGroupReady,
.B pfFluxEnableSyncGroup,
.B pfFluxDisableSyncGroup,
.B pfGetFluxEnableSyncGroup,
.B pfFluxSyncComplete,
.B pfFluxDefaultNumBuffers,
.B pfGetFluxDefaultNumBuffers,
.B pfGetFlux,
.B pfFluxFrame,
.B pfGetFluxFrame
\- 
Create, initialize, and manage a pfFlux
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfFluxInitFuncType\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfFlux*
\f3\%pfNewFlux\fP(size_t\ nbytes,
'in +2
'll -2
int\ numBuffers,
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfFlux*
\f3\%pfNewFluxInitFunc\fP(pfFluxInitFuncType\ initFunc,
'in +2
'll -2
int\ numBuffers,
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfFluxInitFuncType
\f3\%pfGetFluxInitFunc\fP(const\ pfFlux*\ _flux);
.nf
.fi
.TP
pfType*
\f3\%pfGetFluxClassType\fP(void);
.nf
.fi
.TP
size_t
\f3\%pfGetFluxDataSize\fP(const\ pfFlux*\ flux);
.nf
.fi
.TP
int
\f3\%pfGetFluxNumBuffers\fP(const\ pfFlux*\ flux,
'in +2
'll -2
int\ type);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFluxInitData\fP(pfFlux*\ flux,
'in +2
'll -2
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFluxCallDataFunc\fP(pfFlux*\ flux,
'in +2
'll -2
pfFluxDataFuncType\ func,
void\ *funcData);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfGetFluxCurData\fP(pfFlux*\ flux);
.nf
.fi
.TP
void*
\f3\%pfGetFluxCurDataFromData\fP(void\ *data);
.nf
.fi
.TP
void*
\f3\%pfGetFluxWritableData\fP(pfFlux*\ flux);
.nf
.fi
.TP
void*
\f3\%pfGetFluxWritableDataFromData\fP(void\ *data);
.nf
.fi
.TP
void*
\f3\%pfGetFluxBufferData\fP(int\ bufferId);
.nf
.fi
.TP
void
\f3\%pfFluxWriteComplete\fP(pfFlux*\ flux);
.nf
.fi
.TP
void
\f3\%pfFluxWriteCompleteFromData\fP(void\ *data);
.nf
.fi
.TP
void
\f3\%pfFluxMode\fP(pfFlux*\ flux,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFluxMode\fP(const\ pfFlux*\ flux,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFluxSrcChanged\fP(pfFlux*\ flux);
.nf
.fi
.TP
pfEngine*
\f3\%pfGetFluxSrcEngine\fP(const\ pfFlux*\ flux,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFluxNumSrcEngines\fP(const\ pfFlux*\ flux);
.nf
.fi
.TP
pfEngine*
\f3\%pfGetFluxClientEngine\fP(const\ pfFlux*\ flux,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFluxNumClientEngines\fP(const\ pfFlux*\ flux);
.nf
.fi
.TP
void
\f3\%pfFluxMask\fP(pfFlux*\ flux,
'in +2
'll -2
uint\ mask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetFluxMask\fP(const\ pfFlux*\ flux);
.nf
.fi
.TP
void
\f3\%pfFluxEvaluate\fP(pfFlux*\ flux,
'in +2
'll -2
int\ mask);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFluxEvaluateEye\fP(pfFlux*\ flux,
'in +2
'll -2
int\ mask,
pfVec3\ eyePos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFluxSyncGroup\fP(pfFlux*\ flux,
'in +2
'll -2
uint\ syncGroup);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetFluxSyncGroup\fP(pfFlux*\ flux);
.nf
.fi
.TP
uint
\f3\%pfGetFluxNamedSyncGroup\fP(const\ char\ *name);
.nf
.fi
.TP
const char*
\f3\%pfGetFluxSyncGroupName\fP(uint\ syncGroup);
.nf
.fi
.TP
int
\f3\%pfGetFluxNumNamedSyncGroups\fP(void);
.nf
.fi
.TP
void
\f3\%pfFluxSyncGroupReady\fP(uint\ syncGroup);
.nf
.fi
.TP
void
\f3\%pfFluxEnableSyncGroup\fP(uint\ syncGroup);
.nf
.fi
.TP
void
\f3\%pfFluxDisableSyncGroup\fP(uint\ syncGroup);
.nf
.fi
.TP
int
\f3\%pfGetFluxEnableSyncGroup\fP(uint\ syncGroup);
.nf
.fi
.TP
void
\f3\%pfFluxSyncComplete\fP(void);
.nf
.fi
.TP
int
\f3\%pfFluxDefaultNumBuffers\fP(int\ numBuffers);
.nf
.fi
.TP
int
\f3\%pfGetFluxDefaultNumBuffers\fP(void);
.nf
.fi
.TP
pfFlux*
\f3\%pfGetFlux\fP(void\ *data);
.nf
.fi
.TP
void
\f3\%pfFluxFrame\fP(int\ frame);
.nf
.fi
.TP
int
\f3\%pfGetFluxFrame\fP(int\ frame);
.nf
.fi
.TP
typedef int
\f3\%(*pfFluxInitFuncType)\fP(pfFluxMemory\ *_fmem);
.nf
.fi
.TP
typedef void
\f3\%(*pfFluxDataFuncType)\fP(void\ *_data,
'in +2
'll -2
void\ *_funcData);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFlux\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfFlux\fP.
Casting an object of class \f3\%pfFlux\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFlux\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'flux\ \ 'u
\f2flux\fP
identifies a pfFlux.
.SH DESCRIPTION

A \f3\%pfFlux\fP is a container for holding dynamic data.  It contains
multiple buffers of data each associated with a frame number.  This
allows multiple processes to each have a copy of the data appropriate
to the frame they are working on.

\f3\%pfNewFlux\fP creates and returns a handle to a \f3\%pfFlux\fP.  \f2arena\fP
specifies a malloc arena out of which the \f3\%pfFlux\fP is allocated or
\f3\%NULL\fP for allocation off the process heap.
The argument \f2nbytes\fP specifies the length of each associated pfFluxMemory.
The argument \f2numBuffers\fP specifies the number of pfFluxMemory data
buffers that the pfFlux will be created with.  \f2numBuffers\fP can be set
to \f3\%PFFLUX_DEFAULT_NUM_BUFFERS\fP in which case the number of buffers will
be a number determined to be appropriate to the current multi processing
mode.  \f3\%PFFLUX_DEFAULT_NUM_BUFFERS\fP can also also be used in additive
expressions such as (\f3\%PFFLUX_DEFAULT_NUM_BUFFERS\fP + 1), to creat a
number of buffers that is one greater then the default number of buffers.

\f3\%pfNewFluxInitFunc\fP also allocates a
\f3\%pfFlux\fP from the specified memory arena.  However the size of
the associated pfFluxMemorys and their initialization is determined
by the call back function \f2initFunc\fP of type \f3\%pfFluxInitFuncType\fP.  The
\f2initFunc\fP takes a pfFluxMemory \f2fmem\fP, and returns an int.  It will
be called once to determine the size of pfFluxMemorys to create and it
will be called once for each pfFluxMemory created.  If \f2fmem\fP
is NULL it should return the size of pfFluxMemorys to create.
If \f2fmem\fP is not NULL it should do any desired initialization of the
data portion of the pfFluxMemory.  For example it might call
\f3\%pfFluxedGSetInit\fP to turn the data portion into a pfGeoSet and
then add coordinate attributes etc. to that pfGeoSet.  This is
how a fluxed pfGeoSet is created.

A \f3\%pfFlux\fP can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetFluxClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFlux\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetFluxClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfFlux\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfGetFluxDataSize\fP returns the size of
the data buffers in a pfFlux.

\f3\%pfGetFluxNumBuffers\fP the number of
data buffers a pfFlux contains, if \f2type\fP is set to
\f3\%PFFLUX_BUFFERS_GENERATED\fP.  If \f2type\fP is set to
\f3\%PFFLUX_BUFFERS_SPECIFIED\fP, it will return what the \f2numBuffers\fP
argument was set to when the pfFlux was created.

\f3\%pfFluxInitData\fP initializes all data buffers of
a pfFlux to the data referenced by \f2data\fP.  \f2data\fP should be at least
as large as the data buffers of the pfFlux.

\f3\%pfFluxCallDataFunc\fP calls \f2func\fP for
each data buffers of a pfFlux.  \f2func\fP will be called with the
pointer to the data buffer and with \f2funcData\fP.  This function is
useful in manipulating the buffers of a pfFlux when they contained
fluxed Performer objects such as fluxed pfGeoSets.

\f3\%pfGetFluxCurData\fP returns a pointer to
the current data buffer of a pfFlux.  The current buffer is the readable
data buffer whose frame number is the closest to the current flux frame
number, but not greater then the current flux frame number.

Example of reading data:

.Ex
.nf

pfVec3 *cur_verts;

cur_verts = (pfVec3*)pfGetFluxCurData(flux);

.Ee
.fi
.na


\f3\%pfGetFluxWritableData\fP returns a
pointer to the data buffer whose frame number matches the current
flux frame number.  NULL will be returned if the \f3\%PFLUX_WRITE_ONCE\fP
mode is set to \f3\%PF_ON\fP and there is already a readable buffer with
a frame number that matches the current flux frame number.

\f3\%pfFluxWriteComplete\fP will mark the
data buffer whose frame number matches the current flux frame number,
as readable.  It has no effect if there is no buffer for the current flux
frame number.

Example of writing data:

.Ex
.nf

pfVec3 *verts;
int i, num_verts;

verts = (pfVec3*)pfGetFluxWritableData(flux);

/* Set all verts to 1.0, 2.0, 3.0 */
num_verts = pfGetFluxDataSize(flux) / sizeof(pfVec3);
for (i = 0; i < num_verts; i++)
    pfSetVec3(verts[i], 1.0f, 2.0f, 3.0f);

pfFluxWriteComplete(flux);

.Ee
.fi
.na


\f3\%pfGetFluxBufferData\fP returns the
untyped data pointer associated with buffer \f2bufferId\fP of
\f2flux\fP.

\f3\%pfFluxMode\fP and
\f3\%pfGetFluxMode\fP set and get the modes of a
pfFlux.  \f2mode\fP is the mode you are setting and \f2val\fP is the value
you are setting the mode to.  The modes are:
.PP
.TS
center tab($) ;
c | c
lB | lB .
\f2mode\fP$default
_
PFFLUX_PUSH$PF_OFF
PFFLUX_ON_DEMAND$PF_OFF
PFFLUX_COPY_LAST_DATA$PF_OFF
PFFLUX_WRITE_ONCE$PF_OFF
.TE
.PP
\f3\%PFFLUX_PUSH\fP controls what is done to a pfFlux's client pfEngines when
\f3\%pfFluxWriteComplete\fP is done.  Setting
it to \f3\%PF_ON\fP will cause \f3\%pfEngineEvaluate\fP
to be done to its clients.  Setting it to \f3\%PF_OFF\fP will cause
\f3\%pfEngineSrcChanged\fP to be done to its clients.

\f3\%PFFLUX_ON_DEMAND\fP controls on demand evaluation triggering.  Setting
it to \f3\%PF_ON\fP will cause an evaluation of the pfFlux to occur, if
\f3\%pfGetFluxCurData\fP is called and the
data buffer for the current flux frame is dirty.

\f3\%PFFLUX_COPY_LAST_DATA\fP controls what happens when a buffer is assigned a
new frame number.  Setting it to \f3\%PF_ON\fP will cause the data, from
the data buffer with the frame number that is closest to but not greater
then the new frame number, to be copied to the data buffer that is getting
the new frame number.  This is useful when a random portion of a pfFluxes
data will be updated with each write.

\f3\%PFFLUX_WRITE_ONCE\fP is used to avoid multiple writes on a pfFlux within the
same frame. It controls what happens when
\f3\%pfGetFluxWritableData\fP is called and there
is already a readable data buffer with the current frame number (Having a
readable data buffer means that someone called
\f3\%pfGetFluxWritableData\fP and
\f3\%pfFluxWriteComplete\fP this frame).
Setting the flag to \f3\%PF_ON\fP will cause NULL to be returned from
\f3\%pfGetFluxWritableData\fP.  Setting it to
\f3\%PF_OFF\fP will cause the pointer to the readable data buffer to be returned.
Using the \f3\%PFFLUX_WRITE_ONCE\fP flag is a good idea when you have multiple
writing processes to a Flux, and you wish to make sure that only one of them
writes at any given frame.

\f3\%pfFluxSrcChanged\fP will mark the data buffer,
with a frame number matching the current flux frame number, as dirty.

\f3\%pfGetFluxSrcEngine\fP returns the \f2i\fPth
source pfEngine of a pfFlux.  A pfFlux gains source pfEngines by
being the destination of a pfEngine.

\f3\%pfGetFluxNumSrcEngines\fP returns
the number of source pfEngines of a pfFlux.

\f3\%pfGetFluxClientEngine\fP returns the \f2i\fPth
client pfEngine of a pfFlux.  A pfFlux gains client pfEngines by
being a source of a pfEngine.

\f3\%pfGetFluxNumClientEngines\fP returns
the number of client pfEngines of a pfFlux.

\f3\%pfFluxMask\fP and
\f3\%pfGetFluxMask\fP set and get the evaluation
mask of a pfFlux.  The default mask is \f3\%PFFLUX_BASIC_MASK\fP.

\f3\%pfFluxEvaluate\fP and
\f3\%pfFluxEvaluateEye\fP trigger
an evaluation of a pfFlux if any of the bits in \f2mask\fP match any of
the bits in the evaluation mask of the pfFlux.  The evaluation of a
pfFlux is equivalent to calling \f3\%pfEngineEvaluate\fP
on the source engines of the pfFlux followed by calling
\f3\%pfFluxWriteComplete\fP on the pfFlux.

\f3\%pfFluxSyncGroup\fP and
\f3\%pfGetFluxSyncGroup\fP set and get the
sync group of a pfFlux.

pfFlux sync groups are used to synchronize the completion of multiple
pfFluxes.  When \f3\%pfFluxWriteComplete\fP
id called on a pfFlux that is part of an enabled sync group the
data buffer for the current flux frame will not be made readable and
instead the pfFlux will be scheduled for later completion.  All pfFluxes
are created as part of sync group 0, which can never be enabled.
One example where sync groups are useful is, when pfFluxes are being
evaluated in an asynchronys process.

\f3\%pfGetFluxNamedSyncGroup\fP
will returns a sync group number associated with \f2name\fP.  If
name is not yet associated with a sync group, the next unused sync group
number will be named \f2name\fP.  Once a sync group has been named its
name can never be changed.

\f3\%pfGetFluxSyncGroupName\fP
returns the name of \f2syncGroup\fP.

\f3\%pfGetFluxNumNamedSyncGroups\fP
returns the number of named sync groups.

\f3\%pfFluxSyncGroupReady\fP specifies that
the \f2syncGroup\fP is ready for completion if it has been enabled.  This
will have no effect if \f2syncGroup\fP has not been enabled.

\f3\%pfFluxEnableSyncGroup\fP and
\f3\%pfFluxDisableSyncGroup\fP
enable and disable a sync group.
\f3\%pfGetFluxEnableSyncGroup\fP
returns whether a sync group is enabled.

\f3\%pfFluxSyncComplete\fP will cause the
completion of all pfFluxes that have been scheduled for completion
and are part of a ready sync group.  In addition to making the buffer
readable it will also mark it with the current flux frame number.
Normally there is no reason to call this function, as it is called
by \f3\%pfFrame\fP.

\f3\%pfGetFlux\fP will return the pfFlux that the
data buffer pointer \f2data\fP is a part of.  It will return NULL if
\f2data\fP is not part of a pfFlux.  This is useful to find out if an
attribute of a pfGeoSet is a pfFlux.

\f3\%pfFluxDefaultNumBuffers\fP sets the
default number of buffers that are allocated when a pfFlux is created using
\f3\%PFFLUX_DEFAULT_NUM_BUFFERS\fP.  Normally there is no reason to call this
function, as it is called by \f3\%pfConfig\fP.  If you are not calling
\f3\%pfConfig\fP in your application and you are using pfFlux you should call
\f3\%pfFluxDefaultNumBuffers\fP before
you fork any processes.
\f3\%pfGetFluxDefaultNumBuffers\fP
returns the current default number of buffers.

\f3\%pfFluxFrame\fP will set the current flux frame
number for the process that is invoking it.  This is the frame number that
\f3\%pfGetFluxCurData\fP
\f3\%pfGetFluxWritableData\fP and
\f3\%pfFluxWriteComplete\fP will use in determining
which buffers to operate on.  Normally there is no reason to call this
function, as it is called by \f3\%pfFrame\fP for all Performer processes.
\f3\%pfGetFluxFrame\fP returns the current flux frame
number.

pfFluxes can be connected to other Performer objects using the following
functions:

.RS
\f3\%pfEngineSrc\fP
.br
\f3\%pfEngineDst\fP
.br
\f3\%pfNewFCS\fP
.br
\f3\%pfFCSFlux\fP
.br
\f3\%pfGSetAttr\fP
.br
\f3\%pfGSetBBoxFlux\fP
.br
\f3\%pfASDAddQueryArray\fP
.br
\f3\%pfBboardPosFlux\fP
.br
\f3\%pfLODRangeFlux\fP
.br
\f3\%pfSwitchValFlux\fP
.RE

.SH NOTES


pfFlux replaces the obsoleted pfCycleBuffers.
The following shows how to convert code using pfCycleBuffers to use pfFlux:
.Ex
.nf

    /* Replace pfCyclebuffer creation with pfFlux: */
    pfFlux *flux = pfNewFlux(size, \f3\%PFFLUX_DEFAULT_NUM_BUFFERS\fP);

    /* replace getting of read-only data
     * pfCBufGetCurData() for read becomes:
     */
    pfFluxGetCurData();

    /* replace getting of data to edit */

    /* get writable buffer BEFORE editing data
     *
     */
	pfGetFluxWritableData();

    /* ... edit data */

    /* declare data edited after editing for the frame is done.
     * Replace pfCBufferChanged(pfCycleBuffer *cbuf) becomes:
     */
    pfFluxWriteComplete();

.Ee
.fi
.na


.SH BUGS



.SH SEE ALSO
pfFluxMemory,
pfEngine,
pfFCS,
pfFrame,
pfGetFrameTimeFlux,
pfASD,
pfBillboard,
pfGeoSet,
pfLOD,
pfSwitch
