'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFog" "3pf"
.SH NAME
.upperok
.B pfNewFog,
.B pfGetFogClassType,
.B pfFogType,
.B pfGetFogType,
.B pfFogColor,
.B pfGetFogColor,
.B pfFogRange,
.B pfGetFogRange,
.B pfFogOffsets,
.B pfGetFogOffsets,
.B pfFogRamp,
.B pfGetFogRamp,
.B pfGetFogDensity,
.B pfApplyFog,
.B pfGetCurFog
\- 
Create, modify and query fog definition
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfType\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfFog *
\f3\%pfNewFog\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetFogClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfFogType\fP(pfFog\ *fog,
'in +2
'll -2
int\ type);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFogType\fP(const\ pfFog\ *fog);
.nf
.fi
.TP
void
\f3\%pfFogColor\fP(pfFog\ *fog,
'in +2
'll -2
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFogColor\fP(const\ pfFog\ *fog,
'in +2
'll -2
float\ *r,
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFogRange\fP(pfFog\ *fog,
'in +2
'll -2
float\ onset,
float\ opaque);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFogRange\fP(const\ pfFog\ *fog,
'in +2
'll -2
float\ *onset,
float\ *opaque);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFogOffsets\fP(pfFog\ *fog,
'in +2
'll -2
float\ onset,
float\ opaque);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFogOffsets\fP(const\ pfFog\ *fog,
'in +2
'll -2
float\ *onset,
float\ *opaque);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFogRamp\fP(pfFog\ *fog,
'in +2
'll -2
int\ points,
float\ *range,
float\ *density,
float\ bias);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFogRamp\fP(const\ pfFog\ *fog,
'in +2
'll -2
int\ *points,
float\ *range,
float\ *density,
float\ *bias);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetFogDensity\fP(const\ pfFog\ *fog,
'in +2
'll -2
float\ range);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyFog\fP(pfFog\ *fog);
.nf
.fi
.TP
pfFog *
\f3\%pfGetCurFog\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFog\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfFog\fP.
Casting an object of class \f3\%pfFog\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFog\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

\f3\%pfFog\fP is used to simulate atmospheric phenomena such as fog and
haze and for depthcueing.  The fog color is blended with the color
that is computed for rendered geometry based on the geometry's range
from the eyepoint.  Fog effects may be computed at geometric vertices
and then interpolated or computed precisely at each individual pixel.

\f3\%pfNewFog\fP creates and returns a handle to a new pfFog.  \f2arena\fP
specifies a malloc arena out of which the pfFog is allocated or NULL
for allocation from the calling process' heap.  pfFogs can be deleted
with \f3\%pfDelete\fP.

\f3\%pfGetFogClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFog\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetFogClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfFog\fP.  When decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fPto test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfFogType\fP sets the fog type to be used when this pfFog is applied.
\f2type\fP must be one of:
.RS
\f3\%PFFOG_VTX_LIN\fP
.br
\f3\%PFFOG_VTX_EXP\fP
.br
\f3\%PFFOG_VTX_EXP2\fP
.br
\f3\%PFFOG_PIX_LIN\fP
.br
\f3\%PFFOG_PIX_EXP\fP
.br
\f3\%PFFOG_PIX_EXP2\fP
.br
\f3\%PFFOG_PIX_SPLINE\fP
.RE

Detailed descriptions of these fog types are in the OpenGL \f3\%glFog(3G)\fP
man pages, with the exception of \f3\%PFFOG_PIX_SPLINE\fP.  This is an
advanced fog type that allows the user to define fog densities as a
\f3\%PFFOG_MAXPOINTS\fP point spline curve as described in \f3\%pfFogRamp\fP.
When fog type \f3\%PFFOG_PIX_SPLINE\fP is specified the internal fog ramp
table will be recomputed using the current values of fog range, fog
offsets, and fog ramp.  The default fog type is \f3\%PFFOG_PIX_EXP2\fP.
\f3\%pfGetFogType\fP returns the fog type as its value.

\f3\%pfFogColor\fP specifies the color to be used as the fog blend color.
The default fog color is white, whose RGB value is [1.0, 1.0, 1.0].
\f3\%pfGetFogColor\fP returns the fog color in the variables specified.

\f3\%pfFogRange\fP sets the onset and opaque ranges in world coordinate
distances.  The onset is the range at which fog blending first occurs.
The opaque range is the distance at which scene elements are completely
opaque and appear as the fog color.  For the fog types \f3\%PFFOG_VTX_EXP,
PFFOG_VTX_EXP2, PFFOG_PIX_EXP, PFFOG_PIX_EXP2\fP only the opaque range
is significant; the onset range is always 0.0 in world coordinates.  If
the fog type is \f3\%PFFOG_PIX_SPLINE\fP then the internal fog ramp table
will be recomputed whenever the ranges are specified.
\f3\%pfGetFogRange\fP returns the current fog range values.

\f3\%pfFogOffsets\fP sets the individual onset and opaque range offsets
used to modify the fog range.  These offsets are added to the fog range
values when the pfFog is applied.  Calling this function with offsets of
zero causes the ranges defined by \f3\%pfFogRange\fP to be used directly.
If the fog type is \f3\%PFFOG_PIX_SPLINE\fP then the internal fog ramp
table will be recomputed whenever the offsets are specified.
\f3\%pfGetFogOffsets\fP returns the current fog offset values.

\f3\%pfFogRamp\fP defines the fog density curve using a table rather than
as an algebraic function of range.  The fog ramp table is only used
with the \f3\%PFFOG_PIX_SPLINE\fP fog type.  From four to PFFOG_MAXPOINTS
control points are used to describe this curve.  If fewer than four
control points are given, the last point will be replicated to create
four points.  Each point consists of a range and fog density pair.
These are given in ascending order in the arrays \f2range\fP and
\f2density\fP.  The range value is specified in a normalized form in the
numeric range [0..1], with 0.0 corresponding to the fog onset range
(plus offset) and 1.0 the fog opaque range (plus offset).  This allows
the ranges to be changed while maintaining the same fog density curve.
The fog density at each range point must also be in the [0..1] range,
where 1.0 represents no fog and 0.0 means opaque fog, using the OpenGL-
style interpretation. A Catmull-Rom
spline interpolation is used to create hardware fog tables from this
fog ramp table.  If the fog type is \f3\%PFFOG_PIX_SPLINE\fP then the
internal fog ramp table will be recomputed whenever the fog ramp, fog
range, or fog offsets are specified.  The default fog ramp table
defines a linear interpolation between the onset and opaque ranges.
Currently, the \f2bias\fP value must be set to zero.  \f3\%pfGetFogRamp\fP
returns the number of points, range and density arrays, and bias in the
variables specified.

\f3\%pfGetFogDensity\fP returns the density, ranging
from 0 to 1 of \f2fog\fP at range \f2range\fP.

\f3\%pfApplyFog\fP configures the graphics hardware with the fog parameters
encapsulated by \f2fog\fP.  Only the most recently applied pfFog is
active although any number of pfFog definitions may be created.
Fogging must also be enabled (\f3\%pfEnable\fP(\f3\%PFEN_FOG\fP)) for
\f2fog\fP to take effect.  Modifications made to this
pfFog do not have effect until \f3\%pfApplyFog\fP is
called.  If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfApplyFog\fP will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

The fog state element is identified by the \f3\%PFSTATE_FOG\fP token.  Use this
token with \f3\%pfGStateAttr\fP to set the fog mode of a pfGeoState and with
\f3\%pfOverride\fP to override subsequent fog changes:

Example 1:
.Ex
.nf

/* Set up 'fogged' pfGeoState */
pfGStateMode(gstate, PFSTATE_ENFOG, PFFOG_ON);
pfGStateAttr(gstate, PFSTATE_FOG, fog);

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Draw fogged gset */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

/* Override so that all geometry is fogged with 'fog' */
pfEnable(PFEN_FOG);
pfApplyFog(fog);
pfOverride(PFSTATE_FOG | PFSTATE_ENFOG, PF_ON);
.Ee
.fi
.na


\f3\%pfGetCurFog\fP returns the currently active pfFog.

.SH NOTES


PFFOG_PIX_SPLINE and PFFOG_PTX* fog modes are not currently supported under
Linux.

\f3\%PFFOG_PIX_SPLINE\fP is only effective on InfiniteReality and RealityEngine
graphics systems.
The visual quality of per-pixel fogging is influenced by the ratio of the
distances from the eye to the far and the eye to the near clipping planes.
This ratio should be minimized for best results.
.SH BUGS

\f3\%pfGetFogDensity\fP does not properly evaluate \f3\%PFFOG_PIX_SPLINE\fP; instead
it linearly interpolates the spline points.
.SH SEE ALSO
pfDispList,
pfEnable,
pfGeoState,
pfObject,
pfOverride,
fogvertex,
lsetdepth,
perspective,
glFog
