'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFont" "3pf"
.SH NAME
.upperok
.B pfNewFont,
.B pfGetFontClassType,
.B pfFontCharGSet,
.B pfGetFontCharGSet,
.B pfFontCharSpacing,
.B pfGetFontCharSpacing,
.B pfFontAttr,
.B pfGetFontAttr,
.B pfFontVal,
.B pfGetFontVal,
.B pfFontMode,
.B pfGetFontMode
\- 
Routines to load fonts for use in Performer.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ pfVec3*\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfFont*
\f3\%pfNewFont\fP(void\ *arena);
.nf
.fi
.TP
pfType*
\f3\%pfGetFontClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfFontCharGSet\fP(pfFont*\ font,
'in +2
'll -2
int\ ascii,
pfGeoSet*\ gset);
.in
.ll
.nf
.fi
.TP
pfGeoSet*
\f3\%pfGetFontCharGSet\fP(pfFont*\ font,
'in +2
'll -2
int\ ascii);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFontCharSpacing\fP(pfFont*\ font,
'in +2
'll -2
int\ ascii,
pfVec3\ spacing);
.in
.ll
.nf
.fi
.TP
const pfVec3*
\f3\%pfGetFontCharSpacing\fP(pfFont*\ font,
'in +2
'll -2
int\ ascii);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFontAttr\fP(pfFont*\ font,
'in +2
'll -2
int\ which,
void\ *attr);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfGetFontAttr\fP(pfFont*\ font,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFontVal\fP(pfFont*\ font,
'in +2
'll -2
int\ which,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetFontVal\fP(pfFont*\ font,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFontMode\fP(pfFont*\ font,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFontMode\fP(pfFont*\ font,
'in +2
'll -2
int\ mode);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFont\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfFont\fP.
Casting an object of class \f3\%pfFont\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFont\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

The \f3\%pfFont\fP facility provides the capability to load fonts for
3-D rendering with the string drawing routines from \f3\%pfString\fP
and \f3\%pfText\fP.  The basic methodology is the user provides individual
GeoSets to be used as font characters.  Likewise, the user provides
3-D spacings for each character so that Performer can correctly move
the 'cursor' or '3-D origin' after drawing each character.  Note that
this facility is completely general and is independent of external
font descriptions - see \f3\%pfdLoadFont\fP for a description of loading
some PostScript Type I fonts into a pfFont structure.

\f3\%pfNewFont\fP returns a handle to a new \f3\%pfFont\fP.  \f2arena\fP
specifies the malloc arena out of which the \f3\%pfFont\fP is allocated or
NULL for allocation off the heap.  A NULL pointer is returned to
indicate failure.  pfFonts can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetFontClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFont\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetFontClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfFont\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

.SS \f3\%pfFont\fP Definition:
Call \f3\%pfFontCharGSet\fP to set the pfGeoSet which
Performer should use when drawing the character specified by \f2ascii\fP in a
\f3\%pfString\fP.
\f3\%pfGetFontCharGSet\fP returns the pfGeoSet currently
being used for the character specified by \f2ascii\fP.
Call \f3\%pfFontCharSpacing\fP to set the 3D spacing
for the character specified by \f2ascii\fP to be the pfVec3
\f2spacing\fP. This spacing is used to update the cursor position of a \f3\%pfString\fP
after this character has been drawn.
\f3\%pfGetFontCharSpacing\fP returns a reference to
a pfVec3 specifying the spacing of a given character of a font.

.SS \f3\%pfFont\fP Attributes:
\f3\%pfFontAttr\fP sets a particular attribute for a
given Performer font, while \f3\%pfGetFontAttr\fP will
return a particular attribute corresponding to the \f2which\fP token.

Current valid pfFont Attributes:
\f3\%PFFONT_GSTATE\fP
\f3\%PFFONT_BBOX\fP
\f3\%PFFONT_SPACING\fP
\f3\%PFFONT_NAME\fP

\f3\%PFFONT_GSTATE\fP specifies a global pfGeoState to be used for every
character of a pfFont. Note that pfGeoStates bound to GeoSets representing
characters will take precedence over the PFFONT_GSTATE pfGeoState.
A Font has NO pfGeoState by default.

\f3\%PFFONT_BBOX\fP specifies a bounding box that will enclose every individual
character of a pfFont.

\f3\%PFFONT_SPACING\fP specifies a global spacing to use to simulate fixed width
fonts.  This spacing is used only if the pfFont mode PFFONT_CHAR_SPACING
is set to PFFONT_CHAR_SPACING_FIXED or a spacing is not available (NULL) for
a given character.
\f3\%PFFONT_NAME\fP simply specifies a name associated with a pfFont.

.SS \f3\%pfFont\fP Modes:
\f3\%pfFontMode\fP sets a particular mode for a given
Performer font, while \f3\%pfGetFontMode\fP will return
the current value of the mode corresponding to the \f2mode\fP token.

Current valid \f3\%pfFont\fP Modes:
\f3\%PFFONT_CHAR_SPACING\fP
\f3\%PFFONT_NUM_CHARS\fP

\f3\%PFFONT_CHAR_SPACING\fP specifies whether to use fixed or variable spacings for
all characters of a pfFont.  Possible values are \f3\%PFFONT_CHAR_SPACING_FIXED\fP
and \f3\%PFFONT_CHAR_SPACING_VARIABLE\fP - the later being the default.

.SS \f3\%pfFont\fP Values:
\f3\%pfFontVal\fP sets a particular value for a given
Performer font, while \f3\%pfGetFontVal\fP will return
the corresponding value associated with  the \f2which\fP token.
.SH NOTES

See \f3\%pfText\fP for sample code demonstrating \f3\%pfFont\fP.
.SH SEE ALSO
pfBox,
pfDelete,
pfGeoSet,
pfGeoState,
pfString,
pfText,
pfdLoadFont
