'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfFrustum" "3pf"
.SH NAME
.upperok
.B pfNewFrust,
.B pfGetFrustClassType,
.B pfMakePerspFrust,
.B pfMakeOrthoFrust,
.B pfMakeSimpleFrust,
.B pfGetFrustType,
.B pfGetFrustFOV,
.B pfFrustAspect,
.B pfGetFrustAspect,
.B pfFrustNearFar,
.B pfGetFrustNearFar,
.B pfGetFrustNear,
.B pfGetFrustFar,
.B pfGetFrustEye,
.B pfGetFrustPtope,
.B pfGetFrustGLProjMat,
.B pfApplyFrust,
.B pfFrustContainsPt,
.B pfFrustContainsBox,
.B pfFrustContainsSphere,
.B pfFrustContainsCyl,
.B pfOrthoXformFrust
\- 
Operations on frusta
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfFrustum\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfFrustum *
\f3\%pfNewFrust\fP(void*\ arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetFrustClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfMakePerspFrust\fP(pfFrustum*\ frust,
'in +2
'll -2
float\ left,
float\ right,
float\ bottom,
float\ top);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeOrthoFrust\fP(pfFrustum*\ frust,
'in +2
'll -2
float\ left,
float\ right,
float\ bottom,
float\ top);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeSimpleFrust\fP(pfFrustum*\ frust,
'in +2
'll -2
float\ fov);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFrustType\fP(const\ pfFrustum*\ frust);
.nf
.fi
.TP
void
\f3\%pfGetFrustFOV\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
float*\ fovh,
float*\ fovv);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFrustAspect\fP(pfFrustum*\ frust,
'in +2
'll -2
int\ which,
float\ widthHeightRatio);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetFrustAspect\fP(const\ pfFrustum*\ frust);
.nf
.fi
.TP
void
\f3\%pfFrustNearFar\fP(pfFrustum*\ frust,
'in +2
'll -2
float\ near,
float\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFrustNearFar\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
float*\ near,
float*\ far);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFrustNear\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
pfVec3\ ll,
pfVec3\ lr,
pfVec3\ ul,
pfVec3\ ur);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFrustFar\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
pfVec3\ ll,
pfVec3\ lr,
pfVec3\ ul,
pfVec3\ ur);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetFrustEye\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
pfVec3\ eye);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFrustPtope\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
pfPolytope\ *ptope);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetFrustGLProjMat\fP(const\ pfFrustum*\ frust,
'in +2
'll -2
pfMatrix\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyFrust\fP(const\ pfFrustum\ *frust);
.nf
.fi
.TP
int
\f3\%pfFrustContainsPt\fP(const\ pfFrustum\ *fr,
'in +2
'll -2
const\ pfVec3\ pt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFrustContainsBox\fP(const\ pfFrustum\ *frust,
'in +2
'll -2
const\ pfBox\ *box);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFrustContainsSphere\fP(const\ pfFrustum\ *fr,
'in +2
'll -2
const\ pfSphere\ *sph);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFrustContainsCyl\fP(const\ pfFrustum\ *frust,
'in +2
'll -2
const\ pfCylinder\ *cyl);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfOrthoXformFrust\fP(pfFrustum*\ dst,
'in +2
'll -2
const\ pfFrustum*\ src,
const\ pfMatrix\ mat);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfFrustum\fP is
derived from the parent class \f3\%pfPolytope\fP,
so each of these member functions of
class \f3\%pfPolytope\fP
are also directly usable with objects
of class \f3\%pfFrustum\fP.
Casting an object of class \f3\%pfFrustum\fP
to an object of class \f3\%pfPolytope\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfPolytope\fP.

.PD 0
.TP \w'void\ \ \ 'u
int
\f3\%pfGetPtopeNumFacets\fP(pfPolytope\ *ptope);
.PD 0
.TP
int
\f3\%pfPtopeFacet\fP(pfPolytope\ *ptope,
'in +2
'll -2
int\ i,
const\ pfPlane\ *facet);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetPtopeFacet\fP(pfPolytope\ *ptope,
'in +2
'll -2
int\ i,
pfPlane\ *facet);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemovePtopeFacet\fP(pfPolytope\ *ptope,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
void
\f3\%pfOrthoXformPtope\fP(pfPolytope\ *ptope,
'in +2
'll -2
const\ pfPolytope\ *src,
const\ pfMatrix\ \ mat);
.in
.ll
.PD 0
.TP
int
\f3\%pfPtopeContainsPt\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfVec3\ \ pt);
.in
.ll
.PD 0
.TP
int
\f3\%pfPtopeContainsSphere\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfSphere\ *sphere);
.in
.ll
.PD 0
.TP
int
\f3\%pfPtopeContainsBox\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfBox\ *box);
.in
.ll
.PD 0
.TP
int
\f3\%pfPtopeContainsCyl\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfCylinder\ *cyl);
.in
.ll
.PD 0
.TP
int
\f3\%pfPtopeContainsPtope\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfPolytope\ *ptope1);
.in
.ll

.PD
.PP
Since the class
\f3\%pfPolytope\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfFrustum\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfFrustum\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'frust\ \ 'u
\f2frust\fP
identifies a pfFrustum.
.SH DESCRIPTION

A pfFrustum represents a viewing and or culling volume bounded by left,
right, top, bottom, near and far planes.

\f3\%pfNewFrust\fP creates and returns a handle to a pfFrustum.
\f2arena\fP specifies a malloc arena out of which the pfFrustum is
allocated or \f3\%NULL\fP for allocation off the process heap.  pfFrusta
can be deleted with \f3\%pfDelete\fP.

A new pfFrustum defaults to a simple perspective frustum (see
\f3\%pfMakeSimpleFrust\fP) with FOV = 45 degrees, and
near and far distances of 1 and 1000.

\f3\%pfGetFrustClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfFrustum\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetFrustClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfFrustum\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfMakePerspFrust\fP configures \f2frust\fP as a perspective frustum with
the eye at (0,0,0) and the points (\f2left\fP, \f2near\fP, \f2bottom\fP) and
(\f2right\fP, \f2near\fP, \f2top\fP) being the lower-left and upper-right
corners of the viewing plane.  The coordinate system used is:
left -> right = +X axis, near -> far = +Y axis, bottom -> top = +Z axis.
The far plane lies at Y = far. Note that the field of view of a
frustum configured with \f3\%pfMakePerspFrust\fP is dependent on the current
near plane distance. However, subsequent changes to the near plane distance
with \f3\%pfFrustNearFar\fP do not affect the field of view, simplifying
clip plane modification.

\f3\%pfMakePerspFrust\fP is similar to the
IRIS GL \f3\%window(3g)\fP command and can generate off-axis projections
that are often used for stereo and "video-wall" displays.  With an
off-axis frustum, the line from the eyepoint passing through
the center of the image is not perpendicular to the projection plane.

Example 1:
.Ex
.nf

/*
 * Make two off-axis projections which together provide
 * horizontal and vertical FOVs of 90 and 45 degrees.
 */
t = pfTan(22.5f);

pfFrustNearFar(left,  1.0f, 1000.0f);
pfMakePerspFrust(left, -1.0f, 0.0f, -t, t);

pfFrustNearFar(right, 1.0f, 1000.0f);
pfMakePerspFrust(right, 0.0f, 1.0f, -t, t);
.Ee
.fi
.na


\f3\%pfMakeOrthoFrust\fP configures \f2frust\fP as an orthogonal frustum.  The 6
sides of the frustum are: x = left, x = right, z = bottom, z = top, y =
near, y = far.  \f3\%pfMakeOrthoFrust\fP is similar to the IRIS GL
\f3\%ortho2(3g)\fP command.  The near and far distances of an orthogonal
frustum are set by \f3\%pfFrustNearFar\fP.

\f3\%pfMakeSimpleFrust\fP configures \f2frust\fP as an on-axis perspective
frustum with horizontal and vertical fields-of-view of \f2fov\fP
degrees.  With an on-axis frustum, the line connecting the center of
projection with the eyepoint is perpendicular to the projection plane.
\f3\%pfMakeSimpleFrust\fP is similar to the IRIS GL \f3\%perspective(3g)\fP
command.  The near and far distances of a simple frustum are set by
\f3\%pfFrustNearFar\fP. For viewports with non-square aspect ratios,
\f3\%pfFrustAspect\fP may be used to automatically fit either the horizontal
or vertical fields of view to the viewport (see below).

\f3\%pfGetFrustType\fP returns a symbolic token indicating the frustum type
of \f2frust\fP and is one of: \f3\%PFFRUST_SIMPLE\fP, \f3\%PFFRUST_ORTHOGONAL\fP, or
\f3\%PFFRUST_PERSPECTIVE\fP.  The frustum type is set by the
\f3\%pfMake<*>Frust\fP routines.  Note that it is possible to make a simple
frustum with \f3\%pfMakePerspFrust\fP if \f2left\fP == -\f2right\fP and
\f2bottom\fP == -\f2top\fP.

\f3\%pfFrustNearFar\fP sets the near and far distances of \f2frust\fP.  It will
also recalculate the frustum's geometry based on the frustum type.
If \f2frust\fP is perspective, its field of view will not be changed, only
the near and far planes will be modified.
\f3\%pfGetFrustNearFar\fP copies the near and far distances of \f2frust\fP into
\f2near\fP and \f2far\fP.

\f3\%pfFrustAspect\fP adjusts the horizontal or vertical extent of \f2frust\fP
to fit the aspect ratio specified by \f2widthHeightRatio\fP.  \f2which\fP
is a symbolic token specifying how to modify \f2frust\fP and is one of:
.RS
.TP 30
\f3\%PFFRUST_CALC_NONE\fP
Disable aspect ratio calculation
.TP
\f3\%PFFRUST_CALC_HORIZ\fP
Modify horizontal extent of frustum to match the aspect ratio
.TP
\f3\%PFFRUST_CALC_VERT\fP
Modify vertical extent of frustum to match the aspect ratio
.RE

\f3\%pfFrustAspect\fP is useful for matching a frustum to a viewport:

Example 2:
.Ex
.nf

getviewport(&l, &r, &b, &t);
aspect = (float)(r - l) / (float)(t - b);

/*
 * Fit vertical frustum extent to viewport so that horizontal
 * FOV is 45 degrees and vertical is based on 'aspect'.
 */
pfMakeSimpleFrust(frust, 45.0f);
pfFrustAspect(frust, PFFRUST_CALC_VERT, aspect);
.Ee
.fi
.na


Frustum aspect ratio matching is not persistent. You must call
\f3\%pfFrustAspect\fP each time the frustum changes shape in order to
maintain matched frustum/viewport.

\f3\%pfGetFrustAspect\fP returns the aspect ratio of \f2frust\fP.

\f3\%pfGetFrustFOV\fP copies the total horizontal and vertical fields of
view into \f2fovh\fP and \f2fovv\fP respectively.  The fields of view for an
orthogonal frustum are both 0.0.

\f3\%pfGetFrustNear\fP returns the four corners of the near (viewing or
projection) plane putting
the lower-left, lower-right, upper-left and upper-right vertices into
\f2ll\fP, \f2lr\fP, \f2ul\fP, and \f2ur\fP, respectively.

\f3\%pfGetFrustFar\fP returns the four corners of the far plane putting
the lower-left, lower-right, upper-left and upper-right vertices into
\f2ll\fP, \f2lr\fP, \f2ul\fP, and \f2ur\fP, respectively.

\f3\%pfGetFrustEye\fP copies the eye position of the frustum \f2frust\fP into
\f2eye\fP.

\f3\%pfGetFrustPtope\fP copies the 6 half spaces which define
\f2frust\fP into the pfPolytope \f2ptope\fP.

\f3\%pfGetFrustGLProjMat\fP returns the projection matrix corresponding to
\f2frust\fP in the coordinate system of the Graphics Library, ignoring
any transformations applied to \f2frust\fP with \f3\%pfOrthoXformFrust\fP.

\f3\%pfApplyFrust\fP configures the hardware projection matrix with the
projection defined by \f2frust\fP.  Modifications made to \f2frust\fP do not have
effect until \f3\%pfApplyFrust\fP is called.

\f3\%pfApplyFrust\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfApplyFrust\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

\f3\%pfFrustContainsPt\fP
returns \f3\%TRUE\fP or \f3\%FALSE\fP depending on whether the point \f2pt\fP is
in the interior of the specified frustum.

\f3\%pfFrustContainsBox\fP, \f3\%pfFrustContainsSphere\fP and
\f3\%pfFrustContainsCyl\fP
test whether the specified pfFrustum contains a
non-empty portion of the volume specified by the second
argument, a box, sphere or cylinder, respectively.  

The return value from these functions is the OR of one or more bit
fields.  The returned value may be:
.RS
.TP 5
\f3\%PFIS_FALSE\fP: The intersection of the primitive
and the pfFrustum is empty.
.TP
\f3\%PFIS_MAYBE\fP: The intersection of the primitive and the
pfFrustum might be non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP: The intersection of the primitive and the
pfFrustum is definitely non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP | \f3\%PFIS_ALL_IN\fP: The primitive
is non-empty and lies entirely inside the pfFrustum.
.RE

The primary use of \f3\%pfFrustContainsSphere\fP and
\f3\%pfFrustContainsBox\fP within OpenGL
Performer is in culling the database to the view frustum each frame,
where speed is paramount.  If this computation cannot be done easily,
the function returns \f3\%PFIS_MAYBE\fP.

\f3\%pfOrthoXformFrust\fP transforms the frustum using the matrix \f2mat\fP:
\f2dst\fP = \f2src\fP * \f2mat\fP.  If \f2mat\fP is not orthogonal the results
are undefined.

.SH NOTES

pfFrustum construction orients the frustum with +Z up, +X to the
right, and +Y into the screen which is different than
the OpenGL viewing coordinate systems which has +Y up, +X to the
right and -Z into the screen.
.SH SEE ALSO
pfBox,
pfDelete,
pfDispList,
pfMatrix,
pfObject,
pfPlaneIsectSeg,
pfPolytope,
pfSphere,
pfState,
pfVec3,
ortho,
perspective,
window
