'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGeoSet" "3pf"
.SH NAME
.upperok
.B pfNewGSet,
.B pfGetGSetClassType,
.B pfCompileGSet,
.B pfDrawGSet,
.B pfDrawHlightedGSet,
.B pfGSetNumPrims,
.B pfGetGSetNumPrims,
.B pfGSetPrimType,
.B pfGetGSetPrimType,
.B pfGSetPrimLengths,
.B pfGetGSetPrimLengths,
.B pfGetGSetPrimLength,
.B pfGSetAttr,
.B pfGetGSetAttrBind,
.B pfGetGSetAttrLists,
.B pfGetGSetAttrRange,
.B pfGSetMultiAttr,
.B pfGetGSetMultiAttrBind,
.B pfGetGSetMultiAttrLists,
.B pfGetGSetMultiAttrRange,
.B pfGSetDecalPlane,
.B pfGetGSetDecalPlane,
.B pfGSetDrawMode,
.B pfGetGSetDrawMode,
.B pfGSetGState,
.B pfGetGSetGState,
.B pfGSetGStateIndex,
.B pfGetGSetGStateIndex,
.B pfGSetLineWidth,
.B pfGetGSetLineWidth,
.B pfGSetPntSize,
.B pfGetGSetPntSize,
.B pfGSetHlight,
.B pfGetGSetHlight,
.B pfGSetDrawBin,
.B pfGetGSetDrawBin,
.B pfGSetDrawOrder,
.B pfGetGSetDrawOrder,
.B pfGSetPassFilter,
.B pfGetGSetPassFilter,
.B pfHideGSetStripPrim,
.B pfUnhideGSetStripPrim,
.B pfIsGSetStripPrimHidden,
.B pfQueryGSet,
.B pfMQueryGSet,
.B pfGSetBBox,
.B pfGetGSetBBox,
.B pfGSetBBoxFlux,
.B pfGetGSetBBoxFlux,
.B pfGSetIsectMask,
.B pfGetGSetIsectMask,
.B pfGSetIsectSegs,
.B pfGSetPassList,
.B pfGetGSetPassList,
.B pfFluxedGSetInit
\- 
Create, modify and query geometry set objects
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfHighlight\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfGeoSet *
\f3\%pfNewGSet\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetGSetClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfCompileGSet\fP(pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfDrawGSet\fP(pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfDrawHlightedGSet\fP(pfGeoSet*\ gset);
.nf
.fi
.TP
void
\f3\%pfGSetNumPrims\fP(pfGeoSet\ *gset,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetNumPrims\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetPrimType\fP(pfGeoSet\ *gset,
'in +2
'll -2
int\ type);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetPrimType\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetPrimLengths\fP(pfGeoSet*\ gset,
'in +2
'll -2
int\ *lengths);
.in
.ll
.nf
.fi
.TP
int *
\f3\%pfGetGSetPrimLengths\fP(const\ pfGeoSet*\ gset);
.nf
.fi
.TP
int
\f3\%pfGetGSetPrimLength\fP(const\ pfGeoSet*\ gset,
'in +2
'll -2
int\ i);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetAttr\fP(pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
int\ bind,
void\ *alist,
ushort\ *ilist);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetAttrBind\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetGSetAttrLists\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
void\ **alist,
ushort\ **ilist);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetAttrRange\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
int\ *minIndex,
int\ *maxIndex);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetMultiAttr\fP(pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
int\ index,
int\ bind,
void\ *alist,
ushort\ *ilist);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetMultiAttrBind\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetGSetMultiAttrLists\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
int\ index,
void\ **alist,
ushort\ **ilist);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetMultiAttrRange\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ attr,
int\ index,
int\ *minIndex,
int\ *maxIndex);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetDecalPlane\fP(pfGeoSet\ *gset,
'in +2
'll -2
pfPlane\ *plane);
.in
.ll
.nf
.fi
.TP
pfPlane *
\f3\%pfGetGSetDecalPlane\fP(pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetDrawMode\fP(pfGeoSet\ *gset,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetDrawMode\fP(const\ pfGeoSet\ *gset,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetGState\fP(pfGeoSet\ *gset,
'in +2
'll -2
pfGeoState\ *gstate);
.in
.ll
.nf
.fi
.TP
pfGeoState *
\f3\%pfGetGSetGState\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetGStateIndex\fP(pfGeoSet\ *gset,
'in +2
'll -2
int\ id);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetGStateIndex\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetLineWidth\fP(pfGeoSet\ *gset,
'in +2
'll -2
float\ width);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetGSetLineWidth\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetPntSize\fP(pfGeoSet\ *gset,
'in +2
'll -2
float\ size);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetGSetPntSize\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetHlight\fP(pfGeoSet*\ gset,
'in +2
'll -2
pfHighlight\ *hlight);
.in
.ll
.nf
.fi
.TP
pfHighlight *
\f3\%pfGetGSetHlight\fP(const\ pfGeoSet*\ gset);
.nf
.fi
.TP
void
\f3\%pfGSetDrawBin\fP(pfGeoSet\ *gset,
'in +2
'll -2
short\ bin);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetDrawBin\fP(const\ pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetDrawOrder\fP(pfGeoSet\ *\ gset,
'in +2
'll -2
unsigned\ int\ order);
.in
.ll
.nf
.fi
.TP
unsigned int
\f3\%pfGetGSetDrawOrder\fP(const\ pfGeoSet\ *gset)
.nf
.fi
.TP
void
\f3\%pfGSetPassFilter\fP(uint\ mask);
.nf
.fi
.TP
uint
\f3\%pfGetGSetPassFilter\fP(void);
.nf
.fi
.TP
void
\f3\%pfHideGSetStripPrim\fP(const\ pfGeoSet*\ gset,
'in +2
'll -2
int\ i);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfUnhideGSetStripPrim\fP(const\ pfGeoSet*\ gset,
'in +2
'll -2
int\ i);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfIsGSetStripPrimHidden\fP(const\ pfGeoSet*\ gset,
'in +2
'll -2
int\ i);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfQueryGSet\fP(const\ pfGeoSet*\ gset,
'in +2
'll -2
uint\ which,
void*\ dst);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMQueryGSet\fP(const\ pfGeoSet*\ gset,
'in +2
'll -2
uint*\ which,
void*\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetBBox\fP(pfGeoSet\ *gset,
'in +2
'll -2
pfBox\ *box,
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetGSetBBox\fP(pfGeoSet\ *gset,
'in +2
'll -2
pfBox\ *box);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetBBoxFlux\fP(pfGeoSet\ *gset,
'in +2
'll -2
pfFlux\ *flux);
.in
.ll
.nf
.fi
.TP
pfFlux*
\f3\%pfGetGSetBBoxFlux\fP(pfGeoSet\ *gset);
.nf
.fi
.TP
void
\f3\%pfGSetIsectMask\fP(pfGeoSet\ *gset,
'in +2
'll -2
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetGSetIsectMask\fP(pfGeoSet\ *gset);
.nf
.fi
.TP
int
\f3\%pfGSetIsectSegs\fP(pfGeoSet\ *gset,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGSetPassList\fP(pfPassList\ *passList);
.nf
.fi
.TP
pfPassList *
\f3\%pfGetGSetPassList\fP();
.nf
.fi
.TP
int
\f3\%pfFluxedGSetInit\fP(pfFluxMemory\ *fmem);
.fi

.Ex
.nf

typedef struct
{
    int		mode;
    void*	userData;
    pfSeg	segs[PFIS_MAX_SEGS];
    uint	activeMask;
    uint	isectMask;
    void*	bound;
    int		(*discFunc)(pfHit*);
} pfSegSet;
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfGeoSet\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfGeoSet\fP.
Casting an object of class \f3\%pfGeoSet\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfGeoSet\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'gset\ \ 'u
\f2gset\fP
identifies a pfGeoSet.
.TP
\f2attr\fP
is a symbolic token that identifies a specific attribute
type and is one of:
.RS
.TP 25
\f3\%PFGS_COLOR4\fP
\f2alist\fP must be list of pfVec4 colors
.TP
\f3\%PFGS_NORMAL3\fP
\f2alist\fP must be list of pfVec3 normals,
.TP
\f3\%PFGS_TEXCOORD2\fP
\f2alist\fP must be list of pfVec2 texture coordinates,
.TP
\f3\%PFGS_COORD3\fP
\f2alist\fP must be list of pfVec3 coordinates.
.RE
.TP
\f2bind\fP
is a symbolic token that specifies an attribute binding
type and is one of:
.RS
.TP 25
\f3\%PFGS_OFF\fP
\f2attr\fP is not specified and is thus inherited,
.TP
\f3\%PFGS_OVERALL\fP
\f2attr\fP is specified once for the entire pfGeoSet,
.TP
\f3\%PFGS_PER_PRIM\fP
\f2attr\fP is specified once per primitive,
.TP
\f3\%PFGS_PER_VERTEX\fP
\f2attr\fP is specified once per vertex.
.RE
.SH DESCRIPTION

The pfGeoSet (short for "Geometry Set") is a fundamental OpenGL
Performer data structure.  Each pfGeoSet is a collection of geometry
with one primitive type, such as points, lines, triangles.  Each
pfGeoSet also has a single combination of texture, normal, and
color attribute bindings, such as "untextured with colors per vertex
and normals per primitive".  A pfGeoSet forms primitives out of lists
of attributes which may or may not be indexed.  An indexed pfGeoSet
uses a list of unsigned shorts to index an attribute list.

Indexing provides a more general mechanism for specifying geometry than
hardwired attribute lists and also has the potential for substantial
memory savings due to shared attributes.  Nonindexed pfGeoSet's are
sometimes easier to construct and may save memory in situations where
vertex sharing is not possible since index lists are not required.
Nonindexed pfGeoSet's also require fewer CPU cycles to traverse and may
exhibit better caching behavior.  A pfGeoSet must be either completely
indexed or non-indexed; hybrid pfGeoSets that have some attributes
indexed and others non-indexed are not supported. For theses cases,
simply construct an identity-map index list and specify it with
each "non-indexed" pfGeoSet attribute array.

\f3\%pfNewGSet\fP creates and returns a handle to a pfGeoSet.  \f2arena\fP
specifies a malloc arena out of which the pfGeoSet is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfGeoSets can be
deleted with \f3\%pfDelete\fP.

.SS pfGeoSet Attributes

\f3\%pfGSetAttr\fP sets a pfGeoSet attribute
binding type, attribute list, and attribute index list. These pfGeoSet
attributes include vertex coordinate, color specification, normal vector,
texture coordinate, or packed attribute array which is supplied in list
form to the pfGeoSet.

The optional attribute index list is a list
of unsigned short integers which index the attribute list. The attribute
binding type specifies how the lists are interpreted to define geometry,
specifying for example, that the color attribute list provides a color for each
vertex (PFGS_PER_VERTEX) or just an overall color for the entire
pfGeoSet (PFGS_OVERALL).

\f3\%pfGeoSet\fP supports two multi-valued attributes: \f3\%PFGS_TEXCOORD2\fP and
\f3\%PFGS_TEXCOORD3\fP. A multi-valued attribute is an ordered set of regular
attributes. \f3\%pfGSetMultiAttr\fP sets a
\f3\%pfGeoSet\fP multi-valued attribute. It has an additional parameter \f2index\fP
identifying one of the ordered set of attributes. The available multi-valued
attributes enable specifying multiple texture coordinate arrays on a
\f3\%pfGeoSet\fP.  \f3\%pfGeoSet\fP uses these arrays on graphic hardware supporting
the OpenGL multi-texture extension.

\f2index\fP can be in the range 0 to (\f3\%PF_MAX_TEXTURES\fP-1). These value
correspond to hardware multi-texture units with the same indices. At run-time,
\f3\%pfGeoSet\fP rejects \f2index\fP values if the current hardware does not have
enough multi-texture units.  \f3\%pfGeoSet\fP recognizes all multi-value attributes
from (\f2index\fP == 0) to the first index with a NULL attribute. For example,
when setting the \f3\%PFGS_TEXCOORD2\fP multi-value attribute at index 0, 1, and 3,
\f3\%pfGeoSet\fP ignores the setting for (\f2index\fP == 3) because the attribute
with (\f2index\fP == 2) is NULL.

Calling \f3\%pfGSetAttr\fP with attribute
\f3\%PFGS_TEXCOORD2\fP and \f3\%PFGS_TEXCOORD3\fP is equivalent to calling
\f3\%pfGSetMultiAttr\fP on the same attributes with
(\f2index\fP == 0).

Only certain combinations of attributes and binding types make sense.
For example, vertices clearly must be specified per-vertex and the
utility of texture coordinates specified other than per-vertex is
questionable.

The following table shows the allowed combinations for the normal
attribute arrays:

.TS
center tab($) ;
c | c s s s
c | c s s s
c | cB cB cB cB
lB | c c c c .
Binding$Attribute Type
\^$_
\^$COLOR4$NORMAL3$TEXCOORD2$COORD3
_
PFGS_OFF$yes$yes$yes$no
PFGS_OVERALL$yes$yes$no$no
PFGS_PER_PRIM$yes$yes$no$no
PFGS_PER_VERTEX$yes$yes$yes$yes
.TE

In conjunction with specifying a vertex binding for a given vertex attributes,
packed attribute arrays may set with the \f3\%PFGS_PACKED_ATTRS\fP.
Packed attribute arrays must include all of the per-vertex data for the normal attributes
the single array, according to the packed attribute format that is set as the
\f3\%PFGS_PACKED_ATTRS\fP binding type. Only \f3\%PFGS_OFF\fP, \f3\%PFGS_OVERALL\fP and \f3\%PFGS_PER_VERTEX\fP
attribute bindings may be used for the normal vertex attributes when using the
packed attribute arrays. The format of the \f3\%PFGS_PACKED_ATTRS\fP may be one of:
.RS
.TP
\f3\%PFGS_PA_C4UBN3ST2FV3F\fP
the packed attribute array contains all currently bound per-vertex attributes,
including the vertex coordinates.  Colors must be packed into one unsigned byte with RGBA
byte ordering, normals must be shorts scaled to the range [-32767, 32767],
texture coordinates and vertex coordinates are floats.
Each attribute for each vertex must start on a 32-bit word boundary.
.TP
\f3\%PFGS_PA_C4UBN3ST2F\fP
the packed attribute array contains all currently bound per-vertex attributes, except
the vertex coordinates.  Colors must be packed into one unsigned byte with RGBA
byte ordering, normals must be shorts scaled to the range [-32767, 32767],
texture coordinates are floats.
The vertex coordinates will be taken from the normal vertex attribute array
specified with the \f3\%PFGS_COORD3\fP attribute.
Each attribute for each vertex must start on a 32-bit word boundary.
.TP
\f3\%PFGS_PA_C4UBT2F\fP
the packed attribute array contains colors as unsigned bytes and 2D
texture coordinates as floats. The vertex coordinates will be taken from the normal vertex attribute array
specified with the \f3\%PFGS_COORD3\fP attribute and normals will be taken
from the normal attribute array specified with \f3\%PFGS_NORMAL3\fP.
.TP
\f3\%PFGS_PA_C4UBN3ST2SV3F\fP, \f3\%PFGS_PA_C4UBN3ST2S\fP, \f3\%PFGS_PA_C4UBT2S\fP
the packed attribute array contains the specified currently bound
per-vertex attributes.
Colors are packed into unsigned bytes, normals are signed shorts in the
range [-32767, 32767] and texture coordinates are unsigned shorts
in the range [0, 65536].  A texture matrix should be used to rescale
the texture coordinates into the proper range.  A texture matrix can
be specified for a pfGeoSet through its pfGeoState.  See the
set \f3\%pfGStateAttr(3pf)\fP man page and the \f3\%PFSTATE_TEXMAT\fP attribute.
.TP
\f3\%PFGS_PA_C4UBN3ST3FV3F\fP, \f3\%PFGS_PA_C4UBN3ST3F\fP, \f3\%PFGS_PA_C4UBT3F\fP
the packed attribute array contains the specified currently bound
per-vertex attributes as above.  Texture coordinates are floats and
are 3D texture coordinates, specifying s, t, and r.
\f3\%PFGS_PA_C4UBN3ST3SV3F\fP, \f3\%PFGS_PA_C4UBN3ST3S\fP, \f3\%PFGS_PA_C4UBT3S\fP
the packed attribute array contains the specified currently bound
per-vertex attributes as above.  Texture coordinates are unsigned shorts and
are 3D texture coordinates, specifying s, t, and r.
.RE

When only using packed attribute arrays, you may specify a NULL for the redundant
attribute data arrays for the individual attributes, such as the colors, normals,,
and texture coordinates.  The normal vertex attribute arrays is required if intersections
are to be done with the pfGeoSet. For examples of using \f3\%PFGS_PACKED_ATTRS\fP,
see the example below, as well as the example in
\f3\%/usr/share/Performer/src/pguide/libpr/C/vertexarray.c\fP.
There are also utility routines in libpfutil for creating the packed attribute arrays; see
the \f3\%pfuTravCreatePackedAttrs\fP and \f3\%pfuFillGSetPackedAttrs\fP man pages
for more information.

An \f3\%OVERALL\fP binding requires an index list of length 1 for indexed
pfGeoSets.  The value of \f2bind\fP is unimportant for \f2attr\fP =
\f3\%PFGS_COORD3\fP since vertices are always specified on a per-vertex
basis.  Default bindings are OFF for all attributes except coordinates.

\f2ilist\fP, if not NULL, is an index array which indexes the attribute
array, \f2alist\fP.  If \f2ilist\fP is NULL, the pfGeoSet is non-indexed and
accesses the attribute list in sequential order.

If any attribute's binding is not \f3\%PFGS_OFF\fP and the corresponding
\f2ilist\fP is defined as NULL, the pfGeoSet is considered to be
non-indexed and ALL other specified index lists will be ignored.
Nonindexed interpretation of an attribute list is equivalent to using
an index list whose elements are 0,1,2,...,N-1.  Consequently it is
possible to emulate a pfGeoSet with mixed indexed and non-indexed
attributes by using an index array whose elements are 0,1,2,...,N-1
with N being the largest possible index.

If attribute and index lists are allocated from the \f3\%pfMalloc\fP
routines, \f3\%pfGSetAttr\fP will correctly
update the reference counts of the lists.  Specifically,
\f3\%pfGSetAttr\fP will decrement the reference
counts of the old lists and increment the reference counts of the new
lists.  It will not free any lists whose reference counts reach 0.
When a pfGeoSet is deleted with \f3\%pfDelete\fP, all pfMalloc'ed lists
will have their reference counts decremented by one and will be freed
if their count reaches 0.

When pfGeoSets are copied with \f3\%pfCopy\fP, all pfMalloc'ed lists of the
source pfGeoSet will have their reference counts incremented by one and
those pfMalloc'ed lists of the destination pfGeoSet will have their
reference counts decremented by one.  \f3\%pfCopy\fP copies lists only by
reference (only the pointer is copied) and will not free any lists
whose reference counts reach 0.

Attribute lists may be any of the following types of memory:
.RS
.TP 5
1.
Data allocated with \f3\%pfMalloc\fP. This is the usual, and recommended
memory type for pfGeoSet index and attribute arrays.
.TP
2.
Static, malloc(), amalloc(), usmalloc() etc, data subsequently referred to
as non-pfMalloc'ed data.
This type of memory is not generally recommended since it does not
support reference counting or other features provided by \f3\%pfMalloc\fP.
In particular, the use of static data is highly discouraged and may
result in segmentation violations.
.TP
3.
pfFlux memory.  In a pipelined, multiprocessing environment,
a pfFlux provides multiple data buffers which allow frame-accurate
data modifications to pfGeoSet attribute arrays like coordinates
(facial animation), and texture coordinates (ocean waves, surf).
\f3\%pfGSetAttr\fP will accept a pfFlux*
or pfFluxMemory* for the attribute list
(index lists do not support pfFlux) and the pfGeoSet
will select the appropriate buffer when rendered or intersected with.
See pfFlux for more details.
.TP
4.
pfCycleBuffer and pfCycleMemory.  However pfCycleBuffer has been obsoleted
by pfFlux.  See pfCycleBuffer for more details.
.RE

Performer allows mixing pfMalloc'ed, pfFlux and pfCycleBuffer attributes on
a single \f3\%pfGeoSet\fP.

\f3\%pfGetGSetAttrBind\fP returns the binding type of \f2attr\fP and
\f3\%pfGetGSetAttrLists\fP returns the attribute and index list base
pointers. If the gset is non-indexed, send down a dummy ushort pointer instead of NULL as ilist.

Similarly, \f3\%pfGetGSetMultiAttrBind\fP
returns the binding type of \f2attr\fP at the \f2index\fP'th position, and
\f3\%pfGetGSetMultiAttrLists\fP returns the
attribute and index list base pointers at the \f2index\fP'th position.

\f3\%pfGetGSetAttrRange\fP returns the range of attributes in the
attribute list identified by \f2attr\fP that are used by \f2gset\fP.
(The total size, in bytes, of the list may be queried through
\f3\%pfGetSize\fP if the list was allocated by \f3\%pfMalloc\fP.)
If the list is non-indexed,
\f3\%pfGetGSetAttrRange\fP returns the number of contiguous attributes
accessed by \f2gset\fP (the range implicitly beginning at 0).
If the list is indexed, \f3\%pfGetGSetAttrRange\fP
returns the same value as in the non-indexed case but also copies
the minimum and maximum indices into \f2minIndex\fP and \f2maxIndex\fP.
If the attribute list is non-indexed, or the attribute binding type is
\f3\%PFGSS_OFF\fP, 0 and -1 are returned in \f2minIndex\fP and \f2maxIndex\fP.
\f3\%NULL\fP may be passed instead of \f2minIndex\fP and/or \f2maxIndex\fP
when the min/max index is not required.

\f3\%pfGetGSetAttrRange\fP is typically used to allocate a new attribute
array when cloning a pfGeoSet:
.Ex
.nf

int numVerts = pfGetGSetAttrRange(gset, PFGS_COORD3, NULL, &max);
numVerts = PF_MAX2(numVerts, max + 1);
newVerts = (pfVec3*) pfMalloc(sizeof(pfVec3) * numVerts, arena);
.Ee
.fi
.na


Similarly, \f3\%pfGetGSetMultiAttrRange\fP
returns the range of attributes in the attribute list identified by \f2attr\fP
for a multi-valued attribute at position \f2index\fP.

.SS pfGeoSet Primitive Types

\f3\%pfGSetPrimType\fP specifies the type of primitives found in a
pfGeoSet.  \f2type\fP is a symbolic token and is one of:

.RS
\f3\%PFGS_POINTS\fP
.br
\f3\%PFGS_LINES\fP
.br
\f3\%PFGS_LINESTRIPS\fP
.br
\f3\%PFGS_FLAT_LINESTRIPS\fP
.br
\f3\%PFGS_TRIS\fP
.br
\f3\%PFGS_QUADS\fP
.br
\f3\%PFGS_TRISTRIPS\fP
.br
\f3\%PFGS_FLAT_TRISTRIPS\fP
.br
\f3\%PFGS_TRIFANS\fP
.br
\f3\%PFGS_FLAT_TRIFANS\fP
.br
\f3\%PFGS_POLYS\fP
.RE

The primitive type dictates how the coordinate and coordinate index
lists are interpreted to form geometry.  See below for a description of
primitive types.  \f3\%pfGetGSetPrimType\fP returns the primitive type of
\f2gset\fP.

\f3\%pfGSetNumPrims\fP and \f3\%pfGetGSetNumPrims\fP sets/gets the number of
primitives in \f2gset\fP.  A primitive is a single point, line segment,
line strip, triangle, quad, triangle strip, or polygon depending on the
primitive type.

A single line strip, triangle strip, or polygon is considered to be a
primitive so a pfGeoSet may contain multiple strips of differing
lengths or multiple polygons with differing number of sides.
Therefore, for strip primitives and \f3\%PFGS_POLYS\fP, a separate array
is necessary which specifies the number of vertices in each strip or
polygon.  This array is set by
\f3\%pfGSetPrimLengths\fP.  \f2lengths\fP
is an array of vertex counts such that lengths[0] = number of vertices
in strip/polygon 0, lengths[1] = number of vertices in strip/polygon
1,..., lengths[n-1] = number of vertices in strip/polygon n-1 where n
is the number of primitives set by
\f3\%pfGSetNumPrims\fP.
\f3\%pfGetGSetPrimLengths\fP returns a
pointer to the lengths array of \f2gset\fP.
\f3\%pfGetGSetPrimLength\fP
returns the positive length for the \f2i\fPth primitive of the pfGeoSet.

As of OpenGL Performer 2.2, the negative of the proper length may be
specified for an individual length of a strip prmitive in the lengths array
to indicate that this pfGeoSet primitive should be "hidden" from drawing.
The primitive will however be counted in drawing statistics (\f3\%pfStats\fP) and will
be used in intersections and bounding box computations and all other
pfGeoSet processing.
\f3\%pfHideGSetStripPrim\fP
will force the length of the \f2i\fP'th primitive of a stripped pfGeoSet
to be the negative of its proper length;
\f3\%pfUnhideGSetStripPrim\fP
will set the primitive length to be the positive value.
\f3\%pfisGSetStripPrimHidden\fP will return 1 if
the \f2i\fPth primitive of the pfGeoSet is negative and 0 otherwise.
\f3\%pfGetGSetPrimLength\fP
always returns a positive length for the \f2i\fPth primitive of the pfGeoSet
and can be used wherever the lengths of pfGeoSets of unknown source must be
inspected to protect against negative values in the lengths array.


Assuming the coordinate index list is an array V indexed by i, \f2num\fP
is the number of primitives, \f2lengths\fP is the array of strip or polygon
lengths and Nv the size of the coordinate index list, the primitive type
interprets V in the following ways:
.RS
.TP 5
\f3\%PFGS_POINTS\fP
The pfGeoSet is a set of \f2num\fP points.
Each V[i] is a point, i = 0, 1, 2, ..., \f2num\fP-1.
Nv = \f2num\fP.
.TP
\f3\%PFGS_LINES\fP
The pfGeoSet is a set of \f2num\fP disconnected line segments.
Each line segment is drawn from V[i] to V[i+1], i = 0, 2, ..., 2*(\f2num\fP-1).
Nv = 2 * \f2num\fP.
.TP
\f3\%PFGS_LINESTRIPS\fP
The pfGeoSet is a set of \f2num\fP line strips (also known as polylines).
Linestrip[i] is drawn between
V[p+j], j = 0, 1, ..., \f2lengths\fP[i]-1,
where p is sum of all
\f2lengths\fP[k], 0 <= k < i.
Nv = sum of all \f2lengths\fP[k], k = 0, 1, ..., \f2num\fP-1.
Note that all \f2lengths\fP[i] values should be >= 2.
.TP
\f3\%PFGS_FLAT_LINESTRIPS\fP
The pfGeoSet is a set of \f2num\fP line strips (also known as polylines).
Linestrip[i] is drawn between
V[p+j], j = 0, 1, ..., \f2lengths\fP[i]-1,
where p is sum of all
\f2lengths\fP[k], 0 <= k < i.
Nv = sum of all \f2lengths\fP[k], k = 0, 1, ..., \f2num\fP-1.
Note that all \f2lengths\fP[i] value should be >= 2.
.TP
\f3\%PFGS_TRIS\fP
The pfGeoSet is a set of \f2num\fP independent triangles.
Each triangle is V[i], V[i+1], V[i+2], i = 0, 3, 6, ..., 3*(\f2num\fP-1).
Nv = 3 * \f2num\fP.
.TP
\f3\%PFGS_QUADS\fP
The pfGeoSet is a set of \f2num\fP independent quads.
Each quad is V[i], V[i+1], V[i+2], V[i+3], i = 0, 4, 8, ..., 4*(\f2num\fP-1).
Nv = 4 * \f2num\fP.
.TP
\f3\%PFGS_TRISTRIPS\fP
The pfGeoSet is a set of \f2num\fP triangle strips.
Tristrip[i] is drawn between V[p+j], j = 0, 1, ..., \f2lengths\fP[i]-1,
where p is sum of all
\f2lengths\fP[k], 0 <= k < i.
Nv = sum of all \f2lengths\fP[k], k = 0, 1, ..., \f2num\fP-1.
Note that all \f2lengths\fP[i] values should be >= 3.
.TP
\f3\%PFGS_FLAT_TRISTRIPS\fP
The pfGeoSet is a set of \f2num\fP triangle strips.
Tristrip[i] is drawn between V[p+j], j = 0, 1, ..., \f2lengths\fP[i]-1,
where p is sum of all \f2lengths\fP[k], 0 <= k < i.
Nv = sum of all \f2lengths\fP[k], k = 0, 1, ..., \f2num\fP-1.
Note that all \f2lengths\fP[i] should be >= 3.
The FLAT indicates that the strips should be flat shaded and
that additional attributes for the first two vertices are not
specified.
.TP
\f3\%PFGS_TRIFANS\fP
The pfGeoSet is a set of \f2num\fP triangle fans.
Each trifan[i] is a set of \f2lengths\fP[i] triangles.
The fan starts with the center vertex V[0], with the remaining
\f2lengths\fP[i]-1 vertices specifying the outside points.
.TP
\f3\%PFGS_FLAT_TRIFANS\fP
The pfGeoSet is a set of \f2num\fP triangle fans.
Each trifan[i] is a set of \f2lengths\fP[i] triangles.
The fan starts with the center vertex V[0], with the remaining
\f2lengths\fP[i]-1 vertices specifying the outside points.
The FLAT indicates that the strips should be flat shaded and
that additional attributes for the first two vertices are not
specified.
.TP
\f3\%PFGS_POLYS\fP
The pfGeoSet is a set of \f2num\fP polygons.
Polygon[i] is the convex hull of the vertices V[p+j], j = 0, 1, ..., \f2lengths\fP[i]-1
where p is sum of all
\f2lengths\fP[k], 0 <= k < i.
Nv = sum of all \f2lengths\fP[k], k = 0, 1, ..., \f2num\fP-1.
Note that all \f2lengths\fP[i] should be >= 3.
.RE

\f3\%PFGS_TRIS\fP, \f3\%PFGS_QUADS\fP, \f3\%PFGS_TRISTRIPS\fP, \f3\%PFGS_FLAT_TRISTRIPS\fP,
and \f3\%PFGS_POLYS\fP
are rendered as filled polygons but will be rendered in wire-frame
according to the following rules:
.RS
.TP 5
1.
Always render in wireframe mode if \f3\%PFEN_WIREFRAME\fP mode
is enabled through \f3\%pfGSetDrawMode\fP.
.TP
2.
Use the wireframe mode set by the attached pfGeoState, if any, as
described in \f3\%pfGSetGState\fP below.
.TP
3.
Use the wireframe mode set by \f3\%pfEnable\fP or \f3\%pfDisable\fP with the
\f3\%PFEN_WIREFRAME\fP argument.
.RE

A \f3\%PFGS_PER_VERTEX\fP binding for \f3\%PFGS_COLOR4\fP and \f3\%PFGS_NORMAL3\fP
is interpreted differently for \f3\%PFGS_FLAT_LINESTRIPS\fP and
\f3\%PFGS_FLAT_TRISTRIPS\fP primitive types.  With flat-shaded strip
primitives, only the last vertex in each primitive defines the shading
of the primitive (see \f3\%pfShadeModel\fP.) Thus the first vertex in a
FLAT_LINESTRIP and the first two vertices in a FLAT_TRISTRIP do not
require normals or colors.  Consequently when specifying a
\f3\%PFGS_PER_VERTEX\fP binding for either colors or normals, you should
not specify a color or normal for the first vertex of a line strip or
for the first 2 vertices of a triangle strip. \f3\%pfDrawGSet\fP
will automatically set the shading model to \f3\%FLAT\fP
before rendering \f3\%PFGS_FLAT_\fP primitives.

Example 1:
.Ex
.nf

/* Set up a non-indexed, FLAT_TRISTRIP pfGeoSet */
gset = pfNewGSet(NULL);
pfGSetPrimType(gset, PFGS_FLAT_TRISTRIPS);
pfGSetNumPrims(gset, 2);
lengths[0] = 4;
lengths[1] = 3;
pfGSetPrimLengths(gset, lengths);

/* Only need 3 colors: 2 for 1st strip and 1 for 2nd */
colors = (pfVec4*) pfMalloc(sizeof(pfVec4) * 3, NULL);

pfGSetAttr(gset, PFGS_COLOR4, PFGS_PER_VERTEX, colors, NULL);
pfGSetAttr(gset, PFGS_COORD3, PFGS_PER_VERTEX, coords, NULL);
.Ee
.fi
.na



.SS pfGeoSet Special Rendering Characteristics

When colortable mode is enabled, either through \f3\%pfEnable\fP or through
\f3\%pfApplyGState\fP, a pfGeoSet will not use its local color array but
will use the color array supplied by the currently active pfColortable
(See the \f3\%pfColortable\fP and \f3\%pfEnable\fP manual pages). pfColortables
will affect both indexed and non-indexed pfGeoSets.

A pfGeoSet of type \f3\%PFGS_POINTS\fP will be rendered with the special
characteristics of light points if a pfLPointState has been applied.
Light point features include:

.RS
.TP 3
1. Perspective size.
.TP
2. Perspective fading.
.TP
3. Fog punch-through.
.TP
4. Directionality.
.TP
5. Intensity.
.RE

See pfLPointState for more details.

\f3\%pfGSetPntSize\fP and \f3\%pfGSetLineWidth\fP set the point size and line
width of \f2gset\fP.  Point size has effect only when the primitive type is
\f3\%PFGS_POINTS\fP and line width is used only for primitive types
\f3\%PFGS_LINES\fP, \f3\%PFGS_LINESTRIPS\fP, \f3\%PFGS_FLAT_LINESTRIPS\fP and for
all primitives drawn in wireframe mode.  A pfGeoSet sets point size and
line width immediately before rendering only if the size/width is greater
than zero. Otherwise it will inherit size/width through the Graphics Library.

\f3\%pfGetGSetPntSize\fP and \f3\%pfGetGSetLineWidth\fP return \f2gset\fP's point
size and line width respectively.

\f3\%pfGSetDrawMode\fP further characterizes a pfGeoSet's primitive type as
flat-shaded, wireframe or compiled.  \f2mode\fP is a symbolic token
specifying the mode to set and is one of:
.RS
.TP 25
\f3\%PFGS_FLATSHADE\fP
Always render \f2gset\fP with a flat shading model.
.TP
\f3\%PFGS_WIREFRAME\fP
Always render and intersect \f2gset\fP in wireframe. For rendering in wireframe
and intersection with solid geometry, enable wireframe on an attached
pfGeoState (See \f3\%pfGSetGState\fP).
.TP
\f3\%PFGS_COMPILE_GL\fP
At the next draw for each pfState, compile \f2gset\fP's geometry into a
GL display list and subsequently render the display list.
.TP
\f3\%PFGS_DRAW_GLOBJ\fP
Select the rendering of an already created display list and
do not force a compile.
.TP
\f3\%PFGS_PACKED_ATTRS\fP
Use the  \f2gset\fP's packed attribute arrays, set with the
\f3\%PFGS_PACKED_ATTRS\fP to \f3\%pfGSetAttr\fP,
to render geometry with GL vertex arrays.
This mode is only available under OpenGL operation.
.RE

\f2val\fP is \f3\%PF_ON\fP or \f3\%PF_OFF\fP to enable/disable the mode.

If a pfGeoSet has very few primitives, the CPU overhead in
\f3\%pfDrawGSet\fP may become noticeable.  In this situation, it is
reasonable to compile the pfGeoSet into a GL display list which has
very little CPU overhead.  However, GL display lists have several
drawbacks that must be considered:
.RS
.TP 5
Storage
GL display lists will increase memory usage because every vertex,
color, etc is copied into the display list, thus duplicating the
pfGeoSet's attribute arrays.  Additionally, GL display lists cannot
index and so do not benefit from vertex sharing.

While it is possible to delete the attribute arrays after the pfGeoSet
has been compiled to free up some memory, it will no longer be
possible to intersect with the pfGeoSet's geometry (see
\f3\%pfGSetIsectSegs\fP).

.TP
Flexibility
Once in a GL display list, attributes like coordinates and normals may
not be modified.  This precludes dynamic geometry like water and facial
animation.
.TP
Coherency
If any attribute of the pfGeoSet changes then the burden is on the user
to regenerate the GL display list through \f3\%pfGSetDrawMode\fP.
.RE

In summary, applications with many very small pfGeoSets each of which
defines static unchanging geometry may be suitable for pfGeoSet
compilation into GL display lists.

The mechanism of \f3\%PFGS_COMPILE_GL\fP is illustrated in the
following example:
.Ex
.nf

/* We assume 'gset' is already "built" by this point */

/* Enable GL display list compilation and rendering */
pfGSetDrawMode(gset, PFGS_COMPILE_GL, PF_ON);

/*
 * The first pfDrawGSet after pfGSetDrawMode will compile
 * the pfGeoSet into a GL display list.  Note that this is
 * a very slow procedure and is generally done at
 * initialization time.
 */
pfDrawGSet(gset);
 :
/* This time we draw the GL display list */
pfDrawGSet(gset);
 :
/* Disable GL display list mode */
pfGSetDrawMode(gset, PFGS_COMPILE_GL, PF_OFF);

/* Free the GL display list and render 'gset' in immediate mode */
pfDrawGSet(gset);
.Ee
.fi
.na


Deciding which shading model to used when draw a pfGeoSet is
performed with the following decision hierarchy:
.RS
.TP 5
1.
Use flat shading if pfGeoSet consists of either
\f3\%PFGS_FLAT_TRISTRIPS\fP or \f3\%PFGS_FLAT_LINESTRIPS\fP or if the mode
\f3\%PFGS_FLATSHADE\fP is enabled with \f3\%pfGSetDrawMode\fP.
.TP
2.
Use the shading model specified by the pfGeoState bound to the
pfGeoSet.  This is the typical case in OpenGL Performer.  See the
\f3\%pfGSetGState\fP description below for further details.
.TP
3.
Use the shading model set by \f3\%pfShadeModel\fP.
.RE

\f3\%pfGetGSetDrawMode\fP returns the value
of \f2mode\fP or -1 if \f2mode\fP is an unknown mode.

.SS pfGeoSets (Geometry) and pfGeoStates (Appearance)

A pfGeoState is an encapsulation of libpr graphics modes and attributes
(see \f3\%pfState\fP).  For example, a pfGeoState representing a glass
surface may reference a shiny pfMaterial and enable transparency.  A
pfGeoState does not inherit state from other pfGeoStates.
Consequently, when attached to a pfGeoSet via
\f3\%pfGSetGState\fP, \f2gset\fP will always be rendered with the state encapsulated by
\f2gstate\fP, regardless of the order in which pfGeoSet/pfGeoState pairs
are rendered.  This behavior greatly eases the burden of managing
graphics state in the graphics library. A pfGeoSet may directly
reference or indirectly index a pfGeoState through a global table.

\f3\%pfGSetGState\fP "attaches" \f2gstate\fP to
\f2gset\fP so that \f2gset\fP may
be drawn with a certain graphics state.  When drawn by
\f3\%pfDrawGSet\fP, a pfGeoSet will apply its
pfGeoState (if it has one) with
\f3\%pfApplyGState\fP and the graphics library
will be initialized to the proper state for drawing \f2gset\fP.  A \f2gstate\fP value of \f3\%NULL\fP will remove any previous
pfGeoState and cause \f2gset\fP to inherit whatever
graphics state is around at the time of rendering.

\f3\%pfGSetGStateIndex\fP allows a
pfGeoSet to index its pfGeoState.  Indexing is useful for efficiently
managing a single database with multiple appearances, e.g., a normal
vs. an infrared view of a scene would utilize 2 pfGeoState tables, each
referencing a different set of pfGeoStates.

Indexed pfGeoStates use a global table of pfGeoState* specified by
\f3\%pfApplyGStateTable\fP.  When indexing a
pfGeoState, \f3\%pfDrawGSet\fP calls
\f3\%pfApplyGState\fP with the \f2index\fPth entry
of this table if the index can be properly resolved. Otherwise no
pfGeoState is applied.
\f3\%pfGetGSetGStateIndex\fP returns the
pfGeoState index of \f2gset\fP or -1 if
\f2gset\fP directly references its pfGeoState.

\f3\%pfGSetGState\fP increments the reference
count of the new pfGeoState by one and decrements the reference count
of the previous pfGeoState by one but does not delete the previous
pfGeoState if its reference count reaches zero.
\f3\%pfGSetGStateIndex\fP does not affect
pfGeoState reference counts.

It is important to understand and remember that any pfGeoSet without an
associated pfGeoState will \f3\%not\fP be rendered with the global, default
state but will be drawn with the current state.  To inherit the global
state, a pfGeoState which inherits all state elements should be
attached to the pfGeoSet. pfGeoSets should share like pfGeoStates for
space and rendering time savings.  See the \f3\%pfGeoState\fP reference
page for full details.

\f3\%pfGetGSetGState\fP returns the pfGeoState
associated with \f2gset\fP or \f3\%NULL\fP if there is
none. If \f2gset\fP indexes its pfGeoState,
\f3\%pfGetGSetGState\fP will look up the
pfGeoState index in the global pfGeoState table and return the result
or \f3\%NULL\fP if it cannot resolve the reference.


\f3\%pfGSetDecalPlane\fP sets \f2plane\fP
to be the reference plane used for the \f2gset\fP
when the current decal mode has \f3\%PFDECAL_PLANE\fP selected.
Setting a decal plane on a pfGeoSet (as opposed to a pfGeoState) may
add a small amount of overhead to the drawing of that pfGeoSet which may
be visible for small pfGeoSets.  However, this may be preferable to
breaking up pfGeoStates for handling many different reference planes.
Reference planes are only supported under OpenGL
operation and require the reference_plane SGI extension to the OpenGL.
The \f3\%PFQFTR_DECAL_PLANE\fP to \f3\%pfQueryFeature\fP can be used for run-time
queries for the support of decal reference planes.
See the \f3\%pfDecal\fP man page for more information.

\f3\%pfGSetHlight\fP sets \f2hlight\fP to be the
highlighting structure used for \f2gset\fP.  When
this flag is not \f3\%PFHL_OFF\fP, this gset will be drawn as highlighted
unless highlighting has been overridden as off with \f3\%pfOverride\fP.
See the \f3\%pfHighlight\fP manual page for information of creating and
configuring a highlighting state structure.
\f3\%pfGetGSetHlight\fP returns the current
GeoSet highlight definition.

\f3\%pfDrawHlightedGSet\fP is a
convenience routine for drawing ONLY the highlighting stage of
\f2gset\fP, according to the currently active
highlighting structure.

.SS Drawing pfGeoSets

\f3\%pfDrawGSet\fP is a display-listable command.
If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfDrawGSet\fP will not have immediate effect
but will be captured by the pfDispList and will only have effect when
that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

If \f2gset\fP has an attached pfGeoState, then
\f3\%pfDrawGSet\fP first calls
\f3\%pfApplyGState\fP before rendering the
pfGeoSet geometry, as shown in the following examples.

Example 3a:
.Ex
.nf

/* Make sure 'gset' has not attached pfGeoState */
pfGSetGState(gset, NULL);

/* Apply graphics state encapsulated by 'gstate' */
pfApplyGState(gstate);

/* Draw 'gset' with graphics state encapsulated by 'gstate' */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 3b:
.Ex
.nf

/* Attach 'gstate' to 'gset' */
pfGSetGState(gset, gstate);

/* Draw 'gset' with graphics state encapsulated by 'gstate' */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 3c:
.Ex
.nf

/* Use indexed pfGeoState */
pfGSetGStateIndex(gset, 2);

/* Set up and apply pfGeoState table */
pfSet(list, 2, gstate);
pfApplyGStateTable(list);

/* Draw 'gset' with graphics state encapsulated by 'gstate' */
pfDrawGSet(gset);
.Ee
.fi
.na


Examples 3a, 3b, and 3c are equivalent methods for drawing the same thing.
Method 3b is recommended though since the pfGeoState and pfGeoSet
pair can be set up at database initialization time.

\f3\%pfGSetDrawBin\fP sets \f2gset\fP's draw bin identifier to \f2bin\fP.  \f2bin\fP identifies a
drawing bin to which \f2gset\fP belongs and is used
for controlling the rendering order of a database.  The pfGeoSet draw
bin is currently used only by \f3\%libpf\fP applications (see
\f3\%pfChanBinOrder\fP) and is ignored by
\f3\%libpr\fP-only applications. The default pfGeoSet draw bin identifier
is -1. \f3\%pfGetGSetDrawBin\fP returns the draw bin
identifier of \f2gset\fP.

\f3\%pfGSetDrawOrder\fP sets
\f2gset\fP's \f2order\fP in the bin if the bin sort
order is PFSORT_DRAW_ORDER.  It is necessary to set the Draw Order of
each \f2gset\fP that contains calligraphic light points
(see pfCalligraphic man pages). Do not set the DrawBin for those
\f2gset\fPs, as they will automatically go in the light
point display list if a LPoint Process has been started.

The \f2mask\fP argument to
\f3\%pfGSetPassFilter\fP is a bitmask which
specifies a pfGeoSet drawing "filter". Only pfGeoSets which pass the
filter test are rendered by \f3\%pfDrawGSet\fP.
\f2mask\fP consists of the logical OR of the following:

.RS
.TP 5
\f3\%PFGS_TEX_GSET\fP
Draw only textured pfGeoSets
.TP
\f3\%PFGS_NONTEX_GSET\fP
Draw only non-textured pfGeoSets
.TP
\f3\%PFGS_EMISSIVE_GSET\fP
Draw only pfGeoSets which use an emissive
pfMaterial or pfLPointState.
.TP
\f3\%PFGS_NONEMISSIVE_GSET\fP
Draw only non-emissive pfGeoSets
.TP
\f3\%PFGS_LAYER_GSET\fP
Draw only pfGeoSets which are layer (as opposed to base) geometry.
.TP
\f3\%PFGS_NONLAYER_GSET\fP
Draw only pfGeoSets which are not layer geometry.
.RE

A \f2mask\fP of 0 disables pfGeoSet filtering. Filtering is useful for
multipass rendering techniques.
\f3\%pfGetGSetPassFilter\fP returns the
current pfGeoSet filtering mask.

\f3\%pfCompileGSet\fP will force the immediate creation
of a GL display list for the pfGeoSet in the current graphics context but will
not draw or select display list renderin for the pfGeoSet.  This routine is
usefull for the preprocessing of pfGeoSets, possibly in a sproced non-rendering
process for OpenGL, for future GL display list rendering.
Since \f3\%pfCompileGSet\fP does not execute the pfGeoSet
display list, the display list will not affect or be downloaded to
the graphics pipeline.
\f3\%pfCompileGSet\fP is not a display-listable command.

.SS Intersecting with pfGeoSets

\f3\%pfGSetIsectMask\fP enables
intersections and sets the intersection mask for \f2gset\fP.  \f2mask\fP is a 32-bit mask used to determine whether a
particular pfGeoSet should be examined during a particular intersection
request.  A non-zero bit-wise AND of the pfGeoSet's mask with the mask
of the intersection request
(\f3\%pfGSetIsectSegs\fP) indicates that the
pfGeoSet should be tested.  The default mask is all 1's, i.e.
0xffffffff.

\f3\%pfGetGSetIsectMask\fP returns the
intersection mask of the specified pfGeoSet.

Intersections for geometry whose vertex coordinates don't change are
more efficient when information is cached for each pfGeoSet to be
intersected with.  When setting the mask or changing caching,
\f3\%PFTRAV_SELF\fP should always be part of \f2setMode\fP.  OR-ing
\f3\%PFTRAV_IS_CACHE\fP into \f2setMode\fP causes the creation or update of
the cache.  Because creating the cache requires a moderate amount of
computation, it is best done at setup time.

For objects whose geometry changes only occasionally, additional calls
to \f3\%pfGSetIsectMask\fP with
\f3\%PFTRAV_IS_CACHE\fP OR-ed into \f2setMode\fP will recompute the cached
information.  Alternately, OR-ing \f3\%PFTRAV_IS_UNCACHE\fP into
\f2setMode\fP will disable caching.

The \f2bitOp\fP argument is one of \f3\%PF_AND\fP, \f3\%PF_OR\fP, or \f3\%PF_SET\fP
and indicates, respectively, whether the new mask is derived from
AND-ing with the old mask, OR-ing with the old mask or simply set.

\f3\%pfGSetBBox\fP sets the bounding volume of
\f2gset\fP.  Each pfGeoSet has an associated
bounding volume used for culling and intersection testing and a
bounding mode, either static or dynamic.  By definition, the bounding
volume of a node encloses all the geometry parented by node, which
means that the node and all its children fit within the node's bounding
volume.

The \f2mode\fP argument to \f3\%pfGSetBBox\fP
specifies whether or not the bounding volume for \f2node\fP should be
recomputed when an attribute of \f2gset\fP is
changed.  If the mode is \f3\%PFBOUND_STATIC\fP, OpenGL Performer will not
modify the bound once it is set or computed.  If the mode is
\f3\%PFBOUND_DYNAMIC\fP, OpenGL Performer will recompute the bound if the
number of primitives, the primitive lengths array or the vertex
coordinate arrays are changed.  Note that OpenGL Performer does not know
if the contents of these arrays changes, only when the pointer itself
is set.  Recomputation of the bounding box can be forced by calling
\f3\%pfGSetBBox\fP with a \f2bbox\fP that is
\f3\%NULL\fP. Also note that a geoset can not update the parent geode with
this new bounding volume information, as a result, a geoset will not
propagate new bounding information up the tree.
Call \f3\%pfNodeBSphere\fP on
the parent Geode to recompute the bounding volume.

\f3\%pfGetGSetBBox\fP copies the bounding box of
\f2gset\fP into \f2bbox\fP and returns the current
bounding mode.

\f3\%pfGSetBBoxFlux\fP and
\f3\%pfGetGSetBBoxFlux\fP set and get a pfFlux
that can be used to contain the bounding box of a pfGeoSet.

\f3\%pfGSetIsectSegs\fP tests for intersection
between the pfGeoSet \f2gset\fP and the group of
line segments specified in \f2segSet\fP. The resulting intersections (if
any) are returned in \f2hits\fP.  The return value of
\f3\%pfGSetIsectSegs\fP is the number of segments
that intersected the pfGeoSet.

\f2hits\fP is an empty array supplied by the user through which results
are returned.  The array must have an entry for each segment in
\f2segSet\fP.  Upon return, \f2hits\fP[i][0] is a pfHit* which gives the
intersection result for the \f2i\fPth segment in \f2segSet\fP.  The pfHit
objects come from an internally maintained pool and are reused on
subsequent requests.  Hence, the contents are only valid until the
next invocation of \f3\%pfGSetIsectSegs\fP in the current process.  They
should not be freed by the application.

\f2segSet\fP is a pfSegSet public structure specifying the intersection
request.  In the structure, \f2segs\fP is an array of line segments to
be intersected against the pfGeoSet.  \f2activeMask\fP is a bit vector
specifying which segments in the SegSet are to be active for the
current request.  If the i'th bit is set to 1, it indicates the
corresponding segment in the \f2segs\fP array is active.

The bit vector \f2mode\fP specifies the behavior of the intersection
process and is a bitwise OR of the following:
.RS
.TP 30
\f3\%PFTRAV_IS_PRIM\fP
Intersect with primitives (quads or triangles)
.TP
\f3\%PFTRAV_IS_GSET\fP
Intersect with pfGeoSet bounding boxes
.TP
\f3\%PFTRAV_IS_NORM\fP
Return normal in the pfHit structure
.TP
\f3\%PFTRAV_IS_CULL_BACK\fP
Ignore backfacing polygons
.TP
\f3\%PFTRAV_IS_CULL_FRONT\fP
Ignore front-facing polygons
.RE

The bit fields \f3\%PFTRAV_IS_PRIM\fP and \f3\%PFTRAV_IS_GSET\fP, indicate the
level at which intersections should be evaluated and discriminator
callbacks, if any, invoked.  Note that if neither of these level
selectors are specified, no intersection testing is done at all.  In
the pfSegSet, \f2isectMask\fP is another bit vector.  It is bit-wise
AND-ed with the intersection mask of the pfGeoSet.  If the result is
zero no intersection testing is done.

The \f2bound\fP field in a pfSegSet is an optional user provided bounding
volume around the set of segments.  Currently, the only supported
volume is a cylinder.  To use a bounding cylinder, bitwise OR
\f3\%PFTRAV_IS_BCYL\fP into the \f2mode\fP field of the pfSegSet and assign
the pointer to the bounding volume to the \f2bound\fP field.
\f3\%pfCylAroundSegs\fP will construct a
cylinder around the segments.

When a bounding volume is supplied, the bounding volume is tested
against the pfGeoSet bounding box before examining the individual
segments.  The largest improvement is for groups of at least several
segments which are closely grouped segments.  Placing a bounding
cylinder around small groups or widely dispersed segments can decrease
performance.

The \f2userData\fP pointer allows an application to associate other data
with the pfSegSet.  Upon return and in discriminator callbacks, the
pfSegSet's \f2userData\fP pointer can be obtained from the returned
pfHit with \f3\%pfGetUserData\fP.

\f2discFunc\fP is a user supplied callback function which provides a more
powerful means for controlling intersections than the simple mask
test.  The function acts as a discriminating function which examines
information about candidate intersections and judges their validity.
When a candidate intersection occurs, the \f2discFunc\fP callback is
invoked with a pfHit structure containing information about the
intersection.

The callback may then return a value which indicates whether and how
the intersection should continue.  This value is composed of the following
major action specifications with additional modifiers bitwise-OR-ed in
as explained below.
.RS
.TP 5
\f3\%PFTRAV_CONT\fP
Indicates that the process should continue traversing the primitive list.
.TP
\f3\%PFTRAV_PRUNE\fP
Stops further testing of the line segment against the current pfGeoSet.
.TP
\f3\%PFTRAV_TERM\fP
Stops further testing of the line segment completely.
.RE

To have \f3\%PFTRAV_TERM\fP or \f3\%PFTRAV_PRUNE\fP apply to all segments,
\f3\%PFTRAV_IS_ALL_SEGS\fP can be OR-ed into the discriminator return
value.  This causes the entire traversal to be terminated or pruned.

The callback may OR into the status return value any of:
.RS
.TP 5
\f3\%PFTRAV_IS_IGNORE\fP
Indicates that the current intersection should be ignored, otherwise the
intersection is taken as valid.
.TP
\f3\%PFTRAV_IS_CLIP_START\fP
Indicates that for pruned and continued traversals
that before proceeding the segment should be clipped to start at the current
intersection point.
.TP
\f3\%PFTRAV_IS_CLIP_END\fP
Indicates that for pruned and continued traversals
that before proceeding the segment should be clipped to end at the current
intersection point.
.RE

If \f2discFunc\fP is NULL, the behavior is the same as if the discriminator
returned (\f3\%PFTRAV_CONT\fP | \f3\%PFTRAV_IS_CLIP_END\fP), so that the
intersection nearest the start of the segment will be returned.

.ne 22
A pfHit object also conveys information to the discriminator callback,
if any.    The following table lists the information which can be
obtained from an pfHit.

.TS
center tab($) ;
c | c | c
lB | l | l .
Query$Type$Contents
_
PFQHIT_FLAGS$int$Status flags
PFQHIT_SEGNUM$int$Index of segment in pfSegSet
PFQHIT_SEG$pfSeg$Segment, as clipped
PFQHIT_POINT$pfVec3$Intersection point
PFQHIT_NORM$pfVec3$Normal at intersection point
PFQHIT_VERTS$pfVec3[3]$Vertices of intersected triangle
PFQHIT_TRI$int$Index of triangle in pfGeoSet primitive
PFQHIT_PRIM$int$Index of primitive in pfGeoSet
PFQHIT_GSET$pfGeoSet *$Pointer to intersected pfGeoSet
PFQHIT_NODE$pfNode *$Pointer to pfGeode
PFQHIT_NAME$char *$Name of pfGeode
PFQHIT_XFORM$pfMatrix$Transformation matrix
PFQHIT_PATH$pfPath *$Path within scene graph
.TE

\f3\%pfQueryGSet\fP is a convenience routine for
determining the values of implicit pfGeoSet parameters.  The \f2which\fP
argument is a token which selects the parameter from the set
\f3\%PFQGSET_NUM_TRIS\fP and \f3\%PFQGSET_NUM_VERTS\fP.  The result is written
to the address indicated by \f2dst\fP.  The number of bytes written to
\f2dst\fP is returned as the value of
\f3\%pfQueryGSet\fP.
\f3\%pfMQueryGSet\fP is similar but copies a
series of items sequentially into the buffer specified by \f2dst\fP.
The items and their order are defined by a NULL-terminated array of
query tokens pointed to by \f2which\fP. For both functions, the return
value is the number of bytes written to the destination buffer.

\f3\%pfGetGSetClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfGeoSet\fP.  The \f3\%pfType\fP* returned by
\f3\%pfGetGSetClassType\fP is the same as
the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class \f3\%pfGeoSet\fP.  Because
OpenGL Performer allows subclassing of built-in types, when decisions are
made based on the type of an object, it is usually better to use
\f3\%pfIsOfType\fP to test if an
object is of a type derived from a Performer type rather than to test
for strict equality of the \f3\%pfType\fP*'s.

\f3\%pfGSetPassList\fP and
\f3\%pfGetGSetPassList\fP set and get a \f3\%pfPassList\fP
pointer on a \f3\%pfGeoSet\fP. A \f3\%pfPassList\fP is an object generated by
\f3\%pfShader\fP. It changes the way in which a \f3\%pfGeoSet\fP is drawn. Instead
of drawing the \f3\%pfGeoSet\fP using its \f3\%pfGeoState\fP once, it draws the
\f3\%pfGeoSet\fP multiple times using \f3\%pfGeoSet\fP and \f3\%pfFBState\fP pointers from
the \f3\%pfPassList\fP. This API is used to implement multi-pass rendering
algorithms. The best way to attach \f3\%pfPassList\fP pointers to \f3\%pfGeoSets\fP is
by using a \f3\%pfShader\fP and a \f3\%pfShaderManager\fP.

.SH NOTES

The following example shows one way to create a pfGeoSet defining a
hexahedron, which is also known as a cube.
.Ex
.nf

static pfVec3 coords[] =
{
    {-1.0, -1.0,  1.0},
    { 1.0, -1.0,  1.0},
    { 1.0,  1.0,  1.0},
    {-1.0,  1.0,  1.0},
    {-1.0, -1.0, -1.0},
    { 1.0, -1.0, -1.0},
    { 1.0,  1.0, -1.0},
    {-1.0,  1.0, -1.0}
};

static ushort cindex[] =
{
    0, 1, 2, 3,	/* front  */
    0, 3, 7, 4,	/* left   */
    4, 7, 6, 5,	/* back   */
    1, 5, 6, 2,	/* right  */
    3, 2, 6, 7,	/* top    */
    0, 4, 5, 1	/* bottom */
};

static pfVec3 norms[] =
{
    { 0.0,  0.0,  1.0},
    { 0.0,  0.0, -1.0},
    { 0.0,  1.0,  0.0},
    { 0.0, -1.0,  0.0},
    { 1.0,  0.0,  0.0},
    {-1.0,  0.0,  0.0}
};

static ushort nindex[] =
{
    0,
    5,
    1,
    4,
    2,
    3
};

/* Convert static data to pfMalloc'ed data */
static void*
memdup(void *mem, size_t bytes, void *arena)
{
    void *data = pfMalloc(bytes, arena);
    memcpy(data, mem, bytes);
    return data;
}

/* Set up an indexed PFGS_QUADS pfGeoSet */
gset = pfNewGSet(NULL);
pfGSetPrimType(gset, PFGS_QUADS);
pfGSetNumPrims(gset, 6);
pfGSetAttr(gset, PFGS_COORD3,  PFGS_PER_VERTEX,
	memdup(coords, sizeof(coords), NULL),
	(ushort*)memdup(cindex, sizeof(cindex), NULL));

pfGSetAttr(gset, PFGS_NORMAL3, PFGS_PER_PRIM,
	memdup(norms, sizeof(norms), NULL),
	(ushort*)memdup(nindex, sizeof(nindex), NULL));
.Ee
.fi
.na

The following example shows one way to create a pfGeoSet with packed
attribute arrays.
.Ex
.nf

/* declare some template arrays of data */
pfVec3  stripcoords[4][4] ={{{-1.0f,  -1.0f,  1.0f }, {-1.0f,  1.0f,   1.0f },
		    {-0.5f,  -1.0f,  1.0f }, {-0.5f,  1.0f,   1.0f }},
		    {{-0.5f,  -1.0f,  1.0f }, {-0.5f,  1.0f,   1.0f },
		     {0.0f,  -1.0f,  1.0f }, {0.0f,  1.0f,   1.0f }},
		    {{0.0f,  -1.0f,  1.0f }, {0.0f,  1.0f,   1.0f },
		     {0.5f,  -1.0f,  1.0f }, {0.5f,  1.0f,   1.0f }, },
		    {{0.5f,  -1.0f,  1.0f }, {0.5f,  1.0f,   1.0f },
		     { 1.0f,  -1.0f,  1.0f }, { 1.0f,  1.0f,   1.0f }}};
int lengths[5] = {4, 4, 4, 4};

uint    pcolors[] = {0xffffffff, 0x0000ffff, 0xff0000ff, 0x00ff00ff};
short	pnorms[][4] = { {0, 0, -MAX_SHORT, 0},
			{0, 0, -MAX_SHORT, 0},
			{0, 0, -MAX_SHORT, 0},
			{0, 0, -MAX_SHORT, 0} };

float	ptexcoords[][2] = { {0, 0}, {1.0f, 0}, {1.0f, 1.0f}, {0, 1.0f} };

	...

    /* allocate an array for the packed vertex data */
    stripp = strip = (void *)pfCalloc(4, 4*12 * sizeof(float), NULL);
    /* pack the data into the packed attr array for the PFGS_PA_C4UBN3ST2FV3F format
     * and for all attributes with per-vertex binding
     */
    for (j=0; j < 4; j++)
    {
        for (i=0; i < 4; i++)
	{
	switch(i)
	{
	    case 0: t = 0; break;
	    case 1: t = 3; break;
	    case 2: t = 1; break;
	    case 3: t = 2; break;
	}
	*((long*)stripp) = pcolors[i];
	stripp = (void*) (((char*)stripp) + sizeof(int));
	*((short*)stripp) = pnorms[i][0];
	stripp = (void*) (((char*)stripp) + sizeof(short));
	*((short*)stripp) = pnorms[i][1];
	stripp = (void*) (((char*)stripp) + sizeof(short));
	*((short*)stripp) = pnorms[i][2];
	stripp = (void*) (((char*)stripp) + sizeof(short)); /* pad to word-align next attr */
	stripp = (void*) (((char*)stripp) + sizeof(short));
	*((float*)stripp) = ptexcoords[t][0];
	stripp = (void*) (((char*)stripp) + sizeof(float));
	*((float*)stripp) = ptexcoords[t][1];
	stripp = (void*) (((char*)stripp) + sizeof(float));
	*((float*)stripp) = stripcoords[j][i][0];
	stripp = (void*) (((char*)stripp) + sizeof(float));
	*((float*)stripp) = stripcoords[j][i][1];
	stripp = (void*) (((char*)stripp) + sizeof(float));
	*((float*)stripp) = stripcoords[j][i][2];
	stripp = (void*) (((char*)stripp) + sizeof(float));
	}
    }
.Ee
.fi
.na

.Ex
.nf

    /* set the attributes on the pfGeoSet */
    gset = pfNewGSet(NULL);
    pfGSetPrimType(gset, PFGS_TRISTRIPS);
    pfGSetPrimLengths(gset, lengths);
    pfGSetNumPrims(gset, 4);
    pfGSetAttr(gset, PFGS_PACKED_ATTRS, PFGS_PA_C4UBN3ST2FV3F, strip, NULL);
    pfGSetAttr(gset, PFGS_COLOR4, PFGS_PER_VERTEX, NULL, NULL);
    pfGSetAttr(gset, PFGS_TEXCOORD2, PFGS_PER_VERTEX, NULL, NULL);
    pfGSetAttr(gset, PFGS_NORMAL3, PFGS_PER_VERTEX, NULL, NULL);
    pfGSetDrawMode(gset, PFGS_PACKED_ATTRS, 1);
.Ee
.fi
.na


pfGeoSets using with \f3\%PFGS_PACKED_ATTRS\fP for
\f3\%PFGS_TRISTRIPS\fP, \f3\%PFGS_FLAT_TRISTRIPS\fP,
\f3\%PFGS_TRIFANS\fP, and \f3\%PFGS_FLAT_TRIFANS\fP
primitive types and whose standard coordinate attribute
array is NULL do not draw the standard full wireframe
for the \f3\%PFGS_WIREFRAME\fP draw mode but instead draw a faster quick-wireframe
based on the exact vertex ordering in the \f3\%PFGS_PACKED_ATTRS\fP attribute array.

pfGeoSets using with \f3\%PFGS_PACKED_ATTRS\fP for \f3\%PFGS_QUADS\fP primitives
will be drawn with as GL quads instead of as triangle strips as is done with
normal pfGeoSet rendering.

pfGeoSets drawn with \f3\%PFGS_COMPILE_GL\fP and \f3\%PFGS_PACKED_ATTRS\fP will
ignore subsequent changes to pfLPointStates.
.SH SEE ALSO
pfApplyGState,
pfColortable,
pfCopy,
pfCycleBuffer,
pfDecal,
pfDelete,
pfDisable,
pfDispList,
pfEnable,
pfFlux,
pfFluxMemory,
pfGSetDrawMode,
pfGeoState,
pfHit,
pfLPointState,
pfMalloc,
pfMaterial,
pfNewHlight,
pfObject,
pfGSetIsectSegs,
pfShadeModel,
pfState,
pfuFillGSetPackedAttrs,
pfuTravCreatePackedAttrs,
pfShader,
pfShaderManager
