'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGeode" "3pf"
.SH NAME
.upperok
.B pfNewGeode,
.B pfGetGeodeClassType,
.B pfAddGSet,
.B pfRemoveGSet,
.B pfInsertGSet,
.B pfReplaceGSet,
.B pfGetGSet,
.B pfGetNumGSets
\- 
Create, modify, and query a geometry node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfGeoSet\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfGeode *
\f3\%pfNewGeode\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetGeodeClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfAddGSet\fP(pfGeode*\ geode,
'in +2
'll -2
pfGeoSet*\ gset);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfRemoveGSet\fP(pfGeode*\ geode,
'in +2
'll -2
pfGeoSet*\ gset);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfInsertGSet\fP(pfGeode*\ geode,
'in +2
'll -2
int\ index,
pfGeoSet*\ gset);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfReplaceGSet\fP(pfGeode*\ geode,
'in +2
'll -2
pfGeoSet*\ old,
pfGeoSet*\ new);
.in
.ll
.nf
.fi
.TP
pfGeoSet *
\f3\%pfGetGSet\fP(const\ pfGeode*\ geode,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNumGSets\fP(const\ pfGeode*\ geode);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfGeode\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfGeode\fP.
Casting an object of class \f3\%pfGeode\fP
to an object of class \f3\%pfNode\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfGeode\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfGeode\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'geode\ \ 'u
\f2geode\fP
identifies a pfGeode.
.SH DESCRIPTION

The name "pfGeode" is short for Geometry Node.  A pfGeode is a leaf
node in the OpenGL Performer scene graph hierarchy and is derived from
pfNode so it can use pfNode API.  A pfGeode is simply a list of
pfGeoSets which it draws and intersects with.  A pfGeode is the
smallest cullable unit unless \f3\%PFCULL_GSET\fP is set by
\f3\%pfChanTravMode\fP in which case OpenGL Performer will cull individual
pfGeoSets within pfGeodes.

The bounding volume of a pfGeode is that which surrounds all its
pfGeoSets.  Unless the bounding volume is considered static (see
\f3\%pfNodeBSphere\fP), OpenGL Performer will compute a new volume when the
list of pfGeoSets is modified by \f3\%pfAddGSet\fP, \f3\%pfRemoveGSet\fP,
\f3\%pfInsertGSet\fP or \f3\%pfReplaceGSet\fP.  If the bounding box of a child
pfGeoSet changes, call \f3\%pfNodeBSphere\fP to tell OpenGL Performer to
update the bounding volume of the pfGeode.

\f3\%pfNewGeode\fP creates and returns a handle to a pfGeode.  Like
other pfNodes, pfGeodes are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetGeodeClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfGeode\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetGeodeClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfGeode\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfAddGSet\fP appends \f2gset\fP to \f2geode\fP's pfGeoSet list.
\f3\%pfRemoveGSet\fP removes \f2gset\fP from the list and shifts the list
down over the vacant spot.  For example, if \f2gset\fP had index 0, then
index 1 becomes index 0, index 2 becomes index 1 and so on.
\f3\%pfRemoveGSet\fP returns a 1 if \f2gset\fP was actually removed and 0 if
it was not found in the list.  \f3\%pfAddGSet\fP and \f3\%pfRemoveGSet\fP will
cause OpenGL Performer to recompute new bounding volumes for \f2geode\fP unless
it is configured to use static bounding volumes.

\f3\%pfInsertGSet\fP will insert \f2gset\fP before the pfGeoSet with index
\f2index\fP.  \f2index\fP must be within the range 0 to
\f3\%pfGetNumGSets\fP(\f2geode\fP).  \f3\%pfReplaceGSet\fP replaces \f2old\fP with
\f2new\fP and returns 1 if the operation was successful or 0 if \f2old\fP
was not found in the list.  \f3\%pfInsertGSet\fP and \f3\%pfReplaceGSet\fP will
cause OpenGL Performer to recompute new bounding volumes for \f2geode\fP
unless it is configured to use static bounding volumes.

\f3\%pfGetNumGSets\fP returns the number of pfGeoSets in \f2geode\fP.
\f3\%pfGetGSet\fP returns a handle to the pfGeoSet with index \f2index\fP or
\f3\%NULL\fP if the index is out of range.

If database sorting is disabled, that is if the \f3\%PFCULL_SORT\fP mode of
\f3\%pfChanTravMode\fP is not set, the pfGeoSets in a pfGeode will be drawn
in the order they appear on the list.  If sorting is enabled, there is
no guarantee about the drawing order, since the reordering of GeoSets
for minimum state-changing overhead is one of the primary design
motivations of OpenGL Performer's libpf and libpr.
.SH NOTES

pfGeode geometry is not multibuffered by OpenGL Performer when in
multiprocessing mode in order to save memory.  Therefore there are some
restrictions on dynamic geometry.  Modified vertex positions will be
culled properly only if a static bound is defined which surrounds all
possible excursions of the dynamic geometry.  Since the draw process
may be drawing the geometry at the same time the application process is
modifying it, cracks may appear between polygons which share a dynamic
vertex.  Creation and deletion of vertices are not currently supported
by OpenGL Performer.  However, the application may handle its own
multibuffering of pfGeodes through mutual exclusion with locks or
through the use of parallel data structures and pfSwitch nodes to
achieve any kind of dynamic geometry.

The shifting behavior of \f3\%pfRemoveGSet\fP can cause some confusion.  The
following sample code shows how to remove all pfGeoSets from \f2geode\fP:

.Ex
.nf

int	i;
int	n = pfGetNumGSets(geode);

for (i = 0; i < n; i++)
    pfRemoveGSet(geode, pfGetGSet(geode, 0)); /* 0, not i */
.Ee
.fi
.na

Alternately, you can traverse the list from back to front, in which
case the shift never hits the fan.
.Ex
.nf

int	i;
int	n = pfGetNumGSets(geode);

for (i = n - 1; i >= 0; i--)
    pfRemoveGSet(geode, pfGetGSet(geode, i)); /* i, not 0 */
.Ee
.fi
.na


When sorting is enabled (see \f3\%pfChanTravMode\fP and \f3\%PFCULL_SORT\fP),
transparent pfGeoSets are drawn last unless the pfGeode has a pre or
post draw callback (see \f3\%pfNodeTravFuncs\fP).  Drawing transparent
pfGeoSets after opaque geometry reduces artifacts when blended
transparency (see \f3\%pfTransparency\fP) is used and can improve fill
rate performance.
.SH SEE ALSO
pfChanTravMode,
pfGeoSet,
pfNode,
pfNodeTravFuncs,
pfTransparency,
pfDelete
