'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfGroup" "3pf"
.SH NAME
.upperok
.B pfNewGroup,
.B pfGetGroupClassType,
.B pfAddChild,
.B pfInsertChild,
.B pfReplaceChild,
.B pfRemoveChild,
.B pfSearchChild,
.B pfGetChild,
.B pfGetNumChildren,
.B pfBufferAddChild,
.B pfBufferRemoveChild
\- 
Create, modify, and query a group node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfGroup\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfGroup *
\f3\%pfNewGroup\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetGroupClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.nf
.fi
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.nf
.fi
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfGroup\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfGroup\fP.
Casting an object of class \f3\%pfGroup\fP
to an object of class \f3\%pfNode\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfGroup\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfGroup\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'group\ \ 'u
\f2group\fP
identifies a pfGroup.
.SH DESCRIPTION

A pfGroup is the internal node type of the OpenGL Performer hierarchy and is
derived from pfNode.  A pfGroup has a list of children which are
traversed when \f2group\fP is traversed.  Children may be any pfNode
which includes both internal nodes (pfGroups) and leaf nodes
(pfNodes).  Other nodes which are derived from pfGroup may use pfGroup
API. OpenGL Performer nodes derived from pfGroup are:
.RS
\f3\%pfScene\fP
.br
\f3\%pfSwitch\fP
.br
\f3\%pfLOD\fP
.br
\f3\%pfSequence\fP
.br
\f3\%pfLayer\fP
.br
\f3\%pfSCS\fP
.br
\f3\%pfDCS\fP
.br
\f3\%pfMorph\fP
.RE

\f3\%pfNewGroup\fP creates and returns a handle to a pfGroup.  Like
other pfNodes, pfGroups are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetGroupClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfGroup\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetGroupClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfGroup\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfAddChild\fP appends \f2child\fP to \f2group\fP and increments
the reference count of \f2child\fP.  \f3\%pfRemoveChild\fP
removes \f2child\fP from the list and shifts the list down over the
vacant spot, e.g. - if \f2child\fP had index 0, then index 1 becomes
index 0, index 2 becomes index 1 and so on.  \f3\%pfRemoveChild\fP returns
a 1 if \f2child\fP was actually removed and 0 if it was not found in the
list. \f3\%pfRemoveChild\fP decrements the reference count of \f2child\fP
but does not delete \f2child\fP if its reference count reaches 0.

\f3\%pfInsertChild\fP inserts \f2child\fP before the child with index
\f2index\fP.  \f2index\fP must be within the range 0 to
\f3\%pfGetNumChildren\fP(\f2group\fP).

\f3\%pfReplaceChild\fP replaces \f2old\fP with \f2new\fP and returns 1
if the operation was successful or 0 if \f2old\fP is not a child
of \f2group\fP.

\f3\%pfSearchChild\fP returns the index of \f2child\fP if it was found
in the children list of \f2group\fP or -1 if it was not found.

\f3\%pfGetNumChildren\fP returns the number of children in \f2group\fP.
\f3\%pfGetChild\fP returns a handle to the child with index \f2index\fP or
NULL if the index is out of range.

The bounding volume of a pfGroup encompasses all its children.
Modifications to the child list of a pfGroup will
cause OpenGL Performer to recompute new bounding
volumes for the pfGroup unless it is configured to use static
bounding volumes (see \f3\%pfNodeBSphere\fP).

\f3\%pfBufferAddChild\fP and
\f3\%pfBufferRemoveChild\fP provide
access to nodes that do not exist in the current pfBuffer (See the
pfBuffer man page). Either, none, or both of \f2group\fP and \f2node\fP may exist outside the current pfBuffer.
\f3\%pfBufferAddChild\fP and
\f3\%pfBufferRemoveChild\fP act just
like their non-buffered counterparts
\f3\%pfAddChild\fP and
\f3\%pfRemoveChild\fP except that the
addition or removal request is not carried out immediately but is
recorded by the current pfBuffer. The request is delayed until the
first \f3\%pfMergeBuffer\fP when both
\f2group\fP and \f2node\fP are found in the main OpenGL
Performer pfBuffer. The list of
\f3\%pfBufferAddChild\fP and
\f3\%pfBufferRemoveChild\fP requests is
traversed in \f3\%pfMergeBuffer\fP after all nodes
have been merged.
\f3\%pfBufferAddChild\fP and
\f3\%pfBufferRemoveChild\fP return
\f3\%TRUE\fP if the request was recorded and \f3\%FALSE\fP otherwise.

.SH SEE ALSO
pfLookupNode,
pfNode,
pfBuffer,
pfDelete
