'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLODState" "3pf"
.SH NAME
.upperok
.B pfNewLODState,
.B pfGetLODStateClassType,
.B pfLODStateAttr,
.B pfGetLODStateAttr,
.B pfLODStateName,
.B pfGetLODStateName,
.B pfFindLODState
\- 
Create, modify, and query level of detail state.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLODState\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfLODState *
\f3\%pfNewLODState\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetLODStateClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLODStateAttr\fP(pfLODState\ *ls,
'in +2
'll -2
long\ attr,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetLODStateAttr\fP(pfLODState\ *ls,
'in +2
'll -2
long\ attr);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfLODStateName\fP(pfLODState\ *ls,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfGetLODStateName\fP(const\ pfLODState\ *ls);
.nf
.fi
.TP
pfLODState *
\f3\%pfFindLODState\fP(const\ char\ *name);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLODState\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfLODState\fP.
Casting an object of class \f3\%pfLODState\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLODState\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'ls\ \ 'u
\f2ls\fP
identifies a pfLODState.
.SH DESCRIPTION

pfLODState encapsulates a definition
of how an LOD or group of LODs should
respond to distance from the eyepoint and stress.
Currently, there are 8 attributes that
can be used to define LOD child selection and child transition distance
based on a LOD's distance from the channel's viewpoint and the channel's
stress (see \f3\%pfNewChan\fP and \f3\%pfChanStress\fP).

\f3\%pfNewLODState\fP creates and returns a handle to a pfLODState.  Like
other pfNodes, pfLODStates are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetLODStateClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLODState\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetLODStateClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfLODState\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLODStateAttr\fP and \f3\%pfGetLODStateAttr\fP are used to set and get
the following attributes:
.RS
.TP 5
\f3\%PFLODSTATE_RANGE_RANGESCALE\fP, \f3\%PFLODSTATE_RANGE_RANGEOFFSET\fP
directly modify the geometric range used to determine the current LOD child.
.TP
\f3\%PFLODSTATE_RANGE_STRESSSCALE\fP, \f3\%PFLODSTATE_RANGE_STRESSOFFSET\fP
modify the way the current channel stress affects the range computation.
.TP
\f3\%PFLODSTATE_TRANSITION_RANGESCALE\fP, \f3\%PFLODSTATE_TRANSITION_RANGEOFFSET\fP
directly modify the transition widths set by \f3\%pfLODTransition\fP.
.TP
\f3\%PFLODSTATE_TRANSITION_STRESSSCALE\fP, \f3\%PFLODSTATE_TRANSITION_STRESSOFFSET\fP
modify the way transition widths are adjusted by the channel stress value.
.RE

These scale and offset values adjust the LOD selection process in
the following way, presented in pseudocode:
.Ex
.nf

effectiveRange =
    OverallLODScale *
    (Range * \f3\%RANGE_RANGESCALE\fP + \f3\%RANGE_RANGEOFFSET\fP) *
    (Stress * \f3\%RANGE_STRESSSCALE\fP + \f3\%RANGE_STRESSOFFSET\fP);

effectiveTransitionWidth[i] =
    OverallFadeScale *
    (Trans[i] * \f3\%TRANSITION_RANGESCALE\fP + \f3\%TRANSITION_RANGEOFFSET\fP) /
    (Stress * \f3\%TRANSITION_STRESSSCALE\fP + \f3\%TRANSITION_STRESSOFFSET\fP);
.Ee
.fi
.na


OverallLODScale and OverallFadeScale are the \f3\%PFLOD_SCALE\fP and
\f3\%PFLOD_FADE\fP attributes set with \f3\%pfChanLODAttr\fP. Both
are global values that affect the switching and transition ranges
of all pfLODs in the scene.

The default values for all \f3\%SCALE\fP and \f3\%OFFSET\fP attributes are
1.0 and 0.0 respectively except \f3\%TRANSITION_STRESSSCALE\fP and
\f3\%TRANSITION_STRESSOFFSET\fP which are 0.0 and 1.0 respectively, i.e.,
transition ranges are not scaled by stress by default.

A pfLODState influences a pfLOD's behavior in one of 3 ways:
.RS
.TP
1.
Direct reference. A pfLOD may directly reference a pfLODState with
\f3\%pfLODLODState\fP.
.TP
2.
Indexed. A pfLOD may index a pfLODState with
\f3\%pfLODLODStateIndex\fP. When the LOD
is evaluated, the \f2index\fPth entry of the evaluating pfChannel's
pfLODState table is used. A pfChannel's pfLODState table is set with
(\f3\%pfChanLODStateList\fP).
With indexed pfLODStates, different pfChannels can have different
LOD behavior by using different pfLODState tables, e.g., an infrared
channel may not "see" cold objects as well as a visual channel
so "cold" pfLODs will index a different pfLODState in the infrared channel
than in the visual channel.
.TP
3.
Inherited from pfChannel. A pfLOD which does not directly reference
or index a pfLODState will use the pfLODState of the evaluating pfChannel
(\f3\%pfChanLODState\fP). This is
the default pfLOD behavior.
.RE

When a pfLOD references or indexes a pfLODState,  the \f3\%SCALE\fP and \f3\%OFFSET\fP
parameters of the pfLODState are multiplied and added, respectively, to the
corresponding \f3\%SCALE\fP and \f3\%OFFSET\fP parameters of the evaluating
pfChannel's pfLODState, e.g., effective \f3\%RANGE_RANGESCALE\fP =
pfLODState's \f3\%RANGE_RANGESCALE\fP * pfChannel's \f3\%RANGE_RANGESCALE\fP.

Multiple pfLODs may share the same pfLODState reference or index.

\f3\%pfLODStateName\fP and \f3\%pfGetLODStateName\fP set and get the name of a
particular pfLODState while \f3\%pfFindLODState\fP will return the first
pfLODState defined with the given name.
.SH SEE ALSO
pfLOD,
pfChannel,
pfChanLODAttr,
pfChanStress
