'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLPointState" "3pf"
.SH NAME
.upperok
.B pfNewLPState,
.B pfGetLPStateClassType,
.B pfLPStateMode,
.B pfGetLPStateMode,
.B pfLPStateVal,
.B pfGetLPStateVal,
.B pfLPStateShape,
.B pfGetLPStateShape,
.B pfLPStateBackColor,
.B pfGetLPStateBackColor,
.B pfApplyLPState,
.B pfMakeLPStateRangeTex,
.B pfMakeLPStateShapeTex,
.B pfRasterFunc,
.B pfGetRasterFunc,
.B pfCalligFunc,
.B pfGetCalligFunc,
.B pfGetCurLPState
\- 
Set and get pfLPointState size, transparency, directionality, shape, and fog attributes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLPointState\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfLPointState *
\f3\%pfNewLPState\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetLPStateClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLPStateMode\fP(pfLPointState\ *lpstate,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetLPStateMode\fP(const\ pfLPointState\ *lpstate,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPStateVal\fP(pfLPointState\ *lpstate,
'in +2
'll -2
int\ attr,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetLPStateVal\fP(const\ pfLPointState\ *lpstate,
'in +2
'll -2
int\ attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPStateShape\fP(pfLPointState\ *lpstate,
'in +2
'll -2
float\ horiz,
float\ vert,
float\ roll,
float\ falloff,
float\ ambient);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPStateShape\fP(const\ pfLPointState\ *lpstate,
'in +2
'll -2
float\ *horiz,
float\ *vert,
float\ *roll,
float\ *falloff,
float\ *ambient);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPStateBackColor\fP(pfLPointState\ *lpstate,
'in +2
'll -2
float\ r,
float\ g,
float\ b,
float\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPStateBackColor\fP(pfLPointState\ *lpstate,
'in +2
'll -2
float\ *r,
float\ *g,
float\ *b,
float\ *a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyLPState\fP(pfLPointState\ *lpstate);
.nf
.fi
.TP
void
\f3\%pfMakeLPStateRangeTex\fP(pfLPointState\ *lpstate,
'in +2
'll -2
pfTexture\ *tex,
int\ size,
pfFog*\ fog);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeLPStateShapeTex\fP(pfLPointState\ *lpstate,
'in +2
'll -2
pfTexture\ *tex,
int\ size);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfRasterFunc\fP(pfLPointState\ *lpstate,
'in +2
'll -2
pfRasterFuncType\ rasterCallback,
void\ *rasterData);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetRasterFunc\fP(pfLPointState\ *lpstate,
'in +2
'll -2
pfRasterFuncType\ *rasterCallback,
void\ **data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCalligFunc\fP(pfLPointState\ *lpstate,
'in +2
'll -2
pfCalligFuncType\ calligCallback,
void\ *calligData);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCalligFunc\fP(pfLPointState\ *lpstate,
'in +2
'll -2
pfCalligFuncType\ *calligCallback,
void\ **calligData);
.in
.ll
.nf
.fi
.TP
pfLPointState*
\f3\%pfGetCurLPState\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLPointState\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfLPointState\fP.
Casting an object of class \f3\%pfLPointState\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLPointState\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'lpstate\ \ 'u
\f2lpstate\fP
identifies a pfLPointState.
.SH DESCRIPTION

A pfLPointState is a \f3\%libpr\fP data structure which, in conjunction
with a pfGeoSet of type \f3\%PFGS_POINTS\fP, supports a sophisticated
\f3\%light point\fP primitive type. Examples of light points are stars,
beacons, strobes, runway edge and end illumination, taxiway lights,
visual approach slope indicators (VASI), precision approach path
indicators (PAPI), and street lights when viewed from a great
distance.

Light points should not be confused with light sources, such as a
pfLight. A light point is visible as one or more self-illuminated small
points that do not illuminate surrounding objects. By comparison, a
pfLight does illuminate scene contents but is itself not a visible
object.

When a pfLPointState is applied with
\f3\%pfApplyLPState\fP or
through its parent pfGeoState (See
\f3\%pfDrawGSet\fP and
\f3\%pfApplyGState\fP),
any pfGeoSet of type \f3\%PFGS_POINTS\fP will be rendered with
the following special light point characteristics (if enabled):
.RS
.TP 3
1.
Perspective size. Light points can be assigned a real world size
and exhibit perspective behavior, e.g., points closer to the eye
will be rendered larger than those points farther away.
.TP
2.
Perspective fading. Once a light point reaches a minimum size, it may
be made more transparent in order to enhance the perspective illusion.
Fading is often more realistic than simply shrinking the point size to 0.
.TP
3.
Fog punch-through. Since light points are emissive objects, they
must shine through fog more than non-emissive objects.
.TP
4.
Directionality. Light points can be assigned a direction as
well as vertical and horizontal envelopes (or lobes) about this
direction vector. Directional light point intensity is then view
position-dependent. Light point direction is defined by the
normals (\f3\%PFGS_NORMAL3\fP) supplied by \f3\%PFGS_POINTS\fP pfGeoSets.
.TP
5.
Intensity. Normally, light point color and transparency are defined by the
colors (\f3\%PFGS_COLOR4\fP) supplied by \f3\%PFGS_POINTS\fP pfGeoSets.
pfLPointStates provide the additional capability of modifying the
intensity of all points in a light point pfGeoSet by scaling the alpha
of all point colors.
.RE

At a minimum, light point usage requires a configuration based on
three linked libpr objects: a pfGeoSet, a pfGeoState attached to
that pfGeoSet, and a pfLPointState attached to the pfGeoState. Here
are the details:
.RS
.TP 3
1.
A pfGeoSet of type \f3\%PFGS_POINTS\fP. This pfGeoSet must have a
\f3\%PFGS_COLOR4\fP attribute binding of \f3\%PFGS_PER_VERTEX\fP in some
situations and should have supplied normals (\f3\%PFGS_NORMAL3\fP) if
the light points are directional.
.TP
2. A pfGeoState which is usually attached to the pfGeoSet and
which references a pfLPointState. The pfGeoState should almost
always enable transparency since all light point effects except
perspective size require transparency.
.TP
3. A pfLPointState configured appropriately and attached to the
pfGeoState listed in step two.
.RE

The following example illustrates how to build a comprehensive
light point structure that uses texture mapping to accelerate
directionality computations:

.Ex
.nf

/*
 * Create pfLPointState and pfGeoState.
 */
pfGeoState 	*gst = pfNewGState(arena);
pfLPointState	*lps = pfNewLPState(arena);
pfGStateMode(gst, PFSTATE_ENLPOINTSTATE, 1);
pfGStateAttr(gst, PFSTATE_LPOINTSTATE, lps);

/*
 * Light point projected diameter is computed on CPU. Real world
 * size is 0.07 database units and projected size is clamped be
 * between 0.25 and 4 pixels.
 */
pfLPStateMode(lps, PFLPS_SIZE_MODE, PFLPS_SIZE_MODE_ON);
pfLPStateVal(lps, PFLPS_SIZE_MIN_PIXEL, 0.25f);
pfLPStateVal(lps, PFLPS_SIZE_ACTUAL, 0.07f);
pfLPStateVal(lps, PFLPS_SIZE_MAX_PIXEL, 4.0f);

/*
 * Light points become transparent when their projected diameter is
 * < 2 pixels. The transparency falloff rate is linear with
 * projected size with a scale factor of 0.6. The transparency
 * multiplier, NOT the light point transparency, is clamped to 0.1.
 */
pfLPStateVal(lps, PFLPS_TRANSP_PIXEL_SIZE, 2.0f);
pfLPStateVal(lps, PFLPS_TRANSP_EXPONENT, 1.0f);
pfLPStateVal(lps, PFLPS_TRANSP_SCALE, 0.6f);
pfLPStateVal(lps, PFLPS_TRANSP_CLAMP, 0.1f);

/*
 * Light points will be fogged as if they were 4 times
 * nearer to the eye than actual to achieve punch-through.
 */
pfLPStateVal(lps, PFLPS_FOG_SCALE, 0.25f);

/* Range to light points computed on CPU is true range */
pfLPStateMode(lps, PFLPS_RANGE_MODE, PFLPS_RANGE_MODE_TRUE);

/*
 * Light points are bidirectional but have different (magenta)
 * back color. Front color is provided by pfGeoSet colors.
 */
pfLPStateMode(lps, PFLPS_SHAPE_MODE, PFLPS_SHAPE_MODE_BI_COLOR);
pfLPStateBackColor(lps, 1.0f, 0.0f, 1.0f, 1.0f);

/*
 * 60 degrees horizontal and 30 degrees vertical envelope.
 * Envelope is rotated -25 degrees about the light point
 * direction. Falloff rate is linear and ambient intensity is 0.1.
 */
pfLPStateShape(lps, 60.0f, 30.0f, -25.0f, 1.0f, 0.1f);

/*
 * Specify that light points should use texturing hardware to simulate
 * directionality and use CPU to compute light point transparency and
 * fog punch-through. Note that if light points are omnidirectional,
 * you should use PFLPS_TRANSP_MODE_TEX and PFLPS_FOG_MODE_TEX instead.
 */
pfLPStateMode(lps, PFLPS_DIR_MODE, PFLPS_DIR_MODE_TEX);
pfLPStateMode(lps, PFLPS_TRANSP_MODE, PFLPS_TRANSP_MODE_ALPHA);
pfLPStateMode(lps, PFLPS_FOG_MODE, PFLPS_FOG_MODE_ALPHA);

/*
 * Make directionality environment map of size 64 x 64 and attach
 * it to the light point pfGeoState. We assume that a pfTexEnv of
 * type PFTE_MODULATE has been globally applied with pfApplyTEnv.
 */
tex = pfNewTex(arena);
pfMakeLPStateShapeTex(lps, tex, 64);
pfGStateAttr(gst, PFSTATE_TEXTURE, tex);
pfGStateMode(gst, PFSTATE_ENTEXTURE, 1);

/*
 * Make SPHERE_MAP pfTexGen and attach to light point pfGeoState.
 * pfGeoSet normals define the per-light light point direction.
 */
tgen = pfNewTGen(arena);
pfTGenMode(tgen, PF_S, PFTG_SPHERE_MAP);
pfTGenMode(tgen, PF_T, PFTG_SPHERE_MAP);
pfGStateAttr(gst, PFSTATE_TEXGEN, tgen);
pfGStateMode(gst, PFSTATE_ENTEXGEN, 1);

/*
 * Configure light point transparency. Use PFTR_BLEND_ALPHA for high
 * quality transparency. Set pfAlphaFunc so that light points are not
 * drawn unless their alphas exceed 1 when using 8-bit color resolution.
 */
pfGStateMode(gst, PFSTATE_TRANSPARENCY, PFTR_BLEND_ALPHA);
pfGStateVal(gst, PFSTATE_ALPHAREF, 1.0/255.0);
pfGStateMode(gst, PFSTATE_ALPHAFUNC, PFAF_GREATER);

/*
 * Disable pfFog effects since light points are fogged by
 * the pfLPointState.
 */
pfGStateMode(gst, PFSTATE_ENFOG, 0);
/*
 * Disable lighting effects since light points are completely
 * emissive.
 */
pfGStateMode(gst, PFSTATE_ENLIGHTING, 0);

/*
 * Attach the pfGeoState to a pfGeoSet of type PFGS_POINTS and
 * you've got light points!
 */
pfGSetPrimType(gset, PFGS_POINTS);
pfGSetGState(gset, gst);
.Ee
.fi
.na


\f3\%pfLPointState Modes\fP

Each of the five light point characteristics listed earlier may be achieved
through the Graphics Library in different ways depending on the
available graphics hardware. \f3\%pfLPStateMode\fP/\f3\%pfLPStateVal\fP provide
control over feature implementation. Modes and their corresponding values
accepted by \f3\%pfLPStateMode\fP are:
.RS
.TP 3
\f3\%PFLPS_SIZE_MODE\fP  /* Perspective size */
.br
\f3\%PFLPS_SIZE_MODE_ON\fP - Enable perspective light point size. Perspective
size is computed on the CPU.

.br
\f3\%PFLPS_SIZE_MODE_OFF\fP - Disable perspective light point size.
.TP
\f3\%PFLPS_TRANSP_MODE\fP  /* Perspective fading */
.br
\f3\%PFLPS_TRANSP_MODE_ON\fP - Enable default (CPU-based) light point fading.

.br
\f3\%PFLPS_TRANSP_MODE_OFF\fP - Disable light point fading.

.br
\f3\%PFLPS_TRANSP_MODE_ALPHA\fP - Enable light point fading. Compute
fade value on CPU and modify light point alpha. This mode requires
that pfGeoSets have a \f3\%PFGS_COLOR4\fP binding of \f3\%PFGS_PER_VERTEX\fP
and that there be a unique color for each point.

.br
\f3\%PFLPS_TRANSP_MODE_TEX\fP - Enable light point fading. Use
texture mapping to simulate fading.
.TP
\f3\%PFLPS_FOG_MODE\fP  /* Fog punch-through */
.br
\f3\%PFLPS_FOG_MODE_ON\fP - Enable default (CPU-based) fog punch-through.

.br
\f3\%PFLPS_FOG_MODE_OFF\fP - Disable fog punch-through.

.br
\f3\%PFLPS_FOG_MODE_ALPHA\fP - Enable fog punch-through. Compute
fog value on CPU and modify light point alpha. This mode requires
that pfGeoSets have a \f3\%PFGS_COLOR4\fP binding of \f3\%PFGS_PER_VERTEX\fP
and that there be a unique color for each point.

.br
\f3\%PFLPS_FOG_MODE_TEX\fP - Enable fog punch-through. Use
texture mapping to simulate fog.

.br
(Normal fogging should be disabled (\f3\%pfDisable(PFEN_FOG)\fP or
\f3\%pfGStateMode(g, PFSTATE_ENFOG,
0)\fP) when
\f3\%PFLPS_FOG_MODE\fP is not \f3\%PFLPS_FOG_MODE_OFF\fP since the
pfLPointState will fog the points)

.TP
\f3\%PFLPS_DIR_MODE\fP  /* Directionality enable */
.br
\f3\%PFLPS_DIR_MODE_ON\fP - Enable default (CPU-based) directional light points.

.br
\f3\%PFLPS_DIR_MODE_OFF\fP - Disable directional light points.

.br
\f3\%PFLPS_DIR_MODE_ALPHA\fP - Enable directional light points. Compute
directionality on CPU and modify light point alpha. This mode requires
that pfGeoSets have a \f3\%PFGS_COLOR4\fP binding of \f3\%PFGS_PER_VERTEX\fP
and that there be a unique color for each point.

.br
\f3\%PFLPS_DIR_MODE_TEX\fP - Enable directional light points. Use
texture mapping to simulate directionality.
.TP
\f3\%PFLPS_SHAPE_MODE\fP  /* Directionality shape */
.br
\f3\%PFLPS_SHAPE_MODE_UNI\fP - Directional light points are unidirectional.
Light distribution is an elliptical cone specified by \f3\%pfLPStateShape\fP,
centered about the light direction
vector.

.br
\f3\%PFLPS_SHAPE_MODE_BI\fP - Directional light points are bidirectional
with identical front and back colors. Light
distribution is two elliptical cones, specified by \f3\%pfLPStateShape\fP,
centered about the positive and
negative light direction vectors.

.br
\f3\%PFLPS_SHAPE_MODE_BI_COLOR\fP - Directional light points are bidirectional
with back color specified by \f3\%pfLPStateBackColor\fP. Light
distribution is two elliptical cones, specified by \f3\%pfLPStateShape\fP,
centered about the positive and negative light direction vectors.
.TP
\f3\%PFLPS_RANGE_MODE\fP
.br
\f3\%PFLPS_RANGE_MODE_DEPTH\fP - Range to light point is approximated by
depth from eye. This may be faster, but less accurate than
\f3\%PFLPS_RANGE_MODE_TRUE\fP.

.br
\f3\%PFLPS_RANGE_MODE_TRUE\fP - Range to light point is true, slanted range
to eye. This may be slower, but more accurate than
\f3\%PFLPS_RANGE_MODE_DEPTH\fP.
.RE

\f3\%pfLPointState Values\fP

\f3\%pfLPStateVal\fP sets the attribute of \f2lpstate\fP identified by \f2which\fP
to \f2val\fP. \f3\%pfGetLPStateVal\fP returns the attribute of \f2lpstate\fP
identified by \f2which\fP.

Values associated with \f3\%PFLPS_SIZE_MODE\fP and which have effect only
when \f3\%PFLPS_SIZE_MODE\fP is \f3\%PFLPS_SIZE_MODE_ON\fP are the following:
.RS
.TP
\f3\%PFLPS_SIZE_MIN_PIXEL\fP
\f2val\fP specifies the minimum diameter, in pixels,
of light points. Default value is 0.25. Note that actual minimum point size
is clamped to the minimum supported by the graphics hardware.
.TP
\f3\%PFLPS_SIZE_MAX_PIXEL\fP
\f2val\fP specifies the maximum diameter, in pixels,
of light points. Default value is 4.0.  Note that actual maximum point size
is clamped to the maximum supported by the graphics hardware.
.TP
\f3\%PFLPS_SIZE_ACTUAL\fP
\f2val\fP specifies light point diameter in eye
coordinates. Scales do not affect the actual light point size.
Default value is 0.25.
.RE

In pseudo-code, the size of a light point is determined as follows:
.Ex
.nf

/* NearPixelDistance is described below */
computedSize = \f3\%PFLPS_SIZE_ACTUAL\fP * NearPixelDistance / rangeToEye;

if (\f3\%PFLPS_SIZE_MODE\fP == \f3\%PFLPS _SIZE_MODE_ON\fP)
{
    /* Clamp pixel size of point */
    if (computedSize < \f3\%PFLPS_SIZE_MIN_PIXEL\fP)
	computedSize = \f3\%PFLPS_SIZE_MIN_PIXEL\fP;
    else
    if (computedSize > \f3\%PFLPS_SIZE_MAX_PIXEL\fP)
	computedSize = \f3\%PFLPS_SIZE_MAX_PIXEL\fP;

    lightPointSize = computedSize;
}
.Ee
.fi
.na


Values associated with \f3\%PFLPS_TRANSP_MODE\fP and which have effect only
when \f3\%PFLPS_TRANSP_MODE\fP is not \f3\%PFLPS_TRANSP_MODE_OFF\fP.
.RS
.TP
\f3\%PFLPS_TRANSP_PIXEL_SIZE\fP
\f2val\fP specifies the threshold diameter,
in pixels, at which light point alphas are decreased so that they become
more transparent once computed light point size is less than \f2val\fP.
Default value is 0.25.
.TP
\f3\%PFLPS_TRANSP_EXPONENT\fP
\f2val\fP specifies an exponential falloff for
light point fading and should be >= 0.0. Values > 0 and < 1 make the falloff
curve flatter while values > 1 make it sharper.
Default value is 1.0 for a linear falloff based on projected pixel size.
.TP
\f3\%PFLPS_TRANSP_SCALE\fP
\f2val\fP specifies a scale factor for the
light point fade multiplier. Values > 0 and < 1 decrease the falloff
rate while values > 1 increase it.
Default value is 1.0.
.TP
\f3\%PFLPS_TRANSP_CLAMP\fP - \f2val\fP specifies the minimum fade multiplier.
.RE

In pseudo-code, the transparency of a light point is determined as follows:
.Ex
.nf

if (\f3\%PFLPS_TRANSP_MODE\fP == \f3\%PFLPS_TRANSP_MODE_ALPHA\fP &&
    \f3\%PFLPS_TRANSP_PIXEL_SIZE\fP > computedSize)
{
    float       a;

    a = 1.0f - \f3\%PFLPS_TRANSP_SCALE\fP *
	powf(\f3\%PFLPS_TRANSP_PIXEL_SIZE\fP - computedSize,
	     \f3\%PFLPS_TRANSP_EXPONENT\fP);

    /* Clamp alpha multiplier, not alpha */
    if (a < \f3\%PFLPS_TRANSP_CLAMP\fP)
	a = \f3\%PFLPS_TRANSP_CLAMP\fP;

    lightPointAlpha *= a;
}
.Ee
.fi
.na


.TP
\f3\%PFLPS_FOG_SCALE\fP
\f2val\fP specifies a scale factor that multiplies
the range from eye to light point before fogging. Values > 0.0 and < 1.0
cause light points to punch through fog more than non-emissive surfaces.
Default value is 0.25.

In pseudo-code, the fog of a light point is determined as follows:
.Ex
.nf

/* fogFunction ranges from 0 (no fog) to 1 (completely fogged) */
lightPointAlpha *= 1.0f - fogFunction(rangeToEye * \f3\%PFLPS_FOG_SCALE\fP);
.Ee
.fi
.na

.TP
\f3\%PFLPS_INTENSITY\fP
\f2val\fP multiplies all light point alphas.
Default value is 1.0.
.TP
\f3\%PFLPS_SIZE_DIFF_THRESH\fP
\f2val\fP specifies the threshold, in pixels,
at which a new point size should be specified to the Graphics Library.
It is strictly a tuning parameter which trades off speed for image
quality. Default value is 0.1. Higher values improve performance
but may degrade light point image quality.
.RE

\f3\%PFLPS_TRANSP_MODE\fP, \f3\%PFLPS_FOG_MODE\fP, and \f3\%PFLPS_DIR_MODE\fP
modes each have possible values of \f3\%ALPHA\fP and \f3\%TEX\fP which dictate
the mechanism used to simulate the effect. The \f3\%ALPHA\fP mechanism
is the default and uses the CPU to compute the effect which is
then realized by modifying the alpha of light point colors.
pfGeoSets of type \f3\%PFGS_POINTS\fP which use an \f3\%ALPHA\fP mechanism
should have a \f3\%PFGS_COLOR4\fP binding of \f3\%PFGS_PER_VERTEX\fP even
if all point colors are the same, since the light point alphas will
be different based on \f3\%ALPHA\fP computation by the pfLPointState.

While \f3\%ALPHA\fP mechanisms are graphics hardware-independent, they may
be slower than \f3\%TEX\fP mechanisms on machines which provide hardware
texture mapping. By supplying an appropriate pfTexture, pfTexGen, and pfTexEnv
(usually attached to the pfGeoState to which the pfLPointState is attached),
you can use the texture mapping hardware to efficiently simulate
directionality or fog punch-through and perspective fading. At this time
it is not possible to support all \f3\%TEX\fP mechanisms at once:
.RS
.TP
1.
Only \f3\%PFLPS_DIR_MODE_TEX\fP or,
.TP
2.
\f3\%PFLPS_TRANSP_MODE_TEX\fP and/or \f3\%PFLPS_FOG_MODE_TEX\fP
.RE
It is
recommended that directional light points use \f3\%PFLPS_DIR_MODE_TEX\fP
since directionality is the most expensive effect to compute on the CPU.

Two convenience routines, \f3\%pfMakeLPStateRangeTex\fP and
\f3\%pfMakeLPStateShapeTex\fP are provided to compute a texture image
which accurately mimics certain characteristics of \f2lpstate\fP.

\f3\%pfMakeLPStateRangeTex\fP should be used in conjunction with
\f3\%PFLPS_TRANSP_MODE_TEX\fP and/or \f3\%PFLPS_FOG_MODE_TEX\fP and will
set a computed image on the supplied pfTexture, \f2tex\fP. The image will be
a 2D array of \f2size\fP by \f2size\fP if both \f3\%PFLPS_TRANSP_MODE_TEX\fP and
\f3\%PFLPS_FOG_MODE_TEX\fP are set on \f2lpstate\fP or the image will be
a 1D array of length \f2size\fP if only 1 of \f3\%PFLPS_TRANSP_MODE_TEX\fP and
\f3\%PFLPS_FOG_MODE_TEX\fP is set.

When using \f3\%PFLPS_TRANSP_MODE_TEX\fP and/or \f3\%PFLPS_FOG_MODE_TEX\fP,
you must supply a pfTexGen structure which computes the S (and T
if both \f3\%PFLPS_TRANSP_MODE_TEX\fP and \f3\%PFLPS_FOG_MODE_TEX\fP are set)
texture coordinates as distance from the Z = 0 plane in eye coordinates.
For example:
.Ex
.nf

tgen = pfNewTGen(arena);
pfTGenPlane(tgen, PF_S, 0.0f, 0.0f, 1.0f, 0.0f);
pfTGenPlane(tgen, PF_T, 0.0f, 0.0f, 1.0f, 0.0f);
pfTGenMode(tgen, PF_S, PFTG_EYE_PLANE);
pfTGenMode(tgen, PF_T, PFTG_EYE_PLANE);
.Ee
.fi
.na

\f3\%pfMakeLPStateRangeTex\fP takes into account only the following
values of \f2lpstate\fP when building the texture image and should be
called again whenever they change:

.RS
\f3\%PFLPS_TRANSP_PIXEL_SIZE\fP
.br
\f3\%PFLPS_TRANSP_EXPONENT\fP
.br
\f3\%PFLPS_TRANSP_SCALE\fP
.br
\f3\%PFLPS_TRANSP_CLAMP\fP
.RE

\f3\%pfMakeLPStateShapeTex\fP computes an environment map which
approximates the directional characteristics of \f2lpstate\fP.
The computed image is assigned to \f2tex\fP and its dimensions are
\f2size\fP by \f2size\fP. When using \f3\%PFLPS_DIR_MODE_TEX\fP,
you must supply a pfTexGen structure which uses \f3\%PFTG_SPHERE_MAP\fP
to compute both S and T. For example:
.Ex
.nf

tgen = pfNewTGen(arena);
pfTGenMode(tgen, PF_S, PFTG_SPHERE_MAP);
pfTGenMode(tgen, PF_T, PFTG_SPHERE_MAP);
.Ee
.fi
.na


\f3\%pfMakeLPStateShapeTex\fP takes into account only the \f3\%PFLPS_SHAPE_MODE\fP
modes and those values specified by \f3\%pfLPStateShape\fP. Consequently,
\f3\%pfMakeLPStateShapeTex\fP should be called whenever these modes/values
change.

\f2fog\fP should represent the desired fog ramp, e.g. \f3\%PFFOG_LINEAR\fP,
\f3\%PFFOG_SPLINE\fP, if \f3\%PFLPS_FOG_MODE_TEX\fP is set or NULL if
not set. The fog ranges are ignored and \f2fog\fP is not modified.

Each of the four main light point features (size, transparency, fog,
and directionality) are view-dependent effects.  Consequently, knowledge
about the viewing and modeling transformations is required in certain
situations:
.RS
.TP 3
1.
When not using \f3\%libpf\fP. Otherwise, \f3\%libpf\fP automatically
informs \f3\%libpr\fP of the viewing and modeling transformations.
.TP
2.
When using an \f3\%ALPHA\fP mechanism, e.g., \f3\%PFLPS_DIR_MODE_ALPHA\fP.
.TP
3.
When \f3\%PFLPS_SIZE_MODE\fP is \f3\%PFLPS_SIZE_MODE_ON\fP.
.RE

Use \f3\%pfViewMat\fP and \f3\%pfModelMat\fP to specify the viewing
and modeling matrices respectively. For best performance, these
routines should be called only when the corresponding matrix changes.
Additionally you may call \f3\%pfInvModelMat\fP to specify the inverse
of the modeling matrix if you've already computed it for some other
reason. When using \f3\%PFLPS_SIZE_MODE_ON\fP, use \f3\%pfNearPixDist\fP
to specify the distance, in pixels, from the eye to the near clip plane.
pfLPointState needs this parameter to map world size
to pixel size (but only if not using \f3\%libpf\fP). \f3\%pfViewMat\fP,
\f3\%pfModelMat\fP, \f3\%pfInvModelMat\fP, and \f3\%pfNearPixDist\fP are all
display-listable commands which may be captured
by an open pfDispList.

\f3\%pfNewLPState\fP creates and returns a handle to a pfLPointState.
\f2arena\fP specifies a malloc arena out of which the pfLPointState is
allocated or \f3\%NULL\fP for allocation off the process heap.
pfLPointStates can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetLPStateClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLPointState\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetLPStateClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfLPointState\fP.  When decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfLPointShape\fP specifies the light distribution characteristics of
directional light points. Light point directions are specified by
pfGeoSet normals after they have been transformed by the current
modeling matrix. Note that a \f3\%PFGS_NORMAL3\fP binding of
\f3\%PFGS_OVERALL\fP is permitted as well as a binding of \f3\%PFGS_PER_VERTEX\fP.
Directional light points require that \f3\%PFLPS_DIR_MODE\fP be
\f3\%PFLPS_DIR_MODE_ON\fP, \f3\%PFLPS_DIR_MODE_ALPHA\fP, or \f3\%PFLPS_DIR_MODE_TEX\fP.

\f2horiz\fP and \f2vert\fP are total-angles angles (not half-angles) in
degrees which specify the horizontal and vertical envelopes about the
direction vector. As such, the maximum value for these angles is 180
degrees, for a 180 degree lobe shape. An envelope is a symmetric
angular spread in a specific plane about the light direction vector.
The default direction is along the positive Y axis so the horizontal
envelope is in the X plane and the vertical in the Z plane. The
envelopes are twisted about the +Y axis by \f2roll\fP degrees, then
rotated by the rotation which takes the +Y axis onto the light point
direction vector. Default values are:

.RS
\f2horiz\fP = 90 degrees
.br
\f2vert\fP = 90 degrees
.br
\f2roll\fP = 0 degrees
.br
\f2falloff\fP = 1
.br
\f2ambient\fP = 0
.RE

When the vector from the eyepoint to the light position is outside its
envelope, the light point's intensity is \f2ambient\fP.  If within, the
intensity of the light point is computed based on the location of the
eye within the elliptical cone.  Intensity ranges from 1.0 when the eye
lies on the light direction vector to \f2ambient\fP on the edge of the cone.
\f2falloff\fP is an exponent which modifies the intensity.  A value of 0
indicates that there is no falloff and values > 0 increase the falloff
rate.  The default \f2falloff\fP is 1.  As intensity decreases, the light
point's transparency increases.

\f3\%pfGetLPointShape\fP copies
\f2lpstate\fP's shape parameters into \f2horiz\fP,
\f2vert\fP, \f2roll\fP, \f2falloff\fP, and \f2ambient\fP.

\f3\%pfLPStateBackColor\fP specifies the back color of \f2lpstate\fP.
If \f2lpstate\fP's shape mode is not \f3\%PFLPS_SHAPE_MODE_BI_COLOR\fP,
then the back color has no effect. \f3\%pfLPStateBackColor\fP copies
\f2lpstate\fP's back color components into \f2r\fP, \f2g\fP, \f2b\fP, \f2a\fP.

\f3\%pfApplyLPState\fP makes \f2lpstate\fP the current pfLPointState which
affects all subsequently drawn pfGeoSets of type \f3\%PFGS_POINTS\fP.
\f3\%pfApplyLPState\fP is a display-listable command which may be captured
by an open pfDispList. A pfLPointState may also be attached to a pfGeoState.
\f3\%pfGetCurLPState\fP returns the current pfLPointState or NULL if there
is none.

.SS LIGHT POINTS PREPROCESSING


Light point processing can be heavy. One way is to reduce the load by using textures,
but reducing the quality and precision of the light points. This may be acceptable
in many case, but is not tolerable for high quality light points.

An other way is to have a separate task to do the processing in parallel with the
drawing of the scene, and then to draw the light points that have already been
preprocessed. (see \f3\%pfPreprocessDList\fP)

In that case, do not use textures simplification. This prevent preprocessing and
also annul the following pfLPointState callbacks. If you do not have a process
dedicated to preprocess light points, and do not use texture simplification in a
pfLPointState, you may use the following callbacks being conscious of the time taken
out of the draw by the callback.

\f3\%pfRasterFunc\fP sets the
\f2rasterCallback\fP function and the user data (\f2data\fP) to the
\f2lpstate\fP.

\f3\%pfGetRasterFunc\fP gives back the
current function and data.

\f3\%pfCalligFunc\fP and
\f3\%pfGetCalligFunc\fP do
the same for the Calligraphic Light Points callback as explained
in the \f3\%pfCalligraphic\fP man pages.

The object of those callbacks is to give access directly to the computation of each
light in the pfGoeSet. The callback will be call when processing the pfLPointState
only if the \f3\%PFLPS_CALLBACK_MODE\fP is not set to \f3\%PFLPS_CALLBACK_MODE_OFF\fP.

Two modes are available:

\f3\%PFLPS_CALLBACK_MODE_PRE\fP makes the callback to be invoked before IRIX Performer standard light points behaviour. Use this to implement your own attenuation algorithm.

\f3\%PFLPS_CALLBACK_MODE_POST\fP makes the callback to be invoked after IRIX Performer do the standard computation. Use this to implement some nice animations, or final touch attenuation computation.


When the callback returns, no further computation is done before the light points are drawn.

The callback function receive many arguments (as defined in pr.h):
.Ex
.nf

typedef struct {
	pfLPointState   *lpstate;  /* Read Only LPState */
	pfGeoSet        *geoset;   /* Read Only GeoSet */
	void            *userData; /* Provided when setting the callback */
	float           *sizes;    /* Write Only - resulting sizes */
	float           *alphas;   /* Write Only - resulting alphas */
	} pfRasterData;
.Ee
.fi
.na

\f2lpstate\fP is the pointer to the pfLPointState beeing processed.

\f2geoset\fP is the pointer to the pfGeoSet beeing processed.

\f2userData\fP is the pointer provided when declaring the callback.

\f2sizes\fP, \f2alphas\fP are the result of the light points computation. They are allready allocated,
even if it is a PRE callback.

The \f2sizes\fP contains the size of each point in pixel unit, and \f2alpha\fP the transparency. The
size is always a positive value, but an alpha value can be negative. A negative value tells
to draw this point with the backColor, with an alpha value of -\f2alpha\fP.

Here is an skeleton of a post callback:
.Ex
.nf


void myCallback(pfRasterData *rasterData)
{
pfVec3* vertices;
unsigned short *vindex;
pfVec3* norms;
unsigned short *nindex;
int nbind;
pfVec4* colors;
unsigned short *cindex;
int cbind;
unsigned short *cindex;
pfFog *fog;
int fogEnabled = 0;
int i,n;

int sizeMode;

pfMatrix ViewMat, InvModelView;
.......
.......

	/* get pointers to the geoset */
	pfGetGSetAttrLists(rasterData->gset,PFGS_COORD3, &vertices, &vindex);
	pfGetGSetAttrLists(rasterData->gset,PFGS_NORMAL3, &norms, &nindex);
	nbind = pfGetGSetAttrBind(rasterData->gset,PFGS_NORMAL3);
	/* colors are usualy not used here */
	cbind = pfGetGSetAttrBind(rasterData->gset,PFGS_COLOR4);
	pfGetGSetAttrLists(rasterData->gset,PFGS_COLOR4, &colors, &cindex);
	/* use color table if enabled */
	if (pfGetEnable(PFEN_COLORTABLE))
		colors = pfGetCurCtab();
	/* get the number of lights */
	n = pfGetGSetNumPrims(rasterData->gset);

	/* get matrices */
	pfGetViewMat(ViewMat);
	pfGetInvModelMat(InvModelMat);

	/* see if there's fog */
	fog = pfGetCurFog();
	if (pfGetEnable(PFEN_FOG) && fog)
	   fogEnabled = 1;

	/* get information on the lpstate */
	sizeMode = pfGetLPStateMode(rasterData->lpstate,PFLPS_SIZE_MODE);
	........
	........
	/* do the computation */
	for (i=0; i<n; i++)
	{
	   /* get the normal */
	   if (vindex)
	   {
	      if (nbind & PFGS_OVERALL)
		  nj=nindex[0];
	      else if (nbind)
	          nj=nindex[i];
 	      else
		  nj=-1; /* this geoset has no normals */

	      nv=vindex[i];
	   } else
	   {
	      if (nbind & PFGS_OVERALL)
	          nj=0;
              else if (nbind)
		  nj=i;
	      else
		  nj=-1; /* this geoset has no normals */

	      nv=i;
	   }
	   /* now we have vertices[nv] and normals[nv] to do the computation */

	   ........
	   ........
	   rasterData->alphas[i] = ....
	   rasterData->sizes[i] = ....
        }
}
.Ee
.fi
.na


\f3\%Calligraphic\fP Light Points are supported using the preprocessing
capability, and the pfCalligraphic object. The calligraphic extensions
to pfLPointState are described in the pfCalligraphic man pages.

.SH NOTES

Falloff distribution is cosine(incidence angle) ^ falloff.

The angle calculation for textured lightpoints may be inaccurate in extreme
wide-angle visibility configurations, and work only for symmetric aperture.

.SH SEE ALSO
pfCalligraphic,
pfDelete,
pfDispList,
pfFog,
pfGeoSet,
pfGeoState,
pfState,
pfTexture,
pfTexGen,
pfuMakeLPStateRangeTex,
pfuMakeLPStateShapeTex
