'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLight" "3pf"
.SH NAME
.upperok
.B pfNewLight,
.B pfGetLightClassType,
.B pfLightColor,
.B pfGetLightColor,
.B pfLightAtten,
.B pfGetLightAtten,
.B pfLightPos,
.B pfGetLightPos,
.B pfSpotLightDir,
.B pfGetSpotLightDir,
.B pfSpotLightCone,
.B pfGetSpotLightCone,
.B pfLightOn,
.B pfLightOff,
.B pfIsLightOn,
.B pfLightAmbient,
.B pfGetLightAmbient,
.B pfGetCurLights
\- 
Create, modify and query lights
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLight\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfLight *
\f3\%pfNewLight\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetLightClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLightColor\fP(pfLight\ *lt,
'in +2
'll -2
int\ which,
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLightColor\fP(const\ pfLight\ *lt,
'in +2
'll -2
int\ which,
float\ *r,
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLightAtten\fP(pfLight*\ light,
'in +2
'll -2
float\ constant,
float\ linear,
float\ quadratic);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLightAtten\fP(pfLight*\ light,
'in +2
'll -2
float\ *constant,
float\ *linear,
float\ *quadratic);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLightPos\fP(pfLight\ *lt,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLightPos\fP(const\ pfLight\ *lt,
'in +2
'll -2
float\ *x,
float\ *y,
float\ *z,
float\ *w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSpotLightDir\fP(pfLight\ *lt,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSpotLightDir\fP(const\ pfLight\ *lt,
'in +2
'll -2
float\ *x,
float\ *y,
float\ *z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSpotLightCone\fP(pfLight\ *lt,
'in +2
'll -2
float\ exponent,
float\ spread);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSpotLightCone\fP(const\ pfLight\ *lt,
'in +2
'll -2
float\ *exponent,
float\ *spread);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLightOn\fP(pfLight\ *lt);
.nf
.fi
.TP
void
\f3\%pfLightOff\fP(pfLight\ *lt);
.nf
.fi
.TP
int
\f3\%pfIsLightOn\fP(pfLight\ *lt);
.nf
.fi
.TP
void
\f3\%pfLightAmbient\fP(pfLight\ *lt,
'in +2
'll -2
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLightAmbient\fP(const\ pfLight\ *lt,
'in +2
'll -2
float\ *r,
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetCurLights\fP(pfLight\ *lights[PF_MAX_LIGHTS]);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLight\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfLight\fP.
Casting an object of class \f3\%pfLight\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLight\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'lt\ \ 'u
\f2lt\fP
identifies a pfLight.
.SH DESCRIPTION

A pfLight is a light source that illuminates scene geometry, generating
realistic shading effects.  A pfLight cannot itself be seen but its
effect is visible through its illuminative effect on scene geometry.
See the OpenGL \f3\%glLight(3g)\fP
man page for more details on lights and individual
lighting parameters.

\f3\%pfNewLight\fP creates and returns a handle to a pfLight.  \f2arena\fP
specifies a malloc arena out of which the pfLight is allocated or
\f3\%NULL\fP for allocation off the process heap.  A NULL pointer is
returned to indicate failure.  pfLights can be deleted with
\f3\%pfDelete\fP.

\f3\%pfGetLightClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLight\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetLightClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfLight\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLightColor\fP accepts a token for the color attribute to set
(\f3\%PFLT_AMBIENT\fP, \f3\%PFLT_DIFFUSE\fP, or \f3\%PFLT_SPECULAR\fP) and
three floating point values (\f2r\fP, \f2g\fP, and \f2b\fP) in the range
[0.0 .. 1.0] defining values for the red, green, and blue components
of the indicated attribute of the light source.  By default, the r,
g, and b values are all 1.0.  \f3\%pfGetLightColor\fP copies the requested
light color values for the given light source and color attribute
into the parameters \f2r\fP, \f2g\fP, and \f2b\fP.

\f3\%pfLightAtten\fP sets the attenuation parameters
of \f2light\fP. The light intensity is scaled at each
vertex by:
.IP
1.0 / (\f2constant\fP + \f2linear\fP * dist + \f2quadratic\fP * dist^2)
.PP
where 'dist' is the distance from the light position to the lit vertex.
Note that 'dist' is 1.0 for infinite light sources. The default
attenuation values are \f2constant\fP = 1.0, \f2linear\fP = 0.0,
\f2quadratic\fP = 0.0, i.e., light attenuation is disabled.
\f3\%pfGetLightAtten\fP returns the
attenuation parameters of \f2light\fP in
\f2constant\fP, \f2linear\fP, and \f2quadratic\fP.
See the \f3\%pfLModelAtten\fP man page
for more information.

\f3\%pfSpotLightDir\fP specifies the direction in which a spot light source
emits its light.  It receives three floating point values, \f2x\fP, \f2y\fP,
and \f2z\fP, specifying the x, y, and z direction vectors.
\f3\%pfGetSpotLightDir\fP copies the x, y, and z direction vectors into the
parameters \f2x\fP, \f2y\fP, and \f2z\fP.

\f3\%pfSpotLightCone\fP specifies the exponent and spread of the spot light
cone, and receives two floating point values, \f2f1\fP and \f2f2\fP, to set
the exponent for the intensity, and the spread of the cone, respectively.
\f3\%pfGetSpotLightCone\fP copies the current exponent and spread of the
cone into the parameters \f2f1\fP and \f2f2\fP.

\f3\%pfLightPos\fP receives four floating point values to set the \f2x\fP,
\f2y\fP, \f2z\fP, and \f2w\fP, coordinates for the position of the light
source.  Typically, the homogeneous coordinate \f2w\fP is 0.0 to indicate
that the light position is infinitely far from the origin in the
direction (\f2x\fP, \f2y\fP, \f2z\fP).  Local light sources are specified by
a non-zero value for \f2w\fP and usually incur a performance penalty.
\f3\%pfGetLightPos\fP copies the x, y, z and w coordinates of the light
source into the parameters \f2x\fP, \f2y\fP, \f2z\fP and \f2w\fP, respectively.

\f3\%pfLightOn\fP enables \f2light\fP so that its illumination will influence
scene geometry if lighting is properly enabled (See below).  The
maximum number of active lights is determined by the particular
graphics library implementation but typically is at least eight.

Modifications made to \f2light\fP do not have effect until \f3\%pfLightOn\fP
is called.

For geometry to be illuminated, the following must be true:
.RS
.TP 5
1.
Lighting must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_LIGHTING\fP)
.TP
2.
A pfLightModel must be applied: \f3\%pfApplyLModel\fP
.TP
3.
A pfMaterial must be applied: \f3\%pfApplyMtl\fP
.TP
4.
One or more pfLights must be on: \f3\%pfLightOn\fP
.TP
5.
Illuminated geometry must have normals: \f3\%pfGSetAttr\fP, \f3\%PFGS_NORMAL3\fP
.RE

\f3\%pfLightOn\fP also affects the position of the light in the scene.
When called, the current graphics library ModelView matrix transforms
the position of the light set by \f3\%pfLightPos\fP.  Calling \f3\%pfLightOn\fP
when specific transformations are on the stack will result in different
light behaviors, which are outlined in the following paragraphs.

To simulate a light attached to the viewer (simulating a miner's head-mounted
lamp) call \f3\%pfLightOn\fP only once with an identity matrix on the stack:
.Ex
.nf

pfLightPos(viewerLight, 0.0, 0.0, 1.0, 0.0);

/*
 * viewerLight always points in direction of view, i.e. - down -Z axis.
 */
pfPushIdentMatrix();
pfLightOn(viewerLight);
pfPopMatrix();

/* Draw scene */
.Ee
.fi
.na


To simulate a light "attached" to the world (at a fixed location in
world-space coordinates like the sun or moon) call \f3\%pfLightOn\fP every
frame with only the viewing transformation on the stack:
.Ex
.nf

pfLightPos(sunLight, 0.0, 1.0, 0.0, 0.0);

pfPushIdentMatrix();

/* viewer is at origin looking +30 degrees 'up' */
pfRotate(PF_X, -30.0f);

/* sunLight always points straight down on scene */
pfLightOn(sunLight);

/* Draw scene */

pfPopMatrix();
.Ee
.fi
.na


To simulate a light attached to an object like the headlights of a car,
call \f3\%pfLightOn\fP every frame with the combined viewing and modeling
transformation on the stack:
.Ex
.nf

pfLightPos(headLight, 2.0, 0.0, 0.0, 1.0);

pfPushIdentMatrix();

/* Viewer is at origin looking +30 degrees 'up' */
pfRotate(PF_X, -30.0f);

/* Car is at (100.0f, 100.0f, 100.0f) */
pfTranslate(100.0f, 100.0f, 100.0f);

/*
 * carLight is a point light source at the front of the car
 * provided the car is modeled such that the headlights are
 * 2 units from the center of the car in the +X direction.
 */
pfLightOn(headLight);

/* Draw scene */

pfPopMatrix();
.Ee
.fi
.na


\f3\%pfLightOff\fP disables \f2light\fP so that it does not contribute to
scene illumination.

\f3\%pfIsLightOn\fP returns a boolean indicating whether \f2light\fP is on or
not.

\f3\%pfGetCurLights\fP returns the number of currently active lights,
\f2n\fP.  The array \f2lights\fP is filled with \f2n\fP pointers to the
pfLight structures of the light sources that are currently ``on''.

The light source state element is identified by the \f3\%PFSTATE_LIGHT\fP
token.  Use this token with \f3\%pfGStateAttr\fP to set the light array of
a pfGeoState and with \f3\%pfOverride\fP to override subsequent light
source changes:

\f3\%pfLightAmbient\fP is provided for compatibility with previous versions
of OpenGL Performer. It accepts three floating point values in the range
from 0.0 through 1.0 to set the \f2r\fP, \f2g\fP, and \f2b\fP, values for the
red, green, and blue components of the ambient light.  By default,
lights have ambient red, green, and blue values of 0.0.
\f3\%pfGetLightAmbient\fP copies the ambient light values for the given
light source into the parameters \f2r\fP, \f2g\fP, and \f2b\fP.
For future compatibility, calls to:
.Ex
.nf

pfLightAmbient(lt, r, g, b);
.Ee
.fi
.na


should be replaced by
.Ex
.nf

pfLightColor(lt, \f3\%PFLT_AMBIENT\fP, r, g, b);
.Ee
.fi
.na

and calls to:
.Ex
.nf

pfGetLightAmbient(lt, &r, &g, &b);
.Ee
.fi
.na


should be replaced by
.Ex
.nf

pfGetLightColor(lt, \f3\%PFLT_AMBIENT\fP, &r, &g, &b);
.Ee
.fi
.na

.SH EXAMPLES
Example 1:
.Ex
.nf

pfLight		*lightArray[PF_MAX_LIGHTS];

for (i=0; i<PF_MAX_LIGHTS; i++)
    lightArray[i] = NULL;

lightArray[0] = light0;
lightArray[1] = light1;

/* Set up specially-lit pfGeoState */
pfGStateMode(gstate, PFSTATE_ENLIGHTING, PF_ON);
pfGStateAttr(gstate, PFSTATE_LIGHT, lightArray);

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Set normal array. 'gset' is non-indexed */
pfGSetAttr(gset, PFGS_NORMAL3, PFGS_PER_VERTEX, norms, NULL);

/* Draw specially-lit gset */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

pfLightOn(light0);
pfLightOn(light1);

/*
 * Override so that all geometry is lit with light0 and light1
 * if lighting is otherwise properly enabled.
 */
pfOverride(PFSTATE_LIGHT, PF_ON);
.Ee
.fi
.na


The array of lights passed to \f3\%pfGStateAttr\fP should be \f3\%PF_MAX_LIGHTS\fP
long and should contain references to pfLights that are to be used by
the pfGeoState.  Empty array elements should be set to \f3\%NULL\fP.

\f3\%pfLightOn\fP and \f3\%pfLightOff\fP are display-listable commands.  If a
pfDispList has been opened by \f3\%pfOpenDList\fP, \f3\%pfLightOn\fP and
\f3\%pfLightOff\fP will not have immediate effect but will be captured by
the pfDispList and will only have effect when that pfDispList is later
drawn with \f3\%pfDrawDList\fP.
.SH NOTES

Local lighting results in improper shading of flat-shaded
triangle and line strips (\f3\%PFGS_FLAT_TRISTRIPS\fP, \f3\%PFGS_LINE_TRISTRIPS\fP)
which often manifests itself as "faceting" of planar polygons.
The only solution is either to use infinite lighting or not use FLAT primitives.
Note that when using the OpenGL Performer triangle meshing routine,
\f3\%pfdMeshGSet\fP, the construction of non-FLAT strips is easily enforced
with \f3\%pfdMesherMode(PFDMESH_LOCAL_LIGHTING, 1)\fP.
.SH SEE ALSO
pfDelete,
pfDispList,
pfGeoState,
pfLightModel,
pfMaterial,
pfObject,
pfOverride,
pfState,
lmbind,
lmcolor,
lmdef,
glLight,
glColorMaterial
