'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLightModel" "3pf"
.SH NAME
.upperok
.B pfNewLModel,
.B pfGetLModelClassType,
.B pfApplyLModel,
.B pfLModelAtten,
.B pfGetLModelAtten,
.B pfLModelLocal,
.B pfGetLModelLocal,
.B pfLModelTwoSide,
.B pfGetLModelTwoSide,
.B pfLModelAmbient,
.B pfGetLModelAmbient,
.B pfGetCurLModel
\- 
Create, modify and query lighting model
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLightModel\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfLightModel *
\f3\%pfNewLModel\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetLModelClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfApplyLModel\fP(pfLightModel\ *lm);
.nf
.fi
.TP
void
\f3\%pfLModelAtten\fP(pfLightModel\ *lm,
'in +2
'll -2
float\ a0,
float\ a1,
float\ a2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLModelAtten\fP(const\ pfLightModel\ *lm,
'in +2
'll -2
float\ *a0,
float\ *a1,
float\ *a2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLModelLocal\fP(pfLightModel\ *lm,
'in +2
'll -2
int\ l);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetLModelLocal\fP(const\ pfLightModel\ *lm);
.nf
.fi
.TP
void
\f3\%pfLModelTwoSide\fP(pfLightModel\ *lm,
'in +2
'll -2
int\ t);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetLModelTwoSide\fP(const\ pfLightModel\ *lm);
.nf
.fi
.TP
void
\f3\%pfLModelAmbient\fP(pfLightModel\ *lm,
'in +2
'll -2
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLModelAmbient\fP(const\ pfLightModel\ *lm,
'in +2
'll -2
float\ *r,
float\ *g,
float\ *b);
.in
.ll
.nf
.fi
.TP
pfLightModel *
\f3\%pfGetCurLModel\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLightModel\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfLightModel\fP.
Casting an object of class \f3\%pfLightModel\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLightModel\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'lm\ \ 'u
\f2lm\fP
identifies a pfLightModel.
.SH DESCRIPTION

A pfLightModel defines characteristics of the hardware lighting model
used to illuminate geometry.
See the OpenGL \f3\%glLightModel(3g)\fP man page for more details on
lighting environments and individual parameters.

\f3\%pfNewLModel\fP creates and returns a handle to a pfLightModel.
\f2arena\fP specifies a malloc arena out of which the pfLightModel is
allocated or \f3\%NULL\fP for allocation off the process heap.  A NULL
pointer is returned to indicate failure.  pfLightModels can be deleted
with \f3\%pfDelete\fP.

\f3\%pfGetLModelClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLightModel\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetLModelClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfLightModel\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLModelAtten\fP sets the lighting attenuation factors for \f2lm\fP.
\f2a1\fP, \f2a2\fP, and \f2a3\fP specify the constant, linear, and
second-order attenuation factors, respectively.  These factors are
associated with all non-infinite lights.  The default values for
constant, linear, and quadratic attenuation factors are 1.0, 0.0,
and 0.0, respectively, effectively disabling each.
Note that OpenGL light attenuation is done per-light.
See the \f3\%pfLightAtten\fP man page for more
information.

\f3\%pfGetLModelAtten\fP copies the lighting attenuation factors for \f2lm\fP
into the parameters \f2a1\fP, \f2a2\fP, and \f2a3\fP.

\f3\%pfLModelLocal\fP specifies whether the light reflection calculations
are to be done based on a local or infinite viewpoint.  The default is
\f3\%PF_OFF\fP signifying an infinite viewer for the light model.  In
general, local lighting is more expensive than infinite lighting.

\f3\%pfGetLModelLocal\fP returns a boolean value signifying whether or not
the effective viewpoint in \f2lm\fP is a local viewpoint.

\f3\%pfLModelTwoSide\fP specifies whether two-sided lighting is to be used
in the given light model.  The default is \f3\%PF_OFF\fP, disabling two-sided
lighting.  See the OpenGL \f3\%glLightModel\fP
man page for more details on two-sided lighting.

\f3\%pfGetLModelTwoSide\fP returns the setting of \f2lm\fP's two-sided
lighting mode.

\f3\%pfLModelAmbient\fP receives three floating point values in the range
from 0.0 through 1.0 to set the red, green, and blue, values for the
amount of the ambient light associated with the scene for the given
light model.

\f3\%pfGetLModelAmbient\fP copies the red, green, and blue components of
the ambient in the given light model into the parameters \f2r\fP, \f2g\fP,
and \f2b\fP, respectively.  The default value for the ambient red, green,
and blue light components is 0.2.

\f3\%pfApplyLModel\fP causes \f2lm\fP, with its current settings, to become
the current lighting model.  When lighting is enabled (See below), this
lighting model will be applied to all geometry drawn after
\f3\%pfApplyLModel\fP is called.  Modifications to \f2lm\fP, such as changing
the ambient color, or setting two-sided lighting, will not be applied
until \f3\%pfApplyLModel\fP is called with \f2lm\fP.

For geometry to be illuminated, the following must be true:
.RS
.TP 5
1.
Lighting must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_LIGHTING\fP)
.TP
2.
A pfLightModel must be applied: \f3\%pfApplyLModel\fP
.TP
3.
A pfMaterial must be applied: \f3\%pfApplyMtl\fP
.TP
4.
One or more pfLights must be on: \f3\%pfLightOn\fP
.TP
5.
Illuminated geometry must have normals: \f3\%pfGSetAttr\fP, \f3\%PFGS_NORMAL3\fP
.RE

The lighting model state element is identified by the
\f3\%PFSTATE_LIGHTMODEL\fP token.  Use this token with \f3\%pfGStateAttr\fP to
set the lighting model of a pfGeoState and with \f3\%pfOverride\fP to
override subsequent lighting model changes:
.SH EXAMPLES
Example 1:
.Ex
.nf

pfLModelTwoSide(lmodel, PF_ON);

/* Set up two-sided lighting pfGeoState */
pfGStateMode(gstate, PFSTATE_ENLIGHTING, PF_ON);
pfGStateAttr(gstate, PFSTATE_LIGHTMODEL, lmodel);
pfGStateAttr(gstate, PFSTATE_FRONTMTL, mtl);
pfGStateAttr(gstate, PFSTATE_BACKMTL, mtl);
pfGStateMode(gstate, PFSTATE_CULLFACE, PF_OFF);

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Set normal array. 'gset' is non-indexed */
pfGSetAttr(gset, PFGS_NORMAL3, PFGS_PER_VERTEX, norms, NULL);

/* Draw lit, two-sided gset */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

pfApplyLModel(lmodel);

/* Override so that all geometry is lit with 'lmodel' */
pfOverride(PFSTATE_LIGHTMODEL, PF_ON);
.Ee
.fi
.na


\f3\%pfApplyLModel\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfApplyLModel\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

\f3\%pfGetCurLModel\fP returns a pointer to the currently active
pfLightModel, or NULL if there is no active pfLightModel.
.SH SEE ALSO
pfDelete,
pfDispList,
pfGeoState,
pfLight,
glLightModel,
pfMaterial,
pfObject,
pfState,
lmbind,
lmcolor,
lmdef
