'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLightPoint" "3pf"
.SH NAME
.upperok
.B pfNewLPoint,
.B pfGetLPointClassType,
.B pfGetNumLPoints,
.B pfLPointSize,
.B pfGetLPointSize,
.B pfLPointColor,
.B pfGetLPointColor,
.B pfLPointRot,
.B pfGetLPointRot,
.B pfLPointShape,
.B pfGetLPointShape,
.B pfLPointFogScale,
.B pfGetLPointFogScale,
.B pfLPointPos,
.B pfGetLPointPos,
.B pfGetLPointGSet
\- 
Set and get pfLightPoint size, color, shape, rotation and position.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLightPoint\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfLightPoint *
\f3\%pfNewLPoint\fP(int\ num);
.nf
.fi
.TP
pfType *
\f3\%pfGetLPointClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetNumLPoints\fP(const\ pfLightPoint\ *lpoint);
.nf
.fi
.TP
void
\f3\%pfLPointSize\fP(pfLightPoint\ *lpoint,
'in +2
'll -2
float\ size);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetLPointSize\fP(const\ pfLightPoint\ *lpoint);
.nf
.fi
.TP
void
\f3\%pfLPointColor\fP(pfLightPoint\ *lpoint,
'in +2
'll -2
int\ index,
pfVec4\ clr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPointColor\fP(const\ pfLightPoint\ *lpoint,
'in +2
'll -2
int\ index,
pfVec4\ clr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPointRot\fP(pfLightPoint\ *lpoint,
'in +2
'll -2
float\ azim,
float\ elev,
float\ roll);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPointRot\fP(const\ pfLightPoint\ *lpoint,
'in +2
'll -2
float\ *azim,
float\ *elev,
float\ *roll);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPointShape\fP(pfLightPoint\ *lpoint,
'in +2
'll -2
int\ dir,
float\ henv,
float\ venv,
float\ falloff);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPointShape\fP(const\ pfLightPoint\ *lpoint,
'in +2
'll -2
int\ *dir,
float\ *henv,
float\ *venv,
float\ *falloff);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPointFogScale\fP(pfLightPoint\ *lpoint,
'in +2
'll -2
float\ onsetScale,
float\ opaqueScale);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPointFogScale\fP(const\ pfLightPoint\ *lpoint,
'in +2
'll -2
float\ *onsetScale,
float\ *opaqueScale);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLPointPos\fP(pfLightPoint\ *lpoint,
'in +2
'll -2
int\ index,
pfVec3\ pos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLPointPos\fP(const\ pfLightPoint\ *lpoint,
'in +2
'll -2
int\ index,
pfVec3\ pos);
.in
.ll
.nf
.fi
.TP
pfGeoSet*
\f3\%pfGetLPointGSet\fP(const\ pfLightPoint\ *lpoint);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLightPoint\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfLightPoint\fP.
Casting an object of class \f3\%pfLightPoint\fP
to an object of class \f3\%pfNode\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfLightPoint\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLightPoint\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'lpoint\ \ 'u
\f2lpoint\fP
identifies a pfLightPoint.
.SH DESCRIPTION

pfLightPoint is now obsoleted in favor of the \f3\%libpr\fP primitive
pfLPointState. \f3\%pfGetLPointGSet\fP returns the underlying pfGeoSet
of \f2lpoint\fP
from which the pfLPointState can be found:

.Ex
.nf

gset = pfGetLPointGSet(lpoint);
gstate = pfGetGSetGState(gset);
lpstate = pfGetGStateAttr(gstate, PFSTATE_LPOINTSTATE);
.Ee
.fi
.na


A pfLightPoint is a pfNode that contains one or more light points.  The
light point node is quite different from a pfLightSource; it is visible
as one or more self-illuminated small points but these points do not
illuminate surrounding objects. In contrast to this, a pfLightSource does
illuminate scene contents but is itself not a visible object.  All the
light points in a pfLightPoint node share all their attributes except
point location and color.

\f3\%pfNewLPoint\fP creates and returns a handle to a pfLightPoint.  Like
other pfNodes, pfLightPoints are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.
\f2num\fP specifies the maximum number of individual light points the
node may contain. The function
\f3\%pfGetNumLPoints\fP returns this
maximum number of light points that the pfLightPoint node
\f2lpoint\fP can hold.  This is the value set when the light point
node was created using \f3\%pfNewLPoint\fP and is
the size of the internal position and color arrays used to represent
the light points.

\f3\%pfGetLPointClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLightPoint\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetLPointClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfLightPoint\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLPointSize\fP sets the screen size of each point of light in
\f2lpoint\fP.  \f2size\fP is specified in pixels and is used as the
argument to \f3\%pntsizef\fP.  Whenever possible, antialiased points are
used but the actual representation of a light point depends on the
hardware being used.  See the \f3\%pntsizef\fP man page for a description
of available light point sizes on OpenGL hardware.  \f3\%pfGetLPointSize\fP
returns the size of \f2lpoint\fP.

\f3\%pfLPointColor\fP sets the color of light point \f2index\fP in \f2lpoint\fP
to \f2clr\fP.  The actual color displayed depends on light point direction,
shape, position, and fog.  \f2clr\fP specifies red, green, blue and alpha
in the range 0.0 to 1.0.  A pfLightPoint is turned off with an alpha of
0.0 since it will be rendered as completely transparent.
\f3\%pfGetLPointColor\fP copies the \f2index\fPth color into \f2clr\fP.

\f3\%pfLPointRot\fP is used for directional lights.  The direction of all
light points in \f2lpoint\fP is the positive Y axis, rotated about the X
axis by \f2elev\fP then rotated about the Z axis by \f2azim\fP.  \f2roll\fP
only affects the light envelope as described below.  The direction
vector is rotated by any transformations (see pfSCS, pfDCS) above
\f2lpoint\fP in the hierarchy.

\f3\%pfGetLPointRot\fP copies \f2lpoint\fP's rotation into \f2azim\fP,
\f2elev\fP, and \f2roll\fP.

\f3\%pfLPointShape\fP describes the intensity distribution of a light point
about its direction vector.  \f2dir\fP is a symbolic token:
.RS
.TP 5
\f3\%PFLP_OMNIDIRECTIONAL\fP
\f2lpoint\fP will be drawn as omnidirectional light points.  Light
distribution is equal in all directions.  All other arguments are
ignored.
.TP
\f3\%PFLP_UNIDIRECTIONAL\fP
\f2lpoint\fP will be drawn as unidirectional point lights.  Light
distribution is an elliptical cone centered about the light direction
vector.
.TP
\f3\%PFLP_BIDIRECTIONAL\fP
\f2lpoint\fP will be drawn as bidirectional light points.  Light
distribution is two elliptical cones centered about the positive and
negative light direction vectors.
.RE

\f2henv\fP and \f2venv\fP are total angles (not half-angles) in degrees which
specify the horizontal and vertical envelopes about the direction
vector.  An envelope is a symmetric angular spread in a specific plane
about the light direction vector.  The default direction is along the
positive Y axis so the horizontal envelope is in the X plane and the
vertical in the Z plane.  Both direction and envelopes are rotated by
the \f3\%pfLPointRot\fP and any inherited transformations.  The default
envelope angles are 360.0 degrees which is equivalent to an
omnidirectional light.

When the vector from the eyepoint to the light position is outside a
light's envelope, the light point is not displayed.  If within, the
intensity of the light point is computed based on the location of the
eye within the elliptical cone.  Intensity ranges from 1.0 when the eye
lies on the light direction vector to 0.0 on the edge of the cone.
\f2falloff\fP is an exponent which modifies the intensity.  A value of 0
indicates that there is no falloff and values > 0 increase the falloff
rate.  The default \f2falloff\fP is 4.  As intensity decreases, the light
point's transparency increases.

\f3\%pfGetLPointShape\fP copies \f2lpoint\fP's shape parameters into
\f2dir\fP, \f2henv\fP, \f2venv\fP, and \f2falloff\fP.

In general, the real world intensity of emissive light points is much
greater than that of reflective surfaces.  Consequently, when fog is
active, light points should be more visible through the fog.
\f3\%pfLPointFogScale\fP sets the fog range scale factors that affects all
light points in \f2lpoint\fP.  \f2onsetScale\fP and \f2opaqueScale\fP multiply
the onset and opaque ranges (\f3\%pfFogRange\fP) of the currently active
fog.  Thus if the scale factors are greater than 1.0, the light points
will be more visible through fog than reflective surfaces.  The default
fog scale factors are both 4.0.  \f3\%pfGetLPointFogScale\fP copies the fog
scale factors of \f2lpoint\fP into \f2onsetScale\fP and \f2opaqueScale\fP.

\f3\%pfLPointPos\fP sets the position of light point with index \f2index\fP
to \f2pos\fP.  \f2index\fP is clamped to the range [0, \f2num\fP-1].  All
positions are transformed by any inherited transformations.  The final
position and orientation of a light point \f2i\fP is transformed by \f3\%R *
T[index] * M\fP where \f3\%R\fP is a rotation matrix defined by
\f3\%pfLPointRot\fP, \f3\%T[i]\fP is the position of light point \f2i\fP, and
\f3\%M\fP is the transformation inherited by \f2lpoint\fP from its
hierarchy.

\f3\%pfGetLPointPos\fP copies the \f2index\fPth position into \f2pos\fP.
.SH NOTES

Light point processing in OpenGL Performer has been subsumed by the
new \f3\%pfLPointState\fP mechanism, which is both more powerful and
more efficient. Application developers are encouraged to transition
to these new light point facilities.

\f3\%pfLightPoint\fP nodes, unlike \f3\%pfLPointState\fP GeoSets, do not provide
size or intensity modulation based on distance to the viewer and the
viewport size. Also, directional lights are significantly more expensive
to cull than omnidirectional lights.

Falloff distribution is cosine(incidence angle) ^ falloff.

When sorting is enabled (see \f3\%pfChanTravMode\fP and \f3\%PFCULL_SORT\fP),
light points are drawn after opaque geometry unless the pfLightPoint node
has a pre-draw or post-draw callback (see \f3\%pfNodeTravFuncs\fP).
.SH SEE ALSO
pfLookupNode,
pfNode,
pfLPointState
