'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfLightSource" "3pf"
.SH NAME
.upperok
.B pfNewLSource,
.B pfGetLSourceClassType,
.B pfLSourceAmbient,
.B pfGetLSourceAmbient,
.B pfLSourceColor,
.B pfGetLSourceColor,
.B pfLSourceAtten,
.B pfGetLSourceAtten,
.B pfSpotLSourceDir,
.B pfGetSpotLSourceDir,
.B pfSpotLSourceCone,
.B pfGetSpotLSourceCone,
.B pfLSourcePos,
.B pfGetLSourcePos,
.B pfLSourceOn,
.B pfLSourceOff,
.B pfIsLSourceOn,
.B pfLSourceMode,
.B pfGetLSourceMode,
.B pfLSourceVal,
.B pfGetLSourceVal,
.B pfLSourceAttr,
.B pfGetLSourceAttr
\- 
Create pfLightSource, specify pfLightSource properties.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfLightSource\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfLightSource *
\f3\%pfNewLSource\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetLSourceClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfLSourceAmbient\fP(pfLightSource*\ lsource,
'in +2
'll -2
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLSourceAmbient\fP(pfLightSource*\ lsource,
'in +2
'll -2
float*\ r,
float*\ g,
float*\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLSourceColor\fP(pfLightSource*\ lsource,
'in +2
'll -2
int\ which,
float\ r,
float\ g,
float\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLSourceColor\fP(pfLightSource*\ lsource,
'in +2
'll -2
int\ which,
float*\ r,
float*\ g,
float*\ b);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLSourceAtten\fP(pfLightSource*\ light,
'in +2
'll -2
float\ constant,
float\ linear,
float\ quadratic);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLSourceAtten\fP(pfLightSource*\ light,
'in +2
'll -2
float\ *constant,
float\ *linear,
float\ *quadratic);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSpotLSourceDir\fP(pfLightSource*\ lsource,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSpotLSourceDir\fP(pfLightSource*\ lsource,
'in +2
'll -2
float*\ x,
float*\ y,
float*\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSpotLSourceCone\fP(pfLightSource*\ lsource,
'in +2
'll -2
float\ f1,
float\ f2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSpotLSourceCone\fP(pfLightSource*\ lsource,
'in +2
'll -2
float*\ f1,
float*\ f2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLSourcePos\fP(pfLightSource*\ lsource,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetLSourcePos\fP(pfLightSource*\ lsource,
'in +2
'll -2
float*\ x,
float*\ y,
float*\ z,
float*\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLSourceOn\fP(pfLightSource*\ lsource);
.nf
.fi
.TP
void
\f3\%pfLSourceOff\fP(pfLightSource*\ lsource);
.nf
.fi
.TP
int
\f3\%pfIsLSourceOn\fP(pfLightSource*\ lsource);
.nf
.fi
.TP
void
\f3\%pfLSourceMode\fP(pfLightSource\ *lsource,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetLSourceMode\fP(const\ pfLightSource\ *lsource,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLSourceVal\fP(pfLightSource\ *lsource,
'in +2
'll -2
int\ mode,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetLSourceVal\fP(const\ pfLightSource\ *lsource,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLSourceAttr\fP(pfLightSource\ *lsource,
'in +2
'll -2
int\ attr,
void\ *obj);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfGetLSourceAttr\fP(const\ pfLightSource\ *lsource,
'in +2
'll -2
int\ attr);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfLightSource\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfLightSource\fP.
Casting an object of class \f3\%pfLightSource\fP
to an object of class \f3\%pfNode\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfLightSource\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfLightSource\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'lsource\ \ 'u
\f2lsource\fP
identifies a pfLightSource.
.SH DESCRIPTION

A pfLightSource is a pfNode which can illuminate geometry in a
pfScene. In addition, pfLightSource supports a technique known as
"projected texturing" which can simulate high quality, real time spotlights
and shadows on certain graphics hardware.

\f3\%pfNewLSource\fP creates and returns a handle to a pfLightSource.
Like other pfNodes, pfLightSources are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetLSourceClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfLightSource\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetLSourceClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfLightSource\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

Most pfLightSource routines are borrowed from pfLight.
These routines
have the identical function as the pfLight routines but operate on
a pfLightSource rather than a pfLight. The routine correspondence is listed
in the following table.

.TS
center tab($);
C | C
L | L .
pfLightSource routine$pfLight routine
_
pfLSourceAmbient$pfLightAmbient
pfGetLSourceAmbient$pfGetLightAmbient
pfLSourceColor$pfLightColor
pfLSourceAtten$pfLightAtten
pfGetLSourceColor$pfGetLightColor
pfLSourcePos$pfLightPos
pfGetLSourcePos$pfGetLightPos
pfSpotLSourceCone$pfSpotLightCone
pfGetSpotLSourceCone$pfGetSpotLightCone
pfSpotLSourceDir$pfSpotLightDir
pfGetSpotLSourceDir$pfGetSpotLightDir
pfLSourceOn$pfLightOn
pfLSourceOff$pfLightOff
pfIsLSourceOn$pfIsLightOn
.TE

The reader is referred to the pfLight man page
for details on the routine description.

When enabled by \f3\%pfLSourceOn\fP, a pfLightSource influences all geometry
that is in the same pfScene if it is not culled during the cull
traversal.  Its position in the hierarchy does not affect its area of
influence.  A pfLightSource is enabled by default and is explicitly
disabled with \f3\%pfLSourceOff\fP.

pfLightSources are processed somewhat differently than other nodes.  If
the \f3\%PFCULL_IGNORE_LSOURCES\fP mode is not enabled by
\f3\%pfChanTravMode\fP, the cull stage will begin with a special traversal
of all paths which lead from the current pfScene to pfLightSources
before it traverses the pfScene geometry.  This initial traversal is no
different from the ordinary cull traversal except that the traversal
order is path-directed rather than an in-order traversal.
Specifically, all switches (pfSwitch, pfLOD, pfSequence) and
transformations (pfSCS, pfDCS) will affect the traversal.  Note that
nodes that lie on paths to pfLightSource nodes will be traversed
multiple times; specifically, any cull or draw callbacks
(\f3\%pfNodeTravFuncs\fP) will be invoked multiple times.

pfLightSources are culled to the viewing frustum only if they have been
assigned a non-null bounding volume (\f3\%pfNodeBSphere\fP).  If a pfLightSource
has a null bounding volume (radius < 0) then it is not culled and has
global effect over its pfScene.  By default pfLightSources have null
bounding volumes.  After the pfLightSource traversal comes the database
traversal which (usually) visually culls the current pfScene and
ignores pfLightSources.

A pfLightSource inherits the current transformation from any pfSCSes
and pfDCSes above it in the hierarchy.  This matrix transforms the light
source's position and direction depending on the light's type, i.e.-
if it is a local, infinite, or spotlight.

All hardware lights corresponding to pfLightSources in a pfScene will
be properly configured before the pfChannel's draw callback is invoked
(see \f3\%pfChanTravFunc\fP).  Consequently, all geometry rendered in the
pfChannel draw callback will be illuminated by the pfScene's light
sources.  However, any draw callback assigned to the pfLightSource node
by \f3\%pfNodeTravFuncs\fP will be invoked before the pfChannel draw
callback is invoked so that anything drawn in the node callback will be
obscured if the channel viewport is cleared (see \f3\%pfClearChan\fP).
Example 1: Adding a pfLightSource to a pfScene.
.Ex
.nf

sun = pfNewLSource();

/* Set slightly yellow color */
pfLSourceColor(sun, PFLT_DIFFUSE, 1.0f, 1.0f, .8f);

/* Set a high ambient level */
pfLSourceColor(sun, PFLT_AMBIENT, .4f, .4f, .3f);

/* Time of day is high noon */
pfLSourcePos(sun, 0.0f, 1.0f, 0.0f, 0.0f);

pfAddChild(scene, sun);
.Ee
.fi
.na


A pfLightSource supports 3 different lighting mechanisms as listed in the
following table:

.TS
center tab($) ;
c | c | c | c | c | c .
Lighting$Normals$Texture$Effects Are$Shadows$Extra Draw
Method$Used$Required$Per-?$$Pass(es)
_
pfLight$Yes$No$Vertex$No$None
PROJTEX$No$Yes$Pixel$No$+(0-1)
SHADOW$No$Auto$Pixel$Yes$+(0-2)
.TE

The normal use of a pfLightSource is as a pfLight which computes lighting
at geometry vertices, taking into account the surface curvature
as represented by geometry normals. This kind of lighting offers the
highest performance but does not produce per-pixel effects or shadows.
Lighting using projected textures, referred to as PROJTEX, produces
high quality spotlights since the spotlight boundary is computed on
a per-pixel, rather than a per-vertex basis as it is with pfLight.
However, PROJTEX lighting does not take surface normals into account,
requires hardware texture mapping for decent performance, and requires
that textured geometry be rendered twice, once with their normal texture
and once with the projected texture. SHADOW lighting is similar to
PROJTEX but adds shadows at the cost of an additional rendering pass.
In this case a special texture map, called a shadow map, is automatically
generated by the pfLightSource and then projected onto the scene.
Typically, pfLight-type lighting is used in conjunction with PROJTEX or SHADOW
so that lighting is a function of both per-pixel projected texturing
and per-vertex surface curvature.

Two different algorithms are implemented in performer. One for IrisGL,
with shadows only on RE2, unchanged since 2.0 release. One for OpenGL,
with shadows only on IR, introduced in 2.2 release. The main difference
between those 2 algorithms is that the IrisGL algorithm requires an
alpha plane if more than one multipass light is used, the OpenGL
algorithm use only color planes.

The IrisGL algorithm is:
- draw a pass will all lights on. Using the textures in the database
- Blend all the PROJTEX and SHADOW in the alpha plane, using texgen
- Multiply the results

Because this algorithm uses alpha, it can only take account of the intensity
of the SHADOW/PROJTEX, and merge all colors together in a first pass.
This is why 2 PROJTEX with different colors will result in 2 PROJTEX
with one merged color.
The last pass is done at the same time as the last PROJTEX/SHADOW pass,
at no additional cost.

If the database is non texture, the first pass can be done at the same
time as the first PROJTEX/SHADOW pass. So a non textured database, with
one PROJTEX/SHADOW is done in a single pass.

There is no distinction between PROJTEX and SHADOW in the second pass,
all intensities are multiplied together.

The OpenGL algorithm is:
- draw a pass with all non PROJTEX/SHADOW pfLightSources
- Additive Blend all the PROJTEX
- Multiplicative Blend all the SHADOW
- Draw the scene with its own textures and multiply on each RGB component
with the previous result
There is one more pass with the OpenGL algorith (the first), if non PROJTEX/SHADOW
pfLightSources are in the Scene.

SHADOW and PROJTEX lighting are separately enabled and disabled
with the \f3\%PFLS_SHADOW_ENABLE\fP and \f3\%PFLS_PROJTEX_ENABLE\fP tokens
to \f3\%pfLSourceMode\fP. \f2val\fP should be either \f3\%PF_ON\fP or \f3\%PF_OFF\fP.
When either is enabled, pfChannels rendering the pfLightSource's scene
automatically enter "multipass mode" since multiple renderings of the
scene are usually required.

\f3\%pfChanTravMode\fP with the
\f3\%PFTRAV_MULTIPASS\fP traversal token offers some control over the
multiple renderings of the scene.
With IrisGL, The \f3\%PFMPASS_GLOBAL_AMBIENT\fP bit
indicates that the alpha bitplanes of the pfChannel's viewport contain
the ambient intensity of the scene.  Note that the pfChannel will not
clear the viewport alpha to this intensity but expects it to have
already been properly cleared. If using a pfEarthSky to clear the
viewport, you can specify the ambient alpha with
\f3\%pfESkyColor\fP. Global ambient is not
required and does have some extra cost. It is not particularly useful
for PROJTEX lighting since ambient intensity can be easily
incorporated in the projected texture (instead of black, just use gray
outside the spotlight) but is useful for SHADOWS which otherwise would
be completely black.
With OpenGL, this bit has no effect, and the Shadow intensity is given
by the PFLS_INTENSITY value of the light source, 0 is a full dark shadow.

By default, emissive surfaces (including light points) are attenuated
by PROJTEX and SHADOW lighting which is not correct since emissive surfaces
should shine even if in shadow or outside the cone of a projected spotlight.
If a scene has emissive surfaces, set the \f3\%PFMPASS_EMISSIVE_PASS\fP bit
in the \f3\%PFTRAV_MULTIPASS\fP mode and the emissive surfaces will be
properly rendered. Note that the emissive rendering pass is not a full pass -
rather it is a pass of only the emissive surfaces.

In situations where the scene is entirely non-textured,
\f3\%PFMPASS_NONTEX_SCENE\fP can be specified as part of the
\f3\%PFTRAV_MULTIPASS\fP traversal mode of a pfChannel. In this case a
complete rendering pass is eliminated.

PROJTEX lighting requires that a pfTexture be specified with the
\f3\%PFLS_PROJ_TEX\fP token to
\f3\%pfLSourceAttr\fP. \f2obj\fP should be an
intensity-alpha (2-component) pfTexture* with identical intensity and
alpha components if using IrisGL. With OpenGL, the alpha component of the
projected texture will modify the transparency of the objects in the scene. If
this is not desired, the alpha component of the texture should be zeroed.

With OpenGL, the textures may also be a full color 4-component texture. With
IrisGL, a color texture can be used if this is the only pfLightSource in
the scene using PROJTEX lighting.

SHADOW lighting does not require a pfTexture, rather one is
automatically created and configured by the pfLightSource.
The size of the texture(shadow) map may be specified with the \f3\%PFLS_SHADOW_SIZE\fP
token to \f3\%pfLSourceVal\fP. \f2val\fP is then the square size of the texture map.
The size of the shadow map greatly influences the quality
and performance of SHADOW lighting. Large shadow map sizes increase
quality but decrease performance. The default shadow map size is 256.
SHADOW lighting requires that the viewport of each pfChannel
which renders the pfLightSource's scene be at least as big as the
shadow map. Otherwise, shadows will be clipped and visual anomalies will
occur.

Both SHADOW and PROJTEX lighting require that a pfFrustum be specified
with the \f3\%PFLS_PROJ_FRUSTUM\fP token to
\f3\%pfLSourceAttr\fP.  \f2obj\fP defines
the projection of the texture (shadow) map and should be a nominal,
i.e., non-transformed pfFrustum*. For SHADOW lighting, the
field-of-view and near and far clipping planes should bracket the
scene to be shadowed as tightly as possible for best results. A sloppy
fit of pfFrustum to scene will result in blocky, poor-quality shadows.

By default, SHADOW lighting requires that the scene be rendered from the
point of view of the pfLightSource to produce a shadow map. By default,
pfChannels automatically do this for each SHADOW pfLightSource in their scene.
However, a new shadow map is only required if the pfLightSource or
objects in the scene change. In the special case where the pfLightSource and
scene are totally static (e.g., the sun illuminating a sleepy town),
the shadow map need not be recomputed. In this case
\f3\%pfLSourceMode(PFLS_FREEZE_SHADOWS, PF_ON)\fP will disable the automatic
recomputation of the shadow map, increasing performance.

For best results, SHADOW lighting requires that the scene be slightly
displaced in depth when rendering the shadow map. This reduces artifacts
such as "self-shadowing". The \f3\%PFLS_SHADOW_DISPLACE_SCALE\fP and
\f3\%PFLS_SHADOW_DISPLACE_OFFSET\fP tokens to \f3\%pfLSourceVal\fP specify
displacement values. The default values are respectively:
for IrisGL 1.0 and 256.0
for OpenGL 1.0 and .0019
but experimentation is required for best results (both values should
be positive).

For pfLightSources which are near the eye, a pfFog can be used to
simulate range-attenuation of the light. Range-attenuation is enabled
with the \f3\%PFLS_FOG_ENABLE\fP token to
\f3\%pfLSourceMode\fP and by specifying a
pfFog with the \f3\%PFLS_PROJ_FOG\fP token to
\f3\%pfLSourceAttr\fP.  The pfFog color
should be the ambient color of the projected texture.  Only a single
range-attenuated projected pfLightSource is supported for a given
pfChannel.

With IrisGL A pfLightSource's intensity is
set with the \f3\%PFLS_INTENSITY\fP token to \f3\%pfLSourceVal\fP. \f2val\fP
simply scales the color(s) of all 3 lighting types: pfLight, PROJTEX, SHADOW.
A scene containing multiple, full-intensity pfLightSources can
be easily saturated so setting pfLightSource intensities is a simple
way to "normalize" lighting within a scene. For example, when using
3 pfLightSources to illuminate a scene, an intensity of .33 would
be reasonable.

With OpenGL, the \f3\%PFLS_INTENSITY\fP has effect only for shadows to set the
intensity inside the shadow. The amount of light is given directly
by the \f3\%PFLT_DIFFUSE\fP value, that is a full RGB triplet, so every
light/shadow can be colored.

Example 2: Range-attenuated, projected texture lighting for landing light
.Ex
.nf


pfLightSource	*spot;
pfTexture	*spotTex;
pfFrustum	*spotFrust;
pfFog		*spotFog;
pfDCS		*spotDCS;
pfChannel	*chan;
pfEarthSky	*esky;

// Create and load 2-component spotlight
spotTex = pfNewTex(arena);
pfLoadTexFile(spotTex, "spot.inta");

// Create and configure projected texture frustum
spotFrust = pfNewFrust(arena);
pfMakeSimpleFrust(spotFrust, 60.0f);
pfFrustNearFar(spotFrust, 1.0f, 100.0f);

// Create and configure range-attenuation fog model
spotFog = pfNewFog(arena);
pfFogColor(spotFog, 0.1f, 0.1f, 0.1f);
pfFogRange(spotFog, 0.0f, 100.0f);

// Create and configure projected texture light source
spot = pfNewLSource();
pfLSourceAttr(spot, PFLS_PROJ_TEX, spotTex);
pfLSourceAttr(spot, PFLS_PROJ_FRUST, spotFrust);
pfLSourceAttr(spot, PFLS_PROJ_FOG, spotFog);
pfLSourceMode(spot, PFLS_PROJTEX_ENABLE, 1);

// Set spotDCS to viewing matrix to move light around with eye
spotDCS = pfNewDCS();
pfAddChild(spotDCS, spot);
pfAddChild(scene, spotDCS);

// Enable emissive pass since scene has emissive surfaces
pfChanTravMode(chan, PFTRAV_MULTIPASS, PFMPASS_EMISSIVE_PASS);

.Ee
.fi
.na


Example 3: Multiple, shadow-casting, colored pfLightSources
.Ex
.nf


pfLightSource	*shad0, *shad1;
pfDCS		*shadDCS0, *shadDCS1;
pfFrustum	*shadFrust;
pfChannel	*chan;
pfEarthSky	*esky;

// Create and configure shadow frustum
shadFrust = pfNewFrust(arena);
pfMakeSimpleFrust(shadFrust, 60.0f);
pfFrustNearFar(shadFrust, 1.0f, 100.0f);

// Create and configure shadow casting light sources
shad0 = pfNewLSource();
pfLSourceMode(shad0, PFLS_SHADOW_ENABLE, 1);
pfLSourceAttr(shad0, PFLS_PROJ_FRUST, shadFrust);
pfLSourceColor(shad0, PFLT_DIFFUSE, 1.0f, 0.0f, 0.0f);
pfLSourceVal(shad0, PFLS_INTENSITY, .5f);

shad1 = pfNewLSource();
pfLSourceMode(shad1, PFLS_SHADOW_ENABLE, 1);
pfLSourceAttr(shad1, PFLS_PROJ_FRUST, shadFrust);
pfLSourceColor(shad1, PFLT_DIFFUSE, 0.0f, 0.0f, 1.0f);
pfLSourceVal(shad1, PFLS_INTENSITY, .5f);

// Set DCSes to move lights around
shadDCS0 = pfNewDCS();
pfAddChild(shadDCS0, shad0);
pfAddChild(scene, shadDCS0);

shadDCS1 = pfNewDCS();
pfAddChild(shadDCS1, shad1);
pfAddChild(scene, shadDCS1);

.Ee
.fi
.na


.SH NOTES


Shadows and Projected Texture functionality is not currently supported
under Linux.

To respect the limited number of active light sources allowed by
graphics library implementations, OpenGL Performer supports at
most \f3\%PF_MAX_LIGHTS\fP active light sources.

If you want light sources to affect only portions of the scene, then set
one or more pfLights on the pfGeoStates which are attached to the
pfGeoSets that you wish to illuminate (see \f3\%pfGStateAttr\fP and
\f3\%PFSTATE_LIGHTS\fP for further details).

Shadows are supported by InfinityReality only when using OpenGL.

PROJTEX and SHADOW lighting require local lighting
for proper effects (\f3\%pfLModelLocal\fP).

SHADOW lighting on RealityEngine requires the depth buffer to be configured
with 32 bits (\f3\%zbsize()\fP). Note that it is legal to have multisample
buffers allocated in addition, the only requirement is that the non-multisampled
depth buffer be 32 bits. Also note that on RealityEngine, a 32-bit depth
buffer requires 12-bit color. An alpha plane is also required for multiple
PROJTEX/SHADOW light sources.

SHADOW lighting on InfiniteReality works fine will all frame buffer
configurations, including multisample.

Shadows and projected textures are not clipped
or properly computed behind the pfLightSource. Instead, geometry
behind the pfLightSource will be textured randomly. The only workaround
is to ensure that all geometry behind the pfLightSource is not
visible to the pfChannel.

Local lighting results in improper shading of flat-shaded
triangle and line strips (\f3\%PFGS_FLAT_TRISTRIPS\fP, \f3\%PFGS_LINE_TRISTRIPS\fP)
which often manifests itself as "faceting" of planar polygons.
The only solution is either to use infinite lighting or not use FLAT primitives.
Note that when using the OpenGL Performer triangle meshing routine,
\f3\%pfdMeshGSet\fP, the construction of non-FLAT strips is easily enforced
with \f3\%pfdMesherMode(PFDMESH_LOCAL_LIGHTING, 1)\fP.

Multipass techniques are not compatible with stencil layer mode, the mode is
forced to PFGL_DECAL_DISPLACE.

.SH SEE ALSO
pfChanTravFunc,
pfChanTravMode,
pfNode,
pfSCS,
pfDCS,
pfGeoSet,
pfGeoState,
pfLight,
pfDelete
