'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfList" "3pf"
.SH NAME
.upperok
.B pfNewList,
.B pfGetListClassType,
.B pfAdd,
.B pfCombineLists,
.B pfFastRemove,
.B pfFastRemoveIndex,
.B pfGet,
.B pfGetListArray,
.B pfGetListArrayLen,
.B pfGetListEltSize,
.B pfGetNum,
.B pfInsert,
.B pfMove,
.B pfListArrayLen,
.B pfNum,
.B pfRemove,
.B pfRemoveIndex,
.B pfReplace,
.B pfResetList,
.B pfSearch,
.B pfSet
\- 
Dynamically-sized list utility
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ void\ **\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfList *
\f3\%pfNewList\fP(int\ eltSize,
'in +2
'll -2
int\ listLength,
void*\ arena);
.in
.ll
.nf
.fi
.TP
pfType *
\f3\%pfGetListClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfAdd\fP(pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCombineLists\fP(pfList*\ dst,
'in +2
'll -2
const\ pfList\ *a,
const\ pfList\ *b);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFastRemove\fP(pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFastRemoveIndex\fP(pfList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGet\fP(const\ pfList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
const void **
\f3\%pfGetListArray\fP(const\ pfList*\ list);
.nf
.fi
.TP
int
\f3\%pfGetListArrayLen\fP(const\ pfList*\ len);
.nf
.fi
.TP
int
\f3\%pfGetListEltSize\fP(const\ pfList*\ list);
.nf
.fi
.TP
int
\f3\%pfGetNum\fP(const\ pfList*\ list);
.nf
.fi
.TP
void
\f3\%pfInsert\fP(pfList*\ list,
'in +2
'll -2
int\ index,
void*\ elt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMove\fP(pfList*\ lists,
'in +2
'll -2
int\ index,
void\ *elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfListArrayLen\fP(pfList*\ list,
'in +2
'll -2
int\ len);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfNum\fP(pfList\ *list,
'in +2
'll -2
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfRemove\fP(pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfRemoveIndex\fP(pfList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfReplace\fP(pfList*\ list,
'in +2
'll -2
void*\ old,
void*\ new);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfResetList\fP(pfList*\ list);
.nf
.fi
.TP
int
\f3\%pfSearch\fP(const\ pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSet\fP(pfList*\ list,
'in +2
'll -2
int\ index,
void\ *elt);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfList\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfList\fP.
Casting an object of class \f3\%pfList\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfList\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'list\ \ 'u
\f2list\fP
identifies a pfList.
.SH DESCRIPTION


A pfList is a dynamically-sized array of arbitrary, but
homogeneously-sized, elements.

\f3\%pfNewList\fP creates and returns a handle to a new pfList.
\f2eltSize\fP specifies the size in bytes of an individual list element.
The element size is fixed at creation time and cannot be later
changed.  \f2listLength\fP is the initial length of the list;
\f2listLength\fP * \f2eltSize\fP bytes will be allocated for the list
array.  The argument \f2arena\fP specifies a malloc arena out of which
the pfList is to be allocated or \f3\%NULL\fP for allocation from the
process heap.  pfLists can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetListClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfList\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetListClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfList\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

A pfList dynamically increases its array size by a factor of 2 and
zeros the additional memory whenever it runs out of array memory.  This
way the array size quickly reaches its final size without many
reallocations of memory.  However, some memory (up to one half of the
total allocation) at the end of the array may be wasted.  If you know
the exact number of elements in the array, you can specify the pfList
array length either when creating it (the \f2listLength\fP argument to
\f3\%pfNewList\fP) or with \f3\%pfListArrayLen\fP.  \f3\%pfGetListArrayLen\fP
returns the current array length of \f2list\fP.

Example 1:
.Ex
.nf

/* Fit list's array to its current number of elements */
pfListArrayLen(list, pfGetNum(list));
.Ee
.fi
.na


\f3\%pfSet\fP sets the \f2index\fPth element of \f2list\fP to \f2elt\fP.  The list
is automatically grown if \f2index\fP is beyond the current array
length.

\f3\%pfGet\fP returns the element of \f2list\fP at index \f2index\fP or 0 if
\f2index\fP is out of bounds.

\f3\%pfAdd\fP appends \f2elt\fP to \f2list\fP and automatically grows \f2list\fP
if necessary.

\f3\%pfRemove\fP removes \f2elt\fP from \f2list\fP and shifts the array down
over the vacant spot, e.g. - if \f2elt\fP had index 0, then index 1
becomes index 0, index 2 becomes index 1 and so on.  \f3\%pfRemove\fP
returns the index of \f2elt\fP if \f2elt\fP was actually removed and -1 if
it was not found in the list. \f3\%pfRemoveIndex\fP
removes the \f2index\fPth element of \f2list\fP, and like \f3\%pfRemove\fP, shifts the array down over the vacant spot.

\f3\%pfFastRemove\fP removes \f2elt\fP from
\f2list\fP but does not shift the array; instead
it places the last element of the array into the vacated location so it
does not preserve the list ordering.
\f3\%pfFastRemoveIndex\fP replaces the
\f2index\fPth element with the last element of \f2list\fP.

Note that both
\f3\%pfRemove\fP and \f3\%pfFastRemove\fP linearly search the array for \f2elt\fP
and remove only the first matching element.  To remove all occurrences
of \f2elt\fP do the following:
.Ex
.nf

while (pfRemove(list, elt) >= 0)
    /* empty */ ;
.Ee
.fi
.na


\f3\%pfSearch\fP returns the index of \f2elt\fP if \f2elt\fP was found in
\f2list\fP and -1 otherwise.

\f3\%pfInsert\fP inserts \f2elt\fP before the array element with index
\f2index\fP.  \f2index\fP must be within the range [0 ..
\f3\%pfGetNum\fP(\f2list\fP)].

\f3\%pfMove\fP deletes \f2elt\fP from its current location and
inserts before the array element with index
\f2index\fP.  \f2index\fP must be within the range [0 ..
\f3\%pfGetNum\fP(\f2list\fP)] or else (-1) is returned
and no move is executed.
If \f2elt\fP is not already in \f2list\fP, (-1) is returned
and \f2elt\fP is not inserted into the list. Otherwise, \f2index\fP is returned
to indicate success.

\f3\%pfReplace\fP replaces the first instance of \f2old\fP with \f2new\fP and
returns the index of \f2old\fP if it was found in \f2list\fP and -1
otherwise.

\f3\%pfGetNum\fP returns the number of elements in \f2list\fP. (Actually,
\f2list\fP may have holes in its array so \f3\%pfGetNum\fP technically should
be considered as returning the maximum index of all elements in \f2list\fP.)

\f3\%pfResetList\fP zeros \f2list\fP's array and resets the number of
elements to 0.  It does not resize the array.

\f3\%pfCombineLists\fP sets \f2dst\fP to \f2a\fP appended with \f2b\fP.  \f2dst\fP
may be the same as \f2a\fP or \f2b\fP.  Lists must have equal element sizes
to be combined.

For quick access to the list array, \f3\%pfGetListArray\fP returns a
pointer to the internal array of \f2list\fP.  Care should be taken with
this routine since out of bounds range checking provided by pfList API
is bypassed.  If you add elements to \f2list\fP then use \f3\%pfNum\fP to set
the number of elements of \f2list\fP.
.SH BUGS

pfLists currently only support an element size of \f3\%sizeof(void*)\fP.
.SH SEE ALSO
pfDelete
