'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMatStack" "3pf"
.SH NAME
.upperok
.B pfNewMStack,
.B pfGetMStackClassType,
.B pfResetMStack,
.B pfPushMStack,
.B pfPopMStack,
.B pfPreMultMStack,
.B pfPostMultMStack,
.B pfLoadMStack,
.B pfGetMStack,
.B pfGetMStackTop,
.B pfGetMStackDepth,
.B pfPreTransMStack,
.B pfPostTransMStack,
.B pfPreRotMStack,
.B pfPostRotMStack,
.B pfPreScaleMStack,
.B pfPostScaleMStack
\- 
Create and manipulate a matrix stack.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfMatStack\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfMatStack *
\f3\%pfNewMStack\fP(int\ size,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfType *
\f3\%pfGetMStackClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfResetMStack\fP(pfMatStack\ *stack);
.nf
.fi
.TP
int
\f3\%pfPushMStack\fP(pfMatStack\ *stack);
.nf
.fi
.TP
int
\f3\%pfPopMStack\fP(pfMatStack\ *stack);
.nf
.fi
.TP
void
\f3\%pfPreMultMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostMultMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLoadMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetMStack\fP(const\ pfMatStack\ *stack,
'in +2
'll -2
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
pfMatrix *
\f3\%pfGetMStackTop\fP(const\ pfMatStack\ *stack);
.nf
.fi
.TP
int
\f3\%pfGetMStackDepth\fP(const\ pfMatStack\ *stack);
.nf
.fi
.TP
void
\f3\%pfPreTransMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostTransMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPreRotMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
float\ degrees,
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostRotMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
float\ degrees,
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPreScaleMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
float\ xs,
float\ ys,
float\ zs);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostScaleMStack\fP(pfMatStack\ *stack,
'in +2
'll -2
float\ xs,
float\ ys,
float\ zs);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfMatStack\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfMatStack\fP.
Casting an object of class \f3\%pfMatStack\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfMatStack\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

These routines allow the creation and manipulation of a stack of 4x4 matrices.

\f3\%pfNewMStack\fP creates and returns a handle to a pfMatStack.
\f2arena\fP specifies a malloc arena out of which the pfMatStack is
allocated or \f3\%NULL\fP for allocation off the process heap.
pfMatStacks can be deleted with \f3\%pfDelete\fP.
\f2size\fP is the number of pfMatrix's in the matrix stack.  The initial
depth is 1 and the top of stack is the identity matrix.

\f3\%pfGetMStackClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfMatStack\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetMStackClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfMatStack\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfResetMStack\fP sets the stack depth to 1
and sets the top of stack to the identity matrix.

\f3\%pfPushMStack\fP pushes down the specified
matrix stack duplicating the top.
\f3\%pfPopMStack\fP pops the matrix stack.
Attempting to pop a matrix stack containing only a single element or
pushing past the maximum depth causes a warning and leaves the stack
unchanged.

\f3\%pfPreMultMStack\fP pre-multiplies the top
of the stack by the matrix \f2m\fP and replaces the top of the stack with
the product.  Thus if \f2T\fP is the top of the stack, the operation
replaces \f2T\fP with \f2m\fP*\f2T\fP.  This order corresponds to that used
by OpenGL's \f2glMultMatrix\fP.
\f3\%pfPostMultMStack\fP operates similarly
but using post-multiplication, calculating \f2T\fP*\f2m\fP instead.

\f3\%pfLoadMStack\fP replaces the top of the stack
with the matrix \f2m\fP.

\f3\%pfGetMStack\fP copies the top of the matrix
into the matrix \f2m\fP.  \f3\%pfGetMStackTop\fP
returns a pointer to the top of the matrix stack.

\f3\%pfGetMStackDepth\fP returns the current
depth of the stack.  Initially the depth is \f21\fP.

The following transformations pre- and post- multiply the top of the
matrix stack:

\f3\%pfPreTransMStack\fP and
\f3\%pfPostTransMStack\fP respectively pre-
and post- multiply the top of the matrix stack by the translation
matrix generated by the coordinates \f2x\fP, \f2y\fP and \f2z\fP.  (See
\f3\%pfMakeTransMat\fP).

\f3\%pfPreRotMStack\fP and
\f3\%pfPostRotMStack\fP respectively pre- and
post- multiply the top of the matrix stack by the rotation by
\f2degrees\fP about the axis defined by (\f2x\fP, \f2y\fP, \f2z\fP).  (See
\f3\%pfMakeRotMat\fP).  The results are undefined
if the vector (\f2x\fP, \f2y\fP, \f2z\fP) is not normalized.

\f3\%pfPreScaleMStack\fP and
\f3\%pfPostScaleMStack\fP respectively pre-
and post- multiply the top of the matrix stack by a scaling matrix.
(See \f3\%pfMakeScaleMat\fP).  The matrix
scales by \f2x\fP in the X direction, \f2y\fP and the Y direction and \f2z\fP
in the Z direction.
.SH NOTES

\f3\%pfPreRotMStack\fP and
\f3\%pfPostRotMStack\fP use pfSinCos which is
faster than the libm counterpart, but has less resolution.

pfMatStack is not related to the GL matrix stack.

IMPORTANT: The argument order of degrees and axis to the
\f3\%pfPreRotMStack\fP are not the same as to
the corresponding routine \f3\%pfRotMStack\fP in the IRIS Performer 1.0
and IRIS Performer 1.1 releases. This change was first introduced in
the IRIS Performer 1.2 release and is present in subsequent releases of
OpenGL Performer.

.SH SEE ALSO
pfDelete,
pfMakeRotMat,
pfMakeScaleMat,
pfMakeTransMat,
pfMatrix,
pfSinCos,
multmatrix
