'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMatrix" "3pf"
.SH NAME
.upperok
.B pfMakeIdentMat,
.B pfMakeTransMat,
.B pfMakeScaleMat,
.B pfMakeRotMat,
.B pfMakeQuatMat,
.B pfMakeEulerMat,
.B pfMakeVecRotVecMat,
.B pfMakeCoordMat,
.B pfGetMatType,
.B pfGetOrthoMatQuat,
.B pfGetOrthoMatCoord,
.B pfSetMat,
.B pfSetMatRowVec3,
.B pfGetMatRowVec3,
.B pfSetMatColVec3,
.B pfGetMatColVec3,
.B pfSetMatRow,
.B pfGetMatRow,
.B pfSetMatCol,
.B pfGetMatCol,
.B pfCopyMat,
.B pfAddMat,
.B pfSubMat,
.B pfScaleMat,
.B pfTransposeMat,
.B pfMultMat,
.B pfPreMultMat,
.B pfPostMultMat,
.B pfPreTransMat,
.B pfPostTransMat,
.B pfPreRotMat,
.B pfPostRotMat,
.B pfPreScaleMat,
.B pfPostScaleMat,
.B pfInvertFullMat,
.B pfInvertAffMat,
.B pfInvertOrthoMat,
.B pfInvertOrthoNMat,
.B pfInvertIdentMat,
.B pfEqualMat,
.B pfAlmostEqualMat
\- 
Set and operate on 4x4 matrices.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
void
\f3\%pfMakeIdentMat\fP(pfMatrix\ dst);
.nf
.fi
.TP
void
\f3\%pfMakeTransMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeScaleMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeRotMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ degrees,
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeQuatMat\fP(pfMatrix\ m,
'in +2
'll -2
const\ pfQuat\ q);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeEulerMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ h,
float\ p,
float\ r);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeVecRotVecMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeCoordMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfCoord\ *c);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetMatType\fP(const\ pfMatrix\ mat);
.nf
.fi
.TP
void
\f3\%pfGetOrthoMatQuat\fP(const\ pfMatrix\ m,
'in +2
'll -2
pfQuat\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetOrthoMatCoord\fP(pfMatrix\ m,
'in +2
'll -2
pfCoord*\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSetMat\fP(const\ float\ *m);
.nf
.fi
.TP
void
\f3\%pfSetMatRowVec3\fP(pfMatrix\ dst,
'in +2
'll -2
int\ row,
const\ pfVec3\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetMatRowVec3\fP(const\ pfMatrix\ m,
'in +2
'll -2
int\ row,
pfVec3\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSetMatColVec3\fP(pfMatrix\ dst,
'in +2
'll -2
int\ col,
const\ pfVec3\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetMatColVec3\fP(const\ pfMatrix\ m,
'in +2
'll -2
int\ col,
pfVec3\ dst);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSetMatRow\fP(pfMatrix\ dst,
'in +2
'll -2
int\ row,
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetMatRow\fP(const\ pfMatrix\ m,
'in +2
'll -2
int\ row,
float\ *x,
float\ *y,
float\ *z,
float\ *w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSetMatCol\fP(pfMatrix\ dst,
'in +2
'll -2
int\ col,
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetMatCol\fP(const\ pfMatrix\ m,
'in +2
'll -2
int\ col,
float\ *x,
float\ *y,
float\ *z,
float\ *w);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCopyMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAddMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m1,
const\ pfMatrix\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSubMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m1,
const\ pfMatrix\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfScaleMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ s,
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTransposeMat\fP(pfMatrix\ dst,
'in +2
'll -2
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMultMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m1,
const\ pfMatrix\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPreMultMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostMultMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPreTransMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostTransMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m,
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPreRotMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ degrees,
float\ x,
float\ y,
float\ z,
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostRotMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ mat,
float\ degrees,
float\ x,
float\ y,
float\ z,
);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPreScaleMat\fP(pfMatrix\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPostScaleMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m,
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfInvertFullMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInvertAffMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInvertOrthoMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInvertOrthoNMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfInvertIdentMat\fP(pfMatrix\ dst,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEqualMat\fP(const\ pfMatrix\ m1,
'in +2
'll -2
const\ pfMatrix\ m2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAlmostEqualMat\fP(const\ pfMatrix\ m1,
'in +2
'll -2
const\ pfMatrix\ m2,
float\ tol);
.in
.ll
.fi

.Ex
.nf

typedef struct
{
   pfVec3       xyz;
   pfVec3       hpr;
} pfCoord;

typedef float pfMatrix[4][4];
.Ee
.fi
.na

.SH DESCRIPTION


Routines for pfMatrix, a 4X4 matrix.


\f3\%pfMakeIdentMat\fP sets \f2dst\fP to the identity matrix.  \f3\%PFMAKE_IDENT_MAT\fP is an
equivalent macro.

The following routines create transformation matrices based on
multiplying a row vector by a matrix on the right, i.e. the vector v
transformed by m is v * m.   Many actions will go considerably faster
if the last column is (0,0,0,1).

\f3\%pfMakeTransMat\fP sets \f2dst\fP to the matrix which translates by
(\f2x\fP, \f2y\fP, \f2z\fP).  Equivalent macro: \f3\%PFMAKE_TRANS_MAT\fP.

\f3\%pfMakeScaleMat\fP sets \f2dst\fP to the matrix which scales by \f2x\fP in
the X direction, by \f2y\fP in the Y direction and by \f2z\fP in the Z
direction.  Equivalent macro: \f3\%PFMAKE_SCALE_MAT\fP

\f3\%pfMakeRotMat\fP sets \f2dst\fP to the matrix which rotates by
\f2degrees\fP about the axis denoted by the unit vector (\f2x\fP, \f2y\fP,
\f2z\fP).  If (\f2x\fP, \f2y\fP, \f2z\fP) is not normalized, results are
undefined.

\f3\%pfMakeQuatMat\fP builds a rotation matrix \f2m\fP that expresses the
rotation defined by the quaternion \f2q\fP.

\f3\%pfMakeEulerMat\fP sets \f2dst\fP to a rotation matrix composed of the
Euler angles \f2h\fP, \f2p\fP, \f2r\fP: \f2h\fP specifies heading, the rotation
about the Z axis; \f2p\fP specifies pitch, the rotation about the X axis;
and, \f2r\fP specifies roll, rotation about the Y axis.  The matrix
created is \f2dst\fP = R*P*H, where R is the roll transform, P is the
pitch transform and H is the heading transform.  All rotations follow
the right hand rule.  The convention is natural for a model in which +Y
is "forward," +Z is "up" and +X is "right".  This routine uses
\f3\%pfSinCos\fP which is faster than the libm counterpart, but has less
resolution (see \f3\%pfSinCos\fP).

\f3\%pfMakeVecRotVecMat\fP sets
\f2dst\fP to the rotation matrix which rotates the
vector \f2v1\fP onto \f2v2\fP, i.e. \f2v2\fP = \f2v1\fP * \f2dst\fP.
\f2v2\fP must be normalized.  The rotation axis is always chosen to be
perpendicular to both \f2v0\fP and \f2v1\fP so that the rotation angle is as small
as possible.  Note that the result is ambiguous only when \f2v0\fP == -\f2v1\fP;
in this case the rotation axis is chosen to be an arbitrary vector
perpendicular to \f2v0\fP and \f2v1\fP.

\f3\%pfMakeCoordMat\fP sets \f2dst\fP to the matrix which rotates by the
Euler transform specified by \f2c\fP->hpr and translates by
\f2c\fP->xyz, i.e. \f2dst\fP = R*P*H*T, where R is the roll transform,
P is the pitch transform and H is the heading transform, and T is
the translation transform.

\f3\%pfGetOrthoMatQuat\fP constructs a
quaternion \f2dst\fP equivalent to the rotation
expressed by the orthonormal matrix \f2m\fP.

\f3\%pfGetOrthoMatCoord\fP returns in
\f2dst\fP the translation and rotation of the
orthonormal matrix, \f2m\fP.  The returned pitch ranges from -90 to +90
degrees.  Roll and heading range from -180 to +180.

\f3\%pfDCSMatType\fP allows the specification
of information about the type of transformation the matrix represents.
This information allows Performer to speed up some operations.  The
matrix type is specified as the OR of
.RS
.TP 5
PFMAT_TRANS:
matrix includes a translational component in the 4th row.
.TP
PFMAT_ROT:
matrix includes a rotational component in the left upper 3X3 submatrix.
.TP
PFMAT_SCALE:
matrix includes a uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_NONORTHO:
matrix includes a non-uniform scale in the left upper 3X3 submatrix.
.TP
PFMAT_PROJ:
matrix includes projections.
.TP
PFMAT_HOM_SCALE:
mat[4][4] != 1.
.TP
PFMAT_MIRROR:
matrix includes mirroring transformation that
switches between right handed and left handed coordinate systems.
.RE

\f3\%pfGetMatType\fP computes the type of
matrix.  This information can be useful if a matrix is to be
used repeatedly, e.g. to transform many objects, but is somewhat
time consuming to compute.

\f3\%pfSetMatRow\fP.
\f2dst\fP[\f2row\fP][0] = \f2x\fP,
\f2dst\fP[\f2row\fP][1] = \f2y\fP,
\f2dst\fP[\f2row\fP][2] = \f2z\fP,
\f2dst\fP[\f2row\fP][3] = \f2w\fP.  Use the arguments to set row
\f2row\fP of \f2dst\fP.  \f2row\fP must be 0, 1, 2, or
3.  Equivalent macro: \f3\%PFSET_MAT_ROW\fP.

\f3\%pfGetMatRow\fP.  \f2*x\fP =
\f2dst\fP[\f2row\fP][0], \f2*y\fP =
\f2dst\fP[\f2row\fP][1], \f2*z\fP =
\f2dst\fP[\f2row\fP][2], \f2*w\fP =
\f2dst\fP[\f2row\fP][3].  Get the arguments to row \f2row\fP of
\f2dst\fP.  \f2row\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_ROW\fP.

\f3\%pfSetMatCol\fP.
\f2dst\fP[0][\f2col\fP] = \f2x\fP,
\f2dst\fP[1][\f2col\fP] = \f2y\fP,
\f2dst\fP[2][\f2col\fP] = \f2z\fP,
\f2dst\fP[3][\f2col\fP] = \f2w\fP.  Use the arguments to set col
\f2col\fP of \f2dst\fP.  \f2col\fP must be 0, 1, 2, or
3.  Equivalent macro: \f3\%PFSET_MAT_COL\fP.

\f3\%pfGetMatCol\fP.  \f2*x\fP =
\f2dst\fP[0][\f2col\fP], \f2*y\fP =
\f2dst\fP[1][\f2col\fP], \f2*z\fP =
\f2dst\fP[2][\f2col\fP], \f2*w\fP =
\f2dst\fP[3][\f2col\fP].  Get the arguments to col \f2col\fP of
\f2dst\fP.  \f2col\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_COL\fP.

\f3\%pfSetMatRowVec3\fP.
\f2dst\fP[\f2row\fP][i] = \f2v\fP[i], i = 0, 1, 2.  Set row
\f2row\fP of \f2dst\fP to the vector \f2v\fP.  \f2row\fP
must be 0, 1, 2, or 3.  Equivalent macro: \f3\%PFSET_MAT_ROWVEC3\fP.

\f3\%pfGetMatRowVec3\fP.  \f2dst\fP[i]
= \f2m\fP[\f2row\fP][i], i = 0, 1, 2.  Return row \f2row\fP of \f2m\fP and in
\f2dst\fP.  \f2row\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_ROWVEC3\fP.

\f3\%pfSetMatColVec3\fP.
\f2dst\fP[i][\f2col\fP] = \f2v\fP[i], i = 0, 1, 2.  Set column
\f2col\fP of \f2dst\fP to the vector \f2v\fP.  \f2col\fP
must be 0, 1, 2, or 3.  Equivalent macro: \f3\%PFSET_MAT_COLVEC3\fP.

\f3\%pfGetMatColVec3\fP.  \f2dst\fP[i]
= \f2m\fP[i][\f2col\fP], i = 0, 1, 2.  Return column \f2col\fP of \f2m\fP in
\f2dst\fP.  \f2col\fP must be 0, 1, 2, or 3.
Equivalent macro: \f3\%PFGET_MAT_COLVEC3\fP.

\f3\%pfSetMat\fP.
\f2dst\fP[i][j] = \f2m\fP[i*4+j], 0 <= i,j <= 3.

\f3\%pfCopyMat\fP: \f2dst\fP = \f2m\fP.
Copies \f2m\fP into \f2dst\fP.  Equivalent macro:
\f3\%PFCOPY_MAT\fP

\f3\%pfPreTransMat\fP: \f2dst\fP =
T(\f2x\fP,\f2y\fP,\f2z\fP) * \f2m\fP, where T(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix
which translates by (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfPostTransMat\fP: \f2dst\fP =
\f2m\fP * T(\f2x\fP,\f2y\fP,\f2z\fP), where T(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix
which translates by (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfPreRotMat\fP: \f2dst\fP =
R(\f2degrees\fP, \f2x\fP,\f2y\fP,\f2z\fP) * \f2m\fP, where
R(\f2degrees\fP,\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which rotates by
\f2degrees\fP about the axis (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfPostRotMat\fP: \f2dst\fP = \f2m\fP * R(\f2degrees\fP, \f2x\fP,\f2y\fP,\f2z\fP),
where R(\f2degrees\fP,\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which rotates
by \f2degrees\fP about the axis (\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfPreScaleMat\fP: \f2dst\fP = S(\f2x\fP,\f2y\fP,\f2z\fP) * \f2m\fP, where
S(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which scales by
(\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfPostScaleMat\fP: \f2dst\fP = \f2m\fP * S(\f2x\fP,\f2y\fP,\f2z\fP), where
S(\f2x\fP,\f2y\fP,\f2z\fP) is the matrix which scales by
(\f2x\fP,\f2y\fP,\f2z\fP).

\f3\%pfAddMat\fP: \f2dst\fP = \f2m1\fP + \f2m2\fP.  Sets \f2dst\fP to the sum of
\f2m1\fP and \f2m2\fP.

\f3\%pfSubMat\fP: \f2dst\fP = \f2m1\fP - \f2m2\fP.  Sets \f2dst\fP to the
difference of \f2m1\fP and \f2m2\fP.

\f3\%pfScaleMat\fP: \f2dst\fP = \f2s\fP * \f2m\fP.  Sets \f2dst\fP to the
product of the scalar \f2s\fP and the matrix \f2m\fP.  This multiplies
the full 4X4 matrix and is not a 3D geometric scale.

\f3\%pfTransposeMat\fP: \f2dst\fP = Transpose(\f2m\fP).  Sets \f2dst\fP to
the transpose of \f2m\fP.

\f3\%pfMultMat\fP: \f2dst\fP = \f2m1\fP * \f2m2\fP.  Sets \f2dst\fP to the
product of \f2m1\fP and \f2m2\fP.

\f3\%pfPostMultMat\fP: \f2dst\fP = \f2dst\fP *\f2m\fP.  Postmultiplies
\f2dst\fP by \f2m\fP.

\f3\%pfPreMultMat\fP: \f2dst\fP = \f2m\fP * \f2dst\fP.  Premultiplies
\f2dst\fP by \f2m\fP.

\f3\%pfInvertFullMat\fP, \f3\%pfInvertAffMat\fP, \f3\%pfInvertOrthoMat\fP,
\f3\%pfInvertOrthoNMat\fP, and \f3\%pfInvertIdentMat\fP, set \f2dst\fP to the
inverse of \f2m\fP for general, affine, orthogonal, orthonormal and
identity matrices respectively.  They are listed here in order of
decreasing generality and increasing speed.  If the matrix \f2m\fP is not
of the type specified in the routine name, the result is undefined.
\f3\%pfInvertFullMat\fP returns FALSE if the matrix is singular and TRUE
otherwise.

\f3\%pfEqualMat\fP(m1, m2) = (\f2m1\fP == \f2m2\fP).  Tests for strict
component-by-element equality of
two matrices \f2m1\fP
and \f2m2\fP and
returns FALSE or TRUE.  Macro equivalent: \f3\%PFEQUAL_MAT\fP.

\f3\%pfAlmostEqualMat\fP(m1, m2, tol).  Tests for approximate
element-by-element equality of
two matrices \f2m1\fP
and \f2m2\fP.  It
returns FALSE or TRUE depending on whether the absolute value of the
difference between each pair of elements is less than the tolerance
\f2tol\fP.  Macro equivalent: \f3\%PFALMOST_EQUAL_MAT\fP.


Routines can accept the same matrix as source, destination, or as a
repeated operand.

.SH NOTES

Some of these routines use pfSinCos and pfSqrt, which are faster but
have less resolution than the libm counterparts.  (See \f3\%pfSinCos\fP)
.SH SEE ALSO
pfSinCos,
pfSqrt,
pfVec3,
pfVec4
