'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfMorph OBSOLETED by pfEngine and pfFlux" "3pf"
.SH NAME
.upperok
.B pfNewMorph,
.B pfGetMorphClassType,
.B pfMorphAttr,
.B pfMorphWeights,
.B pfGetMorphWeights,
.B pfGetMorphNumAttrs,
.B pfGetMorphSrc,
.B pfGetMorphNumSrcs,
.B pfGetMorphDst,
.B pfEvaluateMorph
\- 
Create, modify, and query a pfMorph node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfMorph\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfMorph *
\f3\%pfNewMorph\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetMorphClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfMorphAttr\fP(pfMorph\ *morph,
'in +2
'll -2
int\ index,
int\ floatsPerElt,
int\ nelts,
void\ *dst,
int\ nsrcs,
float\ *alist[],
ushort\ *ilist[],
int\ nlist[]);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMorphWeights\fP(pfMorph\ *morph,
'in +2
'll -2
int\ index,
float\ *weights);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetMorphWeights\fP(const\ pfMorph\ *morph,
'in +2
'll -2
int\ index,
float\ *weights);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetMorphNumAttrs\fP(const\ pfMorph\ *morph);
.nf
.fi
.TP
int
\f3\%pfGetMorphSrc\fP(const\ pfMorph\ *morph,
'in +2
'll -2
int\ index,
int\ src,
float\ **alist,
ushort\ **ilist,
int\ *nlist);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetMorphNumSrcs\fP(const\ pfMorph\ *morph,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGetMorphDst\fP(const\ pfMorph\ *morph,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfEvaluateMorph\fP(pfMorph\ *morph);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfMorph\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfMorph\fP.
Casting an object of class \f3\%pfMorph\fP
to an object of class \f3\%pfGroup\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.PD 0
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfMorph\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfMorph\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfMorph\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'morph\ \ 'u
\f2morph\fP
identifies a pfMorph.
.SH DESCRIPTION

A pfMorph node does not define geometry; rather, it manipulates
geometric attributes of pfGeoSets and other geometric primitives.
While pfMorph is very general, its primary use is for geometric
morphing where the colors, normals, texture coordinates and coordinates
of geometry are smoothly changed over time to simulate actions such as
facial and skeletal animation, ocean waves, continuous level-of-detail,
and advanced special effects. In these situations, the rigid body
transformations provided by matrices do not suffice - instead,
efficient per-vertex manipulations are required.

A pfMorph consists of one or more "sources" and a single "destination"
which together are termed an "attribute".  Both sources and destination
are arrays of "elements" where each element consists of 1 or more
floating point numbers, e.g., an array of pfVec3 coordinates.  The
pfMorph node produces the destination by computing a weighted sum of
the sources. By varying the source weights and using the morph
destination as a pfGeoSet attribute array, the application can achieve
smooth, geometric animation. A pfMorph can "morph" multiple
attributes.

\f3\%pfNewMorph\fP creates and returns a handle to a pfMorph.  Like
other pfNodes, pfMorphs are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetMorphClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfMorph\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetMorphClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfMorph\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfMorphAttr\fP configures the \f2index\fPth
attribute of \f2morph\fP.
\f2floatsPerElt\fP specifies how many floating point numbers comprise
a single attribute element. For example, when morphing
pfGeoSet coordinate and texture coordinate arrays (\f3\%PFGS_COORD3\fP,
\f3\%PFGS_TEXCOORD2\fP), \f2floatsPerElt\fP would be 3 and 2 respectively.
\f2nelts\fP specifies how many attribute elements are in the destination array.
If the required number of pfGeoSet coordinates is 33, then \f2nelts\fP
would be 33, \f2not\fP 33 * 3 = 99. \f2dst\fP is a pointer to the destination
array which should be at least of size \f2floatsPerElt\fP * \f2nelts\fP *
sizeof(float). If \f2dst\fP is \f3\%NULL\fP, then \f2morph\fP will
automatically create and use a pfCycleBuffer of appropriate size.
(pfCycleBuffers are useful when OpenGL Performer is configured
to multiprocess.)

There are 2 distinct methods of accessing the source arrays of a
pfMorph attribute: non-indexed and indexed. Indexing provides a
means of efficiently applying sparse changes to the destination array.
The \f2nsrcs\fP argument to \f3\%pfMorphAttr\fP specifies how many source
arrays are provided in \f2alist\fP, i.e., \f2alist\fP[i] is the i'th source
and is treated as an array of elements where each element consists
of \f2floatsPerElt\fP floating point numbers. Index arrays and their
lengths are provided in \f2ilist\fP and \f2nlist\fP respectively. If \f2ilist\fP
is \f3\%NULL\fP then all sources are non-indexed. If \f2ilist\fP is non-\f3\%NULL\fP,
it contains a list of index lists corresponding to the source lists
in \f2alist\fP. If \f2nlist\fP is \f3\%NULL\fP, then the index lists are assumed
to be \f2nelts\fP long and if non-\f3\%NULL\fP, the length of each index
list is specified in \f2nlist\fP. \f2ilist\fP may contain \f3\%NULL\fP pointers
to mix indexed and non-indexed source arrays.

All source arrays referenced in \f2alist\fP and \f2ilist\fP are reference
counted by \f3\%pfMorphAttr\fP.

\f3\%pfMorphWeights\fP specifies the source weights of the \f2index\fPth
attribute of \f2morph\fP in the
array \f2weights\fP. \f2weights\fP should consist of \f2nsrcs\fP floating
point numbers where \f2nsrcs\fP is the number of attribute sources
specified in \f3\%pfMorphAttr\fP. If
\f2index\fP is < 0, then \f2weights\fP is used for all attributes of
\f2morph\fP. \f3\%pfGetMorphWeights\fP copies the weights of the
\f2index\fPth attribute of \f2morph\fP into \f2weights\fP. \f2weights\fP
should be an array of at least \f2nsrcs\fP floats.

A pfMorph node is evaluated, i.e., its destination array is computed,
during the \f3\%APP\fP traversal which is triggered directly by
the application through \f3\%pfAppFrame\fP (see \f3\%pfAppFrame\fP)
or indirectly by \f3\%pfSync\fP.
Alternately, the pfMorph node may be explicitly evaluated by calling
the function \f3\%pfEvaluateMorph\fP.
In all cases, destination elements are computed as in the following
pseudocode:
.Ex
.nf

zero destination array;

for (s=0; s<\f2nsrcs\fP; s++)
{
    if (\f2ilist\fP == NULL || \f2ilist\fP[s] == NULL)
    {
	/* Source is non-indexed */
        for (i=0; i<\f2nelts\fP; i++)
            for (e=0; e<\f2floatsPerElt\fP; e++)
               dst[i][e] += \f2weights\fP[s] * \f2alist\fP[s][i][e];
    }
    else
    {
	/* Source is indexed */

	int	nindex;

	if (\f2nlist\fP == NULL)
	    nindex = \f2nelts\fP;
	else
	    nindex = \f2nlist\fP[s];

        for (i=0; i<nindex; i++)
            for (e=0; e<\f2floatsPerElt\fP; e++)
               dst[\f2ilist\fP[s][i]][e] += \f2weights\fP[s] * \f2alist\fP[s][i][e];
    }
}
.Ee
.fi
.na


Note that the actual implementation is much more efficient than above,
particularly for the special weights of 0 and 1.

Since pfMorph is a pfGroup, it is guaranteed to be evaluated before
its children in the APP traversal. The pfMorph is only evaluated by
the APP traversal when its weights change.

\f3\%pfGetMorphNumAttrs\fP returns the number
of \f2morph\fP's attributes.

\f3\%pfGetMorphSrc\fP returns the \f2src\fPth source
parameters of the \f2index\fPth attribute of \f2morph\fP. The source attribute array and index array pointers are
copied into \f2alist\fP and \f2ilist\fP respectively. The size of the
\f2src\fPth index array is copied into \f2nlist\fP and the number of floats
per element is returned by \f3\%pfGetMorphSrc\fP.

\f3\%pfGetMorphNumSrcs\fP returns the number of sources
of the \f2index\fPth attribute of \f2morph\fP.

\f3\%pfGetMorphDst\fP returns the \f2index\fPth
destination array of \f2morph\fP.  The destination array is either that
provided earlier by \f3\%pfMorphAttr\fP or the
pfCycleBuffer automatically created when \f3\%NULL\fP was passed as the
\f2dst\fP argument to \f3\%pfMorphAttr\fP.

.SH OBSOLETE
\f3\%pfMorph\fP has been obsoleted by \f3\%pfEngine\fP and \f3\%pfFlux\fP. pfFluxes
are multibuffered data objects for asyncrhonous evaluation, such as by pfEngines,
that can be directly used as vertex attribute
arrays, full pfGeoSets, matrices for \f3\%pfFSC\fP tranformation nodes, and
other special asynchronous values for \f3\%pfLOD\fP and \f3\%pfSwitch\fP.
See these man pages for more information.


.SH SEE ALSO
pfAppFrame,
pfCycleBuffer,
pfGroup,
pfDelete,
pfEngine,
pfFlux,
pfLookupNode
