'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfNode" "3pf"
.SH NAME
.upperok
.B pfGetNodeClassType,
.B pfGetParent,
.B pfGetNumParents,
.B pfNodeBSphere,
.B pfGetNodeBSphere,
.B pfClone,
.B pfBufferClone,
.B pfFlatten,
.B pfNodeName,
.B pfGetNodeName,
.B pfFindNode,
.B pfLookupNode,
.B pfNodeIsectSegs,
.B pfNodeTravMask,
.B pfGetNodeTravMask,
.B pfNodeTravFuncs,
.B pfGetNodeTravFuncs,
.B pfNodeTravData,
.B pfGetNodeTravData,
.B pfNodeTravMode,
.B pfGetNodeTravMode
\- 
Set and get pfNode parents and bounding spheres.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ char\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfType *
\f3\%pfGetNodeClassType\fP(void);
.nf
.fi
.TP
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.nf
.fi
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.nf
.fi
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.nf
.fi
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.nf
.fi
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfNode\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfNode\fP.
Casting an object of class \f3\%pfNode\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfNode\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'which\ \ 'u
\f2node\fP
identifies a pfNode
.Ex
.nf

typedef struct _pfSegSet
{
    int         mode;
    void *      userData;
    pfSeg       segs[PFIS_MAX_SEGS];
    uint        activeMask;
    uint        isectMask;
    void *      bound;
    int        (*discFunc)(pfHit*);
} pfSegSet;

typedef int (*pfNodeTravFuncType)(pfTraverser *trav, void *userData);
.Ee
.fi
.na

.TP
\f2which\fP
identifies the traversal: \f3\%PFTRAV_ISECT\fP,
\f3\%PFTRAV_APP\fP, \f3\%PFTRAV_CULL\fP or \f3\%PFTRAV_DRAW\fP, denoting the
intersection, application, cull, and draw processing stages
respectively.
.SH DESCRIPTION

A pfNode is an abstract type.  OpenGL Performer does not provide any means to
explicitly create a pfNode.  Rather, the pfNode routines operate on
the common aspects of other OpenGL Performer node types.

The complete list of OpenGL Performer nodes (all derived from pfNode) is:
.RS
.TP 5
\f3\%pfBillboard\fP
.TP
\f3\%pfDCS\fP
.TP
\f3\%pfGeode\fP
.TP
\f3\%pfGroup\fP
.TP
\f3\%pfLayer\fP
.TP
\f3\%pfLightPoint\fP
.TP
\f3\%pfLightSource\fP
.TP
\f3\%pfLOD\fP
.TP
\f3\%pfMorph\fP
.TP
\f3\%pfPartition\fP
.TP
\f3\%pfScene\fP
.TP
\f3\%pfSCS\fP
.TP
\f3\%pfSequence\fP
.TP
\f3\%pfSwitch\fP
.TP
\f3\%pfText\fP
.RE

Any OpenGL Performer node is implicitly a pfNode, and a pointer to any of the
above nodes may be used wherever a pfNode* is required as an argument.

The various pfNode types have certain common properties such as a set
of parents, a name, an intersection mask, bounding geometry, callback
functions and callback data.

\f3\%pfGetNodeClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfNode\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetNodeClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfNode\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfGetNumParents\fP returns the number of parents \f2node\fP has in the
scene graph.  A node may have multiple parents because it was
explicitly added to multiple parents with \f3\%pfAddChild\fP. In such cases
it said to be 'instanced'.  Also, leaf geometry nodes such as
pfGeodes, pfLightPoints, and pfBillboards, may have multiple parents as
a result of a \f3\%pfClone\fP.  \f3\%pfGetParent\fP returns the \f2i\fPth parent
of \f2node\fP or \f3\%NULL\fP if \f2i\fP is out of the range 0 to
\f3\%pfGetNumParents\fP - 1.

\f3\%pfNodeBSphere\fP sets the bounding volume of \f2node\fP.  Each pfNode
has an associated bounding volume used for culling and intersection
testing and a bounding mode, either static or dynamic.  By definition,
the bounding volume of a node encloses all the geometry parented by
node, which means that the node and all its children fit within the
node's bounding volume.

Only a subset of the pfNode types actually contain geometry.  These are
known as "leaf nodes" in OpenGL Performer. They are:
.RS
\f3\%pfBillboard\fP
.br
\f3\%pfGeode\fP
.br
\f3\%pfLightPoint\fP
.RE

These and other nodes may indirectly contain geometry through
user-supplied function callbacks set by \f3\%pfNodeTravFuncs\fP.

Normally OpenGL Performer automatically computes bounding volumes but
provides routines to explicitly set bounding volumes.  This is useful
for pfNodes which draw custom geometry through node callbacks
(\f3\%pfNodeTravFuncs\fP).

The \f2bsph\fP argument to \f3\%pfNodeBSphere\fP is the bounding sphere of
\f2node\fP.  If the \f2bsph\fP is \f3\%NULL\fP, OpenGL Performer will compute the
bounding sphere of \f2node\fP.

The \f2mode\fP argument to \f3\%pfNodeBSphere\fP specifies whether or not the
bounding volume for \f2node\fP should be recomputed when an attribute of
\f2node\fP changes or something in the scene graph below \f2node\fP changes
(if \f2node\fP is a pfGroup).  If the mode is \f3\%PFBOUND_STATIC\fP, OpenGL
Performer will not modify the bound once it is set or computed.  If the
mode is \f3\%PFBOUND_DYNAMIC\fP, OpenGL Performer will recompute the bound after
children are added or deleted or after the matrix in a pfDCS changes.
Changes in pfSwitches, pfLODs and pfSequences do not affect bounds
above them in the scene graph.

\f3\%pfGetNodeBSphere\fP returns the current bounding mode and copies into
\f2bsph\fP a pfSphere which encloses \f2node\fP and its children The
return value is the bounding mode which is either \f3\%PFBOUND_DYNAMIC\fP
or \f3\%PFBOUND_STATIC\fP indicating whether or not the bounding volume is
updated automatically when its children change.

OpenGL Performer supports two methods of node instancing.  The first
method is to simply add a node to more than one parent using
\f3\%pfAddChild\fP or \f3\%pfReplaceChild\fP (see pfGroup).  In this case the
graph rooted by the instanced node is shared by all its parents.  This
type of instancing is called \f2shared\fP instancing.

\f3\%pfClone\fP provides instancing which shares geometry but not variable
state like transformations (pfDCS) and switches (pfSwitch).
\f3\%pfClone\fP copies the entire scene graph from \f2node\fP down to, but
not including, leaf geometry nodes such as pfGeodes, pfBillboards and
pfLightPoints.  These leaf nodes are instanced by reference in the
cloned scene graph.  \f3\%pfClone\fP returns the root pfNode of the cloned
graph or \f3\%NULL\fP to indicate error.  This type of instancing is called
\f2common geometry\fP instancing.  An attempt to clone a leaf geometry node
simply returns the handle to that node.

Cloning is recommended for instances of dynamic and articulated
models.  For example: Shared instances of a model with pfDCSes in its
hierarchy will share the pfDCSes as well as the geometry.  This means
that all instances will have the exact same articulation.  However, a
common geometry instance will share only geometry and as a result of
the cloning process will have its own pfDCSes allowing manipulation
independently of any other instances.
This example creates a cloned
instance:
.Ex
.nf

if ((clone = pfClone(carModel, 0)) != NULL)
    pfAddChild(carDCS_3, clone);
.Ee
.fi
.na


The \f2mode\fP argument to \f3\%pfClone\fP is reserved for future extensions
and must be 0 in this release of OpenGL Performer.

When cloning, if the global copy function (\f3\%pfCopyFunc\fP) is \f3\%NULL\fP, user
data pointers (\f3\%pfUserData\fP) are copied to each new node and the
reference counts of pfMemory-derived user data are incremented. If
\f3\%pfCopyFunc\fP is not \f3\%NULL\fP, it will be invoked with the destination
and source nodes as arguments. It is then the responsibility of the copy
function to handle the copy of user data.

\f3\%pfBufferClone\fP is identical to \f3\%pfClone\fP but allows
cloning across pfBuffers. \f2buf\fP identifies the pfBuffer which
contains \f2node\fP and its subtree. The clone of \f2node\fP
and its subtree is placed in the current buffer set
by \f3\%pfSelectBuffer\fP. See the pfBuffer man page for more details.

\f3\%pfFlatten\fP is a database pre-processing step which 'flattens' the
transformation hierarchy of the scene graph rooted by \f2node\fP.
Coordinates and normals contained in leaf geometry nodes such as
pfGeodes, pfBillboards and pfLightPoints are transformed by any
inherited static transformations (pfSCS).  \f3\%pfFlatten\fP automatically
clones any pfNode or pfGeoSet that is multiply referenced. Specifically,
if \f2node\fP has multiple parents, \f2node\fP and its entire subtree will be
cloned. If a pfDCS is
encountered, \f3\%pfFlatten\fP inserts a pfSCS in between the pfDCS and
its parent.

Flattening can substantially improve performance, especially when
pfSCSes are being used to instance a relatively small amount of
geometry since the cost of the transformation approaches the cost of
drawing the geometry.  However, it can also increase the size of the
database since it copies instanced nodes and geometry.  Flattening is
highly recommended for pfBillboards. Flattening also increases the
ability of OpenGL Performer to sort the database by mode (see \f3\%pfChanBinSort\fP),
often a major performance enhancement, since sorting does not cross
transformation boundaries.

\f3\%pfFlatten\fP does not remove pfSCSes from the hierarchy; instead it
sets their transformations to the identity matrix.  For improved
traversal performance, these flattened pfSCS nodes should be removed
from the hierarchy.

The \f2mode\fP argument to pfFlatten is currently ignored and should be 0.

All OpenGL Performer database nodes may be assigned a character string name.
Individual node names need not be unique but to access a node with a
non-unique name, an unambiguous pathname to the
node must be given.  The pathname doesn't need to be a full path.  All
that's required is enough to distinguish the node from others with
the same name.

\f3\%pfNodeName\fP sets the name of \f2node\fP to the string \f2name\fP.  If
the name is unique a 1 will be returned and if the name is not unique,
a 0 will be returned. Node names are kept in a global table which is
used for resolving the first path component of a path name by
\f3\%pfLookupNode\fP. In this case, unambiguous resolution is only possible if the
first path component is unique. \f3\%pfGetNodeName\fP returns the name
of the node or NULL if the name has not been set.

\f3\%pfFindNode\fP is a general search routine for finding named pfNodes.
\f3\%pfFindNode\fP begins searching for the node of type \f2type\fP and
identified by a '/'-separated path name \f2pathName\fP. The search
begins at \f2node\fP and uses a depth-first traversal.  \f3\%pfFindNode\fP
returns NULL if it cannot find the node. Note that the type checking
performed by \f3\%pfFindNode\fP is equivalent to \f3\%pfIsOfType\fP, not
\f3\%pfIsExactType\fP, e.g. searching for a pfGroup includes derived
classes such as pfSwitch.

The string \f2pathName\fP can be either a name or a '/'-separated pathname.
If the name contains no '/' characters, it is assumed to be unique and
the global name table is searched.  If \f2pathName\fP contains '/'
characters, it is assumed to be a path.  Paths are searched by first
finding the node corresponding to the first component of the path
in a global name table. The find routine then traverses the
subtree rooted at that node, searching for the rest of the path. The first
node encountered during the search traversal which matches
\f2pathName\fP is returned.

Example 1:
.Ex
.nf


pfNode	*newhouse, *newdoor;
pfDCS	*door;

/* Create "house" model with named subparts including "door" */

/* Create a new instance of "house" */
newhouse = pfClone(house, 0);

/* Give cloned house a new name */
pfNodeName(newhouse, "newhouse");

/* Find the door part of the new house */
door = (pfDCS*) pfFindNode(newhouse, "door", pfGetDCSClassType());
.Ee
.fi
.na


\f3\%pfNodeIsectSegs\fP intersects a group of line
segments with a scene or portion thereof.  The intersection operation
traverses the scene graph, testing a group of segments against
bounding geometry and eventually model geometry within pfGeoSets.
\f2node\fP specifies the node at which intersection traversal
starts.

\f3\%pfNodeIsectSegs\fP returns the number of
segments which intersected something.  \f2hits\fP is an empty array
supplied by the user through which results are returned.  The array
must have an entry for each segment in \f2segSet\fP.  Upon return,
\f2hits\fP[i][0] is a pfHit* which gives the intersection result for the
\f2i\fPth segment in \f2segSet\fP.  The pfHit objects come from an
internally maintained pool and are reused on subsequent requests.
Hence, the contents are only valid until the next invocation of
\f3\%pfGSetIsectSegs\fP in the current process.  They should not be freed
by the application.

\f2segSet\fP is a pfSegSet structure specifying the intersection
request.  In the structure, \f2segs\fP is an array of line segments to
be intersected against the pfGeoSet.  \f2activeMask\fP is a bit vector
specifying which segments in the pfSegSet are to be active for the
current request.  If bit[i] of the \f2activeMask\fP is set to 1, it
indicates the corresponding segment in the \f2segs\fP array is active.

The bit vector \f2mode\fP specifies the behavior of the
intersection operation and is a bitwise OR of the following:
.RS
.TP 5
\f3\%PFTRAV_IS_PRIM\fP
Intersect with quads or triangle geometry.
.TP
\f3\%PFTRAV_IS_GSET\fP
Intersect with pfGeoSet bounding boxes.
.TP
\f3\%PFTRAV_IS_GEODE\fP
Intersect with pfGeode bounding sphere.
.TP
\f3\%PFTRAV_IS_NORM\fP
Return normals in the pfHit structure.
.TP
\f3\%PFTRAV_IS_CULL_BACK\fP
Ignore back-facing polygons.
.TP
\f3\%PFTRAV_IS_CULL_FRONT\fP
Ignore front-facing polygons.
.TP
\f3\%PFTRAV_IS_PATH\fP
Retain traversal path information.
.TP
\f3\%PFTRAV_IS_NO_PART\fP
Do not use partitions for intersections.
.RE

For several types of pfGroups, the traversal of children can be
controlled for the traversal.

For pfSwitches, the default is to traverse only the child or children
specified by the current switch value.  This can be changed OR-ing one
of the following into the \f2mode\fP argument.
.RS
.TP 5
\f3\%PFTRAV_SW_ALL\fP
Traverse all children of pfSwitches.
.TP
\f3\%PFTRAV_SW_NONE\fP
Don't traverse any children of pfSwitches.
.RE

For pfSequences, the default is to traverse only the current child in
the sequence.  This can be changed OR-ing one of the following into the
\f2mode\fP argument.
.RS
.TP5
\f3\%PFTRAV_SEQ_ALL\fP
Intersect with all children of pfSequences.
.TP
\f3\%PFTRAV_SEQ_NONE\fP
Intersect with no children of pfSequences.
.RE

For pfLODs, the default is to traverse only the child that would be
active at range 0.  This can be changed OR-ing one of the following
into the \f2mode\fP argument.  Also, see \f3\%pfChanNodeIsectSegs\fP for
child selection based on range.
.RS
.TP5
\f3\%PFTRAV_LOD_ALL\fP
Intersect with all children of pfLODs (default is range 0).
.TP
\f3\%PFTRAV_LOD_NONE\fP
Intersect with no children of pfLODs (default is range 0).
.RE

For pfLayers, the default is to traverse all children.  This can be
changed OR-ing one of the following into the \f2mode\fP argument.
.RS
.TP5
\f3\%PFTRAV_LAYER_NONE\fP
Intersect with no children of pfLayers (default is all).
.TP
\f3\%PFTRAV_LAYER_BASE\fP
Intersect with no children of pfLayers (default is all).
.TP
\f3\%PFTRAV_LAYER_DECAL\fP
Intersect with no children of pfLayers (default is all).
.RE

The bit fields \f3\%PFTRAV_IS_PRIM\fP, \f3\%PFTRAV_IS_GSET\fP, and
\f3\%PFTRAV_IS_GEODE\fP indicate the level at which intersections should be
evaluated and discriminator callbacks, if any, invoked.  If none of these
three fields are specified, no intersection testing is done.

In the pfSegSet, \f2isectMask\fP is another bit vector which directs the
intersection traversal.  At each stage of the intersection operation,
the mask is bit-wise AND-ed with the mask of the pfNode or pfGeoSet.
If the mask is non-zero the intersection continues with the next
object, either a pfNode within a pfGroup or a primitive within a
pfGeoSet.  The mask of a pfNode is set using
\f3\%pfNodeTravMask\fP and that of a pfGeoSet
by \f3\%pfGSetIsectMask\fP.  The mask can
be used to distinguish parts of the scene graph which might respond
differently to vision or collision.  For example, as a wall would stop
a truck but shrubbery would not.

The \f2bound\fP field in a pfSegSet is an optional user-provided bounding
volume around the set of segments.  Currently, the only supported
volume is a cylinder.  To use a bounding cylinder, perform a bitwise OR
of \f3\%PFTRAV_IS_BCYL\fP into the \f3\%mode\fP field of the pfSegSet and assign
the pointer to the bounding volume to the \f3\%bound\fP field.

\f3\%pfCylAroundSegs\fP will construct a
cylinder around the segments.  When a bounding volume is supplied, the
intersection traversal may use the cylinder to improve performance.
The largest improvement is for groups of at least several segments
which are closely grouped segments.  Placing a bounding cylinder
around small groups or widely dispersed segments can decrease
performance.

The \f2userData\fP pointer allows an application to associate other data
with the pfSegSet.  Upon return and in discriminator callbacks, the
pfSegSet's \f2userData\fP pointer can be obtained from the returned pfHit
with \f3\%pfGetUserData\fP.

\f2discFunc\fP is a user supplied callback function which provides a more
powerful means for controlling intersections than the simple mask
test.

If \f2discFunc\fP is NULL, the default behavior clips the end of the
segment after each successful intersection at the finest resolution
(pfGeode bounding volume , pfGeoSet bounding box, pfGeoSet geometry)
specified in \f2mode\fP.  Thus, the segment is clipped by each successful
intersection so that the intersection point nearest the starting point
of the segment is returned upon completion.

If a discriminator callback is specified, whenever an intersection
occurs, the \f2discFunc\fP callback is invoked with a pfHit structure
containing information about the intersection.  The discriminator may
then return a value which indicates whether and how the intersection
should continue. The continuation selectors are \f3\%PFTRAV_CONT\fP,
\f3\%PFTRAV_PRUNE\fP, and \f3\%PFTRAV_TERM\fP.
.RS
.TP 5
\f3\%PFTRAV_CONT\fP
Indicates that the traversal should continue traversing
the pfGeoSets beneath a pfGeode.  The discriminator function can
examine information about candidate intersections and judge their
validity and control the continuation of the traversal with its return
value.
.TP
\f3\%PFTRAV_PRUNE\fP
Indicates the traversal should return from the current
level of the search and continue.  If returned on a pfGeoSet primitive
or bounding box test, \f3\%PFTRAV_PRUNE\fP stops further testing of the
line segment against that pfGeoSet.  If returned on the test against a
pfGeode bounding volume, the pfGeode is not traversed for that
line segment.
.TP
\f3\%PFTRAV_TERM\fP
Indicates that the search should terminate for this
segment of the pfSegSet.  To have \f3\%PFTRAV_TERM\fP or \f3\%PFTRAV_PRUNE\fP
apply to all segments, \f3\%PFTRAV_IS_ALL_SEGS\fP can be OR-ed into the
discriminator return value.  This causes the entire traversal to be
terminated or pruned.
.RE

The callback may OR other bitfields into the status return value:
.RS
.TP 5
\f3\%PFTRAV_IS_IGNORE\fP
Indicates that the current intersection should be ignored, otherwise
the intersection is taken as valid.
.TP
\f3\%PFTRAV_IS_CLIP_START\fP
Indicates for pruned and continued traversals that before proceeding the
segment should be clipped to start at the current intersection point.
.TP
\f3\%PFTRAV_IS_CLIP_END\fP
Indicates for pruned and continued traversals that before proceeding the
segment should be clipped to end at the current intersection point.
.RE

If \f2discFunc\fP is NULL, the behavior is the same as if the
discriminator returned \f3\%PFTRAV_CONT\fP | \f3\%PFTRAV_IS_CLIP_END\fP, so
that the intersection nearest the start of the segment will be
returned.

In addition to the discriminator callback, pre- and post- intersection
callbacks are available for each node.  These behave identically to the
pre- and post-callbacks for the cull traversal and can be used to
prune, continue or terminate the traversal at any node.

Both \f3\%pfNodeIsectSegs\fP and the discriminator callback return
information about an intersection in a pfHit object which can be
examined using the \f3\%pfQueryHit\fP and \f3\%pfMQueryHit calls\fP.  The
information includes the intersection point, current matrix
transformation, scene graph, and path.  See the man page for
pfHit for further details.

In multiprocess applications, \f3\%pfNodeIsectSegs\fP should be called
from the APP process or from the ISECT process (in the callback
specified by \f3\%pfIsectFunc\fP).  When called in the APP process,
\f3\%pfNodeIsectSegs\fP should be called after \f3\%pfFrame\fP and before
\f3\%pfSync\fP for best system throughput.

\f3\%pfNodeTravMask\fP sets the traversal
masks of \f2node\fP which are used to control traversal during the
intersection, cull, and draw traversals.  If the bitwise AND of the
node's mask for that traversal type and the mask for the current
traversal is zero, the traversal is disabled at that node.  By
default, the node masks are all 1's.  Traverser masks are set by
\f3\%pfNodeIsectSegs\fP/\f3\%pfChanNodeIsectSegs\fP for
the intersection traversal and
\f3\%pfChanTravMask\fP for the CULL and
DRAW traversals.
\f3\%pfGetNodeTravMask\fP returns the
specified traversal mask for the node.

Bits in the \f2setMode\fP argument indicate whether the set operation
should be carried out for just the specified pfNode (\f3\%PFTRAV_SELF\fP),
just its descendents (\f3\%PFTRAV_DESCEND\fP) or both itself and
descendents.  The descendent traversal goes down into pfGeoSets.

The \f2bitOp\fP argument is one of \f3\%PF_AND\fP, \f3\%PF_OR\fP, or \f3\%PF_SET\fP
and indicates whether the new mask should be AND-ed with the old mask,
OR-ed with the old mask or set outright, respectively.

Efficient intersections require that information be cached for each
pfGeoSet to be intersected with.  To create this cache,
\f3\%PFTRAV_IS_CACHE\fP should be OR-ed into the \f2setMode\fP when first
setting the intersection mask.  Because of the computation involved,
the cache is best created at setup time.  Subsequent changes to the
masks themselves do not require \f3\%PFTRAV_IS_CACHE\fP to be specified.
However, for dynamic objects whose geometry changes (e.g. pfGeoSets
whose vertex arrays are being changed), additional calls with the
\f3\%PFTRAV_IS_CACHE\fP in \f2setMode\fP should be used to recompute the
cached information.  \f3\%PFTRAV_IS_UNCACHE\fP can be OR-ed into the
\f2setMode\fP to disable caching.  \f3\%PFTRAV_IS_CACHE\fP and
\f3\%PFTRAV_IS_UNCACHE\fP can only be specified when \f2which\fP is
\f3\%PFTRAV_ISECT\fP.

\f3\%pfNodeTravFuncs\fP specify the user
supplied functions which are to be invoked during the traversal
indicated by \f2which\fP.  For each traversal, there is a \f2pre\fP and
\f2post\fP traversal callback.  \f2pre\fP is invoked before \f2node\fP and
its children are processed while \f2post\fP is invoked after.  The pre-
and post- methodology supports save and restore or push and pop
programming constructs.  Node callbacks are passed pointers to the
user supplied traversal data pointer for that node and a pfTraverser
which defines the current traversal state.
\f3\%pfGetNodeTravFuncs\fP copies
\f2node\fP's pre and post callbacks of traversal type
\f2which\fP into \f2pre\fP and \f2post\fP respectively.

The \f2data\fP argument to
\f3\%pfNodeTravData\fP is the pointer which is
passed to the traversal callbacks indicated by \f2which\fP.  Both pre-
and post-callbacks will be passed \f2data\fP in addition to a
pfTraverser*.  When multiprocessing, \f2data\fP should point to memory
in a shared arena.  \f3\%pfGetNodeTravData\fP
returns the current data pointer for the specified traversal.

\f3\%pfNodeTravMode\fP is used to set additional
mode information to control traversals.
Currently the \f3\%which\fP argument must be
\f3\%PFTRAV_CONT\fP and the \f3\%mode\fP argument must be \f3\%PFN_CULL_SORT\fP;
the possible choices for the \f3\%value\fP argument are:
.RS
.TP 5
\f3\%PFN_CULL_SORT_UNCONTAINED\fP
This is the default value.
It means that pre- and post-CULL traversal funcs on a node
do not prevent the contents of the node from being interleaved
with the contents of other nodes during CULL sorting.
This means that (surprise!) the contents of the node are not
necessarily bracketed by the graphics calls made in the pre-
and post-CULL node trav funcs.
This behavior is for the benefit of CULL funcs whose purpose
is to return a cull result but that don't make any graphics calls.
(Note that in contrast, pre- and post-DRAW funcs on a node are guaranteed
to bracket the contents of the node, and therefore they prevent
the interleaving of the contents of the node with the contents
of other nodes.)
.TP
\f3\%PFN_CULL_SORT_CONTAINED\fP
This is the opposite of \f3\%PFN_CULL_SORT_UNCONTAINED\fP;
setting this value guarantees the following:
.br
1. Display list items produced by the pre-node CULL func
will get placed in the display list before the contents of the node (including
its children and DRAW funcs)
.br
2. Display list items produced by the post-node CULL func
will get placed in the display list after the contents
of the node (including its children and DRAW funcs)
.br
3. No part of the scene graph other than this node (including
its children and DRAW funcs)
will be placed in the display list
between the items produced by the pre-node CULL func
and the items produced by the post-node CULL func.
.br
\f3\%PFN_CULL_SORT_CONTAINED\fP is typically used in applications such as virtual clip texturing
in which the pre-cull function calls display-listable functions
(such as
\f3\%pfApplyClipTextureVirtualParams\fP)
which are intended to affect the contents of the node and its children,
and no other part of the scene graph.
Turning off CULL sorting altogether using
\f3\%pfChanTravMode\fP
is another way to accomplish
this effect, but that is usually overkill and can result in greatly
decreased performance, as can setting DRAW trav funcs on the node
to accomplish the \f3\%PFN_CULL_SORT_CONTAINED\fP effect.
.RE

\f3\%pfGetNodeTravMode\fP returns
the current value of the given \f3\%mode\fP for the given traversal type \f3\%which\fP.

.SH NOTES

When instanced geometry is flattened, the copy created by \f3\%pfFlatten\fP
shares pfGeoSet attribute arrays with the original when possible.  This
means that the newly flattened pfGeoSet may share some arrays (e.g. color
array), but not other arrays (e.g. the vertex array) with the original.

The post-cull callback is a good place to implement custom level-of-detail
mechanisms.

Currently, nodes use spheres as the default bounding volume.  This may
change in a future release.  \f3\%libpfutil\fP contains sample code for
computing the bounding box for a subgraph of the scene.

It's an interesting fact that although a node's bounding volume completely
contains the geometry of the nodes that it parents, it may well \f2not\fP
completely contain the bounding volumes of those same nodes.  Do you
understand when this situation would occur?

Finding a node by name can be expensive, particularly for path based
searches.  These functions are primarily intended to get handles to
nodes which are loaded from disk and should be used sparingly at
simulation time.

In OpenGL Performer releases since 2.0, \f3\%pfLookupNode\fP
replaces a number of functions from Performer 1.2, e.g. \f3\%pfLookupBboard\fP.
See the scripts in /usr/share/Performer/src/tools for help in porting code.
.SH BUGS
If the graph under a node cloned by
\f3\%pfClone\fP contains an object instanced within
the graph, (i.e. a node having two or more parents within the graph),
the new graph will contain multiple copies of the instanced node
rather than duplicating the connectivity of the original graph.

\f3\%pfFlatten\fP transforms the vertex arrays of non-instanced geometry
in place.  If a pfGeoSet belongs to multiple pfGeodes or a vertex
array is shared between pfGeoSets the array is still flattened in
place.

It is not possible to get multiple intersection results per segment
without a discriminator callback.

Bounding cylinders do not work when non-orthonormal transformations
are present in the pfDCS and pfSCS nodes of a scene graph.

The path returned by \f3\%pfGetTravPath\fP is valid only when invoked
from a cull callback.
.SH SEE ALSO
pfAddChild,
pfCylAroundSegs,
pfDelete,
pfClone,
pfFlatten,
pfGetType,
pfFindNode,
pfLookupNode,
pfNodeIsectSegs,
pfNodeName,
pfNodeTravFuncs,
pfCopyFunc,
pfChanBinSort,
pfGSetIsectMask,
pfQueryHit,
pfMQueryHit,
pfBillboard,
pfDCS,
pfFrame,
pfGeode,
pfIsectFunc,
pfLightPoint,
pfScene,
pfSCS,
pfSeg,
pfGSetIsectSegs,
pfSync,
pfTraverser
