'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfPartition" "3pf"
.SH NAME
.upperok
.B pfNewPart,
.B pfGetPartClassType,
.B pfPartVal,
.B pfGetPartVal,
.B pfPartAttr,
.B pfGetPartAttr,
.B pfBuildPart,
.B pfUpdatePart
\- 
Create and update pfPartition spatial partitioning node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfPartition\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfPartition *
\f3\%pfNewPart\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetPartClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfPartVal\fP(pfPartition*\ part,
'in +2
'll -2
int\ which,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetPartVal\fP(pfPartition\ *part,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfPartAttr\fP(pfPartition*\ part,
'in +2
'll -2
int\ which,
void\ *attr);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfGetPartAttr\fP(pfPartition\ *part,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfBuildPart\fP(pfPartition*\ cset);
.nf
.fi
.TP
void
\f3\%pfUpdatePart\fP(pfPartition*\ cset);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfPartition\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfPartition\fP.
Casting an object of class \f3\%pfPartition\fP
to an object of class \f3\%pfGroup\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.PD 0
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfPartition\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfPartition\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfPartition\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION


A pfPartition is a type of pfGroup for organizing the subgraph of a
scene into a static data structure which is more efficient for
intersection testing with \f3\%pfNodeIsectSegs\fP for some databases.
pfPartition does not affect culling performance nor does it improve
intersection performance under transformation nodes, pfSwitch nodes,
pfMorph nodes or pfSequence nodes.

\f3\%pfNewPart\fP creates and returns a handle to a pfPartition.  Like
other pfNodes, pfPartitions are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetPartClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfPartition\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetPartClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfPartition\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfBuildPart\fP constructs a 2D spatial
partitioning based on the \f2type\fP.

Within the confines of the parameters set by
\f3\%pfPartAttr\fP, OpenGL Performer attempts
to construct an optimal partition based on the distribution of
vertices within the pfGeoSets in the subgraph of the scene rooted at
the partition.  Information about the selected partitioning is
displayed when the \f3\%pfNotifyLevel\fP is debug or higher.  Because the
search for the optimal partitioning is compute intensive, once the
partitioning has been determined for a particular database, the range
of the search should be restricted using
\f3\%pfPartAttr\fP.

\f3\%pfUpdatePart\fP causes the scene graph
under the partition to be traversed and any changes incorporated into
the spatial partitioning.  The partitioning itself does not change.

\f3\%pfPartAttr\fP sets the partition
attribute \f2attr\fP to the attribute \f2attr\fP.  Partition attributes
are:
.RS
.TP 5
\f3\%PFPART_MIN_SPACING\fP
\f2attr\fP points to a pfVec3 specifying the minimum spacing between
partition dividers in each dimension.  If not specified, the default
is 1/20th of the bounding box diagonal.  When a partition is built, a
search is made between \f3\%PFPART_MAX_SPACING\fP and \f3\%PFPART_MIN_SPACING\fP.
.TP
\f3\%PFPART_MAX_SPACING\fP
\f2attr\fP points to a pfVec3 specifying the maximum spacing between
partition dividers in each dimension.  If not specified, the default
is 1/10th of the bounding box diagonal.  When a partition is built, a
search is made between \f3\%PFPART_MAX_SPACING\fP and \f3\%PFPART_MIN_SPACING\fP.
.TP
\f3\%PFPART_ORIGIN\fP
\f2attr\fP points to a pfVec3 specifying an origin for the partition.
If not specified, a search is done to find an optimal origin.
.RE

\f3\%pfGetPartAttr\fP returns the partition
attribute \f2attr\fP.

\f3\%pfPartVal\fP sets the partition value
\f2val\fP to the value \f2val\fP.  Partition values are:
.RS
.TP 5
\f3\%PFPART_FINENESS\fP
A value between 0.0 and 1.0 which indicates how fine of a partitioning
should be constructed.  The subdivision is limited by
\f3\%PFPART_MIN_SPACING\fP and \f3\%PFPART_MAX_SPACING\fP.  1.0 causes
extremely fine subdivision.  0.0 causes no subdivision.  0.5 is
usually a good value and is the default.
.RE

\f3\%pfGetPartVal\fP returns the partition
value \f2val\fP.

A pfPartition behaves like a pfGroup when the mode in the pfSegSet
used with \f3\%pfNodeIsectSegs\fP includes \f3\%PFTRAV_IS_NO_PART\fP.

.SH NOTES


pfPartitions are primarily useful for databases containing many
axis-aligned objects for which bounding spheres are a poor fit and
when only one or two segments are made per call to
\f3\%pfNodeIsectSegs\fP.  For example, terrain following on gridded
terrain is likely to benefit.  For databases such as this which
themselves have a regular grid, it is also important for performance
that the origin and spacing of the partition align exactly the terrain
grid.  pfPartitions do not currently help with the problem pfGeoSets
containing too much geometry.

.SH BUGS


The search for an optimal grid is very thorough so that it takes a
\f2very\fP long time if the search domain is large.  Once a good
partitioning for a database is determined, the \f3\%PFPART_MIN_SPACING\fP,
\f3\%PFPART_MAX_SPACING\fP and \f3\%PFPART_ORIGIN\fP can be set equal for much
faster building.

Currently only partitionings in the XY plane are supported.

.SH SEE ALSO
pfGroup,
pfLookupNode,
pfNode,
pfNodeIsectSegs,
pfNotifyLevel,
pfScene
