'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfPath" "3pf"
.SH NAME
.upperok
.B pfNewPath,
.B pfGetPathClassType,
.B pfCullPath
\- 
Create, modify, and maintain a node path.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfPath\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfPath *
\f3\%pfNewPath\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetPathClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfCullPath\fP(pfPath\ *path,
'in +2
'll -2
pfNode\ *node,
int\ mode);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfPath\fP is
derived from the parent class \f3\%pfList\fP,
so each of these member functions of
class \f3\%pfList\fP
are also directly usable with objects
of class \f3\%pfPath\fP.
Casting an object of class \f3\%pfPath\fP
to an object of class \f3\%pfList\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfList\fP.

.PD 0
.TP \w'const\ void\ **\ \ \ 'u
void
\f3\%pfAdd\fP(pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.PD 0
.TP
void
\f3\%pfCombineLists\fP(pfList*\ dst,
'in +2
'll -2
const\ pfList\ *a,
const\ pfList\ *b);
.in
.ll
.PD 0
.TP
int
\f3\%pfFastRemove\fP(pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.PD 0
.TP
void
\f3\%pfFastRemoveIndex\fP(pfList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGet\fP(const\ pfList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
const void **
\f3\%pfGetListArray\fP(const\ pfList*\ list);
.PD 0
.TP
int
\f3\%pfGetListArrayLen\fP(const\ pfList*\ len);
.PD 0
.TP
int
\f3\%pfGetListEltSize\fP(const\ pfList*\ list);
.PD 0
.TP
int
\f3\%pfGetNum\fP(const\ pfList*\ list);
.PD 0
.TP
void
\f3\%pfInsert\fP(pfList*\ list,
'in +2
'll -2
int\ index,
void*\ elt);
.in
.ll
.PD 0
.TP
int
\f3\%pfMove\fP(pfList*\ lists,
'in +2
'll -2
int\ index,
void\ *elt);
.in
.ll
.PD 0
.TP
void
\f3\%pfListArrayLen\fP(pfList*\ list,
'in +2
'll -2
int\ len);
.in
.ll
.PD 0
.TP
void
\f3\%pfNum\fP(pfList\ *list,
'in +2
'll -2
int\ num);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemove\fP(pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.PD 0
.TP
void
\f3\%pfRemoveIndex\fP(pfList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplace\fP(pfList*\ list,
'in +2
'll -2
void*\ old,
void*\ new);
.in
.ll
.PD 0
.TP
void
\f3\%pfResetList\fP(pfList*\ list);
.PD 0
.TP
int
\f3\%pfSearch\fP(const\ pfList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.PD 0
.TP
void
\f3\%pfSet\fP(pfList*\ list,
'in +2
'll -2
int\ index,
void\ *elt);
.in
.ll

.PD
.PP
Since the class
\f3\%pfList\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfPath\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfPath\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

A pfPath is a dynamically-sized array of pointers.  A pfPath consisting
of pfNode pointers can define a specific path or chain of nodes through
a scene graph.

\f3\%pfNewPath\fP creates and returns a handle to a pfPath.
pfPaths are usually allocated from shared memory.  The path element
size is sizeof(void*) and the initial number of elements in the path
is 4.  pfPaths can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetPathClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfPath\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetPathClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfPath\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfCullPath\fP traverses and culls the chain of nodes specified in
\f2path\fP, beginning at \f2root\fP.  If \f2path\fP is NULL, then \f2root\fP
will be traversed in-order.  If \f2root\fP is NULL, then the exact
chain of nodes specified in \f2path\fP will be traversed.  If neither
\f2root\fP nor \f2path\fP is NULL, then the paths traversed will be all
paths emanating from \f2root\fP which reach the first node in \f2path\fP
and then continue down the nodes specified in \f2path\fP.

\f2mode\fP is a bitmask indicating which type of "switching" nodes (pfLOD,
pfSequence, pfSwitch) to evaluate and may be either:
.RS
.TP 5
\f3\%PFPATH_IGNORE_SWITCHES\fP
Do not evaluate any switches in the node path.
.RE

or else it is the bitwise OR of the following:
.RS
.TP 5
\f3\%PFPATH_EVAL_LOD\fP
Evaluate any pfLOD nodes in the node path.
.TP
\f3\%PFPATH_EVAL_SEQUENCE\fP
Evaluate any pfSequence nodes in the node path.
.TP
\f3\%PFPATH_EVAL_SWITCH\fP
Evaluate any pfSwitch nodes in the node path.
.RE

When an enabled switch node is encountered, traversal will terminate
if the next node in the path is not one selected by the switch. As
a convenience, \f3\%PFPATH_EVAL_SWITCHES\fP is defined to enable all three
of these switchs (\f3\%PFPATH_EVAL_LOD\fP, \f3\%PFPATH_EVAL_SWITCH\fP, and
\f3\%PFPATH_EVAL_SEQUENCE\fP).

Example 1: Path culling
.Ex
.nf

	  scene
	 / \\   \\
	/  scs0 group0
        \\   /     \\
        switch0    geode2
        /  \\
       /    \\
    geode0 geode1
.Ee
.fi
.na


.Ex
.nf

path = pfNewPath();

pfAdd(path, switch0);
pfAdd(path, geode1);
 :
/*
 * In cull callback.  This will cull the following paths:
 *
 *      scene -> switch0 -> geode1
 *      scene -> scs0 -> switch0 -> geode1
 *
 * Note that both path traversals will terminate at switch0
 * if the pfSwitch's switch value is not 1.
*/
pfCullPath(path, scene, PFPATH_EVAL_SWITCHES);
.Ee
.fi
.na


\f3\%pfCullPath\fP should only be called in the cull callback function
set by \f3\%pfChanTravFunc\fP.  The pfChannel passed to the cull callback
will be used to traverse the path, that is its LOD attributes will
affect the pfLODs traversed and nodes will be culled to its viewing
frustum.
.SH SEE ALSO
pfChanTravFunc,
pfCull,
pfList
