'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfPolytope" "3pf"
.SH NAME
.upperok
.B pfNewPtope,
.B pfGetPtopeClassType,
.B pfGetPtopeNumFacets,
.B pfPtopeFacet,
.B pfGetPtopeFacet,
.B pfRemovePtopeFacet,
.B pfOrthoXformPtope,
.B pfPtopeContainsPt,
.B pfPtopeContainsSphere,
.B pfPtopeContainsBox,
.B pfPtopeContainsCyl,
.B pfPtopeContainsPtope
\- 
Create, configure, transform, and intersect polytopes
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfPolytope*\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfPolytope*
\f3\%pfNewPtope\fP(void\ *arena);
.nf
.fi
.TP
pfType*
\f3\%pfGetPtopeClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetPtopeNumFacets\fP(pfPolytope\ *ptope);
.nf
.fi
.TP
int
\f3\%pfPtopeFacet\fP(pfPolytope\ *ptope,
'in +2
'll -2
int\ i,
const\ pfPlane\ *facet);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetPtopeFacet\fP(pfPolytope\ *ptope,
'in +2
'll -2
int\ i,
pfPlane\ *facet);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfRemovePtopeFacet\fP(pfPolytope\ *ptope,
'in +2
'll -2
int\ i);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfOrthoXformPtope\fP(pfPolytope\ *ptope,
'in +2
'll -2
const\ pfPolytope\ *src,
const\ pfMatrix\ \ mat);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPtopeContainsPt\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfVec3\ \ pt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPtopeContainsSphere\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfSphere\ *sphere);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPtopeContainsBox\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfBox\ *box);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPtopeContainsCyl\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfCylinder\ *cyl);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfPtopeContainsPtope\fP(const\ pfPolytope\ *ptope,
'in +2
'll -2
const\ pfPolytope\ *ptope1);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfPolytope\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfPolytope\fP.
Casting an object of class \f3\%pfPolytope\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfPolytope\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'ptope\ \ 'u
\f2ptope\fP
identifies a pfPolytope
.SH DESCRIPTION


A pfPolytope is a set of half spaces whose intersection defines a
convex, possibly semi-infinite, volume which may be used for culling
and other intersection testing where a tighter bound than a pfBox,
pfSphere, or pfCylinder is of benefit.

\f3\%pfNewPtope\fP creates and returns a handle to a pfPolytope.
\f2arena\fP specifies a malloc arena out of which the pfPolytope is
allocated or \f3\%NULL\fP for allocation off the process heap.

\f3\%pfGetPtopeClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfPolytope\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetPtopeClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfPolytope\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfPtopeFacet\fP sets the \f2i\fPth facet of \f2ptope\fP to \f2facet\fP.
\f2facet\fP defines a half space such that the normal of the pfPlane
faces "outside". \f3\%pfGetPtopeFacet\fP copies the
\f2i\fPth facet of \f2ptope\fP into \f2facet\fP.

\f3\%pfRemovePtopeFacet\fP removes the \f2i\fPth facet of \f2ptope\fP
from the list. Remaining facets are shifted left over the removed
facet.

\f3\%pfGetPtopeNumFacets\fP returns the number of facets in \f2ptope\fP.

\f3\%pfOrthoXformPtope\fP transforms \f2src\fP by
\f2mat\fP and
places the result
in \f2ptope\fP.
\f2mat\fP should be an orthonormal matrix or results are
undefined.

The \f3\%pfPtopeContains<*>\fP routines compute the intersection
of \f2ptope\fP with a variety of geometric primitives.
\f3\%pfPtopeContains<*>\fP returns one of the following:
.RS
.TP 5
\f3\%PFIS_FALSE\fP:
The intersection of the primitive and the pfPolytope is empty.
.TP
\f3\%PFIS_MAYBE\fP:
The intersection of the primitive and the pfPolytope might be non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP:
The intersection of the primitive and the pfPolytope is definitely non-empty.
.TP
\f3\%PFIS_MAYBE\fP | \f3\%PFIS_TRUE\fP | \f3\%PFIS_ALL_IN\fP:
The primitive is non-empty and lies entirely inside the pfPolytope.
.RE
.SH SEE ALSO
pfBox,
pfCylinder,
pfDelete,
pfFrustum,
pfMatrix,
pfObject,
pfSphere
