'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfQuat" "3pf"
.SH NAME
.upperok
.B pfMakeRotQuat,
.B pfGetQuatRotMat,
.B pfMakeRotMatQuat,
.B pfMakeVecRotVecQuat,
.B pfGetQuatRot,
.B pfLengthQuat,
.B pfConjQuat,
.B pfExpQuat,
.B pfLogQuat,
.B pfMultQuat,
.B pfDivQuat,
.B pfInvertQuat,
.B pfSlerpQuat,
.B pfSquadQuat,
.B pfQuatMeanTangent
\- 
Set and operate on quaternions
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'extern\ void\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
#include <Performer/prmath.h>
.nf
.fi
.TP
void
\f3\%pfMakeRotQuat\fP(pfQuat\ dst,
'in +2
'll -2
float\ angle,
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetQuatRotMat\fP(pfQuat\ quat,
'in +2
'll -2
pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeRotMatQuat\fP(pfQuat\ quat,
'in +2
'll -2
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMakeVecRotVecQuat\fP(pfQuat\ quat,
'in +2
'll -2
const\ pfVec3\ rotateFrom,
const\ pfVec3\ rotateTo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetQuatRot\fP(const\ pfQuat\ q,
'in +2
'll -2
float\ *angle,
float\ *x,
float\ *y,
float\ *z);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfLengthQuat\fP(const\ pfQuat\ q);
.nf
.fi
.TP
void
\f3\%pfConjQuat\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfExpQuat\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfLogQuat\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfMultQuat\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q1,
const\ pfQuat\ q2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfDivQuat\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q1,
const\ pfQuat\ q2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInvertQuat\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSlerpQuat\fP(pfQuat\ dst,
'in +2
'll -2
float\ t,
const\ pfQuat\ q1,
const\ pfQuat\ q2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSquadQuat\fP(pfQuat\ dst,
'in +2
'll -2
float\ t,
const\ pfQuat\ q1,
const\ pfQuat\ q2,
const\ pfQuat\ a,
const\ pfQuat\ b);
.in
.ll
.nf
.fi
.TP
extern void
\f3\%pfQuatMeanTangent\fP(pfQuat\ dst,
'in +2
'll -2
const\ pfQuat\ q1,
const\ pfQuat\ q2,
const\ pfQuat\ q3);
.in
.ll
.fi

.Ex
.nf

typedef pfVec4 pfQuat;
.Ee
.fi
.na

.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfQuat\fP is
derived from the parent class \f3\%pfVec4\fP,
so each of these member functions of
class \f3\%pfVec4\fP
are also directly usable with objects
of class \f3\%pfQuat\fP.
Casting an object of class \f3\%pfQuat\fP
to an object of class \f3\%pfVec4\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfVec4\fP.

.PD 0
.TP \w'float\ \ \ 'u
void
\f3\%pfAddScaledVec4\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
float\ s,
const\ pfVec3\ v2);
.in
.ll
.PD 0
.TP
void
\f3\%pfAddVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v1,
const\ pfVec4\ v2);
.in
.ll
.PD 0
.TP
int
\f3\%pfAlmostEqualVec4\fP(pfVec4\ v1,
'in +2
'll -2
const\ pfVec4\ v2,
float\ tol);
.in
.ll
.PD 0
.TP
void
\f3\%pfCombineVec4\fP(pfVec4\ dst,
'in +2
'll -2
float\ s1,
const\ pfVec4\ v1,
float\ s2,
const\ pfVec4\ v2);
.in
.ll
.PD 0
.TP
void
\f3\%pfCopyVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v);
.in
.ll
.PD 0
.TP
float
\f3\%pfDistancePt4\fP(const\ pfVec4\ pt1,
'in +2
'll -2
const\ pfVec4\ pt2);
.in
.ll
.PD 0
.TP
float
\f3\%pfDotVec4\fP(const\ pfVec4\ v1,
'in +2
'll -2
const\ pfVec4\ v2);
.in
.ll
.PD 0
.TP
int
\f3\%pfEqualVec4\fP(const\ pfVec4\ v1,
'in +2
'll -2
const\ pfVec4\ v2);
.in
.ll
.PD 0
.TP
float
\f3\%pfLengthVec4\fP(const\ pfVec4\ v);
.PD 0
.TP
void
\f3\%pfNegateVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v);
.in
.ll
.PD 0
.TP
float
\f3\%pfNormalizeVec4\fP(pfVec4\ v);
.PD 0
.TP
void
\f3\%pfScaleVec4\fP(pfVec4\ dst,
'in +2
'll -2
float\ s,
const\ pfVec4\ v);
.in
.ll
.PD 0
.TP
void
\f3\%pfSetVec4\fP(pfVec4\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.PD 0
.TP
float
\f3\%pfSqrDistancePt4\fP(const\ pfVec4\ pt1,
'in +2
'll -2
const\ pfVec4\ pt2);
.in
.ll
.PD 0
.TP
void
\f3\%pfSubVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v1,
const\ pfVec4\ v2);
.in
.ll
.PD 0
.TP
void
\f3\%pfXformVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v,
const\ pfMatrix\ m);
.in
.ll
.PD
.fi
.SH DESCRIPTION

pfQuat represents a quaternion as the four floating point values
(\f2x\fP, \f2y\fP, \f2z\fP, \f2w\fP) of a pfVec4.


\f3\%pfMakeRotQuat\fP converts an \f2axis\fP and
\f2angle\fP rotation representation to a quaternion.
\f3\%pfGetQuatRot\fP is the inverse operation. It
produces the axis (as a unit length direction vector) and angle
equivalent to the given quaternion.  Also see
\f3\%pfMakeQuatMat\fP and
\f3\%pfGetOrthoMatQuat\fP.

\f3\%pfMakeRotMatQuat\fP converts the
rotation expressed by an orthonormal pfMatrix to a pfQuat.  If the
pfMatrix is not orthonormal the results are undefined (and will most
certainly not be the rotation that you wanted).
\f3\%pfGetQuatRotMat\fP constructs a
rotation matrix from the quaternion.

\f3\%pfMakeVecRotVecQuat\fP constructs a
quaternion from the rotation between the two vectors rotateFrom and
rotateTo.

Several monadic quaternion operators are provided.  \f3\%pfConjQuat\fP
produces the complex conjugate \f2dst\fP of \f2q\fP by negating only the
complex components (\f2x\fP, \f2y\fP, and \f2z\fP) which results in an
inverse rotation.  \f3\%pfExpQuat\fP and \f3\%pfLogQuat\fP perform complex
exponentiation and logarithm functions respectively. The length of a
quaternion is computed by \f3\%pfLengthQuat\fP and is defined as the
norm of all four quaternion components.  Macro equivalents are
\f3\%PFCONJ_QUAT\fP and \f3\%PFLENGTH_QUAT\fP.  For negation, use the pfVec4
routine, \f3\%pfNegateVec4\fP.

\f3\%pfMultQuat\fP and \f3\%pfDivQuat\fP are dyadic quaternion operations
which provide the product, and quotient of two quaternions.  When
quaternions are used to represent rotations, multiplication of two
quaternions is equivalent, but more efficient, than the multiplication
of the two correspondinging rotation matrices.

\f3\%pfInvertQuat\fP computes the multiplicative inverse of a
quaternion.  These operations are the basis from which the other
quaternion capabilities have been derived.  Macro equivalents are
\f3\%PFMULT_QUAT\fP, \f3\%PFDIV_QUAT\fP, and \f3\%PFINVERT_QUAT\fP.  For
addition and scalar multiplication, use the pfVec4 routines
\f3\%pfAddVec4\fP, \f3\%pfSubVec4\fP, and \f3\%pfScaleVec4\fP.
Comparisons
can be made with \f3\%pfEqualVec4\fP and \f3\%pfAlmostEqualVec4\fP.

Interpolation of quaternions (as presented by Ken Shoemake) is an
effective technique for rotation interpolation. Spherical linear
interpolation is performed with \f3\%pfSlerpQuat\fP, which produces a
rotation \f2dst\fP that is \f2t\fP of the way between \f2q1\fP and
\f2q2\fP.

Spherical quadratic interpolation is provided by \f3\%pfSquadQuat\fP and
its helper function, \f3\%pfQuatMeanTangent\fP.

.SH NOTES


These functions use a pfVec4 to represent quaternions and store the
imaginary part first, thus the array contents q = {x,y,z,w} are a
representation of the quaternion w + x\f2i\fP + y\f2j\fP+ z\f2k\fP.

Because both \f2q\fP and \f2-q\fP represent the same rotation (quaternions
have a rotation range of [-360,360] degrees) conversions such as
\f3\%pfGetOrthoMatQuat\fP make an arbitrary
choice of the sign of the returned quaternion.  To prevent the
arbitrary sign from introducing large, unintended rotations,
\f3\%pfSlerpQuat\fP checks the angle \f2theta\fP
between \f2q1\fP and \f2q2\fP.  If \f2theta\fP exceeds 180 degrees, \f2q2\fP
is negated changing the interpolations range from [0,\f2theta\fP] to [0,
\f2theta\fP-360 degrees].

When using overloaded operators in C++, assignment operators, e.g.
"+=", are somewhat more efficient than the corresponding binary
operators, e.g. "+", because the latter construct a temporary
intermediate object.  Use assignment operators or macros for
binary operations where optimal speed is important.

C++ does not support array deletion (i.e. \f3\%delete[]\fP) for
arrays of objects allocated new operators that take additional
arguments.  Hence, the array deletion operator \f3\%delete[]\fP should not
be used on arrays of objects created with \f3\%new\fP(arena) pfVec4[n].

For more information on quaternions, see the article by Sir William
Rowan Hamilton "\f2On quaternions; or on a new system of imaginaries in
algebra\fP," in the Philosophical Magazine, xxv, pp. 10-13 (July 1844).
More recent references include "\f2Animating Rotation with Quaternion
Curves\fP," SIGGRAPH Proceedings Vol 19, Number 3, 1985, and
"\f2Quaternion Calculus For Animation\fP," in "Math for SIGGRAPH",
Course Notes, #23, SIGGRAPH 1989, both by Ken Shoemake.  An
introductory tutorial is available on the Internet at
ftp://ftp.cis.upenn.edu/pub/graphics/shoemake/quatut.ps.Z.  Note that
for consistency with Performer's transformation order, pfQuats are the
conjugates of the quaternions described in these references.

.SH SEE ALSO
pfVec4,
pfMatrix
