'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfQueue" "3pf"
.SH NAME
.upperok
.B pfNewQueue,
.B pfInsertQueueElt,
.B pfInsertFrontQueueElt,
.B pfRemoveQueueElt,
.B pfAttemptRemoveQueueElt,
.B pfGetQueueClassType,
.B pfQueueArrayLen,
.B pfGetQueueArrayLen,
.B pfGetQueueNum,
.B pfAddQueueServiceProc,
.B pfGetQueueNumServiceProcs,
.B pfGetQueueServiceProcPID,
.B pfQueueSortMode,
.B pfGetQueueSortMode,
.B pfGetQueueElementSize,
.B pfQueueInputRange,
.B pfGetQueueInputRange,
.B pfQueueOutputRange,
.B pfGetQueueOutputRange,
.B pfQueueSortFunc,
.B pfGetQueueSortFunc,
.B pfGetQueueSortProcPID,
.B pfNotifyQueueSortProc,
.B pfSignalAllQueueServiceProcs,
.B pfGetNumGlobalQueueServiceProcs,
.B pfGetGlobalQueueServiceProcPID,
.B pfGetGlobalQueueServiceProcQueue
\- 
Multiprocess-safe dynamically-sized queue utility
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfQueueSortFuncType\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfQueue *
\f3\%pfNewQueue\fP(int\ eltSize,
'in +2
'll -2
int\ nElts,
void\ *arena);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInsertQueueElt\fP(pfQueue*\ queue,
'in +2
'll -2
void\ *elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInsertFrontQueueElt\fP(pfQueue*\ queue,
'in +2
'll -2
void\ *elt);
.in
.ll
.nf
.fi
.TP
void *
\f3\%pfRemoveQueueElt\fP(pfQueue*\ queue);
.nf
.fi
.TP
void *
\f3\%pfAttemptRemoveQueueElt\fP(pfQueue*\ queue);
.nf
.fi
.TP
pfType *
\f3\%pfGetQueueClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfQueueArrayLen\fP(pfQueue*\ queue,
'in +2
'll -2
int\ length);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetQueueArrayLen\fP(pfQueue*\ queue);
.nf
.fi
.TP
int
\f3\%pfGetQueueNum\fP(pfQueue*\ queue);
.nf
.fi
.TP
int
\f3\%pfAddQueueServiceProc\fP(pfQueue\ *queue,
'in +2
'll -2
pfQueueServiceFuncType\ func);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetQueueNumServiceProcs\fP(pfQueue*\ queue);
.nf
.fi
.TP
int
\f3\%pfGetQueueServiceProcPID\fP(pfQueue*\ queue,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQueueSortMode\fP(pfQueue\ *queue,
'in +2
'll -2
int\ boolean);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetQueueSortMode\fP(pfQueue\ *queue);
.nf
.fi
.TP
int
\f3\%pfGetQueueElementSize\fP(pfQueue\ *queue);
.nf
.fi
.TP
void
\f3\%pfQueueInputRange\fP(pfQueue\ *queue,
'in +2
'll -2
int\ low,
int\ high);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetQueueInputRange\fP(pfQueue\ *queue,
'in +2
'll -2
int\ *low,
int\ *high);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQueueOutputRange\fP(pfQueue\ *queue,
'in +2
'll -2
int\ low,
int\ high);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetQueueOutputRange\fP(pfQueue\ *queue,
'in +2
'll -2
int\ *low,
int\ *high);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfQueueSortFunc\fP(pfQueue\ *queue,
'in +2
'll -2
pfQueueSortFuncType\ func);
.in
.ll
.nf
.fi
.TP
pfQueueSortFuncType
\f3\%pfGetQueueSortFunc\fP(pfQueue\ *queue);
.nf
.fi
.TP
int
\f3\%pfGetQueueSortProcPID\fP(pfQueue\ *queue);
.nf
.fi
.TP
void
\f3\%pfNotifyQueueSortProc\fP(pfQueue\ *queue);
.nf
.fi
.TP
int
\f3\%pfSignalAllQueueServiceProcs\fP(int\ count,
'in +2
'll -2
int\ token);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNumGlobalQueueServiceProcs\fP(void);
.nf
.fi
.TP
int
\f3\%pfGetGlobalQueueServiceProcPID\fP(int\ n);
.nf
.fi
.TP
pfQueue*
\f3\%pfGetGlobalQueueServiceProcQueue\fP(int\ n);
.nf
.fi
.TP
typedef int
\f3\%(*pfQueueServiceFuncType)\fP(void\ *data);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfQueue\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfQueue\fP.
Casting an object of class \f3\%pfQueue\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfQueue\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

The pfQueue data type is implemented as a dynamically sized array
of arbitrary, but homogeneously-sized, elements.

\f3\%pfNewQueue\fP creates and returns a handle to a new pfQueue.
\f2eltSize\fP specifies the size in bytes of an individual queue element.
The element size is fixed at creation time and cannot be changed later.
\f2nElts\fP is the initial length of the queue array;
\f2nElts\fP * \f2eltSize\fP bytes will be allocated for the queue array.
The argument \f2arena\fP specifies a malloc arena out of which the pfQueue
is to be allocated or \f3\%NULL\fP for allocation from the process heap.
pfQueues can be deleted with \f3\%pfDelete\fP.

\f3\%pfGetQueueClassType\fP returns the \f3\%pfType\fP*
for the class \f3\%pfQueue\fP. The \f3\%pfType\fP* returned by
\f3\%pfGetQueueClassType\fP is the same as the
\f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class \f3\%pfQueue\fP.  Because OpenGL Performer
allows subclassing of built-in types, when decisions are made based on the
type of an object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the \f3\%pfType\fP*'s.

A pfQueue dynamically increases its array size by a factor of 2 and zeros
the additional memory whenever it runs out of array memory.  This way
the array size quickly reaches its final size without many reallocations
of memory.  However, some memory (up to one half if the total allocation)
at the end of the array may be wasted.  If you know the exact number of
elements in the array, you can specify the pfQueue array length either
when creating it (the \f2nElts\fP argument to \f3\%pfNewQueue\fP)
or with \f3\%pfQueueArrayLen\fP.
\f3\%pfGetQueueArrayLen\fP returns the current
array length of \f2queue\fP.

\f3\%pfInsertQueueElt\fP adds an element, \f2elt\fP to the
\f2queue\fP.  The queue array is grown automatically if
adding an element forces the number of elements to be greater then the length
of the queue array.

Normally, a queue element is inserted at the back of the queue, and all
the elements that where inserted first must be removed before the element
itself is removed. The
\f3\%pfInsertFrontQueueElt\fP
call adds an element to the .in 0.125i
front.in 0.125i
 of the queue, so it will be the
next element removed. This function is used internally by performer to
help kill queue service processes cleanly.

\f3\%pfRemoveQueueElt\fP removes and returns an element
from the queue.

Note that both inserting and removing from a pfQueue can be done from multiple
processes without collision, but that the pfQueue enforces with locks
that only one process can actually be inserting into the queue and one process
removing from the queue at one time.

Also note that calls to remove will block waiting for an element to be inserted
onto the queue when the queue is empty.

\f3\%pfAttemptRemoveQueueElt\fP removes and
returns an element from the queue. Unlike
\f3\%pfRemoveQueueElt\fP, this command doesn't block
if the queue is empty. Instead, it returns a NULL pointer.

\f3\%pfGetQueueNum\fP returns the number of elements
currently stored in the pfQueue.

\f3\%pfAddQueueServiceProc\fP will use \f3\%sproc\fP
to create a thread to service elements of a queue.  The process ID of the
spawned process is provided to the caller as the return value. This new thread
will share all of the caller's address space and will simply invoke the supplied
function, \f2func\fP, to service a queue element whenever the queue is non-empty.
Thus, this process simply loops calling
\f3\%pfQueueRemove\fP and then calling \f2func\fP
with the element just removed from the queue.

The number of currently active service processes is returned by
\f3\%pfGetQueueNumServiceProcs\fP.

The process ID of a particular service process can be obtained
through \f3\%pfGetQueueServiceProcPID\fP.

Further information regarding all processes allocated to service all queues
can be queried through three global routines.
\f3\%pfGetNumGlobalQueueServiceProcs\fP returns the number of processes that
have been sproc'd by all pfQueue's to service queues.
\f3\%pfGetGlobalQueueServiceProcPID\fP returns the process id of the \f2n\fPth
service process created.
\f3\%pfGetGlobalQueueServiceProcQueue\fP returns the pfQueue associated with
a particular service process.

\f3\%pfQueueSortMode\fP
changes the fundamental mode of a queue. A queue is either sorting (sort
mode is non-zero) or false (sort mode is zero). When a queue is in sorting
mode, a special process, called the sort proc, is created. The sort proc
calls a user defined function call the sort function to sort the elements
of the queue. A sorting queue is divided into three parts, the input queue,
the sort list, and the output queue. Elements can be added and removed from
a queue in the same way whether a queue is in sorting or non-sorting mode.
Both the input queue and the output queue have high and low watermarks.

When the number of elements on the input queue exceeds the high water mark,
the number of elements on the output queue drops below the low water mark,
or \f3\%pfNotifyQueuetSortProc\fP is called,
the sort process wakes up an performs three steps. If the input queue
is above the high water mark, it copies elements into the sort list (which
is a pfList structure) down to the low water mark. The sort proc then
calls the sort function, which sorts the list. Finally, if the output
queue has dropped below the low water mark, the sort proc removes elements
from the end of the sort list and puts them on the output queue up to the
high water mark. The sort proc knows nothing about the elements of the
queue. Only the sort function, supplied by the application, actually
sorts the elements based on understanding the priorities of their contents.
If a sort function hasn't been provided before attempting to change the
queue to sorting mode, then an error message is generated and the call
is ignored.

\f3\%pfGetQueueSortMode\fP
returns the current sort mode value. A non-zero value indicates sorting
mode. A zero value indicates non-sorting, or normal mode.

\f3\%pfGetQueueElementSize\fP
returns the size of the queue elements in bytes. In most cases, the
queue is working with pointer elements. In that case, the size will
be sizeof(void *).

\f3\%pfQueueInputRange\fP
sets the high and low water marks for the input queue. This queue is
active when the queue is in sorting mode. Changes to the low and high values
won't take effect until the next time the queue transitions from non-sorting
to sorting mode. The default values for input range are 0 for the low
water mark, and 3 for the high water mark.
\f3\%pfGetQueueInputRange\fP
returns currently set water mark values. Values read by this function
may not have taken effect yet.

\f3\%pfQueueOutputRange\fP
sets the high and low water marks for the output queue. This queue is
active when the queue is in sorting mode. Changes to the low and high values
won't take effect until the next time the queue transitions from non-sorting
to sorting mode. The default values for output range are 2 for the low
water mark, and 5 for the high water mark.
\f3\%pfGetQueueOutputRange\fP
returns currently set water mark values. Values read by this function
may not have taken effect yet.

\f3\%pfQueueSortFunc\fP
provides a pointer to a function used to sort the elements of queue
when the queue is in sorting mode. The function should take a single
argument, a pointer to a pfQueueSortFuncData structure, and return
void. The pointer will contain a pointer to a pfList containing
pointers to the elements to be sorted, the current values for the
high and low water marks for the input and output queues, and
volatile integers indicating the current size of the input and
output queues. The sort function should do a single sort of the
elements in the pfList and return. The default value of the
sort function pointer is NULL. A queue can not enter sorting
mode without a valid sort function pointer. Changes to the
sorting function don't take effect until the next transition from
non sorting to sorting mode.

The volatile integer values
are used for very latency sensitive operations, or sort algorithms
that may be lengthy. The sort function can periodically check
the size of the input and output queues, and return early,
leaving the list in an incompletely sorted state if necessary.

\f3\%pfGetQueueSortFunc\fP
returns a pointer to the current sorting function. This may
not be the sort function currently in use.

\f3\%pfGetQueueSortProcPID\fP
returns the process id of the sorting process. This value can be used to
change the run priority of the process, or move it to another CPU. If
the queue is not in sorting mode, the process id with be zero.

\f3\%pfNotifyQueueSortProc\fP
signals the sort proc to run the sort function now, rather than
waiting for the high or low water marks for the input or output queues
to signal a sorting run. This function can be called when the application
knows that the sorted queue is out of order or needs culling.

\f3\%pfSignalAllQueueServiceProcs\fP
places a \f2count\fP copies of \f2token\fP at the beginning of the queue, then
P's the exit semaphore \f2count\fP times. This function is used to cleanly
terminate all the readers of a sort queue. The token is generally a
token signalling the reader to exit. P'ing on the semaphore causes the
\f3\%pfSignalAllQueueServiceProcs\fP
function to sleep until all the readers have exited. An exit token is
used to ensure that the reader isn't sleeping waiting for the next
token and never exits.

.SH BUGS

pfQueues currently only support an element size of \f3\%sizeof(void*)\fP.

.SH SEE ALSO
pfDelete,
pfImageCache,
pfClipTexture
