'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfScene" "3pf"
.SH NAME
.upperok
.B pfNewScene,
.B pfGetSceneClassType,
.B pfSceneGState,
.B pfGetSceneGState,
.B pfSceneGStateIndex,
.B pfGetSceneGStateIndex
\- 
Create a scene or root node, set and get scene pfGeoState or
pfGeoState index.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfGeoState\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfScene *
\f3\%pfNewScene\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetSceneClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfSceneGState\fP(pfScene\ *scene,
'in +2
'll -2
pfGeoState\ *gstate);
.in
.ll
.nf
.fi
.TP
pfGeoState *
\f3\%pfGetSceneGState\fP(const\ pfScene\ *scene);
.nf
.fi
.TP
void
\f3\%pfSceneGStateIndex\fP(pfScene\ *scene,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetSceneGStateIndex\fP(const\ pfScene\ *scene);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfScene\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfScene\fP.
Casting an object of class \f3\%pfScene\fP
to an object of class \f3\%pfGroup\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.PD 0
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfScene\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfScene\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfScene\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'gstate\ \ 'u
\f2scene\fP
identifies a pfScene.
.TP
\f2gstate\fP
identifies a pfGeoState.
.SH DESCRIPTION

A pfScene is the root of a hierarchical database which may be drawn or
intersected with.  pfScene is derived from pfGroup so it can use
pfGroup and pfNode API.  A pfScene may have children like a pfGroup but
it cannot be a child of another node. Its special purpose is to serve
as the root node of a scene graph.

\f3\%pfNewScene\fP creates and returns a handle to a pfScene.  Like
other pfNodes, pfScenes are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetSceneClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfScene\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetSceneClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfScene\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

OpenGL Performer will automatically carry out the APP, CULL, and DRAW
traversals on pfScenes which are attached to pfChannels by
\f3\%pfChanScene\fP.  The CULL and DRAW traversals are directly or
indirectly triggered by \f3\%pfFrame\fP while the APP traversal is
triggered by \f3\%pfAppFrame\fP.

Multiple pfChannels may reference the
same pfScene but each pfChannel references only a single pfScene.

\f3\%pfSceneGState\fP attaches \f2gstate\fP to \f2scene\fP. The pfGeoState of
a pfScene defines the "global state" which may be inherited by
other pfGeoStates. This state inheritance mechanism is further
described in the pfGeoState man page.

The scene pfGeoState is defined as the global state by \f3\%pfLoadGState\fP.
This pfGeoState will be loaded before the pfChannel DRAW callback
(\f3\%pfChanTravFunc\fP) is invoked so any custom rendering in the callback
will inherit the state set by the scene pfGeoState. \f3\%pfGetSceneGState\fP
returns the directly referenced pfGeoState of \f2scene\fP or
the appropriate pfGeoState in the global table if \f2scene\fP indexes its
pfGeoState or NULL if the index cannot be resolved.

The scene pfGeoState may be indexed through a global table by assigning
an index with \f3\%pfSceneGStateIndex\fP and specifying the table with
\f3\%pfApplyGStateTable\fP. Usually this table is provided by the pfChannel
(\f3\%pfChanGStateTable\fP). \f3\%pfGetSceneGStateIndex\fP returns the pfGeoState
index of \f2scene\fP or -1 if \f2scene\fP directly references its pfGeoState.

It is not necessary to provide a scene pfGeoState, but it is a convenient
way to specify the default inheritable values for all pfGeoState elements
on a per-scene basis.
.SH SEE ALSO
pfApplyGStateTable,
pfChanScene,
pfChanTravFunc,
pfGeoState,
pfGroup,
pfDelete
