'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfSequence" "3pf"
.SH NAME
.upperok
.B pfNewSeq,
.B pfGetSeqClassType,
.B pfSeqTime,
.B pfGetSeqTime,
.B pfSeqInterval,
.B pfGetSeqInterval,
.B pfSeqDuration,
.B pfGetSeqDuration,
.B pfSeqMode,
.B pfGetSeqMode,
.B pfGetSeqFrame
\- 
Control animation sequence nodes.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfSequence\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfSequence *
\f3\%pfNewSeq\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetSeqClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfSeqTime\fP(pfSequence\ *seq,
'in +2
'll -2
int\ frame,
double\ time);
.in
.ll
.nf
.fi
.TP
double
\f3\%pfGetSeqTime\fP(const\ pfSequence\ *seq,
'in +2
'll -2
int\ frame);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSeqInterval\fP(pfSequence\ *seq,
'in +2
'll -2
int\ mode,
int\ begin,
int\ end);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSeqInterval\fP(const\ pfSequence\ *seq,
'in +2
'll -2
int\ *mode,
int\ *begin,
int\ *end);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSeqDuration\fP(pfSequence\ *seq,
'in +2
'll -2
float\ speed,
int\ nReps);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSeqDuration\fP(const\ pfSequence\ *seq,
'in +2
'll -2
float\ *speed,
int\ *nReps);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSeqMode\fP(pfSequence\ *seq,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetSeqMode\fP(const\ pfSequence\ *seq);
.nf
.fi
.TP
int
\f3\%pfGetSeqFrame\fP(const\ pfSequence\ *seq,
'in +2
'll -2
int\ *repeat);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfSequence\fP is
derived from the parent class \f3\%pfGroup\fP,
so each of these member functions of
class \f3\%pfGroup\fP
are also directly usable with objects
of class \f3\%pfSequence\fP.
Casting an object of class \f3\%pfSequence\fP
to an object of class \f3\%pfGroup\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfGroup\fP.

.PD 0
.TP \w'pfNode\ *\ \ \ 'u
int
\f3\%pfAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfInsertChild\fP(pfGroup\ *group,
'in +2
'll -2
int\ index,
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfReplaceChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *old,
pfNode\ *new);
.in
.ll
.PD 0
.TP
int
\f3\%pfRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
int
\f3\%pfSearchChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode*\ child);
.in
.ll
.PD 0
.TP
pfNode *
\f3\%pfGetChild\fP(const\ pfGroup\ *group,
'in +2
'll -2
int\ index);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumChildren\fP(const\ pfGroup\ *group);
.PD 0
.TP
int
\f3\%pfBufferAddChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll
.PD 0
.TP
int
\f3\%pfBufferRemoveChild\fP(pfGroup\ *group,
'in +2
'll -2
pfNode\ *child);
.in
.ll

.PD
.PP
Since the class
\f3\%pfGroup\fP is itself derived from
the parent class \f3\%pfNode\fP, objects
of class \f3\%pfSequence\fP can also be used
with these functions designed for
objects of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfSequence\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfSequence\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'seq\ \ 'u
\f2seq\fP
identifies a pfSequence.
.SH DESCRIPTION

A pfSequence is a pfGroup that sequences through a range of its
children, drawing each child for a certain length of time.  Its
primary use is for animations, where a \f2sequence\fP of objects or
geometry (children) represent a desired visual event.
\f3\%pfNewSeq\fP creates and returns a handle to a pfSequence.  Like
other pfNodes, pfSequences are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetSeqClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfSequence\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetSeqClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfSequence\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

Children are added to a pfSequence using normal pfGroup API
(\f3\%pfAddChild\fP).  The length of time that a child is drawn is
specified by \f3\%pfSeqTime\fP.  \f2frame\fP is the index of a child that
should be drawn for \f2time\fP seconds.  If \f2frame\fP < 0, then all
children will be displayed for \f2time\fP seconds.  If \f2time\fP = 0.0 or
time is not specified for a particular child, then it will not be drawn
at all.  If \f2time\fP < 0.0 the sequence will pause at child \f2frame\fP
and draw it repeatedly until the sequence is resumed or stopped (see
\f3\%pfSeqMode\fP below).  \f3\%pfGetSeqTime\fP returns the time for frame
\f2frame\fP.

\f3\%pfSeqInterval\fP specifies the
interval or range of frames (children) to sequence.  \f2begin\fP and
\f2end\fP specify the beginning and ending indexes of \f2seq\fP respectively.  Indexes are inclusive and should be in
the range 0, numChildren - 1.  An index < 0 is equivalent to
numChildren - 1 for convenience.  \f2end\fP may be less than \f2begin\fP
for reverse sequences.  The default sequence interval is 0,
numChildren - 1.

\f2mode\fP specifies how \f2seq\fP is sequenced over the range from
\f2begin\fP to \f2end\fP if it is a repeating sequence.
.RS
.TP 5
\f3\%PFSEQ_CYCLE\fP
\f2seq\fP will go from \f2begin\fP to \f2end\fP then restart at \f2begin\fP.
.TP
\f3\%PFSEQ_SWING\fP
\f2seq\fP will go back and forth from \f2begin\fP to \f2end\fP.  The endpoint
frames are drawn only once when the swing changes directions.
.RE

The default \f2mode\fP is \f3\%PFSEQ_CYCLE\fP.  \f3\%pfGetSeqInterval\fP copies
the interval parameters into \f2mode\fP, \f2begin\fP, and \f2end\fP.

\f3\%pfSeqDuration\fP controls the duration of an sequence.  \f2speed\fP
divides the time that each sequence frame is displayed.  Values < 1.0
slow down the sequence while values > 1.0 speed up the sequence.
The default \f2speed\fP is 1.0.  \f2nReps\fP is the number of times \f2seq\fP
repeats before stopping.  If \f2nReps\fP is < 0, \f2seq\fP will sequence
indefinitely and if == 0 the sequence is disabled.  If \f2nReps\fP is > 1,
\f2seq\fP will sequence for \f2nReps\fP cycles or swings depending on the
sequencing mode set by \f3\%pfSeqInterval\fP.

The number of repetitions for both \f3\%PFSEQ_CYCLE\fP and \f3\%PFSEQ_SWING\fP
is increased by 1 every time an endpoint of the sequence is reached.
Therefore \f3\%PFSEQ_CYCLE\fP begins to repeat itself after 1 repetition
while \f3\%PFSEQ_SWING\fP repeats itself after 2 repetitions.  Note that for
1 repetition, both modes are equivalent.

The default value for \f2nReps\fP is 1.  \f3\%pfGetSeqDuration\fP copies the
duration parameters into \f2speed\fP and \f2nReps\fP.

\f3\%pfSeqMode\fP controls the run-time execution of \f2seq\fP.  \f2mode\fP
is a symbolic token:
.RS
.TP 5
\f3\%PFSEQ_START\fP
Restarts the sequence from its beginning.  Once started, a sequence may
be stopped, paused, or started again in which case it is restarted from
its beginning.
.TP
\f3\%PFSEQ_STOP\fP
Stops the sequence.  After an sequence is stopped, it is reset so that
further executions of the sequence begin from the starting index.
.TP
\f3\%PFSEQ_PAUSE\fP
Pauses the sequence without resetting it.  When paused, the current
child will be drawn until the sequence is either stopped or resumed.
.TP
\f3\%PFSEQ_RESUME\fP
Resumes a paused sequence.
.RE

Sequences are evaluated once per frame by \f3\%pfAppFrame\fP.
The time used in the evaluation is that set by \f3\%pfFrameTimeStamp\fP.
This time is automatically set by \f3\%pfFrame\fP but it may be overridden by the
application to account for varying latency due to non-constant
frame rates.

\f3\%pfGetSeqMode\fP returns the mode of \f2seq\fP.  The mode will
automatically be set to \f3\%PFSEQ_STOP\fP if the sequence completes the
number of repetitions set by \f3\%pfSeqDuration\fP.

\f3\%pfGetSeqFrame\fP returns the index of the child which \f2seq\fP is
currently drawing and also copies the number of repetitions it has
completed into \f2repeat\fP.
.SH SEE ALSO
pfAppFrame,
pfFrame,
pfFrameTimeStamp,
pfGroup,
pfNode,
pfDelete
