'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfSinCos" "3pf"
.SH NAME
.upperok
.B pfSinCos,
.B pfTan,
.B pfArcTan2,
.B pfArcSin,
.B pfArcCos,
.B pfSqrt
\- 
Fast math routines sin, cos, sqrt
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'float\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
void
\f3\%pfSinCos\fP(float\ arg,
'in +2
'll -2
float*\ sin,
float*\ cos);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfTan\fP(float\ arg);
.nf
.fi
.TP
float
\f3\%pfArcTan2\fP(float\ y,
'in +2
'll -2
float\ x);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfArcSin\fP(float\ arg);
.nf
.fi
.TP
float
\f3\%pfArcCos\fP(float\ arg);
.nf
.fi
.TP
float
\f3\%pfSqrt\fP(float\ arg);
.fi
.SH DESCRIPTION

\f3\%pfSinCos\fP returns sine and cosine of \f2arg\fP degrees in the
locations pointed to by \f2sin\fP and \f2cos\fP.  The routine is less
accurate than that provided in libm, but faster.  It also loses
precision earlier for large arguments.  For accuracy within an
error tolerance of 1/1000, the argument must be in the range
-7500 to +7500 degrees.

\f3\%pfTan\fP returns the tangent of \f2arg\fP degrees.

\f3\%pfArcTan2\fP returns the arc tangent of \f2y\fP/\f2x\fP in the range -180
to +180 degrees using the signs of both arguments to determine the
quadrant of the return value.

\f3\%pfArcSin\fP returns the arc sine of \f2arg\fP in the range -90 to +90
degrees.

\f3\%pfArcCos\fP returns the arc sine of \f2arg\fP in the range 0 to 180
degrees.

\f3\%pfSqrt\fP returns the square root of \f2arg\fP.

.SH NOTES


\f3\%Performance:\fP
The current Performer math routines are simply wrappers that call
the routines in math.h from libm or libfastm.  The routines may be
changed in the future, but they should always perform as well or
better than the corresponding routines in libm and libfastm.

\f3\%Linking\fP
Currently for maximum performance, programs should be linked to
libfastm.  Please refer to the libfastm man page for a description
of the impact this may have on accuracy.

.SH SEE ALSO
pfMakeCoordMat,
pfNormalizeVec3
