'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfSprite" "3pf"
.SH NAME
.upperok
.B pfNewSprite,
.B pfGetSpriteClassType,
.B pfSpriteMode,
.B pfGetSpriteMode,
.B pfSpriteAxis,
.B pfGetSpriteAxis,
.B pfBeginSprite,
.B pfEndSprite,
.B pfPositionSprite,
.B pfGetCurSprite
\- 
Create and update sprite transformation primitive.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfSprite\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfSprite *
\f3\%pfNewSprite\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetSpriteClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfSpriteMode\fP(pfSprite\ *sprite,
'in +2
'll -2
int\ which,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetSpriteMode\fP(const\ pfSprite\ *sprite,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSpriteAxis\fP(pfSprite\ *sprite,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetSpriteAxis\fP(pfSprite\ *sprite,
'in +2
'll -2
float\ *x,
float\ *y,
float\ *z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfBeginSprite\fP(pfSprite\ *sprite);
.nf
.fi
.TP
void
\f3\%pfEndSprite\fP(void);
.nf
.fi
.TP
void
\f3\%pfPositionSprite\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
pfSprite *
\f3\%pfGetCurSprite\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfSprite\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfSprite\fP.
Casting an object of class \f3\%pfSprite\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfSprite\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'sprite\ \ 'u
\f2sprite\fP
identifies a pfSprite.
.SH DESCRIPTION

A "sprite" is a term borrowed from the video game industry and refers
to a movable graphical object that always appears orthogonal to the
viewer. In 2D, a sprite can be implemented by simply drawing an image
that is aligned with the screen, a technique called "bit-blitting".
pfSprite extends this support to 3D geometry by rotating the geometry
appropriately based on the viewer and object locations to achieve a
consistent screen alignment.  In this respect, pfSprite is not really
a graphical object itself, rather it is an intelligent transformation
and is logically grouped with other libpr transformation primitives
like \f3\%pfMultMatrix\fP.

Sprite transformations (subsequently referred to as sprites) are useful
for complex objects that are roughly symmetrical about an axis or a
point.  By rotating the model about the axis or point, the viewer only
sees the "front" of the model so complexity is saved in the model by
omitting the "back" geometry.  A further performance enhancement is to
incorporate visual complexity in a texture map rather than in
geometry.  Thus, on machines with fast texture mapping, sprites can
present very complex images with very little geometry. Classic examples
of textured sprites use a single quadrilateral that when rotated about
a vertical axis simulate trees and when rotated about a point simulate
clouds or puffs of smoke.

\f3\%pfNewSprite\fP creates and returns a handle to a pfSprite.  \f2arena\fP
specifies a malloc arena out of which the pfSprite is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfSprites can be deleted
with \f3\%pfDelete\fP.

\f3\%pfGetSpriteClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfSprite\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetSpriteClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfSprite\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

Sprite transformations are simply rotations which are based
on:

.RS 4
1. The viewer location.
.TP
2. The sprite location.
.TP
3. The sprite mode/axis.
.RE

The viewer's coordinate system is specified with \f3\%pfViewMat\fP whose
last row is the viewer's location. The sprite location in object
coordinates is specified with
\f3\%pfPositionSprite\fP. This location is
transformed by the current modeling matrix (\f3\%pfModelMat\fP) into
"world" coordinates before computing the rotation based on the sprite
mode.

\f3\%pfSpriteMode\fP sets the \f2which\fP mode of \f2sprite\fP to \f2val\fP.
\f2which\fP identifies a particular mode and is one of:

.RS
\f3\%PFSPRITE_ROT\fP
\f2val\fP specifies the rotation constraints of \f2sprite\fP and is one of:
.TP
\f3\%PFSPRITE_AXIAL_ROT\fP
The +Z object coordinate axis of geometry is the axis of rotation,
i.e. the +Z object axis is rotated onto the sprite axis defined
by \f3\%pfSpriteAxis\fP in eye space,
then the transformed -Y axis is rotated about the sprite axis to
face the viewer as nearly as possible.
.TP
\f3\%PFSPRITE_POINT_ROT_EYE\fP
The sprite rotation is constrained to rotate
about the sprite location specified by \f3\%pfPositionSprite\fP.  The object's -Y is rotated to the eye's -Y (front vector),
and then the objects's Z axis is rotated about the front vector
to point toward the sprite axis (in eye coordinates) as nearly as possible.
In particular, if the sprite axis is +Z (the default), the object +Z
stays upright on the screen.
.TP
\f3\%PFSPRITE_POINT_ROT_WORLD\fP
This mode is identical to \f3\%PFSPRITE_AXIAL_ROT\fP except that the
sprite axis is interpreted as world coordinates rather than eye coordinates.
.TP
The default \f3\%PFSPRITE_ROT\fP mode is \f3\%PFSPRITE_AXIAL_ROT\fP.
.TP
\f3\%PFSPRITE_MATRIX_THRESHOLD\fP
pfGeoSets which contain a number of vertices less than \f2val\fP
will be transformed on the CPU, rather than through the Graphics
Library transformation stack. If \f2sprite\fP is to affect non-pfGeoSet
geometry, then \f2val\fP should be <= 0 in which case the
Graphics Library transformation stack will always be used.
Specifically, \f3\%pfBeginSprite\fP will push the matrix stack,
\f3\%pfPositionSprite\fP will modify the top of stack with the current
sprite rotation, and \f3\%pfEndSprite\fP will pop the matrix stack.
It is not necessary to push/pop the matrix stack within
\f3\%pfBeginSprite\fP/\f3\%pfEndSprite\fP. The default threshold value is
10.
.RE

\f3\%pfGetSpriteMode\fP returns the value of the mode identified by \f2which\fP.

\f3\%pfSpriteAxis\fP sets \f2sprite\fP's axis to (\f2x\fP, \f2y\fP, \f2z\fP).
\f3\%pfGetSpriteAxis\fP returns the axis of \f2sprite\fP in \f2x\fP, \f2y\fP, \f2z\fP.

\f3\%pfBeginSprite\fP makes \f2sprite\fP the current pfSprite and applies its
effects to subsequently drawn pfGeoSets and non-pfGeoSet geometry if
\f2sprite\fP's matrix threshold value is <= 0.
\f3\%pfPositionSprite\fP specifies the sprite origin and \f3\%pfEndSprite\fP
sets the current pfSprite to \f3\%NULL\fP and exits "sprite mode".
\f3\%pfPositionSprite\fP may be called outside
\f3\%pfBeginSprite/pfEndSprite\fP
and any number of times within
\f3\%pfBeginSprite/pfEndSprite\fP
to render
geometry with many different origins but which share the characteristics
of \f2sprite\fP.

Example 1: Draw trees as axial sprites which rotate about +Z.

.Ex
.nf

pfVec3		treeOrg[NUMTREES];
pfGeoSet	*trees[NUMTREES];

sprite = pfNewSprite(arena);
pfBeginSprite(sprite);

for (i=0; i<NUMTREES; i++)
{
    pfPositionSprite(treeOrg[i][0], treeOrg[i][1], treeOrg[i][1]);
    pfDrawGSet(trees[i]);
}

pfEndSprite();
.Ee
.fi
.na


\f3\%pfBeginSprite\fP, \f3\%pfEndSprite\fP, and \f3\%pfPositionSprite\fP are all
display-listable commands.   If a
pfDispList has been opened by \f3\%pfOpenDList\fP, these commands
will not have immediate effect but will be captured by
the pfDispList and will only have effect when that pfDispList is later
drawn with \f3\%pfDrawDList\fP.

.SH NOTES

Both \f3\%PFSPRITE_AXIAL_ROT\fP and \f3\%PFSPRITE_POINT_ROT_WORLD\fP sprites may
"spin" about the Y axis of the pfGeoSet when viewed along the rotation
or alignment axis.
.SH SEE ALSO
pfDelete,
pfDispList,
pfGeoSet,
pfModelMat,
pfState,
pfViewMat
