'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfState" "3pf"
.SH NAME
.upperok
.B pfNewState,
.B pfGetStateClassType,
.B pfSelectState,
.B pfLoadState,
.B pfAttachState,
.B pfInitState,
.B pfGetCurState,
.B pfPushState,
.B pfPopState,
.B pfGetState,
.B pfFlushState,
.B pfBasicState,
.B pfPixScale,
.B pfGetPixScale
\- 
Create, modify and query graphics state
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfState\ *\ \ \ 'u
#include <ulocks.h>
.nf
.fi
.TP
#include <Performer/pr.h>
.nf
.fi
.TP
pfState *
\f3\%pfNewState\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetStateClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfSelectState\fP(pfState\ *state);
.nf
.fi
.TP
void
\f3\%pfLoadState\fP(pfState\ *state);
.nf
.fi
.TP
void
\f3\%pfAttachState\fP(pfState\ *state,
'in +2
'll -2
pfState\ *state1);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfInitState\fP(usptr_t*\ arena);
.nf
.fi
.TP
pfState *
\f3\%pfGetCurState\fP(void);
.nf
.fi
.TP
void
\f3\%pfPushState\fP(void);
.nf
.fi
.TP
void
\f3\%pfPopState\fP(void);
.nf
.fi
.TP
void
\f3\%pfGetState\fP(pfGeoState\ *gstate);
.nf
.fi
.TP
void
\f3\%pfFlushState\fP(void);
.nf
.fi
.TP
void
\f3\%pfBasicState\fP(void);
.nf
.fi
.TP
void
\f3\%pfPixScale\fP(float\ scale);
.nf
.fi
.TP
float
\f3\%pfGetPixScale\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfState\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfState\fP.
Casting an object of class \f3\%pfState\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfState\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

OpenGL Performer manages a subset of the graphics library state for
convenience and improved performance. Further, this state is
conceptually partitioned into two divisions: modes and attributes.  A
mode is a simple "setting" usually represented by a single value while
an attribute is a larger collection of related modes that is
encapsulated in an OpenGL Performer structure, such as \f3\%pfFog\fP.

Modes usually have two routines to set and get them while attributes
have many routines for accessing their parameters and a
\f3\%pfApply<*>\fP
routine which "applies" the attribute's characteristics to the graphics
system via graphics library state commands.  Modes are represented by
basic data types like 'int' and 'float' while attributes are pointers
to opaque OpenGL Performer structures whose contents are accessible only
through function calls.

An example of a mode is the shading model set by \f3\%pfShadeModel\fP and
an attribute is exemplified by a pfMaterial which is applied with
\f3\%pfApplyMtl\fP.  Each mode and attribute is identified by a
\f3\%PFSTATE_\fP token.  These tokens are used in \f3\%pfGStateMode\fP and
\f3\%pfGStateAttr\fP when initializing a pfGeoState and in \f3\%pfOverride\fP
to override mode and attribute settings.

.ne 21
The following table lists the state components that are modes.

.TS
center tab($) ;
C | C | C | C
L | L | L | C .
Mode$PFSTATE_ Token$Routine(s)$Default
_
Transparency$TRANSPARENCY$pfTransparency$PFTR_OFF
Antialiasing$ANTIALIAS$pfAntialias$PFAA_OFF
Decal$DECAL$pfDecal$PFDECAL_OFF
Face culling$CULLFACE$pfCullFace$PFCF_OFF
Alpha function$ALPHAFUNC$pfAlphaFunc$PFAF_ALWAYS
Alpha reference$ALPHAREF$pfAlphaFunc$0
Lighting enable$ENLIGHTING$pfEnable/pfDisable$PF_OFF
Texturing enable$ENTEXTURE$pfEnable/pfDisable$PF_OFF
Fogging enable$ENFOG$pfEnable/pfDisable$PF_OFF
Wireframe enable$ENWIREFRAME$pfEnable/pfDisable$PF_OFF
Colortable enable$ENCOLORTABLE$pfEnable/pfDisable$PF_OFF
Highlighting enable$ENHIGHLIGHTING$pfEnable/pfDisable$PF_OFF
Light Point enable$ENLPOINTSTATE$pfEnable/pfDisable$PF_OFF
TexGen enable$ENTEXGEN$pfEnable/pfDisable$PF_OFF
TexMat enable$ENTEXMAT$pfEnable/pfDisable$PF_OFF
TexLOD enable$ENTEXLOD$pfEnable/pfDisable$PF_OFF
.TE

.ne 17
The following table lists the state components that are attributes.

.TS
center tab($) ;
C | C | C | C
L | L | L | C .
Attribute$PFSTATE_ Token$Routine$Default
_
pfLightModel$LIGHTMODEL$pfApplyLModel$NULL
pfLights$LIGHTS$pfLightOn$all NULL
front pfMaterial$FRONTMTL$pfApplyMtl$NULL
back pfMaterial$BACKMTL$pfApplyMtl$NULL
pfTexEnv$TEXENV$pfApplyTEnv$NULL
pfTexture$TEXTURE$pfApplyTex$NULL
pfTexGen$TEXGEN$pfApplyTGen$NULL
pfTexLOD$TEXLOD$pfApplyTLOD$NULL
texture matrix$TEXMAT$pfApplyTMat$NULL
pfFog$FOG$pfApplyFog$NULL
pfColortable$COLORTABLE$pfApplyCtab$NULL
pfHighlight$HIGHLIGHT$pfApplyHlight$NULL
pfLPointState$LPOINTSTATE$pfApplyLPState$NULL
pfPlane$DECAL_PLANE$pfApplyDecalPlane$NULL
.TE

State values may be established within libpr in one of three ways:
.RS
.TP 5
1.
Immediate mode
.TP
2.
Display list mode
.TP
3.
pfGeoState mode
.RE

Like the graphics library itself, OpenGL Performer has two command
execution modes: immediate mode and display list mode.  In immediate
mode, the setting of a mode or the application of an attribute is
carried out immediately.  Any geometry rendered afterwards will be
drawn with that mode or attribute characteristics.  In display list
mode, the command will be "captured" by the open display list
(pfDispList) and will not have effect until the display list is closed
and later drawn with \f3\%pfDrawDList\fP.

All the routines listed in Table 1 are display-listable, which is to
say that they will be captured by an open pfDispList.  In immediate
mode, most of the above routines send command tokens to the graphics
pipeline.  Thus, the process invoking these commands must have a
graphics context open to accept the command tokens, otherwise a
segmentation violation or similar severe exception will result.
In addition to an open graphics context, a global pfState must have been
selected by \f3\%pfSelectState\fP. Note that neither a graphics context
nor pfState is required when drawing in display list
mode because the commands will be captured by the display list.

Example 1:
.Ex
.nf

/* Enable wireframe in immediate mode */
pfEnable(PFEN_WIREFRAME);

/* Draw 'gset' in wireframe */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

/* Enter display list mode by opening 'dlist' for appending */
pfOpenDList(dlist);
pfEnable(PFEN_WIREFRAME);
pfDrawGSet(gset);
pfCloseDList();

/* Draw 'gset' in wireframe */
pfDrawDList(dlist);
.Ee
.fi
.na


It is important to realize that OpenGL Performer display lists
(pfDispLists) are different from graphics library display lists.  A
pfDispList captures only \f3\%libpr\fP commands and does not contain
low-level geometric information like vertex coordinates and colors.

The pfGeoState encapsulates all of libpr state, i.e. it has all mode
settings and a pointer to a definition for each attribute type.  Through
\f3\%pfGStateMode\fP and \f3\%pfGStateAttr\fP it is possible to set every state
element of a pfGeoState.  When the pfGeoState is applied through
\f3\%pfApplyGState\fP all the state settings encapsulated by the pfGeoState
become active.  pfGeoStates also have useful inheritance properties
that are discussed in the pfGeoState man page.  Typical use of a
pfGeoState is to "build" it at database initialization time and attach
it to a pfGeoSet (\f3\%pfGSetGState\fP).  In this way the pfGeoState defines
the graphics state of the geometry encapsulated by the pfGeoSet
(pfDrawGSet will call \f3\%pfApplyGState\fP if the pfGeoSet has an attached
pfGeoState).

Example 3:
.Ex
.nf

/* Set up wireframe pfGeoState */
gstate = pfNewGState(NULL);
pfGStateMode(gstate, PFSTATE_ENWIREFRAME, PF_ON);

/* Draw wireframe pfGeoSet in "pfGeoState" mode */
pfApplyGState(gstate);          /* Apply 'gstate' */
pfDrawGSet(gset);               /* Draw 'gset' in wireframe */

/* Preferred method for drawing wireframe pfGeoSet */
pfGSetGState(gset, gstate);     /* Attach 'gstate' to 'gset' */
pfDrawGSet(gset);               /* Draw 'gset' in wireframe */
.Ee
.fi
.na


\f3\%pfInitState\fP initializes internal OpenGL Performer state.  \f2arena\fP
specifies a shared semaphore arena created by \f3\%usinit\fP for
multiprocess operation of OpenGL Performer or \f3\%NULL\fP for single
process operation.  For proper multiprocess operation, \f3\%pfInitState\fP
should be called by a single process before calls to \f3\%sproc\fP or
\f3\%fork\fP that will generate other processes using OpenGL Performer
state, with an arena which is shared by all application processes.  In
either single or multi-process operation, \f3\%pfInitState\fP must be
called before any state attributes such as pfTextures are created and
should only be called once.

\f3\%pfNewState\fP creates and returns a handle to a pfState.  \f2arena\fP
specifies a malloc arena out of which the pfState is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfStates can be deleted
with \f3\%pfDelete\fP.
Specifically, a pfState has a stack of state structures that shadow
OpenGL Performer and graphics library state.  This stack may be
manipulated by routines described below.

\f3\%pfGetStateClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfState\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetStateClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfState\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

A pfState should be created for each graphics context that the
process draws to with libpr routines.  When a process switches
graphics contexts it should also switch to the corresponding pfState
with \f3\%pfSelectState\fP.

\f3\%pfSelectState\fP makes \f2state\fP the current state.  pfState is a
global value so it is shared by all share group processes(See
\f3\%sproc\fP).  \f3\%pfSelectState\fP should be used when switching between
different graphics contexts.  It does not configure the graphics
context with its state settings.  \f3\%pfGetCurState\fP returns a pointer
to the current pfState or NULL if there is no active pfState.

Each pfState structure maintains a 64-deep stack of pfGeoStates.  A
pfGeoState shadows all libpr modes and attributes.  Changes to the
current state made through any of the 3 methods listed above are
recorded in the top of the pfGeoState stack.  \f3\%pfGetState\fP copies the
top of the pfGeoState stack into \f2gstate\fP.

\f3\%pfPushState\fP pushes the pfGeoState stack of the current pfState.
When pushed, the configuration of the current state is recorded so that
when popped, that state will be restored, overwriting any state changes
made between push and pop.  The bit vector which represents state
elements that are overridden by \f3\%pfOverride\fP is also pushed.

\f3\%pfPopState\fP compares the current pfGeoState with that of the
previously pushed pfGeoState and calls graphics library routines to
restore the previously pushed state.  The override bit vector is popped
before popping any state elements.  State changes made to a graphics
context must be made using the OpenGL Performer for \f3\%pfPushState\fP and
\f3\%pfPopState\fP to work correctly.  Calls made by the application directly
to the graphics library will circumvent OpenGL Performer state management
which may or may not be desired.

\f3\%pfFlushState\fP is only useful for applications which use
pfGeoStates.  pfGeoStates do not inherit state from each other so state
is pushed and popped when drawing them.  For performance, state is not
actually popped unless a subsequent pfGeoState requires it.  This means
that in-between pfGeoStates, the state may not be what the application
expects.  \f3\%pfFlushState\fP will return the state to the global
default.(See pfGeoState for more on state flushing).  \f3\%pfPushState\fP
calls \f3\%pfFlushState\fP.

\f3\%pfPixScale\fP sets \f2scale\fP as the value to be used in scaling point
and line width specifications. Global control of this scale factor is
important when Dynamic Video Resolution is in use, since points and
lines must be reduced in width as much as they are enlarged by the
video output system in order that the displayed geometry have the
designated width in display-pixel units. \f3\%pfGetPixScale\fP returns
the current pixel scale value.

\f3\%pfBasicState\fP is a convenience routine for disabling all modes and
is useful for drawing things like text which usually should not be lit
or fogged.  Specifically, \f3\%pfBasicState\fP is equivalent to the
following:
.Ex
.nf

/* return graphics pipeline to basic state */
pfDisable(PFEN_FOG);
pfDisable(PFEN_LIGHTING);
pfDisable(PFEN_TEXTURE);
pfDisable(PFEN_WIREFRAME);
pfDisable(PFEN_COLORTABLE);
pfDisable(PFEN_HIGHLIGHTING);
pfDisable(PFEN_LPOINTSTATE);
pfDisable(PFEN_TEXGEN);
pfDisable(PFEN_TEXMAT);

pfShadeModel(PFSM_GOURAUD);
pfAlphaFunc(0, PFAF_OFF);
pfCullFace(PFCF_OFF);
pfTransparency(PFTR_OFF);

if (multisampling-type antialiasing is not enabled)
    pfAntialias(PFAA_OFF);

pfDecal(PFDECAL_OFF);
.Ee
.fi
.na


Use \f3\%pfMakeBasicGState\fP to configure every
state element (value, mode, and attribute) of \f2gstate\fP
to be identical to the state set with \f3\%pfBasicState\fP.
The following code fragment is equivalent to \f3\%pfBasicState\fP:

.Ex
.nf

pfGeoState *gstate = pfNewGState(NULL);
pfMakeBasicGState(gstate);
pfLoadGState(gstate);
.Ee
.fi
.na


Each of \f3\%pfSelectState\fP, \f3\%pfPushState\fP, \f3\%pfPopState\fP,
\f3\%pfFlushState\fP, and \f3\%pfBasicState\fP are display-listable commands.
.SH SEE ALSO
pfAlphaFunc,
pfAntialias,
pfColortable,
pfCullFace,
pfDecal,
pfDelete,
pfEnable,
pfFog,
pfGeoSet,
pfGeoState,
pfHighlight,
pfLight,
pfLightModel,
pfLPointState,
pfMaterial,
pfOverride,
pfShadeModel,
pfTexEnv,
pfTexGen,
pfTexture,
pfTransparency
