'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfStats" "3pf"
.SH NAME
.upperok
.B pfNewStats,
.B pfGetStatsClassType,
.B pfStatsClass,
.B pfGetStatsClass,
.B pfStatsClassMode,
.B pfGetStatsClassMode,
.B pfOpenStats,
.B pfCloseStats,
.B pfGetOpenStats,
.B pfCollectGfxPipeStats,
.B pfGetStatsNumGfxPipeTimestamp,
.B pfStatsAttr,
.B pfGetStatsAttr,
.B pfStatsHwAttr,
.B pfGetStatsHwAttr,
.B pfEnableStatsHw,
.B pfDisableStatsHw,
.B pfGetStatsHwEnable,
.B pfCopyStats,
.B pfResetStats,
.B pfClearStats,
.B pfStatsCountGSet,
.B pfAccumulateStats,
.B pfAverageStats,
.B pfQueryStats,
.B pfMQueryStats,
.B pfGetCurStats,
.B pfGfxPipeTimestamp,
.B pfGetStatsGfxPipeTimestampStatus
\- 
Maintain statistics on OpenGL Performer operations and system usage
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfStats\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
#include <Performer/prstats.h>
.nf
.fi
.TP
pfStats *
\f3\%pfNewStats\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetStatsClassType\fP(void);
.nf
.fi
.TP
uint
\f3\%pfStatsClass\fP(pfStats\ *stats,
'in +2
'll -2
uint\ enmask,
int\ val);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetStatsClass\fP(pfStats\ *stats,
'in +2
'll -2
uint\ enmask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfStatsClassMode\fP(pfStats\ *stats,
'in +2
'll -2
int\ class,
uint\ mask,
int\ val);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfGetStatsClassMode\fP(pfStats\ *stats,
'in +2
'll -2
int\ class);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfOpenStats\fP(pfStats\ *stats,
'in +2
'll -2
uint\ enmask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfCloseStats\fP(uint\ enmask);
.nf
.fi
.TP
uint
\f3\%pfGetOpenStats\fP(pfStats\ *stats,
'in +2
'll -2
uint\ enmask);
.in
.ll
.nf
.fi
.TP
uint
\f3\%pfCollectGfxPipeStats\fP(pfStats*\ stats,
'in +2
'll -2
uint\ enmask);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetStatsNumGfxPipeTimestamp\fP(pfStats*\ stats);
.nf
.fi
.TP
void
\f3\%pfStatsAttr\fP(pfStats\ *fstats,
'in +2
'll -2
int\ attr,
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetStatsAttr\fP(pfStats\ *fstats,
'in +2
'll -2
int\ attr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfStatsHwAttr\fP(int\ attr,
'in +2
'll -2
float\ val);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetStatsHwAttr\fP(int\ attr);
.nf
.fi
.TP
void
\f3\%pfEnableStatsHw\fP(uint\ which);
.nf
.fi
.TP
void
\f3\%pfDisableStatsHw\fP(uint\ which);
.nf
.fi
.TP
uint
\f3\%pfGetStatsHwEnable\fP(uint\ which);
.nf
.fi
.TP
void
\f3\%pfCopyStats\fP(pfStats\ *dst,
'in +2
'll -2
pfStats\ *src,
uint\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfResetStats\fP(pfStats\ *stats);
.nf
.fi
.TP
void
\f3\%pfClearStats\fP(pfStats\ *stats,
'in +2
'll -2
uint\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfStatsCountGSet\fP(pfStats\ *stats,
'in +2
'll -2
pfGeoSet\ *gset);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAccumulateStats\fP(pfStats\ *dst,
'in +2
'll -2
pfStats\ *src,
uint\ which);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAverageStats\fP(pfStats\ *dst,
'in +2
'll -2
pfStats\ *src,
uint\ which,
int\ num);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfQueryStats\fP(pfStats\ *stats,
'in +2
'll -2
uint\ which,
void\ *dst,
int\ size);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfMQueryStats\fP(pfStats\ *stats,
'in +2
'll -2
uint\ *which,
void\ *dst,
int\ size);
.in
.ll
.nf
.fi
.TP
pfStats *
\f3\%pfGetCurStats\fP(void);
.nf
.fi
.TP
void
\f3\%pfGfxPipeTimestamp\fP(uint\ flag);
.nf
.fi
.TP
int
\f3\%pfGetStatsGfxPipeTimestampStatus\fP(pfStats*\ stats,
'in +2
'll -2
uint\ stamp);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfStats\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfStats\fP.
Casting an object of class \f3\%pfStats\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfStats\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH DESCRIPTION

These functions are used to collect, manipulate, print, and query
statistics on state operations, geometry, and graphics and system
operations.

\f3\%pfNewStats\fP creates and returns a handle to a pfStats.  \f2arena\fP
specifies a malloc arena out of which the pfStats is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfStats can be deleted
with \f3\%pfDelete\fP.

\f3\%pfGetStatsClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfStats\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetStatsClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfStats\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfResetStats\fP takes a pointer to a statistics structure, \f2stats\fP,
and will reset that entire statistics structure to its initial state.

\f3\%pfClearStats\fP takes a pointer to a statistics structure, \f2stats\fP,
and a bitmask \f2which\fP specifying the statistics that are to be
cleared to zeroes.

\f3\%pfCopyStats\fP takes pointers to statistics structures, \f2dst\fP and
\f2src\fP, and a bitmask \f2which\fP specifying the statistics that are to
be copied from \f2src\fP to \f2dst\fP.
This function is provided to enable
more control over the default pfObject function \f3\%pfCopy\fP.  Note that
only statistics data is copied and not any enable/disable settings or
modes.

Since some statistics can be expensive to gather, and so might possibly
influence other statistics, statistics are divided into different
classes based on the tasks that they monitor and one may select the
specific statistics classes of interest with
\f3\%pfStatsClass\fP.

Statistics classes also have different modes of collection so that
performance-expensive modes of a particular statistics class many be
disabled with \f3\%pfStatsClassMode\fP.
The statistics class enables may be used for directing operations on
statistics structures, including statistics collection, specified via
\f3\%pfOpenStats\fP, and also for printing, copying,
clearing, accumulation, and averaging.

Class enables and disables are specified with bitmasks.  Each statistics
class has an enable token: a \f3\%PFSTATS_EN*\fP token that can be OR-ed
with other statistics enable tokens and the result passed in to enable
and disable statistics operations.

Statistics classes that require special hardware support have token
names that start with \f3\%PFSTATSHW_\fP.  These tokens are used as class
enable tokens in the usual statistics routines, and also to enable and
disable the hardware statistics gathering via
\f3\%pfEnableStatsHw\fP and
\f3\%pfDisableStatsHw\fP.

Statistics classes also have modes that select different elements of a
class for collection.  These modes are set through
\f3\%pfStatsClassMode\fP.  Each statistics
class starts with a default mode setting.

The following tables provide details of the statistics class structure.
The first table lists the statistics classes, their naming tokens, and
their enable tokens for forming bitmasks.

.TS
center tab($) ;
c s s
c | c | c
l | l | l .
Statistics Class Table
_
Class$PFSTATS_ Token$PFSTATS_EN token
_
Graphics Rendered$\f3\%PFSTATS_GFX\fP$\f3\%PFSTATS_ENGFX\fP
Pixel Fill$\f3\%PFSTATSHW_GFXPIPE_FILL\fP$\f3\%PFSTATSHW_ENGFXPIPE_FILL\fP
CPU$\f3\%PFSTATSHW_CPU\fP$\f3\%PFSTATSHW_ENCPU\fP
GfxPipe$\f3\%PFSTATSHW_GFXPIPE_TIMES\fP$\f3\%PFSTATSHW_ENGFXPIPE_TIMES\fP
_
.TE

This second table defines the statistics classes and their naming token
and enable tokens for forming bitmasks.

.TS
center tab($) ;
c s s
c | c | c
l | l | l .
Statistics Mode Table
_
Class$PFSTATS_ Token$Modes
_
Graphics$\f3\%PFSTATS_GFX\fP$\f3\%PFSTATS_GFX_GEOM\fP
Rendered$$\f3\%PFSTATS_GFX_TSTRIP_LENGTHS\fP
$$\f3\%PFSTATS_GFX_ATTR_COUNTS\fP
$$\f3\%PFSTATS_GFX_STATE\fP
$$\f3\%PFSTATS_GFX_XFORM\fP

Pixel Fill$\f3\%PFSTATSHW_GFXPIPE_FILL\fP$\f3\%PFSTATSHW_GFXPIPE_FILL_DEPTHCMP\fP
$$\f3\%PFSTATSHW_GFXPIPE_FILL_TRANSPARENT\fP

CPU$\f3\%PFSTATSHW_CPU\fP$\f3\%PFSTATSHW_CPU_SYS\fP
$$\f3\%PFSTATSHW_CPU_IND\fP

GfxPipe$\f3\%PFSTATSHW_GFXPIPE_TIMES\fP$\f3\%PFSTATSHW_GFXPIPE_TIMES_TOTAL\fP
$$\f3\%PFSTATSHW_GFXPIPE_TIMES_AUTO_COLLECT\fP
_
.TE

The individual stats classes and modes are discussed in more detail in
the explanation of the statistics routines.

\f3\%pfStatsClass\fP takes a pointer to a statistics structure, \f2stats\fP,
and will set the classes specified in the bitmask, \f2enmask\fP,
according to the \f2val\fP, which must be set to one of the following:
.RS
.TP 25
\f3\%PFSTATS_ON\fP
Enables the specified classes.
.TP
\f3\%PFSTATS_OFF\fP
Disables the specified classes.
.TP
\f3\%PFSTATS_DEFAULT\fP
Resets the specified classes to default values.
.TP
\f3\%PFSTATS_SET\fP
Sets the entire class enable mask to \f2enmask\fP.
.RE

All stats collection can be set at once to on, off, or the default by
using \f3\%PFSTATS_ALL\fP for the bitmask and the appropriate value for the
enable flag.  For example, the following example disables all stats
classes with their current class mode settings.
.Ex
.nf

pfStatsClass(stats, \f3\%PFSTATS_ALL\fP, \f3\%PFSTATS_OFF\fP);
.Ee
.fi
.na


\f3\%pfGetStatsClass\fP takes a pointer to a stats structure, \f2stats\fP,
and the statistics classes of interest specified in the bitmask,
\f2enmask\fP.  If any of the statistics classes specified in \f2enmask\fP
are enabled, then \f3\%pfGetStatsClass\fP will return the bitmask of those
classes, and otherwise, will return zero.  If classes of an open
pfStats structure are disabled, then collection of those classes stop
immediately and those classes are considered closed.

\f3\%pfStatsClassMode\fP takes a pointer to a stats structure, \f2stats\fP,
the name of the class to set, \f2class\fP, a mask of the modes to set,
\f2mask\fP, and the value for the modes, \f2val\fP.  The class modes offer
further control over the statistics that are to be accumulated for a
given class.  For each statistics class, a set of modes is enabled by
default.  Some modes of a statistics class may be somewhat expensive,
and therefore they are not enabled by default.  \f2val\fP must be one
of:
.RS
.TP 25
\f3\%PFSTATS_ON\fP
Enable the modes specified in \f2mask\fP.
.TP
\f3\%PFSTATS_OFF\fP
Disable the modes specified in \f2mask\fP.
.TP
\f3\%PFSTATS_DEFAULT\fP
Set modes specified in \f2mask\fP to default values.
.TP
\f3\%PFSTATS_SET\fP
Set class mode mask to the specified \f2mask\fP.
.RE

As a convenience, all classes may have all of their modes set to on,
off, or their default values by specifying a \f2class\fP of
\f3\%PFSTATS_CLASSES\fP, and a mask of \f3\%PFSTATS_ALL\fP.  These defaults may
differ between machines and may change in the future; so, code should
not assume the current defaults but query the mode values for a given
class where needed.  No statistics for a given mode are accumulated
unless the corresponding class has been enabled with \f3\%pfStatsClass\fP.
If modes of an open pfStats structure are disabled, then collection of
those modes stop immediately.

\f3\%Graphics Statistics Modes\fP
.RS
.TP 5
\f3\%PFSTATS_GFX_GEOM\fP
This counts geometry that is drawn via \f3\%pfDrawGSet\fP.  Statistics
include the number of pfGeoSets drawn, and the numbers of pfGeoSets
that have each binding of each attribute, colors, normals, texture
coordinates.  The number of each type of pfGeoSet primitive is counted,
as well as the number of base primitives drawn: total triangles, lines,
and points.  Statistics are also kept on the number of triangle strips
drawn and the number of the total triangles that were actually in a
triangle strip.  This mode is enabled by default.
.TP
\f3\%PFSTATS_GFX_TSTRIP_LENGTHS\fP
The number of triangles in strips whose length in terms of triangle
count is shorter than \f3\%PFSTATS_TSTRIP_LENGTHS_MAX\fP is recorded.
Triangles in strips whose triangle count is greater than or equal to
\f3\%PFSTATS_TSTRIP_LENGTHS_MAX\fP are all counted together.  Quads are
counted as strips of length two and independent triangles are counted
as strips of length one.  An average triangle strip length (that uses
all of the actual lengths) is also maintained.  Keeping these triangle
strip statistics is expensive for the drawing operation and so this mode
is not enabled by default, but must be enabled with \f3\%pfStatsClassMode\fP.
.TP
\f3\%PFSTATS_GFX_ATTR_COUNTS\fP
The number of each of the different types of geometry attributes
(colors, normals, and texture coordinates) that are drawn is counted.
Keeping attribute statistics is expensive for the drawing operation and
so this mode is not enabled by default, but must be enabled with
\f3\%pfStatsClassMode\fP.
.TP
\f3\%PFSTATS_GFX_STATE\fP
This mode enables the counting of calls to state changes, as well as
the number of actual state changes themselves.  Such state changes
include the immediate mode routines such as \f3\%pfAntialias\fP, and the
application of the state structures, such as \f3\%pfApplyTex\fP.  Also
counted is the number of pfGeoStates encountered and the number of
state stack operations, such as \f3\%pfLoadGState\fP, \f3\%pfApplyGState\fP,
\f3\%pfPushState\fP, and \f3\%pfPopState\fP.  This mode is enabled by
default.
.TP
\f3\%PFSTATS_GFX_XFORM\fP
This mode enables the counting of calls to transformations, such as
\f3\%pfTranslate\fP, \f3\%pfScale\fP, and \f3\%pfRotate\fP, and graphics
matrix stack operations, such as \f3\%pfLoadMatrix\fP, etc.
the number of actual state changes themselves, as well as the number of
pfGeoStates encountered.  This mode is enabled by default.
.RE

\f3\%Graphics Pipe Fill Statistics\fP

These modes enable the accumulation of fill depth-complexity statistics
and require the corresponding hardware statistics to be enabled:
.Ex
.nf

pfEnableStatsHw(\f3\%PFSTATSHW_GFXPIPE_FILL_DEPTHCMP\fP);
.Ee
.fi
.na

.RS
.TP 5
\f3\%PFSTATSHW_GFXPIPE_FILL_DCPAINT\fP
This mode causes \f3\%pfCloseStats\fP to paint the screen according to the
number of times each pixel is touched.  This mode is enabled by
default.
.TP
\f3\%PFSTATSHW_GFXPIPE_FILL_DCCOUNT\fP
This  mode causes \f3\%pfCloseStats\fP to read back the framebuffer for the
calculation of fill depth-complexity statistics.  This mode is enabled
by default.
.TP
\f3\%PFSTATSHW_GFXPIPE_FILL_DEPTHCMP\fP
By default, only actual pixel writes are counted with depth complexity
stats.  This mode enables counting of Z compares as well.  This mode is
not enabled by default.
.TP
\f3\%PFSTATSHW_GFXPIPE_FILL_TRANSP\fP
This mode enables counting of fully transparent pixels.  This mode is
not enabled by default.
.RE

\f3\%CPU Statistics\fP

The CPU statistics keep track of system usage and requires that the
corresponding hardware statistics be enabled:
.Ex
.nf

pfEnableStatsHw(\f3\%PFSTATSHW_ENCPU\fP);
.Ee
.fi
.na

The percentage of time CPUs spend idle, busy, in user code, and waiting
on the Graphics Pipeline, or on the swapping of memory is calculated.
Counted is the number of context switches (process and graphics), the
number of system calls, the number of times the graphics FIFO is found
to be full, the number of times a CPU went to sleep waiting on a full
graphics FIFO, the number of graphics pipeline IOCTLs issued (by the
system), and the number of swapbuffers seen.  All of these statistics
are computed over an elapsed period of time, and using an elapsed
interval of at least one second is recommended.
.RS
.TP 5
\f3\%PFSTATSHW_CPU_SYS\fP
This mode enables computation of the above CPU statistics for the entire
system.  This includes statistics on system usage, cpu-graphics interactions,
and memory.  CPU usage statistics are summed over all CPUs.
This mode is enabled by default.
.TP
\f3\%PFSTATSHW_CPU_IND\fP
This mode enables tracking of CPU statistics for each individual CPU
and is much more expensive than using just the summed statistics.  It
is not enabled by default.
.RE

\f3\%pfGetStatsClassMode\fP takes a pointer to a stats structure,
\f2stats\fP, and the name of the class to query,  \f2class\fP.  The return
value is the mode of \f2class\fP.

\f3\%pfOpenStats\fP takes a pointer to a stats structure, \f2stats\fP, and a
bitmask specifying the statistics classes that are to be opened for
collection in \f2enmask\fP.  This statistics structure will become the
one and only statistics structure open for collection.  The return
value will be the bitmask for all currently open statistics classes.
If another pfStats structure is already open, then this call to
\f3\%pfOpenStats\fP will be ignored and the return value will be 0.  When
statistics classes that use statistics hardware are open for
collection, \f3\%pfOpenStats\fP will access that hardware for
initialization.  Therefore, for graphics pipe statistics, it is
imperative that the statistics hardware only be enabled for the drawing
process.  Furthermore, only one process at a time should use statistics
hardware since it is a shared global resource.  Finally, for
statistics that are actually accumulated in statistics hardware, it is
best to let some time elapse before the statistics are collected (in
\f3\%pfCloseStats\fP).  Refer the examples at the end of this manual page.

\f3\%pfCloseStats\fP takes a bitmask \f2which\fP specifying the classes whose
collected statistics are to be accumulated into the current \f3\%pfStats\fP
structure.  Further collection of these statistics are then disabled
and they will have to be re-opened with \f3\%pfOpenStats\fP for further
collection.  A pfStats structure is considered to be open until all
opened statistics classes have been closed with \f3\%pfCloseStats\fP.  The
return value for \f3\%pfCloseStats\fP is the bitmask of the remaining open
classes.  If \f2stats\fP has no open classes, a value of 0 will be
returned.  When statistics classes that use statistics hardware are
open for collection, \f3\%pfCloseStats\fP will access that hardware to
collect the specified statistics.  Therefore, for graphics pipe
statistics, it is imperative that the statistics hardware only be
enabled for the drawing process.  Furthermore, only one processes should
be using statistics hardware at a time since it is a shared global
resource.

\f3\%pfGetOpenStats\fP takes a pointer to a stats structure, \f2stats\fP, a
bitmask \f2enmask\fP specifying the statistics classes that are being
queried.  If any of the statistics classes specified in \f2enmask\fP are
open for collection, then the bitmask of those statistics classes is
returned, and otherwise, zero.

\f3\%pfGetCurStats\fP returns the currently open statistics structure, or
NULL if there is no statistics structure open for accumulation.

\f3\%pfGfxPipeTimestamp\fP allows the specification of a \f3\%PFSTATSHW_TIMETAMP_\fP
token for the currently open pfStats structure with
\f3\%PFSTATSHW_GFXPIPE_TIMES\fP enabled. These tokens may be
one of the following and must be issued once per collection period
and in increasing order.
.RS
.TP 5
\f3\%PFSTATSHW_TIMESTAMP_START\fP
signal start of drawing.
.TP
\f3\%PFSTATSHW_TIMESTAMP_END\fP
signal end of drawing.
.TP
\f3\%PFSTATSHW_TIMESTAMP_FRAME_END\fP
signals end of frame and is automatically followed by a
\f3\%PFSTATSHW_TIMESTAMP_FINISH\fP to flush graphics pipeline.
.TP
\f3\%PFSTATSHW_TIMESTAMP_FINISH\fP
will flush the graphics pipeline to ensure that all drawing
is including in the timing.
.RE
The \f3\%PFSTATSHW_TIMESTAMP_OPEN\fP and \f3\%PFSTATSHW_TIMESTAMP_CLOSE\fP
may be issued only by OpenGL Performer and these are issued automatically
when \f3\%PFSTATSHW_GFXPIPE_TIMES\fP statistics are opened and closed.

\f3\%pfGetStatsGfxPipeTimestampStatus\fP may be used to find out if a given
timestamp for the specified pfStats structure has completed its trip
through the graphics pipeline (and has resulting data ready for
collection).

\f3\%pfCollectGfxPipeStats\fP  may be used to collect graphics pipeline statistics
for a structure after the statistics for that structure have been closed.
Graphics pipeline statistics must be gathered in the same order that
the timestamps are issued.  If separate collection of graphics pipeline
statistics are to be done, the
\f3\%pfStatsClassMode\fP of
\f3\%PFSTATSHW_GFXPIPE_TIMES_AUTO_COLLECT\fP (which is on by default)
must be turned off.

\f3\%pfStatsAttr\fP takes a pointer to a stats structure, \f2stats\fP, the
name of the attribute to set, \f2attr\fP, and the attribute value,
\f2val\fP.  Currently, there are no pfStats attributes.
\f3\%pfGetStatsAttr\fP takes a pointer to a stats structure, \f2stats\fP, and
the name of the attribute to query, \f2attr\fP.  The return value is that
of attribute \f2attr\fP.

\f3\%pfEnableStatsHw\fP takes a bitmask \f2which\fP specifying the hardware
statistics that should be enabled.  These bitmasks are the statistics
class enable bitmasks that have start with \f3\%PFSTATSHW_*\fP.  Statistics
hardware must be enabled for the corresponding classes of statistics to
be accumulated.  Having statistics hardware enabled will have some cost
to performance; however, in most cases, it pays to leave this hardware
enabled if corresponding statistics classes are being frequently
enabled and disabled.  When statistics classes that use statistics
hardware are open for collection, \f3\%pfOpenStats\fP and \f3\%pfCloseStats\fP
will access that hardware.  For graphics pipe statistics, it is
therefore imperative that the statistics hardware only be enabled for a
process that is connected to the graphics pipeline.  Furthermore, only
one processes should be using statistics hardware at a time since it is
a shared global resource.

\f3\%Graphics Statistics Hardware Enables\fP
.RS
.TP 5
\f3\%PFSTATSHW_ENGFXPIPE_TIMES\fP
Enables the tracking of timestamps in the graphics pipeline.
This produces very accurate measurements of elapsed drawing times with
minimal impact.  Timestamps are issued automatically when statistics
are opened and closed, and additional stamps may be issued with
\f3\%pfGfxPipeTimestamp\fP.
.TP
\f3\%PFSTATSHW_ENGFXPIPE_FILL\fP
Enables hardware to support tracking of depth complexity statistics.
When this mode is enabled, the framebuffer keeps track of the number of
times each pixel is touched.  This may require a framebuffer
reconfiguration which can be quite expensive, and which may not be
possible in GLX windows.
.TP
\f3\%PFSTATSHW_ENCPU\fP
This mode enable gathering of CPU statistics by the system.  This mode
should only be enabled by one process at a time.
.RE

\f3\%pfDisableStatsHw\fP takes a bitmask \f2which\fP specifying the hardware
statistics that should be disabled.

\f3\%pfGetStatsHwEnable\fP takes a bitmask \f2which\fP specifying the
hardware statistics that are being queried.  If any of the hardware
statistics classes specified in \f2which\fP have their corresponding
hardware enabled, then the bitmask of those statistics classes is
returned, and otherwise, zero is returned.

\f3\%pfStatsHwAttr\fP takes the name of the attribute to set, \f2attr\fP, and
the attribute value, \f2val\fP.  There is currently one stats hardware
attribute:  \f3\%PFSTATSHW_FILL_DCBITS\fP.  Its value must be an integer
value in the range of 1 to 4.  The default value is 3.  This attribute
sets the maximum number of stencil bits used for tracking fill depth
complexity.  See the GL manual page for \f3\%stensize(3g)\fP for more
information on stencil bitplanes.

\f3\%pfGetStatsHwAttr\fP Returns the value of attribute \f2attr\fP.

Collected statistics can be printed to stderr or a file with
\f3\%pfPrint\fP, and can be queried at run-time
with \f3\%pfQueryStats\fP for a single-value query,
and \f3\%pfMQueryStats\fP for getting back a
collection of statistics.

\f3\%pfQueryStats\fP takes a pointer to a statistics structure, \f2stats\fP,
a query token in \f2which\fP, and a destination buffer \f2dst\fP.  The
size of the expected return data is specified by \f2size\fP and if non-zero,
will prevent \f3\%pfQueryStats\fP from writing beyond a buffer that is
too small.
The return value is the number of bytes written to the destination buffer.
There are tokens for getting back all of the statistics, entire
sub-structures, and individual values.  The exposed query structure
types and query  tokens are all defined in \f2<Performer/prstats.h>\fP.
Every structure and field is commented with its corresponding query
token.  For example, the exposed structure type pfStatsValues can be
used to hold the entire contents of a pfStats structure and has
corresponding query token \f3\%PFSTATSVAL_ALL\fP.
.Ex
.nf

typedef struct pfStatsValues
{   /* to get back all stats:       PFSTATSVAL_ALL                 */
    /* PFSTATS_GFX class:             PFSTATSVAL_GFX               */
    pfStatsValGeom      geom;        /* PFSTATSVAL_GFX_GEOM        */
    pfStatsValModes     modeChanges; /* PFSTATSVAL_GFX_MODECHANGES */
    pfStatsValModes     modeCalls;   /* PFSTATSVAL_GFX_MODECALLS   */
    pfStatsValState     state;       /* PFSTATSVAL_GFX_STATE       */
    pfStatsValXforms    xform;       /* PFSTATSVAL_GFX_XFORM       */
    /* PFSTATSHW_GFXPIPE_FILL class: PFSTATSVAL_GFXPIPE_FILL       */
    pfStatsValFill      fill;        /* PFSTATSVAL_GFXPIPE_FILL    */
    /* the PFSTATSHW_CPU class:      PFSTATSVAL_CPU                */
    pfStatsValCPU       cpu;         /* PFSTATSVAL_CPU             */
} pfStatsValues;
.Ee
.fi
.na


The following example will return all of the contents of a pfStats
structure into the contents of a structure of the exposed type
pfStatsValues.
.Ex
.nf

pfStats *stats;
pfStatsValues *val;
pfQueryStats(stats, \f3\%PFSTATSVAL_ALL\fP, (float *) val, sizeof(pfStatsValues));
.Ee
.fi
.na


\f3\%pfMQueryStats\fP takes a pointer to a statistics structure, \f2stats\fP,
a pointer to the start of an array of query tokens in \f2which\fP, and a
destination buffer \f2dst\fP.   The array \f2which\fP must be terminated with
the token PFSTATSVAL_NULL.
The size of the expected return data is
specified by \f2size\fP and if non-zero, will prevent \f3\%pfMQueryStats\fP from
writing beyond a buffer that is too small.
The return value is the number of bytes
written to the destination buffer.

\f3\%pfStatsCountGSet\fP takes a pointer to a statistics structure,
\f2stats\fP, and a pointer to a pfGeoSet, \f2gset\fP, whose geometry
statistics are to be accumulated into \f2stats\fP.

\f3\%pfAccumulateStats\fP takes pointers to statistics structures, \f2dst\fP
and \f2src\fP, and a bitmask \f2which\fP specifying the statistics that are
to be accumulated from \f2src\fP to \f2dst\fP.

\f3\%pfAverageStats\fP takes pointers to statistics structures, \f2dst\fP and
\f2src\fP, and a bitmask \f2which\fP, and an integer \f2num\fP.  The statistics classes
specified by \f2which\fP will be taken from \f2src\fP, averaged by
dviding by \f2num\fP, and the result placed in \f2dst\fP.

For a class of statistics to be collected, the following must be true:
.RS
.TP 5
1.
A statistics structure must be created.
.TP
2.
The corresponding statistics class must be enabled with \f3\%pfStatsClass\fP.
No statistics classes are enabled by default.
.TP
3.
The corresponding statistics class mode must be enabled with
\f3\%pfStatsClassMode\fP.  However, each statistics class has a
popular set of statistics modes enabled by default.
.TP
4.
Any relevant hardware must be enabled via \f3\%pfEnableStatsHw\fP.
.TP
5.
The statistics class must be opened for collection with \f3\%pfOpenStats\fP.
.RE

.SH EXAMPLES
This example creates a statistics structure and enabling the graphics
statistics class with the triangle-strip statistics enabled.
.Ex
.nf

pfStats *stats = NULL;
stats = pfNewStats(NULL);
pfStatsClass(stats, PFSTATS_ENGFX, PFSTATS_ON);
pfStatsClassMode(stats, PFSTATS_GFX, PFSTATS_GFX_TSTRIP_LENGTHS, PFSTATS_ON);
.Ee
.fi
.na


This is an example of collecting CPU statistics over an elapsed period of time.
.Ex
.nf

pfStats *stats = NULL;
double lastTime = 0;
stats = pfNewStats(NULL);

/* enable the CPU stats class - using the default summed CPU statistics */
pfStatsClass(stats, PFSTATSHW_ENCPU, PFSTATS_ON);

/* enable CPU stats hardware */
pfEnableStatsHw(PFSTATSHW_ENCPU);
 :
/* snap CPU stats every 2 seconds */
if (pfGetTime() - lastTime > 2.0)
{
    if (pfGetOpenStats(stats, PFSTATSHW_ENCPU))
    {
        /*
         * final snap of CPU stats is done here and difference
         * between this and the initial snap is calculated.
         */
        pfCloseStats(PFSTATSHW_ENCPU);
    }
    else
    {
        /* initial snap of CPU stats is done here */
        pfOpenStats(stats, PFSTATSHW_ENCPU);
    }
}
.Ee
.fi
.na


This example shows the enabling and disabling of fill statistics.
.Ex
.nf

pfStats *stats = NULL;
stats = pfNewStats(NULL);

/* enable fill statistics collection */
pfStatsClass(stats, PFSTATSHW_ENGFXPIPE_FILL, PFSTATS_ON);

/* enable fill stats hardware - put framebuffer in correct configuration */
pfEnableStatsHW(PFSTATSHW_ENGFXPIPE_FILL);

/* open fill statistics collection and initialize hardware */
pfOpenStats(stats, PFSTATSHW_ENGFXPIPE_FILL);

/* draw geometry */
 :
/*
 * paint window by number of times each pixel was touched in the
 * previous drawing and read back the framebuffer and
 * examine the counts
 */
pfCloseStats(PFSTATSHW_ENGFXPIPE_FILL);
.Ee
.fi
.na

.SH NOTES

Fill stats are currently calculated by using stencil tests and
therefore require stencil bitplanes to be allocated.  Furthermore, the
\f3\%PFSTATSHW_GFXPIPE_FILL_TRANSP\fP mode currently disables modes that
reject fully transparent pixels, such as \f3\%pfAlphaFunc\fP, which will
alter what pixels get written into the zbuffer and therefore should be
used in conjunction with \f3\%PFSTATSHW_GFXPIPE_FILL_DEPTHCMP\fP.

The pfStats routines, structures, and constants are
defined in the <Performer/prstats.h> header file.

.SH BUGS


None

.SH SEE ALSO
pfDelete,
pfPrint
