'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexEnv" "3pf"
.SH NAME
.upperok
.B pfNewTEnv,
.B pfGetTEnvClassType,
.B pfTEnvMode,
.B pfGetTEnvMode,
.B pfTEnvBlendColor,
.B pfGetTEnvBlendColor,
.B pfApplyTEnv,
.B pfGetCurTEnv
\- 
Create, modify and query texture environment
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfTexEnv\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfTexEnv *
\f3\%pfNewTEnv\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetTEnvClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfTEnvMode\fP(pfTexEnv\ *tenv,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTEnvMode\fP(const\ pfTexEnv\ *tenv);
.nf
.fi
.TP
void
\f3\%pfTEnvBlendColor\fP(pfTexEnv\ *tenv,
'in +2
'll -2
float\ r,
float\ g,
float\ b,
float\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTEnvBlendColor\fP(pfTexEnv\ *tenv,
'in +2
'll -2
float*\ r,
float*\ g,
float*\ b,
float*\ a);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyTEnv\fP(pfTexEnv\ *tenv);
.nf
.fi
.TP
pfTexEnv *
\f3\%pfGetCurTEnv\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexEnv\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexEnv\fP.
Casting an object of class \f3\%pfTexEnv\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexEnv\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'tenv\ \ 'u
\f2tenv\fP
identifies a pfTexEnv.
.SH DESCRIPTION

\f3\%pfNewTEnv\fP creates and returns a handle to a pfTexEnv.  \f2arena\fP
specifies a malloc arena out of which the pfTexEnv is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfTexEnvs can be deleted
with \f3\%pfDelete\fP.
See the OpenGL \f3\%glTexEnv(3g)\fP man
page for more details on texture environments.

\f3\%pfGetTEnvClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexEnv\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetTEnvClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfTexEnv\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.


\f3\%pfTEnvMode\fP sets the texture environment mode.  \f2mode\fP is a
symbolic token that specifies a texture environment mode and is one of
the following:
.RS
\f3\%PFTE_MODULATE\fP
.br
\f3\%PFTE_BLEND\fP
.br
\f3\%PFTE_DECAL\fP
.br
\f3\%PFTE_REPLACE\fP
.br
\f3\%PFTE_ADD\fP
.br
\f3\%PFTE_ALPHA\fP
.RE

The default mode is \f3\%PFTE_MODULATE\fP.  \f3\%pfGetTEnvMode\fP returns the
mode of \f2tenv\fP.
See the OpenGL \f3\%glTexEnvf(3g)\fP man page for more details on
texture environments.

n\f3\%pfTEnvBlendColor\fP sets the texture environment blend color.  This color is used when the texture environment mode is
\f3\%PFTE_BLEND\fP or \f3\%PFTE_ADD\fP.
The default OpenGL Performer texture environment
blend color is [1,1,1,1].
It is different from the default OpenGL blend color of [0,0,0,0].
This was done to maintain compatibility with previous OpenGL Performer releases.
\f3\%pfGetTEnvBlendColor\fP copies the texture
environment blend color into \f2r\fP, \f2g\fP, \f2b\fP, \f2a\fP.

\f3\%pfApplyTEnv\fP makes \f2tenv\fP the current texture environment.  When
texturing is enabled (see below), this texture environment will be
applied to all geometry drawn after \f3\%pfApplyTEnv\fP is called.  Only
one pfTexEnv may be active at a time although many may be defined.
Modifications to \f2tenv\fP, such as changing the blend color, will not
have effect until \f3\%pfApplyTEnv\fP is called with \f2tenv\fP.

For geometry to be textured, the following must be true:
.RS
.TP
1.
Texturing must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_TEXTURE\fP)
.TP
2.
A pfTexEnv must be applied: \f3\%pfApplyTEnv\fP
.TP
3.
A pfTexture must be applied: \f3\%pfApplyTex\fP
.TP
4.
Geometry must have texture coordinates: \f3\%pfGSetAttr\fP, \f3\%PFGS_TEXCOORD2\fP
.RE

The texture environment state element is identified by the
\f3\%PFSTATE_TEXENV\fP token.  Use this token with \f3\%pfGStateAttr\fP to set
the texture environment of a pfGeoState and with \f3\%pfOverride\fP to
override subsequent texture environment changes.

Example 1:
.Ex
.nf

/* Set up blue 'blend' texture environment */
tev = pfNewTEnv(NULL);
pfTEnvMode(tev, PFTE_BLEND);
pfTEnvBlendColor(tev, 0.0f, 0.0f, 1.0f);

/* Set up textured/blended pfGeoState */
pfGStateMode(gstate, PFSTATE_ENTEXTURE, PF_ON);
pfGStateAttr(gstate, PFSTATE_TEXENV, tev);
pfGStateAttr(gstate, PFSTATE_TEXTURE, tex);

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Set texture coordinate array. 'gset' is non-indexed */
pfGSetAttr(gset, PFGS_TEXCOORD2, PFGS_PER_VERTEX, tcoords, NULL);

/* Draw textured gset */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

pfApplyTEnv(tev);

/* Override so that all textured geometry uses 'tev' */
pfOverride(PFSTATE_TEXENV, PF_ON);
.Ee
.fi
.na


\f3\%pfApplyTEnv\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfApplyTEnv\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

\f3\%pfGetCurTEnv\fP returns the currently active pfTexEnv or NULL if there
is no active pfTexEnv.
.SH NOTES


\f3\%PFTE_ALPHA\fP is supported only on RealityEngine graphics systems.

.SH SEE ALSO
pfDelete,
pfDispList,
pfEnable,
pfGeoState,
pfObject,
pfState,
pfTexture,
tevbind,
tevdef,
texbind,
texdef,
glTexEnv,
glTexImage2D.
