'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexGen" "3pf"
.SH NAME
.upperok
.B pfNewTGen,
.B pfGetTGenClassType,
.B pfTGenMode,
.B pfGetTGenMode,
.B pfTGenPlane,
.B pfGetTGenPlane,
.B pfTGenPoint,
.B pfGetTGenPoint,
.B pfApplyTGen,
.B pfGetCurTGen
\- 
Create, modify and query texture coordinate generator
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfTexGen\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfTexGen *
\f3\%pfNewTGen\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetTGenClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfTGenMode\fP(pfTexGen\ *tgen,
'in +2
'll -2
int\ texCoord,
int\ mode);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTGenMode\fP(const\ pfTexGen\ *tgen,
'in +2
'll -2
int\ texCoord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTGenPlane\fP(pfTexGen\ *tgen,
'in +2
'll -2
int\ texCoord,
float\ x,
float\ y,
float\ z,
float\ d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTGenPlane\fP(pfTexGen\ *tgen,
'in +2
'll -2
int\ texCoord,
float*\ x,
float*\ y,
float*\ z,
float*\ d);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTGenPoint\fP(pfTexGen\ *tgen,
'in +2
'll -2
int\ texCoord,
float\ x,
float\ y,
float\ z,
float\ dx,
float\ dy,
float\ dz);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTGenPoint\fP(pfTexGen\ *tgen,
'in +2
'll -2
int\ texCoord,
float*\ x,
float*\ y,
float*\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyTGen\fP(pfTexGen\ *tgen);
.nf
.fi
.TP
pfTexGen*
\f3\%pfGetCurTGen\fP(void);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexGen\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexGen\fP.
Casting an object of class \f3\%pfTexGen\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexGen\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'texCoord\ \ 'u
\f2tgen\fP
identifies a pfTexGen
.TP
\f2texCoord\fP
identifies a texture coordinate and is one of:
.IP
\f3\%PF_S\fP,
\f3\%PF_T\fP,
\f3\%PF_R\fP,
\f3\%PF_Q\fP
.PP
.SH DESCRIPTION

The \f3\%pfTexGen\fP capability is used to automatically generate texture
coordinates for geometry, typically for special effects like projected
texture, reflection mapping, and for light points (\f3\%pfLPointState\fP).
\f3\%pfNewTGen\fP creates and returns a handle to a pfTexGen.  \f2arena\fP
specifies a malloc arena out of which the pfTexGen is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfTexGens can be deleted
with \f3\%pfDelete\fP.

\f3\%pfGetTGenClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexGen\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetTGenClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfTexGen\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfTGenMode\fP sets the mode of \f2tgen\fP corresponding to texture
coordinate \f2texCoord\fP to \f2mode\fP. \f2mode\fP must be one of the
following:

.RS
.TP
\f3\%PFTG_OFF\fP
Disables texture coordinate generation
.TP
\f3\%PFTG_OBJECT_LINEAR\fP
Generate texture coordinate as distance from plane in object space.
.TP
\f3\%PFTG_EYE_LINEAR\fP
Generate texture coordinate as distance from plane in eye space. The plane
is transformed by the inverse of the ModelView matrix when
\f2tgen\fP is
applied.
.TP
\f3\%PFTG_EYE_LINEAR_IDENT\fP
Generate texture coordinate as distance from plane in eye space. The plane
is not transformed by the inverse of the ModelView matrix.
.TP
\f3\%PFTG_SPHERE_MAP\fP
Generate texture coordinate based on the view vector reflected about
the vertex normal in eye space.
.TP
\f3\%PFTG_OBJECT_DISTANCE_TO_LINE\fP
Coordinate will be the distance in object space from the vertex to
a line specified with a point and direction vector through \f3\%pfTGenPoint\fP.
.TP
\f3\%PFTG_EYE_DISTANCE_TO_LINE\fP
Coordinate will be the distance in eye space from the eye to
a line specified with \f3\%pfTGenPoint\fP through the vertex.
.RE

See the OpenGL \f3\%glTexGen(3g)\fP man page for the
specific mathematics of the texture coordinate generation modes.

The default texture generation mode for all texture coordinates is
\f3\%PFTG_OFF\fP. \f3\%pfGetTGenMode\fP returns the mode of \f2tgen\fP.

\f3\%pfTGenPlane\fP sets the plane equation used for generating
coordinates for texture coordinate \f2texCoord\fP to \f2a\fPX + \f2b\fPY +
\f2c\fPZ + \f2d\fP = 0. This plane equation is used when \f2tgen\fP's mode is
\f3\%PFTG_EYE_LINEAR\fP, \f3\%PFTG_EYE_LINEAR_IDENT\fP, or \f3\%PFTG_OBJECT_LINEAR\fP
but is ignored when its mode is \f3\%PFTG_SPHERE_MAP\fP. The default plane
equations are:

.RS
\f3\%PF_S\fP: (1, 0, 0, 0)
.TP
\f3\%PF_T\fP: (0, 1, 0, 0)
.TP
\f3\%PF_R\fP: (0, 0, 1, 0)
.TP
\f3\%PF_Q\fP: (0, 0, 0, 1)
.RE

\f3\%pfGetTGenPlane\fP will return the
plane equation parameters for texture coordinate \f2texCoord\fP
of \f2tgen\fP in \f2x\fP, \f2y\fP, \f2z\fP, \f2d\fP.
(If any of those arguments are NULL, they will be ignored.)

\f3\%pfTGenPoint\fP sets a point and possible
direction vector for use with point and line based texture generation
functions.
\f3\%pfGetTGenPoint\fP will return the point
of \f2tgen\fP in \f2x\fP, \f2y\fP, \f2z\fP.

\f3\%pfApplyTGen\fP configures the graphics hardware with the texture
coordinate generating parameters encapsulated by \f2tgen\fP.  Only the
most recently applied pfTexGen is active although any number of
pfTexGen definitions may be created.  Texture coordinate generation
must be enabled (\f3\%pfEnable\fP(\f3\%PFEN_TEXGEN\fP)) for \f2tgen\fP to have
effect and modifications made to \f2tgen\fP do not have effect until the
next time \f3\%pfApplyTGen\fP is called. \f3\%pfGetCurTGen\fP returns the
currently active pfTexGen.

The pfTexGen state element is identified by the \f3\%PFSTATE_TEXGEN\fP
token.  Use this token with \f3\%pfGStateAttr\fP to set the pfTexGen
attribute of a pfGeoState and with \f3\%pfOverride\fP to override
subsequent pfTexGen changes:

Example 1:
.Ex
.nf

/* Set up pfGeoState */
pfGStateMode(gstate, PFSTATE_ENTEXGEN, PF_ON);
pfGStateAttr(gstate, PFSTATE_TEXGEN, pfNewTGen(arena));

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Draw pfGeoSet whose texture coordinates are generated */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

/* Override so that all geometry is affected by 'tgen' */
pfEnable(PFEN_TEXGEN);
pfApplyTGen(tgen);
pfOverride(PFSTATE_TEXGEN | PFSTATE_ENTEXGEN, PF_ON);
.Ee
.fi
.na


\f3\%pfApplyTGen\fP
is a display-listable command.  If a pfDispList has been opened by
\f3\%pfOpenDList\fP,
\f3\%pfApplyTGen\fP
will not have immediate effect but will be captured by the pfDispList
and will only have effect when that pfDispList is later drawn with
\f3\%pfDrawDList\fP.

.SH SEE ALSO
pfDelete,
pfDispList,
pfGeoState,
pfLPointState,
pfMemory,
pfObject,
pfOverride,
texgen,
glTexGen.
