'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfText" "3pf"
.SH NAME
.upperok
.B pfNewText,
.B pfGetTextClassType,
.B pfAddString,
.B pfRemoveString,
.B pfInsertString,
.B pfReplaceString,
.B pfGetString,
.B pfGetNumStrings
\- 
Create, modify, and query a 3D text node.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfString\ *\ \ \ 'u
#include <Performer/pf.h>
.nf
.fi
.TP
pfText *
\f3\%pfNewText\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfGetTextClassType\fP(void);
.nf
.fi
.TP
int
\f3\%pfAddString\fP(pfText*\ text,
'in +2
'll -2
pfString*\ string);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfRemoveString\fP(pfText*\ text,
'in +2
'll -2
pfString*\ str);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfInsertString\fP(pfText*\ text,
'in +2
'll -2
int\ index,
pfString*\ str);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfReplaceString\fP(pfText*\ text,
'in +2
'll -2
pfString*\ old,
pfString*\ new);
.in
.ll
.nf
.fi
.TP
pfString *
\f3\%pfGetString\fP(const\ pfText*\ text,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetNumStrings\fP(const\ pfString*\ string);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfText\fP is
derived from the parent class \f3\%pfNode\fP,
so each of these member functions of
class \f3\%pfNode\fP
are also directly usable with objects
of class \f3\%pfText\fP.
Casting an object of class \f3\%pfText\fP
to an object of class \f3\%pfNode\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfNode\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfGroup *
\f3\%pfGetParent\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ i);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNumParents\fP(const\ pfNode\ *node);
.PD 0
.TP
void
\f3\%pfNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph,
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeBSphere\fP(pfNode\ *node,
'in +2
'll -2
pfSphere\ *bsph);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfBufferClone\fP(pfNode\ *node,
'in +2
'll -2
int\ mode,
pfBuffer\ *buf);
.in
.ll
.PD 0
.TP
int
\f3\%pfFlatten\fP(pfNode\ *node,
'in +2
'll -2
int\ mode);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeName\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetNodeName\fP(const\ pfNode\ *node);
.PD 0
.TP
pfNode*
\f3\%pfFindNode\fP(pfNode\ *node,
'in +2
'll -2
const\ char\ *pathName,
pfType\ *type);
.in
.ll
.PD 0
.TP
pfNode*
\f3\%pfLookupNode\fP(const\ char\ *name,
'in +2
'll -2
pfType*\ type);
.in
.ll
.PD 0
.TP
int
\f3\%pfNodeIsectSegs\fP(pfNode\ *node,
'in +2
'll -2
pfSegSet\ *segSet,
pfHit\ **hits[]);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMask\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
uint\ mask,
int\ setMode,
int\ bitOp);
.in
.ll
.PD 0
.TP
uint
\f3\%pfGetNodeTravMask\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravFuncs\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ pre,
pfNodeTravFuncType\ post);
.in
.ll
.PD 0
.TP
void
\f3\%pfGetNodeTravFuncs\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
pfNodeTravFuncType\ *pre,
pfNodeTravFuncType\ *post);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravData\fP(pfNode\ *node,
'in +2
'll -2
int\ which,
void\ *data);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetNodeTravData\fP(const\ pfNode\ *node,
'in +2
'll -2
int\ which);
.in
.ll
.PD 0
.TP
void
\f3\%pfNodeTravMode\fP(pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode,
int\ val);
.in
.ll
.PD 0
.TP
int
\f3\%pfGetNodeTravMode\fP(const\ pfNode*\ node,
'in +2
'll -2
int\ which,
int\ mode);
.in
.ll

.PD
.PP
Since the class
\f3\%pfNode\fP is itself derived from
the parent class \f3\%pfObject\fP, objects
of class \f3\%pfText\fP can also be used
with these functions designed for
objects of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfText\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'string\ \ 'u
\f2text\fP
identifies a pfText.
.TP
\f2string\fP
identifies a pfString.
.SH DESCRIPTION

A pfText is analogous to a \f3\%pfGeode\fP.  A pfText encapsulates
pfStrings in a scene graph as a \f3\%pfGeode\fP encapsulates
\f3\%pfGeoSet\fPs.  A pfText is a leaf node in the OpenGL Performer scene
graph hierarchy and is derived from \f3\%pfNode\fP so it can use
\f3\%pfNode\fP API.  A pfText is simply a list of pfStrings.

The bounding volume of a pfText is that which surrounds all its
pfStrings.  Unless the bounding volume is considered static (see
\f3\%pfNodeBSphere\fP), OpenGL Performer will compute a new volume when the
list of pfStrings is modified by \f3\%pfAddString\fP, \f3\%pfRemoveString\fP,
\f3\%pfInsertString\fP or \f3\%pfReplaceString\fP.  If the bounding box of a child
pfString changes, call \f3\%pfNodeBSphere\fP to tell OpenGL Performer to
update the bounding volume of the pfText.

\f3\%pfNewText\fP creates and returns a handle to a pfText.  Like
other pfNodes, pfTexts are always allocated from shared
memory and can be deleted using \f3\%pfDelete\fP.

\f3\%pfGetTextClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfText\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetTextClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfText\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfAddString\fP appends \f2str\fP to \f2text\fP's pfString list.
\f3\%pfRemoveString\fP removes \f2str\fP from the list and shifts the list
down over the vacant spot.  For example, if \f2str\fP had index 0, then
index 1 becomes index 0, index 2 becomes index 1 and so on.
\f3\%pfRemoveString\fP returns a 1 if \f2str\fP was actually removed and 0 if
it was not found in the list.  \f3\%pfAddString\fP and \f3\%pfRemoveString\fP will
cause OpenGL Performer to recompute new bounding volumes for \f2text\fP unless
it is configured to use static bounding volumes.

\f3\%pfInsertString\fP will insert \f2str\fP before the pfString with index
\f2index\fP.  \f2index\fP must be within the range 0 to
\f3\%pfGetNumStrings\fP(\f2text\fP).  \f3\%pfReplaceString\fP replaces \f2old\fP with
\f2new\fP and returns 1 if the operation was successful or 0 if \f2old\fP
was not found in the list.  \f3\%pfInsertString\fP and \f3\%pfReplaceString\fP will
cause OpenGL Performer to recompute new bounding volumes for \f2text\fP
unless it is configured to use static bounding volumes.

\f3\%pfGetNumStrings\fP returns the number of pfStrings in \f2text\fP.
\f3\%pfGetString\fP returns a handle to the pfString with index \f2index\fP or
\f3\%NULL\fP if the index is out of range.

Here is a sample code snippet demonstrating how to use
pfText, pfFont, and pfString to add 3D text to a scene graph:

.Ex
.nf

/* Initialize Performer and create pfScene "scene" */

/* Get shared memory arena */
arena = pfGetSharedArena();

/* Append standard directories to Performer search path, PFPATH */
pfFilePath(".:/usr/share/Performer/data");

/* Create 3D message and place in scene. */
text = pfNewText();
pfAddChild(scene, text);
if (pfFindFile("Times-Elfin.of", path, R_OK))
{
    str = pfNewString(arena);
    pfStringMode(str, PFSTR_DRAWSTYLE, PFSTR_EXTRUDED);
    pfStringMode(str, PFSTR_JUSTIFY, PFSTR_MIDDLE);
    pfStringColor(str, 1.0f, 0.0f, 0.8f, 1.0f);
    pfStringString(str, "Welcome to OpenGL Performer");
    pfFlattenString(str);
    pfAddString(text, str);
}
else
{
    pfNotify(PFNFY_WARN,PFNFY_PRINT,"Couldn't find font file.");
    exit(0);
}
.Ee
.fi
.na


.SH SEE ALSO
pfGeoSet,
pfNode,
pfNodeTravFuncs,
pfString,
pfFont,
pfDelete
