'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfTexture" "3pf"
.SH NAME
.upperok
.B pfNewTex,
.B pfGetTexClassType,
.B pfTexName,
.B pfGetTexName,
.B pfTexImage,
.B pfGetTexImage,
.B pfTexFormat,
.B pfGetTexFormat,
.B pfTexFilter,
.B pfTexAnisotropy,
.B pfGetTexAnisotropy,
.B pfGetTexFilter,
.B pfTexRepeat,
.B pfGetTexRepeat,
.B pfTexBorderColor,
.B pfGetTexBorderColor,
.B pfTexBorderType,
.B pfGetTexBorderType,
.B pfTexSpline,
.B pfGetTexSpline,
.B pfTexDetail,
.B pfGetTexDetail,
.B pfGetTexDetailTex,
.B pfDetailTexTile,
.B pfGetDetailTexTile,
.B pfTexList,
.B pfGetTexList,
.B pfTexFrame,
.B pfGetTexFrame,
.B pfTexLoadMode,
.B pfGetTexLoadMode,
.B pfTexLevel,
.B pfGetTexLevel,
.B pfTexLODRange,
.B pfGetTexLODRange,
.B pfGetCurTexLODRange,
.B pfGetTexLODBias,
.B pfTexLODBias,
.B pfGetCurTexLODBias,
.B pfTexLoadOrigin,
.B pfGetTexLoadOrigin,
.B pfTexLoadSize,
.B pfGetTexLoadSize,
.B pfApplyTex,
.B pfFormatTex,
.B pfLoadTex,
.B pfTexLoadImage,
.B pfGetTexLoadImage,
.B pfLoadTexLevel,
.B pfLoadTexFile,
.B pfSaveTexFile,
.B pfSubloadTex,
.B pfSubloadTexLevel,
.B pfFreeTexImage,
.B pfIdleTex,
.B pfIsTexLoaded,
.B pfIsTexFormatted,
.B pfApplyTexMinLOD,
.B pfApplyTexMaxLOD,
.B pfApplyTexLODBias,
.B pfGetCurTex,
.B pfApplyTMat
\- 
Create, modify and query texture
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'const\ char\ *\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
pfTexture *
\f3\%pfNewTex\fP(void\ *arena);
.nf
.fi
.TP
pfType *
\f3\%pfGetTexClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfTexName\fP(pfTexture\ *tex,
'in +2
'll -2
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfGetTexName\fP(const\ pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfTexImage\fP(pfTexture\ *tex,
'in +2
'll -2
uint*\ image,
int\ comp,
int\ ns,
int\ nt,
int\ nr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexImage\fP(const\ pfTexture\ *tex,
'in +2
'll -2
uint\ **image,
int\ *comp,
int\ *ns,
int\ *nt,
int\ *nr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexFormat\fP(pfTexture\ *tex,
'in +2
'll -2
int\ format,
int\ type);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTexFormat\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ format);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexFilter\fP(pfTexture\ *tex,
'in +2
'll -2
int\ filt,
int\ type);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexAnisotropy\fP(pfTexture\ *tex,
'in +2
'll -2
int\ degree);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTexAnisotropy\fP(pfTexture\ *tex);
.nf
.fi
.TP
int
\f3\%pfGetTexFilter\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ filt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexRepeat\fP(pfTexture\ *tex,
'in +2
'll -2
int\ wrap,
int\ type);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTexRepeat\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ wrap);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexBorderColor\fP(pfTexture*\ tex,
'in +2
'll -2
pfVec4\ clr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexBorderColor\fP(pfTexture*\ tex,
'in +2
'll -2
pfVec4\ *clr);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexBorderType\fP(pfTexture*\ tex,
'in +2
'll -2
int\ type);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTexBorderType\fP(pfTexture*\ tex);
.nf
.fi
.TP
void
\f3\%pfTexSpline\fP(pfTexture\ *tex,
'in +2
'll -2
int\ type,
pfVec2\ *pts,
float\ clamp);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexSpline\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ type,
pfVec2\ *pts,
float\ *clamp);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexDetail\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level,
pfTexture\ *detail);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexDetail\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ *level,
pfTexture\ **detail);
.in
.ll
.nf
.fi
.TP
pfTexture *
\f3\%pfGetTexDetailTex\fP(const\ pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfDetailTexTile\fP(pfTexture\ *tex,
'in +2
'll -2
int\ j,
int\ k,
int\ m,
int\ n,
int\ scram);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetDetailTexTile\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ *j,
int\ *k,
int\ *m,
int\ *n,
int\ *scram);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexList\fP(pfTexture\ *tex,
'in +2
'll -2
pfList\ *list);
.in
.ll
.nf
.fi
.TP
pfList *
\f3\%pfGetTexList\fP(const\ pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfTexFrame\fP(pfTexture\ *tex,
'in +2
'll -2
float\ frame);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfGetTexFrame\fP(const\ pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfTexLoadMode\fP(pfTexture\ *tex,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfGetTexLoadMode\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLevel\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level,
pfTexture\ *ltex);
.in
.ll
.nf
.fi
.TP
pfTexture *
\f3\%pfGetTexLevel\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ min,
float\ max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCurTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *min,
float\ *max);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexLODRange\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *biasS,
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexLODBias\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *biasS,
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLODBias\fP(pfTexture*\ tex,
'in +2
'll -2
float\ biasS,
float\ biasT,
float\ biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetCurTexLODBias\fP(pfTexture*\ tex,
'in +2
'll -2
float\ *biasS,
float\ *biasT,
float\ *biasR);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoadOrigin\fP(pfTexture\ *tex,
'in +2
'll -2
int\ which,
int\ xo,
int\ yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexLoadOrigin\fP(pfTexture\ *tex,
'in +2
'll -2
int\ which,
int\ *xo,
int\ *yo);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfTexLoadSize\fP(pfTexture\ *tex,
'in +2
'll -2
int\ xs,
int\ ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfGetTexLoadSize\fP(const\ pfTexture\ *tex,
'in +2
'll -2
int\ *xs,
int\ *ys);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfApplyTex\fP(pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfFormatTex\fP(pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfLoadTex\fP(pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfTexLoadImage\fP(pfTexture*\ tex,
'in +2
'll -2
uint\ *image);
.in
.ll
.nf
.fi
.TP
uint *
\f3\%pfGetTexLoadImage\fP(const\ pfTexture*\ tex);
.nf
.fi
.TP
void
\f3\%pfLoadTexLevel\fP(pfTexture\ *tex,
'in +2
'll -2
int\ level);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfLoadTexFile\fP(pfTexture\ *tex,
'in +2
'll -2
char\ *fname);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSaveTexFile\fP(pfTexture\ *tex,
'in +2
'll -2
char\ *fname);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSubloadTex\fP(pfTexture*\ tex,
'in +2
'll -2
int\ source,
uint\ *image,
int\ xsrc,
int\ ysrc,
int\ srcwid,
int\ xdst,
int\ ydst,
int\ xsize,
int\ ysize);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSubloadTexLevel\fP(pfTexture*\ tex,
'in +2
'll -2
int\ source,
uint\ *image,
int\ xsrc,
int\ ysrc,
int\ srcwid,
int\ xdst,
int\ ydst,
int\ xsize,
int\ ysize,
int\ level);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFreeTexImage\fP(pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfIdleTex\fP(pfTexture\ *tex);
.nf
.fi
.TP
int
\f3\%pfIsTexLoaded\fP(const\ pfTexture\ *tex);
.nf
.fi
.TP
int
\f3\%pfIsTexFormatted\fP(const\ pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfApplyTexMinLOD\fP(float\ min);
.nf
.fi
.TP
void
\f3\%pfApplyTexMaxLOD\fP(float\ min);
.nf
.fi
.TP
void
\f3\%pfApplyTexLODBias\fP(float\ biasS,
'in +2
'll -2
float\ biasT,
float\ biasR);
.in
.ll
.nf
.fi
.TP
pfTexture*
\f3\%pfGetCurTex\fP(void);
.nf
.fi
.TP
void
\f3\%pfApplyTMat\fP(pfMatrix\ *mat);
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfTexture\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfTexture\fP.
Casting an object of class \f3\%pfTexture\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfGetGLHandle\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfTexture\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'tex\ \ 'u
\f2tex\fP
identifies a pfTexture.
.SH DESCRIPTION

\f3\%pfNewTex\fP creates and returns a handle to a pfTexture.  \f2arena\fP
specifies a malloc arena out of which the pfTexture is allocated or
\f3\%NULL\fP for allocation off the process heap.  pfTextures can be deleted
with \f3\%pfDelete\fP.

\f3\%pfGetTexClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfTexture\fP.  The \f3\%pfType\fP* returned
by \f3\%pfGetTexClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfTexture\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfLoadTexFile\fP opens and loads the IRIS
image file specified by \f2fname\fP, using the global search paths set up
by \f3\%pfFilePath\fP and the environment variable \f3\%PFPATH\fP to find
\f2file\fP.  The loaded image is then formatted and used as the image
for \f2tex\fP.  Image memory is allocated out of
the malloc arena in which the pfTexture was created.  A return of FALSE
indicates failure, TRUE success.

\f3\%pfLoadTexFile\fP also sets the name of \f2tex\fP to the pathname of the
file that was loaded (see \f3\%pfTexName\fP).

\f3\%pfSaveTexFile\fP can be used to save a texture
to an IRIS image file specified by \f2fname\fP which contains the complete path
and name of the file to be created.  A return of FALSE indicates failure, TRUE success.

\f3\%pfTexImage\fP sets the image used by \f2tex\fP.  \f2image\fP is an array of
texel data. \f3\%pfTexImage\fP only copies the
pointer to \f2image\fP and does not make a separate copy of the texture
data.  \f2image\fP should be a pointer returned from \f3\%pfMalloc\fP so the
image may be properly reference counted (see \f3\%pfMalloc\fP and
\f3\%pfObject\fP).

The texture image is loaded from left to right, bottom to top.  Texel
rows must be aligned on long word boundaries, so rows must be byte-padded
to the end of each row to get the proper alignment.  \f2comp\fP is the
number of 8-bit components per image pixel.  1, 2, 3, and 4 component
textures are supported.  \f2ns\fP, \f2nt\fP, \f2nr\fP are the number of
texels in the s, t, and r dimensions of \f2image\fP.  See the
OpenGL \f3\%glTexImage(3g)\fP man page for a more
detailed description of texture formats.
\f3\%pfGetTexImage\fP returns the
texture image parameters of \f2tex\fP.
Any or all of the arguments to \f3\%pfGetTexImage\fP
may be NULL, in which case those arguments are ignored.

\f3\%pfFreeTexImage\fP frees the texture image memory associated with
\f2tex\fP after the next \f3\%pfApplyTex\fP is called if the image's
reference count is 0.  The texture image memory should be allocated by
\f3\%pfMalloc\fP and may be shared between multiple pfTextures.  However,
one should take care with \f3\%pfFreeTexImage\fP if \f2tex\fP is to be used
in multiple OpenGL windows.  If the image is freed on the first
\f3\%pfApplyTex\fP then it will not be around when \f2tex\fP is applied in a
second window.  In this case the image should be freed only when
\f2tex\fP has been applied in all windows.

\f3\%pfTexName\fP assigns the character string \f2name\fP to \f2tex\fP.  Names
are useful for sharing textures in order to optimize texture memory
usage.  A pfTexture's name is also set by \f3\%pfLoadTexFile\fP which sets
the name to the pathname of the file that was loaded.  \f3\%pfGetTexName\fP
returns the name of \f2tex\fP.

\f3\%pfTexFormat\fP specifies how the texture image memory associated with
\f2tex\fP is formatted by \f3\%pfFormatTex\fP.
\f2format\fP is a symbolic token specifying
which format to set and is \f3\%PFTEX_INTERNAL_FORMAT\fP, \f3\%PFTEX_IMAGE_FORMAT\fP,
\f3\%PFTEX_EXTERNAL_FORMAT\fP, or \f3\%PFTEX_SUBLOAD_FORMAT\fP.  \f2type\fP is a
symbolic token specifying the format type appropriate to \f2format\fP.
For all of the following formats and token values, there are matching
and additional OpenGL tokens.  See the OpenGL \f3\%glTexImage2D(3g)\fP
man page for more information on these and additional such
tokens.
The tokens for \f3\%PFTEX_EXTERNAL_FORMAT\fP describe how the data in the
image array is sized and packed and can be one of \f3\%PFTEX_PACK_8\fP for
8 bit components in packed bytes (the default),  or \f3\%PFTEX_PACK_16\fP for
images presented as 16bit components,
\f3\%PFTEX_UNSIGNED_SHORT_5_5_5_1\fP or one of the
OpenGL packed pixels <type> tokens.
The tokens for \f3\%PFTEX_IMAGE_FORMAT\fP describe the type of image data in
the array and can be \f3\%PFTEX_LUMINANCE\fP,
\f3\%PFTEX_LUMINANCE_ALPHA\fP, \f3\%PFTEX_RGB\fP, \f3\%PFTEX_RGBA\fP, or one
of the OpenGL <format> tokens.
The tokens for \f3\%PFTEX_INTERNAL_FORMAT\fP include the component names
use in the format and number of bits per component in the format.
Internal formats with fewer bits per texel can have faster performance.
For reasonable texture loading performance,
the \f3\%PFTEX_EXTERNAL_FORMAT\fP and \f3\%PFTEX_INTERNAL_FORMAT\fP should be of
corresponding types (same number of components, if specified,
and same bits per component).
If the \f3\%PFTEX_EXTERNAL_FORMAT\fP is set and the
\f3\%PFTEX_INTERNAL_FORMAT\fP has not been set, OpenGL Performer will automatically
select a matching \f3\%PFTEX_INTERNAL_FORMAT\fP token.
The internal formats, and the number of bits per texel for each, are:
.RS
.TP 30
\f3\%PFTEX_RGB_5\fP
\f216-bit\fP texels.
The default 3 component internal format.
.TP
\f3\%PFTEX_RGB_4\fP
\f216-bit\fP texels.
The default 3 component internal format if \f3\%PFTEX_RGB_5\fP
is not available (IMPACT systems).
.TP
\f3\%PFTEX_RGB5_A1\fP
\f216-bit\fP texels.
.TP
\f3\%PFTEX_RGBA_4\fP
\f216-bit\fP texels.
The default 4 component internal format.
.TP
\f3\%PFTEX_IA_8\fP
\f216-bit\fP texels.
.TP
\f3\%PFTEX_I_8A_8\fP
\f216-bit\fP texels.
.TP
\f3\%PFTEX_I_12A_4\fP
\f216-bit\fP texels.
The default 2 component internal format.
.TP
\f3\%PFTEX_I_8\fP
\f216-bit\fP texels.
The default 1 component internal format.
.TP
\f3\%PFTEX_I_16\fP
\f216-bit\fP texels.
.TP
\f3\%PFTEX_IA_12\fP
\f224-bit\fP texels.
.TP
\f3\%PFTEX_RGBA_8\fP
\f232-bit\fP texels.
.TP
\f3\%PFTEX_RGB_12\fP
\f248-bit\fP texels.
.TP
\f3\%PFTEX_RGBA_12\fP
\f248-bit\fP texels.
.RE
There are additional boolean format options:
.RS
.TP 10
\f3\%PFTEX_GEN_MIPMAP_FORMAT\fP
Specifies whether or not MIPmap level should be automatically created
for a texture if a MIPmap minification filter is in use.  The default
value is TRUE.
.TP
\f3\%PFTEX_DETAIL_TEXTURE\fP
specifies that the texture is to be used as a detail texture.
Once a texture has been specified to be a detail texture, it can no longer
be used as a base texture.  Calling \f3\%pfApplyTex\fP on a detail texture will
bind the texture to the detail target, not the base target.
.TP
\f3\%PFTEX_SUBLOAD_FORMAT\fP
is a boolean mode that specifies that texture is to be able to be loaded in pieces,
if supported on the current machine.
\f2type\fP should be either \f3\%PF_ON\fP or \f3\%PF_OFF\fP.
If an image has been assigned to the pfTexture, it will be automatically
downloaded upon formatting.  This type of texture may be formatted with a NULL image,
in which case, no image is automatically downloaded upon formatting.
If the texture is swapped out of hardware texture memory,
the image will not be automatically restored upon pfApplyTex
unless the \f3\%PFTEX_BASE_AUTO_SUBLOAD\fP mode has been specified for the
\f3\%pfTexLoadMode\fP.
and can always be explicitly reloaded with
\f3\%pfLoadTex\fP.
This format also specifies that all loads of the texture will use the
origin, size and image specified by
\f3\%pfTexLoadOrigin\fP,
\f3\%pfTexLoadSize\fP, and
\f3\%pfTexLoadImage\fP.
If the current graphics hardware configuration cannot support texture subloading,
this mode will be ignored.
In OpenGL, this requires the \f3\%EXT_subtexture\fP extension; see the
\f3\%EXT_subtexture\fP section of the OpenGL \f3\%glIntro(3g)\fP man page for more
information.
If \f3\%PFTEX_SUBLOAD_FORMAT\fP is enabled, \f3\%pfFreeTexImage\fP
should not be used as long as the texture is in use.
.RE

See the
OpenGL \f3\%glTexImage2D(3g)\fP and \f3\%glTexSubImage\fP man pages for
a description of texture formats and corresponding texture loading behavior.
\f3\%pfGetTexFormat\fP returns the format mode corresponding to
\f2format\fP.

\f3\%pfTexRepeat\fP
specifies a texture coordinate repeat function.
\f2wrap\fP is a symbolic token that specifies which texture coordinate(s)
are affected by the repeat function and is one of \f3\%PFTEX_WRAP\fP,
\f3\%PFTEX_WRAP_R\fP, \f3\%PFTEX_WRAP_S\fP, or \f3\%PFTEX_WRAP_T\fP.
\f2mode\fP is a symbolic token that
specifies how texture coordinates outside the range 0.0 through 1.0 are
handled.  \f2mode\fP token values may be one of: \f3\%PFTEX_REPEAT\fP or \f3\%PFTEX_CLAMP\fP.
The default texture repeat function is \f3\%PFTEX_REPEAT\fP for
all texture coordinates.  \f3\%pfGetTexRepeat\fP returns the texture
coordinate repeat function corresponding to \f2wrap\fP.

\f3\%pfTexFilter\fP sets a filter function used by \f2tex\fP.
\f2type\fP may be one of \f3\%PFTEX_MINFILTER\fP, \f3\%PFTEX_MAGFILTER\fP,
\f3\%PFTEX_MAGFILTER_ALPHA\fP, or \f3\%PFTEX_MAGFILTER_COLOR\fP.
\f2filter\fP is a combination of bitmask tokens which
specify a particular minification or magnification filter.
Filters may be partially specified, in which case, OpenGL Performer
will use defaults based on performance considerations for the
current graphics platform.
\f3\%PFTEX_FAST\fP can be included in a texture filter and may cause
a slightly different filter to be substituted in texture application
for fast performance on the current graphics platform.
All filters may include basic interpolation tokens:
.RS
\f3\%PFTEX_POINT\fP
.br
\f3\%PFTEX_LINEAR\fP
.br
\f3\%PFTEX_BILINEAR\fP
.br
\f3\%PFTEX_TRILINEAR\fP
.br
\f3\%PFTEX_QUADLINEAR\fP - for 3D texture only.
.RE

Additionally, filters may specify additional minification or magnification
functions.

.TS
center tab($) ;
c s
c | c
l | l  .
Texture Filter Table
_
Filter$PFTEX_ tokens
_
\f3\%PFTEX_MINFILTER\fP$\f3\%PFTEX_MIPMAP\fP

\f3\%PFTEX_MAGFILTER\fP$\f3\%PFTEX_DETAIL_LINEAR\fP
$\f3\%PFTEX_MODULATE\fP
$\f3\%PFTEX_ADD\fP
$\f3\%PFTEX_DETAIL_COLOR\fP
$\f3\%PFTEX_DETAIL_ALPHA\fP

\f3\%PFTEX_MAGFILTER_ALPHA\fP$\f3\%PFTEX_DETAIL\fP
$\f3\%PFTEX_MODULATE\fP
$\f3\%PFTEX_ADD\fP
$\f3\%PFTEX_DETAIL_ALPHA\fP
$\f3\%PFTEX_SHARPEN\fP
$\f3\%PFTEX_SHARPEN_ALPHA\fP

\f3\%PFTEX_MAGFILTER_COLOR\fP$\f3\%PFTEX_DETAIL\fP
$\f3\%PFTEX_MODULATE\fP
$\f3\%PFTEX_ADD\fP
$\f3\%PFTEX_DETAIL_COLOR\fP
$\f3\%PFTEX_SHARPEN_COLOR\fP
$\f3\%PFTEX_SHARPEN\fP
.TE

For convenience, there are compound tokens that include the most of
usual filter combinations:

.RS
\f3\%PFTEX_MIPMAP_POINT\fP
.br
\f3\%PFTEX_MIPMAP_LINEAR\fP
.br
\f3\%PFTEX_MIPMAP_BILINEAR\fP
.br
\f3\%PFTEX_MIPMAP_TRILINEAR\fP
.br
\f3\%PFTEX_MIPMAP_QUADLINEAR\fP
.br
\f3\%PFTEX_MAGFILTER_COLOR\fP
.br
\f3\%PFTEX_MAGFILTER_ALPHA\fP
.br
\f3\%PFTEX_SHARPEN_COLOR\fP
.br
\f3\%PFTEX_SHARPEN_ALPHA\fP
.br
\f3\%PFTEX_DETAIL_COLOR\fP
.br
\f3\%PFTEX_DETAIL_ALPHA\fP
.br
\f3\%PFTEX_DETAIL_LINEAR\fP
.br
\f3\%PFTEX_MODULATE_DETAIL\fP
.br
\f3\%PFTEX_ADD_DETAIL\fP
.br
\f3\%PFTEX_BICUBIC_LEQUAL\fP
.br
\f3\%PFTEX_BICUBIC_GEQUAL\fP
.br
\f3\%PFTEX_BICUBIC_LEQUAL\fP
.br
\f3\%PFTEX_BICUBIC_GEQUAL\fP
.br
\f3\%PFTEX_BILINEAR_LEQUAL\fP
.br
\f3\%PFTEX_BILINEAR_GEQUAL\fP
.RE

If the desired filter requires support that is not present on
the current graphics platform, that part of the specified filter
will be ignored.
See the OpenGL \f3\%glTexImage(3g)\fP mans page for
descriptions of texture filter types.  The default filter types are:
magfilter = \f3\%PFTEX_BILINEAR\fP, minfilter = \f3\%PFTEX_MIPMAP_TRILINEAR\fP
for both InfiniteReality and Reality Engine, and \f3\%PFTEX_MIPMAP_LINEAR\fP otherwise.
\f3\%pfGetTexFilter\fP returns the filter type of \f2filter\fP.

\f3\%pfTexAnisotropy\fP sets an anisotropic
filter to be used by \f2tex\fP.
The \f2degree\fP argument is the degree of anisotropy to be applied.
\f3\%pfGetTexAnisotropy\fP will return the degree
of anisotropy set by \f3\%pfTexAnisotropy\fP.
The default degree of anisotropy is 1 which is the same as the default
isotropic filter.  A value of 2 will apply a 2:1 anisotropic filter.
The maximum degree of anisotopy can be queried with \f3\%pfQuerySys()\fP.
Anisotropic filtering is supported on OpenGL implementations that support
the GL_EXT_texture_filter_anisotropic extension.  \f3\%pfQueryFeature()\fP
can be used to determine if anisotropic filtering is supported on the current
platform.  If the environment variable PF_MAX_ANISOTROPY is set, then an
anisotropic filter of the value specified by PF_MAX_ANISOTROPY will be applied
to pfTextures that do not set the degree of anisotropy.

Textures are permitted to have explicit borders.
By default, these borders are not enabled.
Texture borders can be enabled by setting a texture border type with
\f3\%pfTexBorderType\fP where \f2type\fP
is one of the following tokens:
\f3\%PFTEX_BORDER_NONE\fP, \f3\%PFTEX_BORDER_COLOR\fP, or \f3\%PFTEX_BORDER_TEXELS\fP.
The default texture border type is \f3\%PFTEX_BORDER_NONE\fP.
If \f3\%PFTEX_BORDER_COLOR\fP is specified, the corresponding
texture border color may be set with
\f3\%pfTexBorderColor\fP.
The default texture border color is black.
If \f3\%PFTEX_BORDER_TEXELS\fP borders are enabled on a pfTexture,
it is assumed that the corresponding
image for that pfTexture includes the border texels and the corresponding
size of the pfTexture also includes the border texels.
\f3\%pfGetTexBorderType\fP will return
the texture border type and
\f3\%pfGetTexBorderColor\fP will
return the texture border color.
If the current graphics hardware configuration does not support
the selected border type, it will be ignored.
Texel borders are only available in OpenGL operation.
Texture borders should be used only when there is strong motivation
and with extreme caution.
Texel borders can add considerable texture storage requirements
to the pfTexture and cause subsequent performance degradations.

\f3\%pfTexDetail\fP sets \f2detail\fP as the detail texture of \f2tex\fP or
disables detailing of \f2tex\fP if \f2detail\fP is \f3\%NULL\fP. The
level of magnification between the base texture and detail texture
is a non-positive number specified by \f2level\fP and may be \f3\%PFTEX_DEFAULT\fP.
The detail texture is replicated as necessary to create a resulting texture
that is 2^\f3\%level\fP times the size of the base (level 0) texture.
The default tex level is four which creates a 16:1 mapping from detail texels
to base texels.
\f3\%pfTexDetail\fP will also set the magnification filter of \f2tex\fP to
\f3\%PFTEX_MODULATE_DETAIL\fP or \f3\%PFTEX_BILINEAR\fP if detailing is enabled
or disabled respectively.
See the OpenGL \f3\%glDetailTexFuncSGIS\fP
man page for a description of detail texture filters and splines.
For use with OpenGL, the OpenGL \f3\%GL_SGIS_detail_texture\fP extension
is required.
Once a texture has been specified to be a detail texture, it can no longer
be used as a base texture.  Calling \f3\%pfApplyTex\fP on a detail texture will
bind the texture to the detail target, not the base target.
Please also see the additional notes on using detail textures below.

\f3\%pfGetTexDetail\fP returns the detail texture of \f2tex\fP in \f2detail\fP or
\f3\%NULL\fP if the texture is not detailed, and the
detail texture level in \f2level\fP.
The level of magnification at which detail is actually applied is controlled by
\f3\%pfTexSpline\fP.
\f3\%pfGetTexDetailTex\fP returns the
detail texture of \f2tex\fP, or \f3\%NULL\fP if the texture is not detailed.

\f3\%pfTexLevel\fP sets a  minification or magnification texture \f2ltex\fP
for the level \f2level\fP for the base texture \f2tex\fP.  If
\f2level\fP is positive, it is taken to be a minification level and
\f2ltex\fP is made the \f2level\fPth MIPmap level for the base texture.  If
\f2level\fP is zero or negative, \f2ltex\fP is taken to be a detail texture whose
corresponding magnification level will be -\f2level\fP. \f3\%pfGetTexLevel\fP
will return the texture for the specified \f2level\fP.

\f3\%pfTexLODRange\fP sets directly on the
current texture the range of levels of detail to be accessible.
This has the same basic functionality as the same control on the pfTexLOD
attribute (see the \f3\%pfTexLOD\fP man page for more information).
The state enable for TEXLOD (\f3\%PFSTATE_ENTEXLOD\fP on a pfGeoState or
\f3\%pfEnable(PFEN_TEXLOD)\fP)
is ignored for an LOD range set on a pfTexture.
A range set on a pfTexture will take priority over a currently applied
pfTexLOD attribute unless \f3\%pfOverride\fP has been set for \f3\%PFSTATE_TEXLOD\fP.
To completely unset the LOD range on a pfTexture, set the min and max values
both to \f3\%PFTEX_DEFAULT\fP.
\f3\%pfGetTexLODRange\fP will return the
texture LOD range set on the pfTexture.  If the range are unset
the value \f3\%PFTEX_DEFAULT\fP will be returned in \f2min\fP and \f2max\fP.
\f3\%pfGetCurTexLODRange\fP will return the current
effective LOD range being applied to the given pfTexture and considers values
inherited from the current global state.  If the values are completely unset,
GL defaults will be returned.
NULL arguments to \f3\%pfGetTexLODRange\fP
and \f3\%pfGetCurTexLODRange\fP
are legal (they are ignored).

\f3\%pfTexLODBias\fP sets directly on the
current texture bias parameters to be used in the texture level of detail
computation.
This has the same basic functionality as the same control on the pfTexLOD
attribute (see the \f3\%pfTexLOD\fP man page for more information).
The state enable for TEXLOD (\f3\%PFSTATE_ENTEXLOD\fP on a pfGeoState or
\f3\%pfEnable(PFEN_TEXLOD)\fP)
is ignored for an LOD bias set on a pfTexture.
A bias setting on a pfTexture will take priority over a currently applied
pfTexLOD attribute unless \f3\%pfOverride\fP has been set for \f3\%PFSTATE_TEXLOD\fP.
To completely unset the LOD range on a pfTexture, set the bias values
both to \f3\%PFTEX_DEFAULT\fP.
\f3\%pfGetTexLODBias\fP will return the
texture LOD bias values.
If the bias values are unset, \f3\%PFTEX_DEFAULT\fP will be returned in the
bias values.
\f3\%pfGetCurTexLODBias\fP will return the current
effective LOD bias being applied to the given pfTexture and considers values
inherited from the current global state.  If the values are completely unset,
GL defaults will be returned.
NULL arguments to \f3\%pfGetTexLODBias\fP
and \f3\%pfGetCurTexLODBias\fP
are legal (they are ignored).

\f3\%pfTexSpline\fP sets the parameters of a cubic interpolating spline
used in certain magnification filters.  \f2type\fP is a symbolic token
specifying a particular filter spline and is either
\f3\%PFTEX_SHARPEN_SPLINE\fP or \f3\%PFTEX_DETAIL_SPLINE\fP which correspond to
magfilters for sharpen (\f3\%PFTEX_SHARPEN\fP) and detail texture
(\f3\%PFTEX_MODULATE_DETAIL\fP or \f3\%PFTEX_ADD_DETAIL\fP) respectively.
\f2pts\fP is an array of pfVec2 of length 4 which specifies the control
points of the filter spline.  A control point is of the form (-LOD,
scale).  The specified LOD is negative since it indicates a
magnification LOD.  The spline is clamped to \f2clamp\fP.  If \f2clamp\fP
is \f3\%PFTEX_DEFAULT\fP, the spline will be automatically clamped to its
maximum value.  If \f2clamp\fP is zero, no clamping will be done.  See
the notes below on compatibility of texture splines with previous
versions of OpenGL Performer.  See the
OpenGL \f3\%glDetailTexFuncSGIS\fP and \f3\%glSharpenTexFuncSGIS\fP man pages
for a description of filter splines.  \f3\%pfGetTexSpline\fP copies the
spline parameters of the filter designated by \f2type\fP into \f2pts\fP and
\f2clamp\fP.
Please also see the additional notes on using detail textures below.

\f3\%pfTexList\fP sets a pfList of pfTexture*, \f2list\fP, on the pfTexture,
\f2tex\fP.  \f3\%pfGetTexList\fP returns the texture list.  \f3\%pfTexFrame\fP
selects a frame from the texture list of \f2tex\fP upon \f3\%pfApplyTex\fP.
The default frame value is (-1) which selects the base texture.
\f3\%pfGetTexFrame\fP returns the current pfTexture frame.  \f3\%pfTexList\fP
and \f3\%pfTexFrame\fP together provide a mechanism for doing texture
animations or managing multiple textures on geometry.  The base
pfTexture is applied to the geometry, but different pfTextures from the
set in the list are selected based on the frame value in the base
texture. The \f3\%PFTEX_LOAD_LIST\fP mode to \f3\%pfTexLoadMode\fP controls how
textures replace previous texture from the same list for efficient
hardware texture memory management.

\f3\%pfFormatTex\fP creates a GL/hardware ready texture for the specified
pfTexture, \f2tex\fP.  All pfTexture parameters are take into account.
Changing any parameter on a pfTexture will cause it to need to be
re-formatted.  \f3\%pfIsTexFormatted\fP will return the formatted state of
the texture.  \f3\%pfGetGLHandle\fP will return the handle to the resulting
GL texture, valid only for the current GL context.

\f3\%pfLoadTex\fP downloads the specified texture source to graphics
hardware texture memory allocated to \f2tex\fP.
Repeated calls to \f3\%pfLoadTex\fP will reload
the image specified by
\f3\%pfTexLoadImage\fP or else the main texture image set by
\f3\%pfTexImage\fP or
\f3\%pfLoadTexFile\fP
down into the graphics subsystem, allowing the contents of the
texture image to be changed dynamically.  If a reformatting of the
texture is required, \f3\%pfFormatTex\fP will be called automatically.
If the texture is of format \f3\%PFTEX_SUBLOAD_FORMAT\fP and the current graphics hardware
configuration supports texture subloading, then the origin and size specified with
\f3\%pfTexLoadOrigin\fP and
\f3\%pfTexLoadSize\fP will be used.
\f3\%pfIsTexLoaded\fP will return
whether or not the specified pfTexture is currently resident in
hardware texture memory.  However, \f3\%pfIsTexLoaded\fP will not reflect
whether or not additional changes made to the contents of the texture
image have been downloaded.

\f3\%pfLoadTexLevel\fP will load a specific level of the
pfTexture and is available in OpenGL only.
The \f2level\fP may be a non-zero positive number to refer to a minification level,
or may be \f3\%PFTEX_LEVEL_BASE\fP to refer to the base texture level,
\f3\%PFTEX_LEVEL_ALL\fP to refer to all levels, or may be a
non-positive number to refer to a detail level.
\f3\%pfLoadTex\fP and
\f3\%pfLoadTexLevel\fP change
the current pfTexture to be undefined.

\f3\%pfSubloadTex\fP downloads a specified texture source to graphics
hardware memory allocated to \f2tex\fP
according to the specified source, image, origin, width of complete image, destination, and subload size,  which
may be different than the load parameters in \f2tex\fP.
The width of the source images is specified in \f2srcwidth\fP and may be
(-1) to refer to the width of the base texture.  \f2srcwidth\fP is used for
the tiling of image textures when the source x origin is greater than 0.
This routine will not change any of these load parameters for future texture loads.
If the current graphics hardware configuration cannot support texture subloading,
this command will have no effect.
\f3\%pfSubloadTexLevel\fP will load a specific level of the
pfTexture and is available in OpenGL only.
The \f2level\fP may be a non-zero positive number to refer to a minification level,
or may be \f3\%PFTEX_LEVEL_BASE\fP to refer to the base texture level,
\f3\%PFTEX_LEVEL_ALL\fP to refer to all levels, or may be a
non-positive number to refer to a detail level.
\f3\%pfSubloadTex\fP and
\f3\%pfSubloadTexLevel\fP
change the current pfTexture to be undefined.

\f3\%pfTexLoadImage\fP can be used
to update a location for texels to be downloaded from without
causing a reformatting of the pfTexture and without loosing the
main image pointer on the pfTexture.  This specified \f2image\fP pointer
will then be used for texture downloads triggered by
\f3\%pfApplyTex\fP and
\f3\%pfLoadTex\fP.
If \f2image\fP is NULL, then texture downloads will go back to using the
main image pointer on the pfTexture, set through
\f3\%pfTexImage\fP or
\f3\%pfLoadTexFile\fP.
\f3\%pfGetTexLoadImage\fP
will return the previously set load image of \f2tex\fP.

Portions of a texture images may be updated by specifying a
\f3\%pfTexLoadOrigin\fP
and \f3\%pfTexLoadSize\fP.
\f3\%pfTexLoadOrigin\fP
sets the origin of the
texture image source or destination, according to \f2which\fP.
\f3\%pfTexLoadSize\fP sets the texture area size,
in texels, that is to be downloaded.  These settings will affect future
texture loads that are triggered by
\f3\%pfApplyTex\fP and
\f3\%pfLoadTex\fP.
\f3\%pfGetTexLoadSize\fP will return the
previously set load size of \f2tex\fP.
\f3\%pfGetTexLoadOrigin\fP will return the
source or destination load origin, as specified by \f2which\fP
of \f2tex\fP.
The x or y argument to
\f3\%pfGetTexLoadSize\fP
\f3\%pfGetTexLoadOrigin\fP
may be NULL, in which case it is ignored.

\f3\%pfTexLoadMode\fP sets parameters that configure texture downloading,
specified by \f2mode\fP to \f2val\fP.  \f2mode\fP may be one of
\f3\%PFTEX_LOAD_SOURCE\fP, \f3\%PFTEX_LOAD_BASE\fP, or \f3\%PFTEX_LOAD_LIST\fP.
Values for the \f3\%PFTEX_LOAD_SOURCE\fP select the source for the texture
image data and may be one of \f3\%PFTEX_IMAGE\fP to select the image specified by
\f3\%pfTexImage\fP, \f3\%PFTEX_SOURCE_VIDEO\fP for video texture, or
\f3\%PFTEX_SOURCE_FRAMEBUFFER\fP.  The default texture load source is
\f3\%PFTEX_SOURCE_IMAGE\fP.
Texture sources of \f3\%PFTEX_SOURCE_VIDEO\fP and \f3\%PFTEX_SOURCE_FRAMEBUFFER\fP also
require the \f3\%PFTEX_SUBLOAD_FORMAT\fP and set it automatically.
The \f3\%PFTEX_LOAD_BASE\fP mode controls how base textures are loaded.
The default, \f3\%PFTEX_BASE_APPLY\fP will do a load of the specified
texture source when the texture is dirty upon a \f3\%pfApplyTex\fP of the
pfTexture. The \f3\%PFTEX_BASE_AUTO_SUBLOAD\fP will automatically
replace the texture from the specified texture source upon every
call to \f3\%pfApplyTex\fP.
The \f3\%PFTEX_LOAD_LIST\fP mode controls how textures
from the texture list are loaded. New selections from the texture list
may be loaded in the following ways: \f3\%PFTEX_LIST_APPLY\fP, the default,
will apply the selected pfTexture from the texture list;
\f3\%PFTEX_LIST_AUTO_IDLE\fP will idle the previous pfTexture selected from
the list so that its graphics texture memory will be freed.  If the
base texture is formatted with \f3\%PFTEX_SUBLOAD_FORMAT\fP,
\f3\%PFTEX_LIST_SUBLOAD\fP will replace the texture image of the base
texture with the texture image from the selected pfTexture of the
texture list. \f3\%PFTEX_LIST_AUTO_SUBLOAD\fP re-uses the hardware texture
memory of the base texture and so is the most efficient means of
sharing graphics memory amongst pfTextures.  However,
\f3\%PFTEX_LIST_SUBLOAD\fP is not available on all graphics platforms (see
notes below) and it requires that the pfTextures be identical in number
of components and formats. \f3\%PFTEX_LIST_AUTO_SUBLOAD\fP will obey the origin
and size set by \f3\%pfTexLoadOrigin\fP and \f3\%pfTexLoadSize\fP.
\f3\%pfGetTexLoadMode\fP will return
the value of \f2mode\fP for \f2tex\fP.

\f3\%pfApplyTex\fP makes \f2tex\fP the current texture.  When texturing is
enabled (see below), this texture will be applied to all geometry drawn
after \f3\%pfApplyTex\fP is called.  Only one pfTexture may be active at a
time although many may be defined.  If formatting or downloading of the
texture is required at the time of the call to \f3\%pfApplyTex\fP, \f3\%pfFormatTex\fP
and \f3\%pfLoadTex\fP will be called automatically.  Modifications to \f2tex\fP, such as
changing the filter type, will not have effect until
\f3\%pfApplyTex\fP is called with \f2tex\fP. \f3\%pfGetCurTex\fP returns the
currently active pfTexture.

\f3\%pfApplyTex\fP will automatically apply the detail texture associated
with \f2tex\fP and will disable detail texturing if \f2tex\fP has no
associated detail texture.

For geometry to be textured, the following must be true:
.RS
.TP 5
1.
Texturing must be enabled: \f3\%pfEnable\fP(\f3\%PFEN_TEXTURE\fP)
.TP
2.
A pfTexEnv must be applied: \f3\%pfApplyTEnv\fP
.TP
3.
A pfTexture must be applied: \f3\%pfApplyTex\fP
.TP
4.
Geometry must have texture coordinates: \f3\%pfGSetAttr\fP, \f3\%PFGS_TEXCOORD2\fP
.RE

The texture state element is identified by the
\f3\%PFSTATE_TEXTURE\fP token.  Use this token with \f3\%pfGStateAttr\fP to set
the texture of a pfGeoState and with
\f3\%pfOverride\fP to override subsequent texture changes:

Example 1:
.Ex
.nf

/* Apply texture environment to be used by textured geometry */
pfApplyTEnv(tev);

/* Set up textured pfGeoState */
pfGStateMode(gstate, PFSTATE_ENTEXTURE, PF_ON);
pfGStateAttr(gstate, PFSTATE_TEXTURE, tex);

/* Attach gstate to gset */
pfGSetGState(gset, gstate);

/* Set texture coordinate array. 'gset' is non-indexed */
pfGSetAttr(gset, PFGS_TEXCOORD2, PFGS_PER_VERTEX, tcoords,NULL);

/* Draw textured gset */
pfDrawGSet(gset);
.Ee
.fi
.na


Example 2:
.Ex
.nf

pfApplyTex(tex);

/* Override so that all textured geometry uses 'tex' */
pfOverride(PFSTATE_TEXTURE, PF_ON);
.Ee
.fi
.na


\f3\%pfGetCurTex\fP returns the current pfTexture or \f3\%NULL\fP if no
pfTexture is active.

\f3\%pfIdleTex\fP and
\f3\%pfIsTexLoaded\fP can help you efficiently manage hardware texture memory.
\f3\%pfIdleTex\fP signifies that \f2tex\fP is no longer needed in texture
memory and may be replaced by new textures.  \f3\%pfIsTexLoaded\fP returns
TRUE or FALSE depending on whether \f2tex\fP is already loaded in texture
memory or not.  With these two commands it is possible to implement a
rudimentary texture paging mechanism.

\f3\%pfApplyTex\fP and \f3\%pfIdleTex\fP are display-listable commands.  If a
pfDispList has been opened by \f3\%pfOpenDList\fP, \f3\%pfApplyTex\fP and
\f3\%pfIdleTex\fP will not have immediate effect but will be captured by
the pfDispList and will only have effect when that pfDispList is later
drawn with \f3\%pfDrawDList\fP.

\f3\%pfApplyTexMinLOD\fP
sets the minLOD value in the graphics context in a frame accurate
manner. The command passes its argument directly to the DRAW process by
storing the minLOD value in a display list. In the DRAW process, the
OpenGL context is directly set with the minLOD value; the minLOD value
in the parent pfTexture class is unaffected. This command is useful when
the minLOD value must be changed multiple times per frame during
scene graph traversal; for example, in scene graph callbacks supporting
virtual cliptexures.

\f3\%pfApplyTexMaxLOD\fP
sets the maxLOD value in the graphics context in a frame accurate
manner. The command passes its argument directly to the DRAW process by
storing the maxLOD value in a display list. In the DRAW process, the
OpenGL context is directly set with the maxLOD value; the maxLOD value
in the parent pfTexture class is unaffected. This command is useful when
the maxLOD value must be changed multiple times per frame during
scene graph traversal; for example, in scene graph callbacks supporting
virtual cliptexures.


\f3\%pfApplyTexLODBias\fP
sets the S, T and R bias values in the graphics context in a frame accurate
manner. The command passes its arguments directly to the DRAW process by
storing the bias values in a display list. In the DRAW process, the
OpenGL context is directly set with the bias values; the S, T, and R bias
values  in the parent pfTexture class are unaffected. This command is
useful when the bias values must be changed multiple times per frame during
scene graph traversal; for example, in scene graph callbacks supporting
virtual cliptexures.

\f3\%pfApplyTMat\fP will apply the pfMatrix \f2mat\fP to the global state
and the current GL texture matrix to transform texture coordinates.
The GL matrix mode will be left in model view mode.

.SH NOTES

Since textures are an expensive hardware resource, the sharing of
textures is highly recommended.  For best performance on machines which
support hardware texturing, all textures should fit in hardware texture
memory.  Otherwise, the GL must page textures from main memory into the
graphics pipeline with a corresponding performance hit. For best
performance and use of memory:

.RS
Use the \f3\%PFTEX_INTERNAL_FORMATS\fP that have 16bit texels.

Keep textures of size an even power of two since they are always
rounded up to the next power of two for storage in hardware texture
memory in OpenGL will simply fail to work if they
do not have sizes that are a power of two.

Share pfTextures between pfGeoStates and share pfGeoStates between
pfGeoSets whenever possible.

Minimize the number of distinct detail and sharpen splines.

Check the graphics state statistics (see the \f3\%pfStats\fP man page) to
see if hardware texture memory is being swapped.  As an additional
diagnostic,  \f3\%pfIsTexLoaded\fP can be used
in a pfGeoState callback before applying a pfTexture to see if a load
or swap will be required.
.RE
For OpenGL operation, detail texturing requires the
\f3\%GL_SGIS_detail_texture\fP OpenGL extension and the sharpen filter
requires the \f3\%GL_SGIS_sharpen_texture\fP extension.
\f3\%pfIsTexLoaded\fP requires the
\f3\%EXT_texture_object\fP OpenGL extension.  See the
\f3\%EXT_texture_object\fP section of the OpenGL \f3\%glIntro(3g)\fP man
page for more information.

A texture source of \f3\%PFTEX_VIDEO\fP is supported only on
InfiniteReality and RealityEngine graphics systems.

.SH BUGS

MIPmap levels cannot be loaded or subloaded unless the have been
explicitly defined with \f3\%pfTexLevel\fP.

For \f3\%PFTEX_SOURCE_VIDEO\fP textures under OpenGL operation, the GL
read source will need to be reset whenever the current GL window is changed.
Additionally, Libpf applications will need to reset their GL read source
(\f3\%glXMakeCurrentReadSGI\fP) every frame in the drawing process.

.SH SEE ALSO
pfDelete,
pfDispList,
pfEnable,
pfFilePath,
pfGeoState,
pfGetGLHandle,
pfMalloc,
pfObject,
pfOverride,
pfState,
pfStats,
pfTexEnv,
pfTexLOD,
tevbind,
tevdef,
texbind,
texdef,
glTexImage,
glDetailTexFuncSGIS,
glSharpenTexFuncSGIS,
glXMakeCurrentReadSGI
