'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVec3" "3pf"
.SH NAME
.upperok
.B pfAddScaledVec3,
.B pfAddVec3,
.B pfEqualVec3,
.B pfAlmostEqualVec3,
.B pfCombineVec3,
.B pfCopyVec3,
.B pfCrossVec3,
.B pfDistancePt3,
.B pfDotVec3,
.B pfLengthVec3,
.B pfNegateVec3,
.B pfNormalizeVec3,
.B pfScaleVec3,
.B pfSetVec3,
.B pfSqrDistancePt3,
.B pfSubVec3,
.B pfXformVec3,
.B pfXformPt3,
.B pfFullXformPt3
\- 
Set and operate on 3-component vectors
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'float\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
#include <Performer/prmath.h>
.nf
.fi
.TP
void
\f3\%pfAddScaledVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
float\ s,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAddVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfEqualVec3\fP(const\ pfVec3\ v1,
'in +2
'll -2
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfAlmostEqualVec3\fP(const\ pfVec3\ v1,
'in +2
'll -2
const\ pfVec3\ v2,
float\ tol);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCombineVec3\fP(pfVec3\ dst,
'in +2
'll -2
float\ s1,
const\ pfVec3\ v1,
float\ s2,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCopyVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCrossVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfDistancePt3\fP(const\ pfVec3\ pt1,
'in +2
'll -2
const\ pfVec3\ pt2);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfDotVec3\fP(const\ pfVec3\ v1,
'in +2
'll -2
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfLengthVec3\fP(const\ pfVec3\ v);
.nf
.fi
.TP
void
\f3\%pfNegateVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfNormalizeVec3\fP(pfVec3\ v);
.nf
.fi
.TP
void
\f3\%pfScaleVec3\fP(pfVec3\ dst,
'in +2
'll -2
float\ s,
const\ pfVec3\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSetVec3\fP(pfVec3\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfSqrDistancePt3\fP(const\ pfVec3\ pt1,
'in +2
'll -2
const\ pfVec3\ pt2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSubVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfXformVec3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v,
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfXformPt3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v,
const\ pfMatrix\ m);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfFullXformPt3\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v,
const\ pfMatrix\ m);
.in
.ll
.fi

.Ex
.nf

typedef float pfVec3[3];
.Ee
.fi
.na

.SH DESCRIPTION

Math functions for 3-component vectors.  Most of these routines have
macro equivalents.


\f3\%pfSetVec3\fP(dst, x, y, z): \f2dst\fP[0] = \f2x\fP, \f2dst\fP[1] = \f2y\fP,
\f2dst\fP[2] = \f2z\fP.  Macro equivalent is  \f3\%PFSET_VEC3\fP.

\f3\%pfCopyVec3\fP(dst, v): \f2dst\fP = \f2v\fP.
Macro equivalent is  \f3\%PFCOPY_VEC3\fP.

\f3\%pfNegateVec3\fP(dst, v): \f2dst\fP = -\f2v\fP.
Macro equivalent is  \f3\%PFNEGATE_VEC3\fP.

\f3\%pfAddVec3\fP(dst, v1, v2): \f2dst\fP = \f2v1\fP + \f2v2\fP.  Sets \f2dst\fP
to the sum of vectors \f2v1\fP and \f2v2\fP.  Macro equivalent is \f3\%PFADD_VEC3\fP.

\f3\%pfSubVec3\fP(dst, v1, v2): \f2dst\fP = \f2v1\fP - \f2v2\fP.  Sets \f2dst\fP to
the difference of \f2v1\fP and \f2v2\fP.  Macro equivalent is  \f3\%PFSUB_VEC3\fP.

\f3\%pfScaleVec3\fP(dst, s, v): \f2dst\fP = \f2s\fP * \f2v1\fP.  Sets \f2dst\fP to
the vector \f2v\fP scaled by \f2s\fP.  Macro equivalent is  \f3\%PFSCALE_VEC3\fP.

\f3\%pfAddScaledVec3\fP(dst, v1, s, v2): \f2dst\fP = \f2v1\fP + \f2s\fP *
\f2v2\fP.  Sets \f2dst\fP to the vector \f2v1\fP plus the vector \f2v2\fP
scaled by \f2s\fP.  Macro equivalent is  \f3\%PFADD_SCALED_VEC3\fP.

\f3\%pfCombineVec3\fP(dst, s1, v1, s2, v2): \f2dst\fP = \f2s1\fP * \f2v1\fP +
\f2s2\fP * \f2v2\fP.  Sets \f2dst\fP to be the linear combination of \f2v1\fP
and \f2v2\fP with scales \f2s1\fP and \f2s2\fP, respectively.  Macro
equivalent: \f3\%PFCOMBINE_VEC3\fP.

\f3\%pfNormalizeVec3\fP(v): \f2v\fP = \f2v\fP / length(\f2v\fP).  Normalizes the
vector \f2v\fP to have unit length and returns the original length of the
vector.

\f3\%pfCrossVec3\fP(dst, v1, v2): \f2dst\fP = \f2v1\fP X \f2v2\fP.  Sets \f2dst\fP
to the cross-product of two vectors \f2v1\fP and \f2v2\fP.

\f3\%pfXformVec3\fP(dst, v, m): \f2dst\fP = \f2v4\fP * \f2m\fP (\f2v4\fP[i]=\f2v[i]\fP
i=0, 1, 2; \f2v4\fP[3] = 0).  Transforms \f2v\fP as a vector by the matrix
\f2m\fP.

\f3\%pfXformPt3\fP(dst, v, m): \f2dst\fP = \f2v4\fP * \f2m\fP (\f2v4\fP[i]=\f2v[i]\fP
i=0, 1, 2; \f2v4\fP[3] = 1).  Transforms \f2v\fP as a point by the matrix
\f2m\fP using the 4X3 submatrix.

\f3\%pfFullXformPt3\fP(dst, v, m): \f2dst\fP = \f2v4\fP * \f2m\fP
(\f2v4\fP[i]=\f2v[i]\fP i=0, 1, 2; \f2v4\fP[3] = 1).  Transforms \f2v\fP as a
point by the matrix \f2m\fP using the full 4X4 matrix and scaling
\f2dst\fP by the resulting w coordinate.

\f3\%pfDotVec3\fP(v1, v2) = \f2v1\fP dot \f2v2\fP = \f2v1\fP[0] * \f2v2\fP[0] +
\f2v1\fP[1] * \f2v2\fP[1] + \f2v1\fP[2] * \f2v2\fP[2].  Returns dot product of
the vectors \f2v1\fP and \f2v2\fP.  Macro equivalent is  \f3\%PFDOT_VEC3\fP.

\f3\%pfLengthVec3\fP(v) = |v| = sqrt(\f2v\fP dot \f2v\fP).  Returns length of
the vector \f2v\fP.  Macro equivalent is  \f3\%PFLENGTH_VEC3\fP.

\f3\%pfSqrDistancePt3\fP(v1, v2) = (\f2v1\fP - \f2v2\fP) dot (\f2v1\fP - \f2v2\fP).
Returns square of distance between two points \f2v1\fP and \f2v2\fP.  Macro
equivalent is \f3\%PFSQR_DISTANCE_PT3\fP.

\f3\%pfDistancePt3\fP(v1, v2) = sqrt((\f2v1\fP - \f2v2\fP) dot (\f2v1\fP -
\f2v2\fP)).  Returns distance between two points \f2v1\fP and \f2v2\fP.
Macro equivalent is  \f3\%PFDISTANCE_PT3\fP.

\f3\%pfEqualVec3\fP(v1, v2) = (\f2v1\fP == \f2v2\fP).  Tests for strict component-wise
equality of two vectors \f2v1\fP and \f2v2\fP and returns FALSE or TRUE.
Macro equivalent is  \f3\%PFEQUAL_VEC3\fP.

\f3\%pfAlmostEqualVec3\fP(v1, v2, tol).  Tests for approximate
component-wise equality of two vectors \f2v1\fP and \f2v2\fP.  It returns
FALSE or TRUE depending on whether the absolute value of the
difference between each pair of components is less than the tolerance
\f2tol\fP.  Macro equivalent is  \f3\%PFALMOST_EQUAL_VEC3\fP.

Routines can accept the same vector as source, destination, or as a
repeated operand.


.SH SEE ALSO
pfMatrix,
pfVec2,
pfVec4
