'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfVec4" "3pf"
.SH NAME
.upperok
.B pfAddScaledVec4,
.B pfAddVec4,
.B pfAlmostEqualVec4,
.B pfCombineVec4,
.B pfCopyVec4,
.B pfDistancePt4,
.B pfDotVec4,
.B pfEqualVec4,
.B pfLengthVec4,
.B pfNegateVec4,
.B pfNormalizeVec4,
.B pfScaleVec4,
.B pfSetVec4,
.B pfSqrDistancePt4,
.B pfSubVec4,
.B pfXformVec4
\- 
Set and operate on 4-component vectors
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'float\ \ \ 'u
#include <Performer/pr.h>
.nf
.fi
.TP
#include <Performer/prmath.h>
.nf
.fi
.TP
void
\f3\%pfAddScaledVec4\fP(pfVec3\ dst,
'in +2
'll -2
const\ pfVec3\ v1,
float\ s,
const\ pfVec3\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfAddVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v1,
const\ pfVec4\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfAlmostEqualVec4\fP(pfVec4\ v1,
'in +2
'll -2
const\ pfVec4\ v2,
float\ tol);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCombineVec4\fP(pfVec4\ dst,
'in +2
'll -2
float\ s1,
const\ pfVec4\ v1,
float\ s2,
const\ pfVec4\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfCopyVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfDistancePt4\fP(const\ pfVec4\ pt1,
'in +2
'll -2
const\ pfVec4\ pt2);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfDotVec4\fP(const\ pfVec4\ v1,
'in +2
'll -2
const\ pfVec4\ v2);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfEqualVec4\fP(const\ pfVec4\ v1,
'in +2
'll -2
const\ pfVec4\ v2);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfLengthVec4\fP(const\ pfVec4\ v);
.nf
.fi
.TP
void
\f3\%pfNegateVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfNormalizeVec4\fP(pfVec4\ v);
.nf
.fi
.TP
void
\f3\%pfScaleVec4\fP(pfVec4\ dst,
'in +2
'll -2
float\ s,
const\ pfVec4\ v);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSetVec4\fP(pfVec4\ dst,
'in +2
'll -2
float\ x,
float\ y,
float\ z,
float\ w);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfSqrDistancePt4\fP(const\ pfVec4\ pt1,
'in +2
'll -2
const\ pfVec4\ pt2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfSubVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v1,
const\ pfVec4\ v2);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfXformVec4\fP(pfVec4\ dst,
'in +2
'll -2
const\ pfVec4\ v,
const\ pfMatrix\ m);
.in
.ll
.fi

.Ex
.nf

typedef float pfVec4[4];
.Ee
.fi
.na

.SH DESCRIPTION

Math functions for 4-component vectors.


\f3\%pfSetVec4\fP(dst, x, y, z, w): \f2dst\fP[0] = \f2x\fP, \f2dst\fP[1] = \f2y\fP,
\f2dst\fP[2] = \f2z\fP, \f2dst\fP[3] = \f2w\fP .  Macro equivalent is
\f3\%PFSET_VEC4\fP.

\f3\%pfCopyVec4\fP(dst, v): \f2dst\fP = \f2v\fP.  Macro equivalent is
\f3\%PFCOPY_VEC4\fP.

\f3\%pfNegateVec4\fP(dst, v): \f2dst\fP = -\f2v\fP.  Macro equivalent is
\f3\%PFNEGATE_VEC4\fP.

\f3\%pfAddVec4\fP(dst, v1, v2): \f2dst\fP = \f2v1\fP + \f2v2\fP.  Sets \f2dst\fP to
the sum of vectors \f2v1\fP and \f2v2\fP.  Macro equivalent is \f3\%PFADD_VEC4\fP.

\f3\%pfSubVec4\fP(dst, v1, v2): \f2dst\fP = \f2v1\fP - \f2v2\fP.  Sets \f2dst\fP to
the difference of \f2v1\fP and \f2v2\fP.  Macro equivalent is
\f3\%PFSUB_VEC4\fP.

\f3\%pfScaleVec4\fP(dst, s, v): \f2dst\fP = \f2s\fP * \f2v1\fP.  Sets \f2dst\fP to
the vector \f2v\fP scaled by \f2s\fP.  Macro equivalent is \f3\%PFSCALE_VEC4\fP.

\f3\%pfAddScaledVec4\fP(dst, v1, s, v2): \f2dst\fP = \f2v1\fP + \f2s\fP *
\f2v2\fP.  Sets \f2dst\fP to the vector \f2v1\fP plus the vector \f2v2\fP
scaled by \f2s\fP.  Macro equivalent is \f3\%PFADD_SCALED_VEC4\fP.

\f3\%pfCombineVec4\fP(dst, s1, v1, s2, v2): \f2dst\fP = \f2s1\fP * \f2v1\fP +
\f2s2\fP * \f2v2\fP.  Sets \f2dst\fP to be the linear combination of \f2v1\fP
and \f2v2\fP with scales \f2s1\fP and \f2s2\fP, respectively.  Macro
equivalent is \f3\%PFCOMBINE_VEC4\fP.

\f3\%pfNormalizeVec4\fP(v):  \f2v\fP = \f2v\fP / length(\f2v\fP).  Normalizes the
vector \f2v\fP to have unit length and returns the original length of the
vector.

\f3\%pfXformVec4\fP(dst, v, m): \f2dst\fP = \f2v\fP * \f2m\fP.  Transforms \f2v\fP
by the matrix \f2m\fP.

\f3\%pfDotVec4\fP(v1, v2) = \f2v1\fP dot \f2v2\fP = \f2v1\fP[0] * \f2v2\fP[0] +
\f2v1\fP[1] * \f2v2\fP[1] + \f2v1\fP[2] * \f2v2\fP[2] + \f2v1\fP[3] * \f2v2\fP[3].
Returns dot product of the vectors \f2v1\fP and \f2v2\fP.  Macro
equivalent is \f3\%PFDOT_VEC4\fP.

\f3\%pfLengthVec4\fP(v) = |v| = sqrt(\f2v\fP dot \f2v\fP).  Returns length of
the vector \f2v\fP.  Macro equivalent is \f3\%PFLENGTH_VEC4\fP.

\f3\%pfSqrDistancePt4\fP(v1, v2) = (\f2v1\fP - \f2v2\fP) dot (\f2v1\fP -
\f2v2\fP).  Returns square of distance between two points \f2v1\fP and
\f2v2\fP.  Macro equivalent is \f3\%PFSQR_DISTANCE_PT4\fP.

\f3\%pfDistancePt4\fP(v1, v2) = sqrt((\f2v1\fP - \f2v2\fP) dot (\f2v1\fP -
\f2v2\fP)).  Returns distance between two points \f2v1\fP and \f2v2\fP.
Macro equivalent is \f3\%PFDISTANCE_PT4\fP.

\f3\%pfEqualVec4\fP(v1, v2) = (\f2v1\fP == \f2v2\fP).  Tests for strict
component-wise equality of two vectors \f2v1\fP and \f2v2\fP and returns
FALSE or TRUE.  Macro equivalent is \f3\%PFEQUAL_VEC4\fP.

\f3\%pfAlmostEqualVec4\fP(v1, v2, tol).  Tests for approximate
component-wise equality of two vectors \f2v1\fP and \f2v2\fP.  It returns
FALSE or TRUE depending on whether the absolute value of the difference
between each pair of components is less than the tolerance \f2tol\fP.
Macro equivalent is \f3\%PFALMOST_EQUAL_VEC4\fP.

Routines can accept the same vector as source, destination, or as a
repeated operand.

.SH SEE ALSO
pfMatrix,
pfVec2,
pfVec3
