'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiCollide" "3pf"
.SH NAME
.upperok
.B pfiGetCollideClassType,
.B pfiNewCollide,
.B pfiEnableCollide,
.B pfiDisableCollide,
.B pfiGetCollideEnable,
.B pfiCollideMode,
.B pfiGetCollideMode,
.B pfiCollideStatus,
.B pfiGetCollideStatus,
.B pfiCollideDist,
.B pfiGetCollideDist,
.B pfiCollideHeightAboveGrnd,
.B pfiGetCollideHeightAboveGrnd,
.B pfiCollideGroundNode,
.B pfiGetCollideGroundNode,
.B pfiCollideObjNode,
.B pfiGetCollideObjNode,
.B pfiCollideCurMotionParams,
.B pfiGetCollideCurMotionParams,
.B pfiGetCollideMotionCoord,
.B pfiCollideFunc,
.B pfiGetCollisionFunc,
.B pfiUpdateCollide
\- 
pfiCollide functions.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiCollide\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfType *
\f3\%pfiGetCollideClassType\fP(void);
.nf
.fi
.TP
pfiCollide *
\f3\%pfiNewCollide\fP(void\ *arena);
.nf
.fi
.TP
void
\f3\%pfiEnableCollide\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiDisableCollide\fP(pfiCollide\ *collide);
.nf
.fi
.TP
int
\f3\%pfiGetCollideEnable\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiCollideMode\fP(pfiCollide\ *collide,
'in +2
'll -2
int\ mode,
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetCollideMode\fP(pfiCollide\ *collide,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiCollideStatus\fP(pfiCollide\ *collide,
'in +2
'll -2
int\ status);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetCollideStatus\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiCollideDist\fP(pfiCollide\ *collide,
'in +2
'll -2
float\ dist);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfiGetCollideDist\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiCollideHeightAboveGrnd\fP(pfiCollide\ *collide,
'in +2
'll -2
float\ dist);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfiGetCollideHeightAboveGrnd\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiCollideGroundNode\fP(pfiCollide\ *collide,
'in +2
'll -2
pfNode*\ ground);
.in
.ll
.nf
.fi
.TP
pfNode *
\f3\%pfiGetCollideGroundNode\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiCollideObjNode\fP(pfiCollide\ *collide,
'in +2
'll -2
pfNode*\ db);
.in
.ll
.nf
.fi
.TP
pfNode *
\f3\%pfiGetCollideObjNode\fP(pfiCollide\ *collide);
.nf
.fi
.TP
void
\f3\%pfiCollideCurMotionParams\fP(pfiCollide\ *collide,
'in +2
'll -2
pfCoord*\ pos,
pfCoord*\ prevPos,
float\ speed);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetCollideCurMotionParams\fP(pfiCollide\ *collide,
'in +2
'll -2
pfCoord*\ pos,
pfCoord*\ prevPos,
float\ *speed);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetCollideMotionCoord\fP(pfiCollide\ *collide,
'in +2
'll -2
pfiMotionCoord*\ xcoord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiCollideFunc\fP(pfiCollide\ *collide,
'in +2
'll -2
pfiCollideFuncType\ func,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetCollisionFunc\fP(pfiCollide\ *collide,
'in +2
'll -2
pfiCollideFuncType\ *func,
void\ **data);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiUpdateCollide\fP(pfiCollide\ *collide);
.fi

.Ex
.nf

typedef int (*pfiCollideFuncType)(pfiCollide *, void *);
.Ee
.fi
.na

.SH DESCRIPTION

\f3\%pfiCollide\fP functions.

The pfiCollide has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiCollide.h.

\f3\%pfiInit\fP should be called once before any pfiCollide routines and before
the forked creation of any additional processes that will be calling
pfiCollide routines.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
