'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiTDFXformer" "3pf"
.SH NAME
.upperok
.B pfiNewTDFXformer,
.B pfiGetTDFXformerClassType,
.B pfiCreateTDFXformer,
.B pfiTDFXformerStartMotion,
.B pfiGetTDFXformerStartMotion,
.B pfiTDFXformerFastClickTime,
.B pfiGetTDFXformerFastClickTime,
.B pfiTDFXformerTrackball,
.B pfiTDFXformerDrive,
.B pfiTDFXformerFly,
.B pfiGetTDFXformerTrackball,
.B pfiGetTDFXformerDrive,
.B pfiGetTDFXformerFly,
.B pfiProcessTDFXformerMouseEvents,
.B pfiProcessTDFXformerMouse,
.B pfiProcessTDFTrackballMouse,
.B pfiProcessTDFTravelMouse
\- 
Performer utility module used by perfly for managing a collection of motion models with a default user interface.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiInputXformTrackball\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
pfiTDFXformer *
\f3\%pfiNewTDFXformer\fP(void*\ arena);
.nf
.fi
.TP
pfType*
\f3\%pfiGetTDFXformerClassType\fP(void);
.nf
.fi
.TP
pfiXformer *
\f3\%pfiCreateTDFXformer\fP(\ pfiInputXformTrackball\ *tb,
'in +2
'll -2
pfiInputXformDrive\ *drive,
pfiInputXformFly\ *fly,
void\ *arena);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiTDFXformerStartMotion\fP(pfiTDFXformer*\ xf,
'in +2
'll -2
float\ startSpeed,
float\ startAccel,
float\ accelMult);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetTDFXformerStartMotion\fP(pfiTDFXformer*\ xf,
'in +2
'll -2
float\ *startSpeed,
float\ *startAccel,
float\ *accelMult);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiTDFXformerFastClickTime\fP(pfiTDFXformer*\ xf,
'in +2
'll -2
float\ msecs);
.in
.ll
.nf
.fi
.TP
float
\f3\%pfiGetTDFXformerFastClickTime\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiTDFXformerTrackball\fP(pfiTDFXformer\ *xf,
'in +2
'll -2
pfiInputXformTrackball\ *tb);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiTDFXformerDrive\fP(pfiTDFXformer\ *xf,
'in +2
'll -2
pfiInputXformDrive\ *tb);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiTDFXformerFly\fP(pfiTDFXformer\ *xf,
'in +2
'll -2
pfiInputXformFly\ *tb);
.in
.ll
.nf
.fi
.TP
pfiInputXformTrackball *
\f3\%pfiGetTDFXformerTrackball\fP(pfiTDFXformer\ *xf);
.nf
.fi
.TP
pfiInputXformDrive *
\f3\%pfiGetTDFXformerDrive\fP(pfiTDFXformer\ *xf);
.nf
.fi
.TP
pfiInputXformFly *
\f3\%pfiGetTDFXformerFly\fP(pfiTDFXformer\ *xf);
.nf
.fi
.TP
int
\f3\%pfiProcessTDFXformerMouseEvents\fP(pfiInput\ *,
'in +2
'll -2
pfuEventStream\ *,
void\ *data);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiProcessTDFXformerMouse\fP(pfiTDFXformer\ *xf,
'in +2
'll -2
pfuMouse\ *mouse,
pfChannel\ *inputChan);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiProcessTDFTrackballMouse\fP(pfiTDFXformer\ *xf,
'in +2
'll -2
pfiInputXformTrackball\ *trackball,
pfuMouse\ *mouse);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiProcessTDFTravelMouse\fP(pfiTDFXformer\ *xf,
'in +2
'll -2
pfiInputXformTravel\ *tr,
pfuMouse\ *mouse);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfiTDFXformer\fP is a facility developed using the pfiXformer to provide
a convenient utility for managing motion models derived from pfiInputXformTrackball,
pfiInputXformDrive, and pfiInputXformFly and providing a default user interface for such
motion models based on input received through a pfuMouse structure.
This utility is used by OpenGL Performer sample programs, such as perfly,
in conjunction with the libpfutil input collection utilities (see the
\f3\%pfuInitInput\fP reference page for more information).

A pfiTDFXformer is a child of the pfiXformer class and
so pfiXformer routines may be called with a pfiTDFXformer.
See the pfiXformer and pfiInputXform reference pages for information on other
general functionality. Functionality specific to the pfiXformer are discussed here
The pfiTDFXformer has a complete C++ API
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiXformer.h.
This reference page only discusses the C API.

\f3\%pfiInit\fP should be called once before any pfiTDFXformer routines and before
the forked creation of any additional processes that will be calling
pfiXformer routines.

\f3\%pfiGetTDFXformerClassType\fP  returns the
\f3\%pfType\fP* for the class \f3\%pfiXformer\fP.
Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP
to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfiNewTDFXformer\fP creates a new \f3\%pfiTDFXformer\fP data structure as described
above and returns a pointer to that structure.  \f2arena\fP should
specify the shared arena handle returned by \f3\%pfGetSharedArena\fP or
'NULL' indicating that the pfiTDFXformer structure should be allocated
from the process dynamic memory area.

\f3\%pfiProcessTDFXformerMouse\fP is the default update function used
by the pfiTDFXformer and implements a interface based
on input from pfuMouse and pfChannel specified
with \f3\%pfiXformerAutoInput\fP. The type of the currently selected
motion model (selected with \f3\%pfiSelectXformerModel\fP) is to see
if it is derived from one of pfiInputXformTrackball, or
pfiInputXformTravel, causes the pfiTDFXformer to invoke the mouse handling
routine pfiProcessTDFTrackballMouse or pfiProcessTDFTravelMouse
for the corresponding motion model type. The trackball, drive, and
fly motion models have the following interpretations of mouse events:

.TP 5
\f3\%TRACKBALL\fP
Motion models derived from \f3\%pfiInputXformTrackball\fP will get the \f3\%TRACKBALL\fP
mouse mapping.
This mode causes the transformation matrix to be transformed as if the
user was using the mouse pointer to spin a virtual trackball that
surrounds the scene.
The center of the scene is the computed center
of the database supplied by \f3\%pfiXformerNode\fP, or the center of the
supplied database bounding box via \f3\%pfiXformerLimits\fP or
\f3\%pfiIXformDBLimits\fP in world-space coordinates.
Trackball motion is intended to applied to the matrix of a pfDCS
transforming the database..
This can be done automatically if the pfDCS was supplied with
\f3\%pfiXformerAutoPosition\fP. The trackball transformation matrix can be requested
from the pfiTDFXformer with \f3\%pfiGetXformerModelMat\fP.
Collision detection is disabled in trackball mode.
Two kinds of motion are possible in this mode.
.RS
.TP 5
\f3\%ROTATION\fP
The user can "spin" the virtual trackball by holding down the middle
mouse button and moving the cursor relative to where it was at the time
the middle button was pressed.  Thus, when the middle mouse button is
down, moving the cursor horizontally on the screen will cause rotation
around Performer's world-space Z-axis, while moving the cursor
vertically will cause rotation around Performer's world-space X-axis.
Releasing the middle mouse button while moving the cursor will cause the
\f3\%pfiXformer\fP to continue to rotate the transformation matrix at the
current rate. Holding down both the middle and right mouse buttons
will cause rotation around Performer's world-space Y-axis.
.TP 5
\f3\%TRANSLATION\fP
The user can "move" or translate the virtual trackball in the XZ plane in
Performer's world-space (the plane of the screen when the view into the
\f3\%pfChannel\fP is directed down the Y-axis - the default in \f3\%perfly\fP)
by holding down the left mouse button and moving the cursor relative
to its position at the time the left mouse button was pressed.
The user can "zoom" or translate the virtual trackball on the Y axis in
Performer's world-space by holding down the right (or both left and right)
mouse buttons while moving the cursor vertically on the screen.
.RE
.TS
center tab($) ;
C | C
L | L .
Mouse Action$Motion Effect
_
Left mouse down$Translation in X and Z
Middle mouse down$Rotation around the X and Z axis
Middle+Right mouse down$Rotation about Y axis
Right mouse down: Translation along Y axis (zoom)
Middle+Right mouse down$Translation in along Y axis (zoom)
No mouse down$mouse position is ignored.
.TE
If the motion model is changed from the trackball model to a moving viewpoint model,
pfiInputXformDrive or pfiInputXformFly, the corresponding final transformations on the scene
pfDCS are then transformed to the viewpoint.

.TP 5
\f3\%DRIVE\fP
Motion models derived from \f3\%pfiInputXformDrive\fP will get the \f3\%DRIVE\fP
mouse mapping.
This mode causes the transformation matrix to be transformed as if the
user were using the mouse to control a car or other land-based vehicle.
In this mode the cursor's position relative to the center of the screen
will continue to cause relative turning of the transformation matrix.
Moving the cursor to the right causes a right turn.  Moving the cursor
to the left causes a left turn.  Keeping the cursor in the middle keeps
the transformation "facing" the same direction.  The left and right mouse
buttons control acceleration and deceleration, respectively. If moving
forward, the right mouse button will decelerate until eventually you start
moving backward.  The left and right buttons together will set your current
speed to zero but allow you to control viewing direction. So, if you
are moving forwards and you desire to be going in reverse immediately,
hit the right and left mouse buttons together, then release the left mouse button.
The middle mouse button allows control of viewing direction while maintaining a
constant speed, or will maintain the current position if the viewer was stopped
when the middle mouse button was pushed.  Additionally, when the middle mouse
button is pressed, the driving height may be altered by holding down a
ctrl-key and moving the mouse up and down.
A single fast middle-mouse
click anywhere on the screen will cause motion to stop.  Additionally, if all
three mouse buttons are down, motion will stop.  When no mouse buttons are down,
the mouse position is ignored; motion in progress when mouse buttons were pressed
will continue at a constant speed.

The mouse buttons are
the same as are interpreted as follows:

.TS
center tab($) ;
C | C
L | L .
Mouse Action$Motion Effect
_
Left mouse down$Accelerate forward motion and steer
Right mouse down$Decelerate motion direction and steer
Middle mouse down$Maintain current motion and and steer
Left and Right down$Halt current motion and steer
Fast middle click$Halt all motion
No mouse down$mouse position is ignored.
.TE

.TP 5
\f3\%FLY\fP
Motion models derived from \f3\%pfiInputXformFly\fP will get the \f3\%FLY\fP
mouse mapping.
This mode causes the transformation matrix to be transformed as if the
user were using the mouse to direct flight in 3D space.
The viewer position
will follow the mouse: vertical motion of the mouse will direct motion up and
down.  The behavior in this mode is different from that of
classic flight models where moving the mouse up pushes the nose of the
aircraft up and moving the mouse down pushes the nose down. Here the
pitch of the aircraft follows the mouse.
Motion controls are analogous to the pfiInputXformDrive model.
The left and right buttons do acceleration and deceleration, middle mouse
directs heading and maintains current motion at a constant speed.
Keeping the cursor in the middle of the screen will maintain current direction.
The mouse buttons are interpreted this way.

.TS
center tab($) ;
C | C
L | L .
Mouse Action$Motion Effect
_
Left mouse down$Accelerate forward motion and steer
Right mouse down$Decelerate motion direction and steer
Middle mouse down$Maintain current motion and and steer
Left and Right down$Halt current motion and steer
Fast middle click$Halt all motion
No mouse down$mouse position is ignored.
.TE
.RE

\f3\%pfiTDFXformerFastClickTime\fP will set the maximum time for a mouse
button to be down and still to qualify as a "fast click" for \f2xf\fP
to be \f2msecs\fP. If \f2msecs\fP is less than 0, fast click checking
will be disabled and no such clicks will be recognized.
The default fast click time is 300msecs.
\f3\%pfiGetTDFXformerFastClickTime\fP returns the fast click time for
\f2xf\fP.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
