'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfiXformer" "3pf"
.SH NAME
.upperok
.B pfiInit,
.B pfiGetXformerClassType,
.B pfiNewXformer,
.B pfiXformerModel,
.B pfiSelectXformerModel,
.B pfiGetXformerCurModel,
.B pfiGetXformerCurModelIndex,
.B pfiRemoveXformerModel,
.B pfiRemoveXformerModelIndex,
.B pfiStopXformer,
.B pfiResetXformer,
.B pfiResetXformerPosition,
.B pfiCenterXformer,
.B pfiXformerAutoInput,
.B pfiXformerMat,
.B pfiGetXformerMat,
.B pfiXformerModelMat,
.B pfiGetXformerModelMat,
.B pfiXformerCoord,
.B pfiGetXformerCoord,
.B pfiXformerResetCoord,
.B pfiGetXformerResetCoord,
.B pfiXformerNode,
.B pfiGetXformerNode,
.B pfiXformerAutoPosition,
.B pfiGetXformerAutoPosition,
.B pfiXformerLimits,
.B pfiGetXformerLimits,
.B pfiEnableXformerCollision,
.B pfiDisableXformerCollision,
.B pfiGetXformerCollisionEnable,
.B pfiXformerCollision,
.B pfiGetXformerCollisionStatus,
.B pfiUpdateXformer,
.B pfiCollideXformer
\- 
Performer utility module for managing a collection of motion models.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfiInputXform\ *\ \ \ 'u
#include <Performer/pfui.h>
.nf
.fi
.TP
void
\f3\%pfiInit\fP(void);
.nf
.fi
.TP
extern pfType*
\f3\%pfiGetXformerClassType\fP(void);
.nf
.fi
.TP
pfiXformer *
\f3\%pfiNewXformer\fP(void*\ arena);
.nf
.fi
.TP
void
\f3\%pfiXformerModel\fP(pfiXformer*\ xf,
'in +2
'll -2
int\ index,
pfiInputXform*\ model);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiSelectXformerModel\fP(pfiXformer*\ xf,
'in +2
'll -2
int\ which);
.in
.ll
.nf
.fi
.TP
pfiInputXform *
\f3\%pfiGetXformerCurModel\fP(pfiXformer*\ xf);
.nf
.fi
.TP
int
\f3\%pfiGetXformerCurModelIndex\fP(pfiXformer*\ xf);
.nf
.fi
.TP
int
\f3\%pfiRemoveXformerModel\fP(pfiXformer*\ xf,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiRemoveXformerModelIndex\fP(pfiXformer*\ xf,
'in +2
'll -2
pfiInputXform*\ model);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiStopXformer\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiResetXformer\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiResetXformerPosition\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiCenterXformer\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiXformerAutoInput\fP(pfiXformer*\ xf,
'in +2
'll -2
pfChannel*\ chan,
pfuMouse*\ mouse,
pfuEventStream*\ events);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiXformerMat\fP(pfiXformer*\ xf,
'in +2
'll -2
PFMATRIX\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetXformerMat\fP(pfiXformer*\ xf,
'in +2
'll -2
PFMATRIX\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiXformerModelMat\fP(pfiXformer*\ xf,
'in +2
'll -2
PFMATRIX\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetXformerModelMat\fP(pfiXformer*\ xf,
'in +2
'll -2
PFMATRIX\ mat);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiXformerCoord\fP(pfiXformer*\ xf,
'in +2
'll -2
pfCoord\ *coord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetXformerCoord\fP(pfiXformer*\ xf,
'in +2
'll -2
pfCoord\ *coord);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiXformerResetCoord\fP(pfiXformer*\ xf,
'in +2
'll -2
pfCoord\ *resetPos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetXformerResetCoord\fP(pfiXformer*\ xf,
'in +2
'll -2
pfCoord\ *resetPos);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiXformerNode\fP(pfiXformer*\ xf,
'in +2
'll -2
pfNode\ *node);
.in
.ll
.nf
.fi
.TP
pfNode *
\f3\%pfiGetXformerNode\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiXformerAutoPosition\fP(pfiXformer*\ xf,
'in +2
'll -2
pfChannel\ *chan,
pfDCS\ *dcs);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetXformerAutoPosition\fP(pfiXformer*\ xf,
'in +2
'll -2
pfChannel\ **chan,
pfDCS\ **dcs);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiXformerLimits\fP(pfiXformer*\ xf,
'in +2
'll -2
float\ maxSpeed,
float\ angularVel,
float\ maxAccel,
pfBox*\ dbLimits);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiGetXformerLimits\fP(pfiXformer*\ xf,
'in +2
'll -2
float\ *maxSpeed,
float\ *angularVel,
float\ *maxAccel,
pfBox*\ dbLimits);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfiEnableXformerCollision\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiDisableXformerCollision\fP(pfiXformer*\ xf);
.nf
.fi
.TP
int
\f3\%pfiGetXformerCollisionEnable\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiXformerCollision\fP(pfiXformer*\ xf,
'in +2
'll -2
int\ mode,
float\ val,
pfNode*\ node);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfiGetXformerCollisionStatus\fP(pfiXformer*\ xf);
.nf
.fi
.TP
void
\f3\%pfiUpdateXformer\fP(pfiXformer*\ xf);
.nf
.fi
.TP
int
\f3\%pfiCollideXformer\fP(pfiXformer*\ xf);
.fi

.Ex
.nf

typedef struct _pfiXformer pfiXformer;
.Ee
.fi
.na

.SH PARAMETERS
.TP \w'xf\ \ 'u
\f2xf\fP
identifies a pfiXformer.
.SH DESCRIPTION

\f3\%pfiXformer\fP is a facility developed to address the common task of
updating a transformation matrix based on a vehicle motion model and
control input from a user.  A transformation matrix is computed using
a motion model selected from a list of possible motion models maintained
by the pfiXformer. This transformation matrix can then be
used to update a \f3\%pfChannel's\fP view specification
(\f3\%pfChanViewMat\fP) or a \f3\%pfDCS\fP node's matrix, or the pfiXformer
can update these elements automatically if specified with
\f3\%pfiXformerAutoPosition\fP. \f3\%pfiXformerAutoInput\fP can
be used to set up mouse-based input to the pfiXformer.

A pfiXformer is a child of the pfiInputXform class and
so pfiInputXform routines may be called with a pfiXformer.
See the pfiInputXform reference page for information on pfiInputXform
functionality. Functionality specific to the pfiXformer are discussed here.
The pfiXformer has a complete C++ API (more complete than the C API)
following the conventions of general OpenGL Performer C++ API; C++ methods
are declared in /usr/include/Performer/pfui/pfiXformer.h.
This reference page only discusses the C API.

\f3\%pfiInit\fP should be called once before any pfiXformer routines and before
the forked creation of any additional processes that will be calling
pfiXformer routines.

\f3\%pfiGetXformerClassType\fP  returns the
\f3\%pfType\fP* for the class \f3\%pfiXformer\fP.
Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP
to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

\f3\%pfiNewXformer\fP creates a new \f3\%pfiXformer\fP data structure as described
above and returns a pointer to that structure.  \f2arena\fP should
specify the shared arena handle returned by \f3\%pfGetSharedArena\fP or
'NULL' indicating that the pfiXformer structure should be allocated
from the process dynamic memory area.

\f3\%pfiXformerAutoInput\fP causes the pfiXformer to use the specified mouse and channel
when collecting user input.  These structures will be examined every frame,
typically \f2xf\fP when \f3\%pfiUpdateXformer\fP is called.
\f3\%pfiUpdateXformer\fP should be
called every frame and will "update" \f2xf\fP based on the input structures
specified in \f3\%pfiXformerAutoInput\fP and the currently selected motion model.

\f3\%pfiXformerAutoPosition\fP will cause the pfiXformer to automatically update
the view and position matrices of \f2chan\fP and \f2dcs\fP automatically.
One or both of \f2chan\fP or \f2dcs\fP may be NULL to prevent channel or dcs
updates.

\f3\%pfiXformerCollision\fP specifies with what types of objects \f3\%xf\fP should
collide.  \f2mode\fP is a bit field that will be bitwise OR-ed into the collision
mode of \f2xf\fP.  Possible modes are \f3\%PFICOLLIDE_GROUND\fP and
\f3\%PFICOLLIDE_OBJECT\fP.  \f2val\fP specifies the minimum distance from \f2xf\fP's
origin to an object or to the ground at which \f2xf\fP is considered to have
collided with that object.  \f2node\fP specifies the root of the subtree
of the scene graph against which \f2xf\fP will check for collisions.
\f3\%pfiGetXformerCollisionStatus\fP returns whether or not \f2xf\fP is currently
colliding with something.

\f3\%pfiXformerLimits\fP sets the maximum speed of \f2xf\fP to \f2maxSpeed\fP,
the angular velocity of \f2xf\fP to \f2angularVel\fP, the maximum
acceleration of \f2xf\fP to \f2maxAccel\fP and the bounds within which
\f2xf\fP can move to be the \f3\%pfBox\fP \f2dbLimits\fP.
\f3\%pfiGetXformerLimits\fP returns everything set by
\f3\%pfiXformerLimits\fP.

\f3\%pfiXformerModel\fP sets \f2model\fP to put at location \f2index\fP in the
motion model list of \f2xf\fP.

\f3\%pfiSelectXformerModel\fP causes the motion model at location \f2which\fP
in the motion model list of \f2xf\fP to be the current active motion
model of \f2xf\fP.  \f3\%pfiGetXformerCurModelIndex\fP will return the index
of the current active motion model for \f2xf\fP.

\f3\%pfiRemoveXformerModel\fP will remove \f2model\fP from the motion model
list of \f3\%xf\fP. \f3\%pfiRemoveXformerModelIndex\fP will replace the
motion model at \f2index\fP from the motion model list of \f2xf\fP with NULL.

\f3\%pfiXformerMat\fP sets the current pfiXformer matrix to \f2mat\fP thus
resetting \f2xf\fP's transformation matrix to \f2mat\fP.  Note that this
also causes the \f2xf\fP's position as specified in the coord field of
the \f3\%pfiXformer\fP to be updated.  \f3\%pfiGetXformerMat\fP returns
\f2xf\fP's current transform matrix by copying it into \f2mat\fP.

\f3\%pfiXformerModelMat\fP sets the current transform
matrix of the current motion model of \f2xf\fP to \f2mat\fP thus
resetting \f2xf\fP's transformation matrix to \f2mat\fP.  Note that this
also causes the \f2xf\fP's position as specified in the coord field of
the \f3\%pfiXformer\fP to be updated.  \f3\%pfiGetXformerModelMat\fP returns
the transform matrix of the current motion model of
\f2xf\fP by copying it into \f2mat\fP.

\f3\%pfiXformerCoord\fP sets the current position of the \f3\%pfiXformer\fP
\f2xf\fP to \f2coord\fP and then recalculates the overall \f3\%pfiXformer\fP
matrix again based on this new position.  Note that positions are
absolute and not relative to previous
positions. \f3\%pfiGetXformerCoord\fP returns the position currently
specified by the \f3\%pfiXformer\fP \f2xf\fP by copying it into \f2coord\fP.

\f3\%pfiXformerNode\fP causes the pfiXformer to use \f2node\fP to automatically
compute database limits and size based on the scene graph rooted at
\f2node\fP.  If the database limits have been previously explicitly
specified with \f3\%pfiXformerLimits\fP or \f3\%pfiIXformDBLimits\fP they will
not be overwritten.

\f3\%pfiResetXformer\fP causes the motion models, the collision model, and
the current position and transformation matrices to be reset to their
initial state.

\f3\%pfiStopXformer\fP causes the transformation matrix in \f2xf\fP to stop
changing by zeroing velocity and acceleration.

\f3\%pfiResetXformerPosition\fP causes the position of the pfiXformer and
its current motion model to be reset to the initial position.  This
stored position can be set with \f3\%pfiXformerResetCoord\fP and queried
with \f3\%pfiGetXformerResetCoord\fP.

\f3\%pfiCenterXformer\fP will cause the position of the pfiXformer and its
current motion model to be reset to the center of the database, computed
using the current database limits as defined by
\f3\%pfiXformerNode\fP or \f3\%pfiIXformDBLimits\fP.

\f3\%pfiEnableXformerCollision\fP  enables the current requested collisions
on \f3\%xf\fP which will be computed upon the call to \f3\%pfiCollideXformer\fP.
\f3\%pfiDisableXformerCollision\fP disables the requested collision and a call to
\f3\%pfiCollideXformer\fP will have no effect.

\f3\%pfiCollideXformer\fP performs collision checks of \f2xf\fP against all relevant
objects (as specified in \f3\%pfiXformerCollision\fP) and return TRUE if \f2xf\fP
has collided with something. This routine is commonly called from a
forked intersection process.
.SH NOTES

The libpfui source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfiTDFXformer,
pfChannel,
pfChanViewMat,
pfCoord,
pfDCS,
pfGetSharedArena,
pfMatrix
