'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuAutoList" "3pfu"
.SH NAME
.upperok
.B pfuNewAutoList,
.B pfuGetAutoListClassType,
.B pfuAdd,
.B pfuGet,
.B pfuGetNum,
.B pfuInsert,
.B pfuMove,
.B pfuRemove,
.B pfuRemoveIndex,
.B pfuReplace,
.B pfuResetList,
.B pfuSearch,
.B pfuSearchForType,
.B pfuSet
\- 
Dynamically-sized resource owning list
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfuAutoList*\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
pfuAutoList*
\f3\%pfuNewAutoList\fP(int\ listLength,
'in +2
'll -2
void*\ arena);
.in
.ll
.nf
.fi
.TP
pfType*
\f3\%pfuGetAutoListClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfuAdd\fP(pfuAutoList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void*
\f3\%pfuGet\fP(const\ pfuAutoList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetNum\fP(const\ pfuAutoList*\ list);
.nf
.fi
.TP
void
\f3\%pfuInsert\fP(pfuAutoList*\ list,
'in +2
'll -2
int\ index,
void*\ elt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuMove\fP(pfuAutoList*\ lists,
'in +2
'll -2
int\ index,
void*\ elt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuRemove\fP(pfuAutoList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuRemoveIndex\fP(pfuAutoList*\ list,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuReplace\fP(pfuAutoList*\ list,
'in +2
'll -2
void*\ old,
void*\ new);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuResetList\fP(pfuAutoList*\ list);
.nf
.fi
.TP
int
\f3\%pfuSearch\fP(const\ pfuAutoList*\ list,
'in +2
'll -2
void*\ elt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuSearchForType\fP(const\ pfuAutoList*\ list,
'in +2
'll -2
pfType*\ type);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSet\fP(pfuAutoList*\ list,
'in +2
'll -2
int\ index,
void*\ elt);
.in
.ll
.fi
.SH PARENT CLASS FUNCTIONS


.PD
.PP
The IRIS Performer class \f3\%pfuAutoList\fP is
derived from the parent class \f3\%pfObject\fP,
so each of these member functions of
class \f3\%pfObject\fP
are also directly usable with objects
of class \f3\%pfuAutoList\fP.
Casting an object of class \f3\%pfuAutoList\fP
to an object of class \f3\%pfObject\fP
is taken care of automatically.
This is also true for
casts to objects of
ancestor classes
of class \f3\%pfObject\fP.

.PD 0
.TP \w'const\ char*\ \ \ 'u
void
\f3\%pfUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot,
void\ *data);
.in
.ll
.PD 0
.TP
void
\f3\%pfUserData\fP(pfObject\ *obj,
'in +2
'll -2
void\ *data);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserDataSlot\fP(pfObject\ *obj,
'in +2
'll -2
int\ slot);
.in
.ll
.PD 0
.TP
void*
\f3\%pfGetUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNumUserData\fP(pfObject\ *obj);
.PD 0
.TP
int
\f3\%pfGetNamedUserDataSlot\fP(const\ char\ *name);
.PD 0
.TP
const char*
\f3\%pfGetUserDataSlotName\fP(int\ slot);
.PD 0
.TP
int
\f3\%pfGetNumNamedUserDataSlots\fP(void);
.PD 0
.TP
int
\f3\%pfDeleteGLHandle\fP(pfObject\ *obj);

.PD
.PP
Since the class
\f3\%pfObject\fP is itself derived from
the parent class \f3\%pfMemory\fP, objects
of class \f3\%pfuAutoList\fP can also be used
with these functions designed for
objects of class \f3\%pfMemory\fP.

.PD 0
.TP \w'const\ char\ *\ \ \ 'u
pfType *
\f3\%pfGetType\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsOfType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
int
\f3\%pfIsExactType\fP(const\ void\ *ptr,
'in +2
'll -2
pfType\ *type);
.in
.ll
.PD 0
.TP
const char *
\f3\%pfGetTypeName\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnref\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfUnrefGetRef\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfGetRef\fP(const\ void\ *ptr);
.PD 0
.TP
int
\f3\%pfCopy\fP(void\ *dst,
'in +2
'll -2
void\ *src);
.in
.ll
.PD 0
.TP
int
\f3\%pfDelete\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfIsFluxed\fP(void\ *ptr);
.PD 0
.TP
int
\f3\%pfCompare\fP(const\ void\ *ptr1,
'in +2
'll -2
const\ void\ *ptr2);
.in
.ll
.PD 0
.TP
void
\f3\%pfPrint\fP(const\ void\ *ptr,
'in +2
'll -2
uint\ which,
uint\ verbose,
FILE\ *file);
.in
.ll
.PD 0
.TP
void *
\f3\%pfGetArena\fP(void\ *ptr);
.PD
.fi
.SH PARAMETERS
.TP \w'list\ \ 'u
\f2list\fP
identifies a pfuAutoList.
.SH DESCRIPTION


A pfuAutoList is a dynamically-sized list of elements.  Elements must
be of type pointer to pfMemory (or a derived class).  pfuAutoList
increments the reference count of elements that are added or inserted
into the list.  It decrements the reference count of elements that are
removed from the list.  In this way, pfuAutoList takes ownership of its
elements.

\f3\%pfuNewAutoList\fP creates and returns a handle to a new pfuAutoList.
The element size is fixed to be the size of a \f3\%pfMemory*\fP and cannot
be changed.  \f2listLength\fP is the initial length of the list;
\f2listLength\fP * \f3\%sizeof( pfMemory* )\fP bytes will be allocated for
the list's storage.  The argument \f2arena\fP specifies a malloc arena
out of which the pfuAutoList is to be allocated or \f3\%NULL\fP for
allocation from the process heap.

pfuAutoLists can be deleted with \f3\%pfDelete\fP. When a list is deleted,
it calls \f3\%pfMemory::unrefDelete()\fP on all elements in the list.


\f3\%pfuGetAutoListClassType\fP returns the
\f3\%pfType\fP* for the class \f3\%pfuAutoList\fP.  The \f3\%pfType\fP* returned
by \f3\%pfuGetAutoListClassType\fP is the
same as the \f3\%pfType\fP* returned by invoking \f3\%pfGetType\fP on any instance of class
\f3\%pfuAutoList\fP.  Because OpenGL Performer allows subclassing of
built-in types, when decisions are made based on the type of an
object, it is usually better to use \f3\%pfIsOfType\fP to test if an object is of a type derived from
a Performer type rather than to test for strict equality of the
\f3\%pfType\fP*'s.

A pfuAutoList dynamically increases its list size by a factor of 2 and
zeros the additional memory whenever it runs out of memory.  This way
the list size quickly reaches its final size without many
reallocations of memory.  However, some memory (up to one half of the
total allocation) at the end of the list may be wasted.  If you know
the exact number of elements in the list, you can specify the
pfuAutoList list length when creating it (the \f2listLength\fP argument
to \f3\%pfuNewAutoList\fP).

\f3\%pfuSet\fP sets the \f2index\fPth element of
\f2list\fP to \f2elt\fP.  The list is automatically
grown if \f2index\fP is beyond the current list length.  If the list
already contains an element at \f2index\fPth then \f3\%pfMemory::unref()\fP is
called on that element, before \f2elt\fP is inserted into the list.
\f3\%pfMemory::ref()\fP is called on \f2elt\fP.

\f3\%pfuGet\fP returns the element of
\f2list\fP at index \f2index\fP or 0 if \f2index\fP
is out of bounds.

\f3\%pfuAdd\fP appends \f2elt\fP to
\f2list\fP and automatically grows
\f2list\fP if necessary.  \f3\%pfMemory::ref()\fP is
called on \f2elt\fP.

\f3\%pfuRemove\fP removes \f2elt\fP from
\f2list\fP and shifts the elements down over the
vacant spot, e.g. - if \f2elt\fP had index 0, then index 1 becomes index
0, index 2 becomes index 1 and so on.
\f3\%pfuRemove\fP returns the index of \f2elt\fP
if \f2elt\fP was actually removed and -1 if it was not found in the list.
\f3\%pfuRemoveIndex\fP removes the
\f2index\fPth element of \f2list\fP, and like
\f3\%pfuRemove\fP, shifts the elements down over
the vacant spot.

Note that if the requested element was removed from the list then
\f3\%pfMemory::unref()\fP is called on that element. In this way, the list
disowns the removed element.

Note that \f3\%pfuRemove\fP linearly searches
the list for \f2elt\fP and removes only the first matching element.  To
remove all occurrences of \f2elt\fP do the following:
.Ex
.nf

while (pfuRemove(list, elt) >= 0)
    /* empty */ ;
.Ee
.fi
.na


\f3\%pfuSearch\fP returns the
index of \f2elt\fP if \f2elt\fP was found in \f2list\fP and -1 otherwise.

\f3\%pfuSearchForType\fP returns the
index of \f2type\fP, if an element was found in \f2list\fP that returns \f3\%TRUE\fP for \f3\%pfMemory::isOfType()\fP, and
returns -1 otherwise.

\f3\%pfuInsert\fP inserts \f2elt\fP before the
list element with index \f2index\fP.  \f2index\fP must be within the range
[0 .. \f3\%pfuGetNum\fP(\f2list\fP)].
\f3\%pfMemory::ref()\fP is called on \f2elt\fP.

\f3\%pfuMove\fP deletes \f2elt\fP from its current
location and inserts before the list element with index \f2index\fP.
\f2index\fP must be within the range [0 ..
\f3\%pfuGetNum\fP(\f2list\fP)] or else (-1) is
returned and no move is executed. If \f2elt\fP is not already in
\f2list\fP, (-1) is returned and \f2elt\fP is not
inserted into the list. Otherwise, \f2index\fP is returned to indicate
success.

\f3\%pfuReplace\fP replaces the first instance
of \f2old\fP with \f2new\fP and returns the index of \f2old\fP if it was
found in \f2list\fP and -1 otherwise.
\f3\%pfMemory::unref()\fP is called on \f2old\fP if it was found in the list.

\f3\%pfuGetNum\fP returns the number of
elements in \f2list\fP.

\f3\%pfuResetList\fP calls
\f3\%pfMemory::unrefDelete()\fP on all the elements in \f2list\fP and resets
the number of elements to 0.

.SH NOTES

Any attempt to add or insert non-\f3\%pfMemory\fP objects into a
\f3\%pfuAutoList\fP will fail. If an error status cannot be returned then a
warning will be issued. The list will remain unchanged.

.SH SEE ALSO
pfList,
pfMemory
