'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuCalcVirtualClipTexParams" "3pf"
.SH NAME
.upperok
.B pfuCalcVirtualClipTexParams
\- 
calculate parameters for virtual clip textures
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuCalcVirtualClipTexParams\fP(int\ nLevels,
'in +2
'll -2
int\ clipSize,
int\ invalidBorder,
float\ minLODTexPix,
float\ minLODLoaded,
float\ maxLODLoaded,
float\ bboxMinDist,
float\ bboxMaxDist,
float\ tradeoff,
const\ struct\ pfVirtualClipTexLimits\ *limits,
int\ *return_LODOffset,
int\ *return_numEffectiveLevels,
float\ *return_minLOD,
float\ *return_maxLOD);
.in
.ll
.fi
.SH DESCRIPTION


\f3\%pfuCalcVirtualClipTexParams\fP attempts to calculate reasonable
values for the four parameters
\f3\%LODOffset\fP,
\f3\%numEffectiveLevels\fP,
\f3\%minLOD\fP,
\f3\%maxLOD\fP
which are need to be set per-frame or per-tile
for virtual clip textures, given as much information
as the caller can provide about the geometry of the scene or tile,
the texture coordinate mapping, the current clip center of the clip texture,
and the current eyepoint.

For details on what the input parameters mean
and a description of the algorithm,
see the commented source code in
/usr/share/Performer/src/lib/libpfutil/clipparams.C.

.SH NOTES


ClipTexture functionality is not supported under Linux.

This function is specifically written to work around bugs
and limitations inherent in virtual clip texturing on InfiniteReality
graphics.
For a description of these bugs and limitations, see
/usr/share/Performer/doc/clipmap/IRClipmapBugs.html or
/usr/share/Performer/doc/clipmap/IRClipmapBugs.txt.
Because of this, the behavior of this function is intricate;
if it seems to be doing something mystifying, you may have to
trace through the commented source code to see what it is thinking.

For examples of various uses of this function, see the sample source code
for the .spherepatch and .ct scene loaders,
and the virtcliptex sample program:
.RS
.nf
/usr/share/Performer/src/lib/libpfdb/libpfspherepatch/pfspherepatch.C
/usr/share/Performer/src/lib/libpfdb/libpfct/pfct.C
/usr/share/Performer/src/sample/pguide/libpf/C/virtcliptex.c
.fi
.RE

For a general description of how to do virtual clip texturing, see
/usr/share/Performer/doc/clipmap/HowToDoVirtual.html or
/usr/share/Performer/doc/clipmap/HowToDoVirtual.txt.

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.

.SH SEE ALSO
pfClipTexture,
pfMPClipTexture,
pfuCalcTexDerivs,
pfuCalcSizeFinestMipLOD,
clipfly
