'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuClipCenterNode" "3pf"
.SH NAME
.upperok
.B pfuNewClipCenterNode,
.B pfuGetClipCenterNodeClassType,
.B pfuClipCenterNodeCallback,
.B pfuGetClipCenterNodeCallback,
.B pfuClipCenterNodeRefNode,
.B pfuGetClipCenterNodeRefNode,
.B pfuClipCenterNodeClipTexture,
.B pfuGetClipCenterNodeClipTexture,
.B pfuClipCenterNodeMPClipTexture,
.B pfuGetClipCenterNodeMPClipTexture,
.B pfuClipCenterNodeChannel,
.B pfuGetClipCenterNodeChannel,
.B pfuNewTexGenClipCenterNode,
.B pfuTexGenClipCenterNodeTexGen,
.B pfuGetTexGenClipCenterNodeTexGen,
.B pfuProcessClipCenters,
.B pfuProcessClipCentersWithChannel,
.B pfuTexGenClipCenterNode
\- 
Special scene graph node for managing and updating pfMPClipTextures
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfuClipCenterPostAppCallbackType\ *\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
pfuClipCenterNode *
\f3\%pfuNewClipCenterNode\fP(void);
.nf
.fi
.TP
pfType *
\f3\%pfuGetClipCenterNodeClassType\fP(void);
.nf
.fi
.TP
void
\f3\%pfuClipCenterNodeCallback\fP(pfuClipCenterNode\ *node,
'in +2
'll -2
pfuClipCenterPostAppCallbackType\ *callback);
.in
.ll
.nf
.fi
.TP
pfuClipCenterPostAppCallbackType *
\f3\%pfuGetClipCenterNodeCallback\fP(pfuClipCenterNode\ *node);
.nf
.fi
.TP
void
\f3\%pfuClipCenterNodeRefNode\fP(pfuClipCenterNode\ *node,
'in +2
'll -2
pfNode\ *refnode);
.in
.ll
.nf
.fi
.TP
pfNode *
\f3\%pfuGetClipCenterNodeRefNode\fP(pfuClipCenterNode\ *node);
.nf
.fi
.TP
void
\f3\%pfuClipCenterNodeClipTexture\fP(pfuClipCenterNode\ *node,
'in +2
'll -2
pfClipTexture\ *cliptex);
.in
.ll
.nf
.fi
.TP
pfClipTexture *
\f3\%pfuGetClipCenterNodeClipTexture\fP(pfuClipCenterNode\ *node);
.nf
.fi
.TP
\ 
\f3\%pfuClipCenterNodeMPClipTexture\fP(pfuClipCenterNode\ *node,
'in +2
'll -2
pfMPClipTexture\ *mpcliptex)
.in
.ll
.nf
.fi
.TP
pfMPClipTexture *
\f3\%pfuGetClipCenterNodeMPClipTexture\fP(pfuClipCenterNode\ *node);
.nf
.fi
.TP
\ 
\f3\%pfuClipCenterNodeChannel\fP(pfuClipCenterNode\ *node,
'in +2
'll -2
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
pfChannel *
\f3\%pfuGetClipCenterNodeChannel\fP(pfuClipCenterNode\ *node);
.nf
.fi
.TP
pfuTexGenClipCenterNode *
\f3\%pfuNewTexGenClipCenterNode\fP(void);
.nf
.fi
.TP
void
\f3\%pfuTexGenClipCenterNodeTexGen\fP(pfuTexGenClipCenterNode\ *node,
'in +2
'll -2
pfTexGen\ *tgen);
.in
.ll
.nf
.fi
.TP
pfTexGen *
\f3\%pfuGetTexGenClipCenterNodeTexGen\fP(pfuTexGenClipCenterNode\ *node);
.nf
.fi
.TP
void
\f3\%pfuProcessClipCenters\fP(pfNode\ *node,
'in +2
'll -2
pfList\ *mpcliptex);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuProcessClipCentersWithChannel\fP(pfNode\ *node,
'in +2
'll -2
pfList\ *mpcliptex,
pfChannel\ *chan);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfuTexGenClipCenterNode::pfuTexGenClipCenterNode\fP(void);
.nf
.fi
.TP
void
\f3\%pfuTexGenClipCenterNode::setTexGen\fP(pfTexGen\ tgen);
.nf
.fi
.TP
pfTexGen *
\f3\%pfuTexGenClipCenterNode::getTexGen\fP(void);
.nf
.fi
.TP
pfuTexGenClipCenterNode *
\f3\%pfuNewTexGenClipCenterNode\fP(void);
.nf
.fi
.TP
void
\f3\%pfuTexGenClipCenterNodeTexGen\fP(pfuTexGenClipCenterNode\ *node,
'in +2
'll -2
pfTexGen\ *tgen);
.in
.ll
.nf
.fi
.TP
pfTexGen *
\f3\%pfuGetTexGenClipCenterNodeTexGen\fP(pfuTexGenClipCenterNode\ *node);
.nf
.fi
.TP
\f3\%pfuNewTexGenClipCenterNodel\fP
.nf
.fi
.TP
constructs a subclass of the pfuClipCenterNode called the
.nf
.fi
.TP
pfuTexGenClipCenterNode. This node uses a different centering algorithm.
.nf
.fi
.TP
Rather than derive the center from the closest point on the cliptextured
.nf
.fi
.TP
geometry to the channels viewpoint, as does the pfuClipCenterNode, it converts
.nf
.fi
.TP
the position of the viewpoint from object space to texture space. It uses
.nf
.fi
.TP
the current value of the object linear texture generation parameters. It
.nf
.fi
.TP
does \f3\%not\fP take the texture transform matrix into account.
.nf
.fi
.TP
This centering algorithm is useful if the clipmapped geometry is mapped
.nf
.fi
.TP
using object space texture coordinate generation.
.nf
.fi
.TP
\f3\%pfuTexGenClipCenterNodeTexGenl\fP
.nf
.fi
.TP
sets a pointer to the pfTexGen object used to apply texture coordinates to
.nf
.fi
.TP
the cliptextured geometry. This object is used by the post-APP callback
.nf
.fi
.TP
to compute the viewpoint position in texture space.
.nf
.fi
.TP
\f3\%pfuGetTexGenClipCenterNodeTexGenl\fP
.nf
.fi
.TP
returns a pointer to the current pfTexGen object used by the post-APP
.nf
.fi
.TP
centering callback. If no pfTexGen object has been assigned, the default
.nf
.fi
.TP
value is NULL.
.nf
.fi
.TP
\f3\%pfuProcessClipCenters\fP
.nf
.fi
.TP
finds all the pfuClipCenterNodes in sub-graph rooted by the node argument,
.nf
.fi
.TP
collects all the pfMPClipTexture objects connected to them (creating them
.nf
.fi
.TP
if only the pfClipTexture exists), and appends them to the pfList provided as
.nf
.fi
.TP
the second argument. The pfList argument should be a pointer to a pfList
.nf
.fi
.TP
object created by the application.
.nf
.fi
.TP
Here is a code fragment that processes all the pfuClipCenterNodes in the
.nf
.fi
.TP
scenegraph, then adds them to all the pipes, using pipe 0 as the masterpipe:
.nf
.fi
.TP
.Ex
.nf

.nf
.fi
.TP
mpcliptextures =
\f3\%pfNewList\fP(sizeof(pfMPClipTexture*),
'in +2
'll -2
1,
pfGetSharedArena());
.in
.ll
.nf
.fi
.TP
\ 
\f3\%pfuProcessClipCenters\fP((pfNode\ *)scene,
'in +2
'll -2
mpcliptextures);
.in
.ll
.nf
.fi
.TP
\ 
\f3\%(void)pfuAddMPClipTexturesToPipes\fP(mpcliptextures,
'in +2
'll -2
pfGetPipe(0),
NULL);
.in
.ll
.nf
.fi
.TP
.Ee
.fi
.na

.nf
.fi
.TP
\f3\%pfuProcessClipCentersWithChannel\fP
.nf
.fi
.TP
this routine works like \f3\%pfuProcessClipCenters\fP except that it also
.nf
.fi
.TP
sets the pfChannel pointer on each pfuClipCenterNode found in the scene
.nf
.fi
.TP
graph, using the pfChannel pointer argument. Setting a pfChannel pointer
.nf
.fi
.TP
on a pfuClipCenter node cause the node to ignore all traversals by
.nf
.fi
.TP
pfChannels that don't match the channel pointer. A channel pointer of
.nf
.fi
.TP
\ 
\f3\%NULL\fP(the\ default)\ makes\ the\ pfuClipCenterNode\ respond\ to\ any\ channel
.nf
.fi
.TP
that traverses it.
.fi
.SH DESCRIPTION

The pfuClipCenterNode is a C++ subclass of the pfGroup node. In
addition to functioning as a group node in a scene graph, a clipcenter
node manages a cliptexture.

When a scene graph is loaded, the clip center node can be configured to
point to a pfClipTexture used by a pfGeoState object. The clip center
node is placed in the scene graph so that its child nodes contain the
geometry textured by the cliptexture. Optionally, the clip center node
can also contain a link to a reference node, which contains a simplified
version of the cliptextured geometry to make the cliptexture center
calculation faster.

When the pipes and channels have been created in the application, the
scene graph is searched for clipcenter nodes, and the clipcenter
node functionality is used to create and configure an pfMPClipTexture
for each pfClipTexture in the scene. At this point, the application may
also want to replace the default cliptexture center callback (a post-APP
callback) with a custom one.

While the scene graph is being displayed, the clipcenter node uses its
callback to update its cliptexture's center, using the relationship between
the viewpoint of the channel traversing the scenegraph, and the geometry
textured with the clip center node's cliptexture.

The clip center node can be customized by subclassing it; the source
code in \f3\%/usr/share/Performer/src/lib/libpfutil/pfuClipCenterNode.C\fP
contains an example subclass illustrating the technique.

\f3\%pfuGetClipCenterNodeCallback\fP
returns a pointer to the current post-APP pfMPClipTexture centering
callback function. The clip center node is created with a default callback
function, \f3\%clipCenterPostApp()\fP, which takes a pointer to a pfTraverser
object as its argument, and returns an integer indicating how the traversal
should continue.

The default function finds the closest polygon to the viewpoint,
taking into account any transforms in the scenegraph, then chooses the closest
point on that polygon. It then transforms the texture coordinates of that
point into texel coordinates (scaling by the virtual size of the cliptexture),
and uses that coordinate to update the cliptexture's center.

\f3\%pfuClipCenterNodeCallback\fP
this function allows the application to provide its own centering function
for the clip center node to use at its post-APP centering callback. The
function's signature  must match the \f3\%pfuClipCenterPostAppCallback\fP type.

\f3\%pfuClipCenterRefNode\fP
allows the application to provide the clip center node with a subgraph
containing a simplified version of the cliptextured geometry. The
clip center node's callback function will use this geometry, if provided,
to calculate the new center for the pfMPClipTexture.

\f3\%pfuGetClipCenterRefNode\fP
returns a pointer to the reference geometry used by the clip center
node's post-APP centering callback. If no reference node has been
provided, this function will return NULL.

\f3\%pfuClipCenterClipTexture\fP
sets the clip center node's cliptexture. This is usually done when
the scene graph is constructed.

\f3\%pfuGetClipCenterClipTexture\fP
returns the current cliptexture, or NULL if no cliptexture has been set.

\f3\%pfuClipCenterMPClipTexture\fP
sets the clip center node's pfMPClipTexture. This function is normally
not used, if the corresponding get function is called, a pfMPClipTexture
is automatically created, configured, and a pointer to it returned.

\f3\%pfuGetClipCenterMPClipTexture\fP
return a pointer to the clip center node's pfMPClipTexture. If no
pfMPClipTexture exists, and the clip center node has a pfClipTexture, a
pfMPClipTexture is created, connected to the cliptexture, a pointer to
it is saved in the clip center node and returned.

\f3\%pfuClipCenterChannel\fP
set the clip center node's channel pointer. If the channel pointer is
not NULL, then the clip center node will ignore any pfChannel that
traverses it if its address doesn't match the value of the channel pointer.
This allows the clip center node to only update a clip texture for a
particular channel. If the channel pointer is NULL, the clip center node
will center the cliptexture when any channel traverses it.

\f3\%pfuGetClipCenterChannel\fP
returns the current value of the clip center node's channel pointer.
If a channel pointer hasn't been set, this function will return the
NULL pointer.


.SH NOTES


ClipTexture functionality is not supported under Linux.

.SH BUGS


Making a clipcenter node with a pfGeode (possibly other types as well)
as a child when a pfdBuilder is being used to create a scene graph
(e.g. in the .im loader) can result in the callback being lost.
One workaround is to create a dummy pfGroup
node above the pfGeode and use that instead.

See the reference page for pfuGetClosestPoint() for bugs and limitations
of the closest-point search implementation.

.SH SEE ALSO
pfClipTexture,
pfMPClipTexture,
pfImageCache,
pfuProcessClipCenters,
pfuProcessClipCentersWithChannel
