'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuCursor" "3pf"
.SH NAME
.upperok
.B pfuLoadWinCursor,
.B pfuLoadPWinCursor,
.B pfuGetInvisibleCursor,
.B pfuCursor,
.B pfuGetCursor,
.B pfuCreateCursor,
.B pfuCursorColor,
.B pfuCursorType,
.B pfuDraw2DCursor,
.B pfuDrawChan2DCursor,
.B pfuDrawPVChan2DCursor,
.B pfuDrawPWin2DCursor,
.B pfuDrawVChan2DCursor,
.B pfuGetCursorType,
.B pfuLoadChanCursor,
.B pfuSelCursor,
.B pfuDrawChanDVRBox
\- 
Create and load cursors for pfWindows and pfPipeWindows.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'Cursor\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuLoadWinCursor\fP(pfWindow\ *win,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuLoadPWinCursor\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
Cursor
\f3\%pfuGetInvisibleCursor\fP(void);
.nf
.fi
.TP
void
\f3\%pfuCursor\fP(Cursor\ c,
'in +2
'll -2
int\ index);
.in
.ll
.nf
.fi
.TP
Cursor
\f3\%pfuGetCursor\fP(int\ index);
.nf
.fi
.TP
Cursor
\f3\%pfuCreateCursor\fP(int\ index);
.nf
.fi
.TP
void
\f3\%pfuCursorColor\fP(pfVec3\ fg,
'in +2
'll -2
pfVec3\ bg);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuCursorType\fP(int\ val);
.nf
.fi
.TP
void
\f3\%pfuDraw2DCursor\fP(int\ mx,
'in +2
'll -2
int\ my);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawChan2DCursor\fP(pfChannel\ *chan,
'in +2
'll -2
int\ mx,
int\ my);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawPVChan2DCursor\fP(pfPipeVideoChannel\ *vChan,
'in +2
'll -2
int\ mx,
int\ my);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawPWin2DCursor\fP(pfPipeWindow\ *pw,
'in +2
'll -2
int\ mx,
int\ my);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawVChan2DCursor\fP(pfVideoChannel\ *vChan,
'in +2
'll -2
int\ mx,
int\ my);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetCursorType\fP(void);
.nf
.fi
.TP
void
\f3\%pfuLoadChanCursor\fP(pfChannel\ *chan,
'in +2
'll -2
int\ c);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSelCursor\fP(int\ c);
.nf
.fi
.TP
void
\f3\%pfuDrawChanDVRBox\fP(pfChannel\ *chan);
.fi
.SH DESCRIPTION

These functions allow different types of cursors to be created and
associated with \f3\%pfWindows\fP, \f3\%pfPipeWindows\fP, \f3\%pfChannels\fP, and
\f3\%pfVideoChannels\fP.

\f3\%pfuCreateCursor\fP creates a cursor with index \f2index\fP.
The cursor can be selected with \f3\%pfuSelCursor\fP.

Cursors have both a foreground and background colors. \f3\%pfuCursorColor\fP
specifies these with \f2fg\fP and \f2bg\fP.

\f3\%pfuLoadWinCursor\fP loads the cursor of type \f2index\fP into the
\f3\%pfWindow\fP \f2win\fP. \f3\%pfuLoadPWinCursor\fP does the same for the
\f3\%pfPipeWindow\fP \f2pwin\fP.  \f3\%pfuLoadChanCursor\fP loads the cursor
for the \f3\%pfChannel\fP \f2chan\fP.

The cursor type can be selected with \f3\%pfuCursorType\fP and inquired
with \f3\%pfuGetCursorType\fP.

Several 2D cursor-drawing functions are available. The more specific the
function, the more carefully the drawing of the cursor can be managed.
This is most important when using Dynamic Video Resizing, where a simple
X-style pixel image cursor will exhibit unintended scaling along with
the image. The solution is to use the 2D cursor type, and to invoke
one of the cursor drawing commands that knows about the video channel
in use. The cursor drawing functions are:
\f3\%pfuDraw2DCursor\fP,
\f3\%pfuDrawChan2DCursor\fP,
\f3\%pfuDrawPVChan2DCursor\fP,
\f3\%pfuDrawPWin2DCursor\fP,
and
\f3\%pfuDrawVChan2DCursor\fP.

Definitions are provided in pfutil.h
for the standard cursor types. Such cursors have definitions of
the form PFU_CURSOR_\f2name\fP, where \f2name\fP is one of:


.RS
circle,
hand1,
arrow,
based_arrow_down,
based_arrow_up,
boat,
bogosity,
bottom_left_corner,
bottom_right_corner,
bottom_side,
bottom_tee,
box_spiral,
center_ptr,
clock,
coffee_mug,
cross,
cross_reverse,
crosshair,
diamond_cross,
dot,
dotbox,
double_arrow,
draft_large,
draft_small,
draped_box,
exchange,
fleur,
gobbler,
gumby,
hand2,
heart,
icon,
iron_cross,
left_ptr,
left_side,
left_tee,
leftbutton,
ll_angle,
lr_angle,
man,
middlebutton,
mouse,
pencil,
pirate,
plus,
question_arrow,
right_ptr,
right_side,
right_tee,
rightbutton,
rtl_logo,
sailboat,
sb_down_arrow,
sb_h_double_arrow,
sb_left_arrow,
sb_right_arrow,
sb_up_arrow,
sb_v_double_arrow,
shuttle,
sizing,
spider,
spraycan,
star,
target,
tcross,
top_left_arrow,
top_left_corner,
top_right_corner,
top_side,
top_tee,
trek,
ul_angle,
umbrella,
ur_angle,
watch, or
xterm.
.RE

\f3\%pfuGetInvisibleCursor\fP creates and returns an invisible
cursor.

\f3\%pfuCursor\fP allows the user to change the default cursor associated
with a given type. \f3\%pfuCursor\fP sets the cursor of type \f2index\fP to
be \f2c\fP. \f3\%pfuGetCursor\fP returns the cursor of type \f2index\fP.

Use the \f3\%xfd\fP command with the "-fn cursor" option to see a list of
the different available cursor types. The OpenGL Performer header file
"/usr/include/Performer/pfutil.h" contains a list of all the cursor
names.

\f3\%pfuDrawChanDVRBox\fP will draw a red box in the center of \f2chan\fP
showing the size of the output area of the pfPipeVideoChannel of the
pfChannel.

.SH NOTES

Only even numbered cursor types are supported, even though \f3\%xfd\fP will
display cursors of both odd and even types.
.SH SEE ALSO
xfd,
pfuGUI,
pfuXFont
