'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuEventQueue" "3pf"
.SH NAME
.upperok
.B pfuNewEventQ,
.B pfuResetEventStream,
.B pfuResetEventQ,
.B pfuAppendEventQStream,
.B pfuAppendEventQ,
.B pfuEventQStream,
.B pfuGetEventQStream,
.B pfuGetEventQEvents,
.B pfuIncEventQFrame,
.B pfuEventQFrame,
.B pfuGetEventQFrame,
.B pfuIncEventStreamFrame,
.B pfuEventStreamFrame,
.B pfuGetEventStreamFrame
\- 
Event queue and event stream management utilities
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfuEventStream\ *\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
pfuEventQueue *
\f3\%pfuNewEventQ\fP(pfDataPool\ *dp,
'in +2
'll -2
int\ id);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuResetEventStream\fP(pfuEventStream\ *es);
.nf
.fi
.TP
void
\f3\%pfuResetEventQ\fP(pfuEventQueue\ *eq);
.nf
.fi
.TP
void
\f3\%pfuAppendEventQStream\fP(pfuEventQueue\ *dst,
'in +2
'll -2
pfuEventStream\ *src);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuAppendEventQ\fP(pfuEventQueue\ *dst,
'in +2
'll -2
pfuEventQueue\ *src);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuEventQStream\fP(pfuEventQueue\ *eq,
'in +2
'll -2
pfuEventStream\ *es);
.in
.ll
.nf
.fi
.TP
pfuEventStream *
\f3\%pfuGetEventQStream\fP(pfuEventQueue\ *eq);
.nf
.fi
.TP
void
\f3\%pfuGetEventQEvents\fP(pfuEventStream\ *events,
'in +2
'll -2
pfuEventQueue\ *eq);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuIncEventQFrame\fP(pfuEventQueue\ *eq);
.nf
.fi
.TP
void
\f3\%pfuEventQFrame\fP(pfuEventQueue\ *eq,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetEventQFrame\fP(pfuEventQueue\ *eq);
.nf
.fi
.TP
void
\f3\%pfuIncEventStreamFrame\fP(pfuEventStream\ *es);
.nf
.fi
.TP
void
\f3\%pfuEventStreamFrame\fP(pfuEventStream\ *es,
'in +2
'll -2
int\ val);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetEventStreamFrame\fP(pfuEventStream\ *es);
.nf
.fi
.TP
.Ex
.nf

.nf
.fi
.TP
typedef struct _pfuEventStream
.nf
.fi
.TP
{
.nf
.fi
.TP
    int	buttonFlags;
.nf
.fi
.TP
    int	frameStamp;
.nf
.fi
.TP
    int 	numDevs;
.nf
.fi
.TP
    int 	numKeys;
.nf
.fi
.TP
    int	devQ[PFUDEV_MAX_INDEVS];
.nf
.fi
.TP
    int	devCount[PFUDEV_MAX_DEVS];
.nf
.fi
.TP
    int	devVal[PFUDEV_MAX_INDEVS];
.nf
.fi
.TP
    int	keyQ[PFUDEV_MAX_INKEYS];
.nf
.fi
.TP
    int 	keyCount[PFUDEV_KEY_MAP_SIZE];
.nf
.fi
.TP
} pfuEventStream;
.nf
.fi
.TP
.Ee
.fi
.na

.fi
.SH PARAMETERS
.TP \w'es\ \ 'u
\f2es\fP
identifies a pfuEventStream
.TP
\f2eq\fP
identifies a pfuEventQueue
.TP
\f2dp\fP
identifies a pfDataPool
.SH DESCRIPTION

These functions provide a means to manage streams and queues of X and
GL input events. \f3\%pfuEventQueue\fPs are compressed frames of
events. \f3\%pfuEventStream\fPs are sequences of events. They offer a way to
manipulate \f3\%pfuEventQueue\fPs.

\f3\%pfuNewEventQ\fP creates, initializes and returns a new event
queue. \f2dp\fP is the \f3\%pfDataPool\fP from which memory for the new event
queue is allocated. \f2id\fP is the handle by which the event queue is
identified. New memory is allocated for the event queue only
if an event queue with the same \f2id\fP is not already present in
\f2dp\fP.

\f3\%pfuResetEventStream\fP resets the event stream \f2es\fP to a null event
stream. \f3\%pfuResetEventQ\fP resets the event stream associated with the
event queue \f2eq\fP.

\f3\%pfuAppendEventQStream\fP appends the event stream \f2src\fP to the
event queue \f2dst\fP. This is done by copying the events in \f2src\fP
to the end of the event stream associated with
\f2dst\fP. \f3\%pfuAppendEventQ\fP appends the event stream associated with
\f2src\fP to \f2dst\fP.

\f3\%pfuEventQStream\fP sets the event stream associated with \f2eq\fP to be
\f2es\fP. \f3\%pfuGetEventQStream\fP returns a pointer to the event stream
associated with \f2eq\fP.

\f3\%pfuGetEventQEvents\fP copies the event stream associated with \f2src\fP
into \f2dst\fP.

\f3\%pfuIncEventQFrame\fP increments the frame stamp of the event stream
associated with \f2eq\fP by 1 or sets the frame stamp to 0 if it is
negative.

\f3\%pfuEventQFrame\fP sets the frame stamp of the event stream associated
with \f2eq\fP to \f2val\fP. \f3\%pfuGetEventQFrame\fP returns the frame stamp of
the event stream associated with \f2eq\fP.

\f3\%pfuIncEventStreamFrame\fP increments the frame stamp of the event stream
\f2es\fP by 1 or sets the frame stamp to 0 if it is negative.

\f3\%pfuEventStreamFrame\fP sets the frame stamp of the event stream \f2es\fP
to \f2val\fP. \f3\%pfuGetEventStreamFrame\fP returns the frame stamp of
the event stream \f2es\fP.
.SH SEE ALSO
pfDataPool,
pfuGUI,
pfuInitInput
