'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuFlybox" "3pf"
.SH NAME
.upperok
.B pfuOpenFlybox,
.B pfuReadFlybox,
.B pfuGetFlybox,
.B pfuGetFlyboxActive,
.B pfuInitFlybox
\- 
Routines to read the BG Systems flybox.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'int\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
int
\f3\%pfuOpenFlybox\fP(char\ *port);
.nf
.fi
.TP
int
\f3\%pfuReadFlybox\fP(int\ *dioval,
'in +2
'll -2
float\ *inbuf);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetFlybox\fP(float\ *analog,
'in +2
'll -2
int\ *but);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetFlyboxActive\fP(void);
.nf
.fi
.TP
int
\f3\%pfuInitFlybox\fP(void);
.fi
.SH DESCRIPTION


These routines provide a simple interface to the BG Systems flybox
but do not provide a flight model based on the flybox.

\f3\%pfuOpenFlybox\fP opens the flybox port specified by \f2port\fP.

\f3\%pfuReadFlybox\fP reads the values of the flybox digital inputs into
\f2dioval\fP and stores the eight analog input values into \f2inbuf\fP.

\f3\%pfuGetFlybox\fP reads the values of the flybox analog inputs into
\f2analog\fP after setting them to zero if their absolute values are
very small. It also stores the flybox digital inputs into \f2but\fP.

\f3\%pfuGetFlyboxActive\fP returns whether the flybox is currently active.

\f3\%pfuInitFlybox\fP initializes the flybox.  It uses \f3\%pfuOpenFlybox\fP and
\f3\%pfuGetFlybox\fP.

.SH NOTES

BG Systems Inc. is located in Palo Alto, California. Their telephone
number is (415) 858-2628.

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
