'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuGLXWinopen" "3pf"
.SH NAME
.upperok
.B pfuOpenXDisplay,
.B pfuGLXWinopen,
.B pfuGetGLXWin,
.B pfuGetGLXDisplayString,
.B pfuGLXAllocColormap,
.B pfuGLXMapcolors,
.B pfuGLMapcolors,
.B pfuMapWinColors,
.B pfuMapPWinColors,
.B pfuPrintWinFBConfig,
.B pfuPrintPWinFBConfig,
.B pfuChooseFBConfig
\- 
Open X display, open GLX window, get GLX window handle.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfuGLXWindow\ *\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
pfuXDisplay *
\f3\%pfuOpenXDisplay\fP(int\ screen);
.nf
.fi
.TP
pfuGLXWindow *
\f3\%pfuGLXWinopen\fP(pfPipe\ *pipe,
'in +2
'll -2
pfPipeWindow*\ pipewin,
const\ char\ *name);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGetGLXWin\fP(pfPipe\ *pipe,
'in +2
'll -2
pfuGLXWindow\ *win);
.in
.ll
.nf
.fi
.TP
const char *
\f3\%pfuGetGLXDisplayString\fP(pfPipe\ *pipe);
.nf
.fi
.TP
int
\f3\%pfuGLXAllocColormap\fP(pfuXDisplay\ *dsp,
'in +2
'll -2
pfuXWindow\ win);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGLXMapcolors\fP(pfuXDisplay\ *dsp,
'in +2
'll -2
pfuXWindow\ win,
pfVec3\ *colors,
int\ loc,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGLMapcolors\fP(pfVec3\ *colors,
'in +2
'll -2
int\ loc,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuMapWinColors\fP(pfWindow\ *win,
'in +2
'll -2
pfVec3\ *colors,
int\ loc,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuMapPWinColors\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
pfVec3\ *colors,
int\ loc,
int\ num);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuPrintWinFBConfig\fP(pfWindow\ *win,
'in +2
'll -2
FILE\ *file);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuPrintPWinFBConfig\fP(pfPipeWindow\ *pwin,
'in +2
'll -2
FILE\ *file);
.in
.ll
.nf
.fi
.TP
pfFBConfig
\f3\%pfuChooseFBConfig\fP(Display\ *dsp,
'in +2
'll -2
int\ screen,
int\ *constraints,
void\ *arena);
.in
.ll
.fi

.Ex
.nf

typedef Window 	pfuXWindow;
typedef uint 	pfuXDisplay;

typedef struct _pfuGLXWindow
{
    pfPipeWindow *pw;
    pfuXDisplay *dsp;
    pfuXWindow	xWin;
    pfuXWindow	glWin;
    pfuXWindow	overWin;

} pfuGLXWindow;
.Ee
.fi
.na

.SH DESCRIPTION


\f3\%pfuInitUtil\fP should be called immediately after \f3\%pfConfig\fP when using
these routines to initialize shared memory used by the utility library.

\f3\%pfuOpenXDisplay\fP opens and returns a handle to a connection to the X
server on \f2screen\fP.  If \f2screen\fP is 1, then the default display,
or that specified by the shell environment variable \f3\%DISPLAY\fP is
used.  \f3\%pfuOpenXDisplay\fP returns NULL if the X display cannot be opened.
These routines are provided only for compatibility with previous OpenGL Performer
releases and new development should use the window system utilities in libpr,
such as \f3\%pfOpenWSConnection\fP and \f3\%pfOpenScreen\fP.

\f3\%pfuGLXWinopen\fP opens and returns a handle to a GLX window for
\f3\%pfPipe\fP \f2pipe\fP, using the existing \f3\%pfPipeWindow\fP \f2pipewin\fP
or making a new \f3\%pfPipeWindow\fP for \f2pipe\fP if \f2pipewin\fP is NULL.
The window's title bar is set to \f2name\fP.

\f3\%pfuGetGLXWin\fP returns a handle in \f2win\fP to the GLX window for pfPipe
\f2pipe\fP, and returns NULL if no such window can be found.

\f3\%pfuGetGLXDisplayString\fP returns the name of the X Display stored
for \f2pipe\fP.

\f3\%pfuGLXAllocColormap\fP allocates color map entries for the window specified
in \f2win\fP and returns the number of colors available. \f2dsp\fP is
\f2win\fP's connection to the X server.

\f3\%pfuGLMapcolors\fP replaces \f2num\fP IRIS GL color map entries.
\f2win\fP, starting at color map index \f2loc\fP.  The \f2colors\fP array
contains the color values to map, normalized in the range [0, 1]. The
red component is stored in \f2colors[i][0]\fP, the green component in
\f2colors[i][1]\fP, and the blue component in \f2colors[i][2]\fP.  This
function is no longer supported.

\f3\%pfuGLXMapcolors\fP replaces \f2num\fP color map entries in the X window
\f2win\fP, starting at color map index \f2loc\fP.  \f2dsp\fP is a valid X connection.
The \f2colors\fP array contains the color values to map, normalized in the range [0, 1]. The
red component is stored in \f2colors[i][0]\fP, the green component in
\f2colors[i][1]\fP, and the blue component in \f2colors[i][2]\fP.

\f3\%pfuMapWinColors\fP replaces \f2num\fP color map entries in the pfWindow
\f2win\fP, starting at color map index \f2loc\fP.  \f2win\fP can be a
GLX, or OpenGL/X window. The \f2colors\fP array contains the color values
to map, normalized in the range [0, 1]. The red component is stored in
\f2colors[i][0]\fP, the green component in \f2colors[i][1]\fP, and the blue
component in \f2colors[i][2]\fP.  \f3\%pfuMapPWinColors\fP is the analogous
routine for pfPipeWindows.

\f3\%pfuPrintWinFBConfig\fP prints the framebuffer configuration of the
pfWindow, \f2win\fP, to the specified file \f2file\fP.  If \f2file\fP is
NULL, stderr is used.  \f3\%pfuPrintPWinFBConfig\fP prints the framebuffer
configuration of the pfPipeWindow, \f2pwin\fP, to the specified file
\f2file\fP.

\f3\%pfuChooseFBConfig\fP is an OpenGL X framebuffer configuration chooser
for selecting X Visuals for OpenGL/X windows.  This chooser limits
performance critical attributes: multisamples, size of depth buffer,
RGB color, and stencil.  If the provided pfWSConnection is NULL, the
current pfWSConnection libpr will be used.  See the
\f3\%pfGetCurWSConnection\fP reference page for more information.  If the
provided screen is (-1), the default screen of the pfWSConnection will
be used.
.SH NOTES

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfuInitUtil,
pfMultipipe
