'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuGetClosestPoint" "3pf"
.SH NAME
.upperok
.B pfuGetClosestPoint
\- 
Find closest point in a scene graph to a given point.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'extern\ int\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
extern int
\f3\%pfuGetClosestPoint\fP(pfNode\ *node,
'in +2
'll -2
float\ eyex,
float\ eyey,
float\ eyez,
const\ pfTexture\ *tex,
int\ travmode,
float\ *x,
float\ *y,
float\ *z,
float\ *s,
float\ *t,
float\ *r);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfuGetClosestPoint\fP traverses a scene graph looking for the closest point
(on any primitive decomposable into triangles)
to the point given by \f2eyex\fP, \f2eyey\fP, \f2eyez\fP, using the \f3\%pfuTraverser\fP
mode given by \f2travmode\fP.
If the argument \f2tex\fP is not \f3\%NULL\fP, the traversal will be restricted
to triangles that are textured by the pfTexture pointed to by \f2tex\fP.

On success, the function returns 1 and
vertex coordinates of the closest point are returned in
*\f2x\fP, *\f2y\fP, *\f2z\fP,  and if \f2tex\fP is not \f3\%NULL\fP,
the texture coordinates of the closest point
will be returned in *\f2r\fP, *\f2s\fP, *\f2t\fP.
On failure (there are no triangles, or, if \f2tex\fP != \f3\%NULL\fP, there are
no triangles textured by \f2tex\fP) \f3\%pfuGetClosestPoint\fP returns 0.

See the source code for the sample ".closest" pseudo-loader in
/usr/share/Performer/src/lib/libpfdb/libpfclosest
for an example of usage.

.SH NOTES

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.

.SH BUGS


The implementation assumes that all coordinate scaling
in \f3\%pfSCS\fP and \f3\%pfDCS\fP nodes in the scene are uniform,
i.e. that the scale factor is the same in all three coordinate axis directions.
If this is not the case, the answer returned will be valid coordinates
(and texture coordinates) of a point on a triangle, but it may not
be the actual closest point.

In the case of degenerate triangles
the coordinates returned may not be on or close to an object at all.

Point and line primitives are not traversed.

Interaction with automatic texture coordinate generation
is very limited.  Only PFTG_OBJECT_LINEAR is supported, and then
only when a pfTexGen is explicitly attached to the pfGeoSet's pfGeoState.

.SH SEE ALSO
pfuTraverser
