'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuInit" "3pf"
.SH NAME
.upperok
.B pfuInit,
.B pfuInitClasses,
.B pfuGetUtilDPool,
.B pfuExitUtil,
.B pfuDPoolSize,
.B pfuGetDPoolSize,
.B pfuFindUtilDPData
\- 
Initialize and reset OpenGL Performer utility library.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'volatile\ void*\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuInit\fP(void);
.nf
.fi
.TP
void
\f3\%pfuInitClasses\fP(void);
.nf
.fi
.TP
pfDataPool *
\f3\%pfuGetUtilDPool\fP(void);
.nf
.fi
.TP
void
\f3\%pfuExitUtil\fP(void);
.nf
.fi
.TP
void
\f3\%pfuDPoolSize\fP(long\ size);
.nf
.fi
.TP
long
\f3\%pfuGetDPoolSize\fP();
.nf
.fi
.TP
volatile void*
\f3\%pfuFindUtilDPData\fP(int\ id);
.fi
.SH DESCRIPTION

\f3\%pfuInit\fP must be called before \f3\%pfConfig\fP and before making any calls
to the utility library.  \f3\%pfuInit\fP initializes C++ classes internal
to libpfutil which must be done before \f3\%pfConfig\fP.
It creates a \f3\%pfDataPool\fP which \f3\%libpfutil\fP uses for
multiprocess operation.  The \f3\%pfDataPool\fP is created in "/usr/tmp" or the
directory specified by the environment variable, \f3\%PFTMPDIR\fP, if it is
set.

In order to change the amount of memory that \f3\%pfuInit\fP will
allocate for the \f3\%libpfutil\fP data pool, call \f3\%pfuDPoolSize\fP.
\f3\%pfuGetDPoolSize\fP returns the size of the data pool.  Note that the
default data pool size is optimal for \f3\%libpfutil's\fP memory allocation.
You should only use \f3\%pfuDPoolSize\fP to increase the size of the data
pool. Changes to the data pool size only take effect when your
application calls \f3\%pfuInit\fP.

\f3\%pfuInitClasses\fP
is called by \f3\%pfuInit\fP to construct all C++ classes defined in the
utility library. It contains calls to each class'es init routine. This
routine does one-time initialization for the entire class, such
as setting the class type variable. The class constructor is used
for class object initialization.

\f3\%pfuGetUtilDPool\fP returns a pointer to the utility library \f3\%pfDataPool\fP.

\f3\%pfuFindUtilDPData\fP returns a pointer to the block of
memory identified by \f2id\fP in the utility library \f3\%pfDataPool\fP
or NULL if \f2id\fP is not found.

\f3\%pfuExitUtil\fP removes the utility library \f3\%pfDataPool\fP from the
file system.


.SH NOTES

If a calling program exits abnormally, the \f3\%pfDataPool\fP will not be deleted.

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.

\f3\%pfuInitUtil\fP has been obsoleted by pfuInit.  pfuInitUtil is
provided as a macro to \f3\%pfuInit\fP for compatibility.

.SH SEE ALSO
pfDataPool
