'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuMCO" "3pf"
.SH NAME
.upperok
.B pfuConfigMCO,
.B pfuGetNumMCOChannels,
.B pfuTileChans,
.B pfuTileChan
\- 
Multi-Channel Option configuration utilities.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuConfigMCO\fP(pfChannel\ **chn,
'in +2
'll -2
int\ nChans);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetNumMCOChannels\fP(pfPipe\ *p);
.nf
.fi
.TP
void
\f3\%pfuTileChans\fP(pfChannel\ **chn,
'in +2
'll -2
int\ nChans,
int\ ntilesx,
int\ ntilesy);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuTileChan\fP(pfChannel\ **chn,
'in +2
'll -2
int\ thisChan,
int\ nChans,
float\ l,
float\ r,
float\ b,
float\ t);
.in
.ll
.fi
.SH DESCRIPTION

These functions serve as a generic way of initializing channels when
using the integrated multi-channel hardware available on most current
SGI platorms, including RealityEngine, InfiniteReality,
Impact, Octane graphics systems.  The multi-channel technique
divides the frame buffer into several tiles and then outputs these different
tiles to different displays through different video outputs.  This allows
multiple video outputs to be driven efficiently by one pfPipeWindow with
multiple pfChannels whose viewports match the framebuffer boundaries.
For example, on RealityEngine, the MCO can be configured to drive
up to six display channels at resolutions varying from 1280x1024 60Hz
non-interlaced to 640x480 30Hz interlaced.  The InfiniteReality has up
to eight channels per single graphics pipeline.  Impact and Octane can
each do four.
These framebuffer boundaries and other information can be queried via a
pfPipeVideoChannel that is attached to the desired hardware video channel.
The utility  functions use a basic knowledge or queries of how the configurations
tile the frame buffer to configure \f3\%pfChannels\fP appropriately for most configurations.
For more details on video channels, refer to the \f3\%pfPipeVideoChannel\fP and
\f3\%XSGIvc(3)\fP reference pages.

\f3\%pfuConfigMCO\fP takes the array of \f3\%pfChannel\fP pointers \f2chn\fP of
size \f2nChans\fP and formats the viewports such that each channel's
viewport divides the framebuffer in the same way the MCO does.  Each
channel is thus mapped to a different display.

\f3\%pfuGetNumMCOChannels\fP returns the number of channel subdivisions the MCO
is currently configured to use.  This is the number of displays that the
MCO has tiled the frame buffer into based on the current video output
format specification (see \f3\%setmon\fP).

\f3\%pfuTileChans\fP is a tiling routine that takes \f2nChans\fP channels and
divides them into a grid of \f2ntilesx\fP by \f2ntilesy\fP viewports that
all fit into the range 0 to 1 in both the x and y directions.

\f3\%pfuTileChan\fP is a utility function that sets the \f2chn[thisChan]\fP
viewport to the specified left (\f2l\fP), right(\f2r\fP), bottom(\f2b\fP), and
top(\f2t\fP) values where each value is between 0 and 1. \f2nChans\fP is
usually the number of channel subdivisions the MCO is configured to
use. \f2thisChan\fP should be at most \f2nChans\fP.
.SH NOTES


MCO is not currently supported under Linux.

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfChannel,
pfPipe,
pfPipeVideoChannel,
setmon,
XSGIvc
