'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuRandom" "3pf"
.SH NAME
.upperok
.B pfuRandomize,
.B pfuRandomLong,
.B pfuRandomFloat,
.B pfuRandomColor
\- 
Set up and generate random numbers and colors.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'float\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuRandomize\fP(int\ seed);
.nf
.fi
.TP
long
\f3\%pfuRandomLong\fP(void);
.nf
.fi
.TP
float
\f3\%pfuRandomFloat\fP(void);
.nf
.fi
.TP
void
\f3\%pfuRandomColor\fP(pfVec4\ color,
'in +2
'll -2
float\ minColor,
float\ maxColor);
.in
.ll
.fi
.SH DESCRIPTION

These functions set up a random number generator and use it to return
uniformly distributed random numbers and colors.

\f3\%pfuRandomize\fP initializes the random number generator with
\f2seed\fP.

\f3\%pfuRandomLong\fP returns a random number of type \f3\%long\fP while
\f3\%pfuRandomFloat\fP returns a random number of type \f3\%float\fP.

\f3\%pfuRandomColor\fP returns a random color in \f2color\fP. The \f2r\fP,
\f2g\fP and \f2b\fP values of \f2color\fP are random numbers in the range
[minColor, maxColor]. The alpha value of \f2color\fP is set to the fully
opaque value 1.

See the \f3\%srandom\fP and \f3\%random\fP man pages for further information on
the random number generator used.
.SH SEE ALSO
random,
srandom
