'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuSaveImage" "3pf"
.SH NAME
.upperok
.B pfuCalcNormalizedChanXY,
.B pfuSaveImage
\- 
Capture screen images.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuCalcNormalizedChanXY\fP(float*\ px,
'in +2
'll -2
float*\ py,
pfChannel*\ chan,
int\ xpos,
int\ ypos);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuSaveImage\fP(char*\ name,
'in +2
'll -2
int\ xorg,
int\ yorg,
int\ xsize,
int\ ysize,
int\ alpha);
.in
.ll
.fi
.SH DESCRIPTION

\f3\%pfuCalcNormalizedChanXY\fP normalizes the window
coordinates (\f2xpos\fP, \f2ypos\fP) to \f2chan\fP's viewport and
returns the resulting normalized position in (\f2px\fP, \f2py\fP).
The mapping is defined so that (\f2px\fP, \f2py\fP) range from (0, 0) to
(1, 1) when (\f2xpos\fP, \f2ypos\fP) is within \f2chan\fP's viewport.

\f3\%pfuSaveImage\fP saves the image rectangle that spans the
window coordinates (\f2xorg\fP, \f2yorg\fP) to
(\f2xorg\fP + \f2xsize\fP, \f2yorg\fP + \f2ysize\fP) into an image file with
the name \f2name\fP. The \f2alpha\fP boolean argument specifies if only an
RGB image (\f2alpha\fP = 0) or a complete RGBA image (\f2alpha\fP = 1) is
desired.
.SH NOTES

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfChannel
