'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuSmoke" "3pf"
.SH NAME
.upperok
.B pfuInitSmokes,
.B pfuNewSmoke,
.B pfuSmokeType,
.B pfuSmokeOrigin,
.B pfuSmokeVelocity,
.B pfuGetSmokeVelocity,
.B pfuSmokeDir,
.B pfuSmokeMode,
.B pfuDrawSmokes,
.B pfuSmokeTex,
.B pfuSmokeDuration,
.B pfuSmokeDensity,
.B pfuGetSmokeDensity,
.B pfuSmokeColor
\- 
Routines for simulating smoke and fire.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfuSmoke\ *\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuInitSmokes\fP(void);
.nf
.fi
.TP
pfuSmoke *
\f3\%pfuNewSmoke\fP(void);
.nf
.fi
.TP
void
\f3\%pfuSmokeType\fP(pfuSmoke\ *smoke,
'in +2
'll -2
int\ type);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeOrigin\fP(pfuSmoke\ *smoke,
'in +2
'll -2
pfVec3\ origin,
float\ radius);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeVelocity\fP(pfuSmoke\ *smoke,
'in +2
'll -2
float\ turbulence,
float\ speed);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGetSmokeVelocity\fP(pfuSmoke\ *smoke,
'in +2
'll -2
float\ *turbulence,
float\ *speed);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeDir\fP(pfuSmoke\ *smoke,
'in +2
'll -2
pfVec3\ dir);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeMode\fP(pfuSmoke\ *smoke,
'in +2
'll -2
int\ mode);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawSmokes\fP(pfVec3\ eye);
.nf
.fi
.TP
void
\f3\%pfuSmokeTex\fP(pfuSmoke\ *smoke,
'in +2
'll -2
pfTexture\ *tex);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeDuration\fP(pfuSmoke\ *smoke,
'in +2
'll -2
float\ dur);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeDensity\fP(pfuSmoke\ *smoke,
'in +2
'll -2
float\ dens,
float\ diss,
float\ expansion);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuGetSmokeDensity\fP(pfuSmoke\ *smoke,
'in +2
'll -2
float\ *dens,
float\ *diss,
float\ *expansion);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuSmokeColor\fP(pfuSmoke\ *smoke,
'in +2
'll -2
pfVec3\ bgn,
pfVec3\ end);
.in
.ll
.fi
.SH DESCRIPTION

This higher level utility is designed to show how to easily generate
smoke effects in OpenGL Performer applications.

\f3\%pfuInitSmokes\fP allocates for, loads and sets the geometry for the
smoke and fire textures. Call \f3\%pfuInitSmokes\fP after \f3\%pfInit\fP but
before \f3\%pfConfig\fP so that all shared data structures are correctly
shared among processes.

Call \f3\%pfuNewSmoke\fP to get a pointer to a new smoke structure which
you then can configure with \f3\%pfuSmokeVelocity\fP, \f3\%pfuSmokeDir\fP
and the other smoke functions.  Smoke is initialized with several
defaults but is not started by default.

Call \f3\%pfuDrawSmokes\fP from the draw process (and \f3\%only\fP from the draw process)
so that the active smoke objects are actually drawn.

\f3\%pfuSmokeType\fP can be set to any of
.RS
\f3\%PFUSMOKE_MISSILE\fP
.br
\f3\%PFUSMOKE_EXPLOSION\fP
.br
\f3\%PFUSMOKE_FIRE\fP
.br
\f3\%PFUSMOKE_SMOKE\fP
.br
\f3\%PFUSMOKE_DUST\fP
.RE

\f3\%pfuSmokeOrigin\fP sets the origin and radius of where \f2smoke\fP is to occur.

\f3\%pfuSmokeVelocity\fP sets the speed at which \f2smoke\fP is to move.

\f3\%pfuGetSmokeVelocity\fP gets the speed at which \f2smoke\fP is moving.

\f3\%pfuSmokeDir\fP sets the direction that \f2smoke\fP will move in (via
the vector \f2dir\fP).

\f3\%pfuSmokeMode\fP sets the current mode of operation for \f2smoke\fP.
Supported values are
.RS
\f3\%PFUSMOKE_STOP\fP
.br
\f3\%PFUSMOKE_START\fP
.RE

\f3\%pfuSmokeTex\fP sets the texture to be used for the smoke effect when
\f2smoke\fP is drawn.

\f3\%pfuSmokeDuration\fP sets the length of time \f2smoke\fP should last
once it is started.

\f3\%pfuSmokeDensity\fP sets the density, dissipation rate, and expansion
rate of the smoke puff.

\f3\%pfuSmokeColor\fP sets the beginning and ending colors for the smoke puff.
.SH NOTES

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
