'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuTex" "3pf"
.SH NAME
.upperok
.B pfuNewSharedTex,
.B pfuGetSharedTexList,
.B pfuMakeTexList,
.B pfuMakeSceneTexList,
.B pfuDownloadTexList,
.B pfuGetTexSize,
.B pfuNewTexList,
.B pfuLoadTexListFiles,
.B pfuLoadTexListFmt,
.B pfuNewProjector,
.B pfuProjectorPreDrawCB,
.B pfuProjectorMovie,
.B pfuGetProjectorHandle,
.B pfuProjectorHandle,
.B pfuGetProjectorScreenList,
.B pfuAddProjectorScreen,
.B pfuRemoveProjectorScreen,
.B pfuReplaceProjectorScreen,
.B pfuLoadDetailTextures
\- 
Create and initialize textures, create and display movies.
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'pfSequence\ *\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
pfTexture *
\f3\%pfuNewSharedTex\fP(const\ char\ *filename,
'in +2
'll -2
void\ *arena);
.in
.ll
.nf
.fi
.TP
pfList *
\f3\%pfuGetSharedTexList\fP(void);
.nf
.fi
.TP
pfList *
\f3\%pfuMakeTexList\fP(pfNode\ *node);
.nf
.fi
.TP
pfList *
\f3\%pfuMakeSceneTexList\fP(pfScene\ *scene);
.nf
.fi
.TP
void
\f3\%pfuDownloadTexList\fP(pfList\ *list,
'in +2
'll -2
int\ style);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetTexSize\fP(pfTexture\ *tex);
.nf
.fi
.TP
void
\f3\%pfuNewTexList\fP(pfTexture\ *tex);
.nf
.fi
.TP
pfList *
\f3\%pfuLoadTexListFiles\fP(pfList\ *movieTexList,
'in +2
'll -2
char\ nameList[][PF_MAXSTRING],
int\ len);
.in
.ll
.nf
.fi
.TP
pfList *
\f3\%pfuLoadTexListFmt\fP(pfList\ *movieTexList,
'in +2
'll -2
const\ char\ *fmtStr,
int\ start,
int\ end);
.in
.ll
.nf
.fi
.TP
pfSequence *
\f3\%pfuNewProjector\fP(pfTexture\ *handle);
.nf
.fi
.TP
int
\f3\%pfuProjectorPreDrawCB\fP(pfTraverser\ *trav,
'in +2
'll -2
void\ *travData);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuProjectorMovie\fP(pfSequence\ *proj,
'in +2
'll -2
pfList\ *movie);
.in
.ll
.nf
.fi
.TP
pfTexture *
\f3\%pfuGetProjectorHandle\fP(pfSequence\ *proj);
.nf
.fi
.TP
void
\f3\%pfuProjectorHandle\fP(pfSequence\ *proj,
'in +2
'll -2
pfTexture\ *new);
.in
.ll
.nf
.fi
.TP
pfList *
\f3\%pfuGetProjectorScreenList\fP(pfSequence\ *proj);
.nf
.fi
.TP
void
\f3\%pfuAddProjectorScreen\fP(pfSequence\ *proj,
'in +2
'll -2
pfTexture\ *screen);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuRemoveProjectorScreen\fP(pfSequence\ *proj,
'in +2
'll -2
pfTexture\ *screen);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuReplaceProjectorScreen\fP(pfSequence\ *proj,
'in +2
'll -2
pfTexture\ *old,
pfTexture\ *new);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuLoadDetailTextures\fP(pfList\ *list,
'in +2
'll -2
pfuDetailInfo\ *di,
int\ ndi);
.in
.ll
.fi
.SH DESCRIPTION

These utilities assist in the sharing and downloading of textures.

For consistent frame rates, it is very important to download textures
into the graphics pipeline's physical texture memory before beginning
simulation.  This is so that there is no momentary pause while the
textures are processed (\f3\%texdef\fP) and downloaded (\f3\%texbind\fP).

An example of the use of these functions can be found in
/usr/share/Performer/src/sample/C/common/generic.c which is
used by a number of sample applications including the OpenGL
Performer \f3\%perfly\fP sample application.

\f3\%pfuNewSharedTex\fP examines the application's global list of
previously allocated textures for the file \f2filename\fP.  If the file
has already been loaded, the address of the existing pfTexture
structure is returned; if not, a new pfTexture is allocated in
\f2arena\fP, the named file is read, and the address is returned for
reference in future requests.

\f3\%pfuGetSharedTexList\fP returns the list of all textures allocated
using the \f3\%pfuNewSharedTex\fP texture-sharing mechanism described above
during the current execution of the process.  The list returned is
useful for many things including texture downloading.

\f3\%pfuMakeTexList\fP constructs a list of textures by recursively
traversing the OpenGL Performer scene graph rooted by \f2node\fP.  Since
this traversal is exhaustive no texture will be missed.

Performer supports the notion of a \f2scene pfGeoState\fP to represent
common rendering state for a pfScene. When this mechanism is used, the
texture list built by \f3\%pfuMakeTexList\fP will not include the texture
defined by the scene pfGeoState. The function \f3\%pfuMakeSceneTexList\fP
duplicates the function of \f3\%pfuMakeTexList\fP and adds the scene
pfGeoState's texture to the list if the scene pfGeoState defines
a texture.

\f3\%pfuDownloadTexList\fP visits each texture in the list provided in \f2list\fP
and performs one of the following functions:
.RS
.TP 5
\f3\%PFUTEX_APPLY\fP
Download each texture without any on-screen fanfare.
.TP
\f3\%PFUTEX_SHOW\fP
Show each texture in the screen while downloading.  This is the source of
the "slide-show" seen as the OpenGL Performer \f3\%perfly\fP program starts up.
.TP
\f3\%PFUTEX_DEFINE\fP
Perform a partial download, performing only the \f3\%texdef\fP operation and
not the subsequent \f3\%texbind\fP.  This can be used as the basis of simple
texture paging mechanisms.
.RE

In most cases, \f3\%pfuDownloadTexList\fP will be called in the first
traversal through the channel draw callback on each
configured \f3\%pfPipe\fP.  This function \f3\%must\fP be called from the draw
process since it makes direct graphics function calls.

\f3\%pfuGetTexSize\fP queries the number of bytes of texture used in \f2tex\fP.

\f3\%pfuNewTexList\fP preallocates a sequence of 16 frames on a \f3\%pfTexture\fP
for animation.

\f3\%pfuLoadTexListFiles\fP fills a list within a \f3\%pfTexture\fP from the array
of file names, \f2nameList\fP, which contains \f2len\fP names. If
\f2movieTexList\fP is passed as NULL, a new list is automatically
allocated. The filled list is returned.

\f3\%pfuLoadTexListFmt\fP fills a list within a \f3\%pfTexture\fP from a sequence
of files indicated by the \f3\%printf\fP-style format string \f2fmtStr\fP.
\f3\%pfuLoadTexListFmt\fP uses \f3\%sprintf\fP and \f2fmtStr\fP to construct
filenames ranging sequentially from \f2start\fP to \f2end\fP and adds the
textures in these files to the list.

The following routines are used to create and display a movie. A
movie has a projector (a \f3\%pfSequence\fP node with a special \f3\%pfUserData\fP
and pre-draw callback), a default base frame (a \f3\%pfTexture*\fP), one or
more screens (\f3\%pfTexture*\fP's) and a reel of movie frames (a \f3\%pfList\fP of
\f3\%pfTexture*\fP).

The \f3\%pfSequence\fP API is used to run the projector and control the
movie display. Screens can be added, removed, or replaced at will.  Each
projector can have any number of screens but each screen should be in
only one projector.  The projector node should be the first child of
the \f3\%pfScene\fP node. It draws no geometry, but only configures its
\f3\%pfTexture*\fP screen to display the correct image when accessed later
via traversal of the normal scene graph (or a direct \f3\%pfApplyTex\fP).

\f3\%pfuNewProjector\fP creates and returns a \f3\%pfSequence\fP containing the
list of textures in \f2handle\fP, with the textures stored as the leaves
under the \f3\%pfSequence\fP and installs \f3\%pfuProjectorPreDrawCB\fP as the
default pre-draw stage callback.

\f3\%pfuProjectorMovie\fP sets the \f3\%pfSequence\fP passed in \f2proj\fP to the
list of textures passed in \f2movie\fP. This enables \f2movie\fP to be
played in all the screens of \f2proj\fP.

\f3\%pfuProjectorHandle\fP sets the \f3\%pfSequence\fP passed in \f2proj\fP to the
list of textures contained in the \f3\%pfTexture\fP handle \f2new\fP.

\f3\%pfuGetProjectorHandle\fP returns the \f3\%pfTexture\fP handle from the
\f3\%pfSequence\fP passed in \f2proj\fP.

\f3\%pfuGetProjectorScreenList\fP returns the list of screens in the
\f3\%pfSequence\fP passed in \f2proj\fP.

\f3\%pfuAddProjectorScreen\fP adds \f2tex\fP to the screen list of \f2proj\fP.
This causes \f2tex\fP to reference \f2proj\fP's movie as its list of
frames.

\f3\%pfuRemoveProjectorScreen\fP removes the screen \f2screen\fP from the
movie \f2proj\fP. This sets \f2screen\fP's texture list to NULL and its
frame to -1.

\f3\%pfuReplaceProjectorScreen\fP replaces the screen \f2old\fP in the movie
\f2proj\fP with the screen \f2mew\fP. This sets \f2old\fP's texture list to
NULL and its frame to -1.

The following code fragment shows how a movie can be created.

Example 1:
.Ex
.nf

  /* create a projector with a pfTexture handle for the movie tape.
   * The reel base texture can also be used as a base screen.
   * The movie can be the texture list on the handle here, or can
   * be added/replaced later with pfuProjectorMovie(proj, tape) or with
   * pfuProjectorHandle(proj, newHandle);
   */
    pfTexture *handle = pfNewTex(pfGetSharedArena());
    pfSequence *proj = pfuNewProjector(handle);

  /* set AUTO_IDLE mode on the handle - new screens on the projector inherit
   * this mode from the handle
   */
    pfTexLoadMode(handle, PFTEX_LIST_AUTO_IDLE, 1);

  /* Create a pfList to hold the frames of the movie */
    pfList *tape = pfuLoadTexListFmt(NULL, fmtStr)
	    /* or pfuLoadTexListFiles(NULL, fileNameList); */

  /* put the movie in the projector */
    pfuProjectorMovie(proj, tape);
.Ee
.fi
.na


\f3\%pfuLoadDetailTextures\fP will define the detail textures according to their
associations specified with \f2di\fP to the base textures found in \f2list\fP.
.Ex
.nf

typedef struct {
    char *texname;
    char *detailname;
    int level;
    pfTexture *detailtex;
    int setSpline;
    pfVec2 spline[4];
} pfuDetailInfo;

.Ee
.fi
.na


.SH NOTES

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfApplyTex,
pfList,
pfScene,
pfSequence,
pfTexture,
pfUserData,
printf,
sprintf
