'\"! eqn | tbl | mmdoc
'\"macro stdmacro
.TH "pfuXFont" "3pf"
.SH NAME
.upperok
.B pfuLoadXFont,
.B pfuMakeXFontBitmaps,
.B pfuMakeRasterXFont,
.B pfuGetXFontWidth,
.B pfuGetXFontHeight,
.B pfuGetCurXFont,
.B pfuSetXFont,
.B pfuCharPos,
.B pfuDrawString,
.B pfuDrawStringPos
\- 
X Window string drawing routines
.SH FUNCTION SPECIFICATION
.nf
.fi
.TP \w'void\ \ \ 'u
#include <Performer/pfutil.h>
.nf
.fi
.TP
void
\f3\%pfuLoadXFont\fP(char\ *fontName,
'in +2
'll -2
pfuXFont\ *fnt);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuMakeXFontBitmaps\fP(pfuXFont\ *fnt);
.nf
.fi
.TP
void
\f3\%pfuMakeRasterXFont\fP(char\ *fontName,
'in +2
'll -2
pfuXFont\ *fnt);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetXFontWidth\fP(pfuXFont\ *f,
'in +2
'll -2
const\ char\ *str);
.in
.ll
.nf
.fi
.TP
int
\f3\%pfuGetXFontHeight\fP(pfuXFont\ *f);
.nf
.fi
.TP
void
\f3\%pfuGetCurXFont\fP(pfuXFont\ *f);
.nf
.fi
.TP
void
\f3\%pfuSetXFont\fP(pfuXFont\ *f);
.nf
.fi
.TP
void
\f3\%pfuCharPos\fP(float\ x,
'in +2
'll -2
float\ y,
float\ z);
.in
.ll
.nf
.fi
.TP
void
\f3\%pfuDrawString\fP(const\ char\ *s);
.nf
.fi
.TP
void
\f3\%pfuDrawStringPos\fP(const\ char\ *s,
'in +2
'll -2
float\ x,
float\ y,
float\ z);
.in
.ll
.fi

.Ex
.nf

typedef struct pfuXFont
{
    int   size;
    int    handle;
    XFontStruct *info;
} pfuXFont;
.Ee
.fi
.na

.SH DESCRIPTION

These functions do simple text drawing using X Windows fonts and string
drawing facilities.

Call \f3\%pfuLoadXFont\fP to load the X Window font named by \f2fontName\fP
into \f2fnt\fP.  Application programs will usually call \f3\%pfuMakeRasterXFont\fP
rather than calling this function directly.

\f3\%pfuMakeXFontBitmaps\fP allocates display lists under OpenGL for
writing the font \f2fnt\fP on the screen.  This is a necessary step after
calling \f3\%pfuLoadXFont\fP and before calling \f3\%pfuDrawString\fP or
\f3\%pfuDrawStringPos\fP.  Application programs will usually call
\f3\%pfuMakeRasterXFont\fP rather than calling this function directly.

\f3\%pfuMakeRasterXFont\fP loads the font specified in \f2fontName\fP into
\f2fnt\fP and, under OpenGL, allocates display lists for displaying the
font.  This function is normally used to load and initialize the font;
this can be followed by \f3\%pfuDrawString\fP or \f3\%pfuDrawStringPos\fP.

\f3\%pfuGetXFontWidth\fP returns the width (X dimension) in pixels of the
string \f2str\fP drawn on the screen in font \f2f\fP.

\f3\%pfuGetXFontHeight\fP returns the height (Y dimension) in pixels of the
font \f2f\fP.

\f3\%pfuGetCurXFont\fP sets \f2f\fP to the current X Window font for drawing.

\f3\%pfuSetXFont\fP sets the current X Window font to be \f2f\fP.

\f3\%pfuCharPos\fP sets the current drawing position on the screen.  See
\f3\%glRasterPos3f\fP in OpenGL for more details.

\f3\%pfuDrawString\fP draws the string \f2s\fP at the current drawing position.

\f3\%pfuDrawStringPos\fP draws the string \f2s\fP at the provided coordinates.

.SH NOTES

The libpfutil source code, object code and documentation are provided
as unsupported software.  Routines are subject to change in future
releases.
.SH SEE ALSO
pfDataPool,
glRasterPos3f
